<a href="https://opencollective.com/plotsjl/donate" target="_blank">
  <img src="https://opencollective.com/webpack/donate/button@2x.png?color=blue" width=200 />
</a>

# Plots

[gh-ci-img]: https://github.com/JuliaPlots/Plots.jl/workflows/ci/badge.svg?branch=master
[gh-ci-url]: https://github.com/JuliaPlots/Plots.jl/actions?query=workflow%3Aci

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/P/Plots.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html

[gitter-img]: https://badges.gitter.im/tbreloff/Plots.jl.svg
[gitter-url]: https://gitter.im/tbreloff/Plots.jl?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://docs.juliaplots.org/stable

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://docs.juliaplots.org/dev

[![][gh-ci-img]][gh-ci-url]
[![][pkgeval-img]][pkgeval-url]
[![project chat](https://img.shields.io/badge/zulip-join_chat-brightgreen.svg)](https://julialang.zulipchat.com/#narrow/stream/236493-plots)
[![][docs-stable-img]][docs-stable-url]
[![][docs-dev-img]][docs-dev-url]
[![Codecov](https://codecov.io/gh/JuliaPlots/Plots.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaPlots/Plots.jl)
[![Plots Downloads](https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Fmonthly_downloads%2FPlots&query=total_requests&suffix=%2Fmonth&label=Downloads)](https://juliapkgstats.com/pkg/Plots)

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.4725317.svg)](https://doi.org/10.5281/zenodo.4725317)
This is the DOI for all Versions, please follow the link to get the DOI for a specific version.

#### Created by Tom Breloff (@tbreloff)

#### Maintained by the [JuliaPlots members](https://github.com/orgs/JuliaPlots/people)

Plots is a plotting API and toolset.  My goals with the package are:

- **Powerful**.  Do more with less.  Complex visualizations become easy.
- **Intuitive**.  Stop reading so much documentation.  Commands should "just work".
- **Concise**.  Less code means fewer mistakes and more efficient development/analysis.
- **Flexible**.  Produce your favorite plots from your favorite package, but quicker and simpler.
- **Consistent**.  Don't commit to one graphics package, use the same code everywhere.
- **Smart**. Attempts to figure out what you **want** it to do... not just what you **tell** it.

const _series_recipe_deps = Dict()

series_recipe_dependencies(st::Symbol, deps::Symbol...) = _series_recipe_deps[st] = deps  # COV_EXCL_LINE

seriestype_supported(st::Symbol) = seriestype_supported(backend(), st)

# returns :no, :native, or :recipe depending on how it's supported
function seriestype_supported(pkg::AbstractBackend, st::Symbol)
    # is it natively supported
    is_seriestype_supported(pkg, st) && return :native

    haskey(_series_recipe_deps, st) || return :no

    supported = true
    for dep in _series_recipe_deps[st]
        if seriestype_supported(pkg, dep) === :no
            supported = false
            break
        end
    end
    return supported ? :recipe : :no
end

macro deps(st, args...)
    return :(Plots.series_recipe_dependencies($(quot(st)), $(map(quot, args)...)))
end

# get a list of all seriestypes
function all_seriestypes()
    sts = Set{Symbol}(keys(_series_recipe_deps))
    for bsym in backends()
        btype = _backendType[bsym]
        sts = union(sts, Set{Symbol}(supported_seriestypes(btype())))
    end
    return sts |> collect |> sort
end

# ----------------------------------------------------------------------------------
RecipesBase.apply_recipe(plotattributes::AKW, ::Type{T}, plt::AbstractPlot) where {T} =
    nothing

# ---------------------------------------------------------------------------

# for seriestype `line`, need to sort by x values

const POTENTIAL_VECTOR_ARGUMENTS = [
    :seriescolor,
    :seriesalpha,
    :linecolor,
    :linealpha,
    :linewidth,
    :linestyle,
    :line_z,
    :fillcolor,
    :fillalpha,
    :fill_z,
    :markercolor,
    :markeralpha,
    :markershape,
    :marker_z,
    :markerstrokecolor,
    :markerstrokealpha,
    :xerror,
    :yerror,
    :zerror,
    :series_annotations,
    :fillrange,
]

@nospecialize

@recipe function f(::Type{Val{:line}}, x, y, z)  # COV_EXCL_LINE
    indices = sortperm(x)
    x := x[indices]
    y := y[indices]

    # sort vector arguments
    for arg in POTENTIAL_VECTOR_ARGUMENTS
        if typeof(plotattributes[arg]) <: AVec
            plotattributes[arg] = _cycle(plotattributes[arg], indices)
        end
    end

    # a tuple as fillrange has to be handled differently
    if typeof(plotattributes[:fillrange]) <: Tuple
        lower, upper = plotattributes[:fillrange]
        typeof(lower) <: AVec && (lower = _cycle(lower, indices))
        typeof(upper) <: AVec && (upper = _cycle(upper, indices))
        plotattributes[:fillrange] = (lower, upper)
    end

    typeof(z) <: AVec && (z := z[indices])
    seriestype := :path
    ()
end
@deps line path

@recipe function f(::Type{Val{:hline}}, x, y, z)  # COV_EXCL_LINE
    n = length(y)
    newx = repeat(Float64[1, 2, NaN], n)
    newy = vec(Float64[yi for i in 1:3, yi in y])
    x := newx
    y := newy
    seriestype := :straightline
    ()
end
@deps hline straightline

@recipe function f(::Type{Val{:vline}}, x, y, z)  # COV_EXCL_LINE
    n = length(y)
    newx = vec(Float64[yi for i in 1:3, yi in y])
    x := newx
    y := repeat(Float64[1, 2, NaN], n)
    seriestype := :straightline
    ()
end
@deps vline straightline

@recipe function f(::Type{Val{:hspan}}, x, y, z)  # COV_EXCL_LINE
    n = div(length(y), 2)
    newx = repeat([-Inf, Inf, Inf, -Inf, NaN], outer = n)
    newy = vcat(map(i -> [y[2i - 1], y[2i - 1], y[2i], y[2i], NaN], 1:n)...)
    linewidth --> 0
    x := newx
    y := newy
    seriestype := :shape
    ()
end
@deps hspan shape

@recipe function f(::Type{Val{:vspan}}, x, y, z)  # COV_EXCL_LINE
    n = div(length(y), 2)
    newx = vcat(map(i -> [y[2i - 1], y[2i - 1], y[2i], y[2i], NaN], 1:n)...)
    newy = repeat([-Inf, Inf, Inf, -Inf, NaN], outer = n)
    linewidth --> 0
    x := newx
    y := newy
    seriestype := :shape
    ()
end
@deps vspan shape

# ---------------------------------------------------------------------------
# path and scatter

# create a path from steps
@recipe function f(::Type{Val{:scatterpath}}, x, y, z)  # COV_EXCL_LINE
    x := x
    y := y
    seriestype := :scatter
    @series begin
        ()
    end
    @series begin
        seriestype := :path
        label := ""
        primary := false
        ()
    end
    primary := false
    ()
end
@deps scatterpath path scatter

# ---------------------------------------------------------------------------
# regression line and scatter

# plots line corresponding to linear regression of y on a constant and x
@recipe function f(::Type{Val{:linearfit}}, x, y, z)  # COV_EXCL_LINE
    x := x
    y := y
    seriestype := :scatter
    @series begin
        ()
    end
    @series begin
        y := mean(y) .+ cov(x, y) / var(x) .* (x .- mean(x))
        seriestype := :path
        label := ""
        primary := false
        ()
    end
    primary := false
    ()
end

@specialize

# ---------------------------------------------------------------------------
# steps

make_steps(x, st, even) = x
function make_steps(x::AbstractArray, st, even)
    n = length(x)
    n == 0 && return zeros(0)
    newx = zeros(2n - (even ? 0 : 1))
    xstartindex = firstindex(x)
    newx[1] = x[xstartindex]
    for i in 2:n
        xindex = xstartindex - 1 + i
        idx = 2i - 1
        if st === :mid
            newx[idx] = newx[idx - 1] = (x[xindex] + x[xindex - 1]) / 2
        else
            newx[idx] = x[xindex]
            newx[idx - 1] = x[st === :pre ? xindex : xindex - 1]
        end
    end
    even && (newx[end] = x[end])
    return newx
end
make_steps(t::Tuple, st, even) = Tuple(make_steps(ti, st, even) for ti in t)

@nospecialize

# create a path from steps
@recipe function f(::Type{Val{:steppre}}, x, y, z)  # COV_EXCL_LINE
    plotattributes[:x] = make_steps(x, :post, false)
    plotattributes[:y] = make_steps(y, :pre, false)
    seriestype := :path

    # handle fillrange
    plotattributes[:fillrange] = make_steps(plotattributes[:fillrange], :pre, false)

    # create a secondary series for the markers
    if plotattributes[:markershape] !== :none
        @series begin
            seriestype := :scatter
            x := x
            y := y
            label := ""
            primary := false
            ()
        end
        markershape := :none
    end
    ()
end
@deps steppre path scatter

# create a path from steps
@recipe function f(::Type{Val{:stepmid}}, x, y, z)  # COV_EXCL_LINE
    plotattributes[:x] = make_steps(x, :mid, true)
    plotattributes[:y] = make_steps(y, :post, true)
    seriestype := :path

    # handle fillrange
    plotattributes[:fillrange] = make_steps(plotattributes[:fillrange], :post, true)

    # create a secondary series for the markers
    if plotattributes[:markershape] !== :none
        @series begin
            seriestype := :scatter
            x := x
            y := y
            label := ""
            primary := false
            ()
        end
        markershape := :none
    end
    ()
end
@deps stepmid path scatter

# create a path from steps
@recipe function f(::Type{Val{:steppost}}, x, y, z)  # COV_EXCL_LINE
    plotattributes[:x] = make_steps(x, :pre, false)
    plotattributes[:y] = make_steps(y, :post, false)
    seriestype := :path

    # handle fillrange
    plotattributes[:fillrange] = make_steps(plotattributes[:fillrange], :post, false)

    # create a secondary series for the markers
    if plotattributes[:markershape] !== :none
        @series begin
            seriestype := :scatter
            x := x
            y := y
            label := ""
            primary := false
            ()
        end
        markershape := :none
    end
    ()
end
@deps steppost path scatter

# ---------------------------------------------------------------------------
# sticks

# create vertical line segments from fill
@recipe function f(::Type{Val{:sticks}}, x, y, z)  # COV_EXCL_LINE
    n = length(x)
    if (fr = plotattributes[:fillrange]) === nothing
        sp = plotattributes[:subplot]
        fr = if sp[:yaxis][:scale] === :identity
            0.0
        else
            NaNMath.min(axis_limits(sp, :y)[1], ignorenan_minimum(y))
        end
    end
    newx, newy, newz = zeros(3n), zeros(3n), z !== nothing ? zeros(3n) : nothing
    for (i, (xi, yi, zi)) in enumerate(zip(x, y, z !== nothing ? z : 1:n))
        rng = (3i - 2):(3i)
        newx[rng] = [xi, xi, NaN]
        if z !== nothing
            newy[rng] = [yi, yi, NaN]
            newz[rng] = [_cycle(fr, i), zi, NaN]
        else
            newy[rng] = [_cycle(fr, i), yi, NaN]
        end
    end
    x := newx
    y := newy
    if z !== nothing
        z := newz
    end
    fillrange := nothing
    seriestype := :path
    if (
            plotattributes[:linecolor] === :auto &&
                plotattributes[:marker_z] !== nothing &&
                plotattributes[:line_z] === nothing
        )
        line_z := plotattributes[:marker_z]
    end

    # create a primary series for the markers
    if plotattributes[:markershape] !== :none
        primary := false
        @series begin
            seriestype := :scatter
            x := x
            y := y
            if z !== nothing
                z := z
            end
            primary := true
            ()
        end
        markershape := :none
    end
    ()
end
@deps sticks path scatter

@specialize

# ---------------------------------------------------------------------------
# bezier curves

# get the value of the curve point at position t
function bezier_value(pts::AVec, t::Real)
    val = 0.0
    n = length(pts) - 1
    for (i, p) in enumerate(pts)
        val += p * binomial(n, i - 1) * (1 - t)^(n - i + 1) * t^(i - 1)
    end
    return val
end

@nospecialize

# create segmented bezier curves in place of line segments
@recipe function f(::Type{Val{:curves}}, x, y, z; npoints = 30)  # COV_EXCL_LINE
    args = z !== nothing ? (x, y, z) : (x, y)
    newx, newy = zeros(0), zeros(0)
    newfr = (fr = plotattributes[:fillrange]) !== nothing ? zeros(0) : nothing
    newz = z !== nothing ? zeros(0) : nothing

    # for each line segment (point series with no NaNs), convert it into a bezier curve
    # where the points are the control points of the curve
    for rng in iter_segments(args...)
        length(rng) < 2 && continue
        ts = range(0, stop = 1, length = npoints)
        nanappend!(newx, map(t -> bezier_value(_cycle(x, rng), t), ts))
        nanappend!(newy, map(t -> bezier_value(_cycle(y, rng), t), ts))
        if z !== nothing
            nanappend!(newz, map(t -> bezier_value(_cycle(z, rng), t), ts))
        end
        if fr !== nothing
            nanappend!(newfr, map(t -> bezier_value(_cycle(fr, rng), t), ts))
        end
    end

    x := newx
    y := newy
    if z === nothing
        seriestype := :path
    else
        seriestype := :path3d
        z := newz
    end
    if fr !== nothing
        fillrange := newfr
    end
    ()
end
@deps curves path

# ---------------------------------------------------------------------------

# create a bar plot as a filled step function
@recipe function f(::Type{Val{:bar}}, x, y, z)  # COV_EXCL_LINE
    ywiden --> false
    procx, procy, xscale, yscale, _ = _preprocess_barlike(plotattributes, x, y)
    nx, ny = length(procx), length(procy)
    axis = plotattributes[:subplot][isvertical(plotattributes) ? :xaxis : :yaxis]
    cv = map(xi -> discrete_value!(plotattributes, :x, xi)[1], procx)
    procx = if nx == ny
        cv
    elseif nx == ny + 1
        0.5diff(cv) + @view(cv[1:(end - 1)])
    else
        error(
            "bar recipe: x must be same length as y (centers), or one more than y (edges).\n\t\tlength(x)=$(length(x)), length(y)=$(length(y))",
        )
    end

    # compute half-width of bars
    bw = plotattributes[:bar_width]
    hw = if bw === nothing
        0.5_bar_width * if nx > 1
            ignorenan_minimum(filter(x -> x > 0, diff(sort(procx))))
        else
            1
        end
    else
        map(i -> 0.5_cycle(bw, i), eachindex(procx))
    end

    # make fillto a vector... default fills to 0
    if (fillto = plotattributes[:fillrange]) === nothing
        fillto = 0
    end
    if yscale in _logScales && !all(_is_positive, fillto)
        # github.com/JuliaPlots/Plots.jl/issues/4502
        # https://github.com/JuliaPlots/Plots.jl/issues/4774
        T = float(eltype(y))
        min_y = NaNMath.minimum(y)
        base = _logScaleBases[yscale]
        baseline = floor_base(min_y, base)
        if min_y == baseline
            baseline /= base
        end
        fillto = map(x -> _is_positive(x) ? T(x) : T(baseline), fillto)
    end

    xseg, yseg = map(_ -> Segments(), 1:2)
    valid_i = isfinite.(procx) .& isfinite.(procy)
    for i in 1:ny
        valid_i[i] || continue
        yi = procy[i]
        center = procx[i]
        hwi = _cycle(hw, i)
        fi = _cycle(fillto, i)
        push!(xseg, center - hwi, center - hwi, center + hwi, center + hwi, center - hwi)
        push!(yseg, yi, fi, fi, yi, yi)
    end

    # widen limits out a bit
    expand_extrema!(axis, scale_lims(ignorenan_extrema(xseg.pts)..., default_widen_factor))

    # switch back
    if !isvertical(plotattributes)
        xseg, yseg = yseg, xseg
        x, y = y, x
    end

    # reset orientation
    orientation := default(:orientation)

    # draw the bar shapes
    @series begin
        seriestype := :shape
        series_annotations := nothing
        primary := true
        x := xseg.pts
        y := yseg.pts
        # expand attributes to match indices in new series data
        for k in _segmenting_vector_attributes ∪ _segmenting_array_attributes
            # if (v = get(plotattributes, k, nothing)) isa AVec
            #     if eachindex(v) != eachindex(y)
            #         @warn "Indices $(eachindex(v)) of attribute `$k` do not match data indices $(eachindex(y))."
            #     end
            #     # Each segment is 6 elements long, including the NaN separator.
            #     # One segment is created for each non-NaN element of `procy`.
            #     # There is no trailing NaN, so the last repetition is dropped.
            #     plotattributes[k] = @views repeat(v[valid_i]; inner = 6)[1:(end - 1)]
            # end
        end
        ()
    end

    # add empty series
    primary := false
    seriestype := :scatter
    markersize := 0
    markeralpha := 0
    fillrange := nothing
    x := procx
    y := procy
    ()
end
@deps bar shape

# ---------------------------------------------------------------------------
# Plots Heatmap
@recipe function f(::Type{Val{:plots_heatmap}}, x, y, z)  # COV_EXCL_LINE
    xe, ye = heatmap_edges(x), heatmap_edges(y)
    m, n = size(z.surf)
    x_pts, y_pts = fill(NaN, 6m * n), fill(NaN, 6m * n)
    fz = zeros(m * n)
    for i in 1:m, j in 1:n  # i ≡ y, j ≡ x
        k = (j - 1) * m + i
        inds = (6(k - 1) + 1):(6k - 1)
        x_pts[inds] .= [xe[j], xe[j + 1], xe[j + 1], xe[j], xe[j]]
        y_pts[inds] .= [ye[i], ye[i], ye[i + 1], ye[i + 1], ye[i]]
        fz[k] = z.surf[i, j]
    end
    ensure_gradient!(plotattributes, :fillcolor, :fillalpha)
    fill_z := fz
    line_z := fz
    x := x_pts
    y := y_pts
    z := nothing
    seriestype := :shape
    label := ""
    widen --> false
    ()
end
@deps plots_heatmap shape

@specialize

is_3d(::Type{Val{:plots_heatmap}}) = true
RecipesPipeline.is_surface(::Type{Val{:plots_heatmap}}) = true
RecipesPipeline.is_surface(::Type{Val{:hexbin}}) = true
# ---------------------------------------------------------------------------
# Histograms

_bin_centers(v::AVec) = (@view(v[1:(end - 1)]) + @view(v[2:end])) / 2

_is_positive(x) = (x > 0) && !(x ≈ 0)

_positive_else_nan(::Type{T}, x::Real) where {T} = _is_positive(x) ? T(x) : T(NaN)

_scale_adjusted_values(
    ::Type{T},
    V::AbstractVector,
    scale::Symbol,
) where {T <: AbstractFloat} = scale in _logScales ? _positive_else_nan.(T, V) : T.(V)

_binbarlike_baseline(min_value::T, scale::Symbol) where {T <: Real} =
if scale in _logScales
    isnan(min_value) ? T(1.0e-3) : floor_base(min_value, _logScaleBases[scale])
else
    zero(T)
end

function _preprocess_binbarlike_weights(
        ::Type{T},
        w,
        wscale::Symbol,
    ) where {T <: AbstractFloat}
    w_adj = _scale_adjusted_values(T, w, wscale)
    w_min = ignorenan_minimum(w_adj)
    w_max = ignorenan_maximum(w_adj)
    baseline = _binbarlike_baseline(w_min, wscale)
    return w_adj, baseline
end

function _preprocess_barlike(plotattributes, x, y)
    xscale = get(plotattributes, :xscale, :identity)
    yscale = get(plotattributes, :yscale, :identity)
    weights, baseline = _preprocess_binbarlike_weights(float(eltype(y)), y, yscale)
    return x, weights, xscale, yscale, baseline
end

function _preprocess_binlike(plotattributes, x, y)
    xscale = get(plotattributes, :xscale, :identity)
    yscale = get(plotattributes, :yscale, :identity)
    T = float(promote_type(eltype(x), eltype(y)))
    edge = T.(x)
    weights, baseline = _preprocess_binbarlike_weights(T, y, yscale)
    return edge, weights, xscale, yscale, baseline
end

@nospecialize

@recipe function f(::Type{Val{:barbins}}, x, y, z)  # COV_EXCL_LINE
    edge, weights, xscale, yscale, baseline = _preprocess_binlike(plotattributes, x, y)
    if plotattributes[:bar_width] === nothing
        bar_width := diff(edge)
    end
    x := _bin_centers(edge)
    y := weights
    seriestype := :bar
    ()
end
@deps barbins bar

@recipe function f(::Type{Val{:scatterbins}}, x, y, z)  # COV_EXCL_LINE
    edge, weights, xscale, yscale, baseline = _preprocess_binlike(plotattributes, x, y)
    @series begin
        x := _bin_centers(edge)
        xerror := diff(edge) / 2
        primary := false
        seriestype := :xerror
        ()
    end
    x := _bin_centers(edge)
    y := weights
    seriestype := :scatter
    ()
end
@deps scatterbins xerror scatter

@specialize

function _stepbins_path(edge, weights, baseline::Real, xscale::Symbol, yscale::Symbol)
    log_scale_x = xscale in _logScales
    log_scale_y = yscale in _logScales

    nbins = length(eachindex(weights))
    if length(eachindex(edge)) != nbins + 1
        error("Edge vector must be 1 longer than weight vector")
    end

    x = eltype(edge)[]
    y = eltype(weights)[]

    it_tuple_e = iterate(edge)
    a, it_state_e = it_tuple_e
    it_tuple_e = iterate(edge, it_state_e)
    it_tuple_w = iterate(weights)

    last_w = eltype(weights)(NaN)

    while it_tuple_e !== nothing && it_tuple_w !== nothing
        b, it_state_e = it_tuple_e
        w, it_state_w = it_tuple_w

        if log_scale_x && a ≈ 0
            a = oftype(a, b / _logScaleBases[xscale]^3)
        end

        if isnan(w)
            if !isnan(last_w)
                push!(x, a, NaN)
                push!(y, baseline, NaN)
            end
        else
            if isnan(last_w)
                push!(x, a)
                push!(y, baseline)
            end
            push!(x, a, b)
            push!(y, w, w)
        end

        a = oftype(a, b)
        last_w = oftype(last_w, w)

        it_tuple_e = iterate(edge, it_state_e)
        it_tuple_w = iterate(weights, it_state_w)
    end
    if (last_w != baseline)
        push!(x, a)
        push!(y, baseline)
    end

    return (x, y)
end

@recipe function f(::Type{Val{:stepbins}}, x, y, z)  # COV_EXCL_LINE
    @nospecialize
    axis = plotattributes[:subplot][Plots.isvertical(plotattributes) ? :xaxis : :yaxis]

    edge, weights, xscale, yscale, baseline = _preprocess_binlike(plotattributes, x, y)

    xpts, ypts = _stepbins_path(edge, weights, baseline, xscale, yscale)
    if !isvertical(plotattributes)
        xpts, ypts = ypts, xpts
    end

    # create a secondary series for the markers
    if plotattributes[:markershape] !== :none
        @series begin
            seriestype := :scatter
            x := _bin_centers(edge)
            y := weights
            fillrange := nothing
            label := ""
            primary := false
            ()
        end
        markershape := :none
        xerror := :none
        yerror := :none
    end

    x := xpts
    y := ypts
    seriestype := :path
    ()
end
@deps stepbins path

function wand_edges(x...)
    @warn """"
    Load the StatsPlots package in order to use :wand bins.
    Defaulting to :auto
    """ once = true
    return :auto
end

function _auto_binning_nbins(
        vs::NTuple{N, AbstractVector},
        dim::Integer;
        mode::Symbol = :auto,
    ) where {N}
    max_bins = 10_000
    _cl(x) = min(ceil(Int, max(x, one(x))), max_bins)
    _iqr(v) = (q = quantile(v, 0.75) - quantile(v, 0.25); q > 0 ? q : oftype(q, 1))
    _span(v) = maximum(v) - minimum(v)

    n_samples = length(LinearIndices(first(vs)))

    # The nd estimator is the key to most automatic binning methods, and is modified for twodimensional histograms to include correlation
    nd = n_samples^(1 / (2 + N))
    nd = if N == 2
        min(n_samples^(1 / (2 + N)), nd / (1 - cor(first(vs), last(vs))^2)^(3 // 8))
    else # the >2-dimensional case does not have a nice solution to correlations
        nd
    end

    v = vs[dim]
    mode === :auto && (mode = :fd)

    return if mode === :sqrt  # Square-root choice
        _cl(sqrt(n_samples))
    elseif mode === :sturges  # Sturges' formula
        _cl(log2(n_samples) + 1)
    elseif mode === :rice  # Rice Rule
        _cl(2 * nd)
    elseif mode === :scott  # Scott's normal reference rule
        _cl(_span(v) / (3.5 * std(v) / nd))
    elseif mode === :fd  # Freedman–Diaconis rule
        _cl(_span(v) / (2 * _iqr(v) / nd))
    elseif mode === :wand
        wand_edges(v)  # this makes this function not type stable, but the type instability does not propagate
    else
        error("Unknown auto-binning mode $mode")
    end
end

_hist_edge(vs::NTuple{N, AbstractVector}, dim::Integer, binning::Integer) where {N} =
    StatsBase.histrange(vs[dim], binning, :left)
_hist_edge(vs::NTuple{N, AbstractVector}, dim::Integer, binning::Symbol) where {N} =
    _hist_edge(vs, dim, _auto_binning_nbins(vs, dim, mode = binning))
_hist_edge(vs::NTuple{N, AbstractVector}, dim::Integer, binning::AbstractVector) where {N} =
    binning

_hist_edges(vs::NTuple{N, AbstractVector}, binning::NTuple{N, Any}) where {N} =
    map(dim -> _hist_edge(vs, dim, binning[dim]), Tuple(1:N))

_hist_edges(
    vs::NTuple{N, AbstractVector},
    binning::Union{Integer, Symbol, AbstractVector},
) where {N} = map(dim -> _hist_edge(vs, dim, binning), Tuple(1:N))

_hist_norm_mode(mode::Symbol) = mode
_hist_norm_mode(mode::Bool) = mode ? :pdf : :none

_invertedindex(v, not) = [j for (i, j) in enumerate(v) if !(i ∈ not)]
_filternans(vs::NTuple{1, AbstractVector}) = filter!.(isfinite, vs)
_filternans(vs::NTuple{1, AbstractRange}) = filter!.(isfinite, collect.(vs))
function _filternans(vs::NTuple{N, AbstractVector}) where {N}
    nots = union(Set.(findall.(!isfinite, vs))...)
    return _invertedindex.(vs, Ref(nots))
end

function _make_hist(
        vs::NTuple{N, AbstractVector},
        binning;
        normed = false,
        weights = nothing,
    ) where {N}
    localvs = _filternans(vs)
    edges = _hist_edges(localvs, binning)
    h = float(
        weights === nothing ?
            StatsBase.fit(StatsBase.Histogram, localvs, edges, closed = :left) :
            StatsBase.fit(
                StatsBase.Histogram,
                localvs,
                StatsBase.Weights(weights),
                edges,
                closed = :left,
            ),
    )
    return normalize!(h, mode = _hist_norm_mode(normed))
end

@nospecialize

@recipe function f(::Type{Val{:histogram}}, x, y, z)  # COV_EXCL_LINE
    seriestype := length(y) > 1.0e6 ? :stephist : :barhist
    ()
end
@deps histogram barhist

@recipe function f(::Type{Val{:barhist}}, x, y, z)  # COV_EXCL_LINE
    h = _make_hist(
        tuple(y),
        plotattributes[:bins],
        normed = plotattributes[:normalize],
        weights = plotattributes[:weights],
    )
    x := h.edges[1]
    y := h.weights
    seriestype := :barbins
    ()
end
@deps barhist barbins

@recipe function f(::Type{Val{:stephist}}, x, y, z)  # COV_EXCL_LINE
    h = _make_hist(
        tuple(y),
        plotattributes[:bins],
        normed = plotattributes[:normalize],
        weights = plotattributes[:weights],
    )
    x := h.edges[1]
    y := h.weights
    seriestype := :stepbins
    ()
end
@deps stephist stepbins

@recipe function f(::Type{Val{:scatterhist}}, x, y, z)  # COV_EXCL_LINE
    h = _make_hist(
        tuple(y),
        plotattributes[:bins],
        normed = plotattributes[:normalize],
        weights = plotattributes[:weights],
    )
    x := h.edges[1]
    y := h.weights
    seriestype := :scatterbins
    ()
end
@deps scatterhist scatterbins

@recipe function f(h::StatsBase.Histogram{T, 1, E}) where {T, E}  # COV_EXCL_LINE
    seriestype --> :barbins

    st_map = Dict(
        :bar => :barbins,
        :scatter => :scatterbins,
        :step => :stepbins,
        :steppost => :stepbins, # :step can be mapped to :steppost in pre-processing
    )
    seriestype := get(st_map, plotattributes[:seriestype], plotattributes[:seriestype])

    if plotattributes[:seriestype] === :scatterbins
        # Workaround, error bars currently not set correctly by scatterbins
        edge, weights, xscale, yscale, baseline =
            _preprocess_binlike(plotattributes, h.edges[1], h.weights)
        xerror --> diff(h.edges[1]) / 2
        seriestype := :scatter
        (Plots._bin_centers(edge), weights)
    else
        (h.edges[1], h.weights)
    end
end

@recipe f(hv::AbstractVector{H}) where {H <: StatsBase.Histogram} =  # COV_EXCL_LINE
    for h in hv
    @series begin
        h
    end
end

# ---------------------------------------------------------------------------
# Histogram 2D

@recipe function f(::Type{Val{:bins2d}}, x, y, z)  # COV_EXCL_LINE
    edge_x, edge_y, weights = x, y, z.surf

    float_weights = float(weights)
    if !plotattributes[:show_empty_bins]
        if float_weights === weights
            float_weights = deepcopy(float_weights)
        end
        for (i, c) in enumerate(float_weights)
            c == 0 && (float_weights[i] = NaN)
        end
    end

    x := Plots._bin_centers(edge_x)
    y := Plots._bin_centers(edge_y)
    z := Surface(permutedims(float_weights))
    seriestype := :heatmap
    ()
end
Plots.@deps bins2d heatmap

@recipe function f(::Type{Val{:histogram2d}}, x, y, z)  # COV_EXCL_LINE
    h = _make_hist(
        (x, y),
        plotattributes[:bins],
        normed = plotattributes[:normalize],
        weights = plotattributes[:weights],
    )
    x := h.edges[1]
    y := h.edges[2]
    z := Surface(h.weights)
    seriestype := :bins2d
    ()
end
@deps histogram2d bins2d

@recipe function f(h::StatsBase.Histogram{T, 2, E}) where {T, E}  # COV_EXCL_LINE
    seriestype --> :bins2d
    (h.edges[1], h.edges[2], Surface(h.weights))
end

# ---------------------------------------------------------------------------
# pie
@recipe function f(::Type{Val{:pie}}, x, y, z)  # COV_EXCL_LINE
    framestyle --> :none
    aspect_ratio --> 1
    s = sum(y)
    θ = 0
    colors = plotattributes[:seriescolor]
    for i in eachindex(y)
        θ_new = θ + 2π * y[i] / s
        coords = [(0.0, 0.0); partialcircle(θ, θ_new, 50)]
        @series begin
            seriescolor := _cycle(colors, i)
            seriestype := :shape
            label --> string(x[i])
            x := first.(coords)
            y := last.(coords)
        end
        θ = θ_new
    end
end
@deps pie shape

# ---------------------------------------------------------------------------
# mesh 3d replacement for non-plotly backends

@recipe function f(::Type{Val{:mesh3d}}, x, y, z)  # COV_EXCL_LINE
    # As long as no i,j,k are supplied this should work with PyPlot and GR
    seriestype := :surface
    if plotattributes[:connections] !== nothing
        "Giving triangles using the connections argument is only supported on Plotly backend." |>
            ArgumentError |>
            throw
    end
    ()
end

# ---------------------------------------------------------------------------
# scatter 3d

@recipe function f(::Type{Val{:scatter3d}}, x, y, z)  # COV_EXCL_LINE
    seriestype := :path3d
    if plotattributes[:markershape] === :none
        markershape := :circle
    end
    linewidth := 0
    linealpha := 0
    ()
end

# note: don't add dependencies because this really isn't a drop-in replacement

# ---------------------------------------------------------------------------
# lens! - magnify a region of a plot
lens!(args...; kwargs...) = plot!(args...; seriestype = :lens, kwargs...)
export lens!
@recipe function f(::Type{Val{:lens}}, plt::AbstractPlot)  # COV_EXCL_LINE
    sp_index, inset_bbox = plotattributes[:inset_subplots]
    width(inset_bbox) isa Measures.Length{:w, <:Real} ||
        throw(ArgumentError("Inset bounding box needs to in relative coordinates."))
    sp = plt.subplots[sp_index]
    xscale = sp[:xaxis][:scale]
    yscale = sp[:yaxis][:scale]
    xl1, xl2 = xlims(sp)
    xls1, xls2 = RecipesPipeline.scale_func(xscale).((xl1, xl2))
    bbx1 = xls1 + left(inset_bbox).value * (xls2 - xls1)
    bbx2 = bbx1 + width(inset_bbox).value * (xls2 - xls1)
    yl1, yl2 = ylims(sp)
    yls1, yls2 = RecipesPipeline.scale_func(yscale).((yl1, yl2))
    bby1 = yls1 + (1 - bottom(inset_bbox).value) * (yls2 - yls1)
    bby2 = bby1 + height(inset_bbox).value * (yls2 - yls1)
    bbx = bbx1 + width(inset_bbox).value * (xls2 - xls1) / 2 * (sp[:xaxis][:flip] ? -1 : 1)
    bby = bby1 + height(inset_bbox).value * (yls2 - yls1) / 2 * (sp[:yaxis][:flip] ? -1 : 1)
    lens_index = last(plt.subplots)[:subplot_index] + 1
    x1, x2 = plotattributes[:x]
    y1, y2 = plotattributes[:y]
    xs1, xs2 = RecipesPipeline.scale_func(xscale).((x1, x2))
    ys1, ys2 = RecipesPipeline.scale_func(yscale).((y1, y2))

    backup = copy(plotattributes)
    empty!(plotattributes)

    series_plotindex := backup[:series_plotindex]
    seriestype := :path
    primary := false
    linecolor := get(backup, :linecolor, :lightgray)
    if haskey(backup, :linestyle)
        linestyle := backup[:linestyle]
    end
    if haskey(backup, :linewidth)
        linewidth := backup[:linewidth]
    end
    bbx_mag = (xs1 + xs2) / 2
    bby_mag = (ys1 + ys2) / 2
    xi_lens, yi_lens =
        intersection_point(bbx_mag, bby_mag, bbx, bby, abs(bby2 - bby1), abs(bbx2 - bbx1))
    xi_mag, yi_mag =
        intersection_point(bbx, bby, bbx_mag, bby_mag, abs(y2 - y1), abs(x2 - x1))
    xi_mag, xi_lens = RecipesPipeline.inverse_scale_func(xscale).((xi_mag, xi_lens))
    yi_mag, yi_lens = RecipesPipeline.inverse_scale_func(yscale).((yi_mag, yi_lens))
    # add lines
    if xl1 < xi_lens < xl2 && yl1 < yi_lens < yl2
        @series begin
            primary := false
            subplot := sp_index
            x := [xi_mag, xi_lens]
            y := [yi_mag, yi_lens]
            ()
        end
    end
    # add magnification shape
    @series begin
        primary := false
        subplot := sp_index
        x := [x1, x1, x2, x2, x1]
        y := [y1, y2, y2, y1, y1]
        ()
    end
    # add subplot
    for series in sp.series_list
        @series begin
            plotattributes = merge(backup, copy(series.plotattributes))
            subplot := lens_index
            primary := false
            xlims := (x1, x2)
            ylims := (y1, y2)
            ()
        end
    end
    nothing
end

@specialize

function intersection_point(xA, yA, xB, yB, h, w)
    s = (yA - yB) / (xA - xB)
    hh, hw = h / 2, w / 2
    # left or right?
    return if -hh <= s * hw <= hh
        if xA > xB  # right
            xB + hw, yB + s * hw
        else  # left
            xB - hw, yB - s * hw
        end
        # top or bot?
    elseif -hw <= hh / s <= hw
        if yA > yB  # top
            xB + hh / s, yB + hh
        else  # bottom
            xB - hh / s, yB - hh
        end
    end
end
# ---------------------------------------------------------------------------
# contourf - filled contours

@recipe function f(::Type{Val{:contourf}}, x, y, z)  # COV_EXCL_LINE
    @nospecialize
    fillrange := true
    seriestype := :contour
    ()
end

# ---------------------------------------------------------------------------
# Error Bars

@attributes function error_style!(plotattributes::AKW)
    # errorbar color should soley determined by markerstrokecolor
    haskey(plotattributes, :marker_z) && reset_kw!(plotattributes, :marker_z)
    haskey(plotattributes, :line_z) && reset_kw!(plotattributes, :line_z)

    msc = if (msc = plotattributes[:markerstrokecolor]) === :match
        plotattributes[:subplot][:foreground_color_subplot]
    elseif msc === :auto
        get_series_color(
            plotattributes[:linecolor],
            plotattributes[:subplot],
            plotattributes[:series_plotindex],
            plotattributes[:seriestype],
        )
    else
        msc
    end

    seriestype := :path
    markerstrokecolor --> msc
    markercolor --> msc
    linecolor --> msc
    linewidth --> plotattributes[:markerstrokewidth]
    label --> ""
end

# if we're passed a tuple of vectors, convert to a vector of tuples
error_zipit(ebar) = istuple(ebar) ? collect(zip(ebar...)) : ebar

error_tuple(x) = x, x
error_tuple(x::Tuple) = x

function error_coords(errorbar, errordata, otherdata...)
    ed = Vector{float_extended_type(errordata)}(undef, 0)
    od = map(odi -> Vector{float_extended_type(odi)}(undef, 0), otherdata)
    for (i, edi) in enumerate(errordata)
        for (j, odj) in enumerate(otherdata)
            odi = _cycle(odj, i)
            nanappend!(od[j], [odi, odi])
        end
        e1, e2 = error_tuple(_cycle(errorbar, i))
        nanappend!(ed, [edi - e1, edi + e2])
    end
    return (ed, od...)
end

# clamp non-NaN values in an array to Base.eps(Float64) for log-scale plots
clamp_to_eps!(ary) = (replace!(x -> x <= 0.0 ? Base.eps(Float64) : x, ary); nothing)

# we will create a series of path segments, where each point represents one
# side of an errorbar

@nospecialize

@recipe function f(::Type{Val{:xerror}}, x, y, z)  # COV_EXCL_LINE
    error_style!(plotattributes)
    markershape := :vline
    xerr = error_zipit(plotattributes[:xerror])
    if z === nothing
        plotattributes[:x], plotattributes[:y] = error_coords(xerr, x, y)
    else
        plotattributes[:x], plotattributes[:y], plotattributes[:z] =
            error_coords(xerr, x, y, z)
    end
    if :xscale ∈ keys(plotattributes) && plotattributes[:xscale] === :log10
        clamp_to_eps!(plotattributes[:x])
    end
    ()
end
@deps xerror path

@recipe function f(::Type{Val{:yerror}}, x, y, z)  # COV_EXCL_LINE
    error_style!(plotattributes)
    markershape := :hline
    yerr = error_zipit(plotattributes[:yerror])
    if z === nothing
        plotattributes[:y], plotattributes[:x] = error_coords(yerr, y, x)
    else
        plotattributes[:y], plotattributes[:x], plotattributes[:z] =
            error_coords(yerr, y, x, z)
    end
    if :yscale ∈ keys(plotattributes) && plotattributes[:yscale] === :log10
        clamp_to_eps!(plotattributes[:y])
    end
    ()
end
@deps yerror path

@recipe function f(::Type{Val{:zerror}}, x, y, z)  # COV_EXCL_LINE
    error_style!(plotattributes)
    markershape := :hline
    if z !== nothing
        zerr = error_zipit(plotattributes[:zerror])
        plotattributes[:z], plotattributes[:x], plotattributes[:y] =
            error_coords(zerr, z, x, y)
    end
    if :zscale ∈ keys(plotattributes) && plotattributes[:zscale] === :log10
        clamp_to_eps!(plotattributes[:z])
    end
    ()
end
@deps zerror path

@specialize

# TODO: move quiver to PlotRecipes

# ---------------------------------------------------------------------------
# quiver

# function apply_series_recipe(plotattributes::AKW, ::Type{Val{:quiver}})
function quiver_using_arrows(plotattributes::AKW)
    plotattributes[:label] = ""
    plotattributes[:seriestype] = :path
    isa(plotattributes[:arrow], Arrow) || (plotattributes[:arrow] = arrow())
    is_3d = haskey(plotattributes, :z) && !isnothing(plotattributes[:z])
    velocity = error_zipit(plotattributes[:quiver])
    xorig, yorig = plotattributes[:x], plotattributes[:y]
    zorig = is_3d ? plotattributes[:z] : []

    # for each point, we create an arrow of velocity vi, translated to the x/y coordinates
    x, y = zeros(0), zeros(0)
    is_3d && (z = zeros(0))
    for i in 1:max(length(xorig), length(yorig), is_3d ? 0 : length(zorig))
        # get the starting position
        xi = _cycle(xorig, i)
        yi = _cycle(yorig, i)
        zi = is_3d ? _cycle(zorig, i) : 0
        # get the velocity
        vi = _cycle(velocity, i)
        if is_3d
            vx, vy, vz = if istuple(vi)
                vi[1], vi[2], vi[3]
            elseif isscalar(vi)
                vi, vi, vi
            elseif isa(vi, Function)
                vi(xi, yi, zi)
            else
                error("unexpected vi type $(typeof(vi)) for quiver: $vi")
            end
        else # 2D quiver
            vx, vy = if istuple(vi)
                first(vi), last(vi)
            elseif isscalar(vi)
                vi, vi
            elseif isa(vi, Function)
                vi(xi, yi)
            else
                error("unexpected vi type $(typeof(vi)) for quiver: $vi")
            end
        end
        # add the points
        nanappend!(x, [xi, xi + vx, NaN])
        nanappend!(y, [yi, yi + vy, NaN])
        is_3d && nanappend!(z, [zi, zi + vz, NaN])
    end
    plotattributes[:x], plotattributes[:y] = x, y
    return is_3d && (plotattributes[:z] = z)
    # KW[plotattributes]
end

# function apply_series_recipe(plotattributes::AKW, ::Type{Val{:quiver}})
function quiver_using_hack(plotattributes::AKW)
    plotattributes[:label] = ""
    plotattributes[:seriestype] = :shape

    velocity = error_zipit(plotattributes[:quiver])
    xorig, yorig = plotattributes[:x], plotattributes[:y]

    # for each point, we create an arrow of velocity vi, translated to the x/y coordinates
    pts = P2[]
    for i in 1:max(length(xorig), length(yorig))

        # get the starting position
        xi = _cycle(xorig, i)
        yi = _cycle(yorig, i)
        p = P2((xi, yi))

        # get the velocity
        vi = _cycle(velocity, i)
        vx, vy = if istuple(vi)
            first(vi), last(vi)
        elseif isscalar(vi)
            vi, vi
        elseif isa(vi, Function)
            vi(xi, yi)
        else
            error("unexpected vi type $(typeof(vi)) for quiver: $vi")
        end
        v = P2((vx, vy))

        dist = norm(v)
        arrow_h = 0.1dist          # height of arrowhead
        arrow_w = 0.5arrow_h       # halfwidth of arrowhead
        U1 = v ./ dist             # vector of arrowhead height
        U2 = P2((-U1[2], U1[1]))   # vector of arrowhead halfwidth
        U1 = U1 .* arrow_h
        U2 = U2 .* arrow_w

        ppv = p .+ v
        nanappend!(pts, P2[p, ppv .- U1, ppv .- U1 .+ U2, ppv, ppv .- U1 .- U2, ppv .- U1])
    end

    return plotattributes[:x], plotattributes[:y] = RecipesPipeline.unzip(pts[2:end])
end

# function apply_series_recipe(plotattributes::AKW, ::Type{Val{:quiver}})
@recipe function f(::Type{Val{:quiver}}, x, y, z)  # COV_EXCL_LINE
    @nospecialize
    if :arrow in supported_attrs()
        quiver_using_arrows(plotattributes)
    else
        quiver_using_hack(plotattributes)
    end
    ()
end
@deps quiver shape path

# --------------------------------------------------------------------
# 1 argument
# --------------------------------------------------------------------

# images - grays
function clamp_greys!(mat::AMat{<:Gray})
    for i in eachindex(mat)
        mat[i].val < 0 && (mat[i] = Gray(0))
        mat[i].val > 1 && (mat[i] = Gray(1))
    end
    return mat
end

@recipe function f(mat::AMat{<:Gray})  # COV_EXCL_LINE
    n, m = map(a -> range(first(a) - 0.5, stop = last(a) + 0.5), axes(mat))

    if is_seriestype_supported(:image)
        seriestype := :image
        yflip --> true
        SliceIt, m, n, Surface(clamp_greys!(mat))
    else
        seriestype := :heatmap
        yflip --> true
        colorbar --> false
        fillcolor --> cgrad([:black, :white])
        SliceIt, m, n, Surface(clamp!(convert(Matrix{Float64}, mat), 0.0, 1.0))
    end
end

@nospecialize

# images - colors
@recipe function f(mat::AMat{T}) where {T <: Colorant}  # COV_EXCL_LINE
    n, m = map(a -> range(first(a) - 0.5, stop = last(a) + 0.5), axes(mat))

    if is_seriestype_supported(:image)
        seriestype := :image
        yflip --> true
        SliceIt, m, n, Surface(mat)
    else
        seriestype := :heatmap
        yflip --> true
        colorbar --> false
        aspect_ratio --> :equal
        z, plotattributes[:fillcolor] = replace_image_with_heatmap(mat)
        SliceIt, m, n, Surface(z)
    end
end

# plotting arbitrary shapes/polygons

@recipe function f(shape::Shape)  # COV_EXCL_LINE
    seriestype --> :shape
    coords(shape)
end

@recipe function f(shapes::AVec{<:Shape})  # COV_EXCL_LINE
    seriestype --> :shape
    # For backwards compatibility, column vectors of segmenting attributes are
    # interpreted as having one element per shape
    for attr in union(_segmenting_array_attributes, _segmenting_vector_attributes)
        v = get(plotattributes, attr, nothing)
        if v isa AVec || v isa AMat && size(v, 2) == 1
            @warn """
            Column vector attribute `$attr` reinterpreted as row vector (one value per shape).
            Pass a row vector instead (e.g. using `permutedims`) to suppress this warning.
            """
            plotattributes[attr] = permutedims(v)
        end
    end
    coords(shapes)
end

@recipe function f(shapes::AMat{<:Shape})  # COV_EXCL_LINE
    seriestype --> :shape
    for j in axes(shapes, 2)
        @series coords(vec(shapes[:, j]))
    end
end

# --------------------------------------------------------------------
# 3 arguments
# --------------------------------------------------------------------

# images - grays
@recipe function f(x::AVec, y::AVec, mat::AMat{T}) where {T <: Gray}  # COV_EXCL_LINE
    if is_seriestype_supported(:image)
        seriestype := :image
        yflip --> true
        SliceIt, x, y, Surface(mat)
    else
        seriestype := :heatmap
        yflip --> true
        colorbar --> false
        fillcolor --> cgrad([:black, :white])
        SliceIt, x, y, Surface(convert(Matrix{Float64}, mat))
    end
end

# images - colors
@recipe function f(x::AVec, y::AVec, mat::AMat{T}) where {T <: Colorant}  # COV_EXCL_LINE
    if is_seriestype_supported(:image)
        seriestype := :image
        yflip --> true
        SliceIt, x, y, Surface(mat)
    else
        seriestype := :heatmap
        yflip --> true
        colorbar --> false
        z, plotattributes[:fillcolor] = replace_image_with_heatmap(mat)
        SliceIt, x, y, Surface(z)
    end
end

@specialize

# -------------------------------------------------

# TODO: move OHLC to PlotRecipes finance.jl

"Represent Open High Low Close data (used in finance)"
mutable struct OHLC{T <: Real}
    open::T
    high::T
    low::T
    close::T
end
Base.convert(::Type{OHLC}, tup::Tuple) = OHLC(tup...)
# Base.tuple(ohlc::OHLC) = (ohlc.open, ohlc.high, ohlc.low, ohlc.close)

# get one OHLC path
function get_xy(o::OHLC, x, xdiff)
    xl, xm, xr = x - xdiff, x, x + xdiff
    ox = [xl, xm, NaN, xm, xm, NaN, xm, xr]
    oy = [o.open, o.open, NaN, o.low, o.high, NaN, o.close, o.close]
    return ox, oy
end

# get the joined vector
function get_xy(v::AVec{OHLC}, x = eachindex(v))
    xdiff = 0.3ignorenan_mean(abs.(diff(x)))
    x_out, y_out = zeros(0), zeros(0)
    for (i, ohlc) in enumerate(v)
        ox, oy = get_xy(ohlc, x[i], xdiff)
        nanappend!(x_out, ox)
        nanappend!(y_out, oy)
    end
    return x_out, y_out
end

# these are for passing in a vector of OHLC objects
# TODO: when I allow `@recipe f(::Type{T}, v::T) = ...` definitions to replace convertToAnyVector,
#       then I should replace these with one definition to convert to a vector of 4-tuples

@nospecialize

@recipe f(x::AVec, ohlc::AVec{NTuple{N, <:Number}}) where {N} = x, map(t -> OHLC(t...), ohlc)

@recipe f(xyuv::AVec{NTuple}) =
    get(plotattributes, :seriestype, :path) === :ohlc ? map(t -> OHLC(t...), xyuv) :
    RecipesPipeline.unzip(xyuv)

@recipe function f(x::AVec, v::AVec{OHLC})  # COV_EXCL_LINE
    seriestype := :path
    get_xy(v, x)
end

@recipe function f(v::AVec{OHLC})  # COV_EXCL_LINE
    seriestype := :path
    get_xy(v)
end

# the series recipe, when passed vectors of 4-tuples

# -------------------------------------------------

# TODO: everything below here should be either changed to a
#       series recipe or moved to PlotRecipes

# "Sparsity plot... heatmap of non-zero values of a matrix"
# function spy{T<:Real}(z::AMat{T}; kw...)
#     mat = reshape(map(zi->float(zi!=0), z),1,:)
#     xn, yn = size(mat)
#     heatmap(mat; leg=false, yflip=true, aspect_ratio=:equal,
#         xlim=(0.5, xn+0.5), ylim=(0.5, yn+0.5),
#         kw...)
# end

# Only allow matrices through, and make it seriestype :spy so the backend can
# optionally handle it natively.

@userplot Spy

@recipe function f(g::Spy)  # COV_EXCL_LINE
    @assert length(g.args) == 1 && typeof(g.args[1]) <: AbstractMatrix
    seriestype := :spy
    mat = g.args[1]
    n, m = axes(mat)
    SliceIt, m, n, Surface(mat)
end

@recipe function f(::Type{Val{:spy}}, x, y, z)  # COV_EXCL_LINE
    yflip := true
    aspect_ratio := 1
    rs, cs, zs = findnz(z.surf)
    xlims := ignorenan_extrema(cs)
    ylims := ignorenan_extrema(rs)
    widen --> true

    markershape --> :circle
    markersize --> 1
    markerstrokewidth := 0
    if length(unique(zs)) == 1
        seriescolor --> :black
    else
        marker_z := zs
    end
    label := ""
    x := cs
    y := rs
    z := nothing
    seriestype := :scatter
    grid --> false
    ()
end

@specialize

findnz(A::AbstractSparseMatrix) = SparseArrays.findnz(A)

# fallback function for finding non-zero elements of non-sparse matrices
function findnz(A::AbstractMatrix)
    keysnz = findall(!iszero, A)
    rs = map(k -> k[1], keysnz)
    cs = map(k -> k[2], keysnz)
    zs = A[keysnz]
    return rs, cs, zs
end

# -------------------------------------------------

@nospecialize

abline!(plt::Plot, a, b; kw...) =
    plot!(plt, [0, 1], [b, b + a]; seriestype = :straightline, kw...)

abline!(args...; kw...) = abline!(current(), args...; kw...)

# -------------------------------------------------
# Complex Numbers

@recipe function f(A::AbstractArray{Complex{T}}) where {T <: Number}  # COV_EXCL_LINE
    xguide --> "Re(x)"
    yguide --> "Im(x)"
    real.(A), imag.(A)
end

# Splits a complex matrix to its real and complex parts
# Reals defaults solid, imaginary defaults dashed
# Label defaults are changed to match the real-imaginary reference / indexing
@recipe function f(x::AbstractArray{Real}, y::AbstractMatrix{Complex})  # COV_EXCL_LINE
    ylabel --> "Re(y)"
    zlabel --> "Im(y)"
    x, real.(y), imag.(y)
end

# Moved in from PlotRecipes - see: http://stackoverflow.com/a/37732384/5075246
@userplot PortfolioComposition

# this shows the shifting composition of a basket of something over a variable
# - "returns" are the dependent variable
# - "weights" are a matrix where the ith column is the composition for returns[i]
# - since each polygon is its own series, you can assign labels easily
@recipe function f(pc::PortfolioComposition)  # COV_EXCL_LINE
    weights, returns = pc.args
    n = length(returns)
    weights = cumsum(weights, dims = 2)
    seriestype := :shape

    # create a filled polygon for each item
    for c in axes(weights, 2)
        sx = vcat(weights[:, c], c == 1 ? zeros(n) : reverse(weights[:, c - 1]))
        sy = vcat(returns, reverse(returns))
        @series Plots.isvertical(plotattributes) ? (sx, sy) : (sy, sx)
    end
end

@userplot AreaPlot

@recipe function f(a::AreaPlot; seriestype = :line)  # COV_EXCL_LINE
    data = cumsum(a.args[end], dims = 2)
    x = length(a.args) == 1 ? (axes(data, 1)) : a.args[1]
    for i in axes(data, 2)
        @series begin
            fillrange := i > 1 ? data[:, i - 1] : 0
            x, data[:, i]
        end
    end
end

@specialize

# https://plot.ly/javascript/getting-started

_plotly_framestyle(style::Symbol) =
if style in (:box, :axes, :zerolines, :grid, :none)
    style
else
    default_style = get((semi = :box, origin = :zerolines), style, :axes)
    @warn "Framestyle :$style is not supported by Plotly and PlotlyJS. :$default_style was chosen instead."
    default_style
end

# --------------------------------------------------------------------------------------

using UUIDs

# ----------------------------------------------------------------

function labelfunc(scale::Symbol, backend::PlotlyBackend)
    texfunc = labelfunc_tex(scale)
    return x -> begin
        tex_x = texfunc(x)
        sup_x = replace(tex_x, r"\^{(.*)}" => s"<sup>\1</sup>")
        # replace dash with \minus (U+2212)
        replace(sup_x, "-" => "−")
    end
end

plotly_font(font::Font, color = font.color) = KW(
    :family => font.family,
    :size => round(Int, 1.4font.pointsize),
    :color => rgba_string(color),
)

plotly_annotation_dict(x, y, val; xref = "paper", yref = "paper") =
    KW(:text => val, :xref => xref, :x => x, :yref => yref, :y => y, :showarrow => false)

plotly_annotation_dict(x, y, z, val; xref = "paper", yref = "paper", zref = "paper") = KW(
    :text => val,
    :xref => xref,
    :x => x,
    :yref => yref,
    :y => y,
    :zref => zref,
    :z => z,
    :showarrow => false,
)

plotly_annotation_dict(x, y, ptxt::PlotText; xref = "paper", yref = "paper") = merge(
    plotly_annotation_dict(x, y, ptxt.str; xref = xref, yref = yref),
    KW(
        :font => plotly_font(ptxt.font),
        :xanchor => ptxt.font.halign === :hcenter ? :center : ptxt.font.halign,
        :yanchor => ptxt.font.valign === :vcenter ? :middle : ptxt.font.valign,
        :rotation => -ptxt.font.rotation,
    ),
)

plotly_annotation_dict(
    x,
    y,
    z,
    ptxt::PlotText;
    xref = "paper",
    yref = "paper",
    zref = "paper",
) = merge(
    plotly_annotation_dict(x, y, z, ptxt.str; xref = xref, yref = yref, zref = zref),
    KW(
        :font => plotly_font(ptxt.font),
        :xanchor => ptxt.font.halign === :hcenter ? :center : ptxt.font.halign,
        :yanchor => ptxt.font.valign === :vcenter ? :middle : ptxt.font.valign,
        :rotation => -ptxt.font.rotation,
    ),
)

plotly_scale(scale::Symbol) = scale === :log10 ? "log" : "-"

function shrink_by(lo, sz, ratio)
    amt = 0.5(1 - ratio) * sz
    return lo + amt, sz - 2amt
end

function plotly_apply_aspect_ratio(sp::Subplot, plotarea, pcts)
    # a 3D scene's box proportions come from `scene.aspectmode` (see `plotly_scene_aspect`),
    # not from shrinking the domain rectangle it is drawn into - the ratio below is derived
    # from the `x`/`y` data ranges alone and is meaningless under a 3D projection
    RecipesPipeline.is3d(sp) && return pcts
    if (aspect_ratio = get_aspect_ratio(sp)) !== :none
        aspect_ratio === :equal && (aspect_ratio = 1.0)
        xmin, xmax = axis_limits(sp, :x)
        ymin, ymax = axis_limits(sp, :y)
        want_ratio = ((xmax - xmin) / (ymax - ymin)) / aspect_ratio
        parea_ratio = width(plotarea) / height(plotarea)
        if want_ratio > parea_ratio
            # need to shrink y
            ratio = parea_ratio / want_ratio
            pcts[2], pcts[4] = shrink_by(pcts[2], pcts[4], ratio)
        elseif want_ratio < parea_ratio
            # need to shrink x
            ratio = want_ratio / parea_ratio
            pcts[1], pcts[3] = shrink_by(pcts[1], pcts[3], ratio)
        end
        pcts
    end
    return pcts
end

# this method gets the start/end in percentage of the canvas for this axis direction
function plotly_domain(sp::Subplot)
    figw, figh = sp.plt[:size]
    pcts = bbox_to_pcts(sp.plotarea, figw * px, figh * px)
    pcts = plotly_apply_aspect_ratio(sp, sp.plotarea, pcts)
    x_domain = [pcts[1], pcts[1] + pcts[3]]
    y_domain = [pcts[2], pcts[2] + pcts[4]]
    if hascolorbar(sp)
        subplot_width = pcts[3]
        colorbar_fractional_size = 0.25
        colorbar_width = subplot_width * colorbar_fractional_size
        x_domain[2] = x_domain[2] - colorbar_width
    end
    return x_domain, y_domain
end

function plotly_axis(axis, sp, anchor = nothing, domain = nothing)
    letter = axis[:letter]
    framestyle = sp[:framestyle]
    ax = KW(
        :visible => framestyle !== :none,
        :title => Plots.get_guide(axis),
        :showgrid => axis[:grid],
        :gridcolor =>
            rgba_string(plot_color(axis[:foreground_color_grid], axis[:gridalpha])),
        :gridwidth => axis[:gridlinewidth],
        :zeroline => framestyle === :zerolines,
        :zerolinecolor => rgba_string(axis[:foreground_color_axis]),
        :showline => framestyle in (:box, :axes) && axis[:showaxis],
        :linecolor => rgba_string(plot_color(axis[:foreground_color_axis])),
        :ticks =>
            axis[:tick_direction] === :out ? "outside" :
            axis[:tick_direction] === :in ? "inside" : "",
        :mirror => framestyle === :box,
        :showticklabels => axis[:showaxis],
    )
    anchor === nothing || (ax[:anchor] = anchor)
    domain === nothing || (ax[:domain] = domain)

    ax[:tickangle] = -axis[:rotation]
    ax[:type] = plotly_scale(axis[:scale])
    lims = axis_limits(sp, letter)

    if axis[:ticks] !== :native || axis[:lims] !== :auto
        ax[:range] = map(RecipesPipeline.scale_func(axis[:scale]), lims)
    end

    if !(axis[:ticks] in (nothing, :none, false))
        ax[:titlefont] = plotly_font(guidefont(axis))
        ax[:tickfont] = plotly_font(tickfont(axis))
        ax[:tickcolor] =
            framestyle in (:zerolines, :grid) || !axis[:showaxis] ?
            rgba_string(invisible()) : rgb_string(axis[:foreground_color_axis])
        ax[:linecolor] = rgba_string(axis[:foreground_color_axis])

        # ticks
        if axis[:ticks] !== :native
            ticks = get_ticks(sp, axis)
            ttype = ticksType(ticks)
            if ttype === :ticks
                ax[:tickmode] = "array"
                ax[:tickvals] = ticks
            elseif ttype === :ticks_and_labels
                ax[:tickmode] = "array"
                ax[:tickvals], ax[:ticktext] = ticks
            end
        end
    else
        ax[:showticklabels] = false
        ax[:showgrid] = false
    end

    # flip
    axis[:flip] && (ax[:range] = reverse(ax[:range]))

    return ax
end

function plotly_polaraxis(sp::Subplot, axis::Axis)
    ax = KW(:visible => axis[:showaxis], :showline => axis[:grid])

    if axis[:letter] === :x
        ax[:range] = rad2deg.(axis_limits(sp, :x))
    else
        ax[:range] = axis_limits(sp, :y)
        ax[:orientation] = -90
    end
    return ax
end

"""
    plotly_scene_aspect(sp::Subplot)

`plotly.js` defaults `scene.aspectmode` to `"auto"`, which proportions the 3D box to the
data but falls back to `"cube"` once one axis spans more than four times the two others.
That data dependent switch makes `plotly` the only backend whose 3D box proportions depend
on the data: `GR` (`GR.setwindow3d`) and `PythonPlot` (`set_box_aspect`) always draw a cube
unless told otherwise. Set the mode explicitly so the default no longer varies with the data.

`aspect_ratio` maps onto `"manual"` rather than `"data"`. Despite its documentation,
`plotly` derives `"data"` from the extent of the traces and ignores user `xlims`/`ylims`/
`zlims`, so an explicitly limited subplot would silently get a box that does not match its
own axes.
"""
function plotly_scene_aspect(sp::Subplot)
    manual(x, y, z) =
        KW(:aspectmode => "manual", :aspectratio => KW(:x => x, :y => y, :z => z))

    ar = get_aspect_ratio(sp)
    ar === :equal && (ar = 1)
    return if ar isa AbstractVector && length(ar) == 3
        manual(ar...)  # matches `PythonPlot`'s `set_box_aspect(ratio)`
    elseif ar isa Number && ar == 1
        # equal units on every axis: size the box by the axis spans themselves, measured
        # in the same scale `plotly_axis` reports the range in, so that a `:log10` axis is
        # compared by decades rather than by its raw data span
        spans = map((:x, :y, :z)) do letter
            axis = sp[get_attr_symbol(letter, :axis)]
            scale = RecipesPipeline.scale_func(axis[:scale])
            amin, amax = axis_limits(sp, letter)
            scale(amax) - scale(amin)
        end
        manual((spans ./ maximum(spans))...)
    else
        # `:none` (i.e. the `:auto` default) and numeric ratios, which have no meaning for
        # a 3D box - see JuliaPlots/Plots.jl#4148 for `aspect_ratio` support in 3D
        KW(:aspectmode => "cube")
    end
end

function plotly_layout(plt::Plot)
    plotattributes_out = KW()

    w, h = plt[:size]
    plotattributes_out[:width], plotattributes_out[:height] = w, h
    plotattributes_out[:paper_bgcolor] = rgba_string(plt[:background_color_outside])
    plotattributes_out[:margin] = KW(:l => 0, :b => 20, :r => 0, :t => 20)

    plotattributes_out[:annotations] = KW[]

    multiple_subplots = length(plt.subplots) > 1

    for sp in plt.subplots
        spidx = multiple_subplots ? sp[:subplot_index] : ""
        x_idx, y_idx = multiple_subplots ? plotly_link_indicies(plt, sp) : ("", "")

        # add an annotation for the title
        if sp[:title] != ""
            bb = plotarea(sp)
            tpos = sp[:titlelocation]
            if tpos === :left
                xmm, ymm = left(bb), top(bbox(sp))
                halign, valign = :left, :top
            elseif tpos === :center
                xmm, ymm = 0.5(left(bb) + right(bb)), top(bbox(sp))
                halign, valign = :hcenter, :top
            elseif tpos === :right
                xmm, ymm = right(bb), top(bbox(sp))
                halign, valign = :right, :top
            else
                xmm = left(bb) + tpos[1] * width(bb)
                # inverting to make consistent with GR
                ymm = bottom(bb) - tpos[2] * height(bb)
                halign, valign = sp[:titlefonthalign], sp[:titlefontvalign]
            end
            titlex, titley = xy_mm_to_pcts(xmm, ymm, w * px, h * px)
            title_font = font(titlefont(sp), halign = halign, valign = valign)
            push!(
                plotattributes_out[:annotations],
                plotly_annotation_dict(titlex, titley, text(sp[:title], title_font)),
            )
        end

        plotattributes_out[:plot_bgcolor] = rgba_string(sp[:background_color_inside])

        # set to supported framestyle
        sp[:framestyle] = _plotly_framestyle(sp[:framestyle])

        if ispolar(sp)
            plotattributes_out[Symbol("angularaxis$(spidx)")] =
                plotly_polaraxis(sp, sp[:xaxis])
            plotattributes_out[Symbol("radialaxis$(spidx)")] =
                plotly_polaraxis(sp, sp[:yaxis])
        else
            x_domain, y_domain = plotly_domain(sp)
            if RecipesPipeline.is3d(sp)
                azim = sp[:camera][1] - 90 #convert azimuthal to match GR behaviour
                theta = 90 - sp[:camera][2] #spherical coordinate angle from z axis
                plotattributes_out[Symbol(:scene, spidx)] = KW(
                    :domain => KW(:x => x_domain, :y => y_domain),
                    Symbol("xaxis$(spidx)") => plotly_axis(sp[:xaxis], sp),
                    Symbol("yaxis$(spidx)") => plotly_axis(sp[:yaxis], sp),
                    Symbol("zaxis$(spidx)") => plotly_axis(sp[:zaxis], sp),
                    plotly_scene_aspect(sp)...,

                    #2.6 multiplier set camera eye such that whole plot can be seen
                    :camera => KW(
                        :eye => KW(
                            :x => 2.6cosd(azim) * sind(theta),
                            :y => 2.6sind(azim) * sind(theta),
                            :z => 2.6cosd(theta),
                        ),
                        :projection => (
                            auto = "orthographic",  # we choose to unify backends by using a default "orthographic" proj when `:auto`
                            ortho = "orthographic",
                            orthographic = "orthographic",
                            persp = "perspective",
                            perspective = "perspective",
                        )[sp[:projection_type]],
                    ),
                )
            else
                plotattributes_out[Symbol("xaxis$(x_idx)")] =
                    plotly_axis(sp[:xaxis], sp, string("y", y_idx), x_domain)
                # don't allow yaxis to be reupdated/reanchored in a linked subplot
                if spidx == y_idx
                    plotattributes_out[Symbol("yaxis$(y_idx)")] =
                        plotly_axis(sp[:yaxis], sp, string("x", x_idx), y_domain)
                end
            end
        end

        # legend
        plotly_add_legend!(plotattributes_out, sp)

        # annotations
        for ann in sp[:annotations]
            append!(
                plotattributes_out[:annotations],
                KW[
                    plotly_annotation_dict(
                        locate_annotation(sp, ann...)...;
                        xref = "x$(x_idx)",
                        yref = "y$(y_idx)",
                    ),
                ],
            )
        end
        # series_annotations
        for series in series_list(sp)
            anns = series[:series_annotations]
            for (xi, yi, str, fnt) in EachAnn(anns, series[:x], series[:y])
                push!(
                    plotattributes_out[:annotations],
                    plotly_annotation_dict(
                        xi,
                        yi,
                        PlotText(str, fnt);
                        xref = "x$(x_idx)",
                        yref = "y$(y_idx)",
                    ),
                )
            end
        end

        # # arrows
        # for sargs in seriesargs
        #     a = sargs[:arrow]
        #     if sargs[:seriestype] in (:path, :line) && typeof(a) <: Arrow
        #         add_arrows(sargs[:x], sargs[:y]) do xyprev, xy
        #             push!(plotattributes_out[:annotations], get_annotation_dict_for_arrow(sargs, xyprev, xy, a))
        #         end
        #     end
        # end

        ispolar(sp) && (plotattributes_out[:direction] = "counterclockwise")

        plotattributes_out
    end

    # turn off hover if nothing's using it
    if all(series -> series.plotattributes[:hover] in (false, :none), plt.series_list)
        plotattributes_out[:hovermode] = "none"
    end

    return plotattributes_out =
        recursive_merge(plotattributes_out, plt.attr[:extra_plot_kwargs])
end

function plotly_add_legend!(plotattributes_out::KW, sp::Subplot)
    plotattributes_out[:showlegend] = sp[:legend_position] !== :none
    legend_position = plotly_legend_pos(sp[:legend_position])
    sp[:legend_position] === :none && return
    return plotattributes_out[:legend] = KW(
        :bgcolor => rgba_string(sp[:legend_background_color]),
        :bordercolor => rgba_string(sp[:legend_foreground_color]),
        :borderwidth => 1,
        :traceorder => "normal",
        :xanchor => legend_position.xanchor,
        :yanchor => legend_position.yanchor,
        :font => plotly_font(legendfont(sp)),
        :tracegroupgap => 0,
        :x => legend_position.coords[1],
        :y => legend_position.coords[2],
        :title => KW(
            :text => sp[:legend_title] === nothing ? "" : string(sp[:legend_title]),
            :font => plotly_font(legendtitlefont(sp)),
        ),
    )
end

#! format: off
plotly_legend_position_mapping = let center = 0.5,
    xcenter = 0.55, ycenter = 0.52,
    xleft = 0.07, xright = 1.0,
    ybot = 0.07, ytop = 1.0,
    youtertop = 1.1, youterbot = -0.15,
    xouterright = 1.05, xouterleft = -0.15
    (
        right = (coords = [xright, ycenter], xanchor = "right", yanchor = "middle"),
        left = (coords = [xleft, ycenter], xanchor = "left", yanchor = "middle"),
        top = (coords = [xcenter, ytop], xanchor = "center", yanchor = "top"),
        bottom = (coords = [xcenter, ybot], xanchor = "center", yanchor = "bottom"),
        bottomleft = (coords = [xleft, ybot], xanchor = "left", yanchor = "bottom"),
        bottomright = (coords = [xright, ybot], xanchor = "right", yanchor = "bottom"),
        topright = (coords = [xright, ytop], xanchor = "right", yanchor = "top"),
        topleft = (coords = [xleft, ytop], xanchor = "left", yanchor = "top"),
        outertop = (coords = [center, youtertop], xanchor = "upper", yanchor = "middle"),
        outerbottom = (coords = [center, youterbot], xanchor = "lower", yanchor = "middle"),
        outerleft = (coords = [xouterleft, center], xanchor = "left", yanchor = "top"),
        outerright = (coords = [xouterright, center], xanchor = "right", yanchor = "top"),
        outertopleft = (coords = [xouterleft, ytop], xanchor = "upper", yanchor = "left"),
        outertopright = (
            coords = [xouterright, ytop],
            xanchor = "upper",
            yanchor = "right",
        ),
        outerbottomleft = (
            coords = [xouterleft, ybot],
            xanchor = "lower",
            yanchor = "left",
        ),
        outerbottomright = (
            coords = [xouterright, ybot],
            xanchor = "lower",
            yanchor = "right",
        ),
        default = (coords = [xright, ytop], xanchor = "auto", yanchor = "auto"),
    )
end
#! format: on

plotly_legend_pos(pos::Symbol) =
    get(plotly_legend_position_mapping, pos, plotly_legend_position_mapping.default)

plotly_legend_pos(v::Tuple{S, T}) where {S <: Real, T <: Real} =
    (coords = v, xanchor = "left", yanchor = "top")

plotly_legend_pos(theta::Real) = plotly_legend_pos((theta, :inner))

function plotly_legend_pos(v::Tuple{S, Symbol}) where {S <: Real}
    (s, c) = sincosd(v[1])
    xanchors = ["left", "center", "right"]
    yanchors = ["bottom", "middle", "top"]

    if v[2] === :inner
        rect = 0.07, 0.5, 1.0, 0.07, 0.52, 1.0
        xanchor = xanchors[legend_anchor_index(c)]
        yanchor = yanchors[legend_anchor_index(s)]
    else
        rect = -0.15, 0.5, 1.05, -0.15, 0.52, 1.1
        xanchor = xanchors[4 - legend_anchor_index(c)]
        yanchor = yanchors[4 - legend_anchor_index(s)]
    end
    return (
        coords = legend_pos_from_angle(v[1], rect...),
        xanchor = xanchor,
        yanchor = yanchor,
    )
end

plotly_layout_json(plt::Plot) = JSON.json(plotly_layout(plt), 4)

plotly_colorscale(cg::ColorGradient, α = nothing) =
    map(v -> [v, rgba_string(plot_color(cg.colors[v], α))], cg.values)
plotly_colorscale(c::AbstractVector{<:Colorant}, α = nothing) =
if length(c) == 1
    [[0.0, rgba_string(plot_color(c[1], α))], [1.0, rgba_string(plot_color(c[1], α))]]
else
    vals = range(0.0, stop = 1.0, length = length(c))
    map(i -> [vals[i], rgba_string(plot_color(c[i], α))], eachindex(c))
end

function plotly_colorscale(cg::PlotUtils.CategoricalColorGradient, α = nothing)
    n = length(cg)
    cinds = repeat(1:n, inner = 2)
    vinds = vcat((i:(i + 1) for i in 1:n)...)
    return map(
        i -> [cg.values[vinds[i]], rgba_string(plot_color(color_list(cg)[cinds[i]], α))],
        eachindex(cinds),
    )
end
plotly_colorscale(c, α = nothing) = plotly_colorscale(_as_gradient(c), α)

get_plotly_marker(k, def) = get(
    (
        rect = "square",
        xcross = "x",
        x = "x",
        utriangle = "triangle-up",
        dtriangle = "triangle-down",
        star5 = "star-triangle-up",
        vline = "line-ns",
        hline = "line-ew",
    ),
    k,
    def,
)

# find indicies of axes to which the subplot links to
function plotly_link_indicies(plt::Plot, sp::Subplot)
    if plt[:link] in (:x, :y, :both)
        x_idx = sp[:xaxis].sps[1][:subplot_index]
        y_idx = sp[:yaxis].sps[1][:subplot_index]
    else
        x_idx = y_idx = sp[:subplot_index]
    end
    return x_idx, y_idx
end

# the Shape contructor will automatically close the shape. since we need it closed,
# we split by NaNs and then construct/destruct the shapes to get the closed coords
function plotly_close_shapes(x, y)
    xs, ys = nansplit(x), nansplit(y)
    for i in eachindex(xs)
        shape = Shape(xs[i], ys[i])
        xs[i], ys[i] = coords(shape)
    end
    return nanvcat(xs), nanvcat(ys)
end

function plotly_data(series::Series, letter::Symbol, data)
    axis = series[:subplot][get_attr_symbol(letter, :axis)]

    data = if axis[:ticks] === :native && data !== nothing
        plotly_native_data(axis, data)
    else
        data
    end

    return if series[:seriestype] in (:heatmap, :contour, :surface, :wireframe, :mesh3d)
        handle_surface(data)
    else
        plotly_data(data)
    end
end
plotly_data(v) = v !== nothing ? collect(v) : v
plotly_data(v::AbstractArray) = v
plotly_data(surf::Surface) = surf.surf
plotly_data(v::AbstractArray{R}) where {R <: Rational} = float(v)

plotly_native_data(axis::Axis, a::Surface) = Surface(plotly_native_data(axis, a.surf))
plotly_native_data(axis::Axis, data::AbstractArray) =
if !isempty(axis[:discrete_values])
    map(
        xi -> axis[:discrete_values][searchsortedfirst(axis[:continuous_values], xi)],
        data,
    )
elseif axis[:formatter] in (datetimeformatter, dateformatter, timeformatter)
    plotly_convert_to_datetime(data, axis[:formatter])
else
    data
end

plotly_convert_to_datetime(x::AbstractArray, formatter::Function) =
if formatter == datetimeformatter
    map(xi -> isfinite(xi) ? replace(formatter(xi), "T" => " ") : missing, x)
elseif formatter == dateformatter
    map(xi -> isfinite(xi) ? replace(formatter(xi), "T" => " ") : missing, x)
elseif formatter == timeformatter
    map(xi -> isfinite(xi) ? string(Dates.today(), " ", formatter(xi)) : missing, x)
else
    error(
        "Invalid DateTime formatter. Expected Plots.datetime/date/time formatter but got $formatter",
    )
end

#ensures that a gradient is called if a single color is supplied where a gradient is needed (e.g. if a series recipe defines marker_z)
as_gradient(grad::ColorGradient, α) = grad
as_gradient(grad, α) = cgrad(alpha = α)

# get a dictionary representing the series params (plotattributes is the Plots-dict, plotattributes_out is the Plotly-dict)
function plotly_series(plt::Plot, series::Series)
    sp = series[:subplot]
    clims = get_clims(sp, series)

    (st = series[:seriestype]) === :shape && return plotly_series_shapes(plt, series, clims)

    plotattributes_out = KW()

    # these are the axes that the series should be mapped to
    if RecipesPipeline.is3d(sp)
        spidx = length(plt.subplots) > 1 ? sp[:subplot_index] : ""
        plotattributes_out[:xaxis] = "x$spidx"
        plotattributes_out[:yaxis] = "y$spidx"
        plotattributes_out[:zaxis] = "z$spidx"
        plotattributes_out[:scene] = "scene$spidx"
    else
        x_idx, y_idx = length(plt.subplots) > 1 ? plotly_link_indicies(plt, sp) : ("", "")
        plotattributes_out[:xaxis] = "x$(x_idx)"
        plotattributes_out[:yaxis] = "y$(y_idx)"
    end
    plotattributes_out[:showlegend] = should_add_to_legend(series)

    if st === :straightline
        x, y = straightline_data(series, 100)
        z = series[:z]
    else
        x, y, z = series[:x], series[:y], series[:z]
    end

    x, y, z = (
        plotly_data(series, letter, data) for
            (letter, data) in zip((:x, :y, :z), (x, y, z))
    )

    plotattributes_out[:name] = series[:label]

    isscatter = st in (:scatter, :scatter3d, :scattergl)
    hasmarker = isscatter || series[:markershape] !== :none
    hasline = st in (:path, :path3d, :straightline)
    hasfillrange =
        st in (:path, :scatter, :scattergl, :straightline) &&
        (isa(series[:fillrange], AbstractVector) || isa(series[:fillrange], Tuple))

    plotattributes_out[:colorbar] = plotly_colorbar(sp)

    if is_2tuple(clims) && all(!isnan, clims)
        plotattributes_out[:zmin], plotattributes_out[:zmax] = clims
    end

    # set the "type"
    if st in (:path, :scatter, :scattergl, :straightline, :path3d, :scatter3d)
        return plotly_series_segments(series, plotattributes_out, x, y, z, clims)

    elseif st === :heatmap
        x = heatmap_edges(x, sp[:xaxis][:scale])
        y = heatmap_edges(y, sp[:yaxis][:scale])
        plotattributes_out[:type] = "heatmap"
        plotattributes_out[:x], plotattributes_out[:y], plotattributes_out[:z] = x, y, z
        plotattributes_out[:colorscale] =
            plotly_colorscale(series[:fillcolor], series[:fillalpha])
        plotattributes_out[:showscale] = hascolorbar(sp)

    elseif st === :contour
        filled = isfilledcontour(series)
        plotattributes_out[:type] = "contour"
        plotattributes_out[:x], plotattributes_out[:y], plotattributes_out[:z] = x, y, z
        plotattributes_out[:contours] = KW(
            :coloring => filled ? "fill" : "lines",
            :showlabels => series[:contour_labels] == true,
        )
        # Plotly does not support arbitrary sets of contours
        # (https://github.com/plotly/plotly.js/issues/4503)
        # so we distinguish AbstractRanges and AbstractVectors
        let levels = series[:levels]
            if levels isa AbstractRange
                plotattributes_out[:contours][:start] = first(levels)
                plotattributes_out[:contours][:end] = last(levels)
                plotattributes_out[:contours][:size] = step(levels)
            elseif levels isa AVec
                levels_range =
                    range(first(levels), stop = last(levels), length = length(levels))
                plotattributes_out[:contours][:start] = first(levels_range)
                plotattributes_out[:contours][:end] = last(levels_range)
                plotattributes_out[:contours][:size] = step(levels_range)
                @warn """
                setting arbitrary contour levels with Plotly backend is not supported;
                use a range to set equally-spaced contours or an integer to set the
                approximate number of contours with the keyword `levels`.
                Setting levels to $(levels_range)
                """
            elseif levels isa Integer
                plotattributes_out[:ncontours] = levels + 2
            end
        end
        plotattributes_out[:colorscale] =
            plotly_colorscale(series[:linecolor], series[:linealpha])
        plotattributes_out[:showscale] = hascolorbar(sp) && hascolorbar(series)

    elseif st in (:surface, :wireframe)
        plotattributes_out[:type] = "surface"
        plotattributes_out[:x], plotattributes_out[:y], plotattributes_out[:z] = x, y, z
        if st === :wireframe
            plotattributes_out[:hidesurface] = true
            wirelines = KW(
                :show => true,
                :color =>
                    rgba_string(plot_color(series[:linecolor], series[:linealpha])),
                :highlightwidth => series[:linewidth],
            )
            plotattributes_out[:contours] =
                KW(:x => wirelines, :y => wirelines, :z => wirelines)
            plotattributes_out[:showscale] = false
        else
            plotattributes_out[:colorscale] =
                plotly_colorscale(series[:fillcolor], series[:fillalpha])
            plotattributes_out[:opacity] = series[:fillalpha]
            if series[:fill_z] !== nothing
                plotattributes_out[:surfacecolor] = handle_surface(series[:fill_z])
            end
            plotattributes_out[:showscale] = hascolorbar(sp)
        end
    elseif st === :mesh3d
        plotattributes_out[:type] = "mesh3d"
        plotattributes_out[:x], plotattributes_out[:y], plotattributes_out[:z] = x, y, z

        if series[:connections] !== nothing
            if typeof(series[:connections]) <: Tuple{Array, Array, Array}
                # 0-based indexing
                i, j, k = series[:connections]
                if !(length(i) == length(j) == length(k))
                    throw(
                        ArgumentError(
                            "Argument connections must consist of equally sized arrays.",
                        ),
                    )
                end
                plotattributes_out[:i] = i
                plotattributes_out[:j] = j
                plotattributes_out[:k] = k
            elseif typeof(series[:connections]) <: AbstractVector{NTuple{3, Int}}
                # 1-based indexing
                i, j, k = broadcast(
                    i -> [inds[i] - 1 for inds in series[:connections]],
                    (1, 2, 3),
                )
                plotattributes_out[:i] = i
                plotattributes_out[:j] = j
                plotattributes_out[:k] = k
            else
                throw(
                    ArgumentError(
                        "Argument connections has to be either a tuple of three arrays (0-based indexing)
                         or an AbstractVector{NTuple{3,Int}} (1-based indexing).",
                    ),
                )
            end
        end
        plotattributes_out[:colorscale] =
            plotly_colorscale(series[:fillcolor], series[:fillalpha])
        plotattributes_out[:color] =
            rgba_string(plot_color(series[:fillcolor], series[:fillalpha]))
        plotattributes_out[:opacity] = series[:fillalpha]
        if series[:fill_z] !== nothing
            plotattributes_out[:surfacecolor] = handle_surface(series[:fill_z])
        end
        plotattributes_out[:showscale] = hascolorbar(sp)
    else
        @warn "Plotly: seriestype $st isn't supported."
        return KW()
    end

    # add "marker"
    if hasmarker
        inds = eachindex(x)
        plotattributes_out[:marker] = KW(
            :symbol =>
                get_plotly_marker(series[:markershape], string(series[:markershape])),
            # :opacity => series[:markeralpha],
            :size => 2_cycle(series[:markersize], inds),
            :color =>
                rgba_string.(
                plot_color.(
                    get_markercolor.(series, inds),
                    get_markeralpha.(series, inds),
                ),
            ),
            :line => KW(
                :color =>
                    rgba_string.(
                    plot_color.(
                        get_markerstrokecolor.(series, inds),
                        get_markerstrokealpha.(series, inds),
                    ),
                ),
                :width => _cycle(series[:markerstrokewidth], inds),
            ),
        )
    end

    plotly_polar!(plotattributes_out, series)
    plotly_adjust_hover_label!(plotattributes_out, series[:hover])

    return [merge(plotattributes_out, series[:extra_kwargs])]
end

function plotly_colorbar(sp::Subplot)
    x_domain, y_domain = plotly_domain(sp)
    plot_attribute = KW(
        :title => sp[:colorbar_title],
        :y => mean(y_domain),
        :len => diff(y_domain)[1],
        :x => x_domain[2],
    )
    return plot_attribute
end

function plotly_series_shapes(plt::Plot, series::Series, clims)
    plotattributes_outs = KW[]
    i = 1
    # these are the axes that the series should be mapped to
    x_idx, y_idx = plotly_link_indicies(plt, series[:subplot])
    plotattributes_base = KW(
        :xaxis => "x$(x_idx)",
        :yaxis => "y$(y_idx)",
        :name => series[:label],
        :legendgroup => series[:label],
    )

    for (xs, ys) in zip(nansplit(series[:x]), nansplit(series[:y]))

        # to draw polygons, we actually draw lines with fill
        plotattributes_out = merge(
            plotattributes_base,
            KW(
                :type => "scatter",
                :mode => "lines",
                :x => xs,
                :y => ys,
                :fill => "tozeroy",
                :fillcolor => rgba_string(
                    plot_color(get_fillcolor(series, clims, i), get_fillalpha(series, i)),
                ),
            ),
        )
        if series[:markerstrokewidth] > 0
            plotattributes_out[:line] = KW(
                :color => rgba_string(
                    plot_color(get_linecolor(series, clims, i), get_linealpha(series, i)),
                ),
                :width => get_linewidth(series, i),
                :dash => string(get_linestyle(series, i)),
            )
        end
        plotattributes_out[:showlegend] = i == 1 ? should_add_to_legend(series) : false
        plotly_polar!(plotattributes_out, series)
        plotly_adjust_hover_label!(plotattributes_out, _cycle(series[:hover], i))
        push!(plotattributes_outs, merge(plotattributes_out, series[:extra_kwargs]))
        i += 1
    end
    if series[:fill_z] !== nothing
        push!(plotattributes_outs, plotly_colorbar_hack(series, plotattributes_base, :fill))
    elseif series[:line_z] !== nothing
        push!(plotattributes_outs, plotly_colorbar_hack(series, plotattributes_base, :line))
    elseif series[:marker_z] !== nothing
        push!(
            plotattributes_outs,
            plotly_colorbar_hack(series, plotattributes_base, :marker),
        )
    end
    return plotattributes_outs
end

function plotly_series_segments(series::Series, plotattributes_base::KW, x, y, z, clims)
    st = series[:seriestype]
    sp = series[:subplot]
    isscatter = st in (:scatter, :scatter3d, :scattergl)
    hasmarker = isscatter || series[:markershape] !== :none
    hasline = st in (:path, :path3d, :straightline)
    hasfillrange =
        st in (:path, :scatter, :scattergl, :straightline) &&
        (isa(series[:fillrange], AbstractVector) || isa(series[:fillrange], Tuple))

    segments = collect(series_segments(series, st))
    plotattributes_outs = fill(KW(), (hasfillrange ? 2 : 1) * length(segments))

    needs_scatter_fix = !isscatter && hasmarker && !any(isnan, y) && length(segments) > 1

    for (k, segment) in enumerate(segments)
        i, rng = segment.attr_index, segment.range

        plotattributes_out = deepcopy(plotattributes_base)
        plotattributes_out[:showlegend] = k == 1 ? should_add_to_legend(series) : false
        plotattributes_out[:legendgroup] = series[:label]

        # set the type
        if st in (:path, :scatter, :scattergl, :straightline)
            plotattributes_out[:type] = st === :scattergl ? "scattergl" : "scatter"
            plotattributes_out[:mode] = if hasmarker
                hasline ? "lines+markers" : "markers"
            else
                hasline ? "lines" : "none"
            end
            if series[:fillrange] == true ||
                    series[:fillrange] == 0 ||
                    isa(series[:fillrange], Tuple)
                plotattributes_out[:fill] = "tozeroy"
                plotattributes_out[:fillcolor] = rgba_string(
                    plot_color(get_fillcolor(series, clims, i), get_fillalpha(series, i)),
                )
            elseif typeof(series[:fillrange]) <: Union{AbstractVector{<:Real}, Real}
                plotattributes_out[:fill] = "tonexty"
                plotattributes_out[:fillcolor] = rgba_string(
                    plot_color(get_fillcolor(series, clims, i), get_fillalpha(series, i)),
                )
            elseif !(series[:fillrange] in (false, nothing))
                @warn "fillrange ignored... plotly only supports filling to zero and to a vector of values. fillrange: $(series[:fillrange])"
            end
            plotattributes_out[:x], plotattributes_out[:y] = x[rng], y[rng]

        elseif st in (:path3d, :scatter3d)
            plotattributes_out[:type] = "scatter3d"
            plotattributes_out[:mode] = if hasmarker
                hasline ? "lines+markers" : "markers"
            else
                hasline ? "lines" : "none"
            end
            plotattributes_out[:x], plotattributes_out[:y], plotattributes_out[:z] =
                x[rng], y[rng], z[rng]
        end

        # add "marker"
        if hasmarker
            mcolor = rgba_string(
                plot_color(get_markercolor(series, clims, i), get_markeralpha(series, i)),
            )
            mcolor_next = if (mz = series[:marker_z]) !== nothing && i < length(mz)
                plot_color(
                    get_markercolor(series, clims, i + 1),
                    get_markeralpha(series, i + 1),
                ) |> rgba_string
            else
                mcolor
            end
            lcolor = rgba_string(
                plot_color(
                    get_markerstrokecolor(series, i),
                    get_markerstrokealpha(series, i),
                ),
            )
            lcolor_next =
                plot_color(
                get_markerstrokecolor(series, i + 1),
                get_markerstrokealpha(series, i + 1),
            ) |> rgba_string

            plotattributes_out[:marker] = KW(
                :symbol => get_plotly_marker(
                    _cycle(series[:markershape], i),
                    string(_cycle(series[:markershape], i)),
                ),
                # :opacity => needs_scatter_fix ? [1, 0] : 1,
                :size => 2_cycle(series[:markersize], i),
                :color => needs_scatter_fix ? [mcolor, mcolor_next] : mcolor,
                :line => KW(
                    :color => needs_scatter_fix ? [lcolor, lcolor_next] : lcolor,
                    :width => _cycle(series[:markerstrokewidth], i),
                ),
            )
        end

        # add "line"
        if hasline
            plotattributes_out[:line] = KW(
                :color => rgba_string(
                    plot_color(get_linecolor(series, clims, i), get_linealpha(series, i)),
                ),
                :width => get_linewidth(series, i),
                :shape => if st === :steppre
                    "vh"
                elseif st === :stepmid
                    "hvh"
                elseif st === :steppost
                    "hv"
                else
                    "linear"
                end,
                :dash => string(get_linestyle(series, i)),
            )
        end

        plotly_polar!(plotattributes_out, series)
        plotly_adjust_hover_label!(plotattributes_out, _cycle(series[:hover], rng))

        if hasfillrange
            # if hasfillrange is true, return two dictionaries (one for original
            # series, one for series being filled to) instead of one
            plotattributes_out_fillrange = deepcopy(plotattributes_out)
            plotattributes_out_fillrange[:showlegend] = false
            # if fillrange is provided as real or tuple of real, expand to array
            if typeof(series[:fillrange]) <: Real
                plotattributes_out[:fillrange] = fill(series[:fillrange], length(rng))
            elseif typeof(series[:fillrange]) <: Tuple
                f1 =
                    (fr1 = series[:fillrange][1]) |> typeof <: Real ?
                    fill(fr1, length(rng)) : fr1[rng]
                f2 =
                    (fr2 = series[:fillrange][2]) |> typeof <: Real ?
                    fill(fr2, length(rng)) : fr2[rng]
                plotattributes_out[:fillrange] = (f1, f2)
            end
            if isa(series[:fillrange], AbstractVector)
                plotattributes_out_fillrange[:y] = series[:fillrange][rng]
                delete!(plotattributes_out_fillrange, :fill)
                delete!(plotattributes_out_fillrange, :fillcolor)
            else
                # if fillrange is a tuple with upper and lower limit, plotattributes_out_fillrange
                # is the series that will do the filling
                plotattributes_out_fillrange[:x], plotattributes_out_fillrange[:y] =
                    concatenate_fillrange(x[rng], series[:fillrange])
                plotattributes_out_fillrange[:line][:width] = 0
                delete!(plotattributes_out, :fill)
                delete!(plotattributes_out, :fillcolor)
            end

            plotattributes_outs[(2k - 1):(2k)] =
                [plotattributes_out_fillrange, plotattributes_out]
        else
            plotattributes_outs[k] = plotattributes_out
        end
        plotattributes_outs[k] = merge(plotattributes_outs[k], series[:extra_kwargs])
    end

    if series[:line_z] !== nothing
        push!(plotattributes_outs, plotly_colorbar_hack(series, plotattributes_base, :line))
    elseif series[:fill_z] !== nothing
        push!(plotattributes_outs, plotly_colorbar_hack(series, plotattributes_base, :fill))
    elseif series[:marker_z] !== nothing
        push!(
            plotattributes_outs,
            plotly_colorbar_hack(series, plotattributes_base, :marker),
        )
    end

    return plotattributes_outs
end

function plotly_colorbar_hack(series::Series, plotattributes_base::KW, sym::Symbol)
    plotattributes_out = deepcopy(plotattributes_base)
    cmin, cmax = get_clims(series[:subplot])
    plotattributes_out[:showlegend] = false
    plotattributes_out[:type] = RecipesPipeline.is3d(series) ? :scatter3d : :scatter
    plotattributes_out[:hoverinfo] = :none
    plotattributes_out[:mode] = :markers
    plotattributes_out[:x], plotattributes_out[:y] = [series[:x][1]], [series[:y][1]]
    if RecipesPipeline.is3d(series)
        plotattributes_out[:z] = [series[:z][1]]
    end
    # zrange = zmax == zmin ? 1 : zmax - zmin # if all marker_z values are the same, plot all markers same color (avoids division by zero in next line)
    plotattributes_out[:marker] = KW(
        :size => 1.0e-10,
        :opacity => 1.0e-10,
        :color => [0.5],
        :cmin => cmin,
        :cmax => cmax,
        :colorscale => plotly_colorscale(series[Symbol("$(sym)color")], 1),
        :showscale => hascolorbar(series[:subplot]),
    )
    return plotattributes_out
end

plotly_polar!(plotattributes_out::KW, series::Series) =
if ispolar(series[:subplot])  # convert polar plots x/y to theta/radius
    theta, r = pop!(plotattributes_out, :x), pop!(plotattributes_out, :y)
    plotattributes_out[:theta] = rad2deg.(theta)
    plotattributes_out[:r] = r
    plotattributes_out[:type] = :scatterpolar
end

function plotly_adjust_hover_label!(plotattributes_out::KW, hover)
    if hover === nothing
        return
    elseif all(in([:none, false]), hover)
        plotattributes_out[:hoverinfo] = "none"
    elseif any(!isnothing, hover)
        plotattributes_out[:hoverinfo] = "text"
        plotattributes_out[:text] = hover
    end
    return nothing
end

# get a list of dictionaries, each representing the series params
function plotly_series(plt::Plot)
    isempty(plt.series_list) && return KW[]
    return reduce(vcat, plotly_series(plt, series) for series in plt.series_list)
end

# get json string for a list of dictionaries, each representing the series params
plotly_series_json(plt::Plot) = JSON.json(plotly_series(plt), 4)

# ----------------------------------------------------------------

html_head(plt::Plot{PlotlyBackend}) = plotly_html_head(plt)
html_body(plt::Plot{PlotlyBackend}) = plotly_html_body(plt)

plotly_url() =
if _use_local_dependencies[]
    _plotly_data_url()
else
    "https://cdn.plot.ly/$_plotly_min_js_filename"
end

function plotly_html_head(plt::Plot)
    plotly = plotly_url()

    include_mathjax = get(plt[:extra_plot_kwargs], :include_mathjax, "")

    mathjax_file = if include_mathjax != "cdn"
        "file://" * include_mathjax
    else
        "https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/MathJax.js?config=TeX-MML-AM_CHTML"
    end

    mathjax_head = if isempty(include_mathjax)
        ""
    else
        "<script src=\"$mathjax_file\"></script>\n\t\t"
    end

    return if isijulia()
        mathjax_head
    else
        "$mathjax_head<script src=$(repr(plotly))></script>"
    end
end

function plotly_html_body(plt, style = nothing)
    if style === nothing
        w, h = plt[:size]
        style = "width:$(w)px;height:$(h)px;"
    end

    requirejs_prefix = requirejs_suffix = ""
    if isijulia()
        # require.js adds .js automatically
        plotly_no_ext = plotly_url() |> splitext |> first

        requirejs_prefix = """
            requirejs.config({
                paths: {
                    plotly: '$(plotly_no_ext)'
                }
            });
            require(['plotly'], function (Plotly) {
        """
        requirejs_suffix = "});"
    end

    unique_tag = "id_$(replace(string(UUIDs.uuid4()), '-' => '_'))"

    html = """
        <div id=\"$unique_tag\" style=\"$style\"></div>
        <script>
        ;(()=> {
        function plots_jl_plotly_$unique_tag() {
            $(requirejs_prefix)
            $(js_body(plt, unique_tag))
            $(requirejs_suffix)
        }
        let plotlyloader = window.document.createElement("script")
        let src="https://requirejs.org/docs/release/$(Plots._requirejs_version)/minified/require.js"
        plotlyloader.addEventListener("load", plots_jl_plotly_$unique_tag);
        plotlyloader.src = src
        document.querySelector("#$unique_tag").appendChild(plotlyloader)
        })()
        </script>
    """
    return html
end

js_body(plt::Plot, unique_tag) =
    "Plotly.newPlot('$unique_tag', $(plotly_series_json(plt)), $(plotly_layout_json(plt)));"

plotly_show_js(io::IO, plot::Plot) =
    JSON.print(io, Dict(:data => plotly_series(plot), :layout => plotly_layout(plot)))

# ----------------------------------------------------------------

Base.showable(::MIME"application/prs.juno.plotpane+html", plt::Plot{PlotlyBackend}) = true

_show(io::IO, ::MIME"application/vnd.plotly.v1+json", plot::Plot{PlotlyBackend}) =
    plotly_show_js(io, plot)

_show(io::IO, ::MIME"text/html", plt::Plot{PlotlyBackend}) = write(io, embeddable_html(plt))

_display(plt::Plot{PlotlyBackend}) = standalone_html_window(plt)

"""
```julia
legend_pos_from_angle(theta, xmin, xcenter, xmax, ymin, ycenter, ymax)
```

Return `(x,y)` at an angle `theta` degrees from
`(xcenter,ycenter)` on a rectangle defined by (`xmin`, `xmax`, `ymin`, `ymax`).
"""
function legend_pos_from_angle(theta, xmin, xcenter, xmax, ymin, ycenter, ymax)
    (s, c) = sincosd(theta)
    x = c < 0 ? (xmin - xcenter) / c : (xmax - xcenter) / c
    y = s < 0 ? (ymin - ycenter) / s : (ymax - ycenter) / s
    A = min(x, y)
    return (xcenter + A * c, ycenter + A * s)
end

"""
Split continuous range `[-1,1]` evenly into an integer `[1,2,3]`
"""
function legend_anchor_index(x)
    x < -1 // 3 && return 1
    x < 1 // 3 && return 2
    return 3
end

"""
Turn legend argument into a (theta, :inner) or (theta, :outer) tuple.
For backends where legend position is given in normal coordinates (0,0) -- (1,1),
so :topleft exactly corresponds to (45, :inner) etc.

If `leg` is a (::Real,::Real) tuple, keep it as is.
"""
legend_angle(leg::Real) = (leg, :inner)
legend_angle(leg::Tuple{S, T}) where {S <: Real, T <: Real} = leg
legend_angle(leg::Tuple{S, Symbol}) where {S <: Real} = leg
legend_angle(leg::Symbol) = get(
    (
        topleft = (135, :inner),
        top = (90, :inner),
        topright = (45, :inner),
        left = (180, :inner),
        right = (0, :inner),
        bottomleft = (225, :inner),
        bottom = (270, :inner),
        bottomright = (315, :inner),
        outertopleft = (135, :outer),
        outertop = (90, :outer),
        outertopright = (45, :outer),
        outerleft = (180, :outer),
        outerright = (0, :outer),
        outerbottomleft = (225, :outer),
        outerbottom = (270, :outer),
        outerbottomright = (315, :outer),
    ),
    leg,
    (45, :inner),
)

function plotly_traces(plt::Plot)
    traces = PlotlyBase.GenericTrace[]
    for series_dict in plotly_series(plt)
        plotly_type = pop!(series_dict, :type)
        push!(traces, PlotlyBase.GenericTrace(plotly_type; series_dict...))
    end
    return traces
end

function plotlybase_syncplot(plt::Plot)
    plt.o = PlotlyBase.Plot()
    PlotlyBase.addtraces!(plt.o, plotly_traces(plt)...)
    layout = plotly_layout(plt)
    w, h = plt[:size]
    PlotlyBase.relayout!(plt.o, layout, width = w, height = h)
    return plt.o
end

for (mime, fmt) in (
        "application/pdf" => "pdf",
        "image/png" => "png",
        "image/svg+xml" => "svg",
        "image/eps" => "eps",
    )
    @eval function _show(io::IO, ::MIME{Symbol($mime)}, plt::Plot{PlotlyBackend})
        if !PlotlyKaleido.is_running()
            PlotlyKaleido.restart()
        end
        return PlotlyKaleido.savefig(io, plotlybase_syncplot(plt), format = $fmt)
    end
end

module PlotMeasures

import ..Measures
import ..Measures:
    Length, AbsoluteLength, Measure, BoundingBox, mm, cm, inch, pt, width, height, w, h

const BBox = Measures.Absolute2DBox
export BBox, BoundingBox, mm, cm, inch, px, pct, pt, w, h

# allow pixels and percentages
const px = AbsoluteLength(0.254)
const pct = Length{:pct, Float64}(1.0)

Base.convert(::Type{<:Measure}, x::Float64) = x * pct

Base.:*(m1::AbsoluteLength, m2::Length{:pct}) = AbsoluteLength(m1.value * m2.value)
Base.:*(m1::Length{:pct}, m2::AbsoluteLength) = AbsoluteLength(m2.value * m1.value)
Base.:/(m1::AbsoluteLength, m2::Length{:pct}) = AbsoluteLength(m1.value / m2.value)
Base.:/(m1::Length{:pct}, m2::AbsoluteLength) = AbsoluteLength(m2.value / m1.value)

end

const _deprecated_attributes = Dict{Symbol, Symbol}(:orientation => :permute)
const _all_defaults = KW[_series_defaults, _plot_defaults, _subplot_defaults]

const _initial_defaults = deepcopy(_all_defaults)
const _initial_axis_defaults = deepcopy(_axis_defaults)

# add defaults for the letter versions
const _axis_defaults_byletter = KW()

reset_axis_defaults_byletter!() =
    for letter in (:x, :y, :z)
    _axis_defaults_byletter[letter] = KW()
    for (k, v) in _axis_defaults
        _axis_defaults_byletter[letter][k] = v
    end
end
reset_axis_defaults_byletter!()

# to be able to reset font sizes to initial values
const _initial_plt_fontsizes =
    Dict(:plot_titlefontsize => _plot_defaults[:plot_titlefontsize])

const _initial_sp_fontsizes = Dict(
    :titlefontsize => _subplot_defaults[:titlefontsize],
    :legend_font_pointsize => _subplot_defaults[:legend_font_pointsize],
    :legend_title_font_pointsize => _subplot_defaults[:legend_title_font_pointsize],
    :annotationfontsize => _subplot_defaults[:annotationfontsize],
    :colorbar_tickfontsize => _subplot_defaults[:colorbar_tickfontsize],
    :colorbar_titlefontsize => _subplot_defaults[:colorbar_titlefontsize],
)

const _initial_ax_fontsizes = Dict(
    :tickfontsize => _axis_defaults[:tickfontsize],
    :guidefontsize => _axis_defaults[:guidefontsize],
)

const _initial_fontsizes =
    merge(_initial_plt_fontsizes, _initial_sp_fontsizes, _initial_ax_fontsizes)

const _internal_args = [
    :plot_object,
    :series_plotindex,
    :series_index,
    :markershape_to_add,
    :letter,
    :idxfilter,
]

const _axis_args = Set(keys(_axis_defaults))
const _series_args = Set(keys(_series_defaults))
const _subplot_args = Set(keys(_subplot_defaults))
const _plot_args = Set(keys(_plot_defaults))

const _magic_axis_args = [:axis, :tickfont, :guidefont, :grid, :minorgrid]
const _magic_subplot_args =
    [:title_font, :legend_font, :legend_title_font, :plot_title_font, :colorbar_titlefont]
const _magic_series_args = [:line, :marker, :fill]
const _all_magic_args =
    Set(union(_magic_axis_args, _magic_series_args, _magic_subplot_args))

const _all_axis_args = union(_axis_args, _magic_axis_args)
const _lettered_all_axis_args =
    Set([Symbol(letter, kw) for letter in (:x, :y, :z) for kw in _all_axis_args])
const _all_subplot_args = union(_subplot_args, _magic_subplot_args)
const _all_series_args = union(_series_args, _magic_series_args)
const _all_plot_args = _plot_args

const _all_args =
    union(_lettered_all_axis_args, _all_subplot_args, _all_series_args, _all_plot_args)

# add all pluralized forms to the _keyAliases dict
for arg in _all_args
    add_aliases(arg, makeplural(arg))
end

# fill symbol cache
for letter in (:x, :y, :z)
    _attrsymbolcache[letter] = Dict{Symbol, Symbol}()
    for k in _axis_args
        # populate attribute cache
        lk = Symbol(letter, k)
        _attrsymbolcache[letter][k] = lk
        # allow the underscore version too: xguide or x_guide
        add_aliases(lk, Symbol(letter, "_", k))
    end
    for k in (_magic_axis_args..., :(_discrete_indices))
        _attrsymbolcache[letter][k] = Symbol(letter, k)
    end
end

# add all non_underscored forms to the _keyAliases
add_non_underscore_aliases!(_keyAliases)

_generate_doclist(attributes) =
    replace(join(sort(collect(attributes)), "\n- "), "_" => "\\_")

@nospecialize

"""
    scatter(x,y)
    scatter!(x,y)

Make a scatter plot of `y` vs `x`.

# Keyword arguments
- $(_document_argument(:markersize))
- $(_document_argument(:markercolor))
- $(_document_argument(:markershape))
- $(_document_argument(:markeralpha))

# Examples
```julia-repl
julia> scatter([1,2,3],[4,5,6],markersize=[3,4,5],markercolor=[:red,:green,:blue])
julia> scatter([(1,4),(2,5),(3,6)])
```
"""
@shorthands scatter

"""
    bar(x,y)
    bar!(x,y)

Make a bar plot of `y` vs `x`.

# Keyword arguments
- $(_document_argument(:bar_position))
- $(_document_argument(:bar_width))
- $(_document_argument(:bar_edges))
- $(_document_argument(:fillrange))
- $(_document_argument(:permute))

# Examples
```julia-repl
julia> bar([1,2,3],[4,5,6],fillcolor=[:red,:green,:blue],fillalpha=[0.2,0.4,0.6])
julia> bar([(1,4),(2,5),(3,6)])
```
"""
@shorthands bar

@shorthands barh

"""
    histogram(x)
    histogram!(x)

Plot a histogram.

# Arguments
- `x`: AbstractVector of values to be binned
- $(_document_argument(:bins))
- `weights`: Vector of weights for the values in `x`, for weighted bin counts
- $(_document_argument(:normalize))
- $(_document_argument(:bar_position))
- $(_document_argument(:bar_width))
- $(_document_argument(:bar_edges))
- $(_document_argument(:permute))

# Example
```julia-repl
julia> histogram([1,2,1,1,4,3,8],bins=0:8)
julia> histogram([1,2,1,1,4,3,8],bins=0:8,weights=weights([4,7,3,9,12,2,6]))
```
"""
@shorthands histogram

"""
    barhist(x)
    barhist!(x)

Make a histogram bar plot. See `histogram`.
"""
@shorthands barhist

"""
    stephist(x)
    stephist!(x)

Make a histogram step plot (bin counts are represented using horizontal lines
instead of bars). See `histogram`.
"""
@shorthands stephist

"""
    scatterhist(x)
    scatterhist!(x)

Make a histogram scatter plot (bin counts are represented using points
instead of bars). See `histogram`.
"""
@shorthands scatterhist

"""
    histogram2d(x,y)
    histogram2d!(x,y)

Plot a two-dimensional histogram.

# Arguments
- `bins`: Number of bins (if an `Integer`) or bin edges (if an `AbtractVector`)
- `weights`: Vector of weights for the values in `x`. Each entry of x contributes
             its weight to the height of its bin.

# Example
```julia-repl
julia> histogram2d(randn(10_000),randn(10_000))
```
"""
@shorthands histogram2d

"""
    density(x)
    density!(x)

Make a line plot of a kernel density estimate of x. The smoothness of the density plot is defined from `bandwidth` (real positive number).

# Arguments
- `x`: AbstractVector of samples for probability density estimation

# Keyword arguments
- `trim`::Bool: enables cutting off the distribution tails.
- `bandwidth`::Number: a low bandwidth induces under-smoothing, whilst a high bandwidth induces over-smoothing.

# Examples
```julia-repl
julia> density(randn(100), bandwidth = -0.01, trim = false)
output : ERROR: Bandwidth must be positive

julia> density(randn(100), bandwidth = 0.1, trim = false)  # a curve with extremity and under-smoothing
julia> density(randn(100), bandwidth = 10, trim = true)  # a curve without extremity and over-smoothing
```

# Example
```julia-repl
julia> using StatsPlots
julia> density(randn(100_000))
```
"""
@shorthands density

"""
    heatmap(x,y,z)
    heatmap!(x,y,z)

Plot a heatmap of the rectangular array `z`.

# Keyword arguments
- $(_document_argument(:aspect_ratio))

# Example
```julia-repl
julia> heatmap(randn(10,10))
```
"""
@shorthands heatmap
@shorthands plots_heatmap

"""
    hexbin(x,y)
    hexbin!(x,y)

Make a hexagonal binning plot (a histogram of the observations `(x[i],y[i])`
with hexagonal bins).

# Example
```julia-repl
julia> hexbin(randn(10_000), randn(10_000))
```
"""
@shorthands hexbin

"""
    sticks(x,y)
    sticks!(x,y)

Draw a stick plot of `y` vs `x`.

# Arguments
- $(_document_argument(:fillrange))
- $(_document_argument(:markershape))

# Example
```julia-repl
julia> sticks(1:10)
```
"""
@shorthands sticks

"""
    hline(y)
    hline!(y)

Draw horizontal lines at positions specified by the values in
the AbstractVector `y`.

# Example
```julia-repl
julia> hline([-1,0,2])
```
"""
@shorthands hline

"""
    vline(x)
    vline!(x)

Draw vertical lines at positions specified by the values in
the AbstractVector `x`.

# Example
```julia-repl
julia> vline([-1,0,2])
```
"""
@shorthands vline

"""
    hspan(y)

Draw a rectangle between the horizontal line at position `y[1]`
and the horizontal line at position `y[2]`. If `length(y) ≥ 4`,
then further rectangles are drawn between `y[3]` and `y[4]`,
`y[5]` and `y[6]`, and so on. If `length(y)` is odd, then the
last entry of `y` is ignored.

# Example
```julia-repl
julia> hspan(1:6)
```
"""
@shorthands hspan

"""
    vspan(x)

Draw a rectangle between the vertical line at position `x[1]`
and the vertical line at position `x[2]`. If `length(x) ≥ 4`,
then further rectangles are drawn between `x[3]` and `x[4]`,
`x[5]` and `x[6]`, and so on. If `length(x)` is odd, then the
last entry of `x` is ignored.

# Example
```julia-repl
julia> vspan(1:6)
```
"""
@shorthands vspan

"""
    ohlc(x,y::Vector{OHLC})
    ohlc!(x,y::Vector{OHLC})

Make open-high-low-close plot. Each entry of y is represented by a vertical
segment extending from the low value to the high value, with short horizontal
segments on the left and right indicating the open and close values, respectively.

# Example
```julia-repl
julia> meanprices = cumsum(randn(100))
julia> y = OHLC[(p+rand(),p+1,p-1,p+rand()) for p in meanprices]
julia> ohlc(y)
```
"""
@shorthands ohlc

"""
    contour(x,y,z)
    contour!(x,y,z)

Draw contour lines of the surface `z`.

# Arguments
- `levels`: Contour levels (if `AbstractVector`) or number of levels (if `Integer`)
- `fill`: Bool. Fill area between contours or draw contours only (false by default)

# Example
```julia-repl
julia> x = y = range(-20, stop = 20, length = 100)
julia> contour(x, y, (x, y) -> x^2 + y^2)
```
"""
@shorthands contour

"An alias for `contour` with fill = true."
@shorthands contourf

@shorthands contour3d

"""
    surface(x,y,z)
    surface!(x,y,z)

Draw a 3D surface plot.

# Example
```julia-repl
julia> using LinearAlgebra
julia> x = y = range(-3, stop = 3, length = 100)
julia> surface(x, y, (x, y) -> sinc(norm([x, y])))
```
"""
@shorthands surface

"""
    wireframe(x,y,z)
    wireframe!(x,y,z)

Draw a 3D wireframe plot.

# Example
```julia-repl
julia> wireframe(1:10,1:10,randn(10,10))
```
"""
@shorthands wireframe

"""
    path3d(x,y,z)
    path3d!(x,y,z)

Plot a 3D path from `(x[1],y[1],z[1])` to `(x[2],y[2],z[2])`,
..., to `(x[end],y[end],z[end])`.

# Example
```julia-repl
julia> path3d([0,1,2,3],[0,1,4,9],[0,1,8,27])
```
"""
@shorthands path3d

"""
    scatter3d(x,y,z)
    scatter3d!(x,y,z)

Make a 3D scatter plot.

# Example
```julia-repl
julia> scatter3d([0,1,2,3],[0,1,4,9],[0,1,8,27])
```
"""
@shorthands scatter3d

"""
    mesh3d(x,y,z)
    mesh3d(x,y,z; connections)

Plot a 3d mesh. On Plotly the triangles can be specified using the connections argument.

# Example
```Julia
x=[0, 1, 2, 0]
y=[0, 0, 1, 2]
z=[0, 2, 0, 1]

i=[0, 0, 0, 1]
j=[1, 2, 3, 2]
k=[2, 3, 1, 3]

plot(x,y,z,seriestype=:mesh3d;connections=(i,j,k))
```
"""
@shorthands mesh3d

"""
    boxplot(x, y)
    boxplot!(x, y)

Make a box and whisker plot.

# Keyword arguments
- `notch`: Bool. Notch the box plot? (false)
- `whisker_range`: Real. Whiskers extend `whisker_range`*IQR below the first quartile
           and above the third quartile. Values outside this range are shown as outliers (1.5)
- `outliers`: Bool. Show outliers? (true)
- `whisker_width`: Real or Symbol. Length of whiskers; the options are `:match` to match the box width, `:half`, or a number to indicate the total length. (:half)

# Example
```julia-repl
julia> using StatsPlots
julia> boxplot(repeat([1,2,3],outer=100),randn(300))
```
"""
@shorthands boxplot

"""
    violin(x,y,z)
    violin!(x,y,z)

Make a violin plot.

# Example
```julia-repl
julia> violin(repeat([1,2,3],outer=100),randn(300))
```
"""
@shorthands violin

"""
    quiver(x,y,quiver=(u,v))
    quiver!(x,y,quiver=(u,v))

Make a quiver (vector field) plot. The `i`th vector extends
from `(x[i],y[i])` to `(x[i] + u[i], y[i] + v[i])`.

# Keyword arguments
- $(_document_argument(:arrow))

# Example
```julia-repl
julia> quiver([1,2,3],[3,2,1],quiver=([1,1,1],[1,2,3]))
```
"""
@shorthands quiver

"""
    curves(x,y)
    curves!(x,y)

Draw a Bezier curve from `(x[1],y[1])` to `(x[end],y[end])`
with control points `(x[2],y[2]), ..., (x[end-1],y[end]-1)`.

# Keyword arguments
- $(_document_argument(:fillrange))

# Example
```julia-repl
julia> curves([1,2,3,4],[1,1,2,4])
```
"""
@shorthands curves

"""
    pie(x, y)

Plot a pie diagram.

# Example
```julia-repl
x = ["Nerds","Hackers","Scientists"]
y = [0.4,0.35,0.25]
pie(x, y, title="The Julia Community")
```
"""
@shorthands pie

"Plot with seriestype :path3d"
plot3d(args...; kw...) = plot(args...; kw..., seriestype = :path3d)
plot3d!(args...; kw...) = plot!(args...; kw..., seriestype = :path3d)

"Add title to an existing plot"
title!(plt::PlotOrSubplot, s::AbstractString; kw...) = plot!(plt; title = s, kw...)
title!(s::AbstractString; kw...) = plot!(; title = s, kw...)

for letter in ("x", "y", "z")
    @eval begin
        """Add $($(letter))label to an existing plot"""
        $(Symbol(letter, :label!))(s::AbstractString; kw...) =
            plot!(; $(Symbol(letter, :label)) = s, kw...)
        $(Symbol(letter, :label!))(plt::PlotOrSubplot, s::AbstractString; kw...) =
            plot!(plt; $(Symbol(letter, :label)) = s, kw...)
        export $(Symbol(letter, :label!))

        "Set $($letter)lims for an existing plot"
        $(Symbol(letter, :lims!))(lims::Tuple; kw...) =
            plot!(; $(Symbol(letter, :lims)) = lims, kw...)
        $(Symbol(letter, :lims!))(xmin::Real, xmax::Real; kw...) =
            plot!(; $(Symbol(letter, :lims)) = (xmin, xmax), kw...)
        $(Symbol(letter, :lims!))(plt::PlotOrSubplot, lims::Tuple{<:Real, <:Real}; kw...) =
            plot!(plt; $(Symbol(letter, :lims)) = lims, kw...)
        $(Symbol(letter, :lims!))(plt::PlotOrSubplot, xmin::Real, xmax::Real; kw...) =
            plot!(plt; $(Symbol(letter, :lims)) = (xmin, xmax), kw...)
        export $(Symbol(letter, :lims!))

        "Set $($letter)ticks for an existing plot"
        $(Symbol(letter, :ticks!))(v::TicksArgs; kw...) =
            plot!(; $(Symbol(letter, :ticks)) = v, kw...)
        $(Symbol(letter, :ticks!))(
            ticks::AVec{T},
            labels::AVec{S};
            kw...,
        ) where {T <: Real, S <: AbstractString} =
            plot!(; $(Symbol(letter, :ticks)) = (ticks, labels), kw...)
        $(Symbol(letter, :ticks!))(plt::PlotOrSubplot, v::TicksArgs; kw...) =
            plot!(plt; $(Symbol(letter, :ticks)) = v, kw...)
        $(Symbol(letter, :ticks!))(
            plt::PlotOrSubplot,
            ticks::AVec{T},
            labels::AVec{S};
            kw...,
        ) where {T <: Real, S <: AbstractString} =
            plot!(plt; $(Symbol(letter, :ticks)) = (ticks, labels), kw...)
        export $(Symbol(letter, :ticks!))

        "Flip the current plots' $($letter) axis"
        $(Symbol(letter, :flip!))(flip::Bool = true; kw...) =
            plot!(; $(Symbol(letter, :flip)) = flip, kw...)
        $(Symbol(letter, :flip!))(plt::PlotOrSubplot, flip::Bool = true; kw...) =
            plot!(plt; $(Symbol(letter, :flip)) = flip, kw...)
        export $(Symbol(letter, :flip!))

        "Specify $($letter) axis attributes for an existing plot"
        $(Symbol(letter, :axis!))(args...; kw...) =
            plot!(; $(Symbol(letter, :axis)) = args, kw...)
        $(Symbol(letter, :axis!))(plt::PlotOrSubplot, args...; kw...) =
            plot!(plt; $(Symbol(letter, :axis)) = args, kw...)
        export $(Symbol(letter, :axis!))

        "Specify $($letter) grid attributes for an existing plot"
        $(Symbol(letter, :grid!))(args...; kw...) =
            plot!(; $(Symbol(letter, :grid)) = args, kw...)
        $(Symbol(letter, :grid!))(plt::PlotOrSubplot, args...; kw...) =
            plot!(plt; $(Symbol(letter, :grid)) = args, kw...)
        export $(Symbol(letter, :grid!))

        """
            $($letter)error(x, y [, z]; $($letter)error = vals)
            $($letter)error!(x, y [, z]; $($letter)error = vals)

        Create or add a series of $($letter)errorbars at the positions defined by `x`, `y` and `z` with the lenghts defined in `vals`.

        Markerstrokecolor will color the whole errorbars if not specified otherwise.
        """
        @shorthands $(Symbol(letter, :error))
    end
end

"""
    annotate!(anns)
    annotate!(anns::Tuple...)
    annotate!(x, y, txt)

Add annotations to an existing plot.
Annotations are specified either as a vector of tuples, each of the form `(x,y,txt)`,
or as three vectors, `x, y, txt`.
Each `txt` can be a `String`, `PlotText` PlotText (created with `text(args...)`),
or a tuple of arguments to `text` (e.g., `("Label", 8, :red, :top)`).

# Example
```julia-repl
julia> plot(1:10)
julia> annotate!([(7,3,"(7,3)"),(3,7,text("hey", 14, :left, :top, :green))])
julia> annotate!([(4, 4, ("More text", 8, 45.0, :bottom, :red))])
julia> annotate!([2,5], [6,3], ["text at (2,6)", "text at (5,3)"])
```
"""
annotate!(anns...; kw...) = plot!(; annotation = anns, kw...)
annotate!(anns::Tuple...; kw...) = plot!(; annotation = collect(anns), kw...)
annotate!(anns::AVec{<:Tuple}; kw...) = plot!(; annotation = anns, kw...)
annotate!(plt::PlotOrSubplot, anns...; kw...) = plot!(plt; annotations = anns, kw...)
annotate!(plt::PlotOrSubplot, anns::Tuple...; kw...) = plot!(plt; annotations = collect(anns), kw...)
annotate!(plt::PlotOrSubplot, anns::AVec{<:Tuple}; kw...) = plot!(plt; annotations = anns, kw...)

@doc """
   abline!([plot,] a, b; kwargs...)

Adds ax+b... straight line over the current plot, without changing the axis limits
""" abline!

@doc """
    areaplot([x,] y)
    areaplot!([x,] y)

Draw a stacked area plot of the matrix y.
# Examples
```julia-repl
julia> areaplot(1:3, [1 2 3; 7 8 9; 4 5 6], seriescolor = [:red :green :blue], fillalpha = [0.2 0.3 0.4])
```
""" areaplot

@doc """
    lens!([plot,] x, y, inset = (sp_index, bbox(x1, x2, y1, y2)))

Magnify a region of a plot given by `x` and `y`.
`sp_index` is the index of the subplot and `x1`, `x2`, `y1` and `y2` should be between `0` and `1`.
""" lens!
@specialize

# https://github.com/JuliaPy/PyPlot.jl
# COV_EXCL_START

is_marker_supported(::PyPlotBackend, shape::Shape) = true

# --------------------------------------------------------------------------------------

# problem: https://github.com/tbreloff/Plots.jl/issues/308
# solution: hack from @stevengj: https://github.com/JuliaPy/PyPlot.jl/pull/223#issuecomment-229747768
let otherdisplays = splice!(Base.Multimedia.displays, 2:length(Base.Multimedia.displays))
    append!(Base.Multimedia.displays, otherdisplays)
end

# "support" matplotlib v3.4
if PyPlot.version < v"3.4"
    @warn """You are using Matplotlib $(PyPlot.version), which is no longer
    officially supported by the Plots community. To ensure smooth Plots.jl
    integration update your Matplotlib library to a version >= 3.4.0

    If you have used Conda.jl to install PyPlot (default installation),
    upgrade your matplotlib via Conda.jl and rebuild the PyPlot.

    If you are not sure, here are the default instructions:

    In Julia REPL:
    ```
    import Pkg;
    Pkg.add("Conda")
    import Conda
    Conda.update()
    Pkg.build("PyPlot")
    ```
    """
end

# PyCall API changes in v1.90.0
isdefined(PyPlot.PyCall, :_setproperty!) ||
    @warn "Plots no longer supports PyCall < 1.90.0 and PyPlot < 2.8.0. Either update PyCall and PyPlot or pin Plots to a version <= 0.23.2."

# # convert colorant to 4-tuple RGBA
# py_color(c::Colorant, α=nothing) = map(f->float(f(convertColor(c,α))), (red, green, blue, alpha))
# py_color(cvec::ColorVector, α=nothing) = map(py_color, convertColor(cvec, α).v)
# py_color(grad::ColorGradient, α=nothing) = map(c -> py_color(c, α), grad.colors)
# py_color(scheme::ColorScheme, α=nothing) = py_color(convertColor(getColor(scheme), α))
# py_color(vec::AVec, α=nothing) = map(c->py_color(c,α), vec)
# py_color(c, α=nothing) = py_color(convertColor(c, α))

# function py_colormap(c::ColorGradient, α=nothing)
#     pyvals = [(v, py_color(getColorZ(c, v), α)) for v in c.values]
#     pycolors["LinearSegmentedColormap"][:from_list]("tmp", pyvals)
# end

# # convert vectors and ColorVectors to standard ColorGradients
# # TODO: move this logic to colors.jl and keep a barebones wrapper for pyplot
# py_colormap(cv::ColorVector, α=nothing) = py_colormap(ColorGradient(cv.v), α)
# py_colormap(v::AVec, α=nothing) = py_colormap(ColorGradient(v), α)

# # anything else just gets a bluesred gradient
# py_colormap(c, α=nothing) = py_colormap(default_gradient(), α)

for k in (:linthresh, :base, :label)
    # add PyPlot specific symbols to cache
    _attrsymbolcache[k] = Dict{Symbol, Symbol}()
    for letter in (:x, :y, :z, Symbol(""), :top, :bottom, :left, :right)
        _attrsymbolcache[k][letter] = Symbol(k, letter)
    end
end

py_handle_surface(v) = v
py_handle_surface(z::Surface) = z.surf

py_color(s) = py_color(parse(Colorant, string(s)))
py_color(c::Colorant) = (red(c), green(c), blue(c), alpha(c))
py_color(cs::AVec) = map(py_color, cs)
py_color(grad::PlotUtils.AbstractColorList) = py_color(color_list(grad))
py_color(c::Colorant, α) = py_color(plot_color(c, α))

function py_colormap(cg::ColorGradient)
    pyvals = collect(zip(cg.values, py_color(PlotUtils.color_list(cg))))
    cm = pycolors."LinearSegmentedColormap"."from_list"("tmp", pyvals)
    cm."set_bad"(color = (0, 0, 0, 0.0), alpha = 0.0)
    return cm
end
function py_colormap(cg::PlotUtils.CategoricalColorGradient)
    r = range(0, stop = 1, length = 256)
    pyvals = collect(zip(r, py_color(cg[r])))
    cm = pycolors."LinearSegmentedColormap"."from_list"("tmp", pyvals)
    cm."set_bad"(color = (0, 0, 0, 0.0), alpha = 0.0)
    return cm
end
py_colormap(c) = py_colormap(_as_gradient(c))

function py_shading(c, z)
    cmap = py_colormap(c)
    ls = pycolors."LightSource"(270, 45)
    return ls."shade"(z, cmap, vert_exag = 0.1, blend_mode = "soft")
end

# get the style (solid, dashed, etc)
function py_linestyle(seriestype::Symbol, linestyle::Symbol)
    seriestype === :none && return " "
    linestyle === :solid && return "-"
    linestyle === :dash && return "--"
    linestyle === :dot && return ":"
    linestyle === :dashdot && return "-."
    @warn "Unknown linestyle $linestyle"
    return "-"
end

function py_marker(marker::Shape)
    x, y = coords(marker)
    n = length(x)
    mat = zeros(n + 1, 2)
    for i in eachindex(x)
        mat[i, 1] = x[i]
        mat[i, 2] = y[i]
    end
    mat[n + 1, :] = @view mat[1, :]
    return pypath."Path"(mat)
end

# get the marker shape
function py_marker(marker::Symbol)
    marker === :none && return " "
    marker === :circle && return "o"
    marker === :rect && return "s"
    marker === :diamond && return "D"
    marker === :utriangle && return "^"
    marker === :dtriangle && return "v"
    marker === :+ && return "+"
    marker === :x && return "x"
    marker === :star5 && return "*"
    marker === :pentagon && return "p"
    marker === :hexagon && return "h"
    marker === :octagon && return "8"
    marker === :pixel && return ","
    marker === :hline && return "_"
    marker === :vline && return "|"
    haskey(_shapes, marker) && return py_marker(_shapes[marker])

    @warn "Unknown marker $marker"
    return "o"
end

# py_marker(markers::AVec) = map(py_marker, markers)
function py_marker(markers::AVec)
    @warn "Vectors of markers are currently unsupported in PyPlot: $markers"
    return py_marker(markers[1])
end

# pass through
function py_marker(marker::AbstractString)
    @assert length(marker) == 1
    return marker
end

function py_stepstyle(seriestype::Symbol)
    seriestype === :steppost && return "steps-post"
    seriestype === :stepmid && return "steps-mid"
    seriestype === :steppre && return "steps-pre"
    return "default"
end

function py_fillstepstyle(seriestype::Symbol)
    seriestype === :steppost && return "post"
    seriestype === :stepmid && return "mid"
    seriestype === :steppre && return "pre"
    return nothing
end

py_fillstyle(::Nothing) = nothing
py_fillstyle(fillstyle::Symbol) = string(fillstyle)

function py_get_matching_math_font(parent_fontfamily)
    # matplotlib supported math fonts according to
    # https://matplotlib.org/stable/tutorials/text/mathtext.html
    py_math_supported_fonts = Dict{String, String}(
        "sans-serif" => "dejavusans",
        "serif" => "dejavuserif",
        "cm" => "cm",
        "stix" => "stix",
        "stixsans" => "stixsans",
    )
    # Fallback to "dejavusans" or "dejavuserif" in case the parentfont is different
    # from supported by matplotlib fonts
    matching_font(font) = occursin("serif", lowercase(font)) ? "dejavuserif" : "dejavusans"
    return get(py_math_supported_fonts, parent_fontfamily, matching_font(parent_fontfamily))
end

get_locator_and_formatter(vals::AVec) =
    pyticker."FixedLocator"(eachindex(vals)), pyticker."FixedFormatter"(vals)

function add_pyfixedformatter(cbar, vals::AVec)
    cbar[:locator], cbar[:formatter] = get_locator_and_formatter(vals)
    return cbar[:update_ticks]()
end

labelfunc(scale::Symbol, backend::PyPlotBackend) =
    PyPlot.LaTeXStrings.latexstring ∘ labelfunc_tex(scale)

function py_mask_nans(z)
    # pynp["ma"][:masked_invalid](z)))
    return PyPlot.PyCall.pycall(pynp."ma"."masked_invalid", Any, z)
    # pynp["ma"][:masked_where](pynp["isnan"](z),z)
end

# ---------------------------------------------------------------------------

function fix_xy_lengths!(plt::Plot{PyPlotBackend}, series::Series)
    return if series[:x] !== nothing
        x, y = series[:x], series[:y]
        nx, ny = length(x), length(y)
        if !isa(get(series.plotattributes, :z, nothing), Surface) && nx != ny
            if nx < ny
                series[:x] = map(i -> Float64(x[mod1(i, nx)]), 1:ny)
            else
                series[:y] = map(i -> Float64(y[mod1(i, ny)]), 1:nx)
            end
        end
    end
end

py_linecolormap(series::Series) =
    py_colormap(cgrad(series[:linecolor], alpha = get_linealpha(series)))
py_markercolormap(series::Series) =
    py_colormap(cgrad(series[:markercolor], alpha = get_markeralpha(series)))
py_fillcolormap(series::Series) =
    py_colormap(cgrad(series[:fillcolor], alpha = get_fillalpha(series)))

# ---------------------------------------------------------------------------

# TODO: these can probably be removed eventually... right now they're just keeping things working before cleanup

# getAxis(sp::Subplot) = sp.o

# function getAxis(plt::Plot{PyPlotBackend}, series::Series)
#     sp = get_subplot(plt, get(series.plotattributes, :subplot, 1))
#     getAxis(sp)
# end

# getfig(o) = o

# ---------------------------------------------------------------------------
# Figure utils -- F*** matplotlib for making me work so hard to figure this crap out

# the drawing surface
py_canvas(fig) = fig."canvas"

# the object controlling draw commands
py_renderer(fig) = py_canvas(fig)."get_renderer"()

# draw commands... paint the screen (probably updating internals too)
py_drawfig(fig) = fig."draw"(py_renderer(fig))
# py_drawax(ax) = ax[:draw](py_renderer(ax[:get_figure]()))

# get a vector [left, right, bottom, top] in PyPlot coords (origin is bottom-left (0, 0)!)
py_extents(obj) = obj."get_window_extent"()."get_points"()

# compute a bounding box (with origin top-left), however pyplot gives coords with origin bottom-left
function py_bbox(obj)
    fl, fr, fb, ft = bb = py_extents(obj."get_figure"())
    l, r, b, t = ex = py_extents(obj)
    # @show obj bb ex
    # BoundingBox(x0, y0, width, height)
    return BoundingBox(l * px, (ft - t) * px, (r - l) * px, (t - b) * px)
end

py_bbox(::Nothing) = BoundingBox(0mm, 0mm)

# get the bounding box of the union of the objects
function py_bbox(v::AVec)
    bbox_union = DEFAULT_BBOX[]
    for obj in v
        bbox_union += py_bbox(obj)
    end
    return bbox_union
end

# bounding box: union of axis tick labels
py_bbox_ticks(ax, letter) =
if ax.name == "3d"
    py_bbox(nothing)  # FIXME: broken in `3d`
else
    py_bbox(getproperty(ax, Symbol("get_" * letter * "ticklabels"))())
end

# bounding box: axis guide
py_bbox_axislabel(ax, letter) =
    py_bbox(getproperty(ax, Symbol("get_" * letter * "axis"))().label)

# bounding box: union of axis ticks and guide
function py_bbox_axis(ax, letter)
    ticks = py_bbox_ticks(ax, letter)
    labels = py_bbox_axislabel(ax, letter)
    return ticks + labels
end

# bounding box: axis title
function py_bbox_title(ax)
    bb = DEFAULT_BBOX[]
    for s in (:title, :_left_title, :_right_title)
        bb += py_bbox(getproperty(ax, s))
    end
    return bb
end

# bounding box: legend
py_bbox_legend(ax) = py_bbox(ax."get_legend"())
py_thickness_scale(plt::Plot{PyPlotBackend}, ptsz) = ptsz * plt[:thickness_scaling]

# ---------------------------------------------------------------------------

# Create the window/figure for this backend.
function _create_backend_figure(plt::Plot{PyPlotBackend})
    w, h = map(px2inch, Tuple(s * plt[:dpi] / Plots.DPI for s in plt[:size]))

    # # reuse the current figure?
    fig = if plt[:overwrite_figure]
        PyPlot.gcf()
    else
        fig = PyPlot.figure()
        # finalizer(fig, close)
        fig
    end

    # clear the figure
    # PyPlot.clf()
    return fig
end

# Set up the subplot within the backend object.
# function _initialize_subplot(plt::Plot{PyPlotBackend}, sp::Subplot{PyPlotBackend})

function py_init_subplot(plt::Plot{PyPlotBackend}, sp::Subplot{PyPlotBackend})
    fig = plt.o
    projection = (proj = sp[:projection]) in (nothing, :none) ? nothing : string(proj)
    kw = if projection == "3d"
        # PyPlot defaults to "persp" projection by default, we choose to unify backends
        # by using a default "ortho" proj when `:auto`
        (;
            proj_type = (
                auto = "ortho",
                ortho = "ortho",
                orthographic = "ortho",
                persp = "persp",
                perspective = "persp",
            )[sp[:projection_type]],
        )
    else
        (;)
    end
    # add a new axis, and force it to create a new one by setting a distinct label
    ax = fig."add_subplot"(; label = string(gensym()), projection = projection, kw...)
    return sp.o = ax
end

# ---------------------------------------------------------------------------

function py_add_series(plt::Plot{PyPlotBackend}, series::Series)
    # plotattributes = series.plotattributes
    st = series[:seriestype]
    sp = series[:subplot]
    ax = sp.o

    # PyPlot doesn't handle mismatched x/y
    fix_xy_lengths!(plt, series)

    # ax = getAxis(plt, series)
    x, y, z = (py_handle_surface(series[letter]) for letter in (:x, :y, :z))
    if st === :straightline
        x, y = straightline_data(series)
    elseif st === :shape
        x, y = shape_data(series)
    end

    if ispolar(series)
        # make negative radii positive and flip the angle
        # (PyPlot ignores negative radii)
        for i in eachindex(y)
            if y[i] < 0
                y[i] = -y[i]
                x[i] -= π
            end
        end
    end

    xyargs = st in _3dTypes ? (x, y, z) : (x, y)

    # handle zcolor and get c/cmap
    needs_colorbar = hascolorbar(sp)
    vmin, vmax = clims = get_clims(sp, series)

    # Dict to store extra kwargs
    extrakw = if st === :wireframe || st === :hexbin
        # vmin, vmax cause an error for wireframe plot
        # We are not supporting clims for hexbin as calculation of bins is not trivial
        KW()
    else
        KW(:vmin => vmin, :vmax => vmax)
    end

    # holds references to any python object representing the matplotlib series
    handles = []
    discrete_colorbar_values = nothing

    # pass in an integer value as an arg, but a levels list as a keyword arg
    levels = series[:levels]
    levelargs = if isscalar(levels)
        levels
    elseif isvector(levels)
        extrakw[:levels] = levels
        ()
    end

    # add custom frame shapes to markershape?
    series_annotations_shapes!(series, :xy)

    # for each plotting command, optionally build and add a series handle to the list

    # line plot
    if st in (:path, :path3d, :steppre, :stepmid, :steppost, :straightline)
        if maximum(series[:linewidth]) > 0
            for (k, segment) in enumerate(series_segments(series, st; check = true))
                i, rng = segment.attr_index, segment.range
                handle = ax."plot"(
                    (arg[rng] for arg in xyargs)...;
                    label = k == 1 ? series[:label] : "",
                    zorder = series[:series_plotindex],
                    color = py_color(
                        single_color(get_linecolor(series, clims, i)),
                        get_linealpha(series, i),
                    ),
                    linewidth = py_thickness_scale(plt, get_linewidth(series, i)),
                    linestyle = py_linestyle(st, get_linestyle(series, i)),
                    solid_capstyle = "butt",
                    dash_capstyle = "butt",
                    drawstyle = py_stepstyle(st),
                )[1]
                push!(handles, handle)
            end

            a = series[:arrow]
            if a !== nothing && !RecipesPipeline.is3d(st)  # TODO: handle 3d later
                if typeof(a) != Arrow
                    @warn "Unexpected type for arrow: $(typeof(a))"
                else
                    arrowprops = KW(
                        :arrowstyle => "simple,head_length=$(a.headlength),head_width=$(a.headwidth)",
                        :shrinkA => 0,
                        :shrinkB => 0,
                        :edgecolor => py_color(get_linecolor(series)),
                        :facecolor => py_color(get_linecolor(series)),
                        :linewidth => py_thickness_scale(plt, get_linewidth(series)),
                        :linestyle => py_linestyle(st, get_linestyle(series)),
                    )
                    add_arrows(x, y) do xyprev, xy
                        ax."annotate"(
                            "",
                            xytext = (
                                0.001xyprev[1] + 0.999xy[1],
                                0.001xyprev[2] + 0.999xy[2],
                            ),
                            xy = xy,
                            arrowprops = arrowprops,
                            zorder = 999,
                        )
                    end
                end
            end
        end
    end

    # add markers?
    if series[:markershape] !== :none &&
            st in (:path, :scatter, :path3d, :scatter3d, :steppre, :stepmid, :steppost, :bar)
        for segment in series_segments(series, :scatter)
            i, rng = segment.attr_index, segment.range
            args = if st === :bar && !isvertical(series)
                y[rng], x[rng]
            else
                x[rng], y[rng]
            end
            if RecipesPipeline.is3d(sp)
                args = (args..., z[rng])
            end

            handle = ax."scatter"(
                args...;
                label = series[:label],
                zorder = series[:series_plotindex] + 0.5,
                marker = py_marker(_cycle(series[:markershape], i)),
                s = py_thickness_scale(plt, _cycle(series[:markersize], i)) .^ 2,
                facecolors = py_color(
                    get_markercolor(series, i),
                    get_markeralpha(series, i),
                ),
                edgecolors = py_color(
                    get_markerstrokecolor(series, i),
                    get_markerstrokealpha(series, i),
                ),
                linewidths = py_thickness_scale(plt, get_markerstrokewidth(series, i)),
                extrakw...,
            )
            push!(handles, handle)
        end
    end

    if st === :hexbin
        sekw = series[:extra_kwargs]
        extrakw[:mincnt] = get(sekw, :mincnt, nothing)
        extrakw[:edgecolors] = get(sekw, :edgecolors, py_color(get_linecolor(series)))
        handle = ax."hexbin"(
            x,
            y;
            label = series[:label],
            C = series[:weights],
            gridsize = series[:bins] === :auto ? 100 : series[:bins],  # 100 is the default value
            linewidths = py_thickness_scale(plt, series[:linewidth]),
            alpha = series[:fillalpha],
            cmap = py_fillcolormap(series),  # applies to the pcolorfast object
            zorder = series[:series_plotindex],
            extrakw...,
        )
        push!(handles, handle)
    end

    if st in (:contour, :contour3d)
        if st === :contour3d
            extrakw[:extend3d] = true
            if !ismatrix(x) || !ismatrix(y)
                x, y = repeat(x', length(y), 1), repeat(y, 1, length(x))
            end
        end

        if typeof(series[:linecolor]) <: AbstractArray
            extrakw[:colors] = py_color.(series[:linecolor])
        else
            extrakw[:cmap] = py_linecolormap(series)
        end

        # contour lines
        handle = ax."contour"(
            x,
            y,
            z,
            levelargs...;
            label = series[:label],
            zorder = series[:series_plotindex],
            linewidths = py_thickness_scale(plt, series[:linewidth]),
            linestyles = py_linestyle(st, series[:linestyle]),
            extrakw...,
        )
        if series[:contour_labels] == true
            ax."clabel"(handle, handle.levels)
        end
        push!(handles, handle)

        # contour fills
        if series[:fillrange] !== nothing
            handle = ax."contourf"(
                x,
                y,
                z,
                levelargs...;
                label = series[:label],
                zorder = series[:series_plotindex] + 0.5,
                alpha = series[:fillalpha],
                extrakw...,
            )
            push!(handles, handle)
        end
    end

    if st in (:surface, :wireframe)
        if z isa AbstractMatrix
            if !ismatrix(x) || !ismatrix(y)
                x, y = repeat(x', length(y), 1), repeat(y, 1, length(x))
            end
            if st === :surface
                if series[:fill_z] !== nothing
                    # the surface colors are different than z-value
                    extrakw[:facecolors] =
                        py_shading(series[:fillcolor], py_handle_surface(series[:fill_z]))
                    extrakw[:shade] = false
                else
                    extrakw[:cmap] = py_fillcolormap(series)
                end
            end
            handle = getproperty(ax, st === :surface ? :plot_surface : :plot_wireframe)(
                x,
                y,
                z;
                label = series[:label],
                zorder = series[:series_plotindex],
                rstride = series[:stride][1],
                cstride = series[:stride][2],
                linewidth = py_thickness_scale(plt, series[:linewidth]),
                edgecolor = py_color(get_linecolor(series)),
                extrakw...,
            )
            push!(handles, handle)

            # contours on the axis planes
            if series[:contours]
                for (zdir, mat) in (("x", x), ("y", y), ("z", z))
                    offset = (zdir == "y" ? ignorenan_maximum : ignorenan_minimum)(mat)
                    handle = ax."contourf"(
                        x,
                        y,
                        z,
                        levelargs...;
                        zdir = zdir,
                        cmap = py_fillcolormap(series),
                        offset = (zdir == "y" ? ignorenan_maximum : ignorenan_minimum)(mat),  # where to draw the contour plane
                    )
                    push!(handles, handle)
                end
            end

        elseif typeof(z) <: AbstractVector
            # tri-surface plot (https://matplotlib.org/mpl_toolkits/mplot3d/tutorial.html#tri-surface-plots)
            handle = ax."plot_trisurf"(
                x,
                y,
                z;
                label = series[:label],
                zorder = series[:series_plotindex],
                cmap = py_fillcolormap(series),
                linewidth = py_thickness_scale(plt, series[:linewidth]),
                edgecolor = py_color(get_linecolor(series)),
                extrakw...,
            )
            push!(handles, handle)
        else
            error("Unsupported z type $(typeof(z)) for seriestype=$st")
        end
    end

    if st === :mesh3d
        polygons = if series[:connections] isa AbstractVector{<:AbstractVector{Int}}
            # Combination of any polygon types
            broadcast(inds -> broadcast(i -> [x[i], y[i], z[i]], inds), series[:connections])
        elseif series[:connections] isa AbstractVector{NTuple{N, Int}} where {N}
            # Only N-gons - connections have to be 1-based (indexing)
            broadcast(inds -> broadcast(i -> [x[i], y[i], z[i]], inds), series[:connections])
        elseif series[:connections] isa NTuple{3, <:AbstractVector{Int}}
            # Only triangles - connections have to be 0-based (indexing)
            ci, cj, ck = series[:connections]
            if !(length(ci) == length(cj) == length(ck))
                "Argument connections must consist of equally sized arrays." |>
                    ArgumentError |>
                    throw
            end
            broadcast(
                j -> broadcast(i -> [x[i], y[i], z[i]], [ci[j] + 1, cj[j] + 1, ck[j] + 1]),
                eachindex(ci),
            )
        else
            "Unsupported `:connections` type $(typeof(series[:connections])) for seriestype=$st" |>
                ArgumentError |>
                throw
        end
        col = mplot3d.art3d.Poly3DCollection(
            polygons,
            linewidths = py_thickness_scale(plt, series[:linewidth]),
            edgecolor = py_color(get_linecolor(series)),
            facecolor = py_color(series[:fillcolor]),
            alpha = get_fillalpha(series),
            zorder = series[:series_plotindex],
        )
        handle = ax."add_collection3d"(col)
        # Fix for handle: https://stackoverflow.com/questions/54994600/pyplot-legend-poly3dcollection-object-has-no-attribute-edgecolors2d
        # It seems there aren't two different alpha values for edge and face
        handle._facecolors2d = py_color(series[:fillcolor])
        handle._edgecolors2d = py_color(get_linecolor(series))
        push!(handles, handle)
    end

    if st === :image
        xmin, xmax = ignorenan_extrema(series[:x])
        ymin, ymax = ignorenan_extrema(series[:y])
        dx = (xmax - xmin) / (length(series[:x]) - 1) / 2
        dy = (ymax - ymin) / (length(series[:y]) - 1) / 2
        z = if eltype(z) <: Colors.AbstractGray
            float(z)
        elseif eltype(z) <: Colorant
            map(c -> Float64[red(c), green(c), blue(c), alpha(c)], z)
        else
            z  # hopefully it's in a data format that will "just work" with imshow
        end
        handle = ax."imshow"(
            z;
            zorder = series[:series_plotindex],
            cmap = py_colormap(cgrad(plot_color([:black, :white]))),
            vmin = 0.0,
            vmax = 1.0,
            extent = (xmin - dx, xmax + dx, ymax + dy, ymin - dy),
        )
        push!(handles, handle)

        # expand extrema... handle is AxesImage object
        xmin, xmax, ymax, ymin = handle."get_extent"()
        expand_extrema!(sp, xmin, xmax, ymin, ymax)
        # sp[:yaxis].series[:flip] = true
    end

    if st === :heatmap
        x, y = heatmap_edges(x, sp[:xaxis][:scale], y, sp[:yaxis][:scale], size(z))

        expand_extrema!(sp[:xaxis], x)
        expand_extrema!(sp[:yaxis], y)
        dvals = sp[:zaxis][:discrete_values]
        isempty(dvals) || (discrete_colorbar_values = dvals)

        handle = ax."pcolormesh"(
            x,
            y,
            py_mask_nans(z);
            label = series[:label],
            zorder = series[:series_plotindex],
            cmap = py_fillcolormap(series),
            alpha = series[:fillalpha],
            # edgecolors = (series[:linewidth] > 0 ? py_linecolor(series) : "face"),
            extrakw...,
        )
        push!(handles, handle)
    end

    if st === :shape
        handle = []
        for segment in series_segments(series)
            i, rng = segment.attr_index, segment.range
            if length(rng) > 1
                lc = get_linecolor(series, clims, i)
                fc = get_fillcolor(series, clims, i)
                la = get_linealpha(series, i)
                fa = get_fillalpha(series, i)
                ls = get_linestyle(series, i)
                fs = get_fillstyle(series, i)
                has_fs = !isnothing(fs)

                path = pypath."Path"(hcat(x[rng], y[rng]))

                # shape outline (and potentially solid fill)
                patches = pypatches."PathPatch"(
                    path;
                    label = series[:label],
                    zorder = series[:series_plotindex],
                    edgecolor = py_color(lc, la),
                    facecolor = py_color(fc, has_fs ? 0 : fa),
                    linewidth = py_thickness_scale(plt, get_linewidth(series, i)),
                    linestyle = py_linestyle(st, ls),
                    fill = !has_fs,
                )
                push!(handle, ax."add_patch"(patches))

                # shape hatched fill
                # hatch color/alpha are controlled by edge (not face) color/alpha
                if has_fs
                    patches = pypatches."PathPatch"(
                        path;
                        label = "",
                        zorder = series[:series_plotindex],
                        edgecolor = py_color(fc, fa),
                        facecolor = py_color(fc, 0), # don't fill with solid background
                        hatch = py_fillstyle(fs),
                        linewidth = 0, # don't replot shape outline (doesn't affect hatch linewidth)
                        linestyle = py_linestyle(st, ls),
                        fill = false,
                    )
                    push!(handle, ax."add_patch"(patches))
                end
            end
        end
        push!(handles, handle)
    end

    series[:serieshandle] = handles

    # # smoothing
    # handleSmooth(plt, ax, series, series[:smooth])

    # handle area filling
    fillrange = series[:fillrange]
    if fillrange !== nothing && st !== :contour
        for segment in series_segments(series)
            i, rng = segment.attr_index, segment.range
            f, dim1, dim2 = if isvertical(series)
                :fill_between, x[rng], y[rng]
            else
                :fill_betweenx, y[rng], x[rng]
            end
            n = length(dim1)
            args = if typeof(fillrange) <: Union{Real, AVec}
                dim1, _cycle(fillrange, rng), dim2
            elseif is_2tuple(fillrange)
                dim1, _cycle(fillrange[1], rng), _cycle(fillrange[2], rng)
            end

            la = get_linealpha(series, i)
            fc = get_fillcolor(series, clims, i)
            fa = get_fillalpha(series, i)
            fs = get_fillstyle(series, i)
            has_fs = !isnothing(fs)

            handle = getproperty(ax, f)(
                args...,
                trues(n),
                false,
                py_fillstepstyle(st);
                zorder = series[:series_plotindex],
                # hatch color/alpha are controlled by edge (not face) color/alpha
                # if has_fs, set edge color/alpha <- fill color/alpha and face alpha <- 0
                edgecolor = py_color(fc, has_fs ? fa : la),
                facecolor = py_color(fc, has_fs ? 0 : fa),
                hatch = py_fillstyle(fs),
                linewidths = 0,
            )
            push!(handles, handle)
        end
    end

    # this is all we need to add the series_annotations text
    anns = series[:series_annotations]
    for (xi, yi, str, fnt) in EachAnn(anns, x, y)
        py_add_annotations(sp, xi, yi, PlotText(str, fnt))
    end
    return
end

# --------------------------------------------------------------------------

function py_set_lims(ax, sp::Subplot, axis::Axis)
    letter = axis[:letter]
    lfrom, lto = axis_limits(sp, letter)
    return getproperty(ax, Symbol("set_", letter, "lim"))(lfrom, lto)
end

function py_set_ticks(sp, ax, ticks, letter)
    ticks === :auto && return
    axis = getproperty(ax, get_attr_symbol(letter, :axis))
    if ticks === :none || ticks === nothing || ticks == false
        kw = KW()
        for dir in (:top, :bottom, :left, :right)
            kw[dir] = kw[get_attr_symbol(:label, dir)] = false
        end
        axis."set_tick_params"(; which = "both", kw...)
        return
    end

    return if (ttype = ticksType(ticks)) === :ticks
        axis."set_ticks"(ticks)
    elseif ttype === :ticks_and_labels
        axis."set_ticks"(ticks[1])
        axis."set_ticklabels"(ticks[2])
    else
        error("Invalid input for $(letter)ticks: $ticks")
    end
end

function py_compute_axis_minval(sp::Subplot, axis::Axis)
    # compute the smallest absolute value for the log scale's linear threshold
    minval = 1.0
    sps = axis.sps
    for sp in sps, series in series_list(sp)
        (v = series.plotattributes[axis[:letter]]) |> isempty && continue
        minval = NaNMath.min(minval, ignorenan_minimum(abs.(v)))
    end

    # now if the axis limits go to a smaller abs value, use that instead
    vmin, vmax = axis_limits(sp, axis[:letter])
    return NaNMath.min(minval, abs(vmin), abs(vmax))
end

function py_set_scale(ax, sp::Subplot, scale::Symbol, letter::Symbol)
    scale in supported_scales() || return @warn "Unhandled scale value in pyplot: $scale"
    func = getproperty(ax, Symbol("set_", letter, "scale"))
    pyletter = PyPlot.version ≥ v"3.3" ? Symbol("") : letter  # https://matplotlib.org/3.3.0/api/api_changes.html
    kw = KW()
    arg = if scale === :identity
        "linear"
    else
        kw[get_attr_symbol(:base, pyletter)] = if scale === :ln
            ℯ
        elseif scale === :log2
            2
        elseif scale === :log10
            10
        end
        axis = sp[get_attr_symbol(letter, :axis)]
        kw[get_attr_symbol(:linthresh, pyletter)] =
            NaNMath.max(1.0e-16, py_compute_axis_minval(sp, axis))
        "symlog"
    end
    return func(arg; kw...)
end

py_set_scale(ax, sp::Subplot, axis::Axis) =
    py_set_scale(ax, sp, axis[:scale], axis[:letter])

py_set_spine_color(spines, color) =
    foreach(loc -> getproperty(spines, loc)."set_color"(color), spines)

py_set_spine_color(spines::Dict, color) =
    for (_, spine) in spines
    spine."set_color"(color)
end

function py_set_axis_colors(sp, ax, a::Axis)
    py_set_spine_color(ax.spines, py_color(a[:foreground_color_border]))
    axissym = get_attr_symbol(a[:letter], :axis)
    return if PyPlot.PyCall.hasproperty(ax, axissym)
        tickcolor =
            sp[:framestyle] in (:zerolines, :grid) ?
            py_color(plot_color(a[:foreground_color_grid], a[:gridalpha])) :
            py_color(a[:foreground_color_axis])
        ax."tick_params"(
            axis = string(a[:letter]),
            which = "both",
            colors = tickcolor,
            labelcolor = py_color(a[:tickfontcolor]),
        )
        getproperty(ax, axissym).label.set_color(py_color(a[:guidefontcolor]))
    end
end

# --------------------------------------------------------------------------
py_hide_spines(ax) =
    foreach(spine -> getproperty(ax.spines, string(spine))."set_visible"(false), ax.spines)

function _before_layout_calcs(plt::Plot{PyPlotBackend})
    # update the fig
    w, h = plt[:size]
    fig = plt.o
    fig."clear"()
    fig."set_size_inches"(w / DPI, h / DPI, forward = true)
    fig."set_facecolor"(py_color(plt[:background_color_outside]))
    fig."set_dpi"(plt[:dpi])

    # resize the window
    PyPlot.plt."get_current_fig_manager"().resize(w, h)

    # initialize subplots
    foreach(sp -> py_init_subplot(plt, sp), plt.subplots)

    # add the series
    foreach(series -> py_add_series(plt, series), plt.series_list)

    # update subplots
    for sp in plt.subplots
        (ax = sp.o) === nothing && continue

        # add the annotations
        for ann in sp[:annotations]
            py_add_annotations(sp, locate_annotation(sp, ann...)...)
        end

        # title
        if !isempty(sp[:title])
            loc = lowercase(string(sp[:titlelocation]))
            func = getproperty(
                ax, if loc == "left"
                    :_left_title
                elseif loc == "right"
                    :_right_title
                else
                    :title
                end
            )
            func."set_text"(sp[:title])
            func."set_fontsize"(py_thickness_scale(plt, sp[:titlefontsize]))
            func."set_family"(sp[:titlefontfamily])
            func."set_math_fontfamily"(py_get_matching_math_font(sp[:titlefontfamily]))
            func."set_color"(py_color(sp[:titlefontcolor]))
            # ax[:set_title](sp[:title], loc = loc)
        end

        # add the colorbar legend
        if hascolorbar(sp)
            # add keyword args for a discrete colorbar
            slist = series_list(sp)
            colorbar_series = slist[findfirst(hascolorbar.(slist))]
            handle = colorbar_series[:serieshandle][end]
            kw = KW()
            if !isempty(sp[:zaxis][:discrete_values]) &&
                    colorbar_series[:seriestype] === :heatmap
                locator, formatter = get_locator_and_formatter(sp[:zaxis][:discrete_values])
                # kw[:values] = eachindex(sp[:zaxis][:discrete_values])
                kw[:values] = sp[:zaxis][:continuous_values]
                kw[:ticks] = locator
                kw[:format] = formatter
                kw[:boundaries] = vcat(0, kw[:values] + 0.5)
            elseif any(
                    colorbar_series[attr] !== nothing for attr in (:line_z, :fill_z, :marker_z)
                )
                cmin, cmax = get_clims(sp)
                norm = pycolors."Normalize"(vmin = cmin, vmax = cmax)
                f = if colorbar_series[:line_z] !== nothing
                    py_linecolormap
                elseif colorbar_series[:fill_z] !== nothing
                    py_fillcolormap
                else
                    py_markercolormap
                end
                cmap = pycmap."ScalarMappable"(norm = norm, cmap = f(colorbar_series))
                cmap."set_array"([])
                handle = cmap
            end
            kw[:spacing] = "proportional"

            if RecipesPipeline.is3d(sp) || ispolar(sp)
                cbax = fig."add_axes"(
                    [0.9, 0.1, 0.03, 0.8],
                    label = string("cbar", sp[:subplot_index]),
                )
                cb = fig."colorbar"(handle; cax = cbax, kw...)
            else
                # divider approach works only with 2d plots
                divider = axes_grid1.make_axes_locatable(ax)
                # width = axes_grid1.axes_size.AxesY(ax, aspect=1.0 / 3.5)
                # pad = axes_grid1.axes_size.Fraction(0.5, width)  # Colorbar is spaced 0.5 of its size away from the ax
                # cbax = divider.append_axes("right", size=width, pad=pad)   # This approach does not work well in subplots
                colorbar_position, colorbar_pad, colorbar_orientation =
                if sp[:colorbar] === :left
                    string(sp[:colorbar]), "5%", "vertical"
                elseif sp[:colorbar] === :top
                    string(sp[:colorbar]), "2.5%", "horizontal"
                elseif sp[:colorbar] === :bottom
                    string(sp[:colorbar]), "5%", "horizontal"
                else
                    "right", "2.5%", "vertical"
                end

                cbax = divider.append_axes(
                    colorbar_position,
                    size = "5%",
                    pad = colorbar_pad,
                    label = string("cbar", sp[:subplot_index]),
                )  # Reasonable value works most of the usecases
                cb = fig."colorbar"(
                    handle;
                    cax = cbax,
                    orientation = colorbar_orientation,
                    kw...,
                )

                if sp[:colorbar] === :left
                    cbax.yaxis.set_ticks_position("left")
                elseif sp[:colorbar] === :top
                    cbax.xaxis.set_ticks_position("top")
                elseif sp[:colorbar] === :bottom
                    cbax.xaxis.set_ticks_position("bottom")
                end
            end

            cb."set_label"(
                sp[:colorbar_title],
                size = py_thickness_scale(plt, sp[:colorbar_titlefontsize]),
                family = sp[:colorbar_titlefontfamily],
                math_fontfamily = py_get_matching_math_font(sp[:colorbar_titlefontfamily]),
                color = py_color(sp[:colorbar_titlefontcolor]),
            )

            # cb."formatter".set_useOffset(false)   # This for some reason does not work, must be a pyplot bug, instead this is a workaround:
            cb."formatter".set_powerlimits((-Inf, Inf))
            cb."update_ticks"()

            ticks = get_colorbar_ticks(sp)
            axis, cbar_axis, ticks_letter = if sp[:colorbar] in (:top, :bottom)
                sp[:xaxis], cb."ax"."xaxis", :x  # colorbar inherits from x axis
            else
                sp[:yaxis], cb."ax"."yaxis", :y  # colorbar inherits from y axis
            end
            py_set_scale(cb.ax, sp, sp[:colorbar_scale], ticks_letter)
            sp[:colorbar_ticks] === :native || py_set_ticks(sp, cb.ax, ticks, ticks_letter)

            for lab in cbar_axis."get_ticklabels"()
                lab."set_fontsize"(py_thickness_scale(plt, sp[:colorbar_tickfontsize]))
                lab."set_family"(sp[:colorbar_tickfontfamily])
                lab."set_math_fontfamily"(
                    py_get_matching_math_font(sp[:colorbar_tickfontfamily]),
                )
                lab."set_color"(py_color(sp[:colorbar_tickfontcolor]))
            end

            # Adjust thickness of the cbar ticks
            intensity = 0.5
            cbar_axis."set_tick_params"(
                direction = axis[:tick_direction] === :out ? "out" : "in",
                width = py_thickness_scale(plt, intensity),
                length = axis[:tick_direction] === :none ? 0 :
                    5py_thickness_scale(plt, intensity),
            )

            cb.outline."set_linewidth"(py_thickness_scale(plt, 1))

            sp.attr[:cbar_handle] = cb
            sp.attr[:cbar_ax] = cbax
        end

        # framestyle
        if !ispolar(sp) && !RecipesPipeline.is3d(sp)
            for pos in ("left", "right", "top", "bottom")
                # Scale all axes by default first
                getproperty(ax.spines, pos)."set_linewidth"(py_thickness_scale(plt, 1))
            end

            # Then set visible some of them
            if sp[:framestyle] === :semi
                intensity = 0.5

                pyspine = getproperty(ax.spines, sp[:yaxis][:mirror] ? "left" : "right")
                pyspine."set_alpha"(intensity)
                pyspine."set_linewidth"(py_thickness_scale(plt, intensity))

                pyspine = getproperty(ax.spines, sp[:xaxis][:mirror] ? "bottom" : "top")
                pyspine."set_linewidth"(py_thickness_scale(plt, intensity))
                pyspine."set_alpha"(intensity)
            elseif sp[:framestyle] === :box
                ax.tick_params(top = true)   # Add ticks too
                ax.tick_params(right = true) # Add ticks too
            elseif sp[:framestyle] in (:axes, :origin)
                getproperty(ax.spines, sp[:xaxis][:mirror] ? "bottom" : "top")."set_visible"(
                    false,
                )
                getproperty(ax.spines, sp[:yaxis][:mirror] ? "left" : "right")."set_visible"(
                    false,
                )
                if sp[:framestyle] === :origin
                    ax.spines."bottom"."set_position"("zero")
                    ax.spines."left"."set_position"("zero")
                end
            elseif sp[:framestyle] in (:grid, :none, :zerolines)
                py_hide_spines(ax)
                if sp[:framestyle] === :zerolines
                    ax."axhline"(
                        y = 0,
                        color = py_color(sp[:xaxis][:foreground_color_axis]),
                        lw = py_thickness_scale(plt, 0.75),
                    )
                    ax."axvline"(
                        x = 0,
                        color = py_color(sp[:yaxis][:foreground_color_axis]),
                        lw = py_thickness_scale(plt, 0.75),
                    )
                end
            end

            if sp[:xaxis][:mirror]
                ax.xaxis."set_label_position"("top")  # the guides
                sp[:framestyle] === :box || ax.xaxis."tick_top"()
            end

            if sp[:yaxis][:mirror]
                ax.yaxis."set_label_position"("right")  # the guides
                sp[:framestyle] === :box || ax.yaxis."tick_right"()
            end
        end

        # axis attributes
        for letter in (:x, :y, :z)
            axissym = get_attr_symbol(letter, :axis)
            PyPlot.PyCall.hasproperty(ax, axissym) || continue
            axis = sp[axissym]
            pyaxis = getproperty(ax, axissym)

            if axis[:guide_position] !== :auto && letter !== :z
                pyaxis."set_label_position"(axis[:guide_position])
            end

            py_set_scale(ax, sp, axis)
            py_set_lims(ax, sp, axis)
            (ispolar(sp) && letter === :y) && ax."set_rlabel_position"(90)
            ticks = sp[:framestyle] === :none ? nothing : get_ticks(sp, axis)

            # don't show the 0 tick label for the origin framestyle
            if sp[:framestyle] === :origin && length(ticks) > 1
                ticks[2][ticks[1] .== 0] .= ""
            end

            # Set ticks
            fontProperties = Dict(
                "family" => axis[:tickfontfamily],
                "math_fontfamily" => py_get_matching_math_font(axis[:tickfontfamily]),
                "size" => py_thickness_scale(plt, axis[:tickfontsize]),
                "rotation" => axis[:tickfontrotation],
            )

            positions = getproperty(ax, Symbol("get_", letter, "ticks"))()
            pyaxis.set_major_locator(pyticker.FixedLocator(positions))

            kw = if RecipesPipeline.is3d(sp)
                NamedTuple(Symbol(k) => v for (k, v) in fontProperties)
            else
                (; fontdict = PyPlot.PyCall.PyDict(fontProperties))
            end

            getproperty(ax, Symbol("set_", letter, "ticklabels"))(positions; kw...)

            py_set_ticks(sp, ax, ticks, letter)

            if axis[:ticks] === :native # it is easier to reset than to account for this
                py_set_lims(ax, sp, axis)
                pyaxis.set_major_locator(pyticker.AutoLocator())
                pyaxis.set_major_formatter(pyticker.ScalarFormatter())
            end

            # Tick marks
            intensity = 0.5  # this value corresponds to scaling of other grid elements
            pyaxis."set_tick_params"(
                direction = axis[:tick_direction] === :out ? "out" : "in",
                width = py_thickness_scale(plt, intensity),
                length = axis[:tick_direction] === :none ? 0 :
                    5py_thickness_scale(plt, intensity),
            )

            getproperty(ax, Symbol("set_", letter, "label"))(Plots.get_guide(axis))
            if get(axis.plotattributes, :flip, false)
                getproperty(ax, Symbol("invert_", letter, "axis"))()
            end
            pyaxis."label"."set_fontsize"(py_thickness_scale(plt, axis[:guidefontsize]))
            pyaxis."label"."set_family"(axis[:guidefontfamily])
            pyaxis."label"."set_math_fontfamily"(
                py_get_matching_math_font(axis[:guidefontfamily]),
            )

            RecipesPipeline.is3d(sp) && pyaxis."set_rotate_label"(false)

            if letter === :y && !RecipesPipeline.is3d(sp)
                axis[:guidefontrotation] + 90
            else
                axis[:guidefontrotation]
            end |> pyaxis."label"."set_rotation"

            if axis[:grid] && ticks ∉ (:none, nothing, false)
                pyaxis."grid"(
                    true,
                    color = py_color(axis[:foreground_color_grid]),
                    linestyle = py_linestyle(:line, axis[:gridstyle]),
                    linewidth = py_thickness_scale(plt, axis[:gridlinewidth]),
                    alpha = axis[:gridalpha],
                )
                ax."set_axisbelow"(true)
            else
                pyaxis."grid"(false)
            end

            n_minor_intervals = axis[:minorticks]
            if !no_minor_intervals(axis) && n_minor_intervals isa Integer
                n_minor_intervals isa Bool || pyaxis."set_minor_locator"(
                    # NOTE: AutoMinorLocator expects a number of intervals
                    PyPlot.matplotlib.ticker.AutoMinorLocator(n_minor_intervals),
                )
                pyaxis."set_tick_params"(
                    which = "minor",
                    direction = axis[:tick_direction] === :out ? "out" : "in",
                    length = axis[:tick_direction] === :none ? 0 :
                        py_thickness_scale(plt, intensity),
                )
            end

            if axis[:minorgrid]
                no_minor_intervals(axis) || ax."minorticks_on"()  # Check if ticks were already configured
                pyaxis."set_tick_params"(
                    which = "minor",
                    direction = axis[:tick_direction] === :out ? "out" : "in",
                    length = axis[:tick_direction] === :none ? 0 :
                        py_thickness_scale(plt, intensity),
                )

                pyaxis."grid"(
                    true,
                    which = "minor",
                    color = py_color(axis[:foreground_color_grid]),
                    linestyle = py_linestyle(:line, axis[:minorgridstyle]),
                    linewidth = py_thickness_scale(plt, axis[:minorgridlinewidth]),
                    alpha = axis[:minorgridalpha],
                )
            end

            py_set_axis_colors(sp, ax, axis)
        end

        # showaxis
        if !sp[:xaxis][:showaxis]
            kw = KW()
            ispolar(sp) && ax.spines."polar".set_visible(false)
            for dir in (:top, :bottom)
                ispolar(sp) || getproperty(ax.spines, string(dir)).set_visible(false)
                kw[dir] = kw[get_attr_symbol(:label, dir)] = false
            end
            ax."xaxis"."set_tick_params"(; which = "both", kw...)
        end
        if !sp[:yaxis][:showaxis]
            kw = KW()
            for dir in (:left, :right)
                ispolar(sp) || getproperty(ax.spines, string(dir)).set_visible(false)
                kw[dir] = kw[get_attr_symbol(:label, dir)] = false
            end
            ax."yaxis"."set_tick_params"(; which = "both", kw...)
        end

        # aspect ratio
        if (ratio = get_aspect_ratio(sp)) !== :none
            if RecipesPipeline.is3d(sp)
                if ratio === :auto
                    nothing
                elseif ratio === :equal
                    ax."set_box_aspect"((1, 1, 1))
                else
                    ax."set_box_aspect"(ratio)
                end
            else
                ax."set_aspect"(isa(ratio, Symbol) ? string(ratio) : ratio, anchor = "C")
            end
        end

        # camera/view angle
        if RecipesPipeline.is3d(sp)
            # convert azimuth to match GR behaviour
            azimuth, elevation = sp[:camera] .- (90, 0)
            ax."view_init"(elevation, azimuth)
        end

        # legend
        py_add_legend(plt, sp, ax)

        # this sets the bg color inside the grid
        ax."set_facecolor"(py_color(sp[:background_color_inside]))

        # link axes
        x_ax_link, y_ax_link = sp[:xaxis].sps[1].o, sp[:yaxis].sps[1].o
        if (twinx = ax != x_ax_link)
            ax."get_shared_x_axes"()."join"(ax, x_ax_link)
        end
        if (twiny = ax != y_ax_link)
            ax."get_shared_y_axes"()."join"(ax, y_ax_link)
        end
    end
    return py_drawfig(fig)
end

expand_padding!(padding, bb, plotbb) =
if ispositive(width(bb)) && ispositive(height(bb))
    padding[1] = max(padding[1], left(plotbb) - left(bb))
    padding[2] = max(padding[2], top(plotbb) - top(bb))
    padding[3] = max(padding[3], right(bb) - right(plotbb))
    padding[4] = max(padding[4], bottom(bb) - bottom(plotbb))
end

# Set the (left, top, right, bottom) minimum padding around the plot area
# to fit ticks, tick labels, guides, colorbars, etc.
function _update_min_padding!(sp::Subplot{PyPlotBackend})
    (ax = sp.o) === nothing && return sp.minpad
    plotbb = py_bbox(ax)

    # TODO: this should initialize to the margin from sp.attr
    # figure out how much the axis components and title "stick out" from the plot area
    padding = [0mm, 0mm, 0mm, 0mm]  # leftpad, toppad, rightpad, bottompad

    for bb in (
            py_bbox_axis(ax, "x"),
            py_bbox_axis(ax, "y"),
            py_bbox_title(ax),
            py_bbox_legend(ax),
        )
        expand_padding!(padding, bb, plotbb)
    end

    if haskey(sp.attr, :cbar_ax) # Treat colorbar the same way
        cbar_ax = sp.attr[:cbar_handle]."ax"
        for bb in
            (py_bbox_axis(cbar_ax, "x"), py_bbox_axis(cbar_ax, "y"), py_bbox_title(cbar_ax))
            expand_padding!(padding, bb, plotbb)
        end
    end

    # optionally add the width of colorbar labels and colorbar to rightpad
    if RecipesPipeline.is3d(sp)
        expand_padding!(padding, py_bbox_axis(ax, "z"), plotbb)
        if haskey(sp.attr, :cbar_ax)
            sp.attr[:cbar_bbox] = py_bbox(sp.attr[:cbar_handle]."ax")
        end
    end

    # add in the user-specified margin
    padding .+= [sp[:left_margin], sp[:top_margin], sp[:right_margin], sp[:bottom_margin]]

    dpi_factor = Plots.DPI / sp.plt[:dpi]

    return sp.minpad = Tuple(dpi_factor .* padding)
end

# -----------------------------------------------------------------

function py_add_annotations(sp::Subplot{PyPlotBackend}, x, y, val)
    ax = sp.o
    return ax."annotate"(val, xy = (x, y), zorder = 999, annotation_clip = false)
end

function py_add_annotations(sp::Subplot{PyPlotBackend}, x, y, val::PlotText)
    ax = sp.o
    return ax."annotate"(
        val.str,
        xy = (x, y),
        family = val.font.family,
        color = py_color(val.font.color),
        horizontalalignment = val.font.halign === :hcenter ? "center" :
            string(val.font.halign),
        verticalalignment = val.font.valign === :vcenter ? "center" :
            string(val.font.valign),
        rotation = val.font.rotation,
        size = py_thickness_scale(sp.plt, val.font.pointsize),
        zorder = 999,
        annotation_clip = false,
    )
end

# -----------------------------------------------------------------

py_legend_pos(pos::Tuple{S, T}) where {S <: Real, T <: Real} = "lower left"

function py_legend_pos(pos::Tuple{<:Real, Symbol})
    (s, c) = sincosd(pos[1])
    if pos[2] === :outer
        s = -s
        c = -c
    end
    yanchors = "lower", "center", "upper"
    xanchors = "left", "center", "right"
    return join([yanchors[legend_anchor_index(s)], xanchors[legend_anchor_index(c)]], ' ')
end

function py_legend_bbox(pos::Tuple{T, Symbol}) where {T <: Real}
    pos[2] === :outer &&
        return legend_pos_from_angle(pos[1], -0.15, 0.5, 1.0, -0.15, 0.5, 1.0)
    return legend_pos_from_angle(pos[1], 0.0, 0.5, 1.0, 0.0, 0.5, 1.0)
end

py_legend_bbox(pos) = pos

function py_add_legend(plt::Plot, sp::Subplot, ax)
    (leg = sp[:legend_position]) === :none && return

    # gotta do this to ensure both axes are included
    labels, handles = [], []
    nseries = 0
    for series in series_list(sp)
        should_add_to_legend(series) || continue
        nseries += 1
        clims = get_clims(sp, series)
        # add a line/marker and a label
        if series[:seriestype] === :shape || series[:fillrange] !== nothing
            lc = get_linecolor(series, clims)
            fc = get_fillcolor(series, clims)
            la = get_linealpha(series)
            fa = get_fillalpha(series)
            ls = get_linestyle(series)
            fs = get_fillstyle(series)
            has_fs = !isnothing(fs)

            # line (and potentially solid fill)
            line_handle = pypatches."Patch"(
                edgecolor = py_color(single_color(lc), la),
                facecolor = py_color(single_color(fc), has_fs ? 0 : fa),
                linewidth = py_thickness_scale(plt, clamp(get_linewidth(series), 0, 5)),
                linestyle = py_linestyle(series[:seriestype], ls),
                capstyle = "butt",
            )
            push!(handles, line_handle)

            # hatched fill
            # hatch color/alpha are controlled by edge (not face) color/alpha
            if has_fs
                fill_handle = pypatches."Patch"(
                    edgecolor = py_color(single_color(fc), fa),
                    facecolor = py_color(single_color(fc), 0), # don't fill with solid background
                    hatch = py_fillstyle(fs),
                    linewidth = 0, # don't replot shape outline (doesn't affect hatch linewidth)
                    linestyle = py_linestyle(series[:seriestype], ls),
                    capstyle = "butt",
                )

                # plot two handles on top of each other by passing in a tuple
                # https://matplotlib.org/stable/tutorials/intermediate/legend_guide.html
                push!(handles, fill_handle)
            end
        elseif series[:seriestype] in
                (:path, :straightline, :scatter, :steppre, :stepmid, :steppost)
            has_line = get_linewidth(series) > 0
            handle = PyPlot.plt."Line2D"(
                (0, 1),
                (0, 0),
                color = py_color(
                    single_color(get_linecolor(series, clims)),
                    get_linealpha(series),
                ),
                linewidth = py_thickness_scale(
                    plt,
                    has_line * sp[:legend_font_pointsize] / 8,
                ),
                linestyle = py_linestyle(:path, get_linestyle(series)),
                solid_capstyle = "butt",
                solid_joinstyle = "miter",
                dash_capstyle = "butt",
                dash_joinstyle = "miter",
                marker = py_marker(_cycle(series[:markershape], 1)),
                markersize = py_thickness_scale(plt, 0.8sp[:legend_font_pointsize]),
                markeredgecolor = py_color(
                    single_color(get_markerstrokecolor(series)),
                    get_markerstrokealpha(series),
                ),
                markerfacecolor = py_color(
                    single_color(get_markercolor(series, clims)),
                    get_markeralpha(series),
                ),
                markeredgewidth = py_thickness_scale(
                    plt,
                    0.8get_markerstrokewidth(series) * sp[:legend_font_pointsize] /
                        first(series[:markersize]),
                ),   # retain the markersize/markerstroke ratio from the markers on the plot
            )
            push!(handles, handle)
        else
            push!(handles, series[:serieshandle][1])
        end
        push!(labels, series[:label])
    end

    # if anything was added, call ax.legend and set the colors
    return if !isempty(handles)
        leg = legend_angle(leg)
        ncol = if (lc = sp[:legend_column]) < 0
            nseries
        elseif lc > 1
            lc == nseries ||
                @warn "n° of legend_column=$lc is not compatible with n° of series=$nseries"
            nseries
        else
            1
        end
        leg = ax."legend"(
            handles,
            labels;
            loc = py_legend_pos(leg),
            bbox_to_anchor = py_legend_bbox(leg),
            scatterpoints = 1,
            fontsize = py_thickness_scale(plt, sp[:legend_font_pointsize]),
            facecolor = py_color(sp[:legend_background_color]),
            edgecolor = py_color(sp[:legend_foreground_color]),
            framealpha = alpha(plot_color(sp[:legend_background_color])),
            fancybox = false,  # makes the legend box square
            borderpad = 0.8,      # to match GR legendbox
            ncol,
        )
        leg."get_frame"()."set_linewidth"(py_thickness_scale(plt, 1))
        leg."set_zorder"(1_000)
        if sp[:legend_title] !== nothing
            leg."set_title"(sp[:legend_title])
            PyPlot.plt."setp"(
                leg."get_title"(),
                color = py_color(sp[:legend_title_font_color]),
                family = sp[:legend_title_font_family],
                fontsize = py_thickness_scale(plt, sp[:legend_title_font_pointsize]),
            )
        end

        for txt in leg."get_texts"()
            PyPlot.plt."setp"(
                txt,
                color = py_color(sp[:legend_font_color]),
                family = sp[:legend_font_family],
                fontsize = py_thickness_scale(plt, sp[:legend_font_pointsize]),
            )
        end
    end
end

# -----------------------------------------------------------------

# Use the bounding boxes (and methods left/top/right/bottom/width/height) `sp.bbox` and `sp.plotarea` to
# position the subplot in the backend.
function _update_plot_object(plt::Plot{PyPlotBackend})
    for sp in plt.subplots
        (ax = sp.o) === nothing && return
        figw, figh = sp.plt[:size]
        figw, figh = figw * px, figh * px
        pcts = bbox_to_pcts(sp.plotarea, figw, figh)
        ax."set_position"(pcts)

        if haskey(sp.attr, :cbar_ax) && RecipesPipeline.is3d(sp)   # 2D plots are completely handled by axis dividers
            bb = sp.attr[:cbar_bbox]
            # this is the bounding box of just the colors of the colorbar (not labels)
            pad = 2mm
            cb_bbox = BoundingBox(
                right(sp.bbox) - 2width(bb) - 2pad,  # x0
                top(sp.bbox) + pad,  # y0
                width(bb),  # width
                height(sp.bbox) - 2pad,  # height
            )
            pcts = get(
                sp[:extra_kwargs],
                "3d_colorbar_axis",
                bbox_to_pcts(cb_bbox, figw, figh),
            )

            sp.attr[:cbar_ax]."set_position"(pcts)
        end
    end
    return PyPlot.draw()
end

# -----------------------------------------------------------------
# display/output

_display(plt::Plot{PyPlotBackend}) = plt.o."show"()

for (mime, fmt) in (
        "application/eps" => "eps",
        "image/eps" => "eps",
        "application/pdf" => "pdf",
        "image/png" => "png",
        "application/postscript" => "ps",
        "image/svg+xml" => "svg",
        "application/x-tex" => "pgf",
    )
    @eval function _show(io::IO, ::MIME{Symbol($mime)}, plt::Plot{PyPlotBackend})
        fig = plt.o
        return fig."canvas"."print_figure"(
            io,
            format = $fmt,
            # bbox_inches = "tight",
            # figsize = map(px2inch, plt[:size]),
            facecolor = fig."get_facecolor"(),
            edgecolor = "none",
            dpi = plt[:dpi],
        )
    end
end

closeall(::PyPlotBackend) = PyPlot.plt."close"("all")

# COV_EXCL_STOP

"""
Holds all data needed for a documentation example... header, description, and plotting expression (Expr)
"""
mutable struct PlotExample
    header::AbstractString
    desc::AbstractString
    external::Bool  # requires external optional dependencies not listed in [deps]
    imports::Union{Nothing, Expr}
    exprs::Expr
end

# COV_EXCL_START
PlotExample(header::AbstractString, expr::Expr) = PlotExample(header, "", expr)
PlotExample(header::AbstractString, imports::Expr, expr::Expr) =
    PlotExample(header, "", false, imports, expr)
PlotExample(header::AbstractString, desc::AbstractString, expr::Expr) =
    PlotExample(header, desc, false, nothing, expr)
PlotExample(header::AbstractString, desc::AbstractString, imports::Expr, expr::Expr) =
    PlotExample(header, desc, false, imports, expr)
# COV_EXCL_STOP

ref_name(i) = "ref" * lpad(i, 3, '0')

# the _examples we'll run for each backend
const _examples = PlotExample[
    PlotExample( # 1
        "Lines",
        "A simple line plot of the columns.",
        :(plot(Plots.fakedata(50, 5), w = 3)),
    ),
    PlotExample( # 2
        "Functions, adding data, and animations",
        """
        Plot multiple functions. You can also put the function first, or use the form `plot(f,
        xmin, xmax)` where f is a Function or AbstractVector{Function}.\n\nGet series data:
        `x, y = plt[i]`.  Set series data: `plt[i] = (x,y)`. Add to the series with
        `push!`/`append!`.\n\nEasily build animations.  (`convert` or `ffmpeg` must be available
        to generate the animation.)  Use command `gif(anim, filename, fps=15)` to save the
        animation.
        """,
        quote
            p = plot([sin, cos], zeros(0), leg = false, xlims = (0, 2π), ylims = (-1, 1))
            anim = Animation()
            for x in range(0, stop = 2π, length = 20)
                push!(p, x, Float64[sin(x), cos(x)])
                frame(anim)
            end
        end,
    ),
    PlotExample( # 3
        "Parametric plots",
        "Plot function pair (x(u), y(u)).",
        :(plot(sin, x -> sin(2x), 0, 2π, line = 4, leg = false, fill = (0, :orange))),
    ),
    PlotExample( # 4
        "Colors",
        """
        Access predefined palettes (or build your own with the `colorscheme` method).
        Line/marker colors are auto-generated from the plot's palette, unless overridden.  Set
        the `z` argument to turn on series gradients.
        """,
        quote
            y = rand(100)
            plot(
                0:10:100,
                rand(11, 4),
                lab = "lines",
                w = 3,
                palette = cgrad(:grays),
                fill = 0,
                α = 0.6,
            )
            scatter!(
                y,
                zcolor = abs.(y .- 0.5),
                m = (:heat, 0.8, Plots.stroke(1, :green)),
                ms = 10 * abs.(y .- 0.5) .+ 4,
                lab = "grad",
            )
        end,
    ),
    PlotExample( # 5
        "Global",
        """
        Change the guides/background/limits/ticks.  Convenience args `xaxis` and `yaxis` allow
        you to pass a tuple or value which will be mapped to the relevant args automatically.
        The `xaxis` below will be replaced with `xlabel` and `xlims` args automatically during
        the preprocessing step. You can also use shorthand functions: `title!`, `xaxis!`,
        `yaxis!`, `xlabel!`, `ylabel!`, `xlims!`, `ylims!`, `xticks!`, `yticks!`
        """,
        :(using Statistics),
        quote
            y = rand(20, 3)
            plot(
                y,
                xaxis = ("XLABEL", (-5, 30), 0:2:20, :flip),
                background_color = RGB(0.2, 0.2, 0.2),
                leg = false,
            )
            hline!(
                mean(y, dims = 1) + rand(1, 3),
                line = (4, :dash, 0.6, [:lightgreen :green :darkgreen]),
            )
            vline!([5, 10])
            title!("TITLE")
            yaxis!("YLABEL", :log10, minorgrid = true)
        end,
    ),
    PlotExample( # 6
        "Images",
        "Plot an image.  y-axis is set to flipped",
        true,
        :(import Downloads, FileIO),
        quote
            path = Downloads.download(
                "http://juliaplots.org/PlotReferenceImages.jl/Plots/pyplot/0.7.0/ref1.png",
            )
            img = FileIO.load(path)
            plot(img)
        end,
    ),
    PlotExample( # 7
        "Arguments",
        """
        Plot multiple series with different numbers of points.  Mix arguments that apply to all
        series (marker/markersize) with arguments unique to each series (colors).  Special
        arguments `line`, `marker`, and `fill` will automatically figure out what arguments to
        set (for example, we are setting the `linestyle`, `linewidth`, and `color` arguments with
        `line`.)  Note that we pass a matrix of colors, and this applies the colors to each
        series.
        """,
        quote
            plot(
                [rand(10), rand(20)],
                color = [:black :orange],
                line = (:dot, 4),
                marker = ([:hex :d], 12, 0.8, Plots.stroke(3, :gray)),
            )
        end,
    ),
    PlotExample( # 8
        "Build plot in pieces",
        "Start with a base plot...",
        :(plot(rand(100) / 3, reg = true, fill = (0, :green))),
    ),
    PlotExample( # 9
        "",
        "and add to it later.",
        :(scatter!(rand(100), markersize = 6, c = :orange)),
    ),
    PlotExample( # 10
        "Histogram2D",
        :(histogram2d(randn(10_000), randn(10_000), nbins = 20)),
    ),
    PlotExample( # 11
        "Line types",
        quote
            linetypes = [:path :steppre :steppost :sticks :scatter]
            n = length(linetypes)
            x = map(_ -> sort(rand(20)), 1:n)
            y = rand(20, n)
            plot(x, y, line = (linetypes, 3), lab = map(string, linetypes), ms = 15)
        end,
    ),
    PlotExample( # 12
        "Line styles",
        quote
            styles = filter(
                s -> s in Plots.supported_styles(),
                [:solid, :dash, :dot, :dashdot, :dashdotdot],
            )
            styles = reshape(styles, 1, length(styles)) # Julia 0.6 unfortunately gives an error when transposing symbol vectors
            plot(
                cumsum(randn(20, length(styles)), dims = 1),
                line = (5, styles),
                label = map(string, styles),
                legendtitle = "linestyle",
            )
        end,
    ),
    PlotExample( # 13
        "Marker types",
        quote
            markers = filter(m -> m in Plots.supported_markers(), Plots._shape_keys)
            markers = permutedims(markers)
            n = length(markers)
            x = range(0, stop = 10, length = n + 2)[2:(end - 1)]
            y = repeat(reshape(reverse(x), 1, :), n, 1)
            scatter(
                x,
                y,
                m = markers,
                markersize = 8,
                lab = map(string, markers),
                bg = :linen,
                xlim = (0, 10),
                ylim = (0, 10),
            )
        end,
    ),
    PlotExample( # 14
        "Bar",
        "`bar(x, y)` plots bars with heights `y` and centers at `x`. `x` defaults to `eachindex(y)`.",
        :(plot(bar(randn(10)), bar([0, 3, 5], [1, 2, 6]), legend = false)),
    ),
    PlotExample( # 15
        "Histogram",
        :(histogram(randn(1_000), bins = :scott, weights = repeat(1:5, outer = 200))),
    ),
    PlotExample( # 16
        "Subplots",
        """
        Use the `layout` keyword, and optionally the convenient `@layout` macro to generate
        arbitrarily complex subplot layouts.
        """,
        quote
            l = @layout([a{0.1h}; b [c; d e]])
            plot(
                randn(100, 5),
                layout = l,
                t = [:line :histogram :scatter :steppre :bar],
                leg = false,
                ticks = nothing,
                border = :none,
            )
        end,
    ),
    PlotExample( # 17
        "Adding to subplots",
        """
        Note here the automatic grid layout, as well as the order in which new series are added
        to the plots.
        """,
        quote
            plot(
                Plots.fakedata(100, 10),
                layout = 4,
                palette = cgrad.([:grays :blues :heat :lightrainbow]),
                bg_inside = [:orange :pink :darkblue :black],
            )
        end,
    ),
    PlotExample( # 18
        "",
        :(using Random),
        quote
            Random.seed!(111)
            plot!(Plots.fakedata(100, 10))
        end,
    ),
    PlotExample( # 19
        "Open/High/Low/Close",
        """
        Create an OHLC chart.  Pass in a list of (open,high,low,close) tuples as your `y`
        argument.  This uses recipes to first convert the tuples to OHLC objects, and
        subsequently create a :path series with the appropriate line segments.
        """,
        quote
            n = 20
            hgt = rand(n) .+ 1
            bot = randn(n)
            openpct = rand(n)
            closepct = rand(n)
            y = OHLC[
                (
                        openpct[i] * hgt[i] + bot[i],
                        bot[i] + hgt[i],
                        bot[i],
                        closepct[i] * hgt[i] + bot[i],
                    ) for i in 1:n
            ]
            ohlc(y)
        end,
    ),
    PlotExample( # 20
        "Annotations",
        """
        The `annotations` keyword is used for text annotations in data-coordinates.
        Pass in a 3-tuple of vectors `(x, y, text)`, or a vector of annotations,
        each of which is a tuple of `x`, `y` and `text`.
        You can position annotations using relative coordinates with the syntax
        `((px, py), text)`, where for example `px=.25` positions the annotation at `25%` of
        the subplot's axis width.
        `text` may be a simple `String`, or a `PlotText` object, which can be built with the
        method `text(string, attrs...)`.
        This wraps font and color attributes and allows you to set text styling.
        `text` may also be a tuple `(string, attrs...)` of arguments which are passed
        to `Plots.text`.

        `annotate!(ann)` is shorthand for `plot!(; annotation=ann)`,
        and `annotate!(x, y, txt)` for `plot!(; annotation=(x,y,txt))`.

        Series annotations are used for annotating individual data points.
        They require only the annotation; x/y values are computed.  Series annotations
        require either plain `String`s or `PlotText` objects.
        """,
        quote
            y = rand(10)
            plot(y, annotations = (3, y[3], Plots.text("this is #3", :left)), leg = false)
            # single vector of annotation tuples
            annotate!(
                [
                    (5, y[5], ("this is #5", 16, :red, :center)),
                    (10, y[10], ("this is #10", :right, 20, "courier")),
                ]
            )
            # `x, y, text` vectors
            annotate!([2, 8], y[[2, 8]], ["#2", "#8"])
            scatter!(
                range(2, stop = 8, length = 6),
                rand(6),
                marker = (50, 0.2, :orange),
                series_annotations = [
                    "series",
                    "annotations",
                    "map",
                    "to",
                    "series",
                    Plots.text("data", :green),
                ],
            )
        end,
    ),
    PlotExample( # 21
        "Custom Markers",
        """A `Plots.Shape` is a light wrapper around vertices of a polygon.  For supported
        backends, pass arbitrary polygons as the marker shapes.  Note: The center is (0,0) and
        the size is expected to be rougly the area of the unit circle.
        """,
        quote
            verts = [
                (-1.0, 1.0),
                (-1.28, 0.6),
                (-0.2, -1.4),
                (0.2, -1.4),
                (1.28, 0.6),
                (1.0, 1.0),
                (-1.0, 1.0),
                (-0.2, -0.6),
                (0.0, -0.2),
                (-0.4, 0.6),
                (1.28, 0.6),
                (0.2, -1.4),
                (-0.2, -1.4),
                (0.6, 0.2),
                (-0.2, 0.2),
                (0.0, -0.2),
                (0.2, 0.2),
                (-0.2, -0.6),
            ]
            plot(
                0.1:0.2:0.9,
                0.7rand(5) .+ 0.15,
                line = (3, :dash, :lightblue),
                marker = (Shape(verts), 30, RGBA(0, 0, 0, 0.2)),
                bg = :pink,
                fg = :darkblue,
                xlim = (0, 1),
                ylim = (0, 1),
                leg = false,
            )
        end,
    ),
    PlotExample( # 22
        "Contours",
        """
        Any value for fill works here.  We first build a filled contour from a function, then an
        unfilled contour from a matrix.
        """,
        quote
            x = 1:0.5:20
            y = 1:0.5:10
            f(x, y) = (3x + y^2) * abs(sin(x) + cos(y))
            X = repeat(reshape(x, 1, :), length(y), 1)
            Y = repeat(y, 1, length(x))
            Z = map(f, X, Y)
            p1 = contour(x, y, f, fill = true)
            p2 = contour(x, y, Z)
            plot(p1, p2)
        end,
    ),
    PlotExample( # 23
        "Pie",
        quote
            x = ["Nerds", "Hackers", "Scientists"]
            y = [0.4, 0.35, 0.25]
            pie(x, y, title = "The Julia Community", l = 0.5)
        end,
    ),
    PlotExample( # 24
        "3D",
        quote
            n = 100
            ts = range(0, stop = 8π, length = n)
            z = 1:n
            plot(
                ts .* map(cos, ts),
                0.1ts .* map(sin, ts),
                z,
                zcolor = reverse(z),
                m = (10, 0.8, :blues, Plots.stroke(0)),
                leg = false,
                cbar = true,
                w = 5,
            )
            plot!(zeros(n), zeros(n), 1:n, w = 10)
        end,
    ),
    PlotExample( # 25
        "DataFrames",
        "Plot using DataFrame column symbols.",
        true,
        :(using StatsPlots, RDatasets),
        quote
            iris = RDatasets.dataset("datasets", "iris")
            @df iris scatter(
                :SepalLength,
                :SepalWidth,
                group = :Species,
                title = "My awesome plot",
                xlabel = "Length",
                ylabel = "Width",
                marker = (0.5, [:cross :hex :star7], 12),
                bg = RGB(0.2, 0.2, 0.2),
            )
        end,
    ),
    PlotExample( # 26
        "Groups and Subplots",
        quote
            group = rand(map(i -> "group $i", 1:4), 100)
            plot(
                rand(100),
                layout = @layout([a b; c]),
                group = group,
                linetype = [:bar :scatter :steppre],
                linecolor = :match,
            )
        end,
    ),
    PlotExample( # 27
        "Polar Plots",
        quote
            Θ = range(0, stop = 1.5π, length = 100)
            r = abs.(0.1 * randn(100) + sin.(3Θ))
            plot(Θ, r, proj = :polar, m = 2)
        end,
    ),
    PlotExample( # 28
        "Heatmap, categorical axes, and aspect_ratio",
        quote
            xs = [string("x", i) for i in 1:10]
            ys = [string("y", i) for i in 1:4]
            z = float((1:4) * reshape(1:10, 1, :))
            heatmap(xs, ys, z, aspect_ratio = 1)
        end,
    ),
    PlotExample( # 29
        "Layouts, margins, label rotation, title location",
        :(using Plots.PlotMeasures),  # for Measures, e.g. mm and px
        quote
            plot(
                rand(100, 6),
                layout = @layout([a b; c]),
                title = ["A" "B" "C"],
                titlelocation = :left,
                left_margin = [20mm 0mm],
                bottom_margin = 10px,
                xrotation = 60,
            )
        end,
    ),
    PlotExample( # 30
        "Boxplot and Violin series recipes",
        "",
        true,
        :(using StatsPlots, RDatasets),
        quote
            singers = RDatasets.dataset("lattice", "singer")
            @df singers violin(:VoicePart, :Height, line = 0, fill = (0.2, :blue))
            @df singers boxplot!(
                :VoicePart,
                :Height,
                line = (2, :black),
                fill = (0.3, :orange),
            )
        end,
    ),
    PlotExample( # 31
        "Animation with subplots",
        "The `layout` macro can be used to create an animation with subplots.",
        quote
            l = @layout([[a; b] c])
            p = plot(
                plot([sin, cos], 1, ylims = (-1, 1), leg = false),
                scatter([atan, cos], 1, ylims = (-1, 1.5), leg = false),
                plot(log, 1, ylims = (0, 2), leg = false),
                layout = l,
                xlims = (1, 2π),
            )

            anim = Animation()
            for x in range(1, stop = 2π, length = 20)
                plot(push!(p, x, Float64[sin(x), cos(x), atan(x), cos(x), log(x)]))
                frame(anim)
            end
        end,
    ),
    PlotExample( # 32
        "Spy",
        """
        For a matrix `mat` with unique nonzeros `spy(mat)` returns a colorless plot. If `mat` has
        various different nonzero values, a colorbar is added. The colorbar can be disabled with
        `legend = nothing`.
        """,
        :(using SparseArrays),
        quote
            a = spdiagm(
                0 => ones(50),
                1 => ones(49),
                -1 => ones(49),
                10 => ones(40),
                -10 => ones(40),
            )
            b = spdiagm(0 => 1:50, 1 => 1:49, -1 => 1:49, 10 => 1:40, -10 => 1:40)
            plot(spy(a), spy(b), title = ["Unique nonzeros" "Different nonzeros"])
        end,
    ),
    PlotExample( # 33
        "Magic grid argument",
        "The grid lines can be modified individually for each axis with the magic `grid` argument.",
        quote
            x = rand(10)
            p1 = plot(x, title = "Default looks")
            p2 = plot(x, grid = (:y, :olivedrab, :dot, 1, 0.9), title = "Modified y grid")
            p3 = plot(deepcopy(p2), title = "Add x grid")
            xgrid!(p3, :on, :cadetblue, 2, :dashdot, 0.4)
            plot(p1, p2, p3, layout = (1, 3), label = "", fillrange = 0, fillalpha = 0.3)
        end,
    ),
    PlotExample( # 34
        "Framestyle",
        """
        The style of the frame/axes of a (sub)plot can be changed with the `framestyle`
        attribute. The default framestyle is `:axes`.
        """,
        quote
            scatter(
                fill(randn(10), 6),
                fill(randn(10), 6),
                framestyle = [:box :semi :origin :zerolines :grid :none],
                title = [":box" ":semi" ":origin" ":zerolines" ":grid" ":none"],
                color = permutedims(1:6),
                layout = 6,
                label = "",
                markerstrokewidth = 0,
                ticks = -2:2,
            )
        end,
    ),
    PlotExample( # 35
        "Lines and markers with varying colors",
        """
        You can use the `line_z` and `marker_z` properties to associate a color with
        each line segment or marker in the plot.
        """,
        quote
            t = range(0, stop = 1, length = 100)
            θ = 6π .* t
            x = t .* cos.(θ)
            y = t .* sin.(θ)
            p1 = plot(x, y, line_z = t, linewidth = 3, legend = false)
            p2 = scatter(x, y, marker_z = +, color = :bluesreds, legend = false)
            plot(p1, p2)
        end,
    ),
    PlotExample( # 36
        "Portfolio Composition maps",
        "see: https://stackoverflow.com/a/37732384",
        :(using Random),
        quote
            Random.seed!(111)
            tickers = ["IBM", "Google", "Apple", "Intel"]
            N, D = 10, length(tickers)
            weights = rand(N, D)
            weights ./= sum(weights, dims = 2)
            returns = sort!((1:N) + D * randn(N))

            portfoliocomposition(weights, returns, labels = permutedims(tickers))
        end,
    ),
    PlotExample( # 37
        "Ribbons",
        """
        Ribbons can be added to lines via the `ribbon` keyword;
        you can pass a tuple of arrays (lower and upper bounds, in this order),
        a single Array (for symmetric ribbons), a Function, or a number.
        """,
        quote
            plot(
                plot(0:10; ribbon = (LinRange(0, 2, 11), LinRange(0, 1, 11))),
                plot(0:10; ribbon = 0:0.5:5),
                plot(0:10; ribbon = sqrt),
                plot(0:10; ribbon = 1),
            )
        end,
    ),
    PlotExample( # 38
        "Histogram2D (complex values)",
        "",
        quote
            n = 10_000
            x = exp.(0.1 * randn(n) .+ randn(n) .* (im))
            histogram2d(
                x,
                nbins = (20, 40),
                show_empty_bins = true,
                normed = true,
                aspect_ratio = 1,
            )
        end,
    ),
    PlotExample( # 39
        "Unconnected lines using `missing` or `NaN`",
        """
        Missing values and non-finite values, including `NaN`, are not plotted.
        Instead, lines are separated into segments at these values.
        """,
        quote
            x, y = [1, 2, 2, 1, 1], [1, 2, 1, 2, 1]
            plot(
                plot([rand(5); NaN; rand(5); NaN; rand(5)]),
                plot([1, missing, 2, 3], marker = true),
                plot([x; NaN; x .+ 2], [y; NaN; y .+ 1], arrow = 2),
                plot([1, 2 + 3im, Inf, 4im, 3, -Inf * im, 0, 3 + 3im], marker = true),
                legend = false,
            )
        end,
    ),
    PlotExample( # 40
        "Lens",
        "A lens lets you easily magnify a region of a plot. x and y coordinates refer to the to be magnified region and the via the `inset` keyword the subplot index and the bounding box (in relative coordinates) of the inset plot with the magnified plot can be specified. Additional attributes count for the inset plot.",
        quote
            plot(
                [(0, 0), (0, 0.9), (1, 0.9), (2, 1), (3, 0.9), (80, 0)],
                legend = :outertopright,
                minorgrid = true,
                minorticks = 2,
            )
            plot!([(0, 0), (0, 0.9), (2, 0.9), (3, 1), (4, 0.9), (80, 0)])
            plot!([(0, 0), (0, 0.9), (3, 0.9), (4, 1), (5, 0.9), (80, 0)])
            plot!([(0, 0), (0, 0.9), (4, 0.9), (5, 1), (6, 0.9), (80, 0)])
            lens!([1, 6], [0.9, 1.1], inset = (1, bbox(0.5, 0.0, 0.4, 0.4)))
        end,
    ),
    PlotExample( # 41
        "Array Types",
        "Plots supports different `Array` types that follow the `AbstractArray` interface, like `StaticArrays` and `OffsetArrays`.",
        true,
        :(using StaticArrays, OffsetArrays),
        quote
            sv = SVector{10}(rand(10))
            ov = OffsetVector(rand(10), -2)
            plot(Any[sv, ov], label = ["StaticArray" "OffsetArray"])
            plot!(3ov, ribbon = ov, label = "OffsetArray ribbon")
        end,
    ),
    PlotExample( # 42
        "Setting defaults and font arguments",
        quote
            default(
                titlefont = (20, "times"),
                legendfontsize = 18,
                guidefont = (18, :darkgreen),
                tickfont = (12, :orange),
                guide = "x",
                framestyle = :zerolines,
                yminorgrid = true,
            )
            plot(
                [sin, cos],
                -2π,
                2π,
                label = ["sin(θ)" "cos(θ)"],
                title = "Trigonometric Functions",
                xlabel = "θ",
                linewidth = 2,
                legend = :outertopleft,
            )
        end,
    ),
    PlotExample( # 43
        "Heatmap with DateTime axis",
        :(using Dates),
        :(heatmap(DateTime.(2016:2020), 1:5, rand(5, 5))),
    ),
    PlotExample( # 44
        "Linked axes",
        quote
            x = -5:0.1:5
            plot(plot(x, x -> x^2), plot(x, x -> sin(x)), layout = 2, link = :y)
        end,
    ),
    PlotExample( # 45
        "Error bars and array type recipes",
        quote
            struct Measurement <: Number
                val::Float64
                err::Float64
            end
            value(m::Measurement) = m.val
            uncertainty(m::Measurement) = m.err

            @recipe function f(::Type{T}, m::T) where {T <: AbstractArray{<:Measurement}}
                if !(
                        get(plotattributes, :seriestype, :path) in (
                            :contour,
                            :contourf,
                            :contour3d,
                            :heatmap,
                            :surface,
                            :wireframe,
                            :image,
                        )
                    )
                    error_sym = Symbol(plotattributes[:letter], :error)
                    plotattributes[error_sym] = uncertainty.(m)
                end
                value.(m)
            end
        end,
        quote
            x = Measurement.(10sort(rand(10)), rand(10))
            y = Measurement.(10sort(rand(10)), rand(10))
            z = Measurement.(10sort(rand(10)), rand(10))
            surf = Measurement.((1:10) .* (1:10)', rand(10, 10))

            plot(
                scatter(x, [x y]),
                scatter(x, y, z),
                heatmap(x, y, surf),
                wireframe(x, y, surf),
                legend = :topleft,
            )
        end,
    ),
    PlotExample( # 46
        "Tuples and `Point`s as data",
        "",
        true,
        :(using GeometryBasics, Distributions),
        quote
            d = MvNormal([1.0 0.75; 0.75 2.0])
            plot([(1, 2), (3, 2), (2, 1), (2, 3)])
            scatter!(Point2.(eachcol(rand(d, 1_000))), alpha = 0.25)
        end,
    ),
    PlotExample( # 47
        "Mesh3d",
        """
        Allows to plot arbitrary 3d meshes. If only x,y,z are given the mesh is generated automatically.
        You can also specify the connections using the connections keyword.
        The connections can be specified in two ways: Either as a tuple of vectors where each vector
        contains the 0-based indices of one point of a triangle, such that elements at the same
        position of these vectors form a triangle. Or as a vector of NTuple{3,Ints} where each element
        contains the 1-based indices of the three points of a triangle.
        """,
        quote
            # specify the vertices
            x = [0, 1, 2, 0]
            y = [0, 0, 1, 2]
            z = [0, 2, 0, 1]

            # specify the triangles
            # every column is one triangle,
            # where the values denote the indices of the vertices of the triangle
            i = [0, 0, 0, 1]
            j = [1, 2, 3, 2]
            k = [2, 3, 1, 3]
            # Or: cns = [(1, 2, 3), (1, 3, 4), (1, 4, 2), (2, 3, 4)] (1-based indexing)

            # the four triangles gives above give a tetrahedron
            mesh3d(
                x,
                y,
                z;
                connections = (i, j, k), # connections = cns
                title = "triangles",
                xlabel = "x",
                ylabel = "y",
                zlabel = "z",
                legend = :none,
                margin = 2Plots.mm,
            )
        end,
    ),
    PlotExample( # 48
        "Vectors of markershapes and segments",
        :(using Base.Iterators: cycle, take),
        quote
            yv = ones(9)
            ys = [1; 1; NaN; ones(6)]
            y = 5 .- [yv 2ys 3yv 4ys]

            plt_color_rows = plot(
                y,
                seriestype = [:path :path :scatter :scatter],
                markershape = collect(take(cycle((:utriangle, :rect)), 9)),
                markersize = 8,
                color = collect(take(cycle((:red, :black)), 9)),
            )

            plt_z_cols = plot(
                y,
                markershape = [:utriangle :x :circle :square],
                markersize = [5 10 10 5],
                marker_z = [5 4 3 2],
                line_z = [1 3 3 1],
                linewidth = [1 10 5 1],
            )

            plot(plt_color_rows, plt_z_cols)
        end,
    ),
    PlotExample( # 49
        "Polar heatmaps",
        quote
            θ = range(0, 2π; length = 100)
            ρ = range(0, 120; length = 50)
            z = sin.(ρ ./ 10) .* cos.(θ)'
            heatmap(
                θ,
                ρ,
                z;
                projection = :polar,
                color = :cividis,
                right_margin = 2Plots.mm,
            )
        end,
    ),
    PlotExample( # 50
        "3D surface with axis guides",
        quote
            xs = collect(0.1:0.05:2.0)
            ys = collect(0.2:0.1:2.0)

            X = [x for x in xs for _ in ys]
            Y = [y for _ in xs for y in ys]

            Z = (x, y) -> 1 / x + y * x^2

            surface(
                X,
                Y,
                Z.(X, Y),
                xlabel = "longer xlabel",
                ylabel = "longer ylabel",
                zlabel = "longer zlabel",
            )
        end,
    ),
    PlotExample( # 51
        "Images with custom axes",
        "",
        true,
        :(using TestImages),
        quote
            img = testimage("lighthouse")

            # plot the image reversing the first dimension and setting yflip = false
            plot(
                [-π, π],
                [-1, 1],
                reverse(img, dims = 1),
                yflip = false,
                aspect_ratio = :none,
            )
            # plot other data
            plot!(sin, -π, π, lw = 3, color = :red)
        end,
    ),
    PlotExample( # 52
        "3d quiver",
        quote
            ϕs = range(-π, π, length = 50)
            θs = range(0, π, length = 25)
            θqs = range(1, π - 1, length = 25)

            x = vec([sin(θ) * cos(ϕ) for (ϕ, θ) in Iterators.product(ϕs, θs)])
            y = vec([sin(θ) * sin(ϕ) for (ϕ, θ) in Iterators.product(ϕs, θs)])
            z = vec([cos(θ) for (ϕ, θ) in Iterators.product(ϕs, θs)])

            u = 0.1vec([sin(θ) * cos(ϕ) for (ϕ, θ) in Iterators.product(ϕs, θqs)])
            v = 0.1vec([sin(θ) * sin(ϕ) for (ϕ, θ) in Iterators.product(ϕs, θqs)])
            w = 0.1vec([cos(θ) for (ϕ, θ) in Iterators.product(ϕs, θqs)])

            quiver(x, y, z, quiver = (u, v, w))
        end,
    ),
    PlotExample( # 53
        "Step Types",
        "A comparison of the various step-like `seriestype`s",
        quote
            x = 1:5
            y = [1, 2, 3, 2, 1]
            default(shape = :circle)
            plot(
                plot(x, y, markershape = :circle, seriestype = :steppre, label = "steppre"),
                plot(x, y, markershape = :circle, seriestype = :stepmid, label = "stepmid"),
                plot(
                    x,
                    y,
                    markershape = :circle,
                    seriestype = :steppost,
                    label = "steppost",
                ),
                layout = (3, 1),
            )
        end,
    ),
    PlotExample( # 54
        "Guide positions and alignment",
        quote
            plot(
                rand(10, 4),
                layout = 4,
                xguide = "x guide",
                yguide = "y guide",
                xguidefonthalign = [:left :right :right :left],
                yguidefontvalign = [:top :bottom :bottom :top],
                xguideposition = :top,
                yguideposition = [:right :left :right :left],
                ymirror = [false true true false],
                xmirror = [false false true true],
                legend = false,
                seriestype = [:bar :scatter :path :stepmid],
            )
        end,
    ),
    PlotExample( # 55
        "3D axis flip / mirror",
        :(using LinearAlgebra),
        quote
            Plots.with(scalefonts = 0.5) do
                x, y = collect(-6:0.5:10), collect(-8:0.5:8)

                args = x, y, (x, y) -> sinc(norm([x, y]) / π)
                kw = (
                    xlabel = "x",
                    ylabel = "y",
                    zlabel = "z",
                    grid = true,
                    minorgrid = true,
                )

                plots = [wireframe(args..., title = "wire"; kw...)]

                for ax in (:x, :y, :z)
                    push!(
                        plots,
                        wireframe(
                            args...,
                            title = "wire-flip-$ax",
                            xflip = ax === :x,
                            yflip = ax === :y,
                            zflip = ax === :z;
                            kw...,
                        ),
                    )
                end

                for ax in (:x, :y, :z)
                    push!(
                        plots,
                        wireframe(
                            args...,
                            title = "wire-mirror-$ax",
                            xmirror = ax === :x,
                            ymirror = ax === :y,
                            zmirror = ax === :z;
                            kw...,
                        ),
                    )
                end

                plot(
                    plots...,
                    layout = (@layout [_ ° _; ° ° °; ° ° °]),
                    margin = 0Plots.px,
                )
            end
        end,
    ),
    PlotExample( # 56
        "Bar plot customizations",
        """
        Width of bars may be specified as `bar_width`.
        The bars' baseline may be specified as `fillto`.
        Each may be scalar, or a vector specifying one value per bar.
        """,
        quote
            plot(
                bar(
                    [-1, 0, 2, 3],
                    [1, 3, 6, 2],
                    fill_z = 4:-1:1,
                    alpha = [1, 0.2, 0.8, 0.5],
                    label = "",
                    bar_width = 1:4,
                ),
                bar(
                    rand(5),
                    bar_width = 1.2,
                    alpha = 0.8,
                    color = [:lightsalmon, :tomato, :crimson, :firebrick, :darkred],
                    fillto = 0:-0.1:-0.4,
                    label = "reds",
                ),
            )
        end,
    ),
    PlotExample( # 57
        "Vertical and horizontal spans",
        "`vspan` and `hspan` can be used to shade horizontal and vertical ranges.",
        quote
            hspan([1, 2, 3, 4]; label = "hspan", legend = :topleft)
            vspan!([2, 3]; alpha = 0.5, label = "vspan")
            plot!([0, 2, 3, 5], [-1, 3, 2, 6]; c = :black, lw = 2, label = "line")
        end,
    ),
    PlotExample( # 58
        "Stacked area chart",
        "`areaplot` draws stacked area plots.",
        quote
            areaplot(
                1:3,
                [1 2 3; 7 8 9; 4 5 6],
                seriescolor = [:red :green :blue],
                fillalpha = [0.2 0.3 0.4],
            )
        end,
    ),
    PlotExample( # 59
        "Annotations at discrete locations",
        quote
            x, y = ["a", "b", "c"], [1, 5, 15]
            p = scatter(["a", "b"], ["q", "r"], ms = 8, legend = false, tickfontsize = 20)
            annotate!(
                ["a", "b"],
                ["r", "q"],
                [text("ar", :top, :left, 50), text("bq", :bottom, :right, 20)],
            )
        end,
    ),
    PlotExample( # 60
        "3D projection",
        "3D plots projection: orthographic (isometric) and perspective (fps).",
        quote
            # 3d cube segments
            x = [
                [-1, +1],
                [-1, -1],
                [-1, +1],
                [+1, +1],
                [+1, +1],
                [-1, -1],
                [-1, -1],
                [+1, +1],
                [-1, +1],
                [-1, -1],
                [-1, +1],
                [+1, +1],
            ]
            y = [
                [+1, +1],
                [-1, +1],
                [-1, -1],
                [-1, +1],
                [+1, +1],
                [+1, +1],
                [-1, -1],
                [-1, -1],
                [+1, +1],
                [-1, +1],
                [-1, -1],
                [-1, +1],
            ]
            z = [
                [+1, +1],
                [+1, +1],
                [+1, +1],
                [+1, +1],
                [-1, +1],
                [-1, +1],
                [-1, +1],
                [-1, +1],
                [-1, -1],
                [-1, -1],
                [-1, -1],
                [-1, -1],
            ]
            kw = (
                aspect_ratio = :equal,
                label = :none,
                xlabel = "x",
                ylabel = "y",
                zlabel = "z",
                xlims = (-1.1, 1.1),
                ylims = (-1.1, 1.1),
                zlims = (-1.1, 1.1),
            )
            plot(
                plot(
                    x,
                    y,
                    z;
                    proj_type = :ortho,
                    title = "orthographic (isometric)",
                    camera = (45, round(atand(1 / √2); digits = 3)),
                    kw...,
                ),
                plot(
                    x,
                    y,
                    z;
                    proj_type = :persp,
                    title = "perspective (fps)",
                    camera = (0, 0),
                    kw...,
                ),
            )
        end,
    ),
    PlotExample(  # 61
        "Bézier curve",
        :(curves([1, 2, 3, 4], [1, 1, 2, 4], title = "Bézier curve")),
    ),
    PlotExample(  # 62
        "Filled area - hatched patterns",
        "Plot hatched regions.",
        quote
            y = rand(10)
            plot(y .+ 1, fillrange = y, fillstyle = :/)
        end,
    ),
    PlotExample(  # 63
        "Shared axes (twin)",
        "`twinx` (shared `x` axis) and `twiny` (shared `y` axis) example usage.",
        quote
            kw = (; lab = "", title_loc = :left)
            x = π:0.1:(2π)

            plot(
                x,
                sin.(x),
                xaxis = "common X label",
                yaxis = "Y label 1",
                color = :red,
                title = "twinx";
                kw...,
            )
            pl = plot!(twinx(), x, 2cos.(x), yaxis = "Y label 2"; kw...)

            plot(
                x,
                cos.(x),
                xaxis = "X label 1",
                yaxis = "common Y label",
                color = :red,
                title = "twiny";
                kw...,
            )
            pr = plot!(twiny(), 2x, cos.(2x), xaxis = "X label 2"; kw...)

            plot(pl, pr)
        end,
    ),
    PlotExample(  # 64
        "Legend positions",
        "Horizontal or vertical legends, at different locations.",
        quote
            legs = (
                :topleft,
                :top,
                :topright,
                :left,
                :inside,
                :right,
                :bottomleft,
                :bottom,
                :bottomright,
            )
            leg_plots(; kw...) = map(
                leg -> plot(
                    [0:1, reverse(0:1)];
                    marker = :circle,
                    ticks = :none,
                    leg_title = leg,
                    leg,
                    kw...,
                ),
                legs,
            )
            w, h = Plots._plot_defaults[:size]
            Plots.with(scalefonts = 0.5, size = (2w, 2h)) do
                plot(leg_plots()..., leg_plots(legend_column = -1)...; layout = (6, 3))
            end
        end,
    ),
    PlotExample(  # 65
        "Outer legend positions",
        "Horizontal or vertical legends, at different locations.",
        quote
            legs = (
                :topleft,
                :top,
                :topright,
                :left,
                nothing,
                :right,
                :bottomleft,
                :bottom,
                :bottomright,
            )
            leg_plots(; kw...) = map(
                leg -> plot(
                    [0:1, reverse(0:1)];
                    marker = :circle,
                    ticks = :none,
                    leg_title = leg,
                    leg = leg isa Symbol ? Symbol(:outer, leg) : :none,
                    kw...,
                ),
                legs,
            )
            w, h = Plots._plot_defaults[:size]
            Plots.with(scalefonts = 0.5, size = (2w, 2h)) do
                plot(leg_plots()..., leg_plots(legend_column = -1)...; layout = (6, 3))
            end
        end,
    ),
    PlotExample( # 66
        "Specifying edges and missing values for barplots",
        "In `bar(x, y)`, `x` may be the same length as `y` to specify bar centers, or one longer to specify bar edges.",
        :(
            plot(
                bar(-5:5, randn(10)),                  # bar edges at -5:5
                bar(-2:2, [2, -2, NaN, -1, 1], color = 1:5), # bar centers at -2:2, one missing value
                legend = false,
            )
        ),
    ),
]

# Some constants for PlotDocs and PlotReferenceImages
_animation_examples = [2, 31]
_backend_skips = Dict(
    :gr => [],
    :pyplot => [],
    :plotlyjs => [
        21,
        24,
        25,
        30,
        49,
        50,
        51,
        55,
        56,
        62,
        63,  # twin axes unsupported
        64,  # legend pos unsupported
        65,  # legend pos unsupported
        66,  # bar: vector-valued `color` unsupported
    ],
    :pgfplotsx => [
        6,  # images
        16,  # pgfplots thinks the upper panel is too small
        32,  # spy
        49,  # polar heatmap
        51,  # image with custom axes
        56,  # custom bar plot
        62,  # fillstyle unsupported
    ],
    :inspectdr => [
        4,
        6,
        10,
        22,
        24,
        28,
        30,
        38,
        43,
        45,
        47,
        48,
        49,
        50,
        51,
        55,
        56,
        60,
        62,
        63,
        64,
        65,
    ],
    :unicodeplots => [
        5,  # limits issue
        6,  # embedded images supported, but requires `using ImageInTerminal`, disable for docs
        16,  # nested layout unsupported
        21,  # custom markers unsupported
        26,  # nested layout unsupported
        29,  # nested layout unsupported
        31,  # nested layout unsupported
        33,  # grid lines unsupported
        34,  # framestyle unsupported
        37,  # ribbons / filled unsupported
        43,  # heatmap with DateTime
        45,  # error bars
        49,  # polar heatmap
        51,  # drawing on top of image unsupported
        55,  # mirror unsupported, resolution too low
        56,  # barplots
        62,  # fillstyle
        63,  # twin axes unsupported
        64,  # legend pos unsupported
        65,  # legend pos unsupported
    ],
    :gaston => [
        31,  # animations - needs github.com/mbaz/Gaston.jl/pull/178
        49,  # TODO: support polar
        60,  # :perspective projection unsupported
        63,  # FXIME: twin axes misalignement
    ],
)
_backend_skips[:plotly] = _backend_skips[:plotlyjs]
_backend_skips[:pythonplot] = _backend_skips[:pyplot]

# ---------------------------------------------------------------------------------
# replace `f(args...)` with `f(rng, args...)` for `f ∈ (rand, randn)`
replace_rand(ex) = ex

function replace_rand(ex::Expr)
    expr = Expr(ex.head)
    foreach(arg -> push!(expr.args, replace_rand(arg)), ex.args)
    if Meta.isexpr(ex, :call) && ex.args[1] ∈ (:rand, :randn, :(Plots.fakedata))
        pushfirst!(expr.args, ex.args[1])
        expr.args[2] = :rng
    end
    return expr
end

# make and display one plot
test_examples(i::Integer; kw...) = test_examples(backend_name(), i; kw...)

function test_examples(
        pkgname::Symbol,
        i::Integer;
        debug = false,
        disp = false,
        rng = nothing,
        callback = nothing,
    )
    @info "Testing plot: $pkgname:$i:$(_examples[i].header)"

    m = Module(Symbol(:PlotsExamples, pkgname))

    # prevent leaking variables (esp. functions) directly into Plots namespace
    Base.eval(
        m, quote
            using Random
            using Plots
            Plots.debug!($debug)
            backend($(QuoteNode(pkgname)))
            rng = $rng
            rng === nothing || Random.seed!(rng, Plots.PLOTS_SEED)
            theme(:default)
        end
    )
    (imp = _examples[i].imports) === nothing || Base.eval(m, imp)
    exprs = _examples[i].exprs
    rng === nothing || (exprs = Plots.replace_rand(exprs))
    Base.eval(m, exprs)

    disp && Base.eval(m, :(gui(current())))
    callback === nothing || Base.invokelatest(callback, m, pkgname, i)
    return Base.eval(m, :(current()))
end

# generate all plots and create a dict mapping idx --> plt
"""
test_examples(pkgname[, idx]; debug=false, disp=false, sleep=nothing, skip=[], only=nothing, callback=nothing)

Run the `idx` test example for a given backend, or all examples if `idx` is not specified.
"""
function test_examples(
        pkgname::Symbol;
        debug = false,
        disp = false,
        sleep = nothing,
        skip = [],
        only = nothing,
        callback = nothing,
        strict = false,
    )
    plts = Dict()
    for i in eachindex(_examples)
        i ∈ something(only, (i,)) || continue
        i ∈ skip && continue
        try
            plts[i] = test_examples(pkgname, i; debug, disp, callback)
        catch ex
            # COV_EXCL_START
            if strict
                rethrow(ex)
            else
                @warn "Example $pkgname:$i:$(_examples[i].header) failed with: $ex"
            end
            # COV_EXCL_STOP
        end
        sleep === nothing || Base.sleep(sleep)
    end
    return plts
end

# xaxis(args...; kw...) = Axis(:x, args...; kw...)
# yaxis(args...; kw...) = Axis(:y, args...; kw...)
# zaxis(args...; kw...) = Axis(:z, args...; kw...)

# -------------------------------------------------------------------------

function Axis(sp::Subplot, letter::Symbol, args...; kw...)
    explicit = KW(
        :letter => letter,
        :extrema => Extrema(),
        :discrete_map => Dict(),   # map discrete values to discrete indices
        :continuous_values => zeros(0),
        :discrete_values => [],
        :use_minor => false,
        :show => true,  # show or hide the axis? (useful for linked subplots)
    )

    attr = DefaultsDict(explicit, _axis_defaults_byletter[letter])

    # update the defaults
    return attr!(Axis([sp], attr), args...; kw...)
end

function get_axis(sp::Subplot, letter::Symbol)
    axissym = get_attr_symbol(letter, :axis)
    return if haskey(sp.attr, axissym)
        sp.attr[axissym]
    else
        sp.attr[axissym] = Axis(sp, letter)
    end::Axis
end

function process_axis_arg!(plotattributes::AKW, arg, letter = "")
    T = typeof(arg)
    arg = get(_scaleAliases, arg, arg)
    return if typeof(arg) <: Font
        plotattributes[get_attr_symbol(letter, :tickfont)] = arg
        plotattributes[get_attr_symbol(letter, :guidefont)] = arg

    elseif arg in _allScales
        plotattributes[get_attr_symbol(letter, :scale)] = arg

    elseif arg in (:flip, :invert, :inverted)
        plotattributes[get_attr_symbol(letter, :flip)] = true

    elseif T <: AbstractString
        plotattributes[get_attr_symbol(letter, :guide)] = arg

        # xlims/ylims
    elseif (T <: Tuple || T <: AVec) && length(arg) == 2
        sym = typeof(arg[1]) <: Number ? :lims : :ticks
        plotattributes[get_attr_symbol(letter, sym)] = arg

        # xticks/yticks
    elseif T <: AVec
        plotattributes[get_attr_symbol(letter, :ticks)] = arg

    elseif arg === nothing
        plotattributes[get_attr_symbol(letter, :ticks)] = []

    elseif T <: Bool || arg in _allShowaxisArgs
        plotattributes[get_attr_symbol(letter, :showaxis)] = showaxis(arg, letter)

    elseif typeof(arg) <: Number
        plotattributes[get_attr_symbol(letter, :rotation)] = arg

    elseif typeof(arg) <: Function
        plotattributes[get_attr_symbol(letter, :formatter)] = arg

    elseif !handleColors!(
            plotattributes,
            arg,
            get_attr_symbol(letter, :foreground_color_axis),
        )
        @warn "Skipped $(letter)axis arg $arg"
    end
end

# update an Axis object with magic args and keywords
function attr!(axis::Axis, args...; kw...)
    # first process args
    plotattributes = axis.plotattributes
    foreach(arg -> process_axis_arg!(plotattributes, arg), args)

    # then preprocess keyword arguments
    Plots.preprocess_attributes!(KW(kw))

    # then override for any keywords... only those keywords that already exists in plotattributes
    for (k, v) in kw
        haskey(plotattributes, k) || continue
        if k === :discrete_values
            foreach(x -> discrete_value!(axis, x), v)  # add these discrete values to the axis
        elseif k === :lims && isa(v, NTuple{2, TimeType})
            plotattributes[k] = (Dates.value(v[1]), Dates.value(v[2]))
        elseif k === :guide && v isa AbstractString && isempty(v) &&
                !haskey(kw, :unitformat)
            plotattributes[:unitformat] = :nounit
            plotattributes[k] = v
        elseif k === :unit
            if !isnothing(plotattributes[k]) && plotattributes[k] != v
                @warn "Overriding unit for $(axis[:letter]) axis: $(plotattributes[k]) -> $v.  This will produce a plot, but series plotted before the override cannot update and will therefore be incorrectly treated as if they had the new units."
            end
            plotattributes[k] = v
        else
            plotattributes[k] = v
        end
    end

    # replace scale aliases
    if haskey(_scaleAliases, plotattributes[:scale])
        plotattributes[:scale] = _scaleAliases[plotattributes[:scale]]
    end

    return axis
end

# -------------------------------------------------------------------------

Base.show(io::IO, axis::Axis) = dumpdict(io, axis.plotattributes, "Axis")
ignorenan_extrema(axis::Axis) = (ex = axis[:extrema]; (ex.emin, ex.emax))

get_guide(axis::Axis) = if isnothing(axis[:guide])
    ""
elseif isnothing(axis[:unit]) || axis[:guide] isa ProtectedString ||
        axis[:unitformat] ≡ :nounit
    axis[:guide]
else
    unit = if axis[:unitformat] isa Function
        axis[:unit]
    elseif Plots.backend_name() ≡ :pgfplotsx
        Latexify.latexify(axis[:unit])
    else
        string(axis[:unit])
    end
    isempty(string(axis[:guide])) && return unit
    format_unit_label(axis[:guide], unit, axis[:unitformat])
end


# Keyword options for unit formats
const UNIT_FORMATS = Dict(
    :round => ('(', ')'),
    :square => ('[', ']'),
    :curly => ('{', '}'),
    :angle => ('<', '>'),
    :slash => '/',
    :slashround => (" / (", ")"),
    :slashsquare => (" / [", "]"),
    :slashcurly => (" / {", "}"),
    :slashangle => (" / <", ">"),
    :verbose => " in units of ",
    :none => nothing,
    :nounit => (l, u) -> l
)

# All options for unit formats
format_unit_label(l, u, f::Nothing) = string(l, ' ', u)
format_unit_label(l, u, f::Function) = f(l, u)
format_unit_label(l, u, f::AbstractString) = string(l, f, u)
format_unit_label(l, u, f::NTuple{2, <:AbstractString}) = string(l, f[1], u, f[2])
format_unit_label(l, u, f::NTuple{3, <:AbstractString}) = string(f[1], l, f[2], u, f[3])
format_unit_label(l, u, f::Char) = string(l, ' ', f, ' ', u)
format_unit_label(l, u, f::NTuple{2, Char}) = string(l, ' ', f[1], u, f[2])
format_unit_label(l, u, f::NTuple{3, Char}) = string(f[1], l, ' ', f[2], u, f[3])
format_unit_label(l, u, f::Bool) = f ? format_unit_label(l, u, :round) : format_unit_label(l, u, nothing)
format_unit_label(l, u, f::Symbol) = format_unit_label(l, u, UNIT_FORMATS[f])

const _label_func =
    Dict{Symbol, Function}(:log10 => x -> "10^$x", :log2 => x -> "2^$x", :ln => x -> "e^$x")
labelfunc(scale::Symbol, backend::AbstractBackend) = get(_label_func, scale, string)

const _label_func_tex = Dict{Symbol, Function}(
    :log10 => x -> "10^{$x}",
    :log2 => x -> "2^{$x}",
    :ln => x -> "e^{$x}",
)
labelfunc_tex(scale::Symbol) = get(_label_func_tex, scale, convert_sci_unicode)

function optimal_ticks_and_labels(ticks, alims, scale, formatter)
    amin, amax = alims

    # scale the limits
    sf, invsf, noop = scale_inverse_scale_func(scale)

    # If the axis input was a Date or DateTime use a special logic to find
    # "round" Date(Time)s as ticks
    # This bypasses the rest of optimal_ticks_and_labels, because
    # optimize_datetime_ticks returns ticks AND labels: the label format (Date
    # or DateTime) is chosen based on the time span between amin and amax
    # rather than on the input format
    # TODO: maybe: non-trivial scale (:ln, :log2, :log10) for date/datetime

    if ticks === nothing && noop
        if formatter == RecipesPipeline.dateformatter
            # optimize_datetime_ticks returns ticks and labels(!) based on
            # integers/floats corresponding to the DateTime type. Thus, the axes
            # limits, which resulted from converting the Date type to integers,
            # are converted to 'DateTime integers' (actually floats) before
            # being passed to optimize_datetime_ticks.
            # (convert(Int, convert(DateTime, convert(Date, i))) == 87600000*i)
            ticks, labels =
                optimize_datetime_ticks(864.0e5 * amin, 864.0e5 * amax; k_min = 2, k_max = 4)
            # Now the ticks are converted back to floats corresponding to Dates.
            return ticks / 864.0e5, labels
        elseif formatter == RecipesPipeline.datetimeformatter
            return optimize_datetime_ticks(amin, amax; k_min = 2, k_max = 4)
        end
    end

    # get a list of well-laid-out ticks
    scaled_ticks = if ticks === nothing
        optimize_ticks(
            sf(amin),
            sf(amax);
            k_min = scale ∈ _logScales ? 2 : 4, # minimum number of ticks
            k_max = 8, # maximum number of ticks
            scale,
        ) |> first
    elseif typeof(ticks) <: Int
        optimize_ticks(
            sf(amin),
            sf(amax);
            k_min = ticks, # minimum number of ticks
            k_max = ticks, # maximum number of ticks
            k_ideal = ticks,
            # `strict_span = false` rewards cases where the span of the
            # chosen  ticks is not too much bigger than amin - amax:
            strict_span = false,
            scale,
        ) |> first
    else
        map(sf, filter(t -> amin ≤ t ≤ amax, ticks))
    end
    unscaled_ticks = noop ? scaled_ticks : map(invsf, scaled_ticks)

    labels::Vector{String} = if any(isfinite, unscaled_ticks)
        get_labels(formatter, scaled_ticks, scale)
    else
        String[]  # no finite ticks to show...
    end

    return unscaled_ticks, labels
end

function get_labels(formatter::Symbol, scaled_ticks, scale)
    if formatter in (:auto, :plain, :scientific, :engineering)
        return map(labelfunc(scale, backend()), Showoff.showoff(scaled_ticks, formatter))
    elseif formatter === :latex
        return map(
            l -> string("\$", replace(convert_sci_unicode(l), '×' => "\\times"), "\$"),
            get_labels(:auto, scaled_ticks, scale),
        )
    elseif formatter === :none
        return String[]
    end
end
function get_labels(formatter::Function, scaled_ticks, scale)
    sf, invsf, _ = scale_inverse_scale_func(scale)
    fticks = map(formatter ∘ invsf, scaled_ticks)
    # extrema can extend outside the region where Categorical tick values are defined
    #   CategoricalArrays's recipe gives "missing" label to those
    filter!(!ismissing, fticks)
    eltype(fticks) <: Number && return get_labels(:auto, map(sf, fticks), scale)
    return fticks
end

# returns (continuous_values, discrete_values) for the ticks on this axis
function get_ticks(sp::Subplot, axis::Axis; update = true, formatter = axis[:formatter])
    if update || !haskey(axis.plotattributes, :optimized_ticks)
        dvals = axis[:discrete_values]
        ticks = _transform_ticks(axis[:ticks], axis)
        axis.plotattributes[:optimized_ticks] =
        if (
                axis[:letter] === :x &&
                    ticks isa Symbol &&
                    ticks !== :none &&
                    !isempty(dvals) &&
                    ispolar(sp)
            )
            collect(0:(π / 4):(7π / 4)), string.(0:45:315)
        else
            cvals = axis[:continuous_values]
            alims = axis_limits(sp, axis[:letter])
            get_ticks(ticks, cvals, dvals, alims, axis[:scale], formatter)
        end
    end
    return axis.plotattributes[:optimized_ticks]
end

# Ticks getter functions
for l in (:x, :y, :z)
    axis = string(l, "-axis")  # "x-axis"
    ticks = string(l, "ticks") # "xticks"
    f = Symbol(ticks)          # :xticks
    @eval begin
        """
            $($f)(p::Plot)

        returns a vector of the $($axis) ticks of the subplots of `p`.

        Example use:

        ```jldoctest
        julia> p = plot(1:5, $($ticks)=[1,2])

        julia> $($f)(p)
        1-element Vector{Tuple{Vector{Float64}, Vector{String}}}:
         ([1.0, 2.0], ["1", "2"])
        ```

        If `p` consists of a single subplot, you might want to grab
        only the first element, via

        ```jldoctest
        julia> $($f)(p)[1]
        ([1.0, 2.0], ["1", "2"])
        ```

        or you can call $($f) on the first (only) subplot of `p` via

        ```jldoctest
        julia> $($f)(p[1])
        ([1.0, 2.0], ["1", "2"])
        ```
        """
        $f(p::Plot) = get_ticks(p, $(Meta.quot(l)))
        """
            $($f)(sp::Subplot)

        returns the $($axis) ticks of the subplot `sp`.

        Note that the ticks are returned as tuples of values and labels:

        ```jldoctest
        julia> sp = plot(1:5, $($ticks)=[1,2]).subplots[1]
        Subplot{1}

        julia> $($f)(sp)
        ([1.0, 2.0], ["1", "2"])
        ```
        """
        $f(sp::Subplot) = get_ticks(sp, $(Meta.quot(l)))
        export $f
    end
end
# get_ticks from axis symbol :x, :y, or :z
get_ticks(sp::Subplot, s::Symbol) = get_ticks(sp, sp[get_attr_symbol(s, :axis)])
get_ticks(p::Plot, s::Symbol) = map(sp -> get_ticks(sp, s), p.subplots)

get_ticks(ticks::Symbol, cvals::T, dvals, args...) where {T} =
if ticks === :none
    T[], String[]
elseif !isempty(dvals)
    n = length(dvals)
    if ticks === :all || n < 16
        cvals, string.(dvals)
    else
        Δ = ceil(Int, n / 10)
        rng = Δ:Δ:n
        cvals[rng], string.(dvals[rng])
    end
else
    optimal_ticks_and_labels(nothing, args...)
end

get_ticks(ticks::AVec, cvals, dvals, args...) = optimal_ticks_and_labels(ticks, args...)
get_ticks(ticks::Int, dvals, cvals, args...) =
if isempty(dvals)
    optimal_ticks_and_labels(ticks, args...)
else
    rng = round.(Int, range(1, stop = length(dvals), length = ticks))
    cvals[rng], string.(dvals[rng])
end
get_ticks(ticks::NTuple{2, Any}, args...) = ticks
get_ticks(::Nothing, cvals::T, args...) where {T} = T[], String[]
get_ticks(ticks::Bool, args...) =
    ticks ? get_ticks(:auto, args...) : get_ticks(nothing, args...)
get_ticks(::T, args...) where {T} =
    throw(ArgumentError("Unknown ticks type in get_ticks: $T"))

# do not specify array item type to also catch e.g. "xlabel=[]" and "xlabel=([],[])"
_has_ticks(v::AVec) = !isempty(v)
_has_ticks(t::Tuple{AVec, AVec}) = !isempty(t[1])
_has_ticks(s::Symbol) = s !== :none
_has_ticks(b::Bool) = b
_has_ticks(::Nothing) = false
_has_ticks(::Any) = true

has_ticks(axis::Axis) = get(axis, :ticks, nothing) |> _has_ticks

_transform_ticks(ticks, axis) = ticks
_transform_ticks(ticks::AbstractArray{T}, axis) where {T <: Dates.TimeType} =
    Dates.value.(ticks)
_transform_ticks(ticks::NTuple{2, Any}, axis) = (_transform_ticks(ticks[1], axis), ticks[2])

const DEFAULT_MINOR_INTERVALS = Ref(5)  # 5 intervals -> 4 ticks

function num_minor_intervals(axis)
    # FIXME: `minorticks` should be fixed in `2.0` to be the number of ticks, not intervals
    # see github.com/JuliaPlots/Plots.jl/pull/4528
    n_intervals = axis[:minorticks]
    return if !(n_intervals isa Bool) && n_intervals isa Integer && n_intervals ≥ 0
        max(1, n_intervals)  # 0 intervals makes no sense
    else   # `:auto` or `true`
        if (base = get(_logScaleBases, axis[:scale], nothing)) == 10
            Int(base - 1)
        else
            DEFAULT_MINOR_INTERVALS[]
        end
    end::Int
end

no_minor_intervals(axis) =
if (n_intervals = axis[:minorticks]) === false
    true  # must be tested with `===` since Bool <: Integer
elseif n_intervals ∈ (:none, nothing)
    true
elseif (n_intervals === :auto && !axis[:minorgrid])
    true
else
    false
end

function get_minor_ticks(sp, axis, ticks_and_labels)
    no_minor_intervals(axis) && return
    ticks = first(ticks_and_labels)
    length(ticks) < 2 && return

    amin, amax = axis_limits(sp, axis[:letter])
    scale = axis[:scale]
    base = get(_logScaleBases, scale, nothing)

    # add one phantom tick either side of the ticks to ensure minor ticks extend to the axis limits
    if (log_scaled = scale ∈ _logScales)
        sub = round(Int, log(base, ticks[2] / ticks[1]))
        ticks = [ticks[1] / base; ticks; ticks[end] * base]
    else
        sub = 1  # unused
        ratio = length(ticks) > 2 ? (ticks[3] - ticks[2]) / (ticks[2] - ticks[1]) : 1
        first_step = ticks[2] - ticks[1]
        last_step = ticks[end] - ticks[end - 1]
        ticks = [ticks[1] - first_step / ratio; ticks; ticks[end] + last_step * ratio]
    end

    n_minor_intervals = num_minor_intervals(axis)
    minorticks = sizehint!(eltype(ticks)[], n_minor_intervals * sub * length(ticks))
    for i in 2:length(ticks)
        lo = ticks[i - 1]
        hi = ticks[i]
        (isfinite(lo) && isfinite(hi) && hi > lo) || continue
        if log_scaled
            for e in 1:sub
                lo_ = lo * base^(e - 1)
                hi_ = lo_ * base
                step = (hi_ - lo_) / n_minor_intervals
                rng = (lo_ + (e > 1 ? 0 : step)):step:(hi_ - (e < sub ? 0 : step / 2))
                append!(minorticks, collect(rng))
            end
        else
            step = (hi - lo) / n_minor_intervals
            append!(minorticks, collect((lo + step):step:(hi - step / 2)))
        end
    end
    return minorticks[amin .≤ minorticks .≤ amax]
end

# -------------------------------------------------------------------------

function reset_extrema!(sp::Subplot)
    for asym in (:x, :y, :z)
        sp[get_attr_symbol(asym, :axis)][:extrema] = Extrema()
    end
    for series in sp.series_list
        expand_extrema!(sp, series.plotattributes)
    end
    return
end

function expand_extrema!(ex::Extrema, v::Number)
    ex.emin = isfinite(v) ? min(v, ex.emin) : ex.emin
    ex.emax = isfinite(v) ? max(v, ex.emax) : ex.emax
    return ex
end

expand_extrema!(axis::Axis, v::Number) = expand_extrema!(axis[:extrema], v)

# these shouldn't impact the extrema
expand_extrema!(axis::Axis, ::Nothing) = axis[:extrema]
expand_extrema!(axis::Axis, ::Bool) = axis[:extrema]

function expand_extrema!(axis::Axis, v::Tuple{MIN, MAX}) where {MIN <: Number, MAX <: Number}
    ex = axis[:extrema]::Extrema
    ex.emin = isfinite(v[1]) ? min(v[1], ex.emin) : ex.emin
    ex.emax = isfinite(v[2]) ? max(v[2], ex.emax) : ex.emax
    return ex
end
function expand_extrema!(axis::Axis, v::AVec{N}) where {N <: Number}
    ex = axis[:extrema]::Extrema
    foreach(vi -> expand_extrema!(ex, vi), v)
    return ex
end

function expand_extrema!(sp::Subplot, plotattributes::AKW)
    vert = isvertical(plotattributes)

    # first expand for the data
    for letter in (:x, :y, :z)
        data = plotattributes[
            if vert
                letter
            else
                letter === :x ? :y : letter === :y ? :x : :z
            end,
        ]
        if (
                letter !== :z &&
                    plotattributes[:seriestype] === :straightline &&
                    any(series[:seriestype] !== :straightline for series in series_list(sp)) &&
                    length(data) > 1 &&
                    data[1] != data[2]
            )
            data = [NaN]
        end
        axis = sp[get_attr_symbol(letter, :axis)]

        if isa(data, Volume)
            expand_extrema!(sp[:xaxis], data.x_extents)
            expand_extrema!(sp[:yaxis], data.y_extents)
            expand_extrema!(sp[:zaxis], data.z_extents)
        elseif eltype(data) <: Number ||
                (isa(data, Surface) && all(di -> isa(di, Number), data.surf))
            if !(eltype(data) <: Number)
                # huh... must have been a mis-typed surface? lets swap it out
                data = plotattributes[letter] = Surface(Matrix{Float64}(data.surf))
            end
            expand_extrema!(axis, data)
        elseif data !== nothing
            # TODO: need more here... gotta track the discrete reference value
            #       as well as any coord offset (think of boxplot shape coords... they all
            #       correspond to the same x-value)
            plotattributes[letter],
                plotattributes[get_attr_symbol(letter, :(_discrete_indices))] =
                discrete_value!(axis, data)
            expand_extrema!(axis, plotattributes[letter])
        end
    end

    # # expand for fillrange/bar_width
    # fillaxis, baraxis = sp.attr[:yaxis], sp.attr[:xaxis]
    # if isvertical(plotattributes)
    #     fillaxis, baraxis = baraxis, fillaxis
    # end

    # expand for fillrange
    fr = plotattributes[:fillrange]
    if fr === nothing && plotattributes[:seriestype] === :bar
        fr = 0.0
    end
    if fr !== nothing && !RecipesPipeline.is3d(plotattributes)
        axis = sp.attr[vert ? :yaxis : :xaxis]
        if typeof(fr) <: Tuple
            foreach(x -> expand_extrema!(axis, x), fr)
        else
            expand_extrema!(axis, fr)
        end
    end

    # expand for bar_width
    if plotattributes[:seriestype] === :bar
        dsym = vert ? :x : :y
        data = plotattributes[dsym]

        if (bw = plotattributes[:bar_width]) === nothing
            pos = filter(>(0), diff(sort(data)))
            plotattributes[:bar_width] = bw = _bar_width * ignorenan_minimum(pos)
        end
        axis = sp.attr[get_attr_symbol(dsym, :axis)]
        expand_extrema!(axis, ignorenan_maximum(data) + 0.5maximum(bw))
        expand_extrema!(axis, ignorenan_minimum(data) - 0.5minimum(bw))
    end

    # expand for heatmaps
    return if plotattributes[:seriestype] === :heatmap
        for letter in (:x, :y)
            data = plotattributes[letter]
            axis = sp[get_attr_symbol(letter, :axis)]
            scale = get(plotattributes, get_attr_symbol(letter, :scale), :identity)
            expand_extrema!(axis, heatmap_edges(data, scale))
        end
    end
end

function expand_extrema!(sp::Subplot, xmin, xmax, ymin, ymax)
    expand_extrema!(sp[:xaxis], (xmin, xmax))
    return expand_extrema!(sp[:yaxis], (ymin, ymax))
end

# -------------------------------------------------------------------------

function scale_lims(from, to, factor)
    mid, span = (from + to) / 2, (to - from) / 2
    return mid .+ (-span, span) .* factor
end

_scale_lims(::Val{true}, ::Function, ::Function, from, to, factor) =
    scale_lims(from, to, factor)
_scale_lims(::Val{false}, f::Function, invf::Function, from, to, factor) =
    invf.(scale_lims(f(from), f(to), factor))

function scale_lims(from, to, factor, scale)
    f, invf, noop = scale_inverse_scale_func(scale)
    return _scale_lims(Val(noop), f, invf, from, to, factor)
end

"""
    scale_lims!([plt], [letter], factor)

Scale the limits of the axis specified by `letter` (one of `:x`, `:y`, `:z`) by the
given `factor` around the limits' middle point.
If `letter` is omitted, all axes are affected.
"""
function scale_lims!(sp::Subplot, letter, factor)
    axis = Plots.get_axis(sp, letter)
    from, to = Plots.get_sp_lims(sp, letter)
    return axis[:lims] = scale_lims(from, to, factor, axis[:scale])
end
function scale_lims!(plt::Plot, letter, factor)
    foreach(sp -> scale_lims!(sp, letter, factor), plt.subplots)
    return plt
end
scale_lims!(letter::Symbol, factor) = scale_lims!(current(), letter, factor)
function scale_lims!(plt::Union{Plot, Subplot}, factor)
    foreach(letter -> scale_lims!(plt, letter, factor), (:x, :y, :z))
    return plt
end
scale_lims!(factor::Number) = scale_lims!(current(), factor)

# figure out if widening is a good idea.
const _widen_seriestypes = (
    :line,
    :path,
    :steppre,
    :stepmid,
    :steppost,
    :sticks,
    :scatter,
    :barbins,
    :barhist,
    :histogram,
    :scatterbins,
    :scatterhist,
    :stepbins,
    :stephist,
    :bins2d,
    :histogram2d,
    :bar,
    :shape,
    :path3d,
    :scatter3d,
)

const default_widen_factor = Ref(1.06)

# factor to widen axis limits by, or `nothing` if axis widening should be skipped
function widen_factor(axis::Axis; factor = default_widen_factor[])
    if (widen = axis[:widen]) isa Bool
        return widen ? factor : nothing
    elseif widen isa Number
        return widen
    else
        widen === :auto || @warn "Invalid value specified for `widen`: $widen"
    end

    # automatic behavior: widen if limits aren't specified and series type is appropriate
    lims = process_limits(axis[:lims], axis)
    (lims isa Tuple || lims === :round) && return
    for sp in axis.sps, series in series_list(sp)
        series.plotattributes[:seriestype] in _widen_seriestypes && return factor
    end
    return nothing
end

function round_limits(amin, amax, scale)
    base = get(_logScaleBases, scale, 10.0)
    factor = base^(1 - round(log(base, amax - amin)))
    amin = floor(amin * factor) / factor
    amax = ceil(amax * factor) / factor
    return amin, amax
end

# NOTE: cannot use `NTuple` here ↓
process_limits(lims::Tuple{<:Union{Symbol, Real}, <:Union{Symbol, Real}}, axis) = lims
process_limits(lims::Symbol, axis) = lims
process_limits(lims::AVec, axis) =
    length(lims) == 2 && all(map(x -> x isa Union{Symbol, Real}, lims)) ? Tuple(lims) :
    nothing
process_limits(lims, axis) = nothing

warn_invalid_limits(lims, letter) = @warn """
Invalid limits for $letter axis. Limits should be a symbol, or a two-element tuple or vector of numbers.
$(letter)lims = $lims
"""

# using the axis extrema and limit overrides, return the min/max value for this axis
function axis_limits(
        sp,
        letter,
        lims_factor = widen_factor(get_axis(sp, letter)),
        consider_aspect = true,
    )
    axis = get_axis(sp, letter)
    ex = axis[:extrema]
    amin, amax = ex.emin, ex.emax
    lims = process_limits(axis[:lims], axis)
    lims === nothing && warn_invalid_limits(axis[:lims], letter)

    if (has_user_lims = lims isa Tuple)
        lmin, lmax = lims
        if lmin isa Number && isfinite(lmin)
            amin = lmin
        elseif lmin isa Symbol
            lmin === :auto || @warn "Invalid min $(letter)limit" lmin
        end
        if lmax isa Number && isfinite(lmax)
            amax = lmax
        elseif lmax isa Symbol
            lmax === :auto || @warn "Invalid max $(letter)limit" lmax
        end
    end
    if lims === :symmetric
        amax = max(abs(amin), abs(amax))
        amin = -amax
    end
    if amax ≤ amin && isfinite(amin)
        amax = amin + 1.0
    end
    if !isfinite(amin) && !isfinite(amax)
        amin, amax = zero(amin), one(amax)
    end
    if ispolar(axis.sps[1])
        if axis[:letter] === :x
            amin, amax = 0, 2π
        elseif lims === :auto
            # widen max radius so ticks dont overlap with theta axis
            amin, amax = 0, amax + 0.1abs(amax - amin)
        end
    elseif lims_factor !== nothing
        amin, amax = scale_lims(amin, amax, lims_factor, axis[:scale])
    elseif lims === :round
        amin, amax = round_limits(amin, amax, axis[:scale])
    end

    aspect_ratio = get_aspect_ratio(sp)
    if (
            !has_user_lims &&
                consider_aspect &&
                letter in (:x, :y) &&
                !(aspect_ratio === :none || RecipesPipeline.is3d(sp))
        )
        aspect_ratio = aspect_ratio isa Number ? aspect_ratio : 1
        area = plotarea(sp)
        plot_ratio = height(area) / width(area)
        dist = amax - amin

        factor = if letter === :x
            ydist, = axis_limits(sp, :y, widen_factor(sp[:yaxis]), false) |> collect |> diff
            axis_ratio = aspect_ratio * ydist / dist
            axis_ratio / plot_ratio
        else
            xdist, = axis_limits(sp, :x, widen_factor(sp[:xaxis]), false) |> collect |> diff
            axis_ratio = aspect_ratio * dist / xdist
            plot_ratio / axis_ratio
        end

        if factor > 1
            center = (amin + amax) / 2
            amin = center + factor * (amin - center)
            amax = center + factor * (amax - center)
        end
    end

    return amin, amax
end

# -------------------------------------------------------------------------

# these methods track the discrete (categorical) values which correspond to axis continuous values (cv)
# whenever we have discrete values, we automatically set the ticks to match.
# we return (continuous_value, discrete_index)
discrete_value!(plotattributes, letter::Symbol, dv) =
let l = if plotattributes[:permute] !== :none
        filter(!=(letter), plotattributes[:permute]) |> only
    else
        letter
    end
    discrete_value!(plotattributes[:subplot][get_attr_symbol(l, :axis)], dv)
end

discrete_value!(axis::Axis, dv) =
if (cv_idx = get(axis[:discrete_map], dv, -1)) == -1
    ex = axis[:extrema]
    cv = NaNMath.max(0.5, ex.emax + 1)
    expand_extrema!(axis, cv)
    push!(axis[:discrete_values], dv)
    push!(axis[:continuous_values], cv)
    cv_idx = length(axis[:discrete_values])
    axis[:discrete_map][dv] = cv_idx
    cv, cv_idx
else
    cv = axis[:continuous_values][cv_idx]
    cv, cv_idx
end

# continuous value... just pass back with axis negative index
discrete_value!(axis::Axis, cv::Number) = (cv, -1)

# add the discrete value for each item.  return the continuous values and the indices
function discrete_value!(axis::Axis, v::AVec)
    cvec = zeros(axes(v))
    discrete_indices = similar(Array{Int}, axes(v))
    for i in eachindex(v)
        cvec[i], discrete_indices[i] = discrete_value!(axis, v[i])
    end
    return cvec, discrete_indices
end

# add the discrete value for each item.  return the continuous values and the indices
function discrete_value!(axis::Axis, v::AMat)
    cmat = zeros(axes(v))
    discrete_indices = similar(Array{Int}, axes(v))
    for I in eachindex(v)
        cmat[I], discrete_indices[I] = discrete_value!(axis, v[I])
    end
    return cmat, discrete_indices
end

discrete_value!(axis::Axis, v::Surface) = map(Surface, discrete_value!(axis, v.surf))

# -------------------------------------------------------------------------

const grid_factor_2d = Ref(1.2)
const grid_factor_3d = Ref(grid_factor_2d[] / 100)

function add_major_or_minor_segments_2d(
        sp,
        ax,
        oax,
        oas,
        oamM,
        ticks,
        grid,
        tick_segments,
        segments,
        factor,
        cond,
    )
    ticks === nothing && return
    if cond
        f, invf = scale_inverse_scale_func(oax[:scale])
        tick_start, tick_stop = if sp[:framestyle] === :origin
            oamin, oamax = oamM
            t = invf(f(0) + factor * (f(oamax) - f(oamin)))
            (-t, t)
        else
            ticks_in = ax[:tick_direction] === :out ? -1 : 1
            oa1, oa2 = oas
            t = invf(f(oa1) + factor * (f(oa2) - f(oa1)) * ticks_in)
            (oa1, t)
        end
    end
    isy = ax[:letter] === :y
    for tick in ticks
        (ax[:showaxis] && cond) && push!(
            tick_segments,
            reverse_if((tick, tick_start), isy),
            reverse_if((tick, tick_stop), isy),
        )
        grid && push!(
            segments,
            reverse_if((tick, first(oamM)), isy),
            reverse_if((tick, last(oamM)), isy),
        )
    end
    return
end

# compute the line segments which should be drawn for this axis
function axis_drawing_info(sp, letter)
    # get axis objects, ticks and minor ticks
    letters = axes_letters(sp, letter)
    ax, oax = map(l -> sp[get_attr_symbol(l, :axis)], letters)
    (amin, amax), oamM = map(l -> axis_limits(sp, l), letters)

    ticks = get_ticks(sp, ax, update = false)
    minor_ticks = get_minor_ticks(sp, ax, ticks)

    # initialize the segments
    segments, tick_segments, grid_segments, minorgrid_segments, border_segments =
        map(_ -> Segments(2), 1:5)

    if sp[:framestyle] !== :none
        isy = letter === :y
        oa1, oa2 = oas = if sp[:framestyle] in (:origin, :zerolines)
            0, 0
        else
            xor(ax[:mirror], oax[:flip]) ? reverse(oamM) : oamM
        end
        if ax[:showaxis]
            if sp[:framestyle] !== :grid
                push!(segments, reverse_if((amin, oa1), isy), reverse_if((amax, oa1), isy))
                # don't show the 0 tick label for the origin framestyle
                if (
                        sp[:framestyle] === :origin &&
                            ticks ∉ (:none, nothing, false) &&
                            length(ticks) > 1
                    )
                    if (i = findfirst(==(0), ticks[1])) !== nothing
                        deleteat!(ticks[1], i)
                        deleteat!(ticks[2], i)
                    end
                end
            end
            # top spine
            sp[:framestyle] in (:semi, :box) && push!(
                border_segments,
                reverse_if((amin, oa2), isy),
                reverse_if((amax, oa2), isy),
            )
        end
        if ax[:ticks] ∉ (:none, nothing, false)
            ax_length = letter === :x ? height(sp.plotarea).value : width(sp.plotarea).value

            # add major grid segments
            add_major_or_minor_segments_2d(
                sp,
                ax,
                oax,
                oas,
                oamM,
                first(ticks),
                ax[:grid],
                tick_segments,
                grid_segments,
                grid_factor_2d[] / ax_length,
                ax[:tick_direction] !== :none,
            )
            if sp[:framestyle] === :box
                add_major_or_minor_segments_2d(
                    sp,
                    ax,
                    oax,
                    reverse(oas),
                    oamM,
                    first(ticks),
                    ax[:grid],
                    tick_segments,
                    grid_segments,
                    grid_factor_2d[] / ax_length,
                    ax[:tick_direction] !== :none,
                )
            end

            # add minor grid segments
            if ax[:minorticks] ∉ (:none, nothing, false) || ax[:minorgrid]
                add_major_or_minor_segments_2d(
                    sp,
                    ax,
                    oax,
                    oas,
                    oamM,
                    minor_ticks,
                    ax[:minorgrid],
                    tick_segments,
                    minorgrid_segments,
                    grid_factor_2d[] / 2ax_length,
                    true,
                )
                if sp[:framestyle] === :box
                    add_major_or_minor_segments_2d(
                        sp,
                        ax,
                        oax,
                        reverse(oas),
                        oamM,
                        minor_ticks,
                        ax[:minorgrid],
                        tick_segments,
                        minorgrid_segments,
                        grid_factor_2d[] / 2ax_length,
                        true,
                    )
                end
            end
        end
    end

    return (
        ticks = ticks,
        segments = segments,
        tick_segments = tick_segments,
        grid_segments = grid_segments,
        minorgrid_segments = minorgrid_segments,
        border_segments = border_segments,
    )
end

function add_major_or_minor_segments_3d(
        sp,
        ax,
        nax,
        nas,
        fas,
        namM,
        ticks,
        grid,
        tick_segments,
        segments,
        factor,
        cond,
    )
    ticks === nothing && return
    if cond
        f, invf = scale_inverse_scale_func(nax[:scale])
        tick_start, tick_stop = if sp[:framestyle] === :origin
            namin, namax = namM
            t = invf(f(0) + factor * (f(namax) - f(namin)))
            (-t, t)
        else
            na0, na1 = nas
            ticks_in = ax[:tick_direction] === :out ? -1 : 1
            t = invf(f(na0) + factor * (f(na1) - f(na0)) * ticks_in)
            (na0, t)
        end
    end
    if grid
        gas = sp[:framestyle] in (:origin, :zerolines) ? namM : nas
        fa0_, fa1_ = reverse_if(fas, ax[:mirror])
        ga0_, ga1_ = reverse_if(gas, ax[:mirror])
    end
    letter = ax[:letter]
    for tick in ticks
        (ax[:showaxis] && cond) && push!(
            tick_segments,
            sort_3d_axes(tick, tick_start, first(fas), letter),
            sort_3d_axes(tick, tick_stop, first(fas), letter),
        )
        grid && push!(
            segments,
            sort_3d_axes(tick, ga0_, fa0_, letter),
            sort_3d_axes(tick, ga1_, fa0_, letter),
            sort_3d_axes(tick, ga1_, fa0_, letter),
            sort_3d_axes(tick, ga1_, fa1_, letter),
        )
    end
    return
end

function axis_drawing_info_3d(sp, letter)
    letters = axes_letters(sp, letter)
    ax, nax, fax = map(l -> sp[get_attr_symbol(l, :axis)], letters)
    (amin, amax), namM, famM = map(l -> axis_limits(sp, l), letters)

    ticks = get_ticks(sp, ax, update = false)
    minor_ticks = get_minor_ticks(sp, ax, ticks)

    # initialize the segments
    segments, tick_segments, grid_segments, minorgrid_segments, border_segments =
        map(_ -> Segments(3), 1:5)

    if sp[:framestyle] !== :none  # && letter === :x
        na0, na1 =
            nas = if sp[:framestyle] in (:origin, :zerolines)
            0, 0
        else
            reverse_if(reverse_if(namM, letter === :y), xor(ax[:mirror], nax[:flip]))
        end
        fa0, fa1 = fas = if sp[:framestyle] in (:origin, :zerolines)
            0, 0
        else
            reverse_if(famM, xor(ax[:mirror], fax[:flip]))
        end
        if ax[:showaxis]
            if sp[:framestyle] !== :grid
                push!(
                    segments,
                    sort_3d_axes(amin, na0, fa0, letter),
                    sort_3d_axes(amax, na0, fa0, letter),
                )
                # don't show the 0 tick label for the origin framestyle
                if (
                        sp[:framestyle] === :origin &&
                            ticks ∉ (:none, nothing, false) &&
                            length(ticks) > 1
                    )
                    if (i = findfirst(==(0), ticks[1])) !== nothing
                        deleteat!(ticks[1], i)
                        deleteat!(ticks[2], i)
                    end
                end
            end
            sp[:framestyle] in (:semi, :box) && push!(
                border_segments,
                sort_3d_axes(amin, na1, fa1, letter),
                sort_3d_axes(amax, na1, fa1, letter),
            )
        end

        if ax[:ticks] ∉ (:none, nothing, false)
            # add major grid segments
            add_major_or_minor_segments_3d(
                sp,
                ax,
                nax,
                nas,
                fas,
                namM,
                first(ticks),
                ax[:grid],
                tick_segments,
                grid_segments,
                grid_factor_3d[],
                ax[:tick_direction] !== :none,
            )

            # add minor grid segments
            if ax[:minorticks] ∉ (:none, nothing, false) || ax[:minorgrid]
                add_major_or_minor_segments_3d(
                    sp,
                    ax,
                    nax,
                    nas,
                    fas,
                    namM,
                    minor_ticks,
                    ax[:minorgrid],
                    tick_segments,
                    minorgrid_segments,
                    grid_factor_3d[] / 2,
                    true,
                )
            end
        end
    end

    return (
        ticks = ticks,
        segments = segments,
        tick_segments = tick_segments,
        grid_segments = grid_segments,
        minorgrid_segments = minorgrid_segments,
        border_segments = border_segments,
    )
end

reverse_if(x, cond) = cond ? reverse(x) : x

const P2 = NTuple{2, Float64}
const P3 = NTuple{3, Float64}

const _haligns = :hcenter, :left, :right
const _valigns = :vcenter, :top, :bottom

nanpush!(a::AVec{P2}, b) = (push!(a, (NaN, NaN)); push!(a, b); nothing)
nanappend!(a::AVec{P2}, b) = (push!(a, (NaN, NaN)); append!(a, b); nothing)
nanpush!(a::AVec{P3}, b) = (push!(a, (NaN, NaN, NaN)); push!(a, b); nothing)
nanappend!(a::AVec{P3}, b) = (push!(a, (NaN, NaN, NaN)); append!(a, b); nothing)

compute_angle(v::P2) = (angle = atan(v[2], v[1]); angle < 0 ? 2π - angle : angle)

# -------------------------------------------------------------

struct Shape{X <: Number, Y <: Number}
    x::Vector{X}
    y::Vector{Y}
end

"""
    Shape(x, y)
    Shape(vertices)

Construct a polygon to be plotted
"""
Shape(verts::AVec) = Shape(RecipesPipeline.unzip(verts)...)
Shape(s::Shape) = deepcopy(s)
function Shape(x::AVec{X}, y::AVec{Y}) where {X, Y}
    return Shape(convert(Vector{X}, x), convert(Vector{Y}, y))
end

get_xs(shape::Shape) = shape.x
get_ys(shape::Shape) = shape.y
vertices(shape::Shape) = collect(zip(shape.x, shape.y))

#deprecated
@deprecate shape_coords coords

"return the vertex points from a Shape or Segments object"
coords(shape::Shape) = shape.x, shape.y

coords(shapes::AVec{<:Shape}) = RecipesPipeline.unzip(map(coords, shapes))

"get an array of tuples of points on a circle with radius `r`"
partialcircle(start_θ, end_θ, n = 20, r = 1) =
    [(r * cos(u), r * sin(u)) for u in range(start_θ, stop = end_θ, length = n)]

"interleave 2 vectors into each other (like a zipper's teeth)"
function weave(x, y; ordering = Vector[x, y])
    ret = eltype(x)[]
    done = false
    while !done
        for o in ordering
            try
                push!(ret, popfirst!(o))
            catch
            end
        end
        done = isempty(x) && isempty(y)
    end
    return ret
end

"create a star by weaving together points from an outer and inner circle.  `n` is the number of arms"
function makestar(n; offset = -0.5, radius = 1.0)
    z1 = offset * π
    z2 = z1 + π / (n)
    outercircle = partialcircle(z1, z1 + 2π, n + 1, radius)
    innercircle = partialcircle(z2, z2 + 2π, n + 1, 0.4radius)
    return Shape(weave(outercircle, innercircle))
end

"create a shape by picking points around the unit circle.  `n` is the number of point/sides, `offset` is the starting angle"
makeshape(n; offset = -0.5, radius = 1.0) =
    Shape(partialcircle(offset * π, offset * π + 2π, n + 1, radius))

function makecross(; offset = -0.5, radius = 1.0)
    z2 = offset * π
    z1 = z2 - π / 8
    outercircle = partialcircle(z1, z1 + 2π, 9, radius)
    innercircle = partialcircle(z2, z2 + 2π, 5, 0.5radius)
    return Shape(
        weave(
            outercircle,
            innercircle,
            ordering = Vector[outercircle, innercircle, outercircle],
        ),
    )
end

from_polar(angle, dist) = (dist * cos(angle), dist * sin(angle))

makearrowhead(angle; h = 2.0, w = 0.4, tip = from_polar(angle, h)) = Shape(
    NTuple{2, Float64}[
        (0, 0),
        from_polar(angle - 0.5π, w) .- tip,
        from_polar(angle + 0.5π, w) .- tip,
        (0, 0),
    ],
)

const _shapes = KW(
    :circle => makeshape(20),
    :rect => makeshape(4, offset = -0.25),
    :diamond => makeshape(4),
    :utriangle => makeshape(3, offset = 0.5),
    :dtriangle => makeshape(3, offset = -0.5),
    :rtriangle => makeshape(3, offset = 0.0),
    :ltriangle => makeshape(3, offset = 1.0),
    :pentagon => makeshape(5),
    :hexagon => makeshape(6),
    :heptagon => makeshape(7),
    :octagon => makeshape(8),
    :cross => makecross(offset = -0.25),
    :xcross => makecross(),
    :vline => Shape([(0, 1), (0, -1)]),
    :hline => Shape([(1, 0), (-1, 0)]),
    :star4 => makestar(4),
    :star5 => makestar(5),
    :star6 => makestar(6),
    :star7 => makestar(7),
    :star8 => makestar(8),
)

Shape(k::Symbol) = deepcopy(_shapes[k])

# -----------------------------------------------------------------------

# uses the centroid calculation from https://en.wikipedia.org/wiki/Centroid#Centroid_of_polygon
"return the centroid of a Shape"
function center(shape::Shape)
    x, y = coords(shape)
    n = length(x)
    A, Cx, Cy = 0, 0, 0
    for i in 1:n
        ip1 = i == n ? 1 : i + 1
        A += x[i] * y[ip1] - x[ip1] * y[i]
    end
    A *= 0.5
    for i in 1:n
        ip1 = i == n ? 1 : i + 1
        m = (x[i] * y[ip1] - x[ip1] * y[i])
        Cx += (x[i] + x[ip1]) * m
        Cy += (y[i] + y[ip1]) * m
    end
    return Cx / 6A, Cy / 6A
end

function scale!(shape::Shape, x::Real, y::Real = x, c = center(shape))
    sx, sy = coords(shape)
    cx, cy = c
    for i in eachindex(sx)
        sx[i] = (sx[i] - cx) * x + cx
        sy[i] = (sy[i] - cy) * y + cy
    end
    return shape
end

"""
    scale(shape, x, y = x, c = center(shape))
    scale!(shape, x, y = x, c = center(shape))

Scale shape by a factor.
"""
scale(shape::Shape, x::Real, y::Real = x, c = center(shape)) =
    scale!(deepcopy(shape), x, y, c)

function translate!(shape::Shape, x::Real, y::Real = x)
    sx, sy = coords(shape)
    for i in eachindex(sx)
        sx[i] += x
        sy[i] += y
    end
    return shape
end

"""
    translate(shape, x, y = x)
    translate!(shape, x, y = x)

Translate a Shape in space.
"""
translate(shape::Shape, x::Real, y::Real = x) = translate!(deepcopy(shape), x, y)

rotate_x(x::Real, y::Real, θ::Real, centerx::Real, centery::Real) =
    ((x - centerx) * cos(θ) - (y - centery) * sin(θ) + centerx)

rotate_y(x::Real, y::Real, θ::Real, centerx::Real, centery::Real) =
    ((y - centery) * cos(θ) + (x - centerx) * sin(θ) + centery)

rotate(x::Real, y::Real, θ::Real, c) = (rotate_x(x, y, θ, c...), rotate_y(x, y, θ, c...))

function rotate!(shape::Shape, θ::Real, c = center(shape))
    x, y = coords(shape)
    for i in eachindex(x)
        xi = rotate_x(x[i], y[i], θ, c...)
        yi = rotate_y(x[i], y[i], θ, c...)
        x[i], y[i] = xi, yi
    end
    return shape
end

"rotate an object in space"
function rotate(shape::Shape, θ::Real, c = center(shape))
    x, y = coords(shape)
    x_new = rotate_x.(x, y, θ, c...)
    y_new = rotate_y.(x, y, θ, c...)
    return Shape(x_new, y_new)
end

# -----------------------------------------------------------------------

mutable struct Font
    family::AbstractString
    pointsize::Int
    halign::Symbol
    valign::Symbol
    rotation::Float64
    color::Colorant
end

"""
    font(args...)
Create a Font from a list of features. Values may be specified either as
arguments (which are distinguished by type/value) or as keyword arguments.
# Arguments
- `family`: AbstractString. "serif" or "sans-serif" or "monospace"
- `pointsize`: Integer. Size of font in points
- `halign`: Symbol. Horizontal alignment (:hcenter, :left, or :right)
- `valign`: Symbol. Vertical alignment (:vcenter, :top, or :bottom)
- `rotation`: Real. Angle of rotation for text in degrees (use a non-integer type)
- `color`: Colorant or Symbol
# Examples
```julia-repl
julia> font(8)
julia> font(family="serif", halign=:center, rotation=45.0)
```
"""
function font(args...; kw...)
    # defaults
    family = "sans-serif"
    pointsize = 14
    halign = :hcenter
    valign = :vcenter
    rotation = 0
    color = colorant"black"

    for arg in args
        T = typeof(arg)
        @assert arg !== :match

        if T == Font
            family = arg.family
            pointsize = arg.pointsize
            halign = arg.halign
            valign = arg.valign
            rotation = arg.rotation
            color = arg.color
        elseif arg === :center
            halign = :hcenter
            valign = :vcenter
        elseif arg ∈ _haligns
            halign = arg
        elseif arg ∈ _valigns
            valign = arg
        elseif T <: Colorant
            color = arg
        elseif T <: Symbol || T <: AbstractString
            try
                color = parse(Colorant, string(arg))
            catch
                family = string(arg)
            end
        elseif T <: Integer
            pointsize = arg
        elseif T <: Real
            rotation = convert(Float64, arg)
        else
            @warn "Unused font arg: $arg ($T)"
        end
    end

    for sym in keys(kw)
        if sym === :family
            family = string(kw[sym])
        elseif sym === :pointsize
            pointsize = kw[sym]
        elseif sym === :halign
            halign = kw[sym]
            halign === :center && (halign = :hcenter)
            @assert halign ∈ _haligns
        elseif sym === :valign
            valign = kw[sym]
            valign === :center && (valign = :vcenter)
            @assert valign ∈ _valigns
        elseif sym === :rotation
            rotation = kw[sym]
        elseif sym === :color
            col = kw[sym]
            color = col isa Colorant ? col : parse(Colorant, col)
        else
            @warn "Unused font kwarg: $sym"
        end
    end

    return Font(family, pointsize, halign, valign, rotation, color)
end

function scalefontsize(k::Symbol, factor::Number)
    f = default(k)
    f = round(Int, factor * f)
    return default(k, f)
end

"""
    scalefontsizes(factor::Number)

Scales all **current** font sizes by `factor`. For example `scalefontsizes(1.1)` increases all current font sizes by 10%. To reset to initial sizes, use `scalefontsizes()`
"""
function scalefontsizes(factor::Number)
    for k in keys(merge(_initial_plt_fontsizes, _initial_sp_fontsizes))
        scalefontsize(k, factor)
    end

    for letter in (:x, :y, :z)
        for k in keys(_initial_ax_fontsizes)
            scalefontsize(get_attr_symbol(letter, k), factor)
        end
    end
    return
end

"""
    scalefontsizes()

Resets font sizes to initial default values.
"""
function scalefontsizes()
    for k in keys(merge(_initial_plt_fontsizes, _initial_sp_fontsizes))
        f = default(k)
        if k in keys(_initial_fontsizes)
            factor = f / _initial_fontsizes[k]
            scalefontsize(k, 1.0 / factor)
        end
    end

    for letter in (:x, :y, :z)
        for k in keys(_initial_ax_fontsizes)
            if k in keys(_initial_fontsizes)
                f = default(get_attr_symbol(letter, k))
                factor = f / _initial_fontsizes[k]
                scalefontsize(get_attr_symbol(letter, k), 1.0 / factor)
            end
        end
    end
    return
end

resetfontsizes() = scalefontsizes()

"Wrap a string with font info"
struct PlotText
    str::AbstractString
    font::Font
end
PlotText(str) = PlotText(string(str), font())

"""
    text(string, args...; kw...)

Create a PlotText object wrapping a string with font info, for plot annotations.
`args` and `kw` are passed to `font`.
"""
text(t::PlotText) = t
text(t::PlotText, font::Font) = PlotText(t.str, font)
text(str::AbstractString, f::Font) = PlotText(str, f)
text(str, args...; kw...) = PlotText(string(str), font(args...; kw...))

Base.length(t::PlotText) = length(t.str)

is_horizontal(t::PlotText) = abs(sind(t.font.rotation)) ≤ sind(45)

# -----------------------------------------------------------------------

struct Stroke
    width
    color
    alpha
    style
end

"""
    stroke(args...; alpha = nothing)

Define the properties of the stroke used in plotting lines
"""
function stroke(args...; alpha = nothing)
    width = 1
    color = :black
    style = :solid

    for arg in args
        T = typeof(arg)

        # if arg in _allStyles
        if allStyles(arg)
            style = arg
        elseif T <: Colorant
            color = arg
        elseif T <: Symbol || T <: AbstractString
            try
                color = parse(Colorant, string(arg))
            catch
            end
        elseif allAlphas(arg)
            alpha = arg
        elseif allReals(arg)
            width = arg
        else
            @warn "Unused stroke arg: $arg ($(typeof(arg)))"
        end
    end

    return Stroke(width, color, alpha, style)
end

struct Brush
    size  # fillrange, markersize, or any other sizey attribute
    color
    alpha
end

function brush(args...; alpha = nothing)
    size = 1
    color = :black

    for arg in args
        T = typeof(arg)

        if T <: Colorant
            color = arg
        elseif T <: Symbol || T <: AbstractString
            try
                color = parse(Colorant, string(arg))
            catch
            end
        elseif allAlphas(arg)
            alpha = arg
        elseif allReals(arg)
            size = arg
        else
            @warn "Unused brush arg: $arg ($(typeof(arg)))"
        end
    end

    return Brush(size, color, alpha)
end

# -----------------------------------------------------------------------

mutable struct SeriesAnnotations
    strs::AVec  # the labels/names
    font::Font
    baseshape::Union{Shape, AVec{Shape}, Nothing}
    scalefactor::Tuple
end

_text_label(lab::Tuple, font) = text(lab[1], font, lab[2:end]...)
_text_label(lab::PlotText, font) = lab
_text_label(lab, font) = text(lab, font)

series_annotations(scalar) = series_annotations([scalar])
series_annotations(anns::SeriesAnnotations) = anns
series_annotations(::Nothing) = nothing

function series_annotations(anns::AMat{SeriesAnnotations})
    @assert size(anns, 1) == 1 "matrix of SeriesAnnotations must be a row vector"
    return anns
end

function series_annotations(anns::AMat, outer_args...)
    # Types that represent annotations for an entire series
    whole_series = Union{AVec, Tuple{AVec, Vararg{Any}}}

    # whole_series types can only be in a row vector
    if size(anns, 1) > 1
        for ann in Iterators.filter(ann -> ann isa whole_series, anns)
            "Given series annotation must be the only element in its column:\n$ann" |>
                ArgumentError |>
                throw
        end
    end

    ann_vec = map(eachcol(anns)) do col
        ann = first(col) isa whole_series ? first(col) : col

        # Override arguments from outer tuple with args from inner tuple
        strs, inner_args = Iterators.peel(wraptuple(ann))
        series_annotations(strs, outer_args..., inner_args...)
    end

    return permutedims(ann_vec)
end

function series_annotations(strs::AVec, args...)
    fnt = font()
    shp = nothing
    scalefactor = 1, 1
    for arg in args
        if isa(arg, Shape) || (isa(arg, AVec) && eltype(arg) == Shape)
            shp = arg
        elseif isa(arg, Font)
            fnt = arg
        elseif isa(arg, Symbol) && haskey(_shapes, arg)
            shp = _shapes[arg]
        elseif isa(arg, Number)
            scalefactor = arg, arg
        elseif is_2tuple(arg)
            scalefactor = arg
        elseif isa(arg, AVec)
            strs = collect(zip(strs, arg))
        else
            @warn "Unused SeriesAnnotations arg: $arg ($(typeof(arg)))"
        end
    end
    return SeriesAnnotations(map(s -> _text_label(s, fnt), strs), fnt, shp, scalefactor)
end

function series_annotations_shapes!(series::Series, scaletype::Symbol = :pixels)
    anns = series[:series_annotations]

    if anns !== nothing && anns.baseshape !== nothing
        # we use baseshape to overwrite the markershape attribute
        # with a list of custom shapes for each
        msw, msh = anns.scalefactor
        msize = Float64[]
        shapes = Vector{Shape}(undef, length(anns.strs))
        for i in eachindex(anns.strs)
            str = _cycle(anns.strs, i)

            # get the width and height of the string (in mm)
            sw, sh = text_size(str, anns.font.pointsize)

            # how much to scale the base shape?
            # note: it's a rough assumption that the shape fills the unit box [-1, -1, 1, 1],
            #       so we scale the length-2 shape by 1/2 the total length
            scalar = backend() == PyPlotBackend() ? 1.7 : 1.0
            xscale = 0.5to_pixels(sw) * scalar
            yscale = 0.5to_pixels(sh) * scalar

            # we save the size of the larger direction to the markersize list,
            # and then re-scale a copy of baseshape to match the w/h ratio
            maxscale = max(xscale, yscale)
            push!(msize, maxscale)
            baseshape = _cycle(anns.baseshape, i)
            shapes[i] =
                scale(baseshape, msw * xscale / maxscale, msh * yscale / maxscale, (0, 0))
        end
        series[:markershape] = shapes
        series[:markersize] = msize
    end
    return nothing
end

mutable struct EachAnn
    anns
    x
    y
end

function Base.iterate(ea::EachAnn, i = 1)
    (ea.anns === nothing || isempty(ea.anns.strs) || i > length(ea.y)) && return

    tmp = _cycle(ea.anns.strs, i)
    str, fnt = if isa(tmp, PlotText)
        tmp.str, tmp.font
    else
        tmp, ea.anns.font
    end
    return (_cycle(ea.x, i), _cycle(ea.y, i), str, fnt), i + 1
end

# -----------------------------------------------------------------------
annotations(anns::AMat) = map(annotations, anns)
annotations(sa::SeriesAnnotations) = sa
annotations(anns::AVec) = anns
annotations(anns) = Any[anns]
annotations(::Nothing) = []

_annotationfont(sp::Subplot) = font(;
    family = sp[:annotationfontfamily],
    pointsize = sp[:annotationfontsize],
    halign = sp[:annotationhalign],
    valign = sp[:annotationvalign],
    rotation = sp[:annotationrotation],
    color = sp[:annotationcolor],
)

_annotation(sp::Subplot, font, lab, pos...; alphabet = "abcdefghijklmnopqrstuvwxyz") = (
    pos...,
    lab === :auto ? text("($(alphabet[sp[:subplot_index]]))", font) :
        _text_label(lab, font),
)

assign_annotation_coord!(axis, x) = discrete_value!(axis, x)[1]
assign_annotation_coord!(axis, x::TimeType) = assign_annotation_coord!(axis, Dates.value(x))

_annotation_coords(pos::Symbol) = get(_positionAliases, pos, pos)
_annotation_coords(pos) = pos

function _process_annotation_2d(sp::Subplot, x, y, lab, font = _annotationfont(sp))
    x = assign_annotation_coord!(sp[:xaxis], x)
    y = assign_annotation_coord!(sp[:yaxis], y)
    return _annotation(sp, font, lab, x, y)
end

_process_annotation_2d(
    sp::Subplot,
    pos::Union{Tuple, Symbol},
    lab,
    font = _annotationfont(sp),
) = _annotation(sp, font, lab, _annotation_coords(pos))

function _process_annotation_3d(sp::Subplot, x, y, z, lab, font = _annotationfont(sp))
    x = assign_annotation_coord!(sp[:xaxis], x)
    y = assign_annotation_coord!(sp[:yaxis], y)
    z = assign_annotation_coord!(sp[:zaxis], z)
    return _annotation(sp, font, lab, x, y, z)
end

_process_annotation_3d(
    sp::Subplot,
    pos::Union{Tuple, Symbol},
    lab,
    font = _annotationfont(sp),
) = _annotation(sp, font, lab, _annotation_coords(pos))

function _process_annotation(sp::Subplot, ann, annotation_processor::Function)
    ann = makevec.(ann)
    return [annotation_processor(sp, _cycle.(ann, i)...) for i in 1:maximum(length.(ann))]
end

# Expand arrays of coordinates, positions and labels into individual annotations
# and make sure labels are of type PlotText
process_annotation(sp::Subplot, ann) =
    _process_annotation(sp, ann, is3d(sp) ? _process_annotation_3d : _process_annotation_2d)

function _relative_position(xmin, xmax, pos::Length{:pct}, scale::Symbol)
    # !TODO Add more scales in the future (asinh, sqrt) ?
    return if scale === :log || scale === :ln
        exp(log(xmin) + pos.value * log(xmax / xmin))
    elseif scale === :log10
        exp10(log10(xmin) + pos.value * log10(xmax / xmin))
    elseif scale === :log2
        exp2(log2(xmin) + pos.value * log2(xmax / xmin))
    else  # :identity (linear scale)
        xmin + pos.value * (xmax - xmin)
    end
end

# annotation coordinates in pct
const position_multiplier = Dict(
    :N => (0.5, 0.9),
    :NE => (0.9, 0.9),
    :E => (0.9, 0.5),
    :SE => (0.9, 0.1),
    :S => (0.5, 0.1),
    :SW => (0.1, 0.1),
    :W => (0.1, 0.5),
    :NW => (0.1, 0.9),
    :topleft => (0.1, 0.9),
    :topcenter => (0.5, 0.9),
    :topright => (0.9, 0.9),
    :bottomleft => (0.1, 0.1),
    :bottomcenter => (0.5, 0.1),
    :bottomright => (0.9, 0.1),
)

# Give each annotation coordinates based on specified position
locate_annotation(sp::Subplot, rel::Tuple, label::PlotText) = (
    map(1:length(rel), (:x, :y, :z)) do i, letter
        _relative_position(
            axis_limits(sp, letter)...,
            rel[i] * pct,
            sp[get_attr_symbol(letter, :axis)][:scale],
        )
    end...,
    label,
)

locate_annotation(sp::Subplot, x, y, label::PlotText) = (x, y, label)
locate_annotation(sp::Subplot, x, y, z, label::PlotText) = (x, y, z, label)
locate_annotation(sp::Subplot, pos::Symbol, label::PlotText) =
    locate_annotation(sp, position_multiplier[pos], label)

# -----------------------------------------------------------------------

function expand_extrema!(a::Axis, surf::Surface)
    ex = a[:extrema]
    foreach(x -> expand_extrema!(ex, x), surf.surf)
    return ex
end

"For the case of representing a surface as a function of x/y... can possibly avoid allocations."
struct SurfaceFunction <: AbstractSurface
    f::Function
end

# -----------------------------------------------------------------------

# # I don't want to clash with ValidatedNumerics, but this would be nice:
# ..(a::T, b::T) = (a, b)

# -----------------------------------------------------------------------

# style is :open or :closed (for now)
struct Arrow
    style::Symbol
    side::Symbol  # :head (default), :tail, or :both
    headlength::Float64
    headwidth::Float64
end

"""
    arrow(args...)

Define arrowheads to apply to lines - args are `style` (`:open` or `:closed`),
`side` (`:head`, `:tail` or `:both`), `headlength` and `headwidth`
"""
function arrow(args...)
    style, side = :simple, :head
    headlength = headwidth = 0.3
    setlength = false
    for arg in args
        T = typeof(arg)
        if T == Symbol
            if arg in (:head, :tail, :both)
                side = arg
            else
                style = arg
            end
        elseif T <: Number
            # first we apply to both, but if there's more, then only change width after the first number
            headwidth = Float64(arg)
            if !setlength
                headlength = headwidth
            end
            setlength = true
        elseif T <: Tuple && length(arg) == 2
            headlength, headwidth = Float64(arg[1]), Float64(arg[2])
        else
            @warn "Skipped arrow arg $arg"
        end
    end
    return Arrow(style, side, headlength, headwidth)
end

# allow for do-block notation which gets called on every valid start/end pair which
# we need to draw an arrow
function add_arrows(func::Function, x::AVec, y::AVec)
    for i in 2:length(x)
        xyprev = (x[i - 1], y[i - 1])
        xy = (x[i], y[i])
        if ok(xyprev) && ok(xy)
            if i == length(x) || !ok(x[i + 1], y[i + 1])
                # add the arrow from xyprev to xy
                func(xyprev, xy)
            end
        end
    end
    return
end

# -----------------------------------------------------------------------
"create a BezierCurve for plotting"
mutable struct BezierCurve{T <: Tuple}
    control_points::Vector{T}
end

function (bc::BezierCurve)(t::Real)
    p = (0.0, 0.0)
    n = length(bc.control_points) - 1
    for i in 0:n
        p = p .+ bc.control_points[i + 1] .* binomial(n, i) .* (1 - t)^(n - i) .* t^i
    end
    return p
end

@deprecate curve_points coords

coords(curve::BezierCurve, n::Integer = 30; range = [0, 1]) =
    map(curve, Base.range(first(range), stop = last(range), length = n))

function extrema_plus_buffer(v, buffmult = 0.2)
    vmin, vmax = ignorenan_extrema(v)
    vdiff = vmax - vmin
    buffer = vdiff * buffmult
    return vmin - buffer, vmax + buffer
end

### Legend

@add_attributes subplot struct Legend
    background_color = :match
    foreground_color = :match
    position = :best
    title = nothing
    font::Font = font(8)
    title_font::Font = font(11)
    column = 1
end :match = (
    :legend_font_family,
    :legend_font_color,
    :legend_title_font_family,
    :legend_title_font_color,
)

#=

# HDF5 Plots: Save/replay plots to/from HDF5

# Usage
Write to .hdf5 file using:
    p = plot(...)
   Plots.hdf5plot_write(p, "plotsave.hdf5")

Read from .hdf5 file using:
    pyplot()  # Must first select backend
    pread = Plots.hdf5plot_read("plotsave.hdf5")
    display(pread)

# TODO
 1. Support more features.
    - GridLayout known not to be working.
 2. Improve error handling.
    - Will likely crash if file format is off.
 3. Save data in a folder parallel to "plot".
    - Will make it easier for users to locate data.
    - Use HDF5 reference to link data?
 4. Develop an actual versioned file format.
    - Should have some form of backward compatibility.
    - Should be reliable for archival purposes.
 5. Fix construction of plot object with hdf5plot_read.
    - Layout doesn't seem to get transferred well (ex: `Plots._examples[40]`).
    - Not building object correctly when backends do not natively support
      a certain feature (ex: :steppre)
    - No support for CategoricalArrays.* structures. But they appear to be
      brought into `Plots._examples[25,30]` through DataFrames.jl - so we can't
      really reference them in this code.
=#

"""
    _hdf5_implementation

Create module (namespace) for implementing HDF5 "plots".
(Avoid name collisions, while keeping names short)
"""
module _hdf5_implementation  # Tools required to implements HDF5 "plots"

    import Dates

    # Plots.jl imports HDF5 to main:
    import ..HDF5
    import ..HDF5: Group, Dataset

    import ..Colors, ..Colorant
    import ..PlotUtils.ColorSchemes.ColorScheme

    import ..HDF5Backend, .._current_plots_version
    import ..HDF5PLOT_MAP_STR2TELEM, ..HDF5PLOT_MAP_TELEM2STR
    import ..HDF5Plot_PlotRef, ..HDF5PLOT_PLOTREF
    import ..BoundingBox, ..Extrema, ..Length
    import ..RecipesPipeline.datetimeformatter
    import ..PlotUtils.ColorPalette,
        ..PlotUtils.CategoricalColorGradient, ..PlotUtils.ContinuousColorGradient
    import ..Surface, ..Shape, ..Arrow
    import ..GridLayout, ..RootLayout
    import ..Font, ..PlotText, ..SeriesAnnotations
    import ..Axis, ..Subplot, ..Plot
    import ..AKW, ..KW, ..DefaultsDict
    import .._axis_defaults
    import ..plot, ..plot!

    # Types that already have built-in HDF5 support (just write out natively):
    const HDF5_SupportedTypes = Union{Number, String}

    # Dispatch types:
    struct CplxTuple end  # Identifies a "complex" tuple structure (not merely numbers)

    # HDF5 reader will auto-detect type correctly:
    struct HDF5_AutoDetect end  # See HDF5_SupportedTypes

    if length(HDF5PLOT_MAP_TELEM2STR) < 1
        # Possible element types of high-level data types:
        # (Used to add type information as an HDF5 string attribute)
        # (Also used to dispatch appropriate read function through _read_typed())
        _telem2str = Dict{String, Type}(
            "NOTHING" => Nothing,
            "SYMBOL" => Symbol,
            "RGBA" => Colorant,  # Write out any Colorant to an #RRGGBBAA string
            "TUPLE" => Tuple,
            "CTUPLE" => CplxTuple,
            "EXTREMA" => Extrema,
            "LENGTH" => Length,
            "ARRAY" => Array,  # Array{Any} (because Array{T<:Union{Number, String}} natively supported by HDF5)

            # Sub-structure types:
            "T_DATETIMEFORMATTER" => typeof(datetimeformatter),

            # Sub-structure types:
            "DEFAULTSDICT" => DefaultsDict,
            "FONT" => Font,
            "BOUNDINGBOX" => BoundingBox,
            "GRIDLAYOUT" => GridLayout,
            "ROOTLAYOUT" => RootLayout,
            "SERIESANNOTATIONS" => SeriesAnnotations,
            "PLOTTEXT" => PlotText,
            "SHAPE" => Shape,
            "ARROW" => Arrow,
            "COLORSCHEME" => ColorScheme,
            "COLORPALETTE" => ColorPalette,
            "CONT_COLORGRADIENT" => ContinuousColorGradient,
            "CAT_COLORGRADIENT" => CategoricalColorGradient,
            "AXIS" => Axis,
            "SURFACE" => Surface,
            "SUBPLOT" => Subplot,
        )
        merge!(HDF5PLOT_MAP_STR2TELEM, _telem2str)  # Faster to create than push!()??
        merge!(
            HDF5PLOT_MAP_TELEM2STR,
            Dict{Type, String}(v => k for (k, v) in HDF5PLOT_MAP_STR2TELEM),
        )
    end

    # Helper functions

    h5plotpath(plotname::String) = "plots/$plotname"

    _hdf5_merge!(dest::AKW, src::AKW) =
        for (k, v) in src
        if isa(v, Axis)
            _hdf5_merge!(dest[k].plotattributes, v.plotattributes)
        else
            dest[k] = v
        end
    end

    # _type_for_map returns the type to use with HDF5PLOT_MAP_TELEM2STR[], in case it is not concrete:
    _type_for_map(::Type{T}) where {T} = T # Catch-all
    _type_for_map(::Type{T}) where {T <: BoundingBox} = BoundingBox
    _type_for_map(::Type{T}) where {T <: ColorScheme} = ColorScheme
    _type_for_map(::Type{T}) where {T <: Surface} = Surface

    # Read/write things like type name in attributes
    _write_datatype_attr(ds::Union{Group, Dataset}, ::Type{T}) where {T} =
        HDF5.attributes(ds)["TYPE"] = HDF5PLOT_MAP_TELEM2STR[T]

    function _read_datatype_attr(ds::Union{Group, Dataset})
        Base.haskey(HDF5.attributes(ds), "TYPE") || return HDF5_AutoDetect
        return HDF5PLOT_MAP_STR2TELEM[HDF5.read(HDF5.attributes(ds)["TYPE"])]
    end

    # Type parameter attributes:
    _write_typeparam_attr(ds::Dataset, v::Length{T}) where {T} =
        HDF5.attributes(ds)["TYPEPARAM"] = string(T) # Need to add units for Length

    _read_typeparam_attr(ds::Dataset) = HDF5.read(HDF5.attributes(ds)["TYPEPARAM"])

    _write_length_attr(grp::Group, v::Vector) = HDF5.attributes(grp)["LENGTH"] = length(v)
    _read_length_attr(::Type{Vector}, grp::Group) = HDF5.read(HDF5.attributes(grp)["LENGTH"])

    _write_size_attr(grp::Group, v::Array) = HDF5.attributes(grp)["SIZE"] = [size(v)...]

    _read_size_attr(::Type{Array}, grp::Group) =
        tuple(HDF5.read(HDF5.attributes(grp)["SIZE"])...)

    # _write_typed(): Simple (leaf) datatypes. (Labels with type name.)

    set_value!(grp::Group, name::String, v) = (grp[name] = v; grp[name])

    # Default behaviour: Assumes value is supported by HDF5 format
    _write_typed(grp::Group, name::String, v::HDF5_SupportedTypes) =
        (set_value!(grp, name, v); nothing)  # No need to _write_datatype_attr

    _write_typed(grp::Group, name::String, v::Nothing) =
        _write_datatype_attr(set_value!(grp, name, "nothing"), Nothing) # Redundancy check/easier to read HDF5 file

    _write_typed(grp::Group, name::String, v::Symbol) =
        _write_datatype_attr(set_value!(grp, name, string(v)), Symbol)

    _write_typed(grp::Group, name::String, v::Colorant) =
        _write_datatype_attr(set_value!(grp, name, "#" * Colors.hex(v, :RRGGBBAA)), Colorant)

    _write_typed(grp::Group, name::String, v::Extrema) =
        _write_datatype_attr(set_value!(grp, name, [v.emin, v.emax]), Extrema)  # More compact than writing struct

    function _write_typed(grp::Group, name::String, v::Length)
        grp[name] = v.value
        _write_datatype_attr(grp[name], Length)
        return _write_typeparam_attr(grp[name], v)
    end

    _write_typed(grp::Group, name::String, v::typeof(datetimeformatter)) =
        _write_datatype_attr(set_value!(grp, name, string(v)), typeof(datetimeformatter))  # Just write something that helps reader

    _write_typed(grp::Group, name::String, v::Array{T}) where {T <: Number} =
        (set_value!(grp, name, v); nothing)  # No need to _write_datatype_attr

    _write_typed(grp::Group, name::String, v::AbstractRange) =
        _write_typed(grp, name, collect(v)) # For now

    # Helper functions for writing complex data structures

    # Write an array using HDF5 hierarchy (when not using simple numeric eltype):
    function _write_harray(grp::Group, name::String, v::Array)
        sgrp = HDF5.create_group(grp, name)
        lidx = LinearIndices(size(v))

        for iter in eachindex(v)
            coord = lidx[iter]
            elem = v[iter]
            idxstr = join(coord, "_")
            _write_typed(sgrp, "v$idxstr", elem)
        end

        return _write_size_attr(sgrp, v)
    end

    # Write Dict without tagging with type:
    _write(grp::Group, name::String, d::AbstractDict) =
    let sgrp = HDF5.create_group(grp, name)
        for (k, v) in d
            kstr = string(k)
            _write_typed(sgrp, kstr, v)
        end
    end

    # Write out arbitrary `struct`s:
    _writestructgeneric(grp::Group, obj::T) where {T} =
        for fname in fieldnames(T)
        v = getfield(obj, fname)
        _write_typed(grp, String(fname), v)
    end

    # _write_typed(): More complex structures. (Labels with type name.)

    # Catch-all (default behaviour for `struct`s):
    function _write_typed(grp::Group, name::String, v::T) where {T}
        # NOTE: need "name" parameter so that call signature is same with built-ins
        MT = _type_for_map(T)
        try # Check to see if type is supported
            typestr = HDF5PLOT_MAP_TELEM2STR[MT]
        catch
            @warn "HDF5Plots does not yet support structs of type `$MT`\n\n$grp"
            return
        end

        # If attribute is supported and no writer is defined, then this should work:
        objgrp = HDF5.create_group(grp, name)
        _write_datatype_attr(objgrp, MT)
        return _writestructgeneric(objgrp, v)
    end

    function _write_typed(grp::Group, name::String, v::Array{T}) where {T}
        _write_harray(grp, name, v)
        return _write_datatype_attr(grp[name], Array) # Any
    end

    function _write_typed(grp::Group, name::String, v::Tuple, ::Type{ELT}) where {ELT <: Number} # Basic Tuple
        _write_typed(grp, name, [v...])
        return _write_datatype_attr(grp[name], Tuple)
    end
    function _write_typed(grp::Group, name::String, v::Tuple, ::Type) # CplxTuple
        _write_harray(grp, name, [v...])
        return _write_datatype_attr(grp[name], CplxTuple)
    end
    _write_typed(grp::Group, name::String, v::Tuple) = _write_typed(grp, name, v, eltype(v))

    _write_typed(grp::Group, name::String, v::Dict) = nothing

    function _write_typed(grp::Group, name::String, d::DefaultsDict) # Typically for plot attributes
        _write(grp, name, d)
        return _write_datatype_attr(grp[name], DefaultsDict)
    end

    function _write_typed(grp::Group, name::String, v::Axis)
        sgrp = HDF5.create_group(grp, name)
        # Ignore: sps::Vector{Subplot}
        _write_typed(sgrp, "plotattributes", v.plotattributes)
        return _write_datatype_attr(sgrp, Axis)
    end

    function _write_typed(grp::Group, name::String, v::Subplot)
        # Not for use in main "Plot.subplots[]" hierarchy.  Just establishes reference with subplot_index.
        sgrp = HDF5.create_group(grp, name)
        _write_typed(sgrp, "index", v[:subplot_index])
        _write_datatype_attr(sgrp, Subplot)
        return
    end

    _write_typed(grp::Group, name::String, v::Plot) = nothing  # Don't write plot references

    # _write(): Write out more complex structures
    # NOTE: No need to write out type information (inferred from hierarchy)

    function _write(grp::Group, sp::Subplot{HDF5Backend})
        _write_typed(grp, "attr", sp.attr)

        listgrp = HDF5.create_group(grp, "series_list")
        _write_length_attr(listgrp, sp.series_list)
        for (i, series) in enumerate(sp.series_list)
            # Just write .plotattributes part:
            _write(listgrp, "$i", series.plotattributes)
        end
        return
    end

    function _write(grp::Group, plt::Plot{HDF5Backend})
        _write_typed(grp, "attr", plt.attr)

        listgrp = HDF5.create_group(grp, "subplots")
        _write_length_attr(listgrp, plt.subplots)
        for (i, sp) in enumerate(plt.subplots)
            sgrp = HDF5.create_group(listgrp, "$i")
            _write(sgrp, sp)
        end
        return
    end

    function hdf5plot_write(
            plt::Plot{HDF5Backend},
            path::AbstractString;
            name::String = "_unnamed",
        )
        return HDF5.h5open(path, "w") do file
            HDF5.write_dataset(file, "VERSION_INFO", string(_current_plots_version))
            grp = HDF5.create_group(file, h5plotpath(name))
            _write(grp, plt)
        end
    end

    # _read(): Read data, but not type information.

    # Types with built-in HDF5 support:
    _read(::Type{HDF5_AutoDetect}, ds::Dataset) = HDF5.read(ds)

    function _read(::Type{Nothing}, ds::Dataset)
        nstr = "nothing"
        v = HDF5.read(ds)
        nstr == v || throw(
            Meta.ParseError("_read(::Nothing, ::Group): Read $v != $nstr:\n$(HDF5.name(ds))"),
        )
        return
    end
    _read(::Type{Symbol}, ds::Dataset) = Symbol(HDF5.read(ds))
    _read(::Type{Colorant}, ds::Dataset) = parse(Colorant, HDF5.read(ds))
    _read(::Type{Tuple}, ds::Dataset) = tuple(HDF5.read(ds)...)
    _read(::Type{Extrema}, ds::Dataset) =
    let v = HDF5.read(ds)
        Extrema(v[1], v[2])
    end
    function _read(::Type{Length}, ds::Dataset)
        TUNIT = Symbol(_read_typeparam_attr(ds))
        v = HDF5.read(ds)
        return Length{TUNIT, typeof(v)}(v)
    end
    _read(::Type{typeof(datetimeformatter)}, ds::Dataset) = datetimeformatter

    # Helper functions for reading in complex data structures

    # When type is unknown, _read_typed() figures it out:
    function _read_typed(grp::Group, name::String)
        ds = grp[name]
        return _read(_read_datatype_attr(ds), ds)
    end

    # _readstructgeneric: Needs object values to be written out with _write_typed():
    function _readstructgeneric(::Type{T}, grp::Group) where {T}
        vlist = Array{Any}(nothing, fieldcount(T))
        for (i, fname) in enumerate(fieldnames(T))
            vlist[i] = _read_typed(grp, String(fname))
        end
        return T(vlist...)
    end

    # Read KW from group:
    function _read(::Type{KW}, grp::Group)
        d = KW()
        gkeys = keys(grp)
        for k in gkeys
            try
                v = _read_typed(grp, k)
                d[Symbol(k)] = v
            catch e
                @warn "Could not read field $k" e grp
            end
        end
        return d
    end

    # _read(): More complex structures.

    # Catch-all (default behaviour for `struct`s):
    _read(T::Type, grp::Group) = _readstructgeneric(T, grp)

    function _read(::Type{Array}, grp::Group) # Array{Any}
        sz = _read_size_attr(Array, grp)
        tuple(0) == sz && return []
        result = Array{Any}(undef, sz)
        lidx = LinearIndices(sz)

        for iter in eachindex(result)
            coord = lidx[iter]
            idxstr = join(coord, "_")
            result[iter] = _read_typed(grp, "v$idxstr")
        end

        # Hack: Implicitly make Julia detect element type.
        #       (Should probably write it explicitly to file)
        result = [elem for elem in result]  # Potentially make more specific
        return reshape(result, sz)
    end

    _read(::Type{CplxTuple}, grp::Group) = tuple(_read(Array, grp)...)

    function _read(::Type{GridLayout}, grp::Group)
        # parent = _read_typed(grp, "parent")  # Can't use generic reader
        parent = RootLayout()  # TODO: support parent???
        minpad = _read_typed(grp, "minpad")
        bbox = _read_typed(grp, "bbox")
        grid = _read_typed(grp, "grid")
        widths = _read_typed(grp, "widths")
        heights = _read_typed(grp, "heights")
        attr = KW() # TODO support attr: _read_typed(grp, "attr")

        return GridLayout(parent, minpad, bbox, grid, widths, heights, attr)
    end
    # Defaults depends on context. So: user must constructs with defaults, then read.
    function _read(::Type{DefaultsDict}, grp::Group)
        # User should set DefaultsDict.defaults to one of:
        #    _plot_defaults, _subplot_defaults, _axis_defaults, _series_defaults
        path = HDF5.name(ds)
        return @warn "Cannot yet read DefaultsDict using _read_typed():\n    $path\nCannot fully reconstruct plot."
    end

    # 1st arg appears to be ref to subplots. Seems to work without it.
    _read(::Type{Axis}, grp::Group) =
        Axis([], DefaultsDict(_read(KW, grp["plotattributes"]), _axis_defaults))

    # Not for use in main "Plot.subplots[]" hierarchy.  Just establishes reference with subplot_index.
    _read(::Type{Subplot}, grp::Group) =
        HDF5PLOT_PLOTREF.ref.subplots[_read_typed(grp, "index")]

    # _read(): Main plot structures

    function _read(grp::Group, sp::Subplot)
        listgrp = HDF5.open_group(grp, "series_list")
        nseries = _read_length_attr(Vector, listgrp)

        for i in 1:nseries
            sgrp = HDF5.open_group(listgrp, "$i")
            seriesinfo = _read(KW, sgrp)

            plot!(sp, seriesinfo[:x], seriesinfo[:y]) # Add data & create data structures
            _hdf5_merge!(sp.series_list[end].plotattributes, seriesinfo)
        end

        # Perform after adding series... otherwise values get overwritten:
        agrp = HDF5.open_group(grp, "attr")
        _hdf5_merge!(sp.attr, _read(KW, agrp))

        return sp
    end

    function _read_plot(grp::Group)
        listgrp = HDF5.open_group(grp, "subplots")
        n = _read_length_attr(Vector, listgrp)

        # Construct new plot, +allocate subplots:
        plt = plot(layout = n)
        HDF5PLOT_PLOTREF.ref = plt  # Used when reading "layout"

        agrp = HDF5.open_group(grp, "attr")
        _hdf5_merge!(plt.attr, _read(KW, agrp))

        for (i, sp) in enumerate(plt.subplots)
            sgrp = HDF5.open_group(listgrp, "$i")
            _read(sgrp, sp)
        end

        return plt
    end

    hdf5plot_read(path::AbstractString; name::String = "_unnamed") =
        HDF5.h5open(path, "r") do file
        grp = HDF5.open_group(file, h5plotpath("_unnamed"))
        return _read_plot(grp)
    end

end  # module _hdf5_implementation

# Implement Plots.jl backend interface for HDF5Backend

is_marker_supported(::HDF5Backend, shape::Shape) = true

# Create the window/figure for this backend.
function _create_backend_figure(plt::Plot{HDF5Backend}) end

# Set up the subplot within the backend object.
function _initialize_subplot(plt::Plot{HDF5Backend}, sp::Subplot{HDF5Backend}) end

# Add one series to the underlying backend object.
# Called once per series
# NOTE: Seems to be called when user calls plot()... even if backend
#       plot, sp.o has not yet been constructed...
function _series_added(plt::Plot{HDF5Backend}, series::Series) end

# When series data is added/changed, this callback can do dynamic updates to the backend object.
# note: if the backend rebuilds the plot from scratch on display, then you might not do anything here.
function _series_updated(plt::Plot{HDF5Backend}, series::Series) end

# called just before updating layout bounding boxes... in case you need to prep
# for the calcs
function _before_layout_calcs(plt::Plot{HDF5Backend}) end

# Set the (left, top, right, bottom) minimum padding around the plot area
# to fit ticks, tick labels, guides, colorbars, etc.
function _update_min_padding!(sp::Subplot{HDF5Backend}) end

# Override this to update plot items (title, xlabel, etc), and add annotations (plotattributes[:annotations])
function _update_plot_object(plt::Plot{HDF5Backend}) end

# ----------------------------------------------------------------

# Display/show the plot (open a GUI window, or browser page, for example).
function _display(plt::Plot{HDF5Backend})
    msg = "HDF5 interface does not support `display()` function."
    msg *= "\nUse `Plots.hdf5plot_write(::String)` method to write to .HDF5 \"plot\" file instead."
    @warn msg
    return
end

# Interface actually required to use HDF5Backend

hdf5plot_write(plt::Plot{HDF5Backend}, path::AbstractString) =
    _hdf5_implementation.hdf5plot_write(plt, path)
hdf5plot_write(path::AbstractString) = _hdf5_implementation.hdf5plot_write(current(), path)
hdf5plot_read(path::AbstractString) = _hdf5_implementation.hdf5plot_read(path)

"""
    theme(s::Symbol)

Specify the colour theme for plots.
"""
function theme(s::Symbol; kw...)
    defaults = if haskey(PlotThemes._themes, s)
        copy(PlotThemes._themes[s].defaults)
    else
        @warn ":$s is not a known theme, using :default"
        Dict{Symbol, Any}()
    end
    return _theme(s, defaults; kw...)
end

function _theme(s::Symbol, defaults::AKW; kw...)
    # Reset to defaults to overwrite active theme
    reset_defaults()

    # Set the theme's gradient as default
    if haskey(defaults, :colorgradient)
        PlotUtils.default_cgrad(pop!(defaults, :colorgradient))
    else
        PlotUtils.default_cgrad(:default)
    end

    # maybe overwrite the theme's gradient
    kw = KW(kw)
    if haskey(kw, :colorgradient)
        PlotUtils.default_cgrad(pop!(kw, :colorgradient))
    end

    # Set the theme's defaults
    default(; defaults..., kw...)
    return
end

@deprecate set_theme(s) theme(s)

@userplot ShowTheme

_color_functions =
    KW(:protanopic => protanopic, :deuteranopic => deuteranopic, :tritanopic => tritanopic)
_get_showtheme_args(thm::Symbol) = thm, identity
_get_showtheme_args(thm::Symbol, func::Symbol) = thm, get(_color_functions, func, identity)

@recipe function showtheme(st::ShowTheme)
    thm, cfunc = _get_showtheme_args(st.args...)
    defaults = PlotThemes._themes[thm].defaults

    # get the gradient
    gradient_colors = color_list(cgrad(get(defaults, :colorgradient, :default)))
    colorgradient = cgrad(cfunc.(RGB.(gradient_colors)))

    # get the palette
    cp = color_list(palette(get(defaults, :palette, :default)))
    cp = cfunc.(RGB.(cp))

    # apply the theme
    for k in keys(defaults)
        k in (:colorgradient, :palette) && continue
        def = defaults[k]
        arg = get(_keyAliases, k, k)
        plotattributes[arg] = if typeof(def) <: Colorant
            cfunc(RGB(def))
        elseif eltype(def) <: Colorant
            cfunc.(RGB.(def))
        elseif occursin("color", string(arg)) && !startswith(string(arg), "colorbar")
            cfunc.(RGB.(plot_color.(def)))
        else
            def
        end
    end

    Random.seed!(1)

    label := ""
    colorbar := false
    layout := (2, 3)

    for j in 1:4
        @series begin
            subplot := 1
            color_palette := cp
            seriestype := :path
            cumsum(randn(50))
        end

        @series begin
            subplot := 2
            seriestype := :scatter
            color_palette := cp
            marker := (:circle, :diamond, :star5, :square)[j]
            randn(10), randn(10)
        end
    end

    @series begin
        subplot := 3
        seriestype := :histogram
        color_palette := cp
        randn(1_000) .+ (0:2:4)'
    end

    f(r) = sin(r) / r
    _norm(x, y) = norm([x, y])
    x = y = range(-3π, stop = 3π, length = 30)
    z = f.(_norm.(x, y'))
    wi = 2:3:30

    @series begin
        subplot := 4
        seriestype := :heatmap
        seriescolor := colorgradient
        xticks := ((-2π):(2π):(2π), string.(-2:2:2, "π"))
        yticks := ((-2π):(2π):(2π), string.(-2:2:2, "π"))
        x, y, z
    end

    @series begin
        subplot := 5
        seriestype := :surface
        seriescolor := colorgradient
        xticks := ((-2π):(2π):(2π), string.(-2:2:2, "π"))
        yticks := ((-2π):(2π):(2π), string.(-2:2:2, "π"))
        x, y, z
    end

    n = 100
    ts = range(0, stop = 10π, length = n)
    x = (0.1ts) .* cos.(ts)
    y = (0.1ts) .* sin.(ts)
    z = 1:n

    @series begin
        subplot := 6
        seriescolor := colorgradient
        linewidth := 3
        line_z := z
        x, y, z
    end
end

# miscellaneous tests (not fitting into other test files)

@testset "Infrastructure" begin
    @test_nowarn JSON.Parser.parse(
        String(read(joinpath(dirname(pathof(Plots)), "..", "..", ".zenodo.json"))),
    )
end

@testset "Plotly standalone" begin
    @test Plots._plotly_local_file_path[] ≡ nothing
    temp = Plots._use_local_dependencies[]
    withenv("PLOTS_HOST_DEPENDENCY_LOCAL" => true) do
        Plots._plots_plotly_defaults()
        @test Plots._plotly_local_file_path[] isa String
        @test isfile(Plots._plotly_local_file_path[])
        @test Plots._use_local_dependencies[] = true
    end
    Plots._plotly_local_file_path[] = nothing
    Plots._use_local_dependencies[] = temp
end

@testset "NoFail" begin
    Plots.with(:unicodeplots) do
        @test backend() == Plots.UnicodePlotsBackend()

        dsp = TextDisplay(IOContext(IOBuffer(), :color => true))

        @testset "plot" begin
            for pl in [
                    histogram([1, 0, 0, 0, 0, 0]),
                    plot([missing]),
                    plot([missing, missing]),
                    plot(fill(missing, 10)),
                    plot([missing; 1:4]),
                    plot([fill(missing, 10); 1:4]),
                    plot([1 1; 1 missing]),
                    plot(["a" "b"; missing "d"], [1 2; 3 4]),
                ]
                display(dsp, pl)
            end
            @test_nowarn plot(x -> x^2, 0, 2)
        end

        @testset "bar" begin
            p = bar([3, 2, 1], [1, 2, 3])
            @test p isa Plots.Plot
            @test display(dsp, p) isa Nothing
        end

        @testset "gui" begin
            open(tempname(), "w") do io
                redirect_stdout(io) do
                    gui(plot())
                end
            end
        end

        @testset "axis scales" begin
            pl = plot(1:5, xscale = :log2, yscale = :ln)
            @test pl[1][:xaxis][:scale] ≡ :log2
            @test pl[1][:yaxis][:scale] ≡ :ln
        end
    end
end

@testset "bool_env" begin
    @test Plots.bool_env("FOO", "true")
    @test Plots.bool_env("FOO", "1")
    @test !Plots.bool_env("FOO", "false")
    @test !Plots.bool_env("FOO", "0")
end

@testset "Themes" begin
    @test showtheme(:dark) isa Plots.Plot
end

@testset "maths" begin
    @test Plots.floor_base(15.0, 10.0) ≈ 10
    @test Plots.ceil_base(15.0, 10.0) ≈ 10^2
    @test Plots.floor_base(4.2, 2.0) ≈ 2^2
    @test Plots.ceil_base(4.2, 2.0) ≈ 2^3
    @test Plots.floor_base(1.5 * ℯ, ℯ) ≈ ℯ
    @test Plots.ceil_base(1.5 * ℯ, ℯ) ≈ ℯ^2
end

@testset "plotattr" begin
    tmp = tempname()
    open(tmp, "w") do io
        redirect_stdout(io) do
            @test_throws ErrorException plotattr(:WrongAttrType)
            @test_throws ErrorException plotattr("WrongAttribute")
            plotattr("seriestype")
            plotattr(:Plot)
            # plotattr()  # interactive (JLFzf)
        end
    end
    str = join(readlines(tmp), "")
    @test occursin("seriestype", str)
    @test occursin("Plot attributes", str)
    @test Plots.attrtypes() == "Series, Subplot, Plot, Axis"
end

@testset "legend" begin
    @test isa(
        Plots.legend_pos_from_angle(20, 0.0, 0.5, 1.0, 0.0, 0.5, 1.0),
        NTuple{2, <:AbstractFloat},
    )
    @test Plots.legend_anchor_index(-1) == 1
    @test Plots.legend_anchor_index(+0) == 2
    @test Plots.legend_anchor_index(+1) == 3

    @test Plots.legend_angle(:foo_bar) == (45, :inner)
    @test Plots.legend_angle(20.0) == Plots.legend_angle((20.0, :inner)) == (20.0, :inner)
    @test Plots.legend_angle((20.0, 10.0)) == (20.0, 10.0)
end

@testset "axis letter" begin
    # a custom type for dispacthing the axis-letter-testing recipe
    struct MyType <: Number
        val::Float64
    end
    value(m::MyType) = m.val
    data = MyType.(sort(randn(20)))

    # A recipe that puts the axis letter in the title
    @recipe function f(::Type{T}, m::T) where {T <: AbstractArray{<:MyType}}
        title --> string(plotattributes[:letter])
        value.(m)
    end

    @testset "orientation" begin
        for f in (histogram, barhist, stephist, scatterhist), o in (:vertical, :horizontal)
            sp = f(data, orientation = o).subplots[1]
            @test sp.attr[:title] == (o ≡ :vertical ? "x" : "y")
        end
    end

    @testset "$f" for f in (hline, hspan)
        @test f(data).subplots[1].attr[:title] == "y"
    end

    @testset "$f" for f in (vline, vspan)
        @test f(data).subplots[1].attr[:title] == "x"
    end
end

@testset "tex_output_standalone" begin
    pl = plot(1:5)
    pl2 = plot(pl, tex_output_standalone = true)
    @test !pl[:tex_output_standalone]
    @test pl2[:tex_output_standalone]
    plot!(pl, tex_output_standalone = true)
    @test pl[:tex_output_standalone]
end

@testset "get_axis_limits" begin
    x = [0.1, 5]
    p1 = plot(x, [5, 0.1], yscale = :log10)
    p2 = plot!(identity)
    @test all(RecipesPipeline.get_axis_limits(p1, :x) .== x)
    @test all(RecipesPipeline.get_axis_limits(p2, :x) .== x)
end

@testset "Slicing" begin
    @test plot(1:5, fillrange = 0)[1][1][:fillrange] == 0
    data4 = rand(4, 4)
    mat = reshape(1:8, 2, 4)
    sp = plot(data4, ribbon = (mat, mat))[1]
    for i in axes(data4, 1)
        for attribute in (:fillrange, :ribbon)
            nt = NamedTuple{tuple(attribute)}
            get_attr(pl) = pl[1][i][attribute]
            @test plot(data4; nt(0)...) |> get_attr == 0
            @test plot(data4; nt(Ref([1, 2]))...) |> get_attr == [1.0, 2.0]
            @test plot(data4; nt(Ref([1 2]))...) |> get_attr == (iseven(i) ? 2 : 1)
            @test plot(data4; nt(Ref(mat))...) |> get_attr == [2(i - 1) + 1, 2i]
        end
        @test sp[i][:ribbon] == ([2(i - 1) + 1, 2i], [2(i - 1) + 1, 2i])
    end
end

@testset "Extract subplot" begin  # github.com/JuliaPlots/Plots.jl/issues/4045
    x1, y1 = -1:5, 4:10
    x2, y2 = rand(10), rand(10)
    p1, p2 = plot(x1, y1), plot(x2, y2)
    pl = plot(p1, p2)  # full plot, with 2 subplots

    pl1 = plot(pl.subplots[1])
    series = first(first(pl1.subplots).series_list)
    @test series[:x] == x1
    @test series[:y] == y1

    pl2 = plot(pl.subplots[2])
    series = first(first(pl2.subplots).series_list)
    @test series[:x] == x2
    @test series[:y] == y2
end

@testset "Empty Plot / Subplots" begin
    pl = plot(map(_ -> plot(1:2, [1:2 2:3]), 1:2)...)
    empty!(pl)
    @test length(pl.subplots) == 2
    @test length(first(pl).series_list) == 0
    @test length(last(pl).series_list) == 0

    pl = plot(map(_ -> plot(1:2, [1:2 2:3]), 1:2)...)
    empty!(first(pl))  # clear out only the first subplot
    @test length(pl.subplots) == 2
    @test length(first(pl).series_list) == 0
    @test length(last(pl).series_list) == 2
end

@testset "Measures" begin
    @test 1Plots.mm * 0.1Plots.pct == 0.1Plots.mm
    @test 0.1Plots.pct * 1Plots.mm == 0.1Plots.mm
    @test 1Plots.mm / 0.1Plots.pct == 10Plots.mm
    @test 0.1Plots.pct / 1Plots.mm == 10Plots.mm
end

@testset "docstring" begin
    @test occursin("label", Plots._generate_doclist(Plots._all_series_args))
end

@testset "wrap" begin
    # not sure what is intended here ...
    wrapped = Plots.wrap([:red, :blue])
    @test !isempty(wrapped)
    @test scatter(1:2, color = wrapped) isa Plots.Plot
end

@testset "group" begin
    # from github.com/JuliaPlots/Plots.jl/issues/3630#issuecomment-876001540
    a = repeat(1:3, inner = 4)
    b = repeat(["low", "high"], inner = 2, outer = 3)
    c = repeat(1:2, outer = 6)
    d = [1, 1, 1, 2, 2, 2, 2, 4, 3, 3, 3, 6]
    @test plot(b, d, group = (c, a), layout = (1, 3)) isa Plots.Plot
end

@testset "skipissing" begin
    @test plot(skipmissing(1:5)) isa Plots.Plot
end

Plots.with(:gr) do
    @testset "text" begin
        io = PipeBuffer()
        x = y = range(-3, 3, length = 10)
        extra_kwargs = Dict(
            :series => Dict(:display_option => Plots.GR.OPTION_SHADED_MESH),
            :subplot => Dict(:legend_hfactor => 2),
            :plot => Dict(:foo => nothing),
        )
        show(io, surface(x, y, (x, y) -> exp(-x^2 - y^2); extra_kwargs))
        str = read(io, String)
        @test occursin("extra kwargs", str)
        @test occursin("Series{1}", str)
        @test occursin("SubplotPlot{1}", str)
        @test occursin("Plot:", str)
    end

    @testset "recipes" begin
        @test Plots.seriestype_supported(:path) ≡ :native

        @test plot([1, 2, 5], seriestype = :linearfit) isa Plots.Plot
        @test plot([1, 2, 5], seriestype = :scatterpath) isa Plots.Plot
        @test plot(1:2, 1:2, 1:2, seriestype = :scatter3d) isa Plots.Plot

        let pl = plot(1:2, -1:1, widen = false)
            Plots.abline!([0, 3], [5, -5])
            @test xlims(pl) == (+1, +2)
            @test ylims(pl) == (-1, +1)
        end

        @test Plots.findnz([0 1; 2 0]) == ([2, 1], [1, 2], [2, 1])
    end

    @testset "mesh3d" begin
        x = [0, 1, 2, 0]
        y = [0, 0, 1, 2]
        z = [0, 2, 0, 1]
        i = [0, 0, 0, 1]
        j = [1, 2, 3, 2]
        k = [2, 3, 1, 3]
        # github.com/JuliaPlots/Plots.jl/pull/3868#issuecomment-939446686
        mesh3d(
            x,
            y,
            z;
            connections = (i, j, k),
            fillcolor = [:blue, :red, :green, :yellow],
            fillalpha = 0.5,
        )

        # github.com/JuliaPlots/Plots.jl/pull/3835#issue-1002117649
        p0 = [0.0, 0.0, 0.0]
        p1 = [1.0, 0.0, 0.0]
        p2 = [0.0, 1.0, 0.0]
        p3 = [1.0, 1.0, 0.0]
        p4 = [0.5, 0.5, 1.0]
        pts = [p0, p1, p2, p3, p4]
        x, y, z = broadcast(i -> getindex.(pts, i), (1, 2, 3))
        # [x[i],y[i],z[i]] is the i-th vertix of the mesh
        mesh3d(
            x,
            y,
            z;
            connections = [
                [1, 2, 4, 3], # Quadrangle
                [1, 2, 5], # Triangle
                [2, 4, 5], # Triangle
                [4, 3, 5], # Triangle
                [3, 1, 5],  # Triangle
            ],
            linecolor = :black,
            fillcolor = :blue,
            fillalpha = 0.2,
        )
        @test true
    end

    @testset "fillstyle" begin
        @test histogram(rand(10); fillstyle = :/) isa Plots.Plot
    end

    @testset "showable" begin
        @test showable(MIME("image/png"), plot(1:2))
    end

    @testset "inline" begin
        show(devnull, plot(1:2, display_type = :inline))
    end

    @testset "legends" begin
        @test plot([0:1 reverse(0:1)]; labels = ["a" "b"], leg = (0.5, 0.5)) isa Plots.Plot
        @test plot([0:1 reverse(0:1)]; labels = ["a" "b"], leg = (0.5, :outer)) isa
            Plots.Plot
        @test plot([0:1 reverse(0:1)]; labels = ["a" "b"], leg = (0.5, :inner)) isa
            Plots.Plot
        @test_logs (:warn, r"n° of legend_column.*") png(
            plot(1:2, legend_columns = 10),
            tempname(),
        )
    end

    @testset "cycling" begin
        # see github.com/JuliaPlots/Plots.jl/issues/4561
        # and github.com/JuliaPlots/Plots.jl/issues/2980
        # cycling arguments is a weird Plots feature - maybe remove in `2.0` ?
        x = 0.0:0.1:1
        y = rand(3)
        show(devnull, scatter(x, y))
        # show(devnull, plot(x, y))  # currently unsupported
    end
end

module Plots

if isdefined(Base, :Experimental) && isdefined(Base.Experimental, Symbol("@optlevel"))
    @eval Base.Experimental.@optlevel 1
end
if isdefined(Base, :Experimental) && isdefined(Base.Experimental, Symbol("@max_methods"))
    @eval Base.Experimental.@max_methods 1
end

using Dates, Printf, Statistics, Base64, LinearAlgebra, SparseArrays, Random, TOML
using PrecompileTools, Reexport, RelocatableFolders
using Base.Meta
@reexport using RecipesBase
@reexport using PlotThemes
@reexport using PlotUtils

import RecipesBase: plot, plot!, animate, is_explicit, grid
import RecipesPipeline
import Requires: @require
import RecipesPipeline:
    inverse_scale_func,
    datetimeformatter,
    AbstractSurface,
    group_as_matrix, # for StatsPlots
    dateformatter,
    timeformatter,
    needs_3d_axes,
    DefaultsDict,
    explicitkeys,
    scale_func,
    is_surface,
    Formatted,
    reset_kw!,
    SliceIt,
    Surface,
    pop_kw!,
    Volume,
    is3d
import UnicodeFun
import StatsBase
import Downloads
import Showoff
import Unzip
import JLFzf
import JSON

#! format: off
export
    grid,
    bbox,
    plotarea,
    KW,

    wrap,
    theme,

    plot,
    plot!,
    attr!,

    current,
    default,
    with,
    twinx,
    twiny,

    pie,
    pie!,
    plot3d,
    plot3d!,

    title!,
    annotate!,

    xlims,
    ylims,
    zlims,

    savefig,
    png,
    gui,
    inline,
    closeall,

    backend,
    backends,
    backend_name,
    backend_object,
    aliases,

    Shape,
    text,
    font,
    stroke,
    brush,
    Surface,
    OHLC,
    arrow,
    Segments,
    Formatted,

    Animation,
    frame,
    gif,
    mov,
    mp4,
    webm,
    animate,
    @animate,
    @gif,
    @P_str,

    test_examples,
    iter_segments,
    coords,

    translate,
    translate!,
    rotate,
    rotate!,
    center,
    BezierCurve,

    plotattr,
    scalefontsize,
    scalefontsizes,
    resetfontsizes
#! format: on
# ---------------------------------------------------------

import NaNMath # define functions that ignores NaNs. To overcome the destructive effects of https://github.com/JuliaLang/julia/pull/12563
ignorenan_minimum(x::AbstractArray{<:AbstractFloat}) = NaNMath.minimum(x)
ignorenan_minimum(x) = Base.minimum(x)
ignorenan_maximum(x::AbstractArray{<:AbstractFloat}) = NaNMath.maximum(x)
ignorenan_maximum(x) = Base.maximum(x)
ignorenan_mean(x::AbstractArray{<:AbstractFloat}) = NaNMath.mean(x)
ignorenan_mean(x) = Statistics.mean(x)
ignorenan_extrema(x::AbstractArray{<:AbstractFloat}) = NaNMath.extrema(x)
ignorenan_extrema(x) = Base.extrema(x)

# ---------------------------------------------------------
import Measures
include("plotmeasures.jl")
using .PlotMeasures
import .PlotMeasures: Length, AbsoluteLength, Measure, width, height
# ---------------------------------------------------------

const PLOTS_SEED = 1234
const PX_PER_INCH = 100
const DPI = PX_PER_INCH
const MM_PER_INCH = 25.4
const MM_PER_PX = MM_PER_INCH / PX_PER_INCH

include("types.jl")
include("utils.jl")
include("colorbars.jl")
include("axes.jl")
include("args.jl")
include("components.jl")
include("legend.jl")
include("consts.jl")
include("themes.jl")
include("plot.jl")
include("pipeline.jl")
include("layouts.jl")
include("arg_desc.jl")
include("recipes.jl")
include("animation.jl")
include("examples.jl")
include("plotattr.jl")
include("backends.jl")
const CURRENT_BACKEND = CurrentBackend(:none)
include("output.jl")
include("shorthands.jl")
include("backends/web.jl")
include("init.jl")

end

mutable struct CurrentPlot
    nullableplot::Union{AbstractPlot, Nothing}
end
const CURRENT_PLOT = CurrentPlot(nothing)

isplotnull() = CURRENT_PLOT.nullableplot === nothing

"""
    current()
Returns the Plot object for the current plot
"""
function current()
    isplotnull() && error("No current plot/subplot")
    return CURRENT_PLOT.nullableplot
end
current(plot::AbstractPlot) = (CURRENT_PLOT.nullableplot = plot)

# ---------------------------------------------------------

Base.string(plt::Plot) = "Plot{$(plt.backend) n=$(plt.n)}"
Base.print(io::IO, plt::Plot) = print(io, string(plt))
function Base.show(io::IO, plt::Plot)
    print(io, string(plt))
    sp_ekwargs = getindex.(plt.subplots, :extra_kwargs)
    s_ekwargs = getindex.(plt.series_list, :extra_kwargs)
    (
        isempty(plt[:extra_plot_kwargs]) &&
            all(isempty, sp_ekwargs) &&
            all(isempty, s_ekwargs)
    ) && return
    print(io, "\nCaptured extra kwargs:\n")
    do_show = true
    for (key, value) in plt[:extra_plot_kwargs]
        do_show && println(io, "  Plot:")
        println(io, " "^4, key, ": ", value)
        do_show = false
    end
    do_show = true
    for (i, ekwargs) in enumerate(sp_ekwargs)
        for (key, value) in ekwargs
            do_show && println(io, "  SubplotPlot{$i}:")
            println(io, " "^4, key, ": ", value)
            do_show = false
        end
        do_show = true
    end
    for (i, ekwargs) in enumerate(s_ekwargs)
        for (key, value) in ekwargs
            do_show && println(io, "  Series{$i}:")
            println(io, " "^4, key, ": ", value)
            do_show = false
        end
        do_show = true
    end
    return
end

getplot(plt::Plot) = plt
getattr(plt::Plot, idx::Int = 1) = plt.attr

# ---------------------------------------------------------

"""
The main plot command. Use `plot` to create a new plot object, and `plot!` to add to an existing one:

```
    plot(args...; kw...)                  # creates a new plot window, and sets it to be the current
    plot!(args...; kw...)                 # adds to the `current`
    plot!(plotobj, args...; kw...)        # adds to the plot `plotobj`
```

There are lots of ways to pass in data, and lots of keyword arguments... just try it and it will likely work as expected.
When you pass in matrices, it splits by columns.
To see the list of available attributes, use the `plotattr(attr)`
function, where `attr` is the symbol `:Series`, `:Subplot`, `:Plot`, or `:Axis`.
Pass any attribute to `plotattr` as a String to look up its docstring, e.g., `plotattr("seriestype")`.

# Extended help

## Series attributes
- $(_generate_doclist(_all_series_args))

## Axis attributes
Prepend these with the axis letter (x, y or z)
- $(_generate_doclist(_all_axis_args))

## Subplot attributes
- $(_generate_doclist(_all_subplot_args))

## Plot attributes
- $(_generate_doclist(_all_plot_args))
"""
function RecipesBase.plot(args...; kw...)
    @nospecialize
    # this creates a new plot with args/kw and sets it to be the current plot
    plotattributes = KW(kw)
    Plots.preprocess_attributes!(plotattributes)

    # create an empty Plot then process
    plt = Plot()
    # plt.user_attr = plotattributes
    return _plot!(plt, plotattributes, args)
end

# build a new plot from existing plots
# note: we split into plt1, plt2 and plts_tail so we can dispatch correctly
plot(
    plt1::Plot,
    plt2::Union{PlaceHolder, Plot},
    plts_tail::Union{PlaceHolder, Plot}...;
    kw...,
) = plot!(deepcopy(plt1), deepcopy(plt2), deepcopy.(plts_tail)...; kw...)
function plot!(
        plt1::Plot,
        plt2::Union{PlaceHolder, Plot},
        plts_tail::Union{PlaceHolder, Plot}...;
        kw...,
    )
    @nospecialize
    plotattributes = KW(kw)
    Plots.preprocess_attributes!(plotattributes)

    # build our plot vector from the args
    plts = Plot[plt1]
    plt2 isa PlaceHolder || push!(plts, plt2)
    foreach(p -> p isa PlaceHolder || push!(plts, p), plts_tail)
    n = length(plts)

    # compute the layout
    layout = layout_args(plotattributes, n)[1]
    num_sp = sum(length(p.subplots) for p in plts)

    # create a new plot object, with subplot list/map made of existing subplots.
    # note: we create a new backend figure for this new plot object
    # note: all subplots and series "belong" to this new plot...
    plt = Plot()

    # TODO: build the user_attr dict by creating "Any matrices" for the args of each subplot

    # TODO: replace this with proper processing from a merged user_attr KW
    # update plot args
    for p in plts
        plt.attr = merge(p.attr, plt.attr)  # plt.attr preempts p.attr (for `twinx`)
        plt.n += p.n
    end
    plt[:size] = last(sort(getindex.(plts, :size), by = x -> x[1] * x[2]))
    _update_plot_args(plt, plotattributes)

    # pass new plot to the backend
    plt.o = _create_backend_figure(plt)
    plt.init = true

    series_attr = KW()
    for (k, v) in plotattributes
        is_series_attr(k) && (series_attr[k] = pop!(plotattributes, k))
    end

    # create the layout
    plt.layout, plt.subplots, plt.spmap = build_layout(layout, num_sp, copy(plts))

    # do we need to link any axes together?
    link_axes!(plt.layout, plt[:link])

    # initialize the subplots
    cmdidx = 1
    for (idx, sp) in enumerate(plt.subplots)
        _initialize_subplot(plt, sp)
        serieslist = series_list(sp)
        append!(plt.inset_subplots, sp.plt.inset_subplots)
        sp.plt = plt
        sp.attr[:subplot_index] = idx
        for series in serieslist
            merge!(series.plotattributes, series_attr)
            _slice_series_args!(series.plotattributes, plt, sp, cmdidx)
            push!(plt.series_list, series)
            _series_added(plt, series)
            cmdidx += 1
        end
    end
    ttl_idx = _add_plot_title!(plt)

    # first apply any args for the subplots
    for (idx, sp) in enumerate(plt.subplots)
        _update_subplot_args(plt, sp, idx == ttl_idx ? KW() : plotattributes, idx, false)
    end

    # finish up
    current(plt)
    _do_plot_show(plt, get(plotattributes, :show, default(:show)))
    return plt
end

# this adds to the current plot, or creates a new plot if none are current
function plot!(args...; kw...)
    @nospecialize
    local plt
    try
        plt = current()
    catch
        return plot(args...; kw...)
    end
    return plot!(current(), args...; kw...)
end

# this adds to a specific plot... most plot commands will flow through here
plot(plt::Plot, args...; kw...) = plot!(deepcopy(plt), args...; kw...)

function plot!(plt::Plot, args...; kw...)
    @nospecialize
    plotattributes = KW(kw)
    Plots.preprocess_attributes!(plotattributes)
    # merge!(plt.user_attr, plotattributes)
    return _plot!(plt, plotattributes, args)
end

# -------------------------------------------------------------------------------

# this is the core plotting function.  recursively apply recipes to build
# a list of series KW dicts.
# note: at entry, we only have those preprocessed args which were passed in... no default values yet
function _plot!(plt::Plot, plotattributes, args)
    @nospecialize
    RecipesPipeline.recipe_pipeline!(plt, plotattributes, args)
    current(plt)
    _do_plot_show(plt, plt[:show])
    return plt
end

# we're getting ready to display/output.  prep for layout calcs, then update
# the plot object after
function prepare_output(plt::Plot)
    _before_layout_calcs(plt)

    _wh = plt.attr[:size]
    if length(_wh) != 2
        throw(ArgumentError("plot size must have length = 2, got size = $_wh"))
    end
    w, h = _wh

    plt.layout.bbox = BoundingBox(0mm, 0mm, w * px, h * px)

    # One pass down and back up the tree to compute the minimum padding
    # of the children on the perimeter.  This is an backend callback.
    _update_min_padding!(plt.layout)

    # specific to :plot_title see _add_plot_title!
    force_minpad = get(plt, :force_minpad, ())
    isempty(force_minpad) || for i in eachindex(plt.layout.grid)
        plt.layout.grid[i].minpad = Tuple(
            i === nothing ? j : i for
                (i, j) in zip(force_minpad, plt.layout.grid[i].minpad)
        )
    end

    # now another pass down, to update the bounding boxes
    update_child_bboxes!(plt.layout)

    # update those bounding boxes of inset subplots
    update_inset_bboxes!(plt)

    # the backend callback, to reposition subplots, etc
    return _update_plot_object(plt)
end

"""
    backend_object(plot)

Returns the backend representation of a Plot object.
Returns `nothing` if the backend does not support this.
"""
function backend_object(plt::Plot)
    prepare_output(plt)
    return plt.o
end

# --------------------------------------------------------------------

"""
Extract a subplot from an existing plot.

# Examples
```julia-repl
julia> p1, p2 = plot(1:2), plot(10:20)
julia> pl = plot(p1, p2)  # plot containing 2 subplots

julia> plot(pl.subplots[1])  # extract 1st subplot as a standalone plot
julia> plot(pl.subplots[2])  # extract 2nd subplot as a standalone plot
```
"""
function plot(sp::Subplot, args...; kw...)
    @nospecialize
    plt = Plots.Plot(sp)
    return plot(plt, PlaceHolder(), PlaceHolder(), args...; kw...)
end

# plot to a Subplot
function plot!(sp::Subplot, args...; kw...)
    @nospecialize
    plt = sp.plt
    return plot!(plt, args...; kw..., subplot = findfirst(isequal(sp), plt.subplots))
end

# NOTE: (0,0) is the top-left !!!

to_pixels(m::AbsoluteLength) = m.value / 0.254

const _cbar_width = 5mm
const DEFAULT_BBOX = Ref(BoundingBox(0mm, 0mm, 0mm, 0mm))
const DEFAULT_MINPAD = Ref((20mm, 5mm, 2mm, 10mm))

origin(bbox::BoundingBox) = left(bbox) + width(bbox) / 2, top(bbox) + height(bbox) / 2
left(bbox::BoundingBox) = bbox.x0[1]
top(bbox::BoundingBox) = bbox.x0[2]
right(bbox::BoundingBox) = left(bbox) + width(bbox)
bottom(bbox::BoundingBox) = top(bbox) + height(bbox)
Base.size(bbox::BoundingBox) = (width(bbox), height(bbox))

# Base.:*{T,N}(m1::Length{T,N}, m2::Length{T,N}) = Length{T,N}(m1.value * m2.value)
ispositive(m::Measure) = m.value > 0

# union together bounding boxes
function Base.:+(bb1::BoundingBox, bb2::BoundingBox)
    # empty boxes don't change the union
    ispositive(width(bb1)) || return bb2
    ispositive(height(bb1)) || return bb2
    ispositive(width(bb2)) || return bb1
    ispositive(height(bb2)) || return bb1

    l = min(left(bb1), left(bb2))
    t = min(top(bb1), top(bb2))
    r = max(right(bb1), right(bb2))
    b = max(bottom(bb1), bottom(bb2))
    return BoundingBox(l, t, r - l, b - t)
end

# convert x,y coordinates from absolute coords to percentages...
# returns x_pct, y_pct
function xy_mm_to_pcts(x::AbsoluteLength, y::AbsoluteLength, figw, figh, flipy = true)
    xmm, ymm = x.value, y.value
    if flipy
        ymm = figh.value - ymm  # flip y when origin in bottom-left
    end
    return xmm / figw.value, ymm / figh.value
end

# convert a bounding box from absolute coords to percentages...
# returns an array of percentages of figure size: [left, bottom, width, height]
function bbox_to_pcts(bb::BoundingBox, figw, figh, flipy = true)
    mms = Float64[f(bb).value for f in (left, bottom, width, height)]
    if flipy
        mms[2] = figh.value - mms[2]  # flip y when origin in bottom-left
    end
    return mms ./ Float64[figw.value, figh.value, figw.value, figh.value]
end

Base.show(io::IO, bbox::BoundingBox) = print(
    io,
    "BBox{l,t,r,b,w,h = $(left(bbox)),$(top(bbox)), $(right(bbox)),$(bottom(bbox)), $(width(bbox)),$(height(bbox))}",
)

# -----------------------------------------------------------
# AbstractLayout

Base.show(io::IO, layout::AbstractLayout) = print(io, "$(typeof(layout))$(size(layout))")

make_measure_hor(n::Number) = n * w
make_measure_hor(m::Measure) = m

make_measure_vert(n::Number) = n * h
make_measure_vert(m::Measure) = m

"""
    bbox(x, y, w, h [,originargs...])
    bbox(layout)

Create a bounding box for plotting
"""
function bbox(x, y, w, h, oarg1::Symbol, originargs::Symbol...)
    oargs = vcat(oarg1, originargs...)
    orighor = :left
    origver = :top
    for oarg in oargs
        if oarg === :center
            orighor = origver = oarg
        elseif oarg in (:left, :right, :hcenter)
            orighor = oarg
        elseif oarg in (:top, :bottom, :vcenter)
            origver = oarg
        else
            @warn "Unused origin arg in bbox construction: $oarg"
        end
    end
    return bbox(x, y, w, h; h_anchor = orighor, v_anchor = origver)
end

# create a new bbox
function bbox(x, y, width, height; h_anchor = :left, v_anchor = :top)
    x = make_measure_hor(x)
    y = make_measure_vert(y)
    width = make_measure_hor(width)
    height = make_measure_vert(height)
    left = if h_anchor === :left
        x
    elseif h_anchor in (:center, :hcenter)
        0.5w - 0.5width + x
    else
        1w - x - width
    end
    top = if v_anchor === :top
        y
    elseif v_anchor in (:center, :vcenter)
        0.5h - 0.5height + y
    else
        1h - y - height
    end
    return BoundingBox(left, top, width, height)
end

# this is the available area for drawing everything in this layout... as percentages of total canvas
bbox(layout::AbstractLayout) = layout.bbox
bbox!(layout::AbstractLayout, bb::BoundingBox) = (layout.bbox = bb)

# layouts are recursive, tree-like structures, and most will have a parent field
Base.parent(layout::AbstractLayout) = layout.parent
parent_bbox(layout::AbstractLayout) = bbox(parent(layout))

# padding_w(layout::AbstractLayout) = left_padding(layout) + right_padding(layout)
# padding_h(layout::AbstractLayout) = bottom_padding(layout) + top_padding(layout)
# padding(layout::AbstractLayout) = (padding_w(layout), padding_h(layout))

update_position!(layout::AbstractLayout) = nothing
update_child_bboxes!(
    layout::AbstractLayout,
    minimum_perimeter = [0mm, 0mm, 0mm, 0mm];
    kw...,
) = nothing

left(layout::AbstractLayout) = left(bbox(layout))
top(layout::AbstractLayout) = top(bbox(layout))
right(layout::AbstractLayout) = right(bbox(layout))
bottom(layout::AbstractLayout) = bottom(bbox(layout))
width(layout::AbstractLayout) = width(bbox(layout))
height(layout::AbstractLayout) = height(bbox(layout))

# pass these through to the bbox methods if there's no plotarea
plotarea(layout::AbstractLayout) = bbox(layout)
plotarea!(layout::AbstractLayout, bb::BoundingBox) = bbox!(layout, bb)

attr(layout::AbstractLayout, k::Symbol) = layout.attr[k]
attr(layout::AbstractLayout, k::Symbol, v) = get(layout.attr, k, v)
attr!(layout::AbstractLayout, v, k::Symbol) = (layout.attr[k] = v)
hasattr(layout::AbstractLayout, k::Symbol) = haskey(layout.attr, k)

leftpad(layout::AbstractLayout) = 0mm
toppad(layout::AbstractLayout) = 0mm
rightpad(layout::AbstractLayout) = 0mm
bottompad(layout::AbstractLayout) = 0mm

# -----------------------------------------------------------
# RootLayout

# this is the parent of the top-level layout
struct RootLayout <: AbstractLayout end

Base.show(io::IO, layout::RootLayout) = Base.show_default(io, layout)
Base.parent(::RootLayout) = nothing
parent_bbox(::RootLayout) = DEFAULT_BBOX[]
bbox(::RootLayout) = DEFAULT_BBOX[]

# -----------------------------------------------------------
# EmptyLayout

# contains blank space
mutable struct EmptyLayout <: AbstractLayout
    parent::AbstractLayout
    bbox::BoundingBox
    attr::KW  # store label, width, and height for initialization
    # label  # this is the label that the subplot will take (since we create a layout before initialization)
end
EmptyLayout(parent = RootLayout(); kw...) = EmptyLayout(parent, DEFAULT_BBOX[], KW(kw))

Base.size(layout::EmptyLayout) = (0, 0)
Base.length(layout::EmptyLayout) = 0
Base.getindex(layout::EmptyLayout, r::Int, c::Int) = nothing

_update_min_padding!(layout::EmptyLayout) = nothing
_update_inset_padding!(layout::EmptyLayout) = nothing

# -----------------------------------------------------------
# GridLayout

# nested, gridded layout with optional size percentages
mutable struct GridLayout <: AbstractLayout
    parent::AbstractLayout
    minpad::Tuple # leftpad, toppad, rightpad, bottompad
    bbox::BoundingBox
    grid::Matrix{AbstractLayout} # Nested layouts. Each position is a AbstractLayout, which allows for arbitrary recursion
    widths::Vector{Measure}
    heights::Vector{Measure}
    attr::KW
end

"""
    grid(args...; kw...)

Create a grid layout for subplots. `args` specify the dimensions, e.g.
`grid(3,2, widths = (0.6,0.4))` creates a grid with three rows and two
columns of different width.
"""
grid(args...; kw...) = GridLayout(args...; kw...)

function GridLayout(
        dims...;
        parent = RootLayout(),
        widths = nothing,
        heights = nothing,
        kw...,
    )
    # Check the values for heights and widths if values are provided
    all_between_one(xs) = all(x -> 0 < x < 1, xs)
    if heights !== nothing
        sum(heights) ≈ 1 || error("The heights provided ($(heights)) must sum to 1.")
        all_between_one(heights) ||
            error("The heights provided ($(heights)) must be in the range (0, 1).")
    else
        heights = zeros(dims[1])
    end
    if widths !== nothing
        sum(widths) ≈ 1 || error("The widths provided ($(widths)) must sum to 1.")
        all_between_one(widths) ||
            error("The widths provided ($(widths)) must be in the range (0, 1).")
    else
        widths = zeros(dims[2])
    end

    grid = Matrix{AbstractLayout}(undef, dims...)
    layout = GridLayout(
        parent,
        DEFAULT_MINPAD[],
        DEFAULT_BBOX[],
        grid,
        Measure[w * pct for w in widths],
        Measure[h * pct for h in heights],
        # convert(Vector{Float64}, widths),
        # convert(Vector{Float64}, heights),
        KW(kw),
    )
    for i in eachindex(grid)
        grid[i] = EmptyLayout(layout)
    end
    return layout
end

Base.size(layout::GridLayout) = size(layout.grid)
Base.length(layout::GridLayout) = length(layout.grid)
Base.getindex(layout::GridLayout, r::Int, c::Int) = layout.grid[r, c]
Base.setindex!(layout::GridLayout, v, r::Int, c::Int) = layout.grid[r, c] = v
Base.setindex!(layout::GridLayout, v, ci::CartesianIndex) = layout.grid[ci] = v

leftpad(pad) = pad[1]
toppad(pad) = pad[2]
rightpad(pad) = pad[3]
bottompad(pad) = pad[4]

leftpad(layout::GridLayout) = leftpad(layout.minpad)
toppad(layout::GridLayout) = toppad(layout.minpad)
rightpad(layout::GridLayout) = rightpad(layout.minpad)
bottompad(layout::GridLayout) = bottompad(layout.minpad)

# here's how this works... first we recursively "update the minimum padding" (which
# means to calculate the minimum size needed from the edge of the subplot to plot area)
# for the whole layout tree.  then we can compute the "padding borders" of this
# layout as the biggest padding of the children on the perimeter.  then we need to
# recursively pass those borders back down the tree, one side at a time, but ONLY
# to those perimeter children.

function paddings(args...)
    funcs = (leftpad, toppad, rightpad, bottompad)
    args = length(args) == 1 ? ntuple(i -> first(args), Val(4)) : args
    return map(i -> map(funcs[i], args[i]), Tuple(1:4))
end

compute_minpad(args...) = map(maximum, paddings(args...))

_update_inset_padding!(layout::GridLayout) = map(_update_inset_padding!, layout.grid)
_update_inset_padding!(sp::Subplot) =
    for isp in sp.plt.inset_subplots
    parent(isp) == sp || continue
    _update_min_padding!(isp)
    sp.minpad = max.(sp.minpad, isp.minpad)
end

# leftpad, toppad, rightpad, bottompad
function _update_min_padding!(layout::GridLayout)
    map(_update_min_padding!, layout.grid)
    map(_update_inset_padding!, layout.grid)
    layout.minpad = compute_minpad(
        layout.grid[:, 1],
        layout.grid[1, :],
        layout.grid[:, end],
        layout.grid[end, :],
    )
    return layout.minpad
end

update_position!(layout::GridLayout) = map(update_position!, layout.grid)

# some lengths are fixed... we have to split up the free space among the list v
function recompute_lengths(v)
    # dump(v)
    tot = 0pct
    cnt = 0
    for vi in v
        if vi == 0pct
            cnt += 1
        else
            tot += vi
        end
    end
    leftover = 1.0pct - tot
    if cnt > 1 && leftover.value <= 0
        error(
            "Not enough length left over in layout!  v = $v, cnt = $cnt, leftover = $leftover",
        )
    end

    # now fill in the blanks
    return map(x -> x == 0pct ? leftover / cnt : x, v)
end

# recursively compute the bounding boxes for the layout and plotarea (relative to canvas!)
function update_child_bboxes!(layout::GridLayout, minimum_perimeter = [0mm, 0mm, 0mm, 0mm])
    nr, nc = size(layout)

    # create a matrix for each minimum padding direction
    minpad_left, minpad_top, minpad_right, minpad_bottom = paddings(layout.grid)

    # get the max horizontal (left and right) padding over columns,
    # and max vertical (bottom and top) padding over rows
    # TODO: add extra padding here
    pad_left = maximum(minpad_left, dims = 1)
    pad_top = maximum(minpad_top, dims = 2)
    pad_right = maximum(minpad_right, dims = 1)
    pad_bottom = maximum(minpad_bottom, dims = 2)

    # make sure the perimeter match the parent
    pad_left[1] = max(pad_left[1], leftpad(minimum_perimeter))
    pad_top[1] = max(pad_top[1], toppad(minimum_perimeter))
    pad_right[end] = max(pad_right[end], rightpad(minimum_perimeter))
    pad_bottom[end] = max(pad_bottom[end], bottompad(minimum_perimeter))

    # scale this up to the total padding in each direction, and limit padding to 95%
    total_pad_horizontal = min(0.95width(layout), sum(pad_left + pad_right))
    total_pad_vertical = min(0.95height(layout), sum(pad_top + pad_bottom))

    # now we can compute the total plot area in each direction
    total_plotarea_horizontal = width(layout) - total_pad_horizontal
    total_plotarea_vertical = height(layout) - total_pad_vertical

    @assert total_plotarea_horizontal > 0mm
    @assert total_plotarea_vertical > 0mm

    # recompute widths/heights
    layout.widths = recompute_lengths(layout.widths)
    layout.heights = recompute_lengths(layout.heights)

    # we have all the data we need... lets compute the plot areas and set the bounding boxes
    for r in 1:nr, c in 1:nc
        child = layout[r, c]

        # get the top-left corner of this child... the first one is top-left of the parent (i.e. layout)
        child_left = c == 1 ? left(layout.bbox) : right(layout[r, c - 1].bbox)
        child_top = r == 1 ? top(layout.bbox) : bottom(layout[r - 1, c].bbox)

        # compute plot area
        plotarea_left = child_left + pad_left[c]
        plotarea_top = child_top + pad_top[r]
        plotarea_width = total_plotarea_horizontal * layout.widths[c]
        plotarea_height = total_plotarea_vertical * layout.heights[r]

        bb = BoundingBox(plotarea_left, plotarea_top, plotarea_width, plotarea_height)
        plotarea!(child, bb)

        # compute child bbox
        child_width = pad_left[c] + plotarea_width + pad_right[c]
        child_height = pad_top[r] + plotarea_height + pad_bottom[r]
        bbox!(child, BoundingBox(child_left, child_top, child_width, child_height))

        # this is the minimum perimeter as decided by this child's parent, so that
        # all children on this border have the same value
        min_child_perim = [
            c == 1 ? leftpad(layout) : pad_left[c],
            r == 1 ? toppad(layout) : pad_top[r],
            c == nc ? rightpad(layout) : pad_right[c],
            r == nr ? bottompad(layout) : pad_bottom[r],
        ]
        # recursively update the child's children
        update_child_bboxes!(child, min_child_perim)
    end
    return
end

# for each inset (floating) subplot, resolve the relative position
# to absolute canvas coordinates, relative to the parent's plotarea
update_inset_bboxes!(plt::Plot) =
    for sp in plt.inset_subplots
    p_area = Measures.resolve(plotarea(sp.parent), sp[:relative_bbox])
    plotarea!(sp, p_area)
    # NOTE: `lens` example, `pgfplotsx` for non-regression
    bbox!(
        sp,
        bbox(
            left(p_area) - leftpad(sp),
            top(p_area) - toppad(sp),
            width(p_area) + leftpad(sp) + rightpad(sp),
            height(p_area) + toppad(sp) + bottompad(sp),
        ),
    )
end
# ----------------------------------------------------------------------

calc_num_subplots(layout::AbstractLayout) = get(layout.attr, :blank, false) ? 0 : 1
calc_num_subplots(layout::GridLayout) = sum(map(l -> calc_num_subplots(l), layout.grid))

function compute_gridsize(numplts::Int, nr::Int, nc::Int)
    # figure out how many rows/columns we need
    if nr < 1
        if nc < 1
            nr = round(Int, sqrt(numplts))
            nc = ceil(Int, numplts / nr)
        else
            nr = ceil(Int, numplts / nc)
        end
    else
        nc = ceil(Int, numplts / nr)
    end
    return nr, nc
end

# ----------------------------------------------------------------------
# constructors

# pass the layout arg through
layout_args(plotattributes::AKW) = layout_args(plotattributes[:layout])

function layout_args(plotattributes::AKW, n_override::Integer)
    layout, n = layout_args(n_override, get(plotattributes, :layout, n_override))
    if n < n_override
        error(
            "When doing layout, n ($n) < n_override ($(n_override)).  You're probably trying to force existing plots into a layout that doesn't fit them.",
        )
    end
    return layout, n
end

function layout_args(n::Integer)
    nr, nc = compute_gridsize(n, -1, -1)
    return GridLayout(nr, nc), n
end

function layout_args(sztup::NTuple{2, Integer})
    nr, nc = sztup
    return GridLayout(nr, nc), nr * nc
end

layout_args(n_override::Integer, n::Integer) = layout_args(n)
layout_args(n, sztup::NTuple{2, Integer}) = layout_args(sztup)

function layout_args(n, sztup::Tuple{Colon, Integer})
    nc = sztup[2]
    nr = ceil(Int, n / nc)
    return GridLayout(nr, nc), n
end

function layout_args(n, sztup::Tuple{Integer, Colon})
    nr = sztup[1]
    nc = ceil(Int, n / nr)
    return GridLayout(nr, nc), n
end

function layout_args(sztup::NTuple{3, Integer})
    n, nr, nc = sztup
    nr, nc = compute_gridsize(n, nr, nc)
    return GridLayout(nr, nc), n
end

layout_args(nt::NamedTuple) = EmptyLayout(; nt...), 1

function layout_args(m::AbstractVecOrMat)
    sz = size(m)
    nr = first(sz)
    nc = get(sz, 2, 1)
    gl = GridLayout(nr, nc)
    for ci in CartesianIndices(m)
        gl[ci] = layout_args(m[ci])[1]
    end
    return layout_args(gl)
end

# recursively get the size of the grid
layout_args(layout::GridLayout) = layout, calc_num_subplots(layout)

layout_args(n_override::Integer, layout::Union{AbstractVecOrMat, GridLayout}) =
    layout_args(layout)

# ----------------------------------------------------------------------

function build_layout(args...)
    layout, n = layout_args(args...)
    return build_layout(layout, n, Array{Plot}(undef, 0))
end

# n is the number of subplots...
function build_layout(layout::GridLayout, n::Integer, plts::AVec{Plot})
    nr, nc = size(layout)
    subplots = Subplot[]
    spmap = SubplotMap()
    empty = isempty(plts)
    i = 0
    for r in 1:nr, c in 1:nc
        l = layout[r, c]
        if isa(l, EmptyLayout) && !get(l.attr, :blank, false)
            if empty
                # initialize the inner subplots recursively
                sp = Subplot(backend(), parent = layout)
                layout[r, c] = sp
                push!(subplots, sp)
                spmap[attr(l, :label, gensym())] = sp
                inc = 1
            else
                # build a layout from a list of existing Plot objects
                plt = popfirst!(plts)  # grab the first plot out of the list
                layout[r, c] = plt.layout
                append!(subplots, plt.subplots)
                merge!(spmap, plt.spmap)
                inc = length(plt.subplots)
            end
            if get(l.attr, :width, :auto) !== :auto
                layout.widths[c] = attr(l, :width)
            end
            if get(l.attr, :height, :auto) !== :auto
                layout.heights[r] = attr(l, :height)
            end
            i += inc
        elseif isa(l, GridLayout)
            # sub-grid
            if get(l.attr, :width, :auto) !== :auto
                layout.widths[c] = attr(l, :width)
            end
            if get(l.attr, :height, :auto) !== :auto
                layout.heights[r] = attr(l, :height)
            end
            l, sps, m = build_layout(l, n - i, plts)
            append!(subplots, sps)
            merge!(spmap, m)
            i += length(sps)
        elseif isa(l, Subplot) && empty
            error("Subplot exists. Cannot re-use existing layout.  Please make a new one.")
        end
        i ≥ n && break  # only add n subplots
    end

    return layout, subplots, spmap
end

# -------------------------------------------------------------------------

# make all reference the same axis extrema/values.
# merge subplot lists.
function link_axes!(axes::Axis...)
    a1 = axes[1]
    for i in 2:length(axes)
        a2 = axes[i]
        a1[:unit] ≡ a2[:unit] ||
            error("Cannot link axes with different units: $(a1[:unit]) and $(a2[:unit])")
        expand_extrema!(a1, ignorenan_extrema(a2))
        for k in (:extrema, :discrete_values, :continuous_values, :discrete_map)
            a2[k] = a1[k]
        end

        # make a2's subplot list refer to a1's and add any missing values
        sps2 = a2.sps
        for sp in sps2
            sp in a1.sps || push!(a1.sps, sp)
        end
        a2.sps = a1.sps
    end
    return
end

# figure out which subplots to link
function link_subplots(a::AbstractArray{AbstractLayout}, axissym::Symbol)
    subplots = []
    for l in a
        if isa(l, Subplot)
            push!(subplots, l)
        elseif isa(l, GridLayout) && size(l) == (1, 1)
            push!(subplots, l[1, 1])
        end
    end
    return subplots
end

# for some vector or matrix of layouts, filter only the Subplots and link those axes
function link_axes!(a::AbstractArray{AbstractLayout}, axissym::Symbol)
    subplots = link_subplots(a, axissym)
    axes = [sp.attr[axissym] for sp in subplots]
    return length(axes) > 0 && link_axes!(axes...)
end

# don't do anything for most layout types
function link_axes!(l::AbstractLayout, link::Symbol) end

# process a GridLayout, recursively linking axes according to the link symbol
function link_axes!(layout::GridLayout, link::Symbol)
    nr, nc = size(layout)
    if link in (:x, :both)
        for c in 1:nc
            link_axes!(layout.grid[:, c], :xaxis)
        end
    end
    if link in (:y, :both)
        for r in 1:nr
            link_axes!(layout.grid[r, :], :yaxis)
        end
    end
    if link === :square
        if (sps = filter(l -> isa(l, Subplot), layout.grid)) |> !isempty
            base_axis = sps[1][:xaxis]
            for sp in sps
                link_axes!(base_axis, sp[:xaxis])
                link_axes!(base_axis, sp[:yaxis])
            end
        end
    end
    if link === :all
        link_axes!(layout.grid, :xaxis)
        link_axes!(layout.grid, :yaxis)
    end
    return foreach(l -> link_axes!(l, link), layout.grid)
end

# -------------------------------------------------------------------------

function twin(sp, letter)
    plt = sp.plt
    orig_sp = first(plt.subplots)
    for letter in filter(!=(letter), axes_letters(orig_sp, letter))
        ax = orig_sp[get_attr_symbol(letter, :axis)]
        ax[:grid] = false  # disable the grid (overlaps with twin axis)
    end
    if orig_sp[:framestyle] === :box
        # incompatible with shared axes (see github.com/JuliaPlots/Plots.jl/issues/2894)
        orig_sp[:framestyle] = :axes
    end
    plot!(
        plt;
        inset = (sp[:subplot_index], bbox(0, 0, 1, 1)),
        left_margin = orig_sp[:left_margin],
        top_margin = orig_sp[:top_margin],
        right_margin = orig_sp[:right_margin],
        bottom_margin = orig_sp[:bottom_margin],
    )
    twin_sp = last(plt.subplots)
    letters = axes_letters(twin_sp, letter)
    tax, oax = map(l -> twin_sp[get_attr_symbol(l, :axis)], letters)
    tax[:grid] = false
    tax[:showaxis] = false
    tax[:ticks] = :none
    tax[:unit] = orig_sp[get_attr_symbol(letter, :axis)][:unit]
    tax[:guide] = nothing
    oax[:grid] = false
    oax[:mirror] = true
    twin_sp[:background_color_inside] = RGBA{Float64}(0, 0, 0, 0)
    link_axes!(sp[get_attr_symbol(letter, :axis)], tax)
    return twin_sp
end

"""
    twinx(sp)

Adds a new, empty subplot overlaid on top of `sp`, with a mirrored y-axis and linked x-axis.
"""
twinx(sp::Subplot) = twin(sp, :x)
twinx(plt::Plot = current()) = twinx(first(plt))

"""
    twiny(sp)

Adds a new, empty subplot overlaid on top of `sp`, with a mirrored x-axis and linked y-axis.
"""
twiny(sp::Subplot) = twin(sp, :y)
twiny(plt::Plot = current()) = twiny(first(plt))

# RecipesPipeline API

## Warnings

function RecipesPipeline.warn_on_recipe_aliases!(
        plt::Plot,
        plotattributes::AKW,
        recipe_type::Symbol,
        @nospecialize(args)
    )
    pkeys = keys(plotattributes)
    for k in pkeys
        if (dk = get(_keyAliases, k, nothing)) !== nothing
            kv = RecipesPipeline.pop_kw!(plotattributes, k)
            dk ∈ pkeys || (plotattributes[dk] = kv)
        end
    end
    return
end

## Grouping

RecipesPipeline.splittable_attribute(plt::Plot, key, val::SeriesAnnotations, len) =
    RecipesPipeline.splittable_attribute(plt, key, val.strs, len)

RecipesPipeline.split_attribute(plt::Plot, key, val::SeriesAnnotations, indices) =
    SeriesAnnotations(
    RecipesPipeline.split_attribute(plt, key, val.strs, indices),
    val.font,
    val.baseshape,
    val.scalefactor,
)

## Preprocessing attributes
function RecipesPipeline.preprocess_axis_args!(plt::Plot, plotattributes, letter)
    # Fix letter for seriestypes that are x only but data gets passed as y
    if treats_y_as_x(get(plotattributes, :seriestype, :path)) &&
            get(plotattributes, :orientation, :vertical) === :vertical
        letter = :x
    end

    plotattributes[:letter] = letter
    return RecipesPipeline.preprocess_axis_args!(plt, plotattributes)
end

RecipesPipeline.is_axis_attribute(plt::Plot, attr) = is_axis_attr_noletter(attr) # in src/args.jl

RecipesPipeline.is_subplot_attribute(plt::Plot, attr) = is_subplot_attr(attr) # in src/args.jl

## User recipes

function RecipesPipeline.process_userrecipe!(plt::Plot, kw_list, kw)
    _preprocess_userrecipe(kw)
    warn_on_unsupported_scales(plt.backend, kw)
    # add the plot index
    plt.n += 1
    kw[:series_plotindex] = plt.n

    push!(kw_list, kw)
    _add_errorbar_kw(kw_list, kw)
    _add_smooth_kw(kw_list, kw)
    return nothing
end

function _preprocess_userrecipe(kw::AKW)
    _add_markershape(kw)

    if get(kw, :permute, default(:permute)) !== :none
        l1, l2 = kw[:permute]
        for k in _axis_args
            k1 = _attrsymbolcache[l1][k]
            k2 = _attrsymbolcache[l2][k]
            kwk = keys(kw)
            if k1 in kwk || k2 in kwk
                kw[k1], kw[k2] = get(kw, k2, default(k2)), get(kw, k1, default(k1))
            end
        end
    end
    # map marker_z if it's a Function
    if isa(get(kw, :marker_z, default(:marker_z)), Function)
        # TODO: should this take y and/or z as arguments?
        kw[:marker_z] =
            isa(kw[:z], Nothing) ? map(kw[:marker_z], kw[:x], kw[:y]) :
            map(kw[:marker_z], kw[:x], kw[:y], kw[:z])
    end

    # map line_z if it's a Function
    if isa(get(kw, :line_z, default(:line_z)), Function)
        kw[:line_z] =
            isa(kw[:z], Nothing) ? map(kw[:line_z], kw[:x], kw[:y]) :
            map(kw[:line_z], kw[:x], kw[:y], kw[:z])
    end

    return nothing
end

function _add_errorbar_kw(kw_list::Vector{KW}, kw::AKW)
    # handle error bars by creating new recipedata data... these will have
    # the same recipedata index as the recipedata they are copied from
    st = get(kw, :seriestype, :none)
    errors = (:xerror, :yerror, :zerror)
    return if st ∉ errors
        for esym in errors
            if get(kw, esym, nothing) !== nothing
                # we make a copy of the KW and apply an errorbar recipe
                errkw = copy(kw)
                errkw[:seriestype] = esym
                errkw[:label] = ""
                errkw[:primary] = false
                push!(kw_list, errkw)
            end
        end
    end
end

function _add_smooth_kw(kw_list::Vector{KW}, kw::AKW)
    # handle smoothing by adding a new series
    return if get(kw, :smooth, false)
        x, y = kw[:x], kw[:y]
        β, α = convert(Matrix{Float64}, [x ones(length(x))]) \ convert(Vector{Float64}, y)
        sx = [ignorenan_minimum(x), ignorenan_maximum(x)]
        sy = β .* sx .+ α
        push!(
            kw_list,
            merge(
                copy(kw),
                KW(
                    :seriestype => :path,
                    :x => sx,
                    :y => sy,
                    :fillrange => nothing,
                    :label => "",
                    :primary => false,
                ),
            ),
        )
    end
end

RecipesPipeline.get_axis_limits(plt::Plot, letter) = axis_limits(plt[1], letter, nothing)

## Plot recipes

RecipesPipeline.type_alias(plt::Plot, st) = get(_typeAliases, st, st)

## Plot setup

function RecipesPipeline.plot_setup!(plt::Plot, plotattributes, kw_list)
    _plot_setup(plt, plotattributes, kw_list)
    _subplot_setup(plt, plotattributes, kw_list)
    return nothing
end

function RecipesPipeline.process_sliced_series_attributes!(plt::Plots.Plot, kw_list)
    # determine global extrema
    xe = ye = ze = NaN, NaN
    for kw in kw_list
        xe = ignorenan_min_max(get(kw, :x, nothing), xe)
        ye = ignorenan_min_max(get(kw, :y, nothing), ye)
        ze = ignorenan_min_max(get(kw, :z, nothing), ze)
    end

    # swap errors
    err_inds =
        findall(kw -> get(kw, :seriestype, :path) in (:xerror, :yerror, :zerror), kw_list)
    for ind in err_inds
        if ind > 1 && get(kw_list[ind - 1], :seriestype, :path) === :scatter
            tmp = copy(kw_list[ind])
            kw_list[ind] = copy(kw_list[ind - 1])
            kw_list[ind - 1] = tmp
        end
    end

    for kw in kw_list
        kw[:x_extrema] = xe
        kw[:y_extrema] = ye
        kw[:z_extrema] = ze

        rib = get(kw, :ribbon, default(:ribbon))
        fr = get(kw, :fillrange, default(:fillrange))
        # map ribbon if it's a Function
        if rib isa Function
            kw[:ribbon] = map(rib, kw[:x])
        end
        # convert a ribbon into a fillrange
        if rib !== nothing
            make_fillrange_from_ribbon(kw)
            # map fillrange if it's a Function
        elseif fr !== nothing && fr isa Function
            kw[:fillrange] = map(fr, kw[:x])
        end
    end
    return nothing
end

# TODO: Should some of this logic be moved to RecipesPipeline?
function _plot_setup(plt::Plot, plotattributes::AKW, kw_list::Vector{KW})
    # merge in anything meant for the Plot
    for kw in kw_list, (k, v) in kw
        haskey(_plot_defaults, k) && (plotattributes[k] = pop!(kw, k))
    end

    # TODO: init subplots here
    _update_plot_args(plt, plotattributes)
    if !plt.init
        plt.o = Base.invokelatest(_create_backend_figure, plt)

        # create the layout and subplots from the inputs
        plt.layout, plt.subplots, plt.spmap = build_layout(plt.attr)
        for (idx, sp) in enumerate(plt.subplots)
            sp.plt = plt
            sp.attr[:subplot_index] = idx
        end

        plt.init = true
    end

    # handle inset subplots
    if (insets = plt[:inset_subplots]) !== nothing
        typeof(insets) <: AVec || (insets = [insets])
        for inset in insets
            parent, bb = is_2tuple(inset) ? inset : (nothing, inset)
            parent = if (P = typeof(parent)) <: Integer
                plt.subplots[parent]
            elseif P == Symbol
                plt.spmap[parent]
            else
                plt.layout
            end
            sp = Subplot(backend(); parent)
            sp.plt = plt
            push!(plt.subplots, sp)
            push!(plt.inset_subplots, sp)
            sp.attr[:relative_bbox] = bb
            sp.attr[:subplot_index] = length(plt.subplots)
        end
    end
    return plt[:inset_subplots] = nothing
end

function _subplot_setup(plt::Plot, plotattributes::AKW, kw_list::Vector{KW})
    # we'll keep a map of subplot to an attribute override dict.
    # Subplot/Axis attributes set by a user/series recipe apply only to the
    # Subplot object which they belong to.
    # TODO: allow matrices to still apply to all subplots
    sp_attrs = Dict{Subplot, Any}()
    for kw in kw_list
        # get the Subplot object to which the series belongs.
        sps = get(kw, :subplot, :auto)
        sp = get_subplot(
            plt,
            _cycle(
                sps === :auto ? plt.subplots : plt.subplots[sps],
                series_idx(kw_list, kw),
            ),
        )
        kw[:subplot] = sp

        # extract subplot/axis attributes from kw and add to sp_attr
        attr = KW()
        for (k, v) in collect(kw)
            if is_subplot_attr(k) || is_axis_attr(k)
                v = pop!(kw, k)
                if sps isa AbstractArray && v isa AbstractArray && length(v) == length(sps)
                    v = v[series_idx(kw_list, kw)]
                end
                attr[k] = v
            end
            if is_axis_attr_noletter(k)
                v = pop!(kw, k)
                if sps isa AbstractArray && v isa AbstractArray && length(v) == length(sps)
                    v = v[series_idx(kw_list, kw)]
                end
                for letter in (:x, :y, :z)
                    attr[get_attr_symbol(letter, k)] = v
                end
            end
        end
        for k in (:scale,), letter in (:x, :y, :z)
            # Series recipes may need access to this information
            lk = get_attr_symbol(letter, k)
            haskey(attr, lk) && (kw[lk] = attr[lk])
        end
        sp_attrs[sp] = attr
    end

    _add_plot_title!(plt)
    # override subplot/axis args.  `sp_attrs` take precedence
    for (idx, sp) in enumerate(plt.subplots)
        attr = if !haskey(plotattributes, :subplot) || plotattributes[:subplot] == idx
            merge(plotattributes, get(sp_attrs, sp, KW()))
        else
            get(sp_attrs, sp, KW())
        end
        _update_subplot_args(plt, sp, attr, idx, false)
    end

    # do we need to link any axes together?
    link_axes!(plt.layout, plt[:link])
    return nothing
end

series_idx(kw_list::AVec{KW}, kw::AKW) =
    Int(kw[:series_plotindex]) - Int(kw_list[1][:series_plotindex]) + 1

function _add_plot_title!(plt)
    plot_title = plt[:plot_title]
    plot_titleindex = nothing

    if plot_title != ""
        # make new subplot for plot title
        if plt[:plot_titleindex] == 0
            the_layout = plt.layout
            vspan = plt[:plot_titlevspan]
            plt.layout = grid(2, 1, heights = (vspan, 1 - vspan))
            plt.layout.grid[1, 1] =
                subplot = Subplot(plt.backend, parent = plt.layout[1, 1])
            plt.layout.grid[2, 1] = the_layout
            subplot.plt = plt

            top = plt.backend isa PyPlotBackend ? nothing : 0mm
            bot = 0mm
            plt[:force_minpad] = nothing, top, nothing, bot
            subplot[:subplot_index] = last(plt.subplots)[:subplot_index] + 1
            plt[:plot_titleindex] = subplot[:subplot_index]
            subplot[:framestyle] = :none
            subplot[:margin] = 0px
            subplot[:background_color_inside] = plt[:background_color]
            push!(plt.subplots, subplot)
        end

        # propagate arguments plt[:plot_titleXXX] --> subplot[:titleXXX]
        plot_titleindex = plt[:plot_titleindex]
        subplot = plt.subplots[plot_titleindex]
        for sym in filter(x -> startswith(string(x), "plot_title"), keys(_plot_defaults))
            subplot[Symbol(string(sym)[(length("plot_") + 1):end])] = plt[sym]
        end
    end

    return plot_titleindex
end

## Series recipes

function RecipesPipeline.slice_series_attributes!(plt::Plot, kw_list, kw)
    sp::Subplot = kw[:subplot]
    # in series attributes given as vector with one element per series,
    # select the value for current series
    _slice_series_args!(kw, plt, sp, series_idx(kw_list, kw))
    return nothing
end

RecipesPipeline.series_defaults(plt::Plot) = _series_defaults # in args.jl

RecipesPipeline.is_seriestype_supported(plt::Plot, st) = is_seriestype_supported(st)

function RecipesPipeline.add_series!(plt::Plot, plotattributes)
    sp = _prepare_subplot(plt, plotattributes)
    if (perm = plotattributes[:permute]) !== :none
        letter1, letter2 = perm
        ms = plotattributes[:markershape]
        if ms === :hline && (perm == (:x, :y) || perm == (:y, :x))
            plotattributes[:markershape] = :vline
        elseif ms === :vline && (perm == (:x, :y) || perm == (:y, :x))
            plotattributes[:markershape] = :hline
        end
        if plotattributes[:seriestype] === :bar # bar calls expand_extrema! in its recipe...
            sp = plotattributes[:subplot]
            sp[get_attr_symbol(letter1, :axis)][:lims],
                sp[get_attr_symbol(letter2, :axis)][:lims] =
                sp[get_attr_symbol(letter2, :axis)][:lims],
                sp[get_attr_symbol(letter1, :axis)][:lims]
        end
        plotattributes[letter1], plotattributes[letter2] =
            plotattributes[letter2], plotattributes[letter1]
    end
    _expand_subplot_extrema(sp, plotattributes, plotattributes[:seriestype])
    _update_series_attributes!(plotattributes, plt, sp)
    return _add_the_series(plt, sp, plotattributes)
end

# getting ready to add the series... last update to subplot from anything
# that might have been added during series recipes
function _prepare_subplot(plt::Plot{T}, plotattributes::AKW) where {T}
    st::Symbol = plotattributes[:seriestype]
    sp::Subplot{T} = plotattributes[:subplot]
    sp_idx = get_subplot_index(plt, sp)
    _update_subplot_args(plt, sp, plotattributes, sp_idx, true)

    st = _override_seriestype_check(plotattributes, st)

    # change to a 3d projection for this subplot?
    if (
            RecipesPipeline.needs_3d_axes(st) ||
                (st === :quiver && plotattributes[:z] !== nothing)
        )
        sp.attr[:projection] = "3d"
    end

    # initialize now that we know the first series type
    if !haskey(sp.attr, :init)
        _initialize_subplot(plt, sp)
        sp.attr[:init] = true
    end
    return sp
end

function _override_seriestype_check(plotattributes::AKW, st::Symbol)
    # do we want to override the series type?
    if !RecipesPipeline.is3d(st) && st ∉ (:contour, :contour3d, :quiver)
        if (z = plotattributes[:z]) !== nothing &&
                size(plotattributes[:x]) == size(plotattributes[:y]) == size(z)
            st = st === :scatter ? :scatter3d : :path3d
            plotattributes[:seriestype] = st
        end
    end
    return st
end

needs_any_3d_axes(sp::Subplot) = any(
    RecipesPipeline.needs_3d_axes(
            _override_seriestype_check(s.plotattributes, s.plotattributes[:seriestype]),
        ) for s in series_list(sp)
)

function _expand_subplot_extrema(sp::Subplot, plotattributes::AKW, st::Symbol)
    # adjust extrema and discrete info
    if st === :image
        xmin, xmax = ignorenan_extrema(plotattributes[:x])
        ymin, ymax = ignorenan_extrema(plotattributes[:y])
        expand_extrema!(sp[:xaxis], (xmin, xmax))
        expand_extrema!(sp[:yaxis], (ymin, ymax))
    elseif st ∉ (:histogram, :bins2d, :histogram2d)
        expand_extrema!(sp, plotattributes)
    end
    # expand for zerolines (axes through origin)
    if sp[:framestyle] in (:origin, :zerolines)
        expand_extrema!(sp[:xaxis], 0.0)
        expand_extrema!(sp[:yaxis], 0.0)
    end
    return nothing
end

function _add_the_series(plt, sp, plotattributes)
    extra_kwargs = warn_on_unsupported_args(plt.backend, plotattributes)
    if (kw = plt[:extra_kwargs]) isa AbstractDict
        plt[:extra_plot_kwargs] = get(kw, :plot, KW())
        sp[:extra_kwargs] = get(kw, :subplot, KW())
        plotattributes[:extra_kwargs] = get(kw, :series, KW())
    elseif kw === :plot
        plt[:extra_plot_kwargs] = extra_kwargs
    elseif kw === :subplot
        sp[:extra_kwargs] = extra_kwargs
    elseif kw === :series
        plotattributes[:extra_kwargs] = extra_kwargs
    else
        throw(ArgumentError("Unsupported type for extra keyword arguments"))
    end
    warn_on_unsupported(plt.backend, plotattributes)
    series = Series(plotattributes)
    push!(plt.series_list, series)
    if (z_order = plotattributes[:z_order]) === :front
        push!(sp.series_list, series)
    elseif z_order === :back
        pushfirst!(sp.series_list, series)
    elseif z_order isa Integer
        insert!(sp.series_list, z_order, series)
    else
        @error "Wrong type $(typeof(z_order)) for attribute z_order"
    end
    _series_added(plt, series)
    return _update_subplot_colorbars(sp, series)
end

defaultOutputFormat(plt::Plot) = "png"

function png(plt::Plot, fn)
    fn = addExtension(fn, "png")
    open(io -> show(io, MIME("image/png"), plt), fn, "w")
    return fn
end
png(fn) = png(current(), fn)

png(plt::Plot, io::IO) = show(io, MIME("image/png"), plt)
png(io::IO) = png(current(), io)

function svg(plt::Plot, fn)
    fn = addExtension(fn, "svg")
    open(io -> show(io, MIME("image/svg+xml"), plt), fn, "w")
    return fn
end

svg(fn) = svg(current(), fn)

svg(plt::Plot, io::IO) = show(io, MIME("image/svg+xml"), plt)
svg(io::IO) = svg(current(), io)

function pdf(plt::Plot, fn)
    fn = addExtension(fn, "pdf")
    open(io -> show(io, MIME("application/pdf"), plt), fn, "w")
    return fn
end
pdf(fn) = pdf(current(), fn)

pdf(plt::Plot, io::IO) = show(io, MIME("application/pdf"), plt)
pdf(io::IO) = pdf(current(), io)

function ps(plt::Plot, fn)
    fn = addExtension(fn, "ps")
    open(io -> show(io, MIME("application/postscript"), plt), fn, "w")
    return fn
end
ps(fn) = ps(current(), fn)

ps(plt::Plot, io::IO) = show(io, MIME("application/postscript"), plt)
ps(io::IO) = ps(current(), io)

function eps(plt::Plot, fn)
    fn = addExtension(fn, "eps")
    open(io -> show(io, MIME("image/eps"), plt), fn, "w")
    return fn
end
eps(fn) = eps(current(), fn)

eps(plt::Plot, io::IO) = show(io, MIME("image/eps"), plt)
eps(io::IO) = eps(current(), io)

function tex(plt::Plot, fn)
    fn = addExtension(fn, "tex")
    open(io -> show(io, MIME("application/x-tex"), plt), fn, "w")
    return fn
end
tex(fn) = tex(current(), fn)

tex(plt::Plot, io::IO) = show(io, MIME("application/x-tex"), plt)
tex(io::IO) = tex(current(), io)

function json(plt::Plot, fn)
    fn = addExtension(fn, "json")
    open(io -> show(io, MIME("application/vnd.plotly.v1+json"), plt), fn, "w")
    return fn
end
json(fn) = json(current(), fn)

json(plt::Plot, io::IO) = show(io, MIME("application/vnd.plotly.v1+json"), plt)
json(io::IO) = json(current(), io)

function html(plt::Plot, fn)
    fn = addExtension(fn, "html")
    open(io -> show(io, MIME("text/html"), plt), fn, "w")
    return fn
end
html(fn) = html(current(), fn)

html(plt::Plot, io::IO) = show(io, MIME("text/html"), plt)
html(io::IO) = html(current(), io)

function txt(plt::Plot, fn; color::Bool = true)
    fn = addExtension(fn, "txt")
    open(io -> show(IOContext(io, :color => color), MIME("text/plain"), plt), fn, "w")
    return fn
end
txt(fn) = txt(current(), fn)

txt(plt::Plot, io::IO) = show(io, MIME("text/plain"), plt)
txt(io::IO) = txt(current(), io)

# ----------------------------------------------------------------

const _savemap = Dict(
    "png" => png,
    "svg" => svg,
    "pdf" => pdf,
    "ps" => ps,
    "eps" => eps,
    "tex" => tex,
    "json" => json,
    "html" => html,
    "tikz" => tex,
    "txt" => txt,
)

for out in Symbol.(unique(values(_savemap)))
    @eval @doc """
        $($out)([plot,], filename)
    Save plot as $($out)-file.
    """ $out
end

const _extension_map = Dict("tikz" => "tex")

"""
    addExtension(filepath, extension)

Change filepath extension according to the extension map
"""
function addExtension(fp, ext::AbstractString)
    dn, fn = splitdir(fp)
    _, oldext = splitext(fn)
    oldext = chop(oldext, head = 1, tail = 0)
    return get(_extension_map, oldext, oldext) == ext ? fp : joinpath(dn, string(fn, ".", ext))
end

"""
    savefig([plot,] filename)

Save a Plot (the current plot if `plot` is not passed) to file. The file
type is inferred from the file extension. All backends support png and pdf
file types, some also support svg, ps, eps, html and tex.
"""
function savefig(plt::Plot, fn) # fn might be an `AbstractString` or an `AbstractPath` from `FilePaths.jl`
    fn = abspath(expanduser(fn))

    # get the extension
    _, ext = splitext(fn)
    ext = chop(ext, head = 1, tail = 0)
    isempty(ext) && (ext = defaultOutputFormat(plt))

    # save it
    if haskey(_savemap, ext)
        func = _savemap[ext]
        return func(plt, fn)
    else
        error("Invalid file extension: ", fn)
    end
end
savefig(fn) = savefig(current(), fn)

# ---------------------------------------------------------

"""
    gui([plot])

Display a plot using the backends' gui window
"""
gui(plt::Plot = current()) = display(PlotsDisplay(), plt)

function inline end  # for IJulia

function Base.display(::PlotsDisplay, plt::Plot)
    prepare_output(plt)
    return _display(plt)
end

_do_plot_show(plt, showval::Bool) = showval && gui(plt)
function _do_plot_show(plt, showval::Symbol)
    showval === :gui && gui(plt)
    return showval in (:inline, :ijulia) && inline(plt)
end

# ---------------------------------------------------------

const _best_html_output_type = KW(
    :unicodeplots => :png,
    :pgfplotsx => :png,
    :inspectdr => :png,
    :plotlyjs => :html,
    :plotly => :html,
    :pyplot => :png,
    :gaston => :png,
    :gr => :png,
)

# a backup for html... passes to svg or png depending on the html_output_format arg
function _show(io::IO, ::MIME"text/html", plt::Plot)
    output_type = Symbol(plt.attr[:html_output_format])
    if output_type === :auto
        output_type = get(_best_html_output_type, backend_name(plt.backend), :svg)
    end
    return if output_type === :png
        # @info "writing png to html output"
        print(
            io,
            "<img src=\"data:image/png;base64,",
            base64encode(show, MIME("image/png"), plt),
            "\" />",
        )
    elseif output_type === :svg
        # @info "writing svg to html output"
        show(io, MIME("image/svg+xml"), plt)
    elseif output_type === :txt
        show(io, MIME("text/plain"), plt)
    else
        error("only png or svg allowed. got: $(repr(output_type))")
    end
end

# delegate showable to _show instead
Base.showable(m::M, ::P) where {M <: MIME, P <: Plot} = showable(m, P)
Base.showable(::M, ::Type{P}) where {M <: MIME, P <: Plot} = hasmethod(_show, Tuple{IO, M, P})

_display(plt::Plot) = @warn "_display is not defined for this backend."

Base.show(io::IO, m::MIME"text/plain", plt::Plot) = show(io, plt)
# for writing to io streams... first prepare, then callback
for mime in (
        "application/vnd.plotly.v1+json",
        "application/postscript",
        "application/x-tex",
        "application/pdf",
        "application/eps",
        "image/svg+xml",
        "text/latex",
        "image/png",
        "image/eps",
        "text/html",
    )
    @eval function Base.show(io::IO, m::MIME{Symbol($mime)}, plt::Plot)
        if haskey(io, :juno_plotsize)
            showjuno(io, m, plt)
        else
            prepare_output(plt)
            Base.invokelatest(_show, io, m, plt)
        end
        return nothing
    end
end

"Close all open gui windows of the current backend"
closeall() = closeall(backend())

# COV_EXCL_START

Base.showable(::MIME"text/html", plt::Plot{UnicodePlotsBackend}) = false  # Pluto

Base.show(io::IO, m::MIME"application/prs.juno.plotpane+html", plt::Plot) =
    showjuno(io, MIME("text/html"), plt)

# Atom PlotPane
function showjuno(io::IO, m, plt)
    dpi = plt[:dpi]

    plt[:dpi] = get(io, :juno_dpi_ratio, 1) * Plots.DPI

    prepare_output(plt)
    return try
        _showjuno(io, m, plt)
    finally
        plt[:dpi] = dpi
    end
end

_showjuno(io::IO, m::MIME"image/svg+xml", plt) =
if Symbol(plt.attr[:html_output_format]) ≠ :svg
    throw(MethodError(show, (typeof(m), typeof(plt))))
else
    _show(io, m, plt)
end

Base.showable(::MIME"application/prs.juno.plotpane+html", plt::Plot) = false

_showjuno(io::IO, m, plt) = _show(io, m, plt)
# COV_EXCL_STOP

module FileIOExt

import Plots: Plots, Plot, @ext_imp_use
@ext_imp_use :import FileIO

_fileio_load(@nospecialize(filename::AbstractString)) =
    FileIO.load(filename::AbstractString)
_fileio_save(@nospecialize(filename::AbstractString), @nospecialize(x)) =
    FileIO.save(filename::AbstractString, x)

function _show_pdfbackends(io::IO, ::MIME"image/png", plt::Plot)
    fn = tempname()

    # first save a pdf file
    Plots.pdf(plt, fn)

    # load that pdf into a FileIO Stream
    s = _fileio_load("$fn.pdf")

    # save a png
    pngfn = "$fn.png"
    _fileio_save(pngfn, s)

    # now write from the file
    return write(io, read(open(pngfn), String))
end

for be in (
        Plots.PGFPlotsBackend,  # NOTE: I guess this can be removed in Plots@2.0
    )
    showable(MIME"image/png"(), Plot{be}) && continue
    @eval Plots._show(io::IO, mime::MIME"image/png", plt::Plot{$be}) =
        _show_pdfbackends(io, mime, plt)
end

end  # module

# https://github.com/JuliaPlots/PlotlyJS.jl

# ------------------------------------------------------------------------------
include(_path(:plotly))

function plotlyjs_syncplot(plt::Plot{PlotlyJSBackend})
    plt[:overwrite_figure] && closeall()
    plt.o = PlotlyJS.plot()
    traces = PlotlyJS.GenericTrace[]
    for series_dict in plotly_series(plt)
        plotly_type = pop!(series_dict, :type)
        series_dict[:transpose] = false
        push!(traces, PlotlyJS.GenericTrace(plotly_type; series_dict...))
    end
    PlotlyJS.addtraces!(plt.o, traces...)
    layout = plotly_layout(plt)
    w, h = plt[:size]
    PlotlyJS.relayout!(plt.o, layout, width = w, height = h)
    return plt.o
end

# ------------------------------------------------------------------------------

for (mime, fmt) in (
        "application/pdf" => "pdf",
        "image/png" => "png",
        "image/svg+xml" => "svg",
        "image/eps" => "eps",
    )
    @eval _show(io::IO, ::MIME{Symbol($mime)}, plt::Plot{PlotlyJSBackend}) =
        PlotlyJS.savefig(io, plotlyjs_syncplot(plt), format = $fmt)
end

# Use the Plotly implementation for json and html:
_show(io::IO, mime::MIME"application/vnd.plotly.v1+json", plt::Plot{PlotlyJSBackend}) =
    plotly_show_js(io, plt)

html_head(plt::Plot{PlotlyJSBackend}) = plotly_html_head(plt)
html_body(plt::Plot{PlotlyJSBackend}) = plotly_html_body(plt)

_show(io::IO, ::MIME"text/html", plt::Plot{PlotlyJSBackend}) =
    write(io, embeddable_html(plt))

_display(plt::Plot{PlotlyJSBackend}) = display(plotlyjs_syncplot(plt))

PlotlyJS.WebIO.render(plt::Plot{PlotlyJSBackend}) =
    PlotlyJS.WebIO.render(plotlyjs_syncplot(plt))

closeall(::PlotlyJSBackend) =
if !isplotnull() && isa(current().o, PlotlyJS.SyncPlot)
    close(current().o)
end

Base.showable(::MIME"application/prs.juno.plotpane+html", plt::Plot{PlotlyJSBackend}) = true

@testset "check_contour_levels" begin
    @test Plots.check_contour_levels(2) === nothing
    @test Plots.check_contour_levels(-1.0:0.2:10.0) === nothing
    @test Plots.check_contour_levels([-100, -2, -1, 0, 1, 2, 100]) === nothing
    @test_throws ArgumentError Plots.check_contour_levels(1.0)
    @test_throws ArgumentError Plots.check_contour_levels((1, 2, 3))
    @test_throws ArgumentError Plots.check_contour_levels(-3)
end

@testset "Plots.preprocess_attributes!" begin
    function equal_after_pipeline(kw)
        kw′ = deepcopy(kw)
        Plots.preprocess_attributes!(kw′)
        kw == kw′
    end

    @test equal_after_pipeline(KW(:levels => 1))
    @test equal_after_pipeline(KW(:levels => 1:10))
    @test equal_after_pipeline(KW(:levels => [1.0, 3.0, 5.0]))
    @test_throws ArgumentError Plots.preprocess_attributes!(KW(:levels => 1.0))
    @test_throws ArgumentError Plots.preprocess_attributes!(KW(:levels => (1, 2, 3)))
    @test_throws ArgumentError Plots.preprocess_attributes!(KW(:levels => -3))
end

@testset "contour[f]" begin
    x = (-2π):0.1:(2π)
    y = (-π):0.1:π
    z = cos.(y) .* sin.(x')

    @testset "Incorrect input" begin
        @test_throws ArgumentError contour(x, y, z, levels = 1.0)
        @test_throws ArgumentError contour(x, y, z, levels = (1, 2, 3))
        @test_throws ArgumentError contour(x, y, z, levels = -3)
    end

    @testset "Default number" begin
        @test contour(x, y, z)[1][1].plotattributes[:levels] ==
            Plots._series_defaults[:levels]
    end

    @testset "Number" begin
        @testset "$n contours" for n in (2, 5, 100)
            p = contour(x, y, z, levels = n)
            attr = p[1][1].plotattributes
            @test attr[:seriestype] === :contour
            @test attr[:levels] == n
        end
    end

    @testset "Range" begin
        levels = -1:0.5:1
        @test contour(x, y, z, levels = levels)[1][1].plotattributes[:levels] == levels
    end

    @testset "Set of levels" begin
        levels = [-1, 0.25, 0, 0.25, 1]
        @test contour(x, y, z, levels = levels)[1][1].plotattributes[:levels] == levels
    end
end

struct NoBackend <: AbstractBackend end

lazyloadPkg() = Base.require(@__MODULE__, :Pkg)

const _toml_proj = TOML.parsefile(normpath(@__DIR__, "..", "Project.toml"))
const _toml_test = TOML.parsefile(normpath(@__DIR__, "..", "test", "Project.toml"))

const _current_plots_version = VersionNumber(_toml_proj["version"])
const _plots_compats = merge(_toml_proj["compat"], _toml_test["compat"])
const _plots_deps = merge(_toml_proj["deps"], _toml_test["deps"])

const _backendSymbol = Dict{DataType, Symbol}(NoBackend => :none)
const _backendType = Dict{Symbol, DataType}(:none => NoBackend)
const _backend_packages = Dict{Symbol, Symbol}()
const _initialized_backends = Set{Symbol}()
const _backends = Symbol[]

function _check_installed(backend::Union{Module, AbstractString, Symbol}; warn = true)
    sym = Symbol(lowercase(string(backend)))
    if warn && !haskey(_backend_packages, sym)
        @warn "backend `$sym` is not compatible with `Plots`."
        return
    end
    # lowercase -> CamelCase, falling back to the given input for `PlotlyBase` ...
    str = string(get(_backend_packages, sym, backend))
    str == "Plotly" && (str *= "Base")  # FIXME: `Plots` inconsistency, `plotly` should be named `plotlybase`
    # check supported
    if warn && !haskey(_plots_compats, str)
        @warn "backend `$str` is not compatible with `Plots`."
        return
    end
    # check installed
    pkg_id = if str == "GR"
        # FIXME: remove in `Plots2.0` (`GR` won't be a hard Plots dependency anymore).
        Base.identify_package(Plots, str)  # GR can be in the Manifest or in the Project
    else
        Base.identify_package(str)  # a Project dependency
    end
    version = if pkg_id === nothing
        nothing
    else
        pkg = lazyloadPkg()
        get(Base.invokelatest(pkg.dependencies), pkg_id.uuid, (; version = nothing)).version
    end
    version === nothing && @warn "backend `$str` is not installed."
    return version
end

function _check_compat(m::Module; warn = true)
    (be_v = _check_installed(m; warn)) === nothing && return
    be_c = _plots_compats[string(m)]
    pkg = lazyloadPkg()
    semver = Base.invokelatest(pkg.Types.semver_spec, be_c)
    if Base.invokelatest(∉, be_v, semver)
        @warn "`$m` $be_v is not compatible with this version of `Plots`. The declared compatibility is $(be_c)."
    end
    return nothing
end

const _backend_paths = Dict{Symbol, RelocatableFolders.Path}(
    :gaston => @path(joinpath(@__DIR__, "backends", "gaston.jl")),
    :gr => @path(joinpath(@__DIR__, "backends", "gr.jl")),
    :hdf5 => @path(joinpath(@__DIR__, "backends", "hdf5.jl")),
    :inspectdr => @path(joinpath(@__DIR__, "backends", "inspectdr.jl")),
    :pgfplotsx => @path(joinpath(@__DIR__, "backends", "pgfplotsx.jl")),
    :plotly => @path(joinpath(@__DIR__, "backends", "plotly.jl")),
    :plotlybase => @path(joinpath(@__DIR__, "backends", "plotlybase.jl")),
    :plotlyjs => @path(joinpath(@__DIR__, "backends", "plotlyjs.jl")),
    :pythonplot => @path(joinpath(@__DIR__, "backends", "pythonplot.jl")),
    :unicodeplots => @path(joinpath(@__DIR__, "backends", "unicodeplots.jl")),
    # Deprecated backends
    :pgfplots => @path(joinpath(@__DIR__, "backends", "deprecated", "pgfplots.jl")),
    :pyplot => @path(joinpath(@__DIR__, "backends", "deprecated", "pyplot.jl")),
)

_path(sym::Symbol) = _backend_paths[sym]

"Returns a list of supported backends"
backends() = _backends

"Returns the name of the current backend"
backend_name() = CURRENT_BACKEND.sym

_backend_instance(sym::Symbol)::AbstractBackend =
    haskey(_backendType, sym) ? _backendType[sym]() : error("Unsupported backend $sym")

backend_package_name(sym::Symbol = backend_name()) = _backend_packages[sym]

macro init_backend(s)
    package_str = string(s)
    str = lowercase(package_str)
    sym = Symbol(str)
    T = Symbol(string(s) * "Backend")
    return quote
        struct $T <: AbstractBackend end
        export $sym
        $sym(; kw...) = (default(; reset = false, kw...); backend($T()))
        backend_name(::$T) = Symbol($str)
        backend_package_name(::$T) = backend_package_name(Symbol($str))
        push!(_backends, Symbol($str))
        _backendType[Symbol($str)] = $T
        _backendSymbol[$T] = Symbol($str)
        _backend_packages[Symbol($str)] = Symbol($package_str)
    end |> esc
end

macro require_backend(pkg)
    be = QuoteNode(Symbol(lowercase("$pkg")))
    return quote
        backend_name() === $be || @require $pkg = $(_plots_deps["$pkg"]) begin
            include(_path($be))
        end
    end |> esc
end

# ---------------------------------------------------------

# don't do anything as a default
_create_backend_figure(plt::Plot) = nothing
_initialize_subplot(plt::Plot, sp::Subplot) = nothing

_series_added(plt::Plot, series::Series) = nothing
_series_updated(plt::Plot, series::Series) = nothing

_before_layout_calcs(plt::Plot) = nothing

title_padding(sp::Subplot) = sp[:title] == "" ? 0mm : sp[:titlefontsize] * pt
guide_padding(axis::Axis) = Plots.get_guide(axis) == "" ? 0mm : axis[:guidefontsize] * pt

closeall(::AbstractBackend) = nothing

"Returns the (width,height) of a text label."
function text_size(lablen::Int, sz::Number, rot::Number = 0)
    # we need to compute the size of the ticks generically
    # this means computing the bounding box and then getting the width/height
    # note:
    ptsz = sz * pt
    width = 0.8lablen * ptsz

    # now compute the generalized "height" after rotation as the "opposite+adjacent" of 2 triangles
    height = abs(sind(rot)) * width + abs(cosd(rot)) * ptsz
    width = abs(sind(rot + 90)) * width + abs(cosd(rot + 90)) * ptsz
    return width, height
end
text_size(lab::AbstractString, sz::Number, rot::Number = 0) =
    text_size(length(lab), sz, rot)
text_size(lab::PlotText, sz::Number, rot::Number = 0) = text_size(length(lab.str), sz, rot)

# account for the size/length/rotation of tick labels
function tick_padding(sp::Subplot, axis::Axis)
    return if (ticks = get_ticks(sp, axis)) === nothing
        0mm
    else
        vals, labs = ticks
        isempty(labs) && return 0mm
        # ptsz = axis[:tickfont].pointsize * pt
        longest_label = maximum(length(lab) for lab in labs)

        # generalize by "rotating" y labels
        rot = axis[:rotation] + (axis[:letter] === :y ? 90 : 0)

        # # we need to compute the size of the ticks generically
        # # this means computing the bounding box and then getting the width/height
        # labelwidth = 0.8longest_label * ptsz
        #
        #
        # # now compute the generalized "height" after rotation as the "opposite+adjacent" of 2 triangles
        # hgt = abs(sind(rot)) * labelwidth + abs(cosd(rot)) * ptsz + 1mm

        # get the height of the rotated label
        text_size(longest_label, axis[:tickfontsize], rot)[2]
    end
end

# Set the (left, top, right, bottom) minimum padding around the plot area
# to fit ticks, tick labels, guides, colorbars, etc.
function _update_min_padding!(sp::Subplot)
    # TODO: something different when `RecipesPipeline.is3d(sp) == true`
    leftpad = tick_padding(sp, sp[:yaxis]) + sp[:left_margin] + guide_padding(sp[:yaxis])
    toppad = sp[:top_margin] + title_padding(sp)
    rightpad = sp[:right_margin]
    bottompad = tick_padding(sp, sp[:xaxis]) + sp[:bottom_margin] + guide_padding(sp[:xaxis])

    # switch them?
    if sp[:xaxis][:mirror]
        bottompad, toppad = toppad, bottompad
    end
    if sp[:yaxis][:mirror]
        leftpad, rightpad = rightpad, leftpad
    end

    # @show (leftpad, toppad, rightpad, bottompad)
    return sp.minpad = (leftpad, toppad, rightpad, bottompad)
end

_update_plot_object(plt::Plot) = nothing

# ---------------------------------------------------------

mutable struct CurrentBackend
    sym::Symbol
    pkg::AbstractBackend
end
CurrentBackend(sym::Symbol) = CurrentBackend(sym, _backend_instance(sym))

# ---------------------------------------------------------
const PLOTS_DEFAULT_BACKEND = "gr"

function load_default_backend()
    CURRENT_BACKEND.sym = :gr
    return backend(CURRENT_BACKEND.sym)
end

function diagnostics(io::IO = stdout)
    origin = if has_preference(Plots, "default_backend")
        "`Preferences`"
    elseif haskey(ENV, "PLOTS_DEFAULT_BACKEND")
        "environment variable"
    else
        "fallback"
    end
    if (be = backend_name()) === :none
        @info "no `Plots` backends currently initialized"
    else
        be_name = string(backend_package_name(be))
        @info "selected `Plots` backend: $be_name, from $origin"
        pkg = lazyloadPkg()
        Base.invokelatest(
            pkg.status,
            ["Plots", "RecipesBase", "RecipesPipeline", be_name];
            mode = pkg.PKGMODE_MANIFEST,
            io,
        )
    end
    return nothing
end

# ---------------------------------------------------------

"""
Returns the current plotting package name.  Initializes package on first call.
"""
function backend()
    CURRENT_BACKEND.sym === :none && load_default_backend()
    return CURRENT_BACKEND.pkg
end

initialized(sym::Symbol) = sym ∈ _initialized_backends

"""
Set the plot backend.
"""
function backend(pkg::AbstractBackend)
    sym = backend_name(pkg)
    if !initialized(sym)
        _initialize_backend(pkg)
        push!(_initialized_backends, sym)
    end
    CURRENT_BACKEND.sym = sym
    CURRENT_BACKEND.pkg = pkg
    return pkg
end

backend(sym::Symbol) =
if sym in _backends
    backend(_backend_instance(sym))
else
    @warn "`:$sym` is not a supported backend."
    backend()
end

const _deprecated_backends =
    [:qwt, :winston, :bokeh, :gadfly, :immerse, :glvisualize, :pgfplots]

# ---------------------------------------------------------

# these are args which every backend supports because they're not used in the backend code
const _base_supported_args = [
    :color_palette,
    :background_color,
    :background_color_subplot,
    :foreground_color,
    :foreground_color_subplot,
    :group,
    :seriestype,
    :seriescolor,
    :seriesalpha,
    :smooth,
    :xerror,
    :yerror,
    :zerror,
    :subplot,
    :x,
    :y,
    :z,
    :show,
    :size,
    :margin,
    :left_margin,
    :right_margin,
    :top_margin,
    :bottom_margin,
    :html_output_format,
    :layout,
    :link,
    :primary,
    :series_annotations,
    :subplot_index,
    :discrete_values,
    :projection,
    :show_empty_bins,
    :z_order,
    :permute,
    :unitformat,
]

function merge_with_base_supported(v::AVec)
    v = vcat(v, _base_supported_args)
    for vi in v
        if haskey(_axis_defaults, vi)
            for letter in (:x, :y, :z)
                push!(v, get_attr_symbol(letter, vi))
            end
        end
    end
    return Set(v)
end

@init_backend PyPlot
@init_backend PythonPlot
@init_backend UnicodePlots
@init_backend Plotly
@init_backend PlotlyJS
@init_backend GR
@init_backend PGFPlots
@init_backend PGFPlotsX
@init_backend InspectDR
@init_backend HDF5
@init_backend Gaston

# ---------------------------------------------------------

# create the various `is_xxx_supported` and `supported_xxxs` methods
# by default they pass through to checking membership in `_gr_xxx`
for s in (:attr, :seriestype, :marker, :style, :scale)
    f1 = Symbol("is_", s, "_supported")
    f2 = Symbol("supported_", s, "s")
    @eval begin
        $f1(::AbstractBackend, $s) = false
        $f1(be::AbstractBackend, $s::AbstractVector) = all(v -> $f1(be, v), $s)
        $f1($s) = $f1(backend(), $s)
        $f2() = $f2(backend())
    end

    for be in backends()
        be_type = typeof(_backend_instance(be))
        v = Symbol("_", be, "_", s)
        @eval begin
            $f1(::$be_type, $s::Symbol) = $s in $v
            $f2(::$be_type) = sort(collect($v))
        end
    end
end

################################################################################
# custom hooks

# @require and imports
function _pre_imports(pkg::AbstractBackend)
    @eval @require_backend $(backend_package_name(pkg))
    return nothing
end

# global definitions `const` and `include`
function _post_imports(pkg::AbstractBackend)
    name = backend_package_name(pkg)
    @eval const $name = Main.$name  # so that the module is available in `Plots`
    return nothing
end

# function calls, pointer initializations, ...
_runtime_init(::AbstractBackend) = nothing

################################################################################
# initialize the backends
function _initialize_backend(pkg::AbstractBackend)
    _pre_imports(pkg)
    name = backend_package_name(pkg)
    # NOTE: this is a hack importing in `Main` (expecting the package to be in `Project.toml`, remove in `Plots@2.0`)
    # FIXME: remove hard `GR` dependency in `Plots@2.0`
    @eval name === :GR ? Plots : Main begin
        import $name
        export $name
        if $(QuoteNode(name)) !== :GR
            $(_check_compat)($name)
        end
    end
    _post_imports(pkg)
    _runtime_init(pkg)
    return nothing
end

# ------------------------------------------------------------------------------
# gr
_post_imports(::GRBackend) = nothing

const _gr_attr = merge_with_base_supported(
    [
        :annotations,
        :annotationrotation,
        :annotationhalign,
        :annotationfontsize,
        :annotationfontfamily,
        :annotationcolor,
        :annotationvalign,
        :legend_background_color,
        :background_color_inside,
        :background_color_outside,
        :legend_foreground_color,
        :foreground_color_grid,
        :foreground_color_axis,
        :foreground_color_text,
        :foreground_color_border,
        :label,
        :seriescolor,
        :seriesalpha,
        :linecolor,
        :linestyle,
        :linewidth,
        :linealpha,
        :markershape,
        :markercolor,
        :markersize,
        :markeralpha,
        :markerstrokewidth,
        :markerstrokecolor,
        :markerstrokealpha,
        :fillrange,
        :fillcolor,
        :fillalpha,
        :fillstyle,
        :bins,
        :layout,
        :title,
        :window_title,
        :guide,
        :widen,
        :lims,
        :ticks,
        :scale,
        :flip,
        :titlefontfamily,
        :titlefontsize,
        :titlefonthalign,
        :titlefontvalign,
        :titlefontrotation,
        :titlefontcolor,
        :legend_font_family,
        :legend_font_pointsize,
        :legend_font_halign,
        :legend_font_valign,
        :legend_font_rotation,
        :legend_font_color,
        :tickfontfamily,
        :tickfontsize,
        :tickfonthalign,
        :tickfontvalign,
        :tickfontrotation,
        :tickfontcolor,
        :guidefontfamily,
        :guidefontsize,
        :guidefonthalign,
        :guidefontvalign,
        :guidefontrotation,
        :guidefontcolor,
        :grid,
        :gridalpha,
        :gridstyle,
        :gridlinewidth,
        :legend_position,
        :legend_title,
        :colorbar,
        :colorbar_title,
        :colorbar_titlefont,
        :colorbar_titlefontsize,
        :colorbar_titlefontrotation,
        :colorbar_titlefontcolor,
        :colorbar_entry,
        :colorbar_scale,
        :clims,
        :fill,
        :fill_z,
        :fontfamily,
        :fontfamily_subplot,
        :line_z,
        :marker_z,
        :legend_column,
        :legend_font,
        :legend_title,
        :legend_title_font_color,
        :legend_title_font_family,
        :legend_title_font_rotation,
        :legend_title_font_pointsize,
        :legend_title_font_valigm,
        :levels,
        :line,
        :ribbon,
        :quiver,
        :orientation,
        :overwrite_figure,
        :plot_title,
        :plot_titlefontcolor,
        :plot_titlefontfamily,
        :plot_titlefontrotation,
        :plot_titlefontsize,
        :plot_titlelocation,
        :plot_titlevspan,
        :polar,
        :aspect_ratio,
        :normalize,
        :weights,
        :inset_subplots,
        :bar_width,
        :arrow,
        :framestyle,
        :tick_direction,
        :camera,
        :contour_labels,
        :connections,
        :axis,
        :thickness_scaling,
        :minorgrid,
        :minorgridalpha,
        :minorgridlinewidth,
        :minorgridstyle,
        :minorticks,
        :mirror,
        :rotation,
        :showaxis,
        :tickfonthalign,
        :formatter,
        :mirror,
        :guidefont,
    ]
)
const _gr_seriestype = [
    :path,
    :scatter,
    :straightline,
    :heatmap,
    :image,
    :contour,
    :path3d,
    :scatter3d,
    :surface,
    :wireframe,
    :mesh3d,
    :volume,
    :shape,
]
const _gr_style = [:auto, :solid, :dash, :dot, :dashdot, :dashdotdot]
const _gr_marker = vcat(_allMarkers, :pixel)
const _gr_scale = [:identity, :ln, :log2, :log10]
is_marker_supported(::GRBackend, shape::Shape) = true

# ------------------------------------------------------------------------------
# plotly
_pre_imports(::PlotlyBackend) = nothing
_post_imports(::PlotlyBackend) = @eval begin
    const PlotlyBase = Main.PlotlyBase
    const PlotlyKaleido = Main.PlotlyKaleido
    # FIXME: in Plots `2.0`, `plotly` backend should be re-named to `plotlybase`
    # so that we can trigger include on `@require` instead of this
    PLOTS_DEFAULT_BACKEND == "plotly" || include(_path(:plotly))
    include(_path(:plotlybase))
end
function _initialize_backend(pkg::PlotlyBackend)
    try
        _pre_imports(pkg)
        @eval Main begin
            import PlotlyBase
            import PlotlyKaleido
            $(_check_compat)(PlotlyBase; warn = false)  # NOTE: don't warn, since those are not backends, but deps
            $(_check_compat)(PlotlyKaleido, warn = false)
        end
        _post_imports(pkg)
        _runtime_init(pkg)
    catch err
        if err isa ArgumentError
            @warn "Failed to load integration with PlotlyBase & PlotlyKaleido." exception =
                (err, catch_backtrace())
        else
            rethrow(err)
        end
        # NOTE: `plotly` is special in the way that it does not require dependencies for displaying a plot
        # as a result, we cannot rely on the `@require` mechanism for loading glue code
        # this is why it must be done here.
        PLOTS_DEFAULT_BACKEND == "plotly" || @eval include(_path(:plotly))
    end
    return @static if isdefined(Base.Experimental, :register_error_hint)
        Base.Experimental.register_error_hint(MethodError) do io, exc, argtypes, kwargs
            if exc.f === _show &&
                    length(argtypes) == 3 &&
                    argtypes[2] <: MIME"image/png" &&
                    argtypes[3] <: Plot{PlotlyBackend}
                println(
                    io,
                    "\n\nTip: For saving/rendering as png with the `Plotly` backend `PlotlyBase` and `PlotlyKaleido` need to be installed.",
                )
            end
        end
    end
end

const _plotly_attr = merge_with_base_supported(
    [
        :annotations,
        :legend_background_color,
        :background_color_inside,
        :background_color_outside,
        :legend_foreground_color,
        :foreground_color_guide,
        :foreground_color_grid,
        :foreground_color_axis,
        :foreground_color_text,
        :foreground_color_border,
        :foreground_color_title,
        :label,
        :seriescolor,
        :seriesalpha,
        :linecolor,
        :linestyle,
        :linewidth,
        :linealpha,
        :markershape,
        :markercolor,
        :markersize,
        :markeralpha,
        :markerstrokewidth,
        :markerstrokecolor,
        :markerstrokealpha,
        :markerstrokestyle,
        :fill,
        :fillrange,
        :fillcolor,
        :fillalpha,
        :fontfamily,
        :fontfamily_subplot,
        :bins,
        :title,
        :titlelocation,
        :titlefontfamily,
        :titlefontsize,
        :titlefonthalign,
        :titlefontvalign,
        :titlefontcolor,
        :legend_column,
        :legend_font,
        :legend_font_family,
        :legend_font_pointsize,
        :legend_font_color,
        :legend_title,
        :legend_title_font_color,
        :legend_title_font_family,
        :legend_title_font_pointsize,
        :tickfontfamily,
        :tickfontsize,
        :tickfontcolor,
        :guidefontfamily,
        :guidefontsize,
        :guidefontcolor,
        :window_title,
        :arrow,
        :guide,
        :widen,
        :lims,
        :line,
        :ticks,
        :scale,
        :flip,
        :rotation,
        :tickfont,
        :guidefont,
        :legendfont,
        :grid,
        :gridalpha,
        :gridlinewidth,
        :legend,
        :colorbar,
        :colorbar_title,
        :colorbar_entry,
        :marker_z,
        :fill_z,
        :line_z,
        :levels,
        :ribbon,
        :quiver,
        :orientation,
        # :overwrite_figure,
        :polar,
        :plot_title,
        :plot_titlefontcolor,
        :plot_titlefontfamily,
        :plot_titlefontsize,
        :plot_titlelocation,
        :plot_titlevspan,
        :normalize,
        :weights,
        # :contours,
        :aspect_ratio,
        :hover,
        :inset_subplots,
        :bar_width,
        :clims,
        :framestyle,
        :tick_direction,
        :camera,
        :contour_labels,
        :connections,
        :xformatter,
        :xshowaxis,
        :xguidefont,
        :yformatter,
        :yshowaxis,
        :yguidefont,
        :zformatter,
        :zguidefont,
    ]
)

const _plotly_seriestype = [
    :path,
    :scatter,
    :heatmap,
    :contour,
    :surface,
    :wireframe,
    :path3d,
    :scatter3d,
    :shape,
    :scattergl,
    :straightline,
    :mesh3d,
]
const _plotly_style = [:auto, :solid, :dash, :dot, :dashdot]
const _plotly_marker = [
    :none,
    :auto,
    :circle,
    :rect,
    :diamond,
    :utriangle,
    :dtriangle,
    :cross,
    :xcross,
    :pentagon,
    :hexagon,
    :octagon,
    :vline,
    :hline,
    :x,
]
const _plotly_scale = [:identity, :log10]

defaultOutputFormat(plt::Plot{Plots.PlotlyBackend}) = "html"

# ------------------------------------------------------------------------------
# pgfplots

const _pgfplots_attr = merge_with_base_supported(
    [
        :annotations,
        :legend_background_color,
        :background_color_inside,
        # :background_color_outside,
        # :legend_foreground_color,
        :foreground_color_grid,
        :foreground_color_axis,
        :foreground_color_text,
        :foreground_color_border,
        :label,
        :seriescolor,
        :seriesalpha,
        :linecolor,
        :linestyle,
        :linewidth,
        :linealpha,
        :markershape,
        :markercolor,
        :markersize,
        :markeralpha,
        :markerstrokewidth,
        :markerstrokecolor,
        :markerstrokealpha,
        :markerstrokestyle,
        :fillrange,
        :fillcolor,
        :fillalpha,
        :bins,
        # :bar_width, :bar_edges,
        :title,
        # :window_title,
        :guide,
        :guide_position,
        :widen,
        :lims,
        :ticks,
        :scale,
        :flip,
        :rotation,
        :tickfont,
        :guidefont,
        :legendfont,
        :grid,
        :legend,
        :colorbar,
        :colorbar_title,
        :fill_z,
        :line_z,
        :marker_z,
        :levels,
        # :ribbon, :quiver, :arrow,
        # :orientation,
        # :overwrite_figure,
        :polar,
        # :normalize, :weights, :contours,
        :aspect_ratio,
        :tick_direction,
        :framestyle,
        :camera,
        :contour_labels,
    ]
)
const _pgfplots_seriestype = [
    :path,
    :path3d,
    :scatter,
    :steppre,
    :stepmid,
    :steppost,
    :histogram2d,
    :ysticks,
    :xsticks,
    :contour,
    :shape,
    :straightline,
]
const _pgfplots_style = [:auto, :solid, :dash, :dot, :dashdot, :dashdotdot]
const _pgfplots_marker = [
    :none,
    :auto,
    :circle,
    :rect,
    :diamond,
    :utriangle,
    :dtriangle,
    :cross,
    :xcross,
    :star5,
    :pentagon,
    :hline,
    :vline,
] #vcat(_allMarkers, Shape)
const _pgfplots_scale = [:identity, :ln, :log2, :log10]

# ------------------------------------------------------------------------------
# plotlyjs
_post_imports(::PlotlyJSBackend) = @eval begin
    const PlotlyJS = Main.PlotlyJS
    if Plots.bool_env("PLOTS_PLOTLYJS_UNSAFE_ELECTRON", "false")
        (Sys.islinux() && isdefined(PlotlyJS, :unsafe_electron)) &&
            PlotlyJS.unsafe_electron()
    end
end

const _plotlyjs_attr = _plotly_attr
const _plotlyjs_seriestype = _plotly_seriestype
const _plotlyjs_style = _plotly_style
const _plotlyjs_marker = _plotly_marker
const _plotlyjs_scale = _plotly_scale

# ------------------------------------------------------------------------------
# pyplot

_post_imports(::PyPlotBackend) = @eval begin
    const PyPlot = Main.PyPlot
    const PyCall = Main.PyPlot.PyCall
end
_runtime_init(::PyPlotBackend) = @eval begin
    pycolors = PyCall.pyimport("matplotlib.colors")
    pypath = PyCall.pyimport("matplotlib.path")
    mplot3d = PyCall.pyimport("mpl_toolkits.mplot3d")
    axes_grid1 = PyCall.pyimport("mpl_toolkits.axes_grid1")
    pypatches = PyCall.pyimport("matplotlib.patches")
    pyticker = PyCall.pyimport("matplotlib.ticker")
    pycmap = PyCall.pyimport("matplotlib.cm")
    pynp = PyCall.pyimport("numpy")

    pynp."seterr"(invalid = "ignore")

    PyPlot.ioff()  # we don't want every command to update the figure
end

function _initialize_backend(pkg::PyPlotBackend)
    _pre_imports(pkg)
    @eval Main begin
        import PyPlot
        export PyPlot
        $(_check_compat)(PyPlot)
    end
    _post_imports(pkg)
    return _runtime_init(pkg)
end

const _pyplot_attr = merge_with_base_supported(
    [
        :annotations,
        :annotationrotation,
        :annotationhalign,
        :annotationfontsize,
        :annotationfontfamily,
        :annotationcolor,
        :annotationvalign,
        :legend_background_color,
        :background_color_inside,
        :background_color_outside,
        :foreground_color_grid,
        :legend_foreground_color,
        :foreground_color_title,
        :foreground_color_axis,
        :foreground_color_border,
        :foreground_color_guide,
        :foreground_color_text,
        :label,
        :linecolor,
        :linestyle,
        :linewidth,
        :linealpha,
        :markershape,
        :markercolor,
        :markersize,
        :markeralpha,
        :markerstrokewidth,
        :markerstrokecolor,
        :markerstrokealpha,
        :fillrange,
        :fillcolor,
        :fillalpha,
        :fillstyle,
        :bins,
        :bar_width,
        :bar_edges,
        :bar_position,
        :title,
        :titlelocation,
        :titlefont,
        :window_title,
        :guide,
        :guide_position,
        :widen,
        :lims,
        :ticks,
        :scale,
        :flip,
        :rotation,
        :titlefontfamily,
        :titlefontsize,
        :titlefontcolor,
        :legend_font_family,
        :legend_font_pointsize,
        :legend_font_color,
        :tickfontfamily,
        :tickfontsize,
        :tickfontcolor,
        :guidefontfamily,
        :guidefontsize,
        :guidefontcolor,
        :grid,
        :gridalpha,
        :gridstyle,
        :gridlinewidth,
        :legend_position,
        :legend_title,
        :colorbar,
        :colorbar_title,
        :colorbar_entry,
        :colorbar_ticks,
        :colorbar_tickfontfamily,
        :colorbar_tickfontsize,
        :colorbar_tickfonthalign,
        :colorbar_tickfontvalign,
        :colorbar_tickfontrotation,
        :colorbar_tickfontcolor,
        :colorbar_titlefontcolor,
        :colorbar_titlefontsize,
        :colorbar_scale,
        :marker_z,
        :line,
        :line_z,
        :fill,
        :fill_z,
        :fontfamily,
        :fontfamily_subplot,
        :legend_column,
        :legend_font,
        :legend_title,
        :legend_title_font_color,
        :legend_title_font_family,
        :legend_title_font_pointsize,
        :levels,
        :ribbon,
        :quiver,
        :arrow,
        :orientation,
        :overwrite_figure,
        :polar,
        :plot_title,
        :plot_titlefontcolor,
        :plot_titlefontfamily,
        :plot_titlefontsize,
        :plot_titlelocation,
        :plot_titlevspan,
        :normalize,
        :weights,
        :contours,
        :aspect_ratio,
        :clims,
        :inset_subplots,
        :dpi,
        :stride,
        :framestyle,
        :tick_direction,
        :thickness_scaling,
        :camera,
        :contour_labels,
        :connections,
        :thickness_scaling,
        :axis,
        :minorgrid,
        :minorgridalpha,
        :minorgridlinewidth,
        :minorgridstyle,
        :minorticks,
        :mirror,
        :showaxis,
        :tickfontrotation,
        :formatter,
        :guidefont,
    ]
)
const _pyplot_seriestype = [
    :path,
    :steppre,
    :stepmid,
    :steppost,
    :shape,
    :straightline,
    :scatter,
    :hexbin,
    :heatmap,
    :image,
    :contour,
    :contour3d,
    :path3d,
    :scatter3d,
    :mesh3d,
    :surface,
    :wireframe,
]
const _pyplot_style = [:auto, :solid, :dash, :dot, :dashdot]
const _pyplot_marker = vcat(_allMarkers, :pixel)
const _pyplot_scale = [:identity, :ln, :log2, :log10]

# ------------------------------------------------------------------------------
# pythonplot

_post_imports(::PythonPlotBackend) = @eval begin
    const PythonPlot = Main.PythonPlot
    const PythonCall = Main.PythonPlot.PythonCall
    const mpl_toolkits = PythonPlot.pyimport("mpl_toolkits")
    const mpl = PythonPlot.pyimport("matplotlib")
    const numpy = PythonPlot.pyimport("numpy")

    PythonPlot.pyimport("mpl_toolkits.axes_grid1")
    numpy.seterr(invalid = "ignore")

    const pyisnone = if isdefined(PythonCall, :pyisnone)
        PythonCall.pyisnone
    else
        PythonCall.Core.pyisnone
    end

    PythonPlot.ioff() # we don't want every command to update the figure
end
_runtime_init(::PythonPlotBackend) = nothing

function _initialize_backend(pkg::PythonPlotBackend)
    _pre_imports(pkg)
    @eval Main begin
        import PythonPlot
        $(_check_compat)(PythonPlot)
    end
    _post_imports(pkg)
    return _runtime_init(pkg)
end

const _pythonplot_seriestype = _pyplot_seriestype
const _pythonplot_marker = _pyplot_marker
const _pythonplot_style = _pyplot_style
const _pythonplot_scale = _pyplot_scale

const _pythonplot_attr = merge_with_base_supported(
    [
        :annotations,
        :legend_background_color,
        :background_color_inside,
        :background_color_outside,
        :foreground_color_grid,
        :legend_foreground_color,
        :foreground_color_title,
        :foreground_color_axis,
        :foreground_color_border,
        :foreground_color_guide,
        :foreground_color_text,
        :label,
        :linecolor,
        :linestyle,
        :linewidth,
        :linealpha,
        :markershape,
        :markercolor,
        :markersize,
        :markeralpha,
        :markerstrokewidth,
        :markerstrokecolor,
        :markerstrokealpha,
        :fillrange,
        :fillcolor,
        :fillalpha,
        :fillstyle,
        :bins,
        :bar_width,
        :bar_edges,
        :bar_position,
        :title,
        :titlelocation,
        :titlefont,
        :window_title,
        :guide,
        :guide_position,
        :widen,
        :lims,
        :ticks,
        :scale,
        :flip,
        :rotation,
        :titlefontfamily,
        :titlefontsize,
        :titlefontcolor,
        :legend_font_family,
        :legend_font_pointsize,
        :legend_font_color,
        :tickfontfamily,
        :tickfontsize,
        :tickfontcolor,
        :guidefontfamily,
        :guidefontsize,
        :guidefontcolor,
        :grid,
        :gridalpha,
        :gridstyle,
        :gridlinewidth,
        :legend_position,
        :legend_title,
        :colorbar,
        :colorbar_title,
        :colorbar_entry,
        :colorbar_ticks,
        :colorbar_tickfontfamily,
        :colorbar_tickfontsize,
        :colorbar_tickfonthalign,
        :colorbar_tickfontvalign,
        :colorbar_tickfontrotation,
        :colorbar_tickfontcolor,
        :colorbar_titlefontcolor,
        :colorbar_titlefontsize,
        :colorbar_scale,
        :marker_z,
        :line,
        :line_z,
        :fill,
        :fill_z,
        :fontfamily,
        :fontfamily_subplot,
        :legend_column,
        :legend_font,
        :legend_title,
        :legend_title_font_color,
        :legend_title_font_family,
        :legend_title_font_pointsize,
        :levels,
        :ribbon,
        :quiver,
        :arrow,
        :orientation,
        :overwrite_figure,
        :polar,
        :normalize,
        :weights,
        :contours,
        :aspect_ratio,
        :clims,
        :inset_subplots,
        :dpi,
        :stride,
        :framestyle,
        :tick_direction,
        :camera,
        :contour_labels,
        :connections,
    ]
)

# ------------------------------------------------------------------------------
# gaston

const _gaston_attr = merge_with_base_supported(
    [
        :annotations,
        # :background_color_legend,
        # :background_color_inside,
        # :background_color_outside,
        # :foreground_color_legend,
        # :foreground_color_grid, :foreground_color_axis,
        # :foreground_color_text, :foreground_color_border,
        :label,
        :seriescolor,
        :seriesalpha,
        :linecolor,
        :linestyle,
        :linewidth,
        :linealpha,
        :markershape,
        :markercolor,
        :markersize,
        :markeralpha,
        # :markerstrokewidth, :markerstrokecolor, :markerstrokealpha, :markerstrokestyle,
        # :fillrange, :fillcolor, :fillalpha,
        # :bins,
        # :bar_width, :bar_edges,
        :title,
        :window_title,
        :guide,
        :guide_position,
        :widen,
        :lims,
        :ticks,
        :scale,
        :flip,
        :rotation,
        :tickfont,
        :guidefont,
        :legendfont,
        :grid,
        :legend,
        # :colorbar, :colorbar_title,
        # :fill_z, :line_z, :marker_z, :levels,
        # :ribbon,
        :quiver,
        :arrow,
        # :orientation, :overwrite_figure,
        :polar,
        # :normalize, :weights, :contours,
        :aspect_ratio,
        :tick_direction,
        # :framestyle,
        # :camera,
        # :contour_labels,
        :connections,
    ]
)

const _gaston_seriestype = [
    :path,
    :path3d,
    :scatter,
    :steppre,
    :stepmid,
    :steppost,
    :ysticks,
    :xsticks,
    :contour,
    :shape,
    :straightline,
    :scatter3d,
    :contour3d,
    :wireframe,
    :heatmap,
    :surface,
    :mesh3d,
    :image,
]

const _gaston_style = [:auto, :solid, :dash, :dot, :dashdot, :dashdotdot]

const _gaston_marker = [
    :none,
    :auto,
    :pixel,
    :cross,
    :xcross,
    :+,
    :x,
    :star5,
    :rect,
    :circle,
    :utriangle,
    :dtriangle,
    :diamond,
    :pentagon,
    # :hline,
    # :vline,
]

const _gaston_scale = [:identity, :ln, :log2, :log10]

# ------------------------------------------------------------------------------
# unicodeplots

const _unicodeplots_attr = merge_with_base_supported(
    [
        :annotations,
        :bins,
        :guide,
        :widen,
        :grid,
        :label,
        :layout,
        :legend,
        :legend_title_font_color,
        :lims,
        :line,
        :linealpha,
        :linecolor,
        :linestyle,
        :markershape,
        :plot_title,
        :quiver,
        :arrow,
        :seriesalpha,
        :seriescolor,
        :scale,
        :flip,
        :title,
        # :marker_z,
        :line_z,
    ]
)
const _unicodeplots_seriestype = [
    :path,
    :path3d,
    :scatter,
    :scatter3d,
    :straightline,
    # :bar,
    :shape,
    :histogram2d,
    :heatmap,
    :contour,
    # :contour3d,
    :image,
    :spy,
    :surface,
    :wireframe,
    :mesh3d,
]
const _unicodeplots_style = [:auto, :solid]
const _unicodeplots_marker = [
    :none,
    :auto,
    :pixel,
    # vvvvvvvvvv shapes
    :circle,
    :rect,
    :star5,
    :diamond,
    :hexagon,
    :cross,
    :xcross,
    :utriangle,
    :dtriangle,
    :rtriangle,
    :ltriangle,
    :pentagon,
    # :heptagon,
    # :octagon,
    :star4,
    :star6,
    # :star7,
    :star8,
    :vline,
    :hline,
    :+,
    :x,
]
const _unicodeplots_scale = [:identity, :ln, :log2, :log10]

# ------------------------------------------------------------------------------
# hdf5

const _hdf5_attr = merge_with_base_supported(
    [
        :annotations,
        :legend_background_color,
        :background_color_inside,
        :background_color_outside,
        :foreground_color_grid,
        :legend_foreground_color,
        :foreground_color_title,
        :foreground_color_axis,
        :foreground_color_border,
        :foreground_color_guide,
        :foreground_color_text,
        :label,
        :linecolor,
        :linestyle,
        :linewidth,
        :linealpha,
        :markershape,
        :markercolor,
        :markersize,
        :markeralpha,
        :markerstrokewidth,
        :markerstrokecolor,
        :markerstrokealpha,
        :fillrange,
        :fillcolor,
        :fillalpha,
        :bins,
        :bar_width,
        :bar_edges,
        :bar_position,
        :title,
        :titlelocation,
        :titlefont,
        :window_title,
        :guide,
        :widen,
        :lims,
        :ticks,
        :scale,
        :flip,
        :rotation,
        :tickfont,
        :guidefont,
        :legendfont,
        :grid,
        :legend,
        :colorbar,
        :marker_z,
        :line_z,
        :fill_z,
        :levels,
        :ribbon,
        :quiver,
        :arrow,
        :orientation,
        :overwrite_figure,
        :polar,
        :normalize,
        :weights,
        :contours,
        :aspect_ratio,
        :clims,
        :inset_subplots,
        :dpi,
        :colorbar_title,
    ]
)
const _hdf5_seriestype = [
    :path,
    :steppre,
    :stepmid,
    :steppost,
    :shape,
    :straightline,
    :scatter,
    :hexbin,
    :heatmap,
    :image,
    :contour,
    :contour3d,
    :path3d,
    :scatter3d,
    :surface,
    :wireframe,
]
const _hdf5_style = [:auto, :solid, :dash, :dot, :dashdot]
const _hdf5_marker = vcat(_allMarkers, :pixel)
const _hdf5_scale = [:identity, :ln, :log2, :log10]

# Additional constants
# Dict has problems using "Types" as keys.  Initialize in "_initialize_backend":
const HDF5PLOT_MAP_STR2TELEM = Dict{String, Type}()
const HDF5PLOT_MAP_TELEM2STR = Dict{Type, String}()

# Don't really like this global variable... Very hacky
mutable struct HDF5Plot_PlotRef
    ref::Union{Plot, Nothing}
end
const HDF5PLOT_PLOTREF = HDF5Plot_PlotRef(nothing)

# ------------------------------------------------------------------------------
# inspectdr

const _inspectdr_attr = merge_with_base_supported(
    [
        :annotations,
        :legend_background_color,
        :background_color_inside,
        :background_color_outside,
        # :foreground_color_grid,
        :legend_foreground_color,
        :foreground_color_title,
        :foreground_color_axis,
        :foreground_color_border,
        :foreground_color_guide,
        :foreground_color_text,
        :label,
        :seriescolor,
        :seriesalpha,
        :line,
        :linecolor,
        :linestyle,
        :linewidth,
        :linealpha,
        :markershape,
        :markercolor,
        :markersize,
        :markeralpha,
        :markerstrokewidth,
        :markerstrokecolor,
        :markerstrokealpha,
        :markerstrokestyle, #Causes warning not to have it... what is this?
        :fillcolor,
        :fillalpha, #:fillrange,
        #    :bins, :bar_width, :bar_edges, :bar_position,
        :title,
        :titlelocation,
        :window_title,
        :guide,
        :widen,
        :lims,
        :scale, #:ticks, :flip, :rotation,
        :titlefontfamily,
        :titlefontsize,
        :titlefontcolor,
        :legend_font_family,
        :legend_font_pointsize,
        :legend_font_color,
        :tickfontfamily,
        :tickfontsize,
        :tickfontcolor,
        :guidefontfamily,
        :guidefontsize,
        :guidefontcolor,
        :grid,
        :legend_position, #:colorbar,
        #    :marker_z,
        #    :line_z,
        #    :levels,
        #   :ribbon, :quiver, :arrow,
        #    :orientation,
        :overwrite_figure,
        :polar,
        #    :normalize, :weights,
        #    :contours, :aspect_ratio,
        #    :clims,
        #    :inset_subplots,
        :dpi,
        #    :colorbar_title,
    ]
)
const _inspectdr_style = [:auto, :solid, :dash, :dot, :dashdot]
const _inspectdr_seriestype = [
    :path,
    :scatter,
    :shape,
    :straightline, #, :steppre, :stepmid, :steppost
]
#see: _allMarkers, _shape_keys
const _inspectdr_marker = Symbol[
    :none,
    :auto,
    :circle,
    :rect,
    :diamond,
    :cross,
    :xcross,
    :utriangle,
    :dtriangle,
    :rtriangle,
    :ltriangle,
    :pentagon,
    :hexagon,
    :heptagon,
    :octagon,
    :star4,
    :star5,
    :star6,
    :star7,
    :star8,
    :vline,
    :hline,
    :+,
    :x,
]

const _inspectdr_scale = [:identity, :ln, :log2, :log10]
# ------------------------------------------------------------------------------
# pgfplotsx

_pre_imports(::PGFPlotsXBackend) = @eval Plots begin
    import LaTeXStrings: LaTeXString
    import UUIDs: uuid4
    import Latexify
    import Contour
    @require_backend PGFPlotsX
end

function _initialize_backend(pkg::PGFPlotsXBackend)
    _pre_imports(pkg)
    @eval Main begin
        import PGFPlotsX
        export PGFPlotsX
        $(_check_compat)(PGFPlotsX)
    end
    _post_imports(pkg)
    return _runtime_init(pkg)
end

const _pgfplotsx_attr = merge_with_base_supported(
    [
        :annotations,
        :annotationrotation,
        :annotationhalign,
        :annotationfontsize,
        :annotationfontfamily,
        :annotationcolor,
        :legend_background_color,
        :background_color_inside,
        :background_color_outside,
        :legend_foreground_color,
        :foreground_color_grid,
        :foreground_color_axis,
        :foreground_color_text,
        :foreground_color_border,
        :label,
        :seriescolor,
        :seriesalpha,
        :line,
        :linecolor,
        :linestyle,
        :linewidth,
        :linealpha,
        :markershape,
        :markercolor,
        :markersize,
        :markeralpha,
        :markerstrokewidth,
        :markerstrokecolor,
        :markerstrokealpha,
        :fillrange,
        :fillcolor,
        :fillalpha,
        :bins,
        :layout,
        :title,
        :window_title,
        :guide,
        :widen,
        :lims,
        :ticks,
        :scale,
        :flip,
        :titlefontfamily,
        :titlefontsize,
        :titlefonthalign,
        :titlefontvalign,
        :titlefontrotation,
        :titlefontcolor,
        :legend_font_family,
        :legend_font_pointsize,
        :legend_font_halign,
        :legend_font_valign,
        :legend_font_rotation,
        :legend_font_color,
        :tickfontfamily,
        :tickfontsize,
        :tickfonthalign,
        :tickfontvalign,
        :tickfontrotation,
        :tickfontcolor,
        :guidefontfamily,
        :guidefontsize,
        :guidefonthalign,
        :guidefontvalign,
        :guidefontrotation,
        :guidefontcolor,
        :grid,
        :gridalpha,
        :gridstyle,
        :gridlinewidth,
        :legend_position,
        :legend_title,
        :colorbar,
        :colorbar_title,
        :colorbar_titlefontsize,
        :colorbar_titlefontcolor,
        :colorbar_titlefontrotation,
        :colorbar_entry,
        :fill,
        :fill_z,
        :line_z,
        :marker_z,
        :levels,
        :legend_column,
        :legend_title,
        :legend_title_font_color,
        :legend_title_font_pointsize,
        :ribbon,
        :quiver,
        :orientation,
        :overwrite_figure,
        :polar,
        :plot_title,
        :plot_titlefontcolor,
        :plot_titlefontrotation,
        :plot_titlefontsize,
        :plot_titlevspan,
        :aspect_ratio,
        :normalize,
        :weights,
        :inset_subplots,
        :bar_width,
        :arrow,
        :framestyle,
        :tick_direction,
        :thickness_scaling,
        :camera,
        :contour_labels,
        :connections,
        :thickness_scaling,
        :axis,
        :draw_arrow,
        :minorgrid,
        :minorgridalpha,
        :minorgridlinewidth,
        :minorgridstyle,
        :minorticks,
        :mirror,
        :rotation,
        :showaxis,
        :tickfontrotation,
        :draw_arrow,
    ]
)
const _pgfplotsx_seriestype = [
    :path,
    :scatter,
    :straightline,
    :path3d,
    :scatter3d,
    :surface,
    :wireframe,
    :heatmap,
    :mesh3d,
    :contour,
    :contour3d,
    :quiver,
    :shape,
    :steppre,
    :stepmid,
    :steppost,
    :ysticks,
    :xsticks,
]
const _pgfplotsx_style = [:auto, :solid, :dash, :dot, :dashdot, :dashdotdot]
const _pgfplotsx_marker = [
    :none,
    :auto,
    :circle,
    :rect,
    :diamond,
    :utriangle,
    :dtriangle,
    :ltriangle,
    :rtriangle,
    :cross,
    :xcross,
    :x,
    :+,
    :star5,
    :star6,
    :pentagon,
    :hline,
    :vline,
]
const _pgfplotsx_scale = [:identity, :ln, :log2, :log10]
is_marker_supported(::PGFPlotsXBackend, shape::Shape) = true

# additional constants
const _pgfplotsx_series_ids = KW()

# previously https://github.com/jw3126/UnitfulRecipes.jl
# authors: Benoit Pasquier (@briochemc) - David Gustavsson (@gustaphe) - Jan Weidner (@jw3126)

module UnitfulExt

import Plots: Plots, @ext_imp_use, @recipe, PlotText, Subplot, AVec, AMat, Axis
import RecipesBase
@ext_imp_use :import Unitful Quantity unit ustrip Unitful dimension Units NoUnits LogScaled logunit MixedUnits Level Gain uconvert
import LaTeXStrings: LaTeXString
import Latexify: latexify

const MissingOrQuantity = Union{Missing, <:Quantity, <:LogScaled}

#==========
Main recipe
==========#

@recipe function f(::Type{T}, x::T) where {T <: AbstractArray{<:MissingOrQuantity}}  # COV_EXCL_LINE
    axisletter = plotattributes[:letter]   # x, y, or z
    clims_types = (:contour, :contourf, :heatmap, :surface)
    if axisletter === :z && get(plotattributes, :seriestype, :nothing) ∈ clims_types
        u = get(plotattributes, :zunit, _unit(eltype(x)))
        ustripattribute!(plotattributes, :clims, u)
        append_cbar_unit_if_needed!(plotattributes, u)
    end
    fixaxis!(plotattributes, x, axisletter)
end

function fixaxis!(attr, x, axisletter)
    # Attribute keys
    err = Symbol(axisletter, :error)       # xerror, yerror, zerror
    axisunit = Symbol(axisletter, :unit)   # xunit, yunit, zunit
    axis = Symbol(axisletter, :axis)       # xaxis, yaxis, zaxis
    # if the subplot already exists with data, use that unit
    sp = get(attr, :subplot, 1)
    if sp ≤ length(attr[:plot_object]) && attr[:plot_object].n > 0
        spu = getaxisunit(attr[:plot_object][sp][axis])
        u = if isnothing(spu)  # subplot exists but doesn't have a unit yet
            get!(attr, axisunit, _unit(eltype(x)))  # get the unit
        else
            spu
        end
    else # Subplot doesn't exist yet, so create it with given unit
        u = get!(attr, axisunit, _unit(eltype(x)))  # get the unit
    end
    # fix the attributes: labels, lims, ticks, marker/line stuff, etc.
    ustripattribute!(attr, err, u)
    if axisletter === :y
        ustripattribute!(attr, :ribbon, u)
        ustripattribute!(attr, :fillrange, u)
    end
    fixaspectratio!(attr, u, axisletter)
    fixseriescolor!(attr, :marker_z)
    fixseriescolor!(attr, :line_z)
    fixmarkersize!(attr)
    return _ustrip.(u, x)  # strip the unit
end

# Recipe for (x::AVec, y::AVec, z::Surface) types
@recipe function f(x::AVec, y::AVec, z::AMat{T}) where {T <: Quantity}  # COV_EXCL_LINE
    u = get(plotattributes, :zunit, _unit(eltype(z)))
    ustripattribute!(plotattributes, :clims, u)
    z = fixaxis!(plotattributes, z, :z)
    append_cbar_unit_if_needed!(plotattributes, u)
    x, y, z
end

# Recipe for vectors of vectors
@recipe function f(::Type{T}, x::T) where {T <: AVec{<:AVec{<:MissingOrQuantity}}}  # COV_EXCL_LINE
    axisletter = plotattributes[:letter]   # x, y, or z
    unitsymbol = Symbol(axisletter, :unit)
    axisunit = pop!(plotattributes, unitsymbol, _unit(eltype(first(x))))
    map(
        x -> (
            plotattributes[unitsymbol] = axisunit; fixaxis!(plotattributes, x, axisletter)
        ),
        x,
    )
end

# Recipe for bare units
@recipe function f(::Type{T}, x::T) where {T <: Units}  # COV_EXCL_LINE
    primary := false
    Float64[] * x
end

# Recipes for functions
@recipe f(f::Function, x::T) where {T <: AVec{<:MissingOrQuantity}} = x, f.(x)
@recipe f(x::T, f::Function) where {T <: AVec{<:MissingOrQuantity}} = x, f.(x)
@recipe f(x::T, y::AVec, f::Function) where {T <: AVec{<:MissingOrQuantity}} = x, y, f.(x', y)
@recipe f(x::AVec, y::T, f::Function) where {T <: AVec{<:MissingOrQuantity}} = x, y, f.(x', y)
@recipe function f(  # COV_EXCL_LINE
        x::T1,
        y::T2,
        f::Function,
    ) where {T1 <: AVec{<:MissingOrQuantity}, T2 <: AVec{<:MissingOrQuantity}}
    x, y, f.(x', y)
end
@recipe function f(f::Function, u::Units)  # COV_EXCL_LINE
    uf = UnitFunction(f, [u])
    recipedata = RecipesBase.apply_recipe(plotattributes, uf)
    _, xmin, xmax = recipedata[1].args
    f, xmin * u, xmax * u
end

"""
```julia
UnitFunction
```
A function, bundled with the assumed units of each of its inputs.

```julia
f(x, y) = x^2 + y
uf = UnitFunction(f, u"m", u"m^2")
uf(3, 2) == f(3u"m", 2u"m"^2) == 7u"m^2"
```
"""
struct UnitFunction <: Function
    f::Function
    u::Vector{Units}
end
(f::UnitFunction)(args...) = f.f((args .* f.u)...)

#===============
Attribute fixing
===============#
# Aspect ratio
function fixaspectratio!(attr, u, axisletter)
    aspect_ratio = get(attr, :aspect_ratio, :auto)
    if aspect_ratio in (:auto, :none)
        # Keep the default behavior (let Plots figure it out)
        return
    end
    if aspect_ratio === :equal
        aspect_ratio = 1
    end
    #=======================================================================================
    Implementation example:

    Consider an x axis in `u"m"` and a y axis in `u"s"`, and an `aspect_ratio` in `u"m/s"`.
    On the first pass, `axisletter` is `:x`, so `aspect_ratio` is converted to `u"m/s"/u"m"
    = u"s^-1"`. On the second pass, `axisletter` is `:y`, so `aspect_ratio` becomes
    `u"s^-1"*u"s" = 1`. If at this point `aspect_ratio` is *not* unitless, an error has been
    made, and the default aspect ratio fixing of Plots throws a `DimensionError` as it tries
    to compare `0 < 1u"m"`.
    =======================================================================================#
    if axisletter === :y
        attr[:aspect_ratio] = aspect_ratio * u
    elseif axisletter === :x
        attr[:aspect_ratio] = aspect_ratio / u
    end
    return nothing
end

# Markers / lines
function fixseriescolor!(attr, key)
    sp = get(attr, :subplot, 1)
    # Precedence to user-passed zunit
    if haskey(attr, :zunit)
        u = attr[:zunit]
        ustripattribute!(attr, key, u)
        # Then to an existing subplot's colorbar title
    elseif sp ≤ length(attr[:plot_object]) && attr[:plot_object].n > 0
        cbar_title = get(attr[:plot_object][sp], :colorbar_title, nothing)
        spu = cbar_title isa UnitfulString ? cbar_title.unit : nothing
        u = if isnothing(spu)
            ustripattribute!(attr, key)
        else
            ustripattribute!(attr, key, spu)
        end
        # Otherwise, get from the attribute
    else
        u = ustripattribute!(attr, key)
    end
    ustripattribute!(attr, :clims, u)
    # fixseriescolor! is called for each axis, so after the first pass,
    # u will be NoUnits and we don't want to append unit again
    return u == NoUnits || append_cbar_unit_if_needed!(attr, u)
end
fixmarkersize!(attr) = ustripattribute!(attr, :markersize)

# strip unit from attribute[key]
ustripattribute!(attr, key) =
if haskey(attr, key)
    v = attr[key]
    u = _unit(eltype(v))
    attr[key] = _ustrip.(u, v)
    u
else
    NoUnits
end

# if supplied, use the unit (optional 3rd argument)
function ustripattribute!(attr, key, u)
    if haskey(attr, key)
        v = attr[key]
        if eltype(v) <: Quantity
            attr[key] = _ustrip.(u, v)
        elseif v isa Tuple
            attr[key] = Tuple([(eltype(vi) <: Quantity ? _ustrip.(u, vi) : vi) for vi in v])
        end
    end
    return u
end

#=======================================
Label string containing unit information
Used only for colorbars, etc., which don't
have a bettter place for storing units
=======================================#

const APS = Plots.AbstractProtectedString
struct UnitfulString{S, U} <: APS
    content::S
    unit::U
end

#=====================================
Append unit to labels when appropriate
This is needed for colorbars, etc., since axes have
distinct unit handling
=====================================#

append_cbar_unit_if_needed!(attr, u) =
    append_cbar_unit_if_needed!(attr, get(attr, :colorbar_title, nothing), u)
# dispatch on the type of `label`
append_cbar_unit_if_needed!(attr, label::UnitfulString, u) = nothing
function append_cbar_unit_if_needed!(attr, label::Nothing, u)
    unitformat = get(attr, Symbol(:z, :unitformat), :round)
    if unitformat ∈ [:nounit, :none, false, nothing]
        return attr[:colorbar_title] = UnitfulString("", u)
    end
    return attr[:colorbar_title] = if Plots.backend_name() === :pgfplotsx
        UnitfulString(LaTeXString(latexify(u)), u)
    else
        UnitfulString(string(u), u)
    end
end
function append_cbar_unit_if_needed!(attr, label::S, u) where {S <: AbstractString}
    isempty(label) && return attr[:colorbar_title] = UnitfulString(label, u)
    return attr[:colorbar_title] = if Plots.backend_name() ≡ :pgfplotsx
        UnitfulString(
            LaTeXString(
                Plots.format_unit_label(
                    label,
                    latexify(u),
                    get(attr, :zunitformat, :round),
                ),
            ),
            u,
        )
    else
        UnitfulString(
            S(
                Plots.format_unit_label(
                    label,
                    u,
                    get(attr, :zunitformat, :round),
                ),
            ),
            u,
        )
    end
end

getaxisunit(::Nothing) = nothing
getaxisunit(u) = u
getaxisunit(a::Axis) = getaxisunit(a[:unit])

#==============
Fix annotations
===============#
function Plots.locate_annotation(
        sp::Subplot,
        x::MissingOrQuantity,
        y::MissingOrQuantity,
        label::PlotText,
    )
    xunit = getaxisunit(sp.attr[:xaxis])
    yunit = getaxisunit(sp.attr[:yaxis])
    return (_ustrip(xunit, x), _ustrip(yunit, y), label)
end
function Plots.locate_annotation(
        sp::Subplot,
        x::MissingOrQuantity,
        y::MissingOrQuantity,
        z::MissingOrQuantity,
        label::PlotText,
    )
    xunit = getaxisunit(sp.attr[:xaxis])
    yunit = getaxisunit(sp.attr[:yaxis])
    zunit = getaxisunit(sp.attr[:zaxis])
    return (_ustrip(xunit, x), _ustrip(yunit, y), _ustrip(zunit, z), label)
end
function Plots.locate_annotation(
        sp::Subplot,
        rel::NTuple{N, <:MissingOrQuantity},
        label,
    ) where {N}
    units = getaxisunit(sp.attr[:xaxis]),
        getaxisunit(sp.attr[:yaxis]),
        getaxisunit(sp.attr[:zaxis])
    return PlotsBase.locate_annotation(sp, _ustrip.(zip(units, rel)), label)
end

#==================#
# ticks and limits #
#==================#
Plots._transform_ticks(ticks::AbstractArray{T}, axis) where {T <: Quantity} =
    _ustrip.(getaxisunit(axis), ticks)
Plots.process_limits(lims::AbstractArray{T}, axis) where {T <: Quantity} =
    _ustrip.(getaxisunit(axis), lims)
Plots.process_limits(lims::Tuple{S, T}, axis) where {S <: Quantity, T <: Quantity} =
    _ustrip.(getaxisunit(axis), lims)

function _ustrip(u, x)
    u isa MixedUnits && return ustrip(uconvert(u, x))
    return ustrip(u, x)
end

function _unit(x)
    (t = eltype(x)) <: LogScaled && return logunit(t)
    return unit(x)
end

function Plots.pgfx_sanitize_string(s::UnitfulString)
    return UnitfulString(Plots.pgfx_sanitize_string(s.content), s.unit)
end

end  # module

@testset "Shapes" begin
    @testset "Type" begin
        square = Shape([(0, 0.0), (1, 0.0), (1, 1.0), (0, 1.0)])
        @test Plots.get_xs(square) == [0, 1, 1, 0]
        @test Plots.get_ys(square) == [0, 0, 1, 1]
        @test Plots.vertices(square) == [(0, 0), (1, 0), (1, 1), (0, 1)]
        @test isa(square, Shape{Int64, Float64})
        @test coords(square) isa Tuple{Vector{S}, Vector{T}} where {T, S}
        @test Shape(:circle) isa Shape

        xs = view([0.0, 1.0, 2.0, 1.25], 1:3)
        ys = view([6 4 7; 9 9 9], 1, :)
        tri = Shape(xs, ys)
        @test isa(tri, Shape{Float64, Int64})
        @test Plots.vertices(tri) == [(0.0, 6), (1.0, 4), (2.0, 7)]
    end

    @testset "Copy" begin
        square = Shape([(0, 0), (1, 0), (1, 1), (0, 1)])
        square2 = Shape(square)
        @test square2.x == square.x
        @test square2.y == square.y
    end

    @testset "Center" begin
        square = Shape([(0, 0), (1, 0), (1, 1), (0, 1)])
        @test Plots.center(square) == (0.5, 0.5)
    end

    @testset "Translate" begin
        square = Shape([(0, 0), (1, 0), (1, 1), (0, 1)])
        squareUp = Shape([(0, 1), (1, 1), (1, 2), (0, 2)])
        squareUpRight = Shape([(1, 1), (2, 1), (2, 2), (1, 2)])

        @test Plots.translate(square, 0, 1).x == squareUp.x
        @test Plots.translate(square, 0, 1).y == squareUp.y

        @test Plots.center(translate!(square, 1)) == (1.5, 1.5)
    end

    @testset "Rotate" begin
        # 2 radians rotation matrix
        R2 = [cos(2) sin(2); -sin(2) cos(2)]
        coords = [0 0; 1 0; 1 1; 0 1]'
        coordsRotated2 = R2 * (coords .- 0.5) .+ 0.5

        square = Shape([(0, 0), (1, 0), (1, 1), (0, 1)])

        # make a new, rotated square
        square2 = Plots.rotate(square, -2)
        @test square2.x ≈ coordsRotated2[1, :]
        @test square2.y ≈ coordsRotated2[2, :]

        # unrotate the new square in place
        rotate!(square2, 2)
        @test square2.x ≈ coords[1, :]
        @test square2.y ≈ coords[2, :]
    end

    @testset "Plot" begin
        ang = range(0, 2π, length = 60)
        ellipse(x, y, w, h) = Shape(w * sin.(ang) .+ x, h * cos.(ang) .+ y)
        myshapes = [ellipse(x, rand(), rand(), rand()) for x in 1:4]
        @test coords(myshapes) isa Tuple{Vector{Vector{S}}, Vector{Vector{T}}} where {T, S}
        local pl
        @test_nowarn pl = plot(myshapes)
        @test pl[1][1][:seriestype] === :shape
    end

    @testset "Misc" begin
        @test Plots.weave([1, 3], [2, 4]) == collect(1:4)
        @test Plots.makeshape(3) isa Plots.Shape
        @test Plots.makestar(3) isa Plots.Shape
        @test Plots.makecross() isa Plots.Shape
        @test Plots.makearrowhead(10.0) isa Plots.Shape

        @test Plots.rotate(1.0, 2.0, 5.0, (0, 0)) isa Tuple

        star = Plots.makestar(3)
        star_scaled = Plots.scale(star, 0.5)

        Plots.scale!(star, 0.5)
        @test Plots.get_xs(star) == Plots.get_xs(star_scaled)
        @test Plots.get_ys(star) == Plots.get_ys(star_scaled)

        @test Plots.extrema_plus_buffer([1, 2], 0.1) == (0.9, 2.1)
    end
end

@testset "Brush" begin
    @testset "Colors" begin
        baseline = brush(1, RGB(0, 0, 0))
        @test brush(:black) == baseline
        @test brush("black") == baseline
    end
    @testset "Weight" begin
        @test brush(10).size == 10
        @test brush(0.1).size == 1
    end
    @testset "Alpha" begin
        @test brush(0.4).alpha == 0.4
        @test brush(20).alpha === nothing
    end
    @testset "Bad Argument" begin
        # using test_logs because test_warn seems to not work anymore
        @test_logs (:warn, "Unused brush arg: nothing (Nothing)") begin
            brush(nothing)
        end
    end
end

@testset "Text" begin
    t = Plots.PlotText("foo")
    @test length(t) == 3

    f = Plots.font()
    @test Plots.PlotText(nothing).str == "nothing"
    @test text(t).str == "foo"
    @test text(t, f).str == "foo"
    @test text("bar", f).str == "bar"
    @test text(true).str == "true"

    for rotation in -180:5:180
        t = text("foo"; rotation)
        if abs(rotation) ≤ 45 || abs(rotation) ≥ 135
            @test Plots.is_horizontal(t)
        else
            @test !Plots.is_horizontal(t)
        end
    end
end

@testset "Annotations" begin
    ann = Plots.series_annotations(missing)

    @test Plots.series_annotations(["1" "2"; "3" "4"]) isa AbstractMatrix
    @test Plots.series_annotations(10).strs[1].str == "10"
    @test Plots.series_annotations(nothing) === nothing
    @test Plots.series_annotations(ann) == ann

    @test Plots.annotations(["1" "2"; "3" "4"]) isa AbstractMatrix
    @test Plots.annotations(ann) == ann
    @test Plots.annotations([ann]) == [ann]
    @test Plots.annotations(nothing) == []

    t = Plots.text("foo")
    sp = plot(1)[1]
    @test Plots.locate_annotation(sp, 1, 2, t) == (1, 2, t)
    @test Plots.locate_annotation(sp, 1, 2, 3, t) == (1, 2, 3, t)
    @test Plots.locate_annotation(sp, (0.1, 0.2), t) isa Tuple
    @test Plots.locate_annotation(sp, (0.1, 0.2, 0.3), t) isa Tuple

    # see github.com/JuliaPlots/Plots.jl/issues/4073
    anns = [(["x", "y"], [10, 20], :hexagon) (["a", "b"], [3, 4], :circle)]
    pl = plot(rand(2, 2), layout = 2, series_annotations = anns)

    # github.com/JuliaPlots/Plots.jl/pull/3634#issue-940055478
    let p = plot(
            plot(rand(10) .* 15, aspect_ratio = :equal),
            plot(rand(10) .* 10, aspect_ratio = :equal),
            legend = false,
            layout = grid(1, 2),
            frame = :box,
        )
        annotate!(sp = 1, (0.03, 0.95), text("Cats&Dogs", :left))
        annotate!(sp = 2, (0.03, 0.95), text("Cats&Dogs", :left))
    end

    for scale in Plots._logScales
        pl = plot(xlim = (1, 10), xscale = scale)
        annotate!(pl, (0.5, 0.5), "hello")
    end

    let pl = plot(1:2)
        for loc in
            (:topleft, :topcenter, :topright, :bottomleft, :bottomcenter, :bottomright)
            annotate!(pl, loc, string(loc))
        end
    end
    let pl = plot(1:2)
        for loc in (:N, :NE, :E, :SE, :S, :SW, :W, :NW, :N)
            annotate!(pl, loc, string(loc))
        end
    end
end

@testset "Fonts" begin
    @testset "Scaling" begin
        sizesToCheck = [
            :titlefontsize,
            :legendfontsize,
            :legendtitlefontsize,
            :xtickfontsize,
            :ytickfontsize,
            :ztickfontsize,
            :xguidefontsize,
            :yguidefontsize,
            :zguidefontsize,
        ]
        # get initial font sizes
        initialSizes = [Plots.default(s) for s in sizesToCheck]

        #scale up font sizes
        scalefontsizes(2)

        # get initial font sizes
        doubledSizes = [Plots.default(s) for s in sizesToCheck]

        @test doubledSizes == initialSizes * 2

        # reset font sizes
        resetfontsizes()

        finalSizes = [Plots.default(s) for s in sizesToCheck]

        @test finalSizes == initialSizes
    end
end

@testset "Series Annotations" begin
    square = Shape([(0.0, 0.0), (1.0, 0.0), (1.0, 1.0), (0.0, 1.0)])
    @test_logs (:warn, "Unused SeriesAnnotations arg: triangle (Symbol)") begin
        pl = plot(
            [1, 2, 3],
            series_annotations = (
                ["a"],
                2,    # pass a scale factor
                (1, 4), # pass two scale factors (overwrites first one)
                square, # pass a shape
                font(:courier), # pass an annotation font
                :triangle,  # pass an incorrect argument
            ),
        )
        sa = pl.series_list[1].plotattributes[:series_annotations]
        @test only(sa.strs).str == "a"
        @test sa.font.family == "courier"
        @test sa.baseshape == square
        @test sa.scalefactor == (1, 4)
    end
    spl = scatter(
        4.53 .* [1 / 1 1 / 2 1 / 3 1 / 4 1 / 5],
        [0 0 0 0 0],
        layout = (5, 1),
        ylims = (-1.1, 1.1),
        xlims = (0, 5),
        series_annotations = permutedims([["1/1"], ["1/2"], ["1/3"], ["1/4"], ["1/5"]]),
    )
    for i in 1:5
        @test only(spl.series_list[i].plotattributes[:series_annotations].strs).str ==
            "1/$i"
    end

    series_anns(pl, series) = pl.series_list[series].plotattributes[:series_annotations]
    ann_strings(ann) = [s.str for s in ann.strs]
    ann_pointsizes(ann) = [s.font.pointsize for s in ann.strs]

    let pl = plot(ones(3, 2), series_annotations = ["a" "d"; "b" "e"; "c" "f"])
        ann1 = series_anns(pl, 1)
        @test ann_strings(ann1) == ["a", "b", "c"]

        ann2 = series_anns(pl, 2)
        @test ann_strings(ann2) == ["d", "e", "f"]
    end

    let pl = plot(ones(2, 2), series_annotations = (["a" "c"; "b" "d"], square))
        ann1 = series_anns(pl, 1)
        @test ann_strings(ann1) == ["a", "b"]

        ann2 = series_anns(pl, 2)
        @test ann_strings(ann2) == ["c", "d"]

        @test ann1.baseshape == ann2.baseshape == square
    end

    let pl = plot(
            ones(3, 2),
            series_annotations = (
                permutedims(
                    [
                        (["x", "y", "z"], [10, 20, 30], (14, 15), square),
                        [("a", 42), "b", "c"],
                    ]
                ),
                (12, 13),
            ),
        )
        ann1 = series_anns(pl, 1)
        @test ann1.baseshape == square
        @test ann1.scalefactor == (14, 15)
        @test ann_strings(ann1) == ["x", "y", "z"]
        @test ann_pointsizes(ann1) == [10, 20, 30]

        ann2 = series_anns(pl, 2)
        @test ann2.scalefactor == (12, 13)
        @test ann_strings(ann2) == ["a", "b", "c"]
        @test ann2.strs[1].font.pointsize == 42
    end

    @test_throws ArgumentError plot(ones(2, 2), series_annotations = [([1],) 2; 3 4])

    pl = plot([1, 2], annotations = (1.5, 2, text("foo", :left)))
    x, y, txt = only(pl.subplots[end][:annotations])
    @test (x, y) == (1.5, 2)
    @test txt.str == "foo"

    pl = plot([1, 2], annotations = ((0.1, 0.5), :auto))
    pos, txt = only(pl.subplots[end][:annotations])
    @test pos == (0.1, 0.5)
    @test txt.str == "(a)"
end

@testset "Bezier" begin
    curve = Plots.BezierCurve([(0.0, 0.0), (0.5, 1.0), (1.0, 0.0)])
    @test curve(0.75) == (0.75, 0.375)
    @test length(coords(curve, 10)) == 10
end

using FFMPEG

"""
    Animation(dir = mktempdir()))

Represents an animation object

Frames can be added to the animation object manually by calling [`frame`](@ref).
See also [`@animate`](@ref), [`@gif`](@ref).
"""
struct Animation
    dir::String
    frames::Vector{String}
end

Animation(dir = convert(String, mktempdir())) = Animation(dir, String[])

"""
    frame(animation[, plot])

Add a plot (the current plot if not specified) to an existing animation
"""
function frame(anim::Animation, plt::P = current()) where {P <: AbstractPlot}
    i = length(anim.frames) + 1
    filename = @sprintf "%06d.png" i
    png(plt, joinpath(anim.dir, filename))
    return push!(anim.frames, filename)
end

giffn() = isijulia() ? "tmp.gif" : tempname() * ".gif"
movfn() = isijulia() ? "tmp.mov" : tempname() * ".mov"
mp4fn() = isijulia() ? "tmp.mp4" : tempname() * ".mp4"
webmfn() = isijulia() ? "tmp.webm" : tempname() * ".webm"
apngfn() = isijulia() ? "tmp.png" : tempname() * ".png"

mutable struct FrameIterator
    itr
    every::Int
    kw
end
FrameIterator(itr; every = 1, kw...) = FrameIterator(itr, every, kw)

"""
Animate from an iterator which returns the plot args each iteration.
"""
function animate(fitr::FrameIterator, fn = giffn(); kw...)
    anim = Animation()
    for (i, plotargs) in enumerate(fitr.itr)
        if mod1(i, fitr.every) == 1
            plot(wraptuple(plotargs)...; fitr.kw...)
            frame(anim)
        end
    end
    return gif(anim, fn; kw...)
end

# most things will implement this
animate(
    obj,
    fn = giffn();
    every = 1,
    fps = 20,
    loop = 0,
    variable_palette = false,
    verbose = false,
    show_msg = false,
    kw...,
) = animate(
    FrameIterator(obj, every, kw),
    fn;
    fps,
    loop,
    variable_palette,
    verbose,
    show_msg,
)

# -----------------------------------------------

"Wraps the location of an animated gif so that it can be displayed"
struct AnimatedGif
    filename::String
end

file_extension(fn) = Base.Filesystem.splitext(fn)[2][2:end]

"""
    gif(animation[, filename]; fps=20, loop=0, variable_palette=false, verbose=false, show_msg=true)
Creates an animated .gif-file from an `Animation` object.
"""
gif(anim::Animation, fn = giffn(); kw...) = buildanimation(anim, fn; kw...)
"""
    mov(animation[, filename]; fps=20, loop=0, verbose=false, show_msg=true)
Creates an .mov-file from an `Animation` object.
"""
mov(anim::Animation, fn = movfn(); kw...) = buildanimation(anim, fn, false; kw...)
"""
    mp4(animation[, filename]; fps=20, loop=0, verbose=false, show_msg=true)
Creates an .mp4-file from an `Animation` object.
"""
mp4(anim::Animation, fn = mp4fn(); kw...) = buildanimation(anim, fn, false; kw...)
"""
    webm(animation[, filename]; fps=20, loop=0, verbose=false, show_msg=true)
Creates an .webm-file from an `Animation` object.
"""
webm(anim::Animation, fn = webmfn(); kw...) = buildanimation(anim, fn, false; kw...)
"""
    apng(animation[, filename]; fps=20, loop=0, verbose=false, show_msg=true)
Creates an animated .apng-file from an `Animation` object.
"""
apng(anim::Animation, fn = apngfn(); kw...) = buildanimation(anim, fn, false; kw...)

ffmpeg_framerate(fps) = "$fps"
ffmpeg_framerate(fps::Rational) = "$(fps.num)/$(fps.den)"

function buildanimation(
        anim::Animation,
        fn::AbstractString,
        is_animated_gif::Bool = true;
        fps::Real = 20,
        loop::Integer = 0,
        variable_palette::Bool = false,
        verbose = false,
        show_msg::Bool = true,
    )
    length(anim.frames) == 0 && throw(ArgumentError("Cannot build empty animations"))

    fn = abspath(expanduser(fn))
    animdir = anim.dir
    framerate = ffmpeg_framerate(fps)
    verbose_level = (verbose isa Int ? verbose : verbose ? 32 : 16) # "error"

    if is_animated_gif
        if variable_palette
            # generate a colorpalette for each frame for highest quality, but larger filesize
            palette = "palettegen=stats_mode=single[pal],[0:v][pal]paletteuse=new=1"
            `-v $verbose_level -framerate $framerate -i $animdir/%06d.png -lavfi "$palette" -loop $loop -y $fn` |>
                ffmpeg_exe
        else
            # generate a colorpalette first so ffmpeg does not have to guess it
            `-v $verbose_level -i $animdir/%06d.png -vf "palettegen=stats_mode=full" -y "$animdir/palette.bmp"` |>
                ffmpeg_exe
            # then apply the palette to get better results
            `-v $verbose_level -framerate $framerate -i $animdir/%06d.png -i "$animdir/palette.bmp" -lavfi "paletteuse=dither=sierra2_4a" -loop $loop -y $fn` |>
                ffmpeg_exe
        end
    elseif file_extension(fn) in ("png", "apng")
        # FFMPEG specific command for APNG (Animated PNG) animations
        `-v $verbose_level -framerate $framerate -i $animdir/%06d.png -plays $loop -f apng  -y $fn` |>
            ffmpeg_exe
    else
        `-v $verbose_level -framerate $framerate -i $animdir/%06d.png -vf format=yuv420p -loop $loop -y $fn` |>
            ffmpeg_exe
    end

    show_msg && @info "Saved animation to $fn"
    return AnimatedGif(fn)
end

# write out html to view the gif
function Base.show(io::IO, ::MIME"text/html", agif::AnimatedGif)
    html = if (ext = file_extension(agif.filename)) == "gif"
        "<img src=\"data:image/gif;base64,$(base64encode(read(agif.filename)))\" />"
    elseif ext == "apng"
        "<img src=\"data:image/png;base64,$(base64encode(read(agif.filename)))\" />"
    elseif ext in ("mov", "mp4", "webm")
        mimetype = ext == "mov" ? "video/quicktime" : "video/$ext"
        "<video autoplay controls><source src=\"data:$mimetype;base64,$(base64encode(read(agif.filename)))\" type = \"$mimetype\"></video>"
    else
        error("Cannot show animation with extension $ext: $agif")
    end

    write(io, html)
    return nothing
end

# Only gifs can be shown via image/gif
Base.showable(::MIME"image/gif", agif::AnimatedGif) = file_extension(agif.filename) == "gif"
Base.showable(::MIME"image/png", agif::AnimatedGif) =
let ext = file_extension(agif.filename)
    ext == "apng" || ext == "png"
end

Base.show(io::IO, ::MIME"image/gif", agif::AnimatedGif) =
    open(fio -> write(io, fio), agif.filename)

Base.show(io::IO, ::MIME"image/png", agif::AnimatedGif) =
    open(fio -> write(io, fio), agif.filename)

# -----------------------------------------------

function _animate(forloop::Expr, args...; type::Symbol = :none)
    forloop.head ∈ (:for, :while) ||
        error("@animate macro expects a for- or while-block: $(forloop.head)")

    # add the call to frame to the end of each iteration
    animsym = gensym("anim")
    countersym = gensym("counter")
    freqassert = :()
    block = forloop.args[2]

    animationsKwargs = Any[]
    filterexpr = true

    n = length(args)
    i = 1
    # create filter and read parameters
    while i <= n
        arg = args[i]
        if arg in (:when, :every)
            # specification of frame filter
            @assert i < n
            filterexpr == true ||
                error("Can only specify one filterexpression (one of 'when' or 'every')")

            filterexpr = #      when          every
                arg == :when ? args[i + 1] : :(mod1($countersym, $(args[i + 1])) == 1)

            i += 1
        elseif arg isa Expr && arg.head == Symbol("=")
            #specification of type <kwarg> = <spec>
            lhs, rhs = arg.args
            push!(animationsKwargs, :($lhs = $rhs))
        else
            error("Parameter specification not understood: $(arg)")
        end
        i += 1
    end

    push!(
        block.args, :(
            if $filterexpr
                Plots.frame($animsym)
            end
        )
    )
    push!(block.args, :($countersym += 1))

    # add a final call to `gif(anim)`?
    retval = if type === :gif
        :(Plots.gif($animsym; $(animationsKwargs...)))
    elseif type === :apng
        :(Plots.apng($animsym; $(animationsKwargs...)))
    else
        animsym
    end

    # full expression:
    return quote
        $freqassert                     # if filtering, check frequency is an Integer > 0
        $animsym = Plots.Animation()    # init animation object
        let $countersym = 1             # init iteration counter
            $forloop                    # for loop, saving a frame after each iteration
        end
        $retval                         # return the animation object, or the gif
    end |> esc
end

"""
Builds an `Animation` using one frame per loop iteration, then create an animated GIF.

Example:

```
  p = plot(1)
  @gif for x=0:0.1:5
    push!(p, 1, sin(x))
  end
```
This macro supports additional parameters, that may be added after the main loop body.
- Add `fps=n` with positive Integer n, to specify the desired frames per second.
- Add `every n` with positive Integer n, to take only one frame every nth iteration.
- Add `when <cond>` where `<cond>` is an Expression resulting in a Boolean, to take a
    frame only when `<cond>` returns `true`. Is incompatible with `every`.
"""
macro gif(forloop::Expr, args...)
    return _animate(forloop, args...; type = :gif)
end

"""
Builds an `Animation` using one frame per loop iteration, then create an animated PNG (APNG).

Example:

```
  p = plot(1)
  @apng for x=0:0.1:5
    push!(p, 1, sin(x))
  end
```
This macro supports additional parameters, that may be added after the main loop body.
- Add `fps=n` with positive Integer n, to specify the desired frames per second.
- Add `every n` with positive Integer n, to take only one frame every nth iteration.
- Add `when <cond>` where `<cond>` is an Expression resulting in a Boolean, to take a
    frame only when `<cond>` returns `true`. Is incompatible with `every`.
"""
macro apng(forloop::Expr, args...)
    return _animate(forloop, args...; type = :apng)
end

"""
Collect one frame per for-block iteration and return an `Animation` object.

Example:

```
p = plot(1)
anim = @animate for x=0:0.1:5
    push!(p, 1, sin(x))
end
gif(anim)
```
This macro supports additional parameters, that may be added after the main loop body.
- Add `every n` with positive Integer n, to take only one frame every nth iteration.
- Add `when <cond>` where `<cond>` is an Expression resulting in a Boolean, to take a
    frame only when `<cond>` returns `true`. Is incompatible with `every`.
"""
macro animate(forloop::Expr, args...)
    return _animate(forloop, args...)
end

@testset "Axes" begin
    pl = plot()
    axis = pl.subplots[1][:xaxis]
    @test typeof(axis) == Plots.Axis
    @test Plots.discrete_value!(axis, "HI") == (0.5, 1)
    @test Plots.discrete_value!(axis, :yo) == (1.5, 2)
    @test Plots.ignorenan_extrema(axis) == (0.5, 1.5)
    @test axis[:discrete_map] == Dict{Any, Any}(:yo => 2, "HI" => 1)

    Plots.discrete_value!(axis, map(i -> "x$i", 1:5))
    Plots.discrete_value!(axis, map(i -> "x$i", 0:2))
    @test Plots.ignorenan_extrema(axis) == (0.5, 7.5)

    # github.com/JuliaPlots/Plots.jl/issues/4375
    for lab in ("foo", :foo)
        pl = plot(1:2, xlabel = lab, ylabel = lab, title = lab)
        show(devnull, pl)
    end

    @test Plots.labelfunc_tex(:log10)(1) == "10^{1}"
    @test Plots.labelfunc_tex(:log2)(1) == "2^{1}"
    @test Plots.labelfunc_tex(:ln)(1) == "e^{1}"

    @test Plots.get_labels(:auto, 1:3, :identity) == ["1", "2", "3"]
    @test Plots.get_labels(:scientific, float.(500:500:1500), :identity) ==
        ["5.00×10^{2}", "1.00×10^{3}", "1.50×10^{3}"]
    @test Plots.get_labels(:engineering, float.(500:500:1500), :identity) ==
        ["500.×10^{0}", "1.00×10^{3}", "1.50×10^{3}"]
    @test Plots.get_labels(:latex, 1:3, :identity) == ["\$1\$", "\$2\$", "\$3\$"]
    # GR is used during tests and it correctly overrides labelfunc(), but PGFPlotsX did not
    Plots.with(:pgfplotsx) do
        @test Plots.get_labels(:auto, 1:3, :log10) == ["10^{1}", "10^{2}", "10^{3}"]
    end
    @test Plots.get_labels(:auto, 1:3, :log10) == ["10^{1}", "10^{2}", "10^{3}"]
    @test Plots.get_labels(:auto, 1:3, :log2) == ["2^{1}", "2^{2}", "2^{3}"]
    @test Plots.get_labels(:auto, 1:3, :ln) == ["e^{1}", "e^{2}", "e^{3}"]
    @test Plots.get_labels(:latex, 1:3, :log10) ==
        ["\$10^{1}\$", "\$10^{2}\$", "\$10^{3}\$"]
    @test Plots.get_labels(:latex, 1:3, :log2) == ["\$2^{1}\$", "\$2^{2}\$", "\$2^{3}\$"]
    @test Plots.get_labels(:latex, 1:3, :ln) == ["\$e^{1}\$", "\$e^{2}\$", "\$e^{3}\$"]

    @test Plots.get_labels(x -> 1.0e3x, 1:3, :identity) == ["1000", "2000", "3000"]
    @test Plots.get_labels(x -> 1.0e3x, 1:3, :log10) == ["10^{4}", "10^{5}", "10^{6}"]
    @test Plots.get_labels(x -> 8x, 1:3, :log2) == ["2^{4}", "2^{5}", "2^{6}"]
    @test Plots.get_labels(x -> ℯ * x, 1:3, :ln) == ["e^{2}", "e^{3}", "e^{4}"]
    @test Plots.get_labels(x -> string(x, " MB"), 1:3, :identity) ==
        ["1.0 MB", "2.0 MB", "3.0 MB"]
    @test Plots.get_labels(x -> string(x, " MB"), 1:3, :log10) ==
        ["10.0 MB", "100.0 MB", "1000.0 MB"]
end

@testset "Showaxis" begin
    for value in Plots._allShowaxisArgs
        @test plot(1:5, showaxis = value)[1][:yaxis][:showaxis] isa Bool
    end
    @test plot(1:5, showaxis = :y)[1][:yaxis][:showaxis]
    @test !plot(1:5, showaxis = :y)[1][:xaxis][:showaxis]
end

@testset "Magic axis" begin
    @test isempty(plot(1, axis = nothing)[1][:xaxis][:ticks])
    @test isempty(plot(1, axis = nothing)[1][:yaxis][:ticks])
end

@testset "Categorical ticks" begin
    p1 = plot('A':'M', 1:13)
    p2 = plot('A':'Z', 1:26)
    p3 = plot('A':'Z', 1:26, ticks = :all)
    @test Plots.get_ticks(p1[1], p1[1][:xaxis])[2] == string.('A':'M')
    @test Plots.get_ticks(p2[1], p2[1][:xaxis])[2] == string.('C':3:'Z')
    @test Plots.get_ticks(p3[1], p3[1][:xaxis])[2] == string.('A':'Z')
end

@testset "Ticks getter functions" begin
    ticks1 = ([1, 2, 3], ("a", "b", "c"))
    ticks2 = ([4, 5], ("e", "f"))
    p1 = plot(1:5, 1:5, 1:5, xticks = ticks1, yticks = ticks1, zticks = ticks1)
    p2 = plot(1:5, 1:5, 1:5, xticks = ticks2, yticks = ticks2, zticks = ticks2)
    pl = plot(p1, p2)
    @test xticks(pl) == yticks(pl) == zticks(pl) == [ticks1, ticks2]
    @test xticks(pl[1]) == yticks(pl[1]) == zticks(pl[1]) == ticks1
end

@testset "Axis limits" begin
    default_widen(from, to) = Plots.scale_lims(from, to, Plots.default_widen_factor)

    pl = plot(1:5, xlims = :symmetric, widen = false)
    @test Plots.xlims(pl) == (-5, 5)

    pl = plot(1:3)
    @test Plots.xlims(pl) == default_widen(1, 3)

    pl = plot([1.05, 2.0, 2.95], ylims = :round)
    @test Plots.ylims(pl) == (1, 3)

    for x in (1:3, -10:10), xlims in ((1, 5), [1, 5])
        pl = plot(x; xlims)
        @test Plots.xlims(pl) == (1, 5)
        pl = plot(x; xlims, widen = true)
        @test Plots.xlims(pl) == default_widen(1, 5)
    end

    pl = plot(1:5, lims = :symmetric, widen = false)
    @test Plots.xlims(pl) == Plots.ylims(pl) == (-5, 5)

    for xlims in (0, 0.0, false, true, plot())
        pl = plot(1:5; xlims)
        plims =
            @test_logs (:warn, r"Invalid limits for x axis") match_mode = :any Plots.xlims(
            pl,
        )
        @test plims == default_widen(1, 5)
    end

    @testset "#4379" begin
        for ylims in ((-5, :auto), [-5, :auto])
            pl = plot([-2, 3], ylims = ylims, widen = false)
            @test Plots.ylims(pl) == (-5.0, 3.0)
        end
        for ylims in ((:auto, 4), [:auto, 4])
            pl = plot([-2, 3], ylims = ylims, widen = false)
            @test Plots.ylims(pl) == (-2.0, 4.0)
        end

        for xlims in ((-3, :auto), [-3, :auto])
            pl = plot([-2, 3], [-1, 1], xlims = xlims, widen = false)
            @test Plots.xlims(pl) == (-3.0, 3.0)
        end
        for xlims in ((:auto, 4), [:auto, 4])
            pl = plot([-2, 3], [-1, 1], xlims = xlims, widen = false)
            @test Plots.xlims(pl) == (-2.0, 4.0)
        end
    end
end

@testset "3D Axis" begin
    ql = quiver([1, 2], [2, 1], [3, 4], quiver = ([1, -1], [0, 0], [1, -0.5]), arrow = true)
    @test ql[1][:projection] == "3d"

    @testset "#3419 - `aspect_ratio` must not alter 3D limits" begin
        # `RecipesPipeline.is3d(:sp)` dispatched on a `Symbol` and so always returned
        # `false`, letting the *2D* aspect correction - which derives its factor from the
        # plot area's pixel width / height - leak into 3D subplots and silently widen the
        # `x` / `y` limits.
        x, y = range(0, 10, length = 10), range(0, 1, length = 10)
        z = [xi * yi for xi in x, yi in y]
        for ar in (:none, :equal, 1)
            pl = surface(x, y, z, aspect_ratio = ar)
            Plots.prepare_output(pl)  # `plotarea` is degenerate until laid out
            @test Plots.xlims(pl) == (0, 10)
            @test Plots.ylims(pl) == (0, 1)
            @test Plots.zlims(pl) == (0, 10)
        end
    end
end

@testset "Twinx" begin
    pl = plot(1:10, margin = 2Plots.cm)
    twpl = twinx(pl)
    pl! = plot!(twpl, -(1:10))
    @test twpl[:right_margin] == 2Plots.cm
    @test twpl[:left_margin] == 2Plots.cm
    @test twpl[:top_margin] == 2Plots.cm
    @test twpl[:bottom_margin] == 2Plots.cm
end

@testset "Axis-aliases" begin
    @test haskey(Plots._keyAliases, :xguideposition)
    @test haskey(Plots._keyAliases, :x_guide_position)
    @test !haskey(Plots._keyAliases, :xguide_position)
    pl = plot(1:2, xl = "x label")
    @test Plots.get_guide(pl[1][:xaxis]) === "x label"
    pl = plot(1:2, xrange = (0, 3))
    @test xlims(pl) === (0, 3)
    pl = plot(1:2, xtick = [1.25, 1.5, 1.75])
    @test pl[1][:xaxis][:ticks] == [1.25, 1.5, 1.75]
    pl = plot(1:2, xlabelfontsize = 4)
    @test pl[1][:xaxis][:guidefontsize] == 4
    pl = plot(1:2, xgα = 0.07)
    @test pl[1][:xaxis][:gridalpha] ≈ 0.07
    pl = plot(1:2, xgridls = :dashdot)
    @test pl[1][:xaxis][:gridstyle] === :dashdot
    pl = plot(1:2, xgridcolor = :red)
    @test pl[1][:xaxis][:foreground_color_grid] === RGBA{Float64}(1.0, 0.0, 0.0, 1.0)
    pl = plot(1:2, xminorgridcolor = :red)
    @test pl[1][:xaxis][:foreground_color_minor_grid] === RGBA{Float64}(1.0, 0.0, 0.0, 1.0)
    pl = plot(1:2, xgrid_lw = 0.01)
    @test pl[1][:xaxis][:gridlinewidth] ≈ 0.01
    pl = plot(1:2, xminorgrid_lw = 0.01)
    @test pl[1][:xaxis][:minorgridlinewidth] ≈ 0.01
    pl = plot(1:2, xtickor = :out)
    @test pl[1][:xaxis][:tick_direction] === :out
end

@testset "Aliases" begin
    compare(pl::Plot, s::Symbol, val, op) =
        op(pl[1][:xaxis][s], val) && op(pl[1][:yaxis][s], val) && op(pl[1][:zaxis][s], val)
    pl = plot(1:2, guide = "all labels")
    @test compare(pl, :guide, "all labels", ===)
    pl = plot(1:2, label = "test")
    @test compare(pl, :guide, "", ===)
    pl = plot(1:2, lim = (0, 3))
    @test xlims(pl) === ylims(pl) === zlims(pl) === (0, 3)
    pl = plot(1:2, tick = [1.25, 1.5, 1.75])
    @test compare(pl, :ticks, [1.25, 1.5, 1.75], ==)
    pl = plot(1:2, labelfontsize = 4)
    @test compare(pl, :guidefontsize, 4, ==)
    pl = plot(1:2, gα = 0.07)
    @test compare(pl, :gridalpha, 0.07, ≈)
    pl = plot(1:2, gridls = :dashdot)
    @test compare(pl, :gridstyle, :dashdot, ===)
    pl = plot(1:2, gridcolor = :red)
    @test compare(pl, :foreground_color_grid, RGBA{Float64}(1.0, 0.0, 0.0, 1.0), ===)
    pl = plot(1:2, minorgridcolor = :red)
    @test compare(pl, :foreground_color_minor_grid, RGBA{Float64}(1.0, 0.0, 0.0, 1.0), ===)
    pl = plot(1:2, grid_lw = 0.01)
    @test compare(pl, :gridlinewidth, 0.01, ≈)
    pl = plot(1:2, minorgrid_lw = 0.01)
    @test compare(pl, :minorgridlinewidth, 0.01, ≈)
    pl = plot(1:2, tickor = :out)
    @test compare(pl, :tick_direction, :out, ===)
end

@testset "scale_lims!" begin
    let pl = plot(1:2)
        xl, yl = xlims(pl), ylims(pl)
        Plots.scale_lims!(:x, 1.1)
        @test first(xlims(pl)) < first(xl)
        @test last(xlims(pl)) > last(xl)
        @test ylims(pl) == yl
    end

    let pl = plot(1:2)
        xl, yl = xlims(pl), ylims(pl)
        Plots.scale_lims!(pl, 1.1)
        @test first(xlims(pl)) < first(xl)
        @test last(xlims(pl)) > last(xl)
        @test first(ylims(pl)) < first(yl)
        @test last(ylims(pl)) > last(yl)
    end
end

@testset "reset_extrema!" begin
    pl = plot(1:2)
    Plots.reset_extrema!(pl[1])
    ax = pl[1][:xaxis]
    @test Plots.expand_extrema!(ax, nothing) == ax[:extrema]
    @test Plots.expand_extrema!(ax, true) == ax[:extrema]
end

@testset "no labels" begin
    # github.com/JuliaPlots/Plots.jl/issues/4475
    pl = plot(100:100:300, hcat([1, 2, 4], [-1, -2, -4]); yformatter = :none)
    @test pl[1][:yaxis][:formatter] === :none
end

@testset "minor ticks" begin
    # FIXME in 2.0: this is awful to read, because `minorticks` represent the number of `intervals`
    for minor_intervals in (:auto, :none, nothing, false, true, 0, 1, 2, 3, 4, 5)
        n_minor_ticks_per_major = if minor_intervals isa Bool
            minor_intervals ? Plots.DEFAULT_MINOR_INTERVALS[] - 1 : 0
        elseif minor_intervals === :auto
            Plots.DEFAULT_MINOR_INTERVALS[] - 1
        elseif minor_intervals === :none || minor_intervals isa Nothing
            0
        else
            max(0, minor_intervals - 1)
        end
        pl = plot(1:4; minorgrid = true, minorticks = minor_intervals)
        sp = first(pl)
        for axis in (:xaxis, :yaxis)
            ticks = Plots.get_ticks(sp, sp[axis], update = false)
            n_expected_minor_ticks = (length(first(ticks)) - 1) * n_minor_ticks_per_major
            minor_ticks = Plots.get_minor_ticks(sp, sp[axis], ticks)
            n_minor_ticks = if minor_intervals isa Bool
                if minor_intervals
                    length(minor_ticks)
                else
                    @test minor_ticks isa Nothing
                    0
                end
            elseif minor_intervals === :auto
                length(minor_ticks)
            elseif minor_intervals === :none || minor_intervals isa Nothing
                @test minor_ticks isa Nothing
                0
            else
                length(minor_ticks)
            end
            show(devnull, pl)
            @test n_minor_ticks == n_expected_minor_ticks
        end
    end
end

@testset "axis guides (labels)" begin
    yguide(pl, idx = length(pl.subplots)) = Plots.get_guide(pl.subplots[idx].attr[:yaxis])

    @test yguide(plot(1:3, ylabel = "hello")) == "hello"
    @test yguide(plot(1:3, ylabel = L"hello")) == L"hello"
    @test yguide(plot(1:3, ylabel = :hello)) == :hello

    @test yguide(plot(1:3, yunit = 1)) == "1"
    @test yguide(plot(1:3, yunit = 1, ylabel = :hello)) == "hello (1)"
    @test yguide(plot(1:3, yunit = 1, ylabel = :hello, unitformat = :square)) == "hello [1]"
    @test yguide(plot(1:3, yunit = 1, ylabel = L"hello")) == L"hello" * " (1)"

    uf = (l, u) -> Symbol(l, "_symb_", u)
    @test yguide(plot(1:3, yunit = 1, ylabel = :hello, unitformat = uf)) == :hello_symb_1

end

using Plots, Test
using Unitful
using Unitful: m, cm, s, DimensionError
using Latexify
# Some helper functions to access the subplot labels and the series inside each test plot
xguide(pl, idx = length(pl.subplots)) = Plots.get_guide(pl.subplots[idx].attr[:xaxis])
yguide(pl, idx = length(pl.subplots)) = Plots.get_guide(pl.subplots[idx].attr[:yaxis])
zguide(pl, idx = length(pl.subplots)) = Plots.get_guide(pl.subplots[idx].attr[:zaxis])
ctitle(pl, idx = length(pl.subplots)) = pl.subplots[idx].attr[:colorbar_title]
xseries(pl, idx = length(pl.series_list)) = pl.series_list[idx].plotattributes[:x]
yseries(pl, idx = length(pl.series_list)) = pl.series_list[idx].plotattributes[:y]
zseries(pl, idx = length(pl.series_list)) = pl.series_list[idx].plotattributes[:z]

testfile = tempname() * ".png"

macro isplot(ex) # @isplot macro to streamline tests
    return :(@test $(esc(ex)) isa Plots.Plot)
end

@testset "heatmap" begin
    x = (1:3)m
    @isplot heatmap(x * x', clims = (1, 7)) # unitless
    @isplot heatmap(x * x', clims = (2m^2, 8m^2)) # units
    @isplot heatmap(x * x', clims = (2.0e6u"mm^2", 7.0e-6u"km^2")) # conversion
    @isplot heatmap(1:3, (1:3)m, x * x', clims = (1m^2, 7.0e-6u"km^2")) # mixed
end

@testset "plot(y)" begin
    y = rand(3)m

    @testset "no keyword argument" begin
        @test yguide(plot(y)) == "m"
        @test yseries(plot(y)) ≈ ustrip.(y)
    end

    @testset "ylabel" begin
        @test yguide(plot(y, ylabel = "hello")) == "hello (m)"
        @test yguide(plot(y, ylabel = P"hello")) == "hello"
        @test yguide(plot(y, ylabel = "hello", unitformat = :nounit)) == "hello"
        pl = plot(y, ylabel = "")
        @test yguide(pl) == ""
        @test yguide(plot!(pl, -y)) == ""
        @test yguide(plot(y, ylabel = "", unitformat = :round)) == "m"
        pl = plot(y; ylabel = "hello")
        plot!(pl, -y)
        @test yguide(pl) == "hello (m)"
        plot!(pl, -y; ylabel = "goodbye")
        @test yguide(pl) == "goodbye (m)"
        pl = plot(y)
        plot!(pl, -y; ylabel = "hello")
        @test yguide(pl) == "hello (m)"
    end

    @testset "yunit" begin
        @test yguide(plot(y, yunit = cm)) == "cm"
        @test yseries(plot(y, yunit = cm)) ≈ ustrip.(cm, y)
        @test plot([copy(y), copy(y)], yunit = cm) |> pl -> yseries(pl, 1) ≈ yseries(pl, 2)
        pl = plot(y)
        @test_logs (:warn, r"Overriding unit") plot!(pl; yunit = cm)
        @test yguide(pl) == "cm"
        plot!(pl; ylabel = "hello")
        @test yguide(pl) == "hello (cm)"
    end

    @testset "ylims" begin # Using all(lims .≈ lims) because of uncontrolled type conversions?
        @test all(ylims(plot(y, ylims = (-1, 3))) .≈ (-1, 3))
        @test all(ylims(plot(y, ylims = (-1m, 3m))) .≈ (-1, 3))
        @test all(ylims(plot(y, ylims = (-100cm, 300cm))) .≈ (-1, 3))
        @test all(ylims(plot(y, ylims = (-100cm, 3m))) .≈ (-1, 3))
        @test all(ylims(plot!(; ylims = (-2cm, 1cm))) .≈ (-0.02, 0.01))
        @test_throws DimensionError begin
            pl = plot(y)
            plot!(pl; ylims = (-1s, 5s))
            savefig(pl, testfile)
        end
    end

    @testset "yticks" begin
        compare_yticks(pl, expected_ticks) = all(first(first(yticks(pl))) .≈ expected_ticks)
        encompassing_ylims = (-1m, 6m)
        @test compare_yticks(plot(y; ylims = encompassing_ylims, yticks = (1:5)m), 1:5)
        @test compare_yticks(
            plot(y; ylims = encompassing_ylims, yticks = [1cm, 3cm]),
            [0.01, 0.03],
        )
        @test compare_yticks(
            plot!(; ylims = encompassing_ylims, yticks = [-1cm, 4cm]),
            [-0.01, 0.04],
        )
        @test_throws DimensionError begin
            pl = plot(y)
            plot!(pl; yticks = (1:5)s)
            savefig(pl, testfile)
        end
    end

    @testset "keyword combinations" begin
        @test yguide(plot(y, yunit = cm, ylabel = "hello")) == "hello (cm)"
        @test yseries(plot(y, yunit = cm, ylabel = "hello")) ≈ ustrip.(cm, y)
        @test all(ylims(plot(y, yunit = cm, ylims = (-1, 3))) .≈ (-1, 3))
        @test all(ylims(plot(y, yunit = cm, ylims = (-1, 3))) .≈ (-1, 3))
        @test all(ylims(plot(y, yunit = cm, ylims = (-100cm, 300cm))) .≈ (-100, 300))
        @test all(ylims(plot(y, yunit = cm, ylims = (-100cm, 3m))) .≈ (-100, 300))
    end
end

@testset "plot(x,y)" begin
    x, y = randn(3)m, randn(3)s

    @testset "no keyword argument" begin
        @test xguide(plot(x, y)) == "m"
        @test xseries(plot(x, y)) ≈ ustrip.(x)
        @test yguide(plot(x, y)) == "s"
        @test yseries(plot(x, y)) ≈ ustrip.(y)
    end

    @testset "labels" begin
        @test xguide(plot(x, y, xlabel = "hello")) == "hello (m)"
        @test xguide(plot(x, y, xlabel = P"hello")) == "hello"
        @test yguide(plot(x, y, ylabel = "hello")) == "hello (s)"
        @test yguide(plot(x, y, ylabel = P"hello")) == "hello"
        @test xguide(plot(x, y, xlabel = "hello", ylabel = "hello")) == "hello (m)"
        @test xguide(plot(x, y, xlabel = P"hello", ylabel = P"hello")) == "hello"
        @test yguide(plot(x, y, xlabel = "hello", ylabel = "hello")) == "hello (s)"
        @test yguide(plot(x, y, xlabel = P"hello", ylabel = P"hello")) == "hello"
    end

    @testset "unitformat" begin
        args = (x, y)
        kwargs = (:xlabel => "hello", :ylabel => "hello")
        @test yguide(plot(args...; kwargs..., unitformat = nothing)) == "hello s"
        @test yguide(
            plot(
                args...;
                kwargs...,
                unitformat = (l, u) -> string(u, " is the unit of ", l),
            ),
        ) == "s is the unit of hello"
        @test yguide(plot(args...; kwargs..., unitformat = ", dear ")) == "hello, dear s"
        @test yguide(plot(args...; kwargs..., unitformat = (", dear ", " esq."))) ==
            "hello, dear s esq."
        @test yguide(
            plot(args...; kwargs..., unitformat = ("well ", ", dear ", " esq.")),
        ) == "well hello, dear s esq."
        @test yguide(plot(args...; kwargs..., unitformat = '?')) == "hello ? s"
        @test yguide(plot(args...; kwargs..., unitformat = ('<', '>'))) == "hello <s>"
        @test yguide(plot(args...; kwargs..., unitformat = ('A', 'B', 'C'))) == "Ahello BsC"
        @test yguide(plot(args...; kwargs..., unitformat = false)) == "hello s"
        @test yguide(plot(args...; kwargs..., unitformat = true)) == "hello (s)"
        @test yguide(plot(args...; kwargs..., unitformat = :round)) == "hello (s)"
        @test yguide(plot(args...; kwargs..., unitformat = :square)) == "hello [s]"
        @test yguide(plot(args...; kwargs..., unitformat = :curly)) == "hello {s}"
        @test yguide(plot(args...; kwargs..., unitformat = :angle)) == "hello <s>"
        @test yguide(plot(args...; kwargs..., unitformat = :slash)) == "hello / s"
        @test yguide(plot(args...; kwargs..., unitformat = :slashround)) == "hello / (s)"
        @test yguide(plot(args...; kwargs..., unitformat = :slashsquare)) == "hello / [s]"
        @test yguide(plot(args...; kwargs..., unitformat = :slashcurly)) == "hello / {s}"
        @test yguide(plot(args...; kwargs..., unitformat = :slashangle)) == "hello / <s>"
        @test yguide(plot(args...; kwargs..., unitformat = :verbose)) ==
            "hello in units of s"
        @test yguide(plot(args...; kwargs..., unitformat = :nounit)) == "hello"
    end
end

@testset "With functions" begin
    x, y = randn(3), randn(3)
    @testset "plot(f, x) / plot(x, f)" begin
        f(x) = x^2
        @test plot(f, x * m) isa Plots.Plot
        @test plot(x * m, f) isa Plots.Plot
        g(x) = x * m # If the unit comes from the function only then it throws
        @test_throws DimensionError plot(x, g)
        @test_throws DimensionError plot(g, x)
    end
    @testset "plot(x, y, f)" begin
        f(x, y) = x * y
        @test plot(x * m, y * s, f) isa Plots.Plot
        @test plot(x * m, y, f) isa Plots.Plot
        @test plot(x, y * s, f) isa Plots.Plot
        g(x, y) = x * y * m # If the unit comes from the function only then it throws
        @test_throws DimensionError plot(x, y, g)
    end
    @testset "plot(f, u)" begin
        f(x) = x^2
        pl = plot(x * m, f.(x * m))
        @test plot!(pl, f, m) isa Plots.Plot
        @test_throws DimensionError plot!(pl, f, s)
        pl = plot(f, m)
        @test xguide(pl) == string(m)
        @test yguide(pl) == string(m^2)
        g(x) = exp(x / (3m))
        @test plot(g, u"m") isa Plots.Plot
    end
end

@testset "More plots" begin
    @testset "data as $dtype" for dtype in
        [:Vectors, :Matrices, Symbol("Vectors of vectors")]
        if dtype == :Vectors
            x, y, z = randn(10), randn(10), randn(10)
        elseif dtype == :Matrices
            x, y, z = randn(10, 2), randn(10, 2), randn(10, 2)
        else
            x, y, z = [rand(10), rand(20)], [rand(10), rand(20)], [rand(10), rand(20)]
        end

        @testset "One array" begin
            @test plot(x * m) isa Plots.Plot
            @test plot(x * m, ylabel = "x") isa Plots.Plot
            @test plot(x * m, ylims = (-1, 1)) isa Plots.Plot
            @test plot(x * m, ylims = (-1, 1) .* m) isa Plots.Plot
            @test plot(x * m, yunit = u"km") isa Plots.Plot
            @test plot(x * m, xticks = (1:3) * m) isa Plots.Plot
        end

        @testset "Two arrays" begin
            @test plot(x * m, y * s) isa Plots.Plot
            @test plot(x * m, y * s, xlabel = "x") isa Plots.Plot
            @test plot(x * m, y * s, xlims = (-1, 1)) isa Plots.Plot
            @test plot(x * m, y * s, xlims = (-1, 1) .* m) isa Plots.Plot
            @test plot(x * m, y * s, xunit = u"km") isa Plots.Plot
            @test plot(x * m, y * s, ylabel = "y") isa Plots.Plot
            @test plot(x * m, y * s, ylims = (-1, 1)) isa Plots.Plot
            @test plot(x * m, y * s, ylims = (-1, 1) .* s) isa Plots.Plot
            @test plot(x * m, y * s, yunit = u"ks") isa Plots.Plot
            @test plot(x * m, y * s, yticks = (1:3) * s) isa Plots.Plot
            @test scatter(x * m, y * s) isa Plots.Plot
            if dtype ≠ Symbol("Vectors of vectors")
                @test scatter(x * m, y * s, zcolor = z * (m / s)) isa Plots.Plot
            end
        end

        @testset "Three arrays" begin
            @test plot(x * m, y * s, z * (m / s)) isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), xlabel = "x") isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), xlims = (-1, 1)) isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), xlims = (-1, 1) .* m) isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), xunit = u"km") isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), ylabel = "y") isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), ylims = (-1, 1)) isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), ylims = (-1, 1) .* s) isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), yunit = u"ks") isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), zlabel = "z") isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), zlims = (-1, 1)) isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), zlims = (-1, 1) .* (m / s)) isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), zunit = u"km/hr") isa Plots.Plot
            @test plot(x * m, y * s, z * (m / s), zticks = (1:2) * m / s) isa Plots.Plot
            @test scatter(x * m, y * s, z * (m / s)) isa Plots.Plot
        end

        @testset "Unitful/unitless combinations" begin
            mystr(x::Array{<:Quantity}) = "Q"
            mystr(x::Array) = "A"
            @testset "plot($(mystr(xs)), $(mystr(ys)))" for xs in [x, x * m],
                    ys in [y, y * s]

                @test plot(xs, ys) isa Plots.Plot
            end
            @testset "plot($(mystr(xs)), $(mystr(ys)), $(mystr(zs)))" for xs in [x, x * m],
                    ys in [y, y * s],
                    zs in [z, z * (m / s)]

                @test plot(xs, ys, zs) isa Plots.Plot
            end
        end
    end

    @testset "scatter(x::$(us[1]), y::$(us[2]))" for us in collect(
            Iterators.product(fill([1, u"m", u"s"], 2)...),
        )
        x, y = rand(10) * us[1], rand(10) * us[2]
        @test scatter(x, y) isa Plots.Plot
        @test scatter(x, y, markersize = x) isa Plots.Plot

        @test scatter(x, y, marker_z = x) isa Plots.Plot
        if us[1] != us[2] && us[1] != 1 && us[2] != 1 # Non-matching dimensions
            @test_throws DimensionError scatter!(x, y, marker_z = y)
        else # One is dimensionless, or have same dimensions
            @test scatter!(x, y, marker_z = y) isa Plots.Plot #
        end
    end

    @testset "contour(x::$(us[1]), y::$(us[2]))" for us in collect(
            Iterators.product(fill([1, u"m", u"s"], 2)...),
        )
        x, y = (1:0.01:2) * us[1], (1:0.02:2) * us[2]
        z = x' ./ y
        @test contour(x, y, z) isa Plots.Plot
        @test contourf(x, y, z) isa Plots.Plot
    end

    @testset "ProtectedString" begin
        y = rand(10) * u"m"
        @test plot(y, label = P"meters") isa Plots.Plot
    end

    @testset "latexify as unitformat" begin
        y = rand(10) * u"m^-1"
        @test yguide(plot(y, ylabel = "hello", unitformat = latexify)) == "\$hello\\;\\left/\\;\\mathrm{m}^{-1}\\right.\$"

        uf = (l, u) -> l * " (" * latexify(u) * ")"
        @test yguide(plot(y, ylabel = "hello", unitformat = uf)) == "hello (\$\\mathrm{m}^{-1}\$)"
    end

    @testset "colorbar title" begin

        x, y = (1:0.01:2) * m, (1:0.02:2) * s
        z = x' ./ y
        pl = contour(x, y, z)
        @test ctitle(pl) ∈ ["m s^-1", "m s⁻¹"]
        pl = contourf(x, y, z, zunit = u"km/hr")
        @test ctitle(pl) ∈ ["km hr^-1", "km hr⁻¹"]
        pl = heatmap(x, y, z, zunit = u"cm/s", zunitformat = :square, colorbar_title = "v")
        @test ctitle(pl) ∈ ["v [cm s^-1]", "v [cm s⁻¹]"]
    end

    @testset "twinx (#4750)" begin
        y = rand(10) * u"m"
        pl = plot(y; xlabel = "check", ylabel = "hello")
        pl2 = twinx(pl)
        plot!(pl2, 1 ./ y; ylabel = "goodbye", yunit = u"cm^-1")
        @test pl isa Plots.Plot
        @test pl2 isa Plots.Subplot
        @test yguide(pl, 1) == "hello (m)"
        # on MacOS the superscript gets rendered with Unicode, on Ubuntu and Windows no
        @test yguide(pl, 2) ∈ ["goodbye (cm^-1)", "goodbye (cm⁻¹)"]
        @test xguide(pl, 1) == "check"
        @test xguide(pl, 2) == ""
    end

    @testset "bad link" begin
        pl1 = plot(rand(10) * u"m")
        pl2 = plot(rand(10) * u"s")
        # TODO: On Julia 1.8 and above, can replace ErrorException with part of error message.
        @test_throws ErrorException plot(pl1, pl2; link = :y)
    end

end

@testset "Comparing apples and oranges" begin
    x1 = rand(10) * u"m"
    x2 = rand(10) * u"cm"
    x3 = rand(10) * u"s"
    pl = plot(x1)
    pl = plot!(pl, x2)
    @test yguide(pl) == "m"
    @test yseries(pl) ≈ ustrip.(x2) / 100
    @test_throws DimensionError plot!(pl, x3) # can't place seconds on top of meters!
end

@testset "Bare units" begin
    pl = plot(u"m", u"s")
    @test xguide(pl) == "m"
    @test yguide(pl) == "s"
    @test iszero(length(pl.series_list[1].plotattributes[:y]))
    hline!(pl, [1u"hr"])
    @test yguide(pl) == "s"
end

@testset "Inset subplots" begin
    x1 = rand(10) * u"m"
    x2 = rand(10) * u"s"
    pl = plot(x1)
    pl = plot!(x2, inset = bbox(0.5, 0.5, 0.3, 0.3), subplot = 2)
    @test yguide(pl, 1) == "m"
    @test yguide(pl, 2) == "s"
end

@testset "Missing values" begin
    x = 1:5
    y = [1.0 * u"s", 2.0 * u"s", missing, missing, missing]
    pl = plot(x, y)
    @test yguide(pl, 1) == "s"
end

@testset "Errors" begin
    x = rand(10) * u"mm"
    ex = rand(10) * u"μm"
    y = rand(10) * u"s"
    ey = rand(10) * u"ms"
    pl = plot(x, y, xerr = ex, yerr = ey)
    @test pl isa Plots.Plot
    @test xguide(pl) == "mm"
    @test yguide(pl) == "s"
    pl = plot(x, y, xerr = ex, yerr = (ey, ey ./ 2))
    @test pl isa Plots.Plot
    @test xguide(pl) == "mm"
    @test yguide(pl) == "s"
end

@testset "Ribbon" begin
    x = (1:10) * u"mm"
    y = rand(10) * u"s"
    ribbon = rand(10) * u"ms"
    ribbon = 100 * rand(10) * u"ms"
    pl = plot(x, y, ribbon = ribbon)
    @test pl isa Plots.Plot
    @test xguide(pl) == "mm"
    @test yguide(pl) == "s"
    pl = plot(x, y, ribbon = (ribbon, ribbon .* 2))
    @test pl isa Plots.Plot
    @test xguide(pl) == "mm"
    @test yguide(pl) == "s"
end

@testset "Fillrange" begin
    x = (1:10) * u"mm"
    y = rand(10) * u"s"
    fillrange = rand(10) * u"ms"
    pl = plot(x, y, fillrange = fillrange)
    @test pl isa Plots.Plot
    @test xguide(pl) == "mm"
    @test yguide(pl) == "s"
end

@testset "Aspect ratio" begin
    pl = plot((1:10)u"m", (1:10)u"dm"; aspect_ratio = :equal)
    savefig(pl, testfile) # Force a render, to make it evaluate aspect ratio
    @test abs(-(ylims(pl)...)) > 50
    plot!(pl, (3:4)u"m", (4:5)u"m")
    @test first(pl.subplots)[:aspect_ratio] == 1 // 10 # This is what "equal" means when yunit==xunit/10
    pl = plot((1:10)u"m", (1:10)u"dm"; aspect_ratio = 2)
    savefig(pl, testfile)
    @test 25 < abs(-(ylims(pl)...)) < 50
    pl = plot((1:10)u"m", (1:10)u"s"; aspect_ratio = 1u"m/s")
    savefig(pl, testfile)
    @test 7.5 < abs(-(ylims(pl)...)) < 12.5
    @test_throws DimensionError savefig(
        plot((1:10)u"m", (1:10)u"s"; aspect_ratio = :equal),
        testfile,
    )
end

# https://github.com/jw3126/UnitfulRecipes.jl/issues/60
@testset "Start with empty plot" begin
    pl = plot()
    plot!(pl, (1:3)m)
    @test yguide(pl) == "m"
end

# https://github.com/jw3126/UnitfulRecipes.jl/issues/79
@testset "Annotate" begin
    pl = plot([0, 1]u"s", [0, 1]u"m")
    annotate!(pl, [0.25]u"s", [0.5]u"m", text("annotation"))
    savefig(pl, testfile)
    @test length(pl.subplots[1].attr[:annotations]) == 1
end

@testset "AbstractProtectedString" begin
    str = P"mass"
    @test pointer(str) isa Ptr
    @test pointer(str, 1) isa Ptr
    @test isvalid(str, 1)
    @test ncodeunits(str) == 4
    @test codeunit(str) == UInt8
end

@testset "Logunits plots" begin
    u = (1:3)u"B"
    v = (1:3)u"dB"
    x = (1:3)u"dBV"
    y = (1:3)u"V"
    pl = plot(u, x)
    @test pl isa Plots.Plot
    @test xguide(pl) == "B"
    @test yguide(pl) == "dBV"
    @test plot!(pl, v, y) isa Plots.Plot
    pl = plot(v, y)
    @test pl isa Plots.Plot
    @test plot!(pl, u, x) isa Plots.Plot
end

if Sys.islinux() && Sys.which("pdflatex") ≢ nothing
    @testset "pgfplotsx exponents" begin  # github.com/JuliaPlots/Plots.jl/issues/4722
        Plots.with(:pgfplotsx) do
            pl = plot([1u"s", 2u"s"], [1u"m/s^2", 2u"m/s^2"])
            savefig(pl, tempname() * ".pdf")

            x, y = rand(10) * u"km", rand(10) * u"hr"
            pl = plot(x, y, x ./ y)
            savefig(pl, tempname() * ".pdf")
        end
    end
end

using Plots, Dates, Test
struct Foo{T}
    x::Vector{T}
    y::Vector{T}
end

@recipe function f(foo::Foo)
    xlabel --> "x"
    ylabel --> "y"
    seriestype --> :path
    marker --> :auto
    return foo.x, foo.y
end

x = collect(0.0:10.0)
foo = Foo(x, sin.(x))

@testset "Magic attributes" begin
    @test plot(foo)[1][1][:markershape] === :+
    @test plot(foo, markershape = :diamond)[1][1][:markershape] === :diamond
    @test plot(foo, marker = :diamond)[1][1][:markershape] === :diamond
    @test (
        @test_logs (:warn, "Skipped marker arg diamond.") plot(
            foo,
            marker = :diamond,
            markershape = :diamond,
        )[1][1][:markershape]
    ) === :diamond
end

@testset "Subplot Attributes" begin
    let pl = plot(rand(4, 4), layout = 2)
        @test pl[1].primary_series_count == 2
    end
end

@testset "Series Attributes" begin
    pl = plot([[1, 2, 3], [2, 3, 4]], lw = 5)
    @test hline!(deepcopy(pl), [1.75])[1].series_list[3][:label] ==
        hline!(deepcopy(pl), [1.75], z_order = :front)[1].series_list[3][:label] ==
        "y3"
    @test hline!(deepcopy(pl), [1.75], z_order = :back)[1].series_list[1][:label] == "y3"
    @test hline!(deepcopy(pl), [1.75], z_order = 2)[1].series_list[2][:label] == "y3"
    sp = pl[1]
    @test isempty(sp[1][:extra_kwargs])
    @test sp[2][:series_index] == 2
    @test sp[1][:seriescolor] == cgrad(default(:palette))[1]
    @test sp[2][:seriescolor] == cgrad(default(:palette))[2]
end

@testset "Axis Attributes" begin
    pl = @test_nowarn plot(; tickfont = font(10, "Times"))
    for axis in (:xaxis, :yaxis, :zaxis)
        @test pl[1][axis][:tickfontsize] == 10
        @test pl[1][axis][:tickfontfamily] == "Times"
    end
end

@testset "Permute recipes" begin
    pl1 = bar(["a", "b", "c"], [1, 2, 3])
    pl2 = bar(["a", "b", "c"], [1, 2, 3], permute = (:x, :y))
    @test xticks(pl2) == yticks(pl1)
    @test yticks(pl2) == xticks(pl1)
    @test filter(isfinite, pl1[1][1][:x]) == filter(isfinite, pl2[1][1][:y])
    @test filter(isfinite, pl1[1][1][:y]) == filter(isfinite, pl2[1][1][:x])
end

@testset "@add_attributes" begin
    Font = Plots.Font
    Plots.@add_attributes subplot struct Legend
        background_color = :match
        foreground_color = :match
        position = :best
        title = nothing
        font::Font = font(8)
        title_font::Font = font(11)
        column = 1
    end :match = (
        :legend_font_family,
        :legend_font_color,
        :legend_title_font_family,
        :legend_title_font_color,
    )
    @test true
end

@testset "aspect_ratio" begin
    fn = tempname()
    for aspect_ratio in (1, 1.0, 1 // 10, :auto, :none, true)
        @test_nowarn png(plot(1:2; aspect_ratio), fn)
    end
    @test_throws ArgumentError png(plot(1:2; aspect_ratio = :invalid_ar), fn)
end

@testset "aliases" begin
    @test :legend in aliases(:legend_position)
    Plots.add_non_underscore_aliases!(Plots._typeAliases)
    Plots.add_axes_aliases(:ticks, :tick)
end

@userplot MatrixHeatmap

@recipe function f(A::MatrixHeatmap)
    mat = A.args[1]
    margin --> (0, :mm)
    seriestype := :heatmap
    x := axes(mat, 2)
    y := axes(mat, 1)
    z := Surface(mat)
    ()
end

@testset "margin" begin
    # github.com/JuliaPlots/Plots.jl/issues/4522
    @test show(devnull, matrixheatmap(reshape(1:12, 3, 4))) isa Nothing
end

@testset "Formatters" begin
    ts = range(DateTime(today()), step = Hour(1), length = 24)
    p1 = plot(ts, 100randn(24))
    vline!(p1, [now()])
    @test p1[1][:yaxis][:formatter] == :auto
    @test p1[1][:xaxis][:formatter] == Plots.datetimeformatter
    p2 = plot(rand(4) .* 10^6, rand(4) .* 10^6, xformatter = :plain, yformatter = :plain)
    vline!(p2, [10^6])
    @test p2[1][:yaxis][:formatter] == :plain
    @test p2[1][:xaxis][:formatter] == :plain
    p3 = plot(rand(4) .* 10^6, rand(4) .* 10^6, yformatter = :plain)
    vline!(p3, [10^6], xformatter = :plain)
    @test p3[1][:yaxis][:formatter] == :plain
    @test p3[1][:xaxis][:formatter] == :plain
end

@testset "Set Lims" begin
    pl = plot(rand(10))

    xlims!((1, 20))
    @test xlims(pl) == (1, 20)
    xlims!(pl, (1, 21))
    @test xlims(pl) == (1, 21)
    ylims!((-1, 1))
    @test ylims(pl) == (-1, 1)
    ylims!(pl, (-2, 2))
    @test ylims(pl) == (-2, 2)
    zlims!((-1, 1))
    @test zlims(pl) == (-1, 1)
    zlims!(pl, (-2, 2))
    @test zlims(pl) == (-2, 2)
    xlims!(-1, 11)
    @test xlims(pl) == (-1, 11)
    xlims!(pl, -2, 12)
    @test xlims(pl) == (-2, 12)
    ylims!((-10, 10))
    @test ylims(pl) == (-10, 10)
    ylims!(pl, (-11, 9))
    @test ylims(pl) == (-11, 9)
    zlims!((-10, 10))
    @test zlims(pl) == (-10, 10)
    zlims!(pl, (-9, 8))
    @test zlims(pl) == (-9, 8)
end

@testset "Set Title / Labels" begin
    pl = plot()
    title!(pl, "Foo")
    sp = pl[1]
    @test sp[:title] == "Foo"
    xlabel!(pl, "xlabel")
    @test Plots.get_guide(sp[:xaxis]) == "xlabel"
    ylabel!(pl, "ylabel")
    @test Plots.get_guide(sp[:yaxis]) == "ylabel"
    zlabel!(pl, "zlabel")
    @test Plots.get_guide(sp[:zaxis]) == "zlabel"
end

@testset "Misc" begin
    pl = plot()
    sp = pl[1]

    xflip!(pl)
    @test sp[:xaxis][:flip]
    xflip!(false)
    @test !sp[:xaxis][:flip]
    yflip!(pl)
    @test sp[:yaxis][:flip]
    yflip!(false)
    @test !sp[:yaxis][:flip]
    xgrid!(pl, true)
    @test sp[:xaxis][:grid]
    xgrid!(pl, false)
    @test !sp[:xaxis][:grid]
    xgrid!(true)
    @test sp[:xaxis][:grid]
    ygrid!(pl, true)
    @test sp[:yaxis][:grid]
    ygrid!(pl, false)
    @test !sp[:yaxis][:grid]
    ygrid!(true)
    @test sp[:yaxis][:grid]

    # multiple annotations
    ann = [(7, 3, "(7,3)"), (3, 7, text("hey", 14, :left, :top, :green))]
    annotate!(pl, ann)
    show(devnull, pl)
    annotate!(pl, ann...)
    show(devnull, pl)
    annotate!(ann...)
    show(devnull, pl)

    # single annotation
    ann = (3, 7, text("hey", 14, :left, :top, :green))
    annotate!(pl, ann)
    show(devnull, pl)
    annotate!(pl, ann...)
    show(devnull, pl)
    annotate!(ann...)

    xaxis!(pl, true)
    @test sp[:xaxis][:showaxis]
    xaxis!(pl, false)
    @test !sp[:xaxis][:showaxis]
    xaxis!(true)
    @test sp[:xaxis][:showaxis]
    yaxis!(pl, true)
    @test sp[:yaxis][:showaxis]
    yaxis!(pl, false)
    @test !sp[:yaxis][:showaxis]
    yaxis!(true)
    @test sp[:yaxis][:showaxis]

    pl = plot3d([1, 2], [1, 2], [1, 2])
    plot3d!(pl, [3, 4], [3, 4], [3, 4])
    @test Plots.series_list(pl[1])[1][:seriestype] === :path3d
end

@testset "Set Ticks" begin
    pl = plot([0, 2, 3, 4, 5, 6, 7, 8, 9, 10])
    sp = pl[1]

    xticks = 2:6
    xticks!(xticks)
    @test sp.attr[:xaxis][:ticks] == xticks

    xticks = 1:5
    xticks!(pl, xticks)
    @test sp.attr[:xaxis][:ticks] == xticks

    yticks = 0.2:0.1:0.7
    yticks!(yticks)
    @test sp.attr[:yaxis][:ticks] == yticks

    yticks = 0.1:0.5
    yticks!(pl, yticks)
    @test sp.attr[:yaxis][:ticks] == yticks

    xticks = [5, 6, 7.5]
    xlabels = ["a", "b", "c"]
    xticks!(xticks, xlabels)
    @test sp.attr[:xaxis][:ticks] == (xticks, xlabels)

    xticks = [5, 2]
    xlabels = ["b", "a"]
    xticks!(pl, xticks, xlabels)
    @test sp.attr[:xaxis][:ticks] == (xticks, xlabels)

    yticks = [0.5, 0.6, 0.75]
    ylabels = ["z", "y", "x"]
    yticks!(yticks, ylabels)
    @test sp.attr[:yaxis][:ticks] == (yticks, ylabels)

    yticks = [0.5, 0.1]
    ylabels = ["z", "y"]
    yticks!(pl, yticks, ylabels)
    @test sp.attr[:yaxis][:ticks] == (yticks, ylabels)
end

# NOTE:  backend should implement `html_body` and `html_head`

# CREDIT: parts of this implementation were inspired by @joshday's PlotlyLocal.jl

standalone_html(
    plt::AbstractPlot;
    title::AbstractString = get(plt.attr, :window_title, "Plots.jl"),
) = """
<!DOCTYPE html>
<html>
    <head>
        <title>$title</title>
        <meta http-equiv="content-type" content="text/html; charset=UTF-8">
        $(html_head(plt))
    </head>
    <body>
        $(html_body(plt))
    </body>
</html>
"""

embeddable_html(plt::AbstractPlot) = html_head(plt) * html_body(plt)

function open_browser_window(filename::AbstractString)
    @static if Sys.isapple()
        return run(`open $(filename)`)
    elseif Sys.islinux() || Sys.isbsd()    # Sys.isbsd() addition is as yet untested, but based on suggestion in https://github.com/JuliaPlots/Plots.jl/issues/681
        return run(`xdg-open $(filename)`)
    elseif Sys.iswindows()
        return run(`$(ENV["COMSPEC"]) /c start "" "$(filename)"`)
    else
        @warn "Unknown OS... cannot open browser window."
    end
end

function write_temp_html(plt::AbstractPlot)
    html = standalone_html(plt; title = plt.attr[:window_title])
    filename = string(tempname(), ".html")
    write(filename, html)
    return filename
end

function standalone_html_window(plt::AbstractPlot)
    old = _use_local_dependencies[] # save state to restore afterwards
    # if we open a browser ourself, we can host local files, so
    # when we have a local plotly downloaded this is the way to go!
    _use_local_dependencies[] =
        _plotly_local_file_path[] === nothing ? false : isfile(_plotly_local_file_path[])
    filename = write_temp_html(plt)
    open_browser_window(filename)
    # restore for other backends
    return _use_local_dependencies[] = old
end

# uses wkhtmltopdf/wkhtmltoimage: http://wkhtmltopdf.org/downloads.html
html_to_png(html_fn, png_fn, w, h) = run(
    `wkhtmltoimage -f png -q --width $w --height $h --disable-smart-width $html_fn $png_fn`,
)

function show_png_from_html(io::IO, plt::AbstractPlot)
    # write html to a temporary file
    html_fn = write_temp_html(plt)

    # convert that html file to a temporary png file using wkhtmltoimage
    png_fn = tempname() * ".png"
    w, h = plt.attr[:size]
    html_to_png(html_fn, png_fn, w, h)

    # now read that file data into io
    pngdata = readall(png_fn)
    return write(io, pngdata)
end

using Test, Plots, Unitful, LaTeXStrings

function create_plot(args...; kwargs...)
    pl = plot(args...; kwargs...)
    return pl, repr("application/x-tex", pl)
end

function create_plot!(args...; kwargs...)
    pl = plot!(args...; kwargs...)
    return pl, repr("application/x-tex", pl)
end

function get_pgf_axes(pl)
    Plots._update_plot_object(pl)
    return Plots.pgfx_axes(pl.o)
end

Plots.with(:pgfplotsx) do
    pl = plot(1:5)
    axis = first(get_pgf_axes(pl))
    @test pl.o.the_plot isa PGFPlotsX.TikzDocument
    @test pl.series_list[1].plotattributes[:quiver] === nothing
    @test count(x -> x isa PGFPlotsX.Plot, axis.contents) == 1
    @test !haskey(axis.contents[1].options.dict, "fill")
    @test occursin("documentclass", Plots.pgfx_preamble(pl))
    @test occursin("documentclass", Plots.pgfx_preamble())

    @testset "Legends" begin
        pl = plot(rand(5, 2), lab = ["1" ""], arrow = true)
        scatter!(pl, rand(5))
        axis_contents = first(get_pgf_axes(pl)).contents
        leg_entries = filter(x -> x isa PGFPlotsX.LegendEntry, axis_contents)
        series = filter(x -> x isa PGFPlotsX.Plot, axis_contents)
        @test length(leg_entries) == 2
        @test length(series) == 5
        @test !haskey(series[1].options.dict, "forget plot")
        @test haskey(series[2].options.dict, "forget plot")
        @test haskey(series[3].options.dict, "forget plot")
        @test haskey(series[4].options.dict, "forget plot")
        @test !haskey(series[5].options.dict, "forget plot")
    end

    @testset "3D docs example" begin
        n = 100
        ts = range(0, stop = 8π, length = n)
        x = ts .* map(cos, ts)
        y = (0.1ts) .* map(sin, ts)
        z = 1:n
        pl = plot(
            x,
            y,
            z,
            zcolor = reverse(z),
            m = (10, 0.8, :blues, Plots.stroke(0)),
            leg = false,
            cbar = true,
            w = 5,
        )
        pl = plot!(pl, zeros(n), zeros(n), 1:n, w = 10)
        axis = first(get_pgf_axes(pl))
        if @test_nowarn(haskey(axis.options.dict, "colorbar"))
            @test axis["colorbar"] === nothing
        end
    end

    @testset "Color docs example" begin
        y = rand(100)
        plot(
            0:10:100,
            rand(11, 4),
            lab = "lines",
            w = 3,
            palette = :grays,
            fill = 0,
            α = 0.6,
        )
        pl = scatter!(
            y,
            zcolor = abs.(y .- 0.5),
            m = (:hot, 0.8, Plots.stroke(1, :green)),
            ms = 10 * abs.(y .- 0.5) .+ 4,
            lab = ["grad", "", "ient"],
        )
        axis = first(get_pgf_axes(pl))
        @test count(x -> x isa PGFPlotsX.LegendEntry, axis.contents) == 6
        @test count(x -> x isa PGFPlotsX.Plot, axis.contents) == 108 # each marker is its own plot, fillranges create 2 plot-objects
        marker = axis.contents[15]
        @test marker isa PGFPlotsX.Plot
        @test marker.options["mark"] == "*"
        @test marker.options["mark options"]["color"] == RGBA{Float64}(colorant"green", 0.8)
        @test marker.options["mark options"]["line width"] == 0.75 # 1px is 0.75pt
    end

    @testset "Plot in pieces" begin
        pl = plot(rand(100) / 3, reg = true, fill = (0, :green))
        scatter!(pl, rand(100), markersize = 6, c = :orange)
        axis_contents = first(get_pgf_axes(pl)).contents
        leg_entries = filter(x -> x isa PGFPlotsX.LegendEntry, axis_contents)
        series = filter(x -> x isa PGFPlotsX.Plot, axis_contents)
        @test length(leg_entries) == 2
        @test length(series) == 4
        @test haskey(series[1].options.dict, "forget plot")
        @test !haskey(series[2].options.dict, "forget plot")
        @test haskey(series[3].options.dict, "forget plot")
        @test !haskey(series[4].options.dict, "forget plot")
    end

    @testset "Marker types" begin
        markers = filter(
            (
                m -> begin
                    m in Plots.supported_markers()
                end
            ), Plots._shape_keys
        )
        markers = reshape(markers, 1, length(markers))
        n = length(markers)
        x = (range(0, stop = 10, length = n + 2))[2:(end - 1)]
        y = repeat(reshape(reverse(x), 1, :), n, 1)
        @test scatter(
            x,
            y,
            m = (8, :auto),
            lab = map(string, markers),
            bg = :linen,
            xlim = (0, 10),
            ylim = (0, 10),
        ) isa Plots.Plot
    end

    @testset "Layout" begin
        @test plot(
            Plots.fakedata(100, 10),
            layout = 4,
            palette = [:grays :blues :hot :rainbow],
            bg_inside = [:orange :pink :darkblue :black],
        ) isa Plots.Plot
    end

    @testset "Polar plots" begin
        Θ = range(0, stop = 1.5π, length = 100)
        r = abs.(0.1 * randn(100) + sin.(3Θ))
        @test plot(Θ, r, proj = :polar, m = 2) isa Plots.Plot
    end

    @testset "Drawing shapes" begin
        verts = [
            (-1.0, 1.0),
            (-1.28, 0.6),
            (-0.2, -1.4),
            (0.2, -1.4),
            (1.28, 0.6),
            (1.0, 1.0),
            (-1.0, 1.0),
            (-0.2, -0.6),
            (0.0, -0.2),
            (-0.4, 0.6),
            (1.28, 0.6),
            (0.2, -1.4),
            (-0.2, -1.4),
            (0.6, 0.2),
            (-0.2, 0.2),
            (0.0, -0.2),
            (0.2, 0.2),
            (-0.2, -0.6),
        ]
        x = 0.1:0.2:0.9
        y = 0.7 * rand(5) .+ 0.15
        @test plot(
            x,
            y,
            line = (3, :dash, :lightblue),
            marker = (Shape(verts), 30, RGBA(0, 0, 0, 0.2)),
            bg = :pink,
            fg = :darkblue,
            xlim = (0, 1),
            ylim = (0, 1),
            leg = false,
        ) isa Plots.Plot
    end

    @testset "Histogram 2D" begin
        @test histogram2d(randn(10_000), randn(10_000), nbins = 20) isa Plots.Plot
    end

    @testset "Heatmap-like" begin
        xs = [string("x", i) for i in 1:10]
        ys = [string("y", i) for i in 1:4]
        z = float((1:4) * reshape(1:10, 1, :))
        pl = heatmap(xs, ys, z, aspect_ratio = 1)
        axis = first(get_pgf_axes(pl))
        if @test_nowarn(haskey(axis.options.dict, "colorbar"))
            @test axis["colorbar"] === nothing
            @test axis["colormap name"] == "plots1"
        end

        @test wireframe(xs, ys, z, aspect_ratio = 1) isa Plots.Plot
        # TODO: clims are wrong
    end

    @testset "Contours" begin
        x = 1:0.5:20
        y = 1:0.5:10
        f(x, y) = (3x + y^2) * abs(sin(x) + cos(y))
        X = repeat(reshape(x, 1, :), length(y), 1)
        Y = repeat(y, 1, length(x))
        Z = map(f, X, Y)
        p2 = contour(x, y, Z)
        p1 = contour(x, y, f, fill = true)
        p3 = contour3d(x, y, Z)
        @test plot(p1, p2) isa Plots.Plot
        @test_nowarn Plots._update_plot_object(p3)
        # TODO: colorbar for filled contours
    end

    @testset "Varying colors" begin
        t = range(0, stop = 1, length = 100)
        θ = (6π) .* t
        x = t .* cos.(θ)
        y = t .* sin.(θ)
        p1 = plot(x, y, line_z = t, linewidth = 3, legend = false)
        p2 = scatter(x, y, marker_z = (x, y) -> x + y, color = :bwr, legend = false)
        @test plot(p1, p2) isa Plots.Plot
    end

    @testset "Framestyles" begin
        # TODO: support :semi
        pl = scatter(
            fill(randn(10), 6),
            fill(randn(10), 6),
            framestyle = [:box :semi :origin :zerolines :grid :none],
            title = [":box" ":semi" ":origin" ":zerolines" ":grid" ":none"],
            color = permutedims(1:6),
            layout = 6,
            label = "",
            markerstrokewidth = 0,
            ticks = -2:2,
        )
        for (i, axis) in enumerate(get_pgf_axes(pl))
            opts = axis.options
            # just check by indexing (not defined -> throws)
            opts["x axis line style"]
            opts["y axis line style"]
            if i == 3
                opts["axis x line*"]
                opts["axis y line*"]
            end
            @test true
        end
    end

    @testset "Quiver" begin
        x = (-2pi):0.2:(2 * pi)
        y = sin.(x)

        u = ones(length(x))
        v = cos.(x)
        pl = plot(x, y, quiver = (u, v), arrow = true)
        @test pl isa Plots.Plot
        # TODO: could adjust limits to fit arrows if too long, but how ?
        # mktempdir() do path
        #    @test_nowarn savefig(pl, path*"arrow.pdf")
        # end
    end

    @testset "Annotations" begin
        y = rand(10)
        ann = (3, y[3], Plots.text("this is \\#3", :left))
        pl = plot(y, annotations = ann, leg = false)
        axis_content = first(get_pgf_axes(pl)).contents
        nodes = filter(x -> !isa(x, PGFPlotsX.Plot), axis_content)
        @test length(nodes) == 1
        mktempdir() do path
            file_path = joinpath(path, "annotations.tex")
            @test_nowarn savefig(pl, file_path)
            open(file_path) do io
                lines = readlines(io)
                @test count(s -> occursin("node", s), lines) == 1
            end
        end
        annotate!(
            [
                (5, y[5], Plots.text("this is \\#5", 16, :red, :center)),
                (10, y[10], Plots.text("this is \\#10", :right, 20, "courier")),
            ]
        )
        axis_content = first(get_pgf_axes(pl)).contents
        nodes = filter(x -> !isa(x, PGFPlotsX.Plot), axis_content)
        @test length(nodes) == 3
        mktempdir() do path
            file_path = joinpath(path, "annotations.tex")
            @test_nowarn savefig(pl, file_path)
            open(file_path) do io
                lines = readlines(io)
                @test count(s -> occursin("node", s), lines) == 3
            end
        end
        pl = scatter!(
            range(2, stop = 8, length = 6),
            rand(6),
            marker = (50, 0.2, :orange),
            series_annotations = [
                "series",
                "annotations",
                "map",
                "to",
                "series",
                Plots.text("data", :green),
            ],
        )
        axis_content = first(get_pgf_axes(pl)).contents
        nodes = filter(x -> !isa(x, PGFPlotsX.Plot), axis_content)
        @test length(nodes) == 9
        mktempdir() do path
            file_path = joinpath(path, "annotations.tex")
            @test_nowarn savefig(pl, file_path)
            open(file_path) do io
                lines = readlines(io)
                @test count(s -> occursin("node", s), lines) == 9
            end
            # test .tikz extension
            file_path = joinpath(path, "annotations.tikz")
            @test_nowarn savefig(pl, file_path)
            @test_nowarn open(file_path) do io
            end
        end
    end

    @testset "Ribbon" begin
        aa = rand(10)
        bb = rand(10)
        cc = rand(10)
        conf = [aa - cc bb - cc]
        pl = plot(collect(1:10), fill(1, 10), ribbon = (conf[:, 1], conf[:, 2]))
        axis_contents = first(get_pgf_axes(pl)).contents
        plots = filter(x -> x isa PGFPlotsX.Plot, axis_contents)
        @test length(plots) == 3
        @test haskey(plots[1].options.dict, "fill")
        @test haskey(plots[2].options.dict, "fill")
        @test !haskey(plots[3].options.dict, "fill")
        @test pl.o !== nothing
        @test pl.o.the_plot !== nothing
    end

    @testset "Markers and Paths" begin
        pl = plot(
            5 .- ones(9),
            markershape = [:utriangle, :rect],
            markersize = 8,
            color = [:red, :black],
        )
        axis_contents = first(get_pgf_axes(pl)).contents
        plots = filter(x -> x isa PGFPlotsX.Plot, axis_contents)
        @test length(plots) == 9
    end

    @testset "Groups and Subplots" begin
        group = rand(map(i -> "group $i", 1:4), 100)
        pl = plot(
            rand(100),
            layout = @layout([a b; c]),
            group = group,
            linetype = [:bar :scatter :steppre],
            linecolor = :match,
        )
        axis_contents = first(get_pgf_axes(pl)).contents
        legend_entries = filter(x -> x isa PGFPlotsX.LegendEntry, axis_contents)
        @test length(legend_entries) == 2
    end

    @testset "Extra kwargs" begin
        pl = plot(1:5, test = "me")
        @test pl[1][1].plotattributes[:extra_kwargs][:test] == "me"
        pl = plot(1:5, test = "me", extra_kwargs = :subplot)
        @test pl[1].attr[:extra_kwargs][:test] == "me"
        pl = plot(1:5, test = "me", extra_kwargs = :plot)
        @test pl.attr[:extra_plot_kwargs][:test] == "me"
        pl = plot(
            1:5,
            extra_kwargs = Dict(
                :plot => Dict(:test => "me"),
                :series => Dict(:and => "me too"),
            ),
        )
        @test pl.attr[:extra_plot_kwargs][:test] == "me"
        @test pl[1][1].plotattributes[:extra_kwargs][:and] == "me too"
        pl = plot(
            plot(1:5, title = "Line"),
            scatter(
                1:5,
                title = "Scatter",
                extra_kwargs = Dict(:subplot => Dict("axis line shift" => "10pt")),
            ),
        )
        axes = get_pgf_axes(pl)
        @test !haskey(axes[1].options.dict, "axis line shift")
        @test haskey(axes[2].options.dict, "axis line shift")
        pl = plot(
            x -> x,
            -1:1;
            add = raw"\node at (0,0.5) {\huge hi};",
            extra_kwargs = :subplot,
        )
        @test pl[1][:extra_kwargs] == Dict(:add => raw"\node at (0,0.5) {\huge hi};")
        axis_contents = first(get_pgf_axes(pl)).contents
        @test filter(x -> x isa String, axis_contents)[1] ==
            raw"\node at (0,0.5) {\huge hi};"
        plot!(pl)
        @test pl[1][:extra_kwargs] == Dict(:add => raw"\node at (0,0.5) {\huge hi};")
        axis_contents = first(get_pgf_axes(pl)).contents
        @test filter(x -> x isa String, axis_contents)[1] ==
            raw"\node at (0,0.5) {\huge hi};"
    end

    @testset "Titlefonts" begin
        pl = plot(1:5, title = "Test me", titlefont = (2, :left))
        @test pl[1][:title] == "Test me"
        @test pl[1][:titlefontsize] == 2
        @test pl[1][:titlefonthalign] === :left
        ax_opt = first(get_pgf_axes(pl)).options
        @test ax_opt["title"] == "Test me"
        @test(haskey(ax_opt.dict, "title style")) isa Test.Pass
        pl = plot(1:5, plot_title = "Test me", plot_titlefont = (2, :left))
        @test pl[:plot_title] == "Test me"
        @test pl[:plot_titlefontsize] == 2
        @test pl[:plot_titlefonthalign] === :left
        pl = heatmap(
            rand(3, 3),
            colorbar_title = "Test me",
            colorbar_titlefont = (12, :right),
        )
        @test pl[1][:colorbar_title] == "Test me"
        @test pl[1][:colorbar_titlefontsize] == 12
        @test pl[1][:colorbar_titlefonthalign] === :right
    end

    @testset "Latexify - LaTeXStrings" begin
        @test Plots.pgfx_sanitize_string("A string, with 2 punctuation chars.") ==
            "A string, with 2 punctuation chars."
        @test Plots.pgfx_sanitize_string("Interpolação polinomial") ==
            raw"Interpola$\textnormal{\c{c}}$$\tilde{a}$o polinomial"
        @test Plots.pgfx_sanitize_string("∫∞ ∂x") == raw"$\int$$\infty$ $\partial$x"

        # special LaTeX characters
        @test Plots.pgfx_sanitize_string("this is #3").s == raw"this is \#3"
        @test Plots.pgfx_sanitize_string("10% increase").s == raw"10\% increase"
        @test Plots.pgfx_sanitize_string("underscores _a_").s == raw"underscores \_a\_"
        @test Plots.pgfx_sanitize_string("plot 1 & 2 & 3").s == raw"plot 1 \& 2 \& 3"
        @test Plots.pgfx_sanitize_string("GDP in \$").s == raw"GDP in \$"
        @test Plots.pgfx_sanitize_string("curly { test }").s == raw"curly \{ test \}"

        @test Plots.pgfx_sanitize_string(L"this is #5").s == raw"$this is \#5$"
        @test Plots.pgfx_sanitize_string(L"10% increase").s == raw"$10\% increase$"
    end

    @testset "Setting correct plot titles" begin
        plt1 = plot(rand(10, 5))
        plt2 = plot(rand(10))

        @test plot(plt1, plt2, layout = (1, 2), plot_titles = ["(a)" "(b)"]) !== nothing
    end

    if Sys.islinux() && Sys.which("pdflatex") ≢ nothing
        @testset "Issues - actually compile `.tex`" begin
            # Plots.jl/issues/4308
            fn = tempname() * ".pdf"
            pl = plot((1:10) .^ 2, (1:10) .^ 2, xscale = :log10)
            Plots.pdf(pl, fn)
            @test isfile(fn)
        end
    end

    @testset "Unitful interaction" begin
        yreg = r"ylabel=\{((?:[^{}]*\{[^{}]*\})*[^{}]*?)\}"
        pl1 = plot([1u"s", 2u"s"], [1u"m", 2u"m"], xlabel = "t", ylabel = "diameter")
        pl2 = plot([1u"s", 2u"s"], [1u"m/s^2", 2u"m/s^2"])
        pl1_tex = String(repr("application/x-tex", pl1))
        pl2_tex = String(repr("application/x-tex", pl2))
        @test pl1_tex[findfirst(yreg, pl1_tex)] == "ylabel={diameter (\$\\mathrm{m}\$)}"
        @test pl2_tex[findfirst(yreg, pl2_tex)] ==
            "ylabel={\$\\mathrm{m}\\,\\mathrm{s}^{-2}\$}"
    end
end

# These functions return an operator for use in `get_clims(::Seres, op)`
process_clims(lims::Tuple{<:Number, <:Number}) =
    (zlims -> ifelse.(isfinite.(lims), lims, zlims)) ∘ ignorenan_extrema
process_clims(s::Union{Symbol, Nothing, Missing}) = ignorenan_extrema
# don't specialize on ::Function otherwise python functions won't work
process_clims(f) = f

get_clims(sp::Subplot)::Tuple{Float64, Float64} =
    haskey(sp.attr, :clims_calculated) ? sp[:clims_calculated] : update_clims(sp)
get_clims(series::Series)::Tuple{Float64, Float64} =
    haskey(series.plotattributes, :clims_calculated) ?
    series[:clims_calculated]::Tuple{Float64, Float64} : update_clims(series)
get_clims(sp::Subplot, series::Series)::Tuple{Float64, Float64} =
    series[:colorbar_entry] ? get_clims(sp) : get_clims(series)

function update_clims(sp::Subplot, op = process_clims(sp[:clims]))::Tuple{Float64, Float64}
    zmin, zmax = Inf, -Inf
    for series in series_list(sp)
        if series[:colorbar_entry]::Bool
            # Avoid calling the inner `update_clims` if at all possible; dynamic dispatch hell
            if (series[:seriestype] ∈ _z_colored_series && series[:z] !== nothing) ||
                    series[:line_z] !== nothing ||
                    series[:marker_z] !== nothing ||
                    series[:fill_z] !== nothing
                zmin, zmax = _update_clims(zmin, zmax, update_clims(series, op)...)
            else
                zmin, zmax = _update_clims(zmin, zmax, NaN, NaN)
            end
        else
            update_clims(series, op)
        end
    end
    return sp[:clims_calculated] = zmin <= zmax ? (zmin, zmax) : (NaN, NaN)
end

function update_clims(
        sp::Subplot,
        series::Series,
        op = process_clims(sp[:clims]),
    )::Tuple{Float64, Float64}
    zmin, zmax = get_clims(sp)
    old_zmin, old_zmax = zmin, zmax
    if series[:colorbar_entry]::Bool
        zmin, zmax = _update_clims(zmin, zmax, update_clims(series, op)...)
    else
        update_clims(series, op)
    end
    isnan(zmin) && isnan(old_zmin) && isnan(zmax) && isnan(old_zmax) ||
        zmin == old_zmin && zmax == old_zmax ||
        update_clims(sp)
    return zmin <= zmax ? (zmin, zmax) : (NaN, NaN)
end

"""
    update_clims(::Series, op=Plots.ignorenan_extrema)
Finds the limits for the colorbar by taking the "z-values" for the series and passing them into `op`,
which must return the tuple `(zmin, zmax)`. The default op is the extrema of the finite
values of the input. The value is stored as a series property, which is retrieved by `get_clims`.
"""
function update_clims(series::Series, op = ignorenan_extrema)::Tuple{Float64, Float64}
    zmin, zmax = Inf, -Inf

    # keeping this unrolled has higher performance
    if series[:seriestype] ∈ _z_colored_series && series[:z] !== nothing
        zmin, zmax = update_clims(zmin, zmax, series[:z], op)
    end
    if series[:line_z] !== nothing
        zmin, zmax = update_clims(zmin, zmax, series[:line_z], op)
    end
    if series[:marker_z] !== nothing
        zmin, zmax = update_clims(zmin, zmax, series[:marker_z], op)
    end
    if series[:fill_z] !== nothing
        zmin, zmax = update_clims(zmin, zmax, series[:fill_z], op)
    end
    return series[:clims_calculated] = zmin <= zmax ? (zmin, zmax) : (NaN, NaN)
end

update_clims(zmin, zmax, vals::AbstractSurface, op)::Tuple{Float64, Float64} =
    update_clims(zmin, zmax, vals.surf, op)
update_clims(zmin, zmax, vals::Any, op)::Tuple{Float64, Float64} =
    _update_clims(zmin, zmax, op(vals)...)
update_clims(zmin, zmax, ::Nothing, ::Any)::Tuple{Float64, Float64} = zmin, zmax

_update_clims(zmin, zmax, emin, emax) = NaNMath.min(zmin, emin), NaNMath.max(zmax, emax)

@enum ColorbarStyle cbar_gradient cbar_fill cbar_lines

function colorbar_style(series::Series)
    colorbar_entry = series[:colorbar_entry]
    if !(colorbar_entry isa Bool)
        @warn "Non-boolean colorbar_entry ignored."
        colorbar_entry = true
    end

    return if !colorbar_entry
        nothing
    elseif isfilledcontour(series)
        cbar_fill
    elseif iscontour(series)
        cbar_lines
    elseif series[:seriestype] ∈ (:heatmap, :surface) ||
            any(series[z] !== nothing for z in (:marker_z, :line_z, :fill_z))
        cbar_gradient
    else
        nothing
    end
end

hascolorbar(series::Series) = colorbar_style(series) !== nothing
hascolorbar(sp::Subplot) =
    sp[:colorbar] !== :none && any(hascolorbar(s) for s in series_list(sp))

function get_colorbar_ticks(sp::Subplot; update = true, formatter = sp[:colorbar_formatter])
    if update || !haskey(sp.attr, :colorbar_optimized_ticks)
        ticks = _transform_ticks(sp[:colorbar_ticks], sp[:colorbar_title])
        cvals = sp[:colorbar_continuous_values]
        dvals = sp[:colorbar_discrete_values]
        clims = get_clims(sp)
        scale = sp[:colorbar_scale]
        sp.attr[:colorbar_optimized_ticks] =
            get_ticks(ticks, cvals, dvals, clims, scale, formatter)
    end
    return sp.attr[:colorbar_optimized_ticks]
end

# Dynamic callback from the pipeline if needed
_update_subplot_colorbars(sp::Subplot) = update_clims(sp)
_update_subplot_colorbars(sp::Subplot, series::Series) = update_clims(sp, series)

@testset "HDF5_Plots" begin
    fname = tempname() * ".hdf5"
    hdf5()

    x = 1:10
    pl = plot(x, x .^ 2)  # create some plot
    Plots.hdf5plot_write(pl, fname)

    # read back file
    gr()  # choose some fast backend likely to work in test environment
    pread = Plots.hdf5plot_read(fname)

    # make sure data made it through
    @test pl.subplots[1].series_list[1][:x] == pread.subplots[1].series_list[1][:x]
    @test pl.subplots[1].series_list[1][:y] == pread.subplots[1].series_list[1][:y]

    ex = pl.subplots[1][:xaxis][:extrema]
    @test (ex.emin, ex.emax) == (1, 10)

    ex = pl.subplots[1][:yaxis][:extrema]
    @test (ex.emin, ex.emax) == (1, 100)

    # display(pread)  # don't display. Regression env might not support
end

module GeometryBasicsExt

import Plots: Plots, @ext_imp_use, @recipe
import RecipesPipeline
import Unzip

@ext_imp_use :import GeometryBasics

RecipesPipeline.unzip(points::AbstractVector{<:GeometryBasics.Point}) =
    Unzip.unzip(Tuple.(points))
RecipesPipeline.unzip(points::AbstractVector{GeometryBasics.Point{N, T}}) where {N, T} =
    isbitstype(T) && sizeof(T) > 0 ? Unzip.unzip(reinterpret(NTuple{N, T}, points)) :
    Unzip.unzip(Tuple.(points))
# -----------------------------------------
# Lists of tuples and GeometryBasics.Points
# -----------------------------------------
@recipe f(v::Plots.AVec{<:GeometryBasics.Point}) = RecipesPipeline.unzip(v)
@recipe f(p::GeometryBasics.Point) = [p]  # Special case for 4-tuples in :ohlc series

end  # module

const PLOTS_DEFAULTS = Dict(:theme => :wong2, :fontfamily => :palantino)
Plots._plots_theme_defaults()

@testset "Loading theme" begin
    pl = plot(1:5)
    @test pl[1][1][:seriescolor] == RGBA(colorant"black")
    @test Plots.guidefont(pl[1][:xaxis]).family == "palantino"
end

empty!(PLOTS_DEFAULTS)
Plots._plots_theme_defaults()

@testset "default" begin
    default(fillrange = 0)
    @test Plots._series_defaults[:fillrange] == 0
    pl = plot(1:5)
    @test pl[1][1][:fillrange] == 0
    @test_nowarn default(legendfont = font(5))
    pl = plot(1:5)
    @test pl[1][:legend_font_pointsize] == 5
    default()
end

@testset "Legend defaults" begin
    pl = plot()
    @test pl[1][:legend_font_family] == "sans-serif"
    @test pl[1][:legend_font_pointsize] == 8
    @test pl[1][:legend_font_halign] === :hcenter
    @test pl[1][:legend_font_valign] === :vcenter
    @test pl[1][:legend_font_rotation] == 0.0
    @test pl[1][:legend_font_color] == RGB{Colors.N0f8}(0.0, 0.0, 0.0)
    @test pl[1][:legend_position] === :best
    @test pl[1][:legend_title] === nothing
    @test pl[1][:legend_title_font_family] == "sans-serif"
    @test pl[1][:legend_title_font_pointsize] == 11
    @test pl[1][:legend_title_font_halign] === :hcenter
    @test pl[1][:legend_title_font_valign] === :vcenter
    @test pl[1][:legend_title_font_rotation] == 0.0
    @test pl[1][:legend_title_font_color] == RGB{Colors.N0f8}(0.0, 0.0, 0.0)
    @test pl[1][:legend_background_color] == RGBA{Float64}(1.0, 1.0, 1.0, 1.0)
    @test pl[1][:legend_foreground_color] == RGB{Colors.N0f8}(0.0, 0.0, 0.0)
end

@testset "Legend API" begin
    pl = plot(;
        legendfontfamily = "serif",
        legendfontsize = 12,
        legendfonthalign = :left,
        legendfontvalign = :top,
        legendfontrotation = 1,
        legendfontcolor = :red,
        legend = :outertopleft,
        legendtitle = "The legend",
        legendtitlefontfamily = "helvetica",
        legendtitlefontsize = 3,
        legendtitlefonthalign = :right,
        legendtitlefontvalign = :bottom,
        legendtitlefontrotation = -5.2,
        legendtitlefontcolor = :blue,
        background_color_legend = :cyan,
        foreground_color_legend = :green,
    )
    @test pl[1][:legend_font_family] == "serif"
    @test pl[1][:legend_font_pointsize] == 12
    @test pl[1][:legend_font_halign] === :left
    @test pl[1][:legend_font_valign] === :top
    @test pl[1][:legend_font_rotation] == 1.0
    @test pl[1][:legend_font_color] === :red
    @test pl[1][:legend_position] === :outertopleft
    @test pl[1][:legend_title] == "The legend"
    @test pl[1][:legend_title_font_family] == "helvetica"
    @test pl[1][:legend_title_font_pointsize] == 3
    @test pl[1][:legend_title_font_halign] === :right
    @test pl[1][:legend_title_font_valign] === :bottom
    @test pl[1][:legend_title_font_rotation] == -5.2
    @test pl[1][:legend_title_font_color] === :blue
    @test pl[1][:legend_background_color] == RGBA{Float64}(0.0, 1.0, 1.0, 1.0)
    @test pl[1][:legend_foreground_color] ==
        RGBA{Float64}(0.0, 0.5019607843137255, 0.0, 1.0)

    #remember settings
    plot(legend_font_pointsize = 20)
    sp = plot!(label = "R")[1]
    @test Plots.legendfont(sp).pointsize == 20

    #setting whole font
    sp = plot(
        1:5,
        legendfont = font(12),
        legend_font_halign = :left,
        foreground_color_subplot = :red,
    )[1]
    @test Plots.legendfont(sp).pointsize == 12
    @test Plots.legendfont(sp).halign === :left
    # match mechanism
    @test sp[:legend_font_color] == colorant"black"
    @test Plots.legendfont(sp).color == colorant"black"
    @test sp[:foreground_color_subplot] == RGBA(colorant"red")

    # magic invocation
    @test_nowarn sp = plot(; legendfont = 12)[1]
    @test sp[:legend_font_pointsize] == 12
    @test Plots.legendfont(sp).pointsize == 12
end

makeplural(s::Symbol) = last(string(s)) == 's' ? s : Symbol(string(s, "s"))
make_non_underscore(s::Symbol) = Symbol(replace(string(s), "_" => ""))

const _keyAliases = Dict{Symbol, Symbol}()

function add_aliases(sym::Symbol, aliases::Symbol...)
    for alias in aliases
        (haskey(_keyAliases, alias) || alias === sym) && return
        _keyAliases[alias] = sym
    end
    return nothing
end

function add_axes_aliases(sym::Symbol, aliases::Symbol...; generic::Bool = true)
    sym in keys(_axis_defaults) || throw(ArgumentError("Invalid `$sym`"))
    generic && add_aliases(sym, aliases...)
    for letter in (:x, :y, :z)
        add_aliases(Symbol(letter, sym), (Symbol(letter, a) for a in aliases)...)
    end
    return
end

function add_non_underscore_aliases!(aliases::Dict{Symbol, Symbol})
    for (k, v) in aliases
        if '_' in string(k)
            aliases[make_non_underscore(k)] = v
        end
    end
    return
end

macro attributes(expr::Expr)
    RecipesBase.process_recipe_body!(expr)
    return expr
end

# ------------------------------------------------------------

const _allAxes = [:auto, :left, :right]
const _axesAliases = Dict{Symbol, Symbol}(:a => :auto, :l => :left, :r => :right)

const _3dTypes = [:path3d, :scatter3d, :surface, :wireframe, :contour3d, :volume, :mesh3d]
const _allTypes = vcat(
    [
        :none,
        :line,
        :path,
        :steppre,
        :stepmid,
        :steppost,
        :sticks,
        :scatter,
        :heatmap,
        :hexbin,
        :barbins,
        :barhist,
        :histogram,
        :scatterbins,
        :scatterhist,
        :stepbins,
        :stephist,
        :bins2d,
        :histogram2d,
        :histogram3d,
        :density,
        :bar,
        :hline,
        :vline,
        :contour,
        :pie,
        :shape,
        :image,
    ],
    _3dTypes,
)

const _z_colored_series = [:contour, :contour3d, :heatmap, :histogram2d, :surface, :hexbin]

const _typeAliases = Dict{Symbol, Symbol}(
    :n => :none,
    :no => :none,
    :l => :line,
    :p => :path,
    :stepinv => :steppre,
    :stepsinv => :steppre,
    :stepinverted => :steppre,
    :stepsinverted => :steppre,
    :step => :steppost,
    :steps => :steppost,
    :stair => :steppost,
    :stairs => :steppost,
    :stem => :sticks,
    :stems => :sticks,
    :dots => :scatter,
    :pdf => :density,
    :contours => :contour,
    :line3d => :path3d,
    :surf => :surface,
    :wire => :wireframe,
    :shapes => :shape,
    :poly => :shape,
    :polygon => :shape,
    :box => :boxplot,
    :velocity => :quiver,
    :vectorfield => :quiver,
    :gradient => :quiver,
    :img => :image,
    :imshow => :image,
    :imagesc => :image,
    :hist => :histogram,
    :hist2d => :histogram2d,
    :bezier => :curves,
    :bezier_curves => :curves,
)

add_non_underscore_aliases!(_typeAliases)

const _histogram_like = [:histogram, :barhist, :barbins]
const _line_like = [:line, :path, :steppre, :stepmid, :steppost]
const _surface_like =
    [:contour, :contourf, :contour3d, :heatmap, :surface, :wireframe, :image]

like_histogram(seriestype::Symbol) = seriestype in _histogram_like
like_line(seriestype::Symbol) = seriestype in _line_like
like_surface(seriestype::Symbol) = RecipesPipeline.is_surface(seriestype)

RecipesPipeline.is3d(series::Series) = RecipesPipeline.is3d(series.plotattributes)
RecipesPipeline.is3d(sp::Subplot) = string(sp.attr[:projection]) == "3d"
ispolar(sp::Subplot) = string(sp.attr[:projection]) == "polar"
ispolar(series::Series) = ispolar(series.plotattributes[:subplot])

# ------------------------------------------------------------

const _allStyles = [:auto, :solid, :dash, :dot, :dashdot, :dashdotdot]
const _styleAliases = Dict{Symbol, Symbol}(
    :a => :auto,
    :s => :solid,
    :d => :dash,
    :dd => :dashdot,
    :ddd => :dashdotdot,
)

const _shape_keys = Symbol[
    :circle,
    :rect,
    :star5,
    :diamond,
    :hexagon,
    :cross,
    :xcross,
    :utriangle,
    :dtriangle,
    :rtriangle,
    :ltriangle,
    :pentagon,
    :heptagon,
    :octagon,
    :star4,
    :star6,
    :star7,
    :star8,
    :vline,
    :hline,
    :+,
    :x,
]

const _allMarkers = vcat(:none, :auto, _shape_keys) #sort(collect(keys(_shapes))))
const _markerAliases = Dict{Symbol, Symbol}(
    :n => :none,
    :no => :none,
    :a => :auto,
    :ellipse => :circle,
    :c => :circle,
    :circ => :circle,
    :square => :rect,
    :sq => :rect,
    :r => :rect,
    :d => :diamond,
    :^ => :utriangle,
    :ut => :utriangle,
    :utri => :utriangle,
    :uptri => :utriangle,
    :uptriangle => :utriangle,
    :v => :dtriangle,
    :V => :dtriangle,
    :dt => :dtriangle,
    :dtri => :dtriangle,
    :downtri => :dtriangle,
    :downtriangle => :dtriangle,
    :> => :rtriangle,
    :rt => :rtriangle,
    :rtri => :rtriangle,
    :righttri => :rtriangle,
    :righttriangle => :rtriangle,
    :< => :ltriangle,
    :lt => :ltriangle,
    :ltri => :ltriangle,
    :lighttri => :ltriangle,
    :lighttriangle => :ltriangle,
    # :+           => :cross,
    :plus => :cross,
    # :x           => :xcross,
    :X => :xcross,
    :star => :star5,
    :s => :star5,
    :star1 => :star5,
    :s2 => :star8,
    :star2 => :star8,
    :p => :pentagon,
    :pent => :pentagon,
    :h => :hexagon,
    :hex => :hexagon,
    :hep => :heptagon,
    :o => :octagon,
    :oct => :octagon,
    :spike => :vline,
)

const _positionAliases = Dict{Symbol, Symbol}(
    :top_left => :topleft,
    :tl => :topleft,
    :top_center => :topcenter,
    :tc => :topcenter,
    :top_right => :topright,
    :tr => :topright,
    :bottom_left => :bottomleft,
    :bl => :bottomleft,
    :bottom_center => :bottomcenter,
    :bc => :bottomcenter,
    :bottom_right => :bottomright,
    :br => :bottomright,
)

const _allScales = [:identity, :ln, :log2, :log10, :asinh, :sqrt]
const _logScales = [:ln, :log2, :log10]
const _logScaleBases = Dict(:ln => ℯ, :log2 => 2.0, :log10 => 10.0)
const _scaleAliases = Dict{Symbol, Symbol}(:none => :identity, :log => :log10)

const _allGridSyms = [
    :x,
    :y,
    :z,
    :xy,
    :xz,
    :yx,
    :yz,
    :zx,
    :zy,
    :xyz,
    :xzy,
    :yxz,
    :yzx,
    :zxy,
    :zyx,
    :all,
    :both,
    :on,
    :yes,
    :show,
    :none,
    :off,
    :no,
    :hide,
]
const _allGridArgs = [_allGridSyms; string.(_allGridSyms); nothing]
hasgrid(arg::Nothing, letter) = false
hasgrid(arg::Bool, letter) = arg
function hasgrid(arg::Symbol, letter)
    return if arg in _allGridSyms
        arg in (:all, :both, :on) || occursin(string(letter), string(arg))
    else
        @warn "Unknown grid argument $arg; $(get_attr_symbol(letter, :grid)) was set to `true` instead."
        true
    end
end
hasgrid(arg::AbstractString, letter) = hasgrid(Symbol(arg), letter)

const _allShowaxisSyms = [
    :x,
    :y,
    :z,
    :xy,
    :xz,
    :yx,
    :yz,
    :zx,
    :zy,
    :xyz,
    :xzy,
    :yxz,
    :yzx,
    :zxy,
    :zyx,
    :all,
    :both,
    :on,
    :yes,
    :show,
    :off,
    :no,
    :hide,
]
const _allShowaxisArgs = [_allGridSyms; string.(_allGridSyms)]
showaxis(arg::Nothing, letter) = false
showaxis(arg::Bool, letter) = arg
function showaxis(arg::Symbol, letter)
    return if arg in _allGridSyms
        arg in (:all, :both, :on, :yes) || occursin(string(letter), string(arg))
    else
        @warn "Unknown showaxis argument $arg; $(get_attr_symbol(letter, :showaxis)) was set to `true` instead."
        true
    end
end
showaxis(arg::AbstractString, letter) = hasgrid(Symbol(arg), letter)

const _allFramestyles = [:box, :semi, :axes, :origin, :zerolines, :grid, :none]
const _framestyleAliases = Dict{Symbol, Symbol}(
    :frame => :box,
    :border => :box,
    :on => :box,
    :transparent => :semi,
    :semitransparent => :semi,
)

const _bar_width = 0.8
# -----------------------------------------------------------------------------

const _series_defaults = KW(
    :label => :auto,
    :colorbar_entry => true,
    :seriescolor => :auto,
    :seriesalpha => nothing,
    :seriestype => :path,
    :linestyle => :solid,
    :linewidth => :auto,
    :linecolor => :auto,
    :linealpha => nothing,
    :fillrange => nothing,   # ribbons, areas, etc
    :fillcolor => :match,
    :fillalpha => nothing,
    :fillstyle => nothing,
    :markershape => :none,
    :markercolor => :match,
    :markeralpha => nothing,
    :markersize => 4,
    :markerstrokestyle => :solid,
    :markerstrokewidth => 1,
    :markerstrokecolor => :match,
    :markerstrokealpha => nothing,
    :bins => :auto,        # number of bins for hists
    :smooth => false,     # regression line?
    :group => nothing,   # groupby vector
    :x => nothing,
    :y => nothing,
    :z => nothing,   # depth for contour, surface, etc
    :marker_z => nothing,   # value for color scale
    :line_z => nothing,
    :fill_z => nothing,
    :levels => 15,
    :orientation => :vertical,
    :bar_position => :overlay,  # for bar plots and histograms: could also be stack (stack up) or dodge (side by side)
    :bar_width => nothing,
    :bar_edges => false,
    :xerror => nothing,
    :yerror => nothing,
    :zerror => nothing,
    :ribbon => nothing,
    :quiver => nothing,
    :arrow => nothing,   # allows for adding arrows to line/path... call `arrow(args...)`
    :normalize => false,     # do we want a normalized histogram?
    :weights => nothing,   # optional weights for histograms (1D and 2D)
    :show_empty_bins => false,     # should empty bins in 2D histogram be colored as zero (otherwise they are transparent)
    :contours => false,     # add contours to 3d surface and wireframe plots
    :contour_labels => false,
    :subplot => :auto,     # which subplot(s) does this series belong to?
    :series_annotations => nothing,       # a list of annotations which apply to the coordinates of this series
    :primary => true,     # when true, this "counts" as a series for color selection, etc.  the main use is to allow
    #     one logical series to be broken up (path and markers, for example)
    :hover => nothing,  # text to display when hovering over the data points
    :stride => (1, 1),    # array stride for wireframe/surface, the first element is the row stride and the second is the column stride.
    :connections => nothing,  # tuple of arrays to specify connectivity of a 3d mesh
    :z_order => :front, # one of :front, :back or integer in 1:length(sp.series_list)
    :permute => :none, # tuple of two symbols to be permuted
    :extra_kwargs => Dict(),
)

const _plot_defaults = KW(
    :plot_title => "",
    :plot_titleindex => 0,
    :plot_titlefontsize => 16,
    :plot_titlelocation => :center,           # also :left or :right
    :plot_titlefontfamily => :match,
    :plot_titlefonthalign => :hcenter,
    :plot_titlefontvalign => :vcenter,
    :plot_titlefontrotation => 0.0,
    :plot_titlefontcolor => :match,
    :plot_titlevspan => 0.05,              # vertical span of the plot title, here 5%
    :background_color => colorant"white",   # default for all backgrounds,
    :background_color_outside => :match,            # background outside grid,
    :foreground_color => :auto,             # default for all foregrounds, and title color,
    :fontfamily => "sans-serif",
    :size => (600, 400),
    :pos => (0, 0),
    :window_title => "Plots.jl",
    :show => false,
    :layout => 1,
    :link => :none,
    :overwrite_figure => true,
    :html_output_format => :auto,
    :tex_output_standalone => false,
    :inset_subplots => nothing,   # optionally pass a vector of (parent,bbox) tuples which are
    # the parent layout and the relative bounding box of inset subplots
    :dpi => DPI,        # dots per inch for images, etc
    :thickness_scaling => 1,
    :display_type => :auto,
    :warn_on_unsupported => true,
    :extra_plot_kwargs => Dict(),
    :extra_kwargs => :series,    # directs collection of extra_kwargs
)

const _subplot_defaults = KW(
    :title => "",
    :titlelocation => :center,           # also :left or :right
    :fontfamily_subplot => :match,
    :titlefontfamily => :match,
    :titlefontsize => 14,
    :titlefonthalign => :hcenter,
    :titlefontvalign => :vcenter,
    :titlefontrotation => 0.0,
    :titlefontcolor => :match,
    :background_color_subplot => :match,            # default for other bg colors... match takes plot default
    :background_color_inside => :match,            # background inside grid
    :foreground_color_subplot => :match,            # default for other fg colors... match takes plot default
    :foreground_color_title => :match,            # title color
    :color_palette => :auto,
    :colorbar => :legend,
    :clims => :auto,
    :colorbar_fontfamily => :match,
    :colorbar_ticks => :auto,
    :colorbar_tickfontfamily => :match,
    :colorbar_tickfontsize => 8,
    :colorbar_tickfonthalign => :hcenter,
    :colorbar_tickfontvalign => :vcenter,
    :colorbar_tickfontrotation => 0.0,
    :colorbar_tickfontcolor => :match,
    :colorbar_scale => :identity,
    :colorbar_formatter => :auto,
    :colorbar_discrete_values => [],
    :colorbar_continuous_values => zeros(0),
    :annotations => [],                # annotation tuples... list of (x,y,annotation)
    :annotationfontfamily => :match,
    :annotationfontsize => 14,
    :annotationhalign => :hcenter,
    :annotationvalign => :vcenter,
    :annotationrotation => 0.0,
    :annotationcolor => :match,
    :projection => :none,             # can also be :polar or :3d
    :projection_type => :auto,        # can also be :ortho(graphic) or :persp(ective)
    :aspect_ratio => :auto,           # choose from :none or :equal
    :margin => 1mm,
    :left_margin => :match,
    :top_margin => :match,
    :right_margin => :match,
    :bottom_margin => :match,
    :subplot_index => -1,
    :colorbar_title => "",
    :colorbar_titlefontsize => 10,
    :colorbar_title_location => :center,           # also :left or :right
    :colorbar_fontfamily => :match,
    :colorbar_titlefontfamily => :match,
    :colorbar_titlefonthalign => :hcenter,
    :colorbar_titlefontvalign => :vcenter,
    :colorbar_titlefontrotation => 0.0,
    :colorbar_titlefontcolor => :match,
    :framestyle => :axes,
    :camera => (30, 30),
    :extra_kwargs => Dict(),
)

const _axis_defaults = KW(
    :guide => "",
    :guide_position => :auto,
    :lims => :auto,
    :ticks => :auto,
    :scale => :identity,
    :rotation => 0,
    :flip => false,
    :link => [],
    :tickfontfamily => :match,
    :tickfontsize => 8,
    :tickfonthalign => :hcenter,
    :tickfontvalign => :vcenter,
    :tickfontrotation => 0.0,
    :tickfontcolor => :match,
    :guidefontfamily => :match,
    :guidefontsize => 11,
    :guidefonthalign => :hcenter,
    :guidefontvalign => :vcenter,
    :guidefontrotation => 0.0,
    :guidefontcolor => :match,
    :foreground_color_axis => :match,            # axis border/tick colors,
    :foreground_color_border => :match,            # plot area border/spines,
    :foreground_color_text => :match,            # tick text color,
    :foreground_color_guide => :match,            # guide text color,
    :discrete_values => [],
    :formatter => :auto,
    :mirror => false,
    :grid => true,
    :foreground_color_grid => :match,            # grid color
    :gridalpha => 0.1,
    :gridstyle => :solid,
    :gridlinewidth => 0.5,
    :foreground_color_minor_grid => :match,            # grid color
    :minorgridalpha => 0.05,
    :minorgridstyle => :solid,
    :minorgridlinewidth => 0.5,
    :tick_direction => :in,
    :minorticks => :auto,
    :minorgrid => false,
    :showaxis => true,
    :widen => :auto,
    :draw_arrow => false,
    :unit => nothing,
    :unitformat => :round,
)

const _suppress_warnings = Set{Symbol}(
    [
        :x_discrete_indices,
        :y_discrete_indices,
        :z_discrete_indices,
        :subplot,
        :subplot_index,
        :series_plotindex,
        :series_index,
        :link,
        :plot_object,
        :primary,
        :smooth,
        :relative_bbox,
        :force_minpad,
        :x_extrema,
        :y_extrema,
        :z_extrema,
    ]
)

is_subplot_attr(k) = k in _all_subplot_args
is_series_attr(k) = k in _all_series_args
is_axis_attr(k) = Symbol(chop(string(k); head = 1, tail = 0)) in _all_axis_args
is_axis_attr_noletter(k) = k in _all_axis_args

RecipesBase.is_key_supported(k::Symbol) = is_attr_supported(k)

# -----------------------------------------------------------------------------
autopick_ignore_none_auto(arr::AVec, idx::Integer) =
    _cycle(setdiff(arr, [:none, :auto]), idx)
autopick_ignore_none_auto(notarr, idx::Integer) = notarr

function aliasesAndAutopick(
        plotattributes::AKW,
        sym::Symbol,
        aliases::Dict{Symbol, Symbol},
        options::AVec,
        plotIndex::Int,
    )
    return if plotattributes[sym] === :auto
        plotattributes[sym] = autopick_ignore_none_auto(options, plotIndex)
    elseif haskey(aliases, plotattributes[sym])
        plotattributes[sym] = aliases[plotattributes[sym]]
    end
end

aliases(val) = aliases(_keyAliases, val)
aliases(aliasMap::Dict{Symbol, Symbol}, val) =
    filter(x -> x.second == val, aliasMap) |> keys |> collect |> sort

# -----------------------------------------------------------------------------
# legend
add_aliases(:legend_position, :legend, :leg, :key, :legends)
add_aliases(
    :legend_background_color,
    :bg_legend,
    :bglegend,
    :bgcolor_legend,
    :bg_color_legend,
    :background_legend,
    :background_colour_legend,
    :bgcolour_legend,
    :bg_colour_legend,
    :background_color_legend,
)
add_aliases(
    :legend_foreground_color,
    :fg_legend,
    :fglegend,
    :fgcolor_legend,
    :fg_color_legend,
    :foreground_legend,
    :foreground_colour_legend,
    :fgcolour_legend,
    :fg_colour_legend,
    :foreground_color_legend,
)
add_aliases(:legend_font_pointsize, :legendfontsize)
add_aliases(
    :legend_title,
    :key_title,
    :keytitle,
    :label_title,
    :labeltitle,
    :leg_title,
    :legtitle,
)
add_aliases(:legend_title_font_pointsize, :legendtitlefontsize)
add_aliases(:plot_title, :suptitle, :subplot_grid_title, :sgtitle, :plot_grid_title)
# margin
add_aliases(:left_margin, :leftmargin)

add_aliases(:top_margin, :topmargin)
add_aliases(:bottom_margin, :bottommargin)
add_aliases(:right_margin, :rightmargin)

# colors
add_aliases(:seriescolor, :c, :color, :colour, :colormap, :cmap)
add_aliases(:linecolor, :lc, :lcolor, :lcolour, :linecolour)
add_aliases(:markercolor, :mc, :mcolor, :mcolour, :markercolour)
add_aliases(:markerstrokecolor, :msc, :mscolor, :mscolour, :markerstrokecolour)
add_aliases(:markerstrokewidth, :msw, :mswidth)
add_aliases(:fillcolor, :fc, :fcolor, :fcolour, :fillcolour)

add_aliases(
    :background_color,
    :bg,
    :bgcolor,
    :bg_color,
    :background,
    :background_colour,
    :bgcolour,
    :bg_colour,
)
add_aliases(
    :background_color_subplot,
    :bg_subplot,
    :bgsubplot,
    :bgcolor_subplot,
    :bg_color_subplot,
    :background_subplot,
    :background_colour_subplot,
    :bgcolour_subplot,
    :bg_colour_subplot,
)
add_aliases(
    :background_color_inside,
    :bg_inside,
    :bginside,
    :bgcolor_inside,
    :bg_color_inside,
    :background_inside,
    :background_colour_inside,
    :bgcolour_inside,
    :bg_colour_inside,
)
add_aliases(
    :background_color_outside,
    :bg_outside,
    :bgoutside,
    :bgcolor_outside,
    :bg_color_outside,
    :background_outside,
    :background_colour_outside,
    :bgcolour_outside,
    :bg_colour_outside,
)
add_aliases(
    :foreground_color,
    :fg,
    :fgcolor,
    :fg_color,
    :foreground,
    :foreground_colour,
    :fgcolour,
    :fg_colour,
)

add_aliases(
    :foreground_color_subplot,
    :fg_subplot,
    :fgsubplot,
    :fgcolor_subplot,
    :fg_color_subplot,
    :foreground_subplot,
    :foreground_colour_subplot,
    :fgcolour_subplot,
    :fg_colour_subplot,
)
add_aliases(
    :foreground_color_grid,
    :fg_grid,
    :fggrid,
    :fgcolor_grid,
    :fg_color_grid,
    :foreground_grid,
    :foreground_colour_grid,
    :fgcolour_grid,
    :fg_colour_grid,
    :gridcolor,
)
add_aliases(
    :foreground_color_minor_grid,
    :fg_minor_grid,
    :fgminorgrid,
    :fgcolor_minorgrid,
    :fg_color_minorgrid,
    :foreground_minorgrid,
    :foreground_colour_minor_grid,
    :fgcolour_minorgrid,
    :fg_colour_minor_grid,
    :minorgridcolor,
)
add_aliases(
    :foreground_color_title,
    :fg_title,
    :fgtitle,
    :fgcolor_title,
    :fg_color_title,
    :foreground_title,
    :foreground_colour_title,
    :fgcolour_title,
    :fg_colour_title,
    :titlecolor,
)
add_aliases(
    :foreground_color_axis,
    :fg_axis,
    :fgaxis,
    :fgcolor_axis,
    :fg_color_axis,
    :foreground_axis,
    :foreground_colour_axis,
    :fgcolour_axis,
    :fg_colour_axis,
    :axiscolor,
)
add_aliases(
    :foreground_color_border,
    :fg_border,
    :fgborder,
    :fgcolor_border,
    :fg_color_border,
    :foreground_border,
    :foreground_colour_border,
    :fgcolour_border,
    :fg_colour_border,
    :bordercolor,
)
add_aliases(
    :foreground_color_text,
    :fg_text,
    :fgtext,
    :fgcolor_text,
    :fg_color_text,
    :foreground_text,
    :foreground_colour_text,
    :fgcolour_text,
    :fg_colour_text,
    :textcolor,
)
add_aliases(
    :foreground_color_guide,
    :fg_guide,
    :fgguide,
    :fgcolor_guide,
    :fg_color_guide,
    :foreground_guide,
    :foreground_colour_guide,
    :fgcolour_guide,
    :fg_colour_guide,
    :guidecolor,
)

# alphas
add_aliases(:seriesalpha, :alpha, :α, :opacity)
add_aliases(:linealpha, :la, :lalpha, :lα, :lineopacity, :lopacity)
add_aliases(:markeralpha, :ma, :malpha, :mα, :markeropacity, :mopacity)
add_aliases(:markerstrokealpha, :msa, :msalpha, :msα, :markerstrokeopacity, :msopacity)
add_aliases(:fillalpha, :fa, :falpha, :fα, :fillopacity, :fopacity)

# axes attributes
add_axes_aliases(:guide, :label, :lab, :l; generic = false)
add_axes_aliases(:lims, :lim, :limit, :limits, :range)
add_axes_aliases(:ticks, :tick)
add_axes_aliases(:rotation, :rot, :r)
add_axes_aliases(:guidefontsize, :labelfontsize)
add_axes_aliases(:gridalpha, :ga, :galpha, :gα, :gridopacity, :gopacity)
add_axes_aliases(
    :gridstyle,
    :grid_style,
    :gridlinestyle,
    :grid_linestyle,
    :grid_ls,
    :gridls,
)
add_axes_aliases(
    :foreground_color_grid,
    :fg_grid,
    :fggrid,
    :fgcolor_grid,
    :fg_color_grid,
    :foreground_grid,
    :foreground_colour_grid,
    :fgcolour_grid,
    :fg_colour_grid,
    :gridcolor,
)
add_axes_aliases(
    :foreground_color_minor_grid,
    :fg_minor_grid,
    :fgminorgrid,
    :fgcolor_minorgrid,
    :fg_color_minorgrid,
    :foreground_minorgrid,
    :foreground_colour_minor_grid,
    :fgcolour_minorgrid,
    :fg_colour_minor_grid,
    :minorgridcolor,
)
add_axes_aliases(
    :gridlinewidth,
    :gridwidth,
    :grid_linewidth,
    :grid_width,
    :gridlw,
    :grid_lw,
)
add_axes_aliases(
    :minorgridstyle,
    :minorgrid_style,
    :minorgridlinestyle,
    :minorgrid_linestyle,
    :minorgrid_ls,
    :minorgridls,
)
add_axes_aliases(
    :minorgridlinewidth,
    :minorgridwidth,
    :minorgrid_linewidth,
    :minorgrid_width,
    :minorgridlw,
    :minorgrid_lw,
)
add_axes_aliases(
    :tick_direction,
    :tickdirection,
    :tick_dir,
    :tickdir,
    :tick_orientation,
    :tickorientation,
    :tick_or,
    :tickor,
)

# series attributes
add_aliases(:seriestype, :st, :t, :typ, :linetype, :lt)
add_aliases(:label, :lab)
add_aliases(:line, :l)
add_aliases(:linewidth, :w, :width, :lw)
add_aliases(:linestyle, :style, :s, :ls)
add_aliases(:marker, :m, :mark)
add_aliases(:markershape, :shape)
add_aliases(:markersize, :ms, :msize)
add_aliases(:marker_z, :markerz, :zcolor, :mz)
add_aliases(:line_z, :linez, :zline, :lz)
add_aliases(:fill, :f, :area)
add_aliases(:fillrange, :fillrng, :frange, :fillto, :fill_between)
add_aliases(:group, :g, :grouping)
add_aliases(:bins, :bin, :nbin, :nbins, :nb)
add_aliases(:ribbon, :rib)
add_aliases(:annotations, :ann, :anns, :annotate, :annotation)
add_aliases(:xguide, :xlabel, :xlab, :xl)
add_aliases(:xlims, :xlim, :xlimit, :xlimits, :xrange)
add_aliases(:xticks, :xtick)
add_aliases(:xrotation, :xrot, :xr)
add_aliases(:yguide, :ylabel, :ylab, :yl)
add_aliases(:ylims, :ylim, :ylimit, :ylimits, :yrange)
add_aliases(:yticks, :ytick)
add_aliases(:yrotation, :yrot, :yr)
add_aliases(:zguide, :zlabel, :zlab, :zl)
add_aliases(:zlims, :zlim, :zlimit, :zlimits)
add_aliases(:zticks, :ztick)
add_aliases(:zrotation, :zrot, :zr)
add_aliases(:guidefontsize, :labelfontsize)
add_aliases(
    :fill_z,
    :fillz,
    :fz,
    :surfacecolor,
    :surfacecolour,
    :sc,
    :surfcolor,
    :surfcolour,
)
add_aliases(:colorbar, :cb, :cbar, :colorkey)
add_aliases(
    :colorbar_title,
    :colorbartitle,
    :cb_title,
    :cbtitle,
    :cbartitle,
    :cbar_title,
    :colorkeytitle,
    :colorkey_title,
)
add_aliases(:clims, :clim, :cbarlims, :cbar_lims, :climits, :color_limits)
add_aliases(:smooth, :regression, :reg)
add_aliases(:levels, :nlevels, :nlev, :levs)
add_aliases(:size, :windowsize, :wsize)
add_aliases(:window_title, :windowtitle, :wtitle)
add_aliases(:show, :gui, :display)
add_aliases(:color_palette, :palette)
add_aliases(:overwrite_figure, :clf, :clearfig, :overwrite, :reuse)
add_aliases(:xerror, :xerr, :xerrorbar)
add_aliases(:yerror, :yerr, :yerrorbar, :err, :errorbar)
add_aliases(:zerror, :zerr, :zerrorbar)
add_aliases(:quiver, :velocity, :quiver2d, :gradient, :vectorfield)
add_aliases(:normalize, :norm, :normed, :normalized)
add_aliases(:show_empty_bins, :showemptybins, :showempty, :show_empty)
add_aliases(:aspect_ratio, :aspectratio, :axis_ratio, :axisratio, :ratio)
add_aliases(:subplot, :sp, :subplt, :splt)
add_aliases(:projection, :proj)
add_aliases(:projection_type, :proj_type)
add_aliases(
    :titlelocation,
    :title_location,
    :title_loc,
    :titleloc,
    :title_position,
    :title_pos,
    :titlepos,
    :titleposition,
    :title_align,
    :title_alignment,
)
add_aliases(
    :series_annotations,
    :series_ann,
    :seriesann,
    :series_anns,
    :seriesanns,
    :series_annotation,
    :text,
    :txt,
    :texts,
    :txts,
)
add_aliases(:html_output_format, :format, :fmt, :html_format)
add_aliases(:orientation, :direction, :dir)
add_aliases(:inset_subplots, :inset, :floating)
add_aliases(:stride, :wirefame_stride, :surface_stride, :surf_str, :str)

add_aliases(
    :framestyle,
    :frame_style,
    :frame,
    :axesstyle,
    :axes_style,
    :boxstyle,
    :box_style,
    :box,
    :borderstyle,
    :border_style,
    :border,
)

add_aliases(:camera, :cam, :viewangle, :view_angle)
add_aliases(:contour_labels, :contourlabels, :clabels, :clabs)
add_aliases(:warn_on_unsupported, :warn)

# -----------------------------------------------------------------------------

function parse_axis_kw(s::Symbol)
    s = string(s)
    for letter in ('x', 'y', 'z')
        startswith(s, letter) &&
            return (Symbol(letter), Symbol(chop(s, head = 1, tail = 0)))
    end
    return nothing
end

# update the defaults globally

"""
`default(key)` returns the current default value for that key.

`default(key, value)` sets the current default value for that key.

`default(; kw...)` will set the current default value for each key/value pair.

`default(plotattributes, key)` returns the key from plotattributes if it exists, otherwise `default(key)`.

"""
function default(k::Symbol)
    k = get(_keyAliases, k, k)
    for defaults in _all_defaults
        haskey(defaults, k) && return defaults[k]
    end
    haskey(_axis_defaults, k) && return _axis_defaults[k]
    if (axis_k = parse_axis_kw(k)) !== nothing
        letter, key = axis_k
        return _axis_defaults_byletter[letter][key]
    end
    k === :letter && return k # for type recipe processing
    return missing
end

function default(k::Symbol, v)
    k = get(_keyAliases, k, k)
    for defaults in _all_defaults
        if haskey(defaults, k)
            defaults[k] = v
            return v
        end
    end
    if haskey(_axis_defaults, k)
        _axis_defaults[k] = v
        return v
    end
    if (axis_k = parse_axis_kw(k)) !== nothing
        letter, key = axis_k
        _axis_defaults_byletter[letter][key] = v
        return v
    end
    return k in _suppress_warnings || error("Unknown key: ", k)
end

function default(; reset = true, kw...)
    (reset && isempty(kw)) && reset_defaults()
    kw = KW(kw)
    Plots.preprocess_attributes!(kw)
    for (k, v) in kw
        default(k, v)
    end
    return
end

default(plotattributes::AKW, k::Symbol) = get(plotattributes, k, default(k))

function reset_defaults()
    foreach(merge!, _all_defaults, _initial_defaults)
    merge!(_axis_defaults, _initial_axis_defaults)
    return reset_axis_defaults_byletter!()
end

# -----------------------------------------------------------------------------

# if arg is a valid color value, then set plotattributes[csym] and return true
function handleColors!(plotattributes::AKW, arg, csym::Symbol)
    try
        plotattributes[csym] = if arg === :auto
            :auto
        else
            plot_color(arg)
        end
        return true
    catch
    end
    return false
end

function processLineArg(plotattributes::AKW, arg)
    # seriestype
    return if allLineTypes(arg)
        plotattributes[:seriestype] = arg

        # linestyle
    elseif allStyles(arg)
        plotattributes[:linestyle] = arg

    elseif typeof(arg) <: Stroke
        arg.width === nothing || (plotattributes[:linewidth] = arg.width)
        arg.color === nothing || (
            plotattributes[:linecolor] =
                arg.color === :auto ? :auto : plot_color(arg.color)
        )
        arg.alpha === nothing || (plotattributes[:linealpha] = arg.alpha)
        arg.style === nothing || (plotattributes[:linestyle] = arg.style)

    elseif typeof(arg) <: Brush
        arg.size === nothing || (plotattributes[:fillrange] = arg.size)
        arg.color === nothing || (
            plotattributes[:fillcolor] =
                arg.color === :auto ? :auto : plot_color(arg.color)
        )
        arg.alpha === nothing || (plotattributes[:fillalpha] = arg.alpha)
        arg.style === nothing || (plotattributes[:fillstyle] = arg.style)

    elseif typeof(arg) <: Arrow || arg in (:arrow, :arrows)
        plotattributes[:arrow] = arg

        # linealpha
    elseif allAlphas(arg)
        plotattributes[:linealpha] = arg

        # linewidth
    elseif allReals(arg)
        plotattributes[:linewidth] = arg

        # color
    elseif !handleColors!(plotattributes, arg, :linecolor)
        @warn "Skipped line arg $arg."
    end
end

function processMarkerArg(plotattributes::AKW, arg)
    # markershape
    return if allShapes(arg) && !haskey(plotattributes, :markershape)
        plotattributes[:markershape] = arg

        # stroke style
    elseif allStyles(arg)
        plotattributes[:markerstrokestyle] = arg

    elseif typeof(arg) <: Stroke
        arg.width === nothing || (plotattributes[:markerstrokewidth] = arg.width)
        arg.color === nothing || (
            plotattributes[:markerstrokecolor] =
                arg.color === :auto ? :auto : plot_color(arg.color)
        )
        arg.alpha === nothing || (plotattributes[:markerstrokealpha] = arg.alpha)
        arg.style === nothing || (plotattributes[:markerstrokestyle] = arg.style)

    elseif typeof(arg) <: Brush
        arg.size === nothing || (plotattributes[:markersize] = arg.size)
        arg.color === nothing || (
            plotattributes[:markercolor] =
                arg.color === :auto ? :auto : plot_color(arg.color)
        )
        arg.alpha === nothing || (plotattributes[:markeralpha] = arg.alpha)

        # linealpha
    elseif allAlphas(arg)
        plotattributes[:markeralpha] = arg

        # bool
    elseif typeof(arg) <: Bool
        plotattributes[:markershape] = arg ? :circle : :none

        # markersize
    elseif allReals(arg)
        plotattributes[:markersize] = arg

        # markercolor
    elseif !handleColors!(plotattributes, arg, :markercolor)
        @warn "Skipped marker arg $arg."
    end
end

function processFillArg(plotattributes::AKW, arg)
    # fr = get(plotattributes, :fillrange, 0)
    if typeof(arg) <: Brush
        arg.size === nothing || (plotattributes[:fillrange] = arg.size)
        arg.color === nothing || (
            plotattributes[:fillcolor] =
                arg.color === :auto ? :auto : plot_color(arg.color)
        )
        arg.alpha === nothing || (plotattributes[:fillalpha] = arg.alpha)
        arg.style === nothing || (plotattributes[:fillstyle] = arg.style)

    elseif typeof(arg) <: Bool
        plotattributes[:fillrange] = arg ? 0 : nothing

        # fillrange function
    elseif allFunctions(arg)
        plotattributes[:fillrange] = arg

        # fillalpha
    elseif allAlphas(arg)
        plotattributes[:fillalpha] = arg

        # fillrange provided as vector or number
    elseif typeof(arg) <: Union{AbstractArray{<:Real}, Real}
        plotattributes[:fillrange] = arg

    elseif !handleColors!(plotattributes, arg, :fillcolor)
        plotattributes[:fillrange] = arg
    end
    # plotattributes[:fillrange] = fr
    return nothing
end

function processGridArg!(plotattributes::AKW, arg, letter)
    return if arg in _allGridArgs || isa(arg, Bool)
        plotattributes[get_attr_symbol(letter, :grid)] = hasgrid(arg, letter)

    elseif allStyles(arg)
        plotattributes[get_attr_symbol(letter, :gridstyle)] = arg

    elseif typeof(arg) <: Stroke
        arg.width === nothing ||
            (plotattributes[get_attr_symbol(letter, :gridlinewidth)] = arg.width)
        arg.color === nothing || (
            plotattributes[get_attr_symbol(letter, :foreground_color_grid)] =
                arg.color in (:auto, :match) ? :match : plot_color(arg.color)
        )
        arg.alpha === nothing ||
            (plotattributes[get_attr_symbol(letter, :gridalpha)] = arg.alpha)
        arg.style === nothing ||
            (plotattributes[get_attr_symbol(letter, :gridstyle)] = arg.style)

        # linealpha
    elseif allAlphas(arg)
        plotattributes[get_attr_symbol(letter, :gridalpha)] = arg

        # linewidth
    elseif allReals(arg)
        plotattributes[get_attr_symbol(letter, :gridlinewidth)] = arg

        # color
    elseif !handleColors!(
            plotattributes,
            arg,
            get_attr_symbol(letter, :foreground_color_grid),
        )
        @warn "Skipped grid arg $arg."
    end
end

function processMinorGridArg!(plotattributes::AKW, arg, letter)
    return if arg in _allGridArgs || isa(arg, Bool)
        plotattributes[get_attr_symbol(letter, :minorgrid)] = hasgrid(arg, letter)

    elseif allStyles(arg)
        plotattributes[get_attr_symbol(letter, :minorgridstyle)] = arg
        plotattributes[get_attr_symbol(letter, :minorgrid)] = true

    elseif typeof(arg) <: Stroke
        arg.width === nothing ||
            (plotattributes[get_attr_symbol(letter, :minorgridlinewidth)] = arg.width)
        arg.color === nothing || (
            plotattributes[get_attr_symbol(letter, :foreground_color_minor_grid)] =
                arg.color in (:auto, :match) ? :match : plot_color(arg.color)
        )
        arg.alpha === nothing ||
            (plotattributes[get_attr_symbol(letter, :minorgridalpha)] = arg.alpha)
        arg.style === nothing ||
            (plotattributes[get_attr_symbol(letter, :minorgridstyle)] = arg.style)
        plotattributes[get_attr_symbol(letter, :minorgrid)] = true

        # linealpha
    elseif allAlphas(arg)
        plotattributes[get_attr_symbol(letter, :minorgridalpha)] = arg
        plotattributes[get_attr_symbol(letter, :minorgrid)] = true

        # linewidth
    elseif allReals(arg)
        plotattributes[get_attr_symbol(letter, :minorgridlinewidth)] = arg
        plotattributes[get_attr_symbol(letter, :minorgrid)] = true

        # color
    elseif handleColors!(
            plotattributes,
            arg,
            get_attr_symbol(letter, :foreground_color_minor_grid),
        )
        plotattributes[get_attr_symbol(letter, :minorgrid)] = true
    else
        @warn "Skipped grid arg $arg."
    end
end

@attributes function processFontArg!(plotattributes::AKW, fontname::Symbol, arg)
    T = typeof(arg)
    if fontname in (:legend_font,)
        # TODO: this is neccessary while old and new font names coexist and should be standard after the transition
        fontname = Symbol(fontname, :_)
    end
    if T <: Font
        Symbol(fontname, :family) --> arg.family

        # TODO: this is neccessary in the transition from old fontsize to new font_pointsize and should be removed when it is completed
        if in(Symbol(fontname, :size), _all_args)
            Symbol(fontname, :size) --> arg.pointsize
        else
            Symbol(fontname, :pointsize) --> arg.pointsize
        end
        Symbol(fontname, :halign) --> arg.halign
        Symbol(fontname, :valign) --> arg.valign
        Symbol(fontname, :rotation) --> arg.rotation
        Symbol(fontname, :color) --> arg.color
    elseif arg === :center
        Symbol(fontname, :halign) --> :hcenter
        Symbol(fontname, :valign) --> :vcenter
    elseif arg ∈ _haligns
        Symbol(fontname, :halign) --> arg
    elseif arg ∈ _valigns
        Symbol(fontname, :valign) --> arg
    elseif T <: Colorant
        Symbol(fontname, :color) --> arg
    elseif T <: Symbol || T <: AbstractString
        try
            Symbol(fontname, :color) --> parse(Colorant, string(arg))
        catch
            Symbol(fontname, :family) --> string(arg)
        end
    elseif typeof(arg) <: Integer
        if in(Symbol(fontname, :size), _all_args)
            Symbol(fontname, :size) --> arg
        else
            Symbol(fontname, :pointsize) --> arg
        end
    elseif typeof(arg) <: Real
        Symbol(fontname, :rotation) --> convert(Float64, arg)
    else
        @warn "Skipped font arg: $arg ($(typeof(arg)))"
    end
end

_replace_markershape(shape::Symbol) = get(_markerAliases, shape, shape)
_replace_markershape(shapes::AVec) = map(_replace_markershape, shapes)
_replace_markershape(shape) = shape

function _add_markershape(plotattributes::AKW)
    # add the markershape if it needs to be added... hack to allow "m=10" to add a shape,
    # and still allow overriding in _apply_recipe
    ms = pop!(plotattributes, :markershape_to_add, :none)
    return if !haskey(plotattributes, :markershape) && ms !== :none
        plotattributes[:markershape] = ms
    end
end

"Handle all preprocessing of args... break out colors/sizes/etc and replace aliases."
function preprocess_attributes!(plotattributes::AKW)
    replaceAliases!(plotattributes, _keyAliases)

    # handle axis args common to all axis
    args = wraptuple(RecipesPipeline.pop_kw!(plotattributes, :axis, ()))
    showarg = wraptuple(RecipesPipeline.pop_kw!(plotattributes, :showaxis, ()))
    for arg in wraptuple((args..., showarg...))
        for letter in (:x, :y, :z)
            process_axis_arg!(plotattributes, arg, letter)
        end
    end
    # handle axis args
    for letter in (:x, :y, :z)
        asym = get_attr_symbol(letter, :axis)
        args = RecipesPipeline.pop_kw!(plotattributes, asym, ())
        if !(typeof(args) <: Axis)
            for arg in wraptuple(args)
                process_axis_arg!(plotattributes, arg, letter)
            end
        end
    end

    # vline and others accesses the y argument but actually maps it to the x axis.
    # Hence, we have to take care of formatters
    if treats_y_as_x(get(plotattributes, :seriestype, :path))
        xformatter = get(plotattributes, :xformatter, :auto)
        yformatter = get(plotattributes, :yformatter, :auto)
        yformatter !== :auto && (plotattributes[:xformatter] = yformatter)
        xformatter === :auto &&
            haskey(plotattributes, :yformatter) &&
            pop!(plotattributes, :yformatter)
    end

    # handle grid args common to all axes
    args = RecipesPipeline.pop_kw!(plotattributes, :grid, ())
    for arg in wraptuple(args)
        for letter in (:x, :y, :z)
            processGridArg!(plotattributes, arg, letter)
        end
    end
    # handle individual axes grid args
    for letter in (:x, :y, :z)
        gridsym = get_attr_symbol(letter, :grid)
        args = RecipesPipeline.pop_kw!(plotattributes, gridsym, ())
        for arg in wraptuple(args)
            processGridArg!(plotattributes, arg, letter)
        end
    end
    # handle minor grid args common to all axes
    args = RecipesPipeline.pop_kw!(plotattributes, :minorgrid, ())
    for arg in wraptuple(args)
        for letter in (:x, :y, :z)
            processMinorGridArg!(plotattributes, arg, letter)
        end
    end
    # handle individual axes grid args
    for letter in (:x, :y, :z)
        gridsym = get_attr_symbol(letter, :minorgrid)
        args = RecipesPipeline.pop_kw!(plotattributes, gridsym, ())
        for arg in wraptuple(args)
            processMinorGridArg!(plotattributes, arg, letter)
        end
    end
    # handle font args common to all axes
    for fontname in (:tickfont, :guidefont)
        args = RecipesPipeline.pop_kw!(plotattributes, fontname, ())
        for arg in wraptuple(args)
            for letter in (:x, :y, :z)
                processFontArg!(plotattributes, get_attr_symbol(letter, fontname), arg)
            end
        end
    end
    # handle individual axes font args
    for letter in (:x, :y, :z)
        for fontname in (:tickfont, :guidefont)
            args = RecipesPipeline.pop_kw!(
                plotattributes,
                get_attr_symbol(letter, fontname),
                (),
            )
            for arg in wraptuple(args)
                processFontArg!(plotattributes, get_attr_symbol(letter, fontname), arg)
            end
        end
    end
    # handle axes args
    for k in _axis_args
        if haskey(plotattributes, k) && k !== :link
            v = plotattributes[k]
            for letter in (:x, :y, :z)
                lk = get_attr_symbol(letter, k)
                if !is_explicit(plotattributes, lk)
                    plotattributes[lk] = v
                end
            end
        end
    end

    # fonts
    for fontname in
        (:titlefont, :legend_title_font, :plot_titlefont, :colorbar_titlefont, :legend_font)
        args = RecipesPipeline.pop_kw!(plotattributes, fontname, ())
        for arg in wraptuple(args)
            processFontArg!(plotattributes, fontname, arg)
        end
    end

    # handle line args
    for arg in wraptuple(RecipesPipeline.pop_kw!(plotattributes, :line, ()))
        processLineArg(plotattributes, arg)
    end

    if haskey(plotattributes, :seriestype) &&
            haskey(_typeAliases, plotattributes[:seriestype])
        plotattributes[:seriestype] = _typeAliases[plotattributes[:seriestype]]
    end

    # handle marker args... default to ellipse if shape not set
    anymarker = false
    for arg in wraptuple(get(plotattributes, :marker, ()))
        processMarkerArg(plotattributes, arg)
        anymarker = true
    end
    RecipesPipeline.reset_kw!(plotattributes, :marker)
    if haskey(plotattributes, :markershape)
        plotattributes[:markershape] = _replace_markershape(plotattributes[:markershape])
        if plotattributes[:markershape] === :none &&
                get(plotattributes, :seriestype, :path) in
                (:scatter, :scatterbins, :scatterhist, :scatter3d) #the default should be :auto, not :none, so that :none can be set explicitly and would be respected
            plotattributes[:markershape] = :circle
        end
    elseif anymarker
        plotattributes[:markershape_to_add] = :circle  # add it after _apply_recipe
    end

    # handle fill
    for arg in wraptuple(get(plotattributes, :fill, ()))
        processFillArg(plotattributes, arg)
    end
    RecipesPipeline.reset_kw!(plotattributes, :fill)

    # handle series annotations
    if haskey(plotattributes, :series_annotations)
        plotattributes[:series_annotations] =
            series_annotations(wraptuple(plotattributes[:series_annotations])...)
    end

    # convert into strokes and brushes

    if haskey(plotattributes, :arrow)
        a = plotattributes[:arrow]
        plotattributes[:arrow] = if a == true
            arrow()
        elseif a in (false, nothing, :none)
            nothing
        elseif !(typeof(a) <: Arrow || typeof(a) <: AbstractArray{Arrow})
            arrow(wraptuple(a)...)
        else
            a
        end
    end

    # legends - defaults are set in `src/components.jl` (see `@add_attributes`)
    if haskey(plotattributes, :legend_position)
        plotattributes[:legend_position] =
            convertLegendValue(plotattributes[:legend_position])
    end
    if haskey(plotattributes, :colorbar)
        plotattributes[:colorbar] = convertLegendValue(plotattributes[:colorbar])
    end

    # framestyle
    if haskey(plotattributes, :framestyle) &&
            haskey(_framestyleAliases, plotattributes[:framestyle])
        plotattributes[:framestyle] = _framestyleAliases[plotattributes[:framestyle]]
    end

    # contours
    if haskey(plotattributes, :levels)
        check_contour_levels(plotattributes[:levels])
    end

    # warnings for moved recipes
    st = get(plotattributes, :seriestype, :path)
    if st in (:boxplot, :violin, :density) &&
            !haskey(
            Base.loaded_modules,
            Base.PkgId(Base.UUID("f3b207a7-027a-5e70-b257-86293d7955fd"), "StatsPlots"),
        )
        @warn "seriestype $st has been moved to StatsPlots.  To use: \`Pkg.add(\"StatsPlots\"); using StatsPlots\`"
    end
    return nothing
end
RecipesPipeline.preprocess_attributes!(plt::Plot, plotattributes::AKW) =
    Plots.preprocess_attributes!(plotattributes)

# -----------------------------------------------------------------------------

const _already_warned = Dict{Symbol, Set{Symbol}}()
const _to_warn = Set{Symbol}()

should_warn_on_unsupported(::AbstractBackend) = _plot_defaults[:warn_on_unsupported]

function warn_on_unsupported_args(pkg::AbstractBackend, plotattributes)
    empty!(_to_warn)
    bend = backend_name(pkg)
    already_warned = get!(_already_warned, bend) do
        Set{Symbol}()
    end
    extra_kwargs = Dict{Symbol, Any}()
    for k in explicitkeys(plotattributes)
        (is_attr_supported(pkg, k) && k ∉ keys(_deprecated_attributes)) && continue
        k in _suppress_warnings && continue
        if ismissing(default(k))
            extra_kwargs[k] = pop_kw!(plotattributes, k)
        elseif plotattributes[k] != default(k)
            k in already_warned || push!(_to_warn, k)
        end
    end

    if !isempty(_to_warn) &&
            get(plotattributes, :warn_on_unsupported, should_warn_on_unsupported(pkg))
        for k in sort(collect(_to_warn))
            push!(already_warned, k)
            if k in keys(_deprecated_attributes)
                @warn """
                Keyword argument `$k` is deprecated.
                Please use `$(_deprecated_attributes[k])` instead.
                """
            else
                @warn "Keyword argument $k not supported with $pkg.  Choose from: $(join(supported_attrs(pkg), ", "))"
            end
        end
    end
    return extra_kwargs
end

# _markershape_supported(pkg::AbstractBackend, shape::Symbol) = shape in supported_markers(pkg)
# _markershape_supported(pkg::AbstractBackend, shape::Shape) = Shape in supported_markers(pkg)
# _markershape_supported(pkg::AbstractBackend, shapes::AVec) = all([_markershape_supported(pkg, shape) for shape in shapes])

function warn_on_unsupported(pkg::AbstractBackend, plotattributes)
    get(plotattributes, :warn_on_unsupported, should_warn_on_unsupported(pkg)) || return
    is_seriestype_supported(pkg, plotattributes[:seriestype]) ||
        @warn "seriestype $(plotattributes[:seriestype]) is unsupported with $pkg. Choose from: $(supported_seriestypes(pkg))"
    is_style_supported(pkg, plotattributes[:linestyle]) ||
        @warn "linestyle $(plotattributes[:linestyle]) is unsupported with $pkg. Choose from: $(supported_styles(pkg))"
    return is_marker_supported(pkg, plotattributes[:markershape]) ||
        @warn "markershape $(plotattributes[:markershape]) is unsupported with $pkg. Choose from: $(supported_markers(pkg))"
end

function warn_on_unsupported_scales(pkg::AbstractBackend, plotattributes::AKW)
    get(plotattributes, :warn_on_unsupported, should_warn_on_unsupported(pkg)) || return
    for k in (:xscale, :yscale, :zscale, :scale)
        if haskey(plotattributes, k)
            v = plotattributes[k]
            if !all(is_scale_supported.(Ref(pkg), v))
                @warn """
                scale $v is unsupported with $pkg.
                Choose from: $(supported_scales(pkg))
                """
            end
        end
    end
    return
end

# -----------------------------------------------------------------------------

function convertLegendValue(val::Symbol)
    return if val in (:both, :all, :yes)
        :best
    elseif val in (:no, :none)
        :none
    elseif val in (
            :right,
            :left,
            :top,
            :bottom,
            :inside,
            :best,
            :legend,
            :topright,
            :topleft,
            :bottomleft,
            :bottomright,
            :outertopright,
            :outertopleft,
            :outertop,
            :outerright,
            :outerleft,
            :outerbottomright,
            :outerbottomleft,
            :outerbottom,
            :inline,
        )
        val
    elseif val === :horizontal
        -1
    else
        error("Invalid symbol for legend: $val")
    end
end
convertLegendValue(val::Real) = val
convertLegendValue(val::Bool) = val ? :best : :none
convertLegendValue(val::Nothing) = :none
convertLegendValue(v::Union{Tuple, NamedTuple}) = convertLegendValue.(v)
convertLegendValue(v::Tuple{<:Real, <:Real}) = v
convertLegendValue(v::Tuple{<:Real, Symbol}) = v
convertLegendValue(v::AbstractArray) = map(convertLegendValue, v)

# -----------------------------------------------------------------------------

"""Throw an error if the `levels` keyword argument is not of the correct type
or `levels` is less than 1"""
function check_contour_levels(levels)
    return if !(levels isa Union{Integer, AVec})
        "the levels keyword argument must be an integer or AbstractVector" |>
            ArgumentError |>
            throw
    elseif levels isa Integer && levels <= 0
        "must pass a positive number of contours to the levels keyword argument" |>
            ArgumentError |>
            throw
    end
end

# -----------------------------------------------------------------------------

# 1-row matrices will give an element
# multi-row matrices will give a column
# InputWrapper just gives the contents
# anything else is returned as-is
function slice_arg(v::AMat, idx::Int)
    isempty(v) && return v
    c = mod1(idx, size(v, 2))
    m, n = axes(v)
    return size(v, 1) == 1 ? v[first(m), n[c]] : v[:, n[c]]
end
slice_arg(wrapper::InputWrapper, idx) = wrapper.obj
slice_arg(v::NTuple{2, AMat}, idx::Int) = slice_arg(v[1], idx), slice_arg(v[2], idx)
slice_arg(v, idx) = v

# given an argument key `k`, extract the argument value for this index,
# and set into plotattributes[k]. Matrices are sliced by column.
# if nothing is set (or container is empty), return the existing value.
function slice_arg!(
        plotattributes_in,
        plotattributes_out,
        k::Symbol,
        idx::Int,
        remove_pair::Bool,
    )
    v = get(plotattributes_in, k, plotattributes_out[k])
    plotattributes_out[k] = if haskey(plotattributes_in, k) && k ∉ _plot_args
        slice_arg(v, idx)
    else
        v
    end
    remove_pair && RecipesPipeline.reset_kw!(plotattributes_in, k)
    return nothing
end

# -----------------------------------------------------------------------------

function color_or_nothing!(plotattributes, k::Symbol)
    plotattributes[k] = (v = plotattributes[k]) === :match ? v : plot_color(v)
    return nothing
end

# -----------------------------------------------------------------------------

# when a value can be `:match`, this is the key that should be used instead for value retrieval
const _match_map = Dict(
    :background_color_outside => :background_color,
    :legend_background_color => :background_color_subplot,
    :background_color_inside => :background_color_subplot,
    :legend_foreground_color => :foreground_color_subplot,
    :foreground_color_title => :foreground_color_subplot,
    :left_margin => :margin,
    :top_margin => :margin,
    :right_margin => :margin,
    :bottom_margin => :margin,
    :titlefontfamily => :fontfamily_subplot,
    :titlefontcolor => :foreground_color_subplot,
    :legend_font_family => :fontfamily_subplot,
    :legend_font_color => :foreground_color_subplot,
    :legend_title_font_family => :fontfamily_subplot,
    :legend_title_font_color => :foreground_color_subplot,
    :colorbar_fontfamily => :fontfamily_subplot,
    :colorbar_titlefontfamily => :fontfamily_subplot,
    :colorbar_titlefontcolor => :foreground_color_subplot,
    :colorbar_tickfontfamily => :fontfamily_subplot,
    :colorbar_tickfontcolor => :foreground_color_subplot,
    :plot_titlefontfamily => :fontfamily,
    :plot_titlefontcolor => :foreground_color,
    :tickfontcolor => :foreground_color_text,
    :guidefontcolor => :foreground_color_guide,
    :annotationfontfamily => :fontfamily_subplot,
    :annotationcolor => :foreground_color_subplot,
)

# these can match values from the parent container (axis --> subplot --> plot)
const _match_map2 = Dict(
    :background_color_subplot => :background_color,
    :foreground_color_subplot => :foreground_color,
    :foreground_color_axis => :foreground_color_subplot,
    :foreground_color_border => :foreground_color_subplot,
    :foreground_color_grid => :foreground_color_subplot,
    :foreground_color_minor_grid => :foreground_color_subplot,
    :foreground_color_guide => :foreground_color_subplot,
    :foreground_color_text => :foreground_color_subplot,
    :fontfamily_subplot => :fontfamily,
    :tickfontfamily => :fontfamily_subplot,
    :guidefontfamily => :fontfamily_subplot,
)

# properly retrieve from plt.attr, passing `:match` to the correct key
Base.getindex(plt::Plot, k::Symbol) =
if (v = plt.attr[k]) === :match
    plt[_match_map[k]]
else
    v
end

# properly retrieve from sp.attr, passing `:match` to the correct key
Base.getindex(sp::Subplot, k::Symbol) =
if (v = sp.attr[k]) === :match
    if haskey(_match_map2, k)
        sp.plt[_match_map2[k]]
    else
        sp[_match_map[k]]
    end
else
    v
end

# properly retrieve from axis.attr, passing `:match` to the correct key
Base.getindex(axis::Axis, k::Symbol) =
if (v = axis.plotattributes[k]) === :match
    if haskey(_match_map2, k)
        axis.sps[1][_match_map2[k]]
    else
        axis[_match_map[k]]
    end
else
    v
end

Base.getindex(series::Series, k::Symbol) = series.plotattributes[k]

Base.setindex!(plt::Plot, v, k::Symbol) = (plt.attr[k] = v)
Base.setindex!(sp::Subplot, v, k::Symbol) = (sp.attr[k] = v)
Base.setindex!(axis::Axis, v, k::Symbol) = (axis.plotattributes[k] = v)
Base.setindex!(series::Series, v, k::Symbol) = (series.plotattributes[k] = v)

Base.get(plt::Plot, k::Symbol, v) = get(plt.attr, k, v)
Base.get(sp::Subplot, k::Symbol, v) = get(sp.attr, k, v)
Base.get(axis::Axis, k::Symbol, v) = get(axis.plotattributes, k, v)
Base.get(series::Series, k::Symbol, v) = get(series.plotattributes, k, v)

# -----------------------------------------------------------------------------

function fg_color(plotattributes::AKW)
    fg = get(plotattributes, :foreground_color, :auto)
    return if fg === :auto
        bg = plot_color(get(plotattributes, :background_color, :white))
        fg = alpha(bg) > 0 && isdark(bg) ? colorant"white" : colorant"black"
    else
        plot_color(fg)
    end
end

# update attr from an input dictionary
function _update_plot_args(plt::Plot, plotattributes_in::AKW)
    for (k, v) in _plot_defaults
        slice_arg!(plotattributes_in, plt.attr, k, 1, true)
    end

    # handle colors
    plt[:background_color] = plot_color(plt.attr[:background_color])
    plt[:foreground_color] = fg_color(plt.attr)
    return color_or_nothing!(plt.attr, :background_color_outside)
end

# -----------------------------------------------------------------------------

function _update_subplot_periphery(sp::Subplot, anns::AVec)
    # extend annotations, and ensure we always have a (x,y,PlotText) tuple
    newanns = []
    for ann in vcat(anns, sp[:annotations])
        append!(newanns, process_annotation(sp, ann))
    end
    sp.attr[:annotations] = newanns

    # handle legend/colorbar
    sp.attr[:legend_position] = convertLegendValue(sp.attr[:legend_position])
    sp.attr[:colorbar] = convertLegendValue(sp.attr[:colorbar])
    if sp.attr[:colorbar] === :legend
        sp.attr[:colorbar] = sp.attr[:legend_position]
    end
    return nothing
end

function _update_subplot_colors(sp::Subplot)
    # background colors
    color_or_nothing!(sp.attr, :background_color_subplot)
    sp.attr[:color_palette] = get_color_palette(sp.attr[:color_palette], 30)
    color_or_nothing!(sp.attr, :legend_background_color)
    color_or_nothing!(sp.attr, :background_color_inside)

    # foreground colors
    color_or_nothing!(sp.attr, :foreground_color_subplot)
    color_or_nothing!(sp.attr, :legend_foreground_color)
    color_or_nothing!(sp.attr, :foreground_color_title)
    return nothing
end

_update_margins(sp::Subplot) =
    for sym in (:margin, :left_margin, :top_margin, :right_margin, :bottom_margin)
    if (margin = get(sp.attr, sym, nothing)) isa Tuple
        # transform e.g. (1, :mm) => 1 * Plots.mm
        sp.attr[sym] = margin[1] * getfield(@__MODULE__, margin[2])
    end
end

function _update_axis(
        plt::Plot,
        sp::Subplot,
        plotattributes_in::AKW,
        letter::Symbol,
        subplot_index::Int,
    )
    # get (maybe initialize) the axis
    axis = get_axis(sp, letter)

    _update_axis(axis, plotattributes_in, letter, subplot_index)

    # convert a bool into auto or nothing
    if isa(axis[:ticks], Bool)
        axis[:ticks] = axis[:ticks] ? :auto : nothing
    end

    _update_axis_colors(axis)
    _update_axis_links(plt, axis, letter)
    return nothing
end

function _update_axis(
        axis::Axis,
        plotattributes_in::AKW,
        letter::Symbol,
        subplot_index::Int,
    )
    # build the KW of arguments from the letter version (i.e. xticks --> ticks)
    kw = KW()
    for k in _all_axis_args
        # first get the args without the letter: `tickfont = font(10)`
        # note: we don't pop because we want this to apply to all axes! (delete after all have finished)
        if haskey(plotattributes_in, k)
            kw[k] = slice_arg(plotattributes_in[k], subplot_index)
        end

        # then get those args that were passed with a leading letter: `xlabel = "X"`
        lk = get_attr_symbol(letter, k)

        if haskey(plotattributes_in, lk)
            kw[k] = slice_arg(plotattributes_in[lk], subplot_index)
        end
    end

    # update the axis
    attr!(axis; kw...)
    return nothing
end

function _update_axis_colors(axis::Axis)
    # # update the axis colors
    color_or_nothing!(axis.plotattributes, :foreground_color_axis)
    color_or_nothing!(axis.plotattributes, :foreground_color_border)
    color_or_nothing!(axis.plotattributes, :foreground_color_guide)
    color_or_nothing!(axis.plotattributes, :foreground_color_text)
    color_or_nothing!(axis.plotattributes, :foreground_color_grid)
    color_or_nothing!(axis.plotattributes, :foreground_color_minor_grid)
    return nothing
end

function _update_axis_links(plt::Plot, axis::Axis, letter::Symbol)
    # handle linking here.  if we're passed a list of
    # other subplots to link to, link them together
    (link = axis[:link]) |> isempty && return
    for other_sp in link
        link_axes!(axis, get_axis(get_subplot(plt, other_sp), letter))
    end
    axis.plotattributes[:link] = []
    return nothing
end

# update a subplots args and axes
function _update_subplot_args(
        plt::Plot,
        sp::Subplot,
        plotattributes_in,
        subplot_index::Int,
        remove_pair::Bool,
    )
    anns = RecipesPipeline.pop_kw!(sp.attr, :annotations)

    # grab those args which apply to this subplot
    for k in keys(_subplot_defaults)
        slice_arg!(plotattributes_in, sp.attr, k, subplot_index, remove_pair)
    end

    _update_subplot_colors(sp)
    _update_margins(sp)
    colorbar_update_keys =
        (:clims, :colorbar, :seriestype, :marker_z, :line_z, :fill_z, :colorbar_entry)
    if any(haskey.(Ref(plotattributes_in), colorbar_update_keys))
        _update_subplot_colorbars(sp)
    end

    lims_warned = false
    for letter in (:x, :y, :z)
        _update_axis(plt, sp, plotattributes_in, letter, subplot_index)
        lk = get_attr_symbol(letter, :lims)

        # warn against using `Range` in x,y,z lims
        if !lims_warned &&
                haskey(plotattributes_in, lk) &&
                plotattributes_in[lk] isa AbstractRange
            @warn "lims should be a Tuple, not $(typeof(plotattributes_in[lk]))."
            lims_warned = true
        end
    end

    return _update_subplot_periphery(sp, anns)
end

# -----------------------------------------------------------------------------

has_black_border_for_default(st) = error(
    "The seriestype attribute only accepts Symbols, you passed the $(typeof(st)) $st.",
)
has_black_border_for_default(st::Function) =
    error("The seriestype attribute only accepts Symbols, you passed the function $st.")
has_black_border_for_default(st::Symbol) =
    like_histogram(st) || st in (:hexbin, :bar, :shape)

# converts a symbol or string into a Colorant or ColorGradient
# and assigns a color automatically
get_series_color(c, sp::Subplot, n::Int, seriestype) =
    if c === :auto
    like_surface(seriestype) ? cgrad() : _cycle(sp[:color_palette], n)
elseif isa(c, Int)
    _cycle(sp[:color_palette], c)
else
    c
end |> plot_color

get_series_color(c::AbstractArray, sp::Subplot, n::Int, seriestype) =
    map(x -> get_series_color(x, sp, n, seriestype), c)

ensure_gradient!(plotattributes::AKW, csym::Symbol, asym::Symbol) =
if plotattributes[csym] isa ColorPalette
    α = nothing
    plotattributes[asym] isa AbstractVector || (α = plotattributes[asym])
    plotattributes[csym] = cgrad(plotattributes[csym], categorical = true, alpha = α)
elseif !(plotattributes[csym] isa ColorGradient)
    plotattributes[csym] =
        typeof(plotattributes[asym]) <: AbstractVector ? cgrad() :
        cgrad(alpha = plotattributes[asym])
end

const DEFAULT_LINEWIDTH = Ref(1)

# get a good default linewidth... 0 for surface and heatmaps
_replace_linewidth(plotattributes::AKW) =
if plotattributes[:linewidth] === :auto
    plotattributes[:linewidth] =
        (get(plotattributes, :seriestype, :path) ∉ (:surface, :heatmap, :image)) *
        DEFAULT_LINEWIDTH[]
end

function _slice_series_args!(plotattributes::AKW, plt::Plot, sp::Subplot, commandIndex::Int)
    for k in keys(_series_defaults)
        haskey(plotattributes, k) &&
            slice_arg!(plotattributes, plotattributes, k, commandIndex, false)
    end
    return plotattributes
end

label_to_string(label::Bool, series_plotindex) =
    label ? label_to_string(:auto, series_plotindex) : ""
label_to_string(label::Nothing, series_plotindex) = ""
label_to_string(label::Missing, series_plotindex) = ""
label_to_string(label::Symbol, series_plotindex) =
if label === :auto
    string("y", series_plotindex)
elseif label === :none
    ""
else
    throw(ArgumentError("unsupported symbol $(label) passed to `label`"))
end
label_to_string(label, series_plotindex) = string(label)  # Fallback to string promotion

function _update_series_attributes!(plotattributes::AKW, plt::Plot, sp::Subplot)
    pkg = plt.backend
    globalIndex = plotattributes[:series_plotindex]
    plotIndex = _series_index(plotattributes, sp)

    aliasesAndAutopick(
        plotattributes,
        :linestyle,
        _styleAliases,
        supported_styles(pkg),
        plotIndex,
    )
    aliasesAndAutopick(
        plotattributes,
        :markershape,
        _markerAliases,
        supported_markers(pkg),
        plotIndex,
    )

    # update alphas
    for asym in (:linealpha, :markeralpha, :fillalpha)
        if plotattributes[asym] === nothing
            plotattributes[asym] = plotattributes[:seriesalpha]
        end
    end
    if plotattributes[:markerstrokealpha] === nothing
        plotattributes[:markerstrokealpha] = plotattributes[:markeralpha]
    end

    # update series color
    scolor = plotattributes[:seriescolor]
    stype = plotattributes[:seriestype]
    plotattributes[:seriescolor] = scolor = get_series_color(scolor, sp, plotIndex, stype)

    # update other colors (`linecolor`, `markercolor`, `fillcolor`) <- for grep
    for s in (:line, :marker, :fill)
        csym, asym = Symbol(s, :color), Symbol(s, :alpha)
        plotattributes[csym] = if plotattributes[csym] === :auto
            plot_color(
                if has_black_border_for_default(stype) && s === :line
                    sp[:foreground_color_subplot]
                else
                    scolor
                end
            )
        elseif plotattributes[csym] === :match
            plot_color(scolor)
        else
            get_series_color(plotattributes[csym], sp, plotIndex, stype)
        end
    end

    # update markerstrokecolor
    plotattributes[:markerstrokecolor] = if plotattributes[:markerstrokecolor] === :match
        plot_color(sp[:foreground_color_subplot])
    elseif plotattributes[:markerstrokecolor] === :auto
        get_series_color(plotattributes[:markercolor], sp, plotIndex, stype)
    else
        get_series_color(plotattributes[:markerstrokecolor], sp, plotIndex, stype)
    end

    # if marker_z, fill_z or line_z are set, ensure we have a gradient
    if plotattributes[:marker_z] !== nothing
        ensure_gradient!(plotattributes, :markercolor, :markeralpha)
    end
    if plotattributes[:line_z] !== nothing
        ensure_gradient!(plotattributes, :linecolor, :linealpha)
    end
    if plotattributes[:fill_z] !== nothing
        ensure_gradient!(plotattributes, :fillcolor, :fillalpha)
    end

    # scatter plots don't have a line, but must have a shape
    if plotattributes[:seriestype] in (:scatter, :scatterbins, :scatterhist, :scatter3d)
        plotattributes[:linewidth] = 0
        if plotattributes[:markershape] === :none
            plotattributes[:markershape] = :circle
        end
    end

    # set label
    plotattributes[:label] = label_to_string.(plotattributes[:label], globalIndex)

    _replace_linewidth(plotattributes)
    return plotattributes
end

_series_index(plotattributes, sp) =
if haskey(plotattributes, :series_index)
    plotattributes[:series_index]::Int
elseif get(plotattributes, :primary, true)
    plotattributes[:series_index] = sp.primary_series_count += 1
else
    plotattributes[:series_index] = sp.primary_series_count
end

#--------------------------------------------------
## inspired by Base.@kwdef
"""
    add_attributes(level, expr, match_table)

Takes a `struct` definition and recurses into its fields to create keywords by chaining the field names with the structs' name with underscore.
Also creates pluralized and non-underscore aliases for these keywords.
- `level` indicates which group of `plot`, `subplot`, `series`, etc. the keywords belong to.
- `expr` is the struct definition with default values like `Base.@kwdef`
- `match_table` is an expression of the form `:match = (symbols)`, with symbols whose default value should be `:match`
"""
macro add_attributes(level, expr, match_table)
    expr = macroexpand(__module__, expr) # to expand @static
    expr isa Expr && expr.head === :struct || error("Invalid usage of @add_attributes")
    if (T = expr.args[2]) isa Expr && T.head === :<:
        T = T.args[1]
    end

    key_dict = KW()
    _splitdef!(expr.args[3], key_dict)

    insert_block = Expr(:block)
    for (key, value) in key_dict
        # e.g. _series_defualts[key] = value
        exp_key = Symbol(lowercase(string(T)), "_", key)
        pl_key = makeplural(exp_key)
        if QuoteNode(exp_key) in match_table.args[2].args
            value = QuoteNode(:match)
        end
        field = QuoteNode(Symbol("_", level, "_defaults"))
        push!(
            insert_block.args,
            Expr(
                :(=),
                Expr(:ref, Expr(:call, getfield, Plots, field), QuoteNode(exp_key)),
                value,
            ),
            :(Plots.add_aliases($(QuoteNode(exp_key)), $(QuoteNode(pl_key)))),
            :(
                Plots.add_aliases(
                    $(QuoteNode(exp_key)),
                    $(QuoteNode(Plots.make_non_underscore(exp_key))),
                )
            ),
            :(
                Plots.add_aliases(
                    $(QuoteNode(exp_key)),
                    $(QuoteNode(Plots.make_non_underscore(pl_key))),
                )
            ),
        )
    end
    return quote
        $expr
        $insert_block
    end |> esc
end

function _splitdef!(blk, key_dict)
    for i in eachindex(blk.args)
        if (ei = blk.args[i]) isa Symbol
            #  var
            continue
        elseif ei isa Expr
            if ei.head === :(=)
                lhs = ei.args[1]
                if lhs isa Symbol
                    #  var = defexpr
                    var = lhs
                elseif lhs isa Expr && lhs.head === :(::) && lhs.args[1] isa Symbol
                    #  var::T = defexpr
                    var = lhs.args[1]
                    type = lhs.args[2]
                    if @isdefined type
                        for field in fieldnames(getproperty(Plots, type))
                            key_dict[Symbol(var, "_", field)] =
                                :(getfield($(ei.args[2]), $(QuoteNode(field))))
                        end
                    end
                else
                    # something else, e.g. inline inner constructor
                    #   F(...) = ...
                    continue
                end
                defexpr = ei.args[2]  # defexpr
                key_dict[var] = defexpr
                blk.args[i] = lhs
            elseif ei.head === :(::) && ei.args[1] isa Symbol
                # var::Typ
                var = ei.args[1]
                key_dict[var] = defexpr
            elseif ei.head === :block
                # can arise with use of @static inside type decl
                _kwdef!(ei, value_args, key_args)
            end
        end
    end
    return blk
end

const _attribute_defaults = Dict(
    :Series => _series_defaults,
    :Subplot => _subplot_defaults,
    :Plot => _plot_defaults,
    :Axis => _axis_defaults,
)

attrtypes() = join(keys(_attribute_defaults), ", ")
attributes(attrtype::Symbol) = sort(collect(keys(_attribute_defaults[attrtype])))

function lookup_aliases(attrtype::Symbol, attribute::Symbol)
    attribute = get(_keyAliases, attribute, attribute)
    attribute ∈ keys(_attribute_defaults[attrtype]) && return attribute
    error("There is no attribute named $attribute in $attrtype")
end

# NOTE: the following cannot be tested in CI (interactive)
# COV_EXCL_START
"""
    plotattr([attr])

Look up the properties of a Plots attribute, or specify an attribute type.
Options are $(attrtypes()).
Call `plotattr()` to search for an attribute via fuzzy finding.
The information is the same as that given on https://docs.juliaplots.org/latest/attributes/.
"""
function plotattr()
    if isijulia()
        @warn "Fuzzy finding of attributes is disabled in notebooks."
        return
    end
    attr = Symbol(JLFzf.inter_fzf(collect(Plots._all_args), "--read0", "--height=80%"))
    letter = ""
    attrtype = if attr ∈ _all_series_args
        "Series"
    elseif attr ∈ _all_subplot_args
        "Subplot"
    elseif attr ∈ _lettered_all_axis_args
        if attr ∉ _all_axis_args
            letters = collect(String(attr))
            letter = first(letters)
            attr = Symbol(join(letters[2:end]))
        end
        "Axis"
    elseif attr ∈ _all_plot_args
        "Plot"
    elseif attr ∈ _all_magic_args
        "Magic"
    else
        "Unknown"
    end

    d = default(attr)
    return print(
        """
        # $letter$attr

        - $attrtype attribute
        - Default: `$(d isa Symbol ? string(':', d) : d)`.
        - $(_argument_description(attr))
        """
    )
end
# COV_EXCL_STOP

function plotattr(attrtype::Symbol)
    attrtype ∈ keys(_attribute_defaults) || error("Viable options are $(attrtypes())")
    return println("Defined $attrtype attributes are:\n$(join(attributes(attrtype), ", "))")
end

function plotattr(attribute::AbstractString)
    attribute = Symbol(attribute)
    attribute = get(_keyAliases, attribute, attribute)
    for (k, v) in _attribute_defaults
        attribute ∈ keys(v) && return plotattr(k, attribute)
    end
    error("There is no attribute named $attribute")
end

function plotattr(attrtype::Symbol, attribute::Symbol)
    attrtype ∈ keys(_attribute_defaults) ||
        ArgumentError("`attrtype` must match one of $(attrtypes())")

    attribute = lookup_aliases(attrtype, attribute)
    type, desc = _arg_desc[attribute]
    def = _attribute_defaults[attrtype][attribute]
    aliases = if (al = Plots.aliases(attribute)) |> length > 0
        "Aliases: " * string(Tuple(al)) * ".\n\n"
    else
        ""
    end

    # Looks up the different elements and plots them
    return println(
        ":$attribute\n\n",
        "$desc\n\n",
        aliases,
        "Type: $type.\n\n",
        "`$attrtype` attribute",
        def == "" ? "" : ", defaults to `$def`.",
    )
end

module IJuliaExt

import Plots: @ext_imp_use, Plots, Plot
using Base64

const IJulia =
    Base.require(Base.PkgId(Base.UUID("7073ff75-c697-5162-941a-fcdaad2a7d2a"), "IJulia"))

function _init_ijulia_plotting()
    # IJulia is more stable with local file
    Plots._use_local_plotlyjs[] =
        Plots._plotly_local_file_path[] === nothing ? false :
        isfile(Plots._plotly_local_file_path[])

    return ENV["MPLBACKEND"] = "Agg"
end

"""
Add extra jupyter mimetypes to display_dict based on the plot backed.

The default is nothing, except for plotly based backends, where it
adds data for `application/vnd.plotly.v1+json` that is used in
frontends like jupyterlab and nteract.
"""
_ijulia__extra_mime_info!(plt::Plot, out::Dict) = out

function _ijulia__extra_mime_info!(plt::Plot{Plots.PlotlyJSBackend}, out::Dict)
    out["application/vnd.plotly.v1+json"] =
        Dict(:data => Plots.plotly_series(plt), :layout => Plots.plotly_layout(plt))
    return out
end

function _ijulia__extra_mime_info!(plt::Plot{Plots.PlotlyBackend}, out::Dict)
    out["application/vnd.plotly.v1+json"] =
        Dict(:data => Plots.plotly_series(plt), :layout => Plots.plotly_layout(plt))
    return out
end

function _ijulia_display_dict(plt::Plot)
    output_type = Symbol(plt.attr[:html_output_format])
    if output_type === :auto
        output_type =
            get(Plots._best_html_output_type, Plots.backend_name(plt.backend), :svg)
    end
    out = Dict()
    if output_type === :txt
        mime = "text/plain"
        out[mime] = sprint(show, MIME(mime), plt)
    elseif output_type === :png
        mime = "image/png"
        out[mime] = base64encode(show, MIME(mime), plt)
    elseif output_type === :svg
        mime = "image/svg+xml"
        out[mime] = sprint(show, MIME(mime), plt)
    elseif output_type === :html
        mime = "text/html"
        out[mime] = sprint(show, MIME(mime), plt)
        _ijulia__extra_mime_info!(plt, out)
    elseif output_type === :pdf
        mime = "application/pdf"
        out[mime] = base64encode(show, MIME(mime), plt)
    else
        error("Unsupported output type $output_type")
    end
    return out
end

if IJulia.inited
    _init_ijulia_plotting()
    IJulia.display_dict(plt::Plot) = _ijulia_display_dict(plt)
end

# IJulia only... inline display
function Plots.inline(plt::Plot = Plots.current())
    IJulia.clear_output(true)
    return display(IJulia.InlineDisplay(), plt)
end

end  # module

const Options = PGFPlotsX.Options
const Table = PGFPlotsX.Table

Base.@kwdef mutable struct PGFPlotsXPlot
    is_created::Bool = false
    was_shown::Bool = false
    the_plot::PGFPlotsX.TikzDocument = PGFPlotsX.TikzDocument()
    function PGFPlotsXPlot(is_created, was_shown, the_plot)
        pgfx_plot = new(is_created, was_shown, the_plot)
        # tikz libraries
        PGFPlotsX.push_preamble!(pgfx_plot.the_plot, "\\usetikzlibrary{arrows.meta}")
        PGFPlotsX.push_preamble!(pgfx_plot.the_plot, "\\usetikzlibrary{backgrounds}")
        # pgfplots libraries
        PGFPlotsX.push_preamble!(pgfx_plot.the_plot, "\\usepgfplotslibrary{patchplots}")
        PGFPlotsX.push_preamble!(pgfx_plot.the_plot, "\\usepgfplotslibrary{fillbetween}")
        # compatibility fixes
        # add background layer to standard layers
        PGFPlotsX.push_preamble!(
            pgfx_plot.the_plot,
            raw"""\pgfplotsset{%
                layers/standard/.define layer set={%
                    background,axis background,axis grid,axis ticks,axis lines,axis tick labels,pre main,main,axis descriptions,axis foreground%
                }{
                    grid style={/pgfplots/on layer=axis grid},%
                    tick style={/pgfplots/on layer=axis ticks},%
                    axis line style={/pgfplots/on layer=axis lines},%
                    label style={/pgfplots/on layer=axis descriptions},%
                    legend style={/pgfplots/on layer=axis descriptions},%
                    title style={/pgfplots/on layer=axis descriptions},%
                    colorbar style={/pgfplots/on layer=axis descriptions},%
                    ticklabel style={/pgfplots/on layer=axis tick labels},%
                    axis background@ style={/pgfplots/on layer=axis background},%
                    3d box foreground style={/pgfplots/on layer=axis foreground},%
                },
            }
            """,
        )
        pgfx_plot
    end
end

## end user utility functions

pgfx_axes(pgfx_plot::PGFPlotsXPlot) = pgfx_plot.the_plot.elements[1].elements

pgfx_preamble() = pgfx_preamble(current())
function pgfx_preamble(pgfx_plot::Plot{PGFPlotsXBackend})
    old_flag = pgfx_plot.attr[:tex_output_standalone]
    pgfx_plot.attr[:tex_output_standalone] = true
    fulltext = String(repr("application/x-tex", pgfx_plot))
    preamble = fulltext[1:(first(findfirst("\\begin{document}", fulltext)) - 1)]
    pgfx_plot.attr[:tex_output_standalone] = old_flag
    return preamble
end

function surface_to_vecs(x::AVec, y::AVec, s::Union{AMat, Surface})
    a = Array(s)
    xn = Vector{eltype(x)}(undef, length(a))
    yn = Vector{eltype(y)}(undef, length(a))
    zn = Vector{eltype(s)}(undef, length(a))
    for (n, (i, j)) in enumerate(Tuple.(CartesianIndices(a)))
        if length(x) == size(s, 1)
            i, j = j, i
        end
        xn[n] = x[j]
        yn[n] = y[i]
        zn[n] = a[i, j]
    end
    return xn, yn, zn
end
surface_to_vecs(x::AVec, y::AVec, z::AVec) = x, y, z

Base.push!(pgfx_plot::PGFPlotsXPlot, item) = push!(pgfx_plot.the_plot, item)

pgfx_split_extra_kw(extra) =
    (get(extra, :add, nothing), filter(x -> first(x) !== :add, extra))

curly(obj) = "{$(string(obj))}"

# anything other than `Function`, `:plain` or `:latex` should map to `:latex` formatter instead
latex_formatter(formatter::Symbol) = formatter in (:plain, :latex) ? formatter : :latex
latex_formatter(formatter::Function) = formatter

labelfunc(scale::Symbol, backend::PGFPlotsXBackend) = labelfunc_tex(scale)

pgfx_halign(k) = (left = "left", hcenter = "center", center = "center", right = "right")[k]

function (pgfx_plot::PGFPlotsXPlot)(plt::Plot{PGFPlotsXBackend})
    if !pgfx_plot.is_created || pgfx_plot.was_shown
        pgfx_sanitize_plot!(plt)
        # extract extra kwargs
        extra_plot, extra_plot_opt = pgfx_split_extra_kw(plt[:extra_plot_kwargs])
        the_plot = PGFPlotsX.TikzPicture(Options(extra_plot_opt...))
        extra_plot !== nothing && push!(the_plot, wraptuple(extra_plot)...)
        bgc = plt.attr[
            if plt.attr[:background_color_outside] === :match
                :background_color
            else
                :background_color_outside
            end,
        ]
        if bgc isa Colors.Colorant
            cstr = plot_color(bgc)
            push!(
                the_plot.options,
                "/tikz/background rectangle/.style" => Options(
                    # "draw" => "black",
                    "fill" => cstr,
                    "fill opacity" => alpha(cstr),
                    "draw opacity" => alpha(cstr),
                ),
                "show background rectangle" => nothing,
            )
        end

        for sp in plt.subplots
            bb2 = bbox(sp)
            dx, dy = bb2.x0
            sp_w, sp_h = width(bb2), height(bb2)
            if sp[:subplot_index] == plt[:plot_titleindex]
                x = dx + sp_w / 2 - 10mm  # FIXME: get rid of magic constant
                y = dy + sp_h / 2
                pgfx_add_annotation!(
                    the_plot,
                    (x, y),
                    PlotText(plt[:plot_title], plottitlefont(plt)),
                    pgfx_thickness_scaling(plt);
                    options = Options("anchor" => "center"),
                    cs = "",
                )
                continue
            end

            lpad = leftpad(sp) + sp[:left_margin]
            rpad = rightpad(sp) + sp[:right_margin]
            tpad = toppad(sp) + sp[:top_margin]
            bpad = bottompad(sp) + sp[:bottom_margin]
            dx += lpad
            dy += tpad
            title_cstr = plot_color(sp[:titlefontcolor])
            bgc_inside = plot_color(sp[:background_color_inside])
            update_clims(sp)
            axis_opt = Options(
                "point meta max" => get_clims(sp)[2],
                "point meta min" => get_clims(sp)[1],
                "legend cell align" => "left",
                "legend columns" => pgfx_legend_col(sp[:legend_column]),
                "title" => sp[:title],
                "title style" => Options(
                    pgfx_get_title_pos(sp[:titlelocation])...,
                    "font" => pgfx_font(sp[:titlefontsize], pgfx_thickness_scaling(sp)),
                    "color" => title_cstr,
                    "draw opacity" => alpha(title_cstr),
                    "rotate" => sp[:titlefontrotation],
                    "align" => pgfx_halign(sp[:titlefonthalign]),
                ),
                "legend style" => pgfx_get_legend_style(sp),
                "axis background/.style" =>
                    Options("fill" => bgc_inside, "opacity" => alpha(bgc_inside)),
                # these are for layouting
                "anchor" => "north west",
                "xshift" => string(dx),
                "yshift" => string(-dy),
            )
            sp_w > 0mm && push!(axis_opt, "width" => string(sp_w - (rpad + lpad)))
            sp_h > 0mm && push!(axis_opt, "height" => string(sp_h - (tpad + bpad)))
            for letter in (:x, :y, :z)
                if letter !== :z || RecipesPipeline.is3d(sp)
                    pgfx_axis!(axis_opt, sp, letter)
                end
            end
            # Search series for any gradient. In case one series uses a gradient set the colorbar and colomap.
            # The reasoning behind doing this on the axis level is that
            # pgfplots colorbar seems to only work on axis level and needs the proper colormap for correctly displaying it.
            # It's also possible to assign the colormap to the series itself but
            # then the colormap needs to be added twice, once for the axis and once for the series.
            # As it is likely that all series within the same axis use the same colormap this should not cause any problem.
            for series in series_list(sp)
                if hascolorbar(series)
                    cg = get_colorgradient(series)
                    cm = pgfx_colormap(cg)
                    PGFPlotsX.push_preamble!(
                        pgfx_plot.the_plot,
                        "\\pgfplotsset{\ncolormap={plots$(sp.attr[:subplot_index])}{$cm},\n}",
                    )
                    push!(axis_opt, "colormap name" => "plots$(sp.attr[:subplot_index])")
                    if cg isa PlotUtils.CategoricalColorGradient
                        push!(
                            axis_opt,
                            "colormap access" => "piecewise const",
                            "colorbar sampled" => nothing,
                        )
                    end
                    break
                end
            end

            if hascolorbar(sp)
                formatter = latex_formatter(sp[:colorbar_formatter])
                cticks = curly(join(get_colorbar_ticks(sp; formatter = formatter)[1], ','))
                letter = sp[:colorbar] === :top ? :x : :y

                colorbar_style = push!(
                    Options("$(letter)label" => sp[:colorbar_title]),
                    "$(letter)label style" => pgfx_get_colorbar_title_style(sp),
                    "$(letter)tick" => cticks,
                    "$(letter)ticklabel style" => pgfx_get_colorbar_ticklabel_style(sp),
                )

                if sp[:colorbar] === :top
                    push!(
                        colorbar_style,
                        "at" => "(0.5, 1.05)",
                        "anchor" => "south",
                        "xticklabel pos" => "upper",
                    )
                end

                if !_has_ticks(sp[:colorbar_ticks])
                    push!(
                        colorbar_style,
                        "$(letter)tick style" => "{draw=none}",
                        "$(letter)ticklabels" => "{,,}",
                    )
                end

                push!(
                    axis_opt,
                    "colorbar $(pgfx_get_colorbar_pos(sp[:colorbar]))" => nothing,
                    "colorbar style" => colorbar_style,
                )
            else
                push!(axis_opt, "colorbar" => "false")
            end
            if RecipesPipeline.is3d(sp)
                if (ar = sp[:aspect_ratio]) !== :auto
                    push!(
                        axis_opt,
                        "unit vector ratio" => ar === :equal ? 1 : join(ar, ' '),
                    )
                end
                push!(axis_opt, "view" => tuple(sp[:camera]))
            end
            axisf = if sp[:projection] === :polar
                # push!(axis_opt, "xmin" => 90)
                # push!(axis_opt, "xmax" => 450)
                PGFPlotsX.PolarAxis
            else
                PGFPlotsX.Axis
            end
            extra_sp, extra_sp_opt = pgfx_split_extra_kw(sp[:extra_kwargs])
            axis = axisf(merge(axis_opt, Options(extra_sp_opt...)))
            extra_sp !== nothing && push!(axis, wraptuple(extra_sp)...)
            if sp[:legend_title] !== nothing
                legtfont = legendtitlefont(sp)
                leg_opt = Options(
                    "font" => pgfx_font(legtfont.pointsize, pgfx_thickness_scaling(sp)),
                    "text" => legtfont.color,
                )
                push!(
                    axis,
                    Options("\\addlegendimage{empty legend}" => nothing),
                    PGFPlotsX.LegendEntry(
                        leg_opt,
                        "\\hspace{-.6cm}{\\textbf{$(sp[:legend_title])}}",
                        false,
                    ),
                )
            end
            for (series_index, series) in enumerate(series_list(sp))
                # give each series an id for fillbetween
                series_id = maximum(values(_pgfplotsx_series_ids), init = 0) + 1
                _pgfplotsx_series_ids[Symbol("$series_index")] = series_id
                opt = series.plotattributes
                st = series[:seriestype]
                extra_series, extra_series_opt = pgfx_split_extra_kw(series[:extra_kwargs])
                series_opt = Options(
                    "color" => single_color(opt[:linecolor]),
                    "name path" => string(series_id),
                )
                series_func =
                if (
                        RecipesPipeline.is3d(series) ||
                            st in (:heatmap, :contour) ||
                            (st === :quiver && opt[:z] !== nothing)
                    )
                    PGFPlotsX.Plot3
                else
                    PGFPlotsX.Plot
                end
                if (
                        series[:fillrange] !== nothing &&
                            series[:ribbon] === nothing &&
                            !isfilledcontour(series)
                    )
                    push!(series_opt, "area legend" => nothing)
                end
                pgfx_add_series!(Val(st), axis, series_opt, series, series_func, opt)
                last_plot =
                    axis.contents[end] isa PGFPlotsX.LegendEntry ? axis.contents[end - 1] :
                    axis.contents[end]
                merge!(last_plot.options, Options(extra_series_opt...))
                if extra_series !== nothing
                    push!(axis.contents[end], wraptuple(extra_series)...)
                end
                # add series annotations
                anns = series[:series_annotations]
                for (xi, yi, str, fnt) in EachAnn(anns, series[:x], series[:y])
                    pgfx_add_annotation!(
                        axis,
                        (xi, yi),
                        PlotText(str, fnt),
                        pgfx_thickness_scaling(series),
                    )
                end
            end  # for series
            # add subplot annotations
            for ann in sp[:annotations]
                # [1:end-1] -> coordinates, [end] is string
                loc_val = locate_annotation(sp, ann...)
                pgfx_add_annotation!(
                    axis,
                    loc_val[1:(end - 1)],
                    loc_val[end],
                    pgfx_thickness_scaling(sp),
                )
            end
            push!(the_plot, axis)
            if length(plt.o.the_plot.elements) > 0
                plt.o.the_plot.elements[1] = the_plot
            else
                push!(plt.o, the_plot)
            end
        end  # for subplots
        pgfx_plot.is_created = true
        pgfx_plot.was_shown = false
    end
    return pgfx_plot
end

## seriestype specifics
function pgfx_add_series!(axis, series_opt, series, series_func, opt)
    series_opt = series_func(series_opt, Table(pgfx_series_arguments(series, opt)...))
    return pgfx_add_legend!(push!(axis, series_opt), series, opt)
end

function pgfx_add_series!(::Val{:path}, axis, series_opt, series, series_func, opt)
    # treat segments
    segments = collect(series_segments(series, series[:seriestype]; check = true))
    for (k, segment) in enumerate(segments)
        i, rng = segment.attr_index, segment.range
        segment_opt = pgfx_linestyle(opt, i)
        if opt[:markershape] !== :none
            if (marker = _cycle(opt[:markershape], i)) isa Shape
                scale_factor = 0.00125
                msize = opt[:markersize] * scale_factor
                path = join(
                    map((x, y) -> "($(x * msize), $(y * msize))", marker.x, marker.y),
                    " -- ",
                )
                PGFPlotsX.push_preamble!(
                    series[:plot_object].o.the_plot,
                    """
                    \\pgfdeclareplotmark{PlotsShape$(series[:series_plotindex])}{
                    \\filldraw
                    $path;
                    }
                    """,
                )
            end
            segment_opt = merge(segment_opt, pgfx_marker(opt, i))
        end
        # add fillrange
        if (sf = opt[:fillrange]) !== nothing && !isfilledcontour(series)
            if sf isa Number || sf isa AVec
                pgfx_fillrange_series!(axis, series, series_func, i, _cycle(sf, rng), rng)
            elseif sf isa Tuple && series[:ribbon] !== nothing
                for sfi in sf
                    pgfx_fillrange_series!(
                        axis,
                        series,
                        series_func,
                        i,
                        _cycle(sfi, rng),
                        rng,
                    )
                end
            end
            if (
                    i == 1 &&
                        series[:subplot][:legend_position] !== :none &&
                        pgfx_should_add_to_legend(series)
                )
                pgfx_filllegend!(series_opt, opt)
            end
        end
        # handle arrows
        coordinates = if (arrow = opt[:arrow]) isa Arrow
            arrow_opt = merge(
                segment_opt,
                Options(
                    "quiver" => Options(
                        "u" => "\\thisrow{u}",
                        "v" => "\\thisrow{v}",
                        pgfx_arrow(arrow, :head) => nothing,
                    ),
                ),
            )
            isempty(opt[:label]) && push!(arrow_opt, "forget plot" => nothing)
            rx, ry = opt[:x][rng], opt[:y][rng]
            nx, ny = length(rx), length(ry)
            x_arrow, y_arrow, x_path, y_path = if arrow.side === :head
                rx[(nx - 1):nx], ry[(ny - 1):ny], rx[1:(nx - 1)], ry[1:(ny - 1)]
            elseif arrow.side === :tail
                rx[2:-1:1], ry[2:-1:1], rx[2:nx], ry[2:ny]
            elseif arrow.side === :both
                rx[[2, 1, nx - 1, nx]], ry[[2, 1, ny - 1, ny]], rx[2:(nx - 1)], ry[2:(ny - 1)]
            end
            coords = Table(
                [
                    :x => x_arrow[1:2:(end - 1)],
                    :y => y_arrow[1:2:(end - 1)],
                    :u => [x_arrow[i] - x_arrow[i - 1] for i in 2:2:lastindex(x_arrow)],
                    :v => [y_arrow[i] - y_arrow[i - 1] for i in 2:2:lastindex(y_arrow)],
                ]
            )
            arrow_plot = series_func(merge(series_opt, arrow_opt), coords)
            push!(series_opt, "forget plot" => nothing)
            push!(axis, arrow_plot)
            Table(x_path, y_path)
        else
            Table(pgfx_series_arguments(series, opt, rng)...)
        end
        push!(axis, series_func(merge(series_opt, segment_opt), coordinates))
        # fill between functions
        if sf isa Tuple && series[:ribbon] === nothing
            sf1, sf2 = sf
            @assert sf1 == series_index "First index of the tuple has to match the current series index."
            push!(
                axis,
                series_func(
                    merge(
                        pgfx_fillstyle(opt, series_index),
                        Options("forget plot" => nothing),
                    ),
                    "fill between [of=$series_id and $(_pgfplotsx_series_ids[Symbol(string(sf2))])]",
                ),
            )
        end
        pgfx_add_legend!(axis, series, opt, k)
    end  # for segments

    # get that last marker
    if !isnothing(opt[:y]) && !any(isnan, opt[:y]) && opt[:markershape] isa AVec
        push!(
            axis,
            PGFPlotsX.PlotInc(  # additional plot
                pgfx_marker(opt, length(segments) + 1),
                PGFPlotsX.Coordinates(tuple((last(opt[:x]), last(opt[:y])))),
            ),
        )
    end
    return nothing
end

pgfx_add_series!(::Val{:straightline}, args...) = pgfx_add_series!(Val(:path), args...)
pgfx_add_series!(::Val{:path3d}, args...) = pgfx_add_series!(Val(:path), args...)

function pgfx_add_series!(::Val{:scatter}, axis, series_opt, args...)
    push!(series_opt, "only marks" => nothing)
    return pgfx_add_series!(Val(:path), axis, series_opt, args...)
end

function pgfx_add_series!(::Val{:scatter3d}, axis, series_opt, args...)
    push!(series_opt, "only marks" => nothing)
    return pgfx_add_series!(Val(:path), axis, series_opt, args...)
end

function pgfx_add_series!(::Val{:surface}, axis, series_opt, series, series_func, opt)
    push!(
        series_opt,
        "surf" => nothing,
        "mesh/rows" => length(unique(opt[:x])), # unique if its all vectors
        "mesh/cols" => length(unique(opt[:y])),
        "z buffer" => "sort",
        "opacity" => something(get_fillalpha(series), 1.0),
    )
    return pgfx_add_series!(axis, series_opt, series, series_func, opt)
end

function pgfx_add_series!(::Val{:wireframe}, axis, series_opt, series, series_func, opt)
    push!(series_opt, "mesh" => nothing, "mesh/rows" => length(opt[:x]))
    return pgfx_add_series!(axis, series_opt, series, series_func, opt)
end

function pgfx_add_series!(::Val{:heatmap}, axis, series_opt, series, series_func, opt)
    push!(axis.options, "view" => "{0}{90}")
    push!(
        series_opt,
        "matrix plot*" => nothing,
        "mesh/rows" => length(opt[:x]),
        "mesh/cols" => length(opt[:y]),
        "point meta" => "\\thisrow{meta}",
        "opacity" => something(get_fillalpha(series), 1.0),
    )
    args = pgfx_series_arguments(series, opt)
    meta = map(r -> any(!isfinite, r) ? NaN : r[3], zip(args...))
    for arg in args
        arg[(!isfinite).(arg)] .= 0
    end
    table = Table(
        [
            "x" => ispolar(series) ? rad2deg.(args[1]) : args[1],
            "y" => args[2],
            "z" => args[3],
            "meta" => meta,
        ]
    )
    push!(axis, series_func(series_opt, table))
    return pgfx_add_legend!(axis, series, opt)
end

function pgfx_add_series!(::Val{:mesh3d}, axis, series_opt, series, series_func, opt)
    ptable = if (cns = opt[:connections]) isa Tuple{Array, Array, Array}  # 0-based indexing
        map((i, j, k) -> "$i $j $k\\\\", cns...)
    elseif typeof(cns) <: AVec{NTuple{3, Int}}  # 1-based indexing
        map(c -> "$(c[1] - 1) $(c[2] - 1) $(c[3] - 1)\\\\", cns)
    else
        """
        Argument connections has to be either a tuple of three arrays (0-based indexing)
        or an AbstractVector{NTuple{3,Int}} (1-based indexing).
        """ |>
            ArgumentError |>
            throw
    end
    push!(
        series_opt,
        "patch" => nothing,
        "table/row sep" => "\\\\",
        "patch table" => join(ptable, "\n        "),
        "fill" => opt[:fillcolor],
        "faceted color" => opt[:linecolor],
        "opacity" => something(get_fillalpha(series), 1.0),
        "draw opacity" => something(get_linealpha(series), 1.0),
    )
    return pgfx_add_series!(axis, series_opt, series, series_func, opt)
end

function pgfx_add_series!(::Val{:contour}, axis, series_opt, series, series_func, opt)
    push!(axis.options, "view" => "{0}{90}")
    if isfilledcontour(series)
        pgfx_add_series!(Val(:filledcontour), axis, series_opt, series, series_func, opt)
        return nothing
    end
    return pgfx_add_series!(Val(:contour3d), axis, series_opt, series, series_func, opt)
end

function pgfx_add_series!(::Val{:filledcontour}, axis, series_opt, series, series_func, opt)
    push!(
        series_opt,
        "contour filled" => Options(), # labels not supported
        "patch type" => "bilinear",
        "shader" => "flat",
    )
    if (levels = opt[:levels]) isa Number
        push!(series_opt["contour filled"], "number" => levels)
    elseif levels isa AVec
        push!(series_opt["contour filled"], "levels" => levels)
    end
    return pgfx_add_series!(axis, series_opt, series, series_func, opt)
end

function pgfx_add_series!(::Val{:contour3d}, axis, series_opt, series, series_func, opt)
    push!(series_opt, "contour prepared" => Options("labels" => opt[:contour_labels]))
    push!(
        axis,
        series_func(
            merge(series_opt, pgfx_linestyle(opt)),
            Table(Contour.contours(pgfx_series_arguments(series, opt)..., opt[:levels])),
        ),
    )
    return pgfx_add_legend!(axis, series, opt)
end

function pgfx_add_series!(::Val{:quiver}, axis, series_opt, series, series_func, opt)
    if (quiver = opt[:quiver]) !== nothing
        push!(
            series_opt,
            "quiver" => Options(
                "u" => "\\thisrow{u}",
                "v" => "\\thisrow{v}",
                pgfx_arrow(opt[:arrow]) => nothing,
            ),
        )
        x, y, z = opt[:x], opt[:y], opt[:z]
        table = if z !== nothing
            push!(series_opt["quiver"], "w" => "\\thisrow{w}")
            pgfx_axis!(axis.options, series[:subplot], :z)
            [:x => x, :y => y, :z => z, :u => quiver[1], :v => quiver[2], :w => quiver[3]]
        else
            [:x => x, :y => y, :u => quiver[1], :v => quiver[2]]
        end
        pgfx_add_legend!(push!(axis, series_func(series_opt, Table(table))), series, opt)
    end
    return nothing
end

function pgfx_add_series!(::Val{:shape}, axis, series_opt, series, series_func, opt)
    series_opt = merge(push!(series_opt, "area legend" => nothing), pgfx_fillstyle(opt))
    return pgfx_add_series!(Val(:path), axis, series_opt, series, series_func, opt)
end

function pgfx_add_series!(::Val{:steppre}, axis, series_opt, args...)
    push!(series_opt, "const plot mark right" => nothing)
    return pgfx_add_series!(Val(:path), axis, series_opt, args...)
end

function pgfx_add_series!(::Val{:stepmid}, axis, series_opt, args...)
    push!(series_opt, "const plot mark mid" => nothing)
    return pgfx_add_series!(Val(:path), axis, series_opt, args...)
end

function pgfx_add_series!(::Val{:steppost}, axis, series_opt, args...)
    push!(series_opt, "const plot" => nothing)
    return pgfx_add_series!(Val(:path), axis, series_opt, args...)
end

function pgfx_add_series!(::Val{:ysticks}, axis, series_opt, args...)
    push!(series_opt, "const plot" => nothing)
    return pgfx_add_series!(Val(:path), axis, series_opt, args...)
end

function pgfx_add_series!(::Val{:xsticks}, axis, series_opt, args...)
    push!(series_opt, "const plot" => nothing)
    return pgfx_add_series!(Val(:path), axis, series_opt, args...)
end

function pgfx_add_legend!(axis, series, opt, i = 1)
    if series[:subplot][:legend_position] !== :none
        leg_entry = if (lab = opt[:label]) isa AVec
            get(lab, i, "")
        elseif lab isa AbstractString
            i == 1 ? lab : ""
        else
            throw(ArgumentError("Malformed label `$lab`"))
        end
        if isempty(leg_entry) || !pgfx_should_add_to_legend(series)
            push!(axis.contents[end].options, "forget plot" => nothing)
        else
            push!(axis, PGFPlotsX.LegendEntry(Options(), leg_entry, false))
        end
    end
    return nothing
end

pgfx_series_arguments(series, opt, range) =
    map(a -> a[range], pgfx_series_arguments(series, opt))
pgfx_series_arguments(series, opt) =
if (st = series[:seriestype]) in (:contour, :contour3d)
    opt[:x], opt[:y], handle_surface(opt[:z])
elseif st in (:heatmap, :surface, :wireframe)
    surface_to_vecs(opt[:x], opt[:y], opt[:z])
elseif RecipesPipeline.is3d(st)
    opt[:x], opt[:y], opt[:z]
elseif st === :straightline
    straightline_data(series)
elseif st === :shape
    shape_data(series)
elseif ispolar(series)
    theta, r = opt[:x], opt[:y]
    rad2deg.(theta), r
else
    opt[:x], opt[:y]
end

pgfx_get_linestyle(k::AbstractString) = pgfx_get_linestyle(Symbol(k))
pgfx_get_linestyle(k::Symbol) = get(
    (
        solid = "solid",
        dash = "dashed",
        dot = "dotted",
        dashdot = "dashdotted",
        dashdotdot = "dashdotdotted",
    ),
    k,
    "solid",
)

pgfx_get_marker(k::AbstractString) = pgfx_get_marker(Symbol(k))
pgfx_get_marker(k::Symbol) = get(
    (
        none = "none",
        cross = "+",
        xcross = "x",
        (+) = "+",
        x = "x",
        utriangle = "triangle*",
        dtriangle = "triangle*",
        rtriangle = "triangle*",
        ltriangle = "triangle*",
        circle = "*",
        rect = "square*",
        star5 = "star",
        star6 = "asterisk",
        diamond = "diamond*",
        pentagon = "pentagon*",
        hline = "-",
        vline = "|",
    ),
    k,
    "*",
)

pgfx_get_xguide_pos(k::AbstractString) = pgfx_get_xguide_pos(Symbol(k))
pgfx_get_xguide_pos(k::Symbol) = get(
    (
        top = "at={(0.5,1)},above,",
        right = "at={(ticklabel* cs:1.02)}, anchor=west,",
        left = "at={(ticklabel* cs:-0.02)}, anchor=east,",
    ),
    k,
    "at={(ticklabel cs:0.5)}, anchor=near ticklabel",
)

pgfx_get_yguide_pos(k::AbstractString) = pgfx_get_yguide_pos(Symbol(k))
pgfx_get_yguide_pos(k::Symbol) = get(
    (
        top = "at={(ticklabel* cs:1.02)}, anchor=south",
        right = "at={(1,0.5)},below,",
        bottom = "at={(ticklabel* cs:-0.02)}, anchor=north,",
    ),
    k,
    "at={(ticklabel cs:0.5)}, anchor=near ticklabel",
)

pgfx_get_legend_pos(k::AbstractString) = pgfx_get_legend_pos(Symbol(k))
pgfx_get_legend_pos(t::Tuple{<:Real, <:Real}) = ("at" => curly(t), "anchor" => "north west")
pgfx_get_legend_pos(nt::NamedTuple) = ("at" => curly(nt.at), "anchor" => string(nt.anchor))
pgfx_get_legend_pos(theta::Real) = pgfx_get_legend_pos((theta, :inner))
pgfx_get_legend_pos(k::Symbol) = get(
    (
        top = ("at" => "(0.5, 0.98)", "anchor" => "north"),
        bottom = ("at" => "(0.5, 0.02)", "anchor" => "south"),
        left = ("at" => "(0.02, 0.5)", "anchor" => "west"),
        right = ("at" => "(0.98, 0.5)", "anchor" => "east"),
        bottomleft = ("at" => "(0.02, 0.02)", "anchor" => "south west"),
        bottomright = ("at" => "(0.98, 0.02)", "anchor" => "south east"),
        topright = ("at" => "(0.98, 0.98)", "anchor" => "north east"),
        topleft = ("at" => "(0.02, 0.98)", "anchor" => "north west"),
        outertop = ("at" => "(0.5, 1.02)", "anchor" => "south"),
        outerbottom = ("at" => "(0.5, -0.02)", "anchor" => "north"),
        outerleft = ("at" => "(-0.02, 0.5)", "anchor" => "east"),
        outerright = ("at" => "(1.02, 0.5)", "anchor" => "west"),
        outerbottomleft = ("at" => "(-0.02, -0.02)", "anchor" => "north east"),
        outerbottomright = ("at" => "(1.02, -0.02)", "anchor" => "north west"),
        outertopright = ("at" => "(1.02, 1)", "anchor" => "north west"),
        outertopleft = ("at" => "(-0.02, 1)", "anchor" => "north east"),
    ),
    k,
    ("at" => "(1.02, 1)", "anchor" => "north west"),
)
function pgfx_get_legend_pos(v::Tuple{<:Real, Symbol})
    s, c = sincosd(first(v))
    anchors = [
        "south west" "south" "south east"
        "west" "center" "east"
        "north west" "north" "north east"
    ]
    I = legend_anchor_index(s)
    rect, anchor = if v[2] === :inner
        (0.07, 0.5, 1.0, 0.07, 0.52, 1.0), anchors[I, I]
    else
        (-0.15, 0.5, 1.05, -0.15, 0.52, 1.1), anchors[4 - I, 4 - I]
    end
    return "at" => string(legend_pos_from_angle(v[1], rect...)), "anchor" => anchor
end

function pgfx_get_legend_style(sp)
    cstr = plot_color(sp[:legend_background_color])
    return merge(
        pgfx_linestyle(
            pgfx_thickness_scaling(sp),
            sp[:legend_foreground_color],
            alpha(plot_color(sp[:legend_foreground_color])),
            "solid",
        ),
        Options(
            "fill" => cstr,
            "fill opacity" => alpha(cstr),
            "text opacity" => alpha(plot_color(sp[:legend_font_color])),
            "font" => pgfx_font(sp[:legend_font_pointsize], pgfx_thickness_scaling(sp)),
            "text" => plot_color(sp[:legend_font_color]),
            "cells" => Options(
                "anchor" => get(
                    (left = "west", right = "east", hcenter = "center"),
                    legendfont(sp).halign,
                    "west",
                ),
            ),
            pgfx_get_legend_pos(sp[:legend_position])...,
        ),
    )
end

pgfx_get_colorbar_pos(k::AbstractString) = pgfx_get_colorbar_pos(Symbol(k))
pgfx_get_colorbar_pos(b::Bool) = ""
pgfx_get_colorbar_pos(s::Symbol) =
    get((left = " left", bottom = " horizontal", top = " horizontal"), s, "")

pgfx_get_title_pos(k::AbstractString) = pgfx_get_title_pos(Symbol(k))
pgfx_get_title_pos(t::Tuple) = ("at" => curly(t), "anchor" => "south")
pgfx_get_title_pos(nt::NamedTuple) = ("at" => curly(nt.at), "anchor" => string(nt.anchor))
pgfx_get_title_pos(s::Symbol) = get(
    (
        left = ("at" => "{(0,1)}", "anchor" => "south west"),
        right = ("at" => "{(1,1)}", "anchor" => "south east"),
    ),
    s,
    ("at" => "{(0.5,1)}", "anchor" => "south"),
)

function pgfx_get_ticklabel_style(sp, axis)
    cstr = plot_color(axis[:tickfontcolor])
    opt = Options(
        "font" => pgfx_font(axis[:tickfontsize], pgfx_thickness_scaling(sp)),
        "color" => cstr,
        "draw opacity" => alpha(cstr),
        "rotate" => axis[:tickfontrotation],
    )
    # aligning rotated tick labels to ticks
    if RecipesPipeline.is3d(sp)
        if axis === sp[:xaxis]
            push!(opt, "anchor" => axis[:rotation] < 60 ? "north east" : "east")
        elseif axis === sp[:yaxis]
            push!(opt, "anchor" => axis[:rotation] < 45 ? "north west" : "north east")
        else
            push!(
                opt,
                "anchor" =>
                    axis[:rotation] == 0 ? "east" :
                    axis[:rotation] < 90 ? "south east" : "south",
            )
        end
    else
        if mod(axis[:rotation], 90) > 0 # 0 and ±90 already look good with the default anchor
            push!(opt, "anchor" => axis === sp[:xaxis] ? "north east" : "south east")
        end
    end
    return opt
end

function pgfx_get_colorbar_ticklabel_style(sp)
    cstr = plot_color(sp[:colorbar_tickfontcolor])
    return Options(
        "font" => pgfx_font(sp[:colorbar_tickfontsize], pgfx_thickness_scaling(sp)),
        "color" => cstr,
        "draw opacity" => alpha(cstr),
        "rotate" => sp[:colorbar_tickfontrotation],
    )
end
function pgfx_get_colorbar_title_style(sp)
    cstr = plot_color(sp[:colorbar_titlefontcolor])
    return Options(
        "font" => pgfx_font(sp[:colorbar_titlefontsize], pgfx_thickness_scaling(sp)),
        "color" => cstr,
        "draw opacity" => alpha(cstr),
        "rotate" => sp[:colorbar_titlefontrotation],
    )
end

## --------------------------------------------------------------------------------------
pgfx_arrow(::Nothing) = "every arrow/.append style={-}"
function pgfx_arrow(arr::Arrow, side = arr.side)
    components = ""
    arrow_head = "{Stealth[length = $(arr.headlength)pt, width = $(arr.headwidth)pt"
    arr.style === :open && (arrow_head *= ", open")
    arrow_head *= "]}"
    (side === :both || side === :tail) && (components *= arrow_head)
    components *= "-"
    (side === :both || side === :head) && (components *= arrow_head)
    return "every arrow/.append style={$components}"
end

function pgfx_filllegend!(series_opt, opt)
    style = strip(sprint(PGFPlotsX.print_tex, pgfx_fillstyle(opt)), ['[', ']', ' '])
    return push!(
        series_opt,
        "legend image code/.code" => "{\n\\draw[$style] (0cm,-0.1cm) rectangle (0.6cm,0.1cm);\n}",
    )
end

# Generates a colormap for pgfplots based on a ColorGradient
pgfx_colormap(cl::PlotUtils.AbstractColorList) = pgfx_colormap(color_list(cl))
pgfx_colormap(v::Vector{<:Colorant}) =
    join(map(c -> @sprintf("rgb=(%.8f,%.8f,%.8f)", red(c), green(c), blue(c)), v), '\n')
pgfx_colormap(cg::ColorGradient) = join(
    map(1:length(cg)) do i
        @sprintf(
            "rgb(%.8f)=(%.8f,%.8f,%.8f)",
            cg.values[i],
            red(cg.colors[i]),
            green(cg.colors[i]),
            blue(cg.colors[i])
        )
    end,
    '\n',
)

pgfx_framestyle(style::Symbol) =
if style in (:box, :axes, :origin, :zerolines, :grid, :none)
    style
else
    default_style = style === :semi ? :box : :axes
    @warn "Framestyle :$style is not (yet) supported by the PGFPlotsX backend. :$default_style was chosen instead."
    default_style
end

pgfx_thickness_scaling(plt::Plot) = plt[:thickness_scaling]
pgfx_thickness_scaling(sp::Subplot) = pgfx_thickness_scaling(sp.plt)
pgfx_thickness_scaling(series) = pgfx_thickness_scaling(series[:subplot])

function pgfx_fillstyle(plotattributes, i = 1)
    if (a = get_fillalpha(plotattributes, i)) === nothing
        a = alpha(single_color(get_fillcolor(plotattributes, i)))
    end
    return Options("fill" => get_fillcolor(plotattributes, i), "fill opacity" => a)
end

function pgfx_linestyle(linewidth::Real, color, α = 1, linestyle = :solid)
    cstr = plot_color(color, α)
    return Options(
        "color" => cstr,
        "draw opacity" => alpha(cstr),
        "line width" => linewidth,
        pgfx_get_linestyle(linestyle) => nothing,
    )
end

pgfx_legend_col(s::Symbol) = s === :horizontal ? -1 : 1
pgfx_legend_col(n) = n

function pgfx_linestyle(plotattributes, i = 1)
    lw = pgfx_thickness_scaling(plotattributes) * get_linewidth(plotattributes, i)
    lc = single_color(get_linecolor(plotattributes, i))
    la = get_linealpha(plotattributes, i)
    ls = get_linestyle(plotattributes, i)
    return pgfx_linestyle(lw, lc, la, ls)
end

function pgfx_font(fontsize, thickness_scaling = 1, font = "\\selectfont")
    fs = fontsize * thickness_scaling
    return "{\\fontsize{$fs pt}{$(1.3fs) pt}$font}"
end

# If a particular fontsize parameter is `nothing`, produce a figure that doesn't specify the
# font size, and therefore uses whatever fontsize is utilised by the doc in which the
# figure is located.
pgfx_font(fontsize::Nothing, thickness_scaling = 1, font = "\\selectfont") = curly(font)

pgfx_should_add_to_legend(series::Series) =
    series.plotattributes[:primary] &&
    series.plotattributes[:seriestype] ∉ (
    :hexbin,
    :bins2d,
    :histogram2d,
    :hline,
    :vline,
    :contour,
    :contourf,
    :contour3d,
    :heatmap,
    :image,
)

function pgfx_marker(plotattributes, i = 1)
    shape = _cycle(plotattributes[:markershape], i)
    cstr =
        plot_color(get_markercolor(plotattributes, i), get_markeralpha(plotattributes, i))
    cstr_stroke = plot_color(
        get_markerstrokecolor(plotattributes, i),
        get_markerstrokealpha(plotattributes, i),
    )
    mark_size =
        pgfx_thickness_scaling(plotattributes) *
        0.75 *
        _cycle(plotattributes[:markersize], i)
    mark_freq = if !any(isnan, plotattributes[:y]) && plotattributes[:markershape] isa AVec
        length(plotattributes[:markershape])
    else
        1
    end
    return Options(
        "mark" => shape isa Shape ? "PlotsShape$i" : pgfx_get_marker(shape),
        "mark size" => "$mark_size pt",
        "mark repeat" => mark_freq,
        "mark options" => Options(
            "color" => cstr_stroke,
            "draw opacity" => alpha(cstr_stroke),
            "fill" => cstr,
            "fill opacity" => alpha(cstr),
            "line width" =>
                pgfx_thickness_scaling(plotattributes) *
                0.75 *
                _cycle(plotattributes[:markerstrokewidth], i),
            "rotate" => if shape === :dtriangle
                180
            elseif shape === :rtriangle
                270
            elseif shape === :ltriangle
                90
            else
                0
            end,
            pgfx_get_linestyle(_cycle(plotattributes[:markerstrokestyle], i)) =>
                nothing,
        ),
    )
end

function pgfx_add_annotation!(
        o,
        pos,
        val,
        thickness_scaling = 1;
        cs = "axis cs:",
        options = Options(),
    )
    # Construct the style string.
    cstr = val.font.color
    ann_opt = merge(
        Options(
            get((hcenter = "", left = "right", right = "left"), val.font.halign, "") =>
                nothing,
            get((vcenter = "", top = "below", bottom = "above"), val.font.valign, "") =>
                nothing,
            "color" => cstr,
            "draw opacity" => float(alpha(cstr)),  # float(...): convert N0f8
            "rotate" => val.font.rotation,
            "font" => pgfx_font(val.font.pointsize, thickness_scaling),
        ),
        options,
    )
    return push!(
        o,
        "\\node$(sprint(PGFPlotsX.print_tex, ann_opt)) at ($(cs)$(join(pos, ','))) {$(val.str)};",
    )
end

function pgfx_fillrange_series!(axis, series, series_func, i, fillrange, rng)
    fr_opt = Options("line width" => "0", "draw opacity" => "0")
    fr_opt = merge(fr_opt, pgfx_fillstyle(series, i))
    push!(
        fr_opt,
        "mark" => "none",  # no markers on fillranges
        "forget plot" => nothing,
    )
    opt = series.plotattributes
    args = if RecipesPipeline.is3d(series)
        opt[:x][rng], opt[:y][rng], opt[:z][rng]
    elseif ispolar(series)
        rad2deg.(opt[:x][rng]), opt[:y][rng]
    elseif series[:seriestype] === :straightline
        straightline_data(series)
    else
        opt[:x][rng], opt[:y][rng]
    end
    return push!(axis, PGFPlotsX.PlotInc(fr_opt, pgfx_fillrange_args(fillrange, args...)))
end

function pgfx_fillrange_args(fillrange, x, y)
    n = length(x)
    x_fill = [x; x[n:-1:1]; x[1]]
    y_fill = [y; _cycle(fillrange, n:-1:1); y[1]]
    return PGFPlotsX.Coordinates(x_fill, y_fill)
end

function pgfx_fillrange_args(fillrange, x, y, z)
    n = length(x)
    x_fill = [x; x[n:-1:1]; x[1]]
    y_fill = [y; y[n:-1:1]; x[1]]
    z_fill = [z; _cycle(fillrange, n:-1:1); z[1]]
    return PGFPlotsX.Coordinates(x_fill, y_fill, z_fill)
end

pgfx_sanitize_string(p::PlotText) = PlotText(pgfx_sanitize_string(p.str), p.font)
pgfx_sanitize_string(s::LaTeXString) = LaTeXString(replace(s, r"\\?([#%])" => s"\\\1"))
function pgfx_sanitize_string(s::AbstractString)
    # regular latex text with the following special characters won't compile if not sanitized (escaped)
    sanitized = replace(s, r"\\?([#%_&\{\}\$])" => s"\\\1")
    return map(collect(sanitized)) do c
        if isascii(c)
            c
        else
            Latexify.latexify(c; parse = false)
        end
    end |> join |> LaTeXString
end

function pgfx_sanitize_plot!(plt)
    for (key, value) in plt.attr
        if value isa Union{AbstractString, AVec{<:AbstractString}}
            plt.attr[key] = pgfx_sanitize_string.(value)
        end
    end
    for subplot in plt.subplots
        for (key, value) in subplot.attr
            if key === :annotations && subplot.attr[:annotations] !== nothing
                old_ann = subplot.attr[key]
                for i in eachindex(old_ann)
                    # [1:end-1] is a tuple of coordinates, [end] - text
                    subplot.attr[key][i] =
                        (old_ann[i][1:(end - 1)]..., pgfx_sanitize_string(old_ann[i][end]))
                end
            elseif value isa Union{AbstractString, AVec{<:AbstractString}}
                subplot.attr[key] = pgfx_sanitize_string.(value)
            elseif value isa Axis
                for (k, v) in value.plotattributes
                    if v isa Union{AbstractString, AVec{<:AbstractString}}
                        value.plotattributes[k] = pgfx_sanitize_string.(v)
                    end
                end
            end
        end
    end
    for series in plt.series_list
        for (key, value) in series.plotattributes
            if key === :series_annotations &&
                    series.plotattributes[:series_annotations] !== nothing
                old_ann = series.plotattributes[key].strs
                for i in eachindex(old_ann)
                    series.plotattributes[key].strs[i] = pgfx_sanitize_string(old_ann[i])
                end
            elseif value isa Union{AbstractString, AVec{<:AbstractString}}
                series.plotattributes[key] = pgfx_sanitize_string.(value)
            end
        end
    end
    return
end

pgfx_is_inline_math(lab) = (
    (startswith(lab, '$') && endswith(lab, '$')) ||
        (startswith(lab, "\\(") && endswith(lab, "\\)"))
)

# surround the power part of label with curly braces
function wrap_power_label(label::AbstractString)
    pgfx_is_inline_math(label) && return label  # already in `mathmode` form
    occursin('^', label) || return label
    base, power = split(label, '^')
    return "$base^$(curly(power))"
end

wrap_power_labels(labels::AVec{LaTeXString}) = labels
function wrap_power_labels(labels::AVec{<:AbstractString})
    new_labels = similar(labels)
    for (i, label) in enumerate(labels)
        new_labels[i] = wrap_power_label(label)
    end
    return new_labels
end

# --------------------------------------------------------------------------------------
function pgfx_axis!(opt::Options, sp::Subplot, letter)
    axis = sp[get_attr_symbol(letter, :axis)]

    # turn off scaled ticks
    tick_color = plot_color(axis[:foreground_color_axis])
    push!(
        opt,
        "scaled $(letter) ticks" => "false",
        "$(letter)label" => Plots.get_guide(axis),
        "$(letter) tick style" =>
            Options("color" => color(tick_color), "opacity" => alpha(tick_color)),
        "$(letter) tick label style" => Options(
            "color" => color(tick_color),
            "opacity" => alpha(tick_color),
            "rotate" => axis[:rotation],
        ),
    )

    # set to supported framestyle
    framestyle = pgfx_framestyle(sp[:framestyle] == false ? :none : sp[:framestyle])

    # axis label position
    labelpos = if letter === :x
        pgfx_get_xguide_pos(axis[:guide_position])
    elseif letter === :y
        pgfx_get_yguide_pos(axis[:guide_position])
    else
        ""
    end

    # add label font
    cstr = plot_color(axis[:guidefontcolor])
    push!(
        opt,
        "$(letter)label style" => Options(
            labelpos => nothing,
            "at" => "{(ticklabel cs:$(get((left = 0, right = 1), axis[:guidefonthalign], 0.5)))}",
            "anchor" => "near ticklabel",
            "font" => pgfx_font(axis[:guidefontsize], pgfx_thickness_scaling(sp)),
            "color" => cstr,
            "draw opacity" => alpha(cstr),
            "rotate" => axis[:guidefontrotation],
        ),
    )

    # flip/reverse?
    axis[:flip] && push!(opt, "$letter dir" => "reverse")

    # scale
    scale = axis[:scale]
    if (is_log_scale = scale in (:ln, :log2, :log10))
        push!(opt, "$(letter)mode" => "log")
        scale === :ln || push!(opt, "log basis $letter" => "$(scale === :log2 ? 2 : 10)")
    end

    # ticks on or off
    if axis[:ticks] in (nothing, false, :none) || framestyle === :none
        push!(opt, "$(letter)majorticks" => "false")
    elseif framestyle in (:grid, :zerolines)
        push!(opt, "$letter tick style" => Options("draw" => "none"))
    end

    # grid on or off
    push!(opt, "$(letter)majorgrids" => string(axis[:grid] && framestyle !== :none))

    # limits
    lims = if ispolar(sp) && letter === :x
        rad2deg.(axis_limits(sp, :x))
    else
        axis_limits(sp, letter)
    end
    push!(opt, "$(letter)min" => lims[1], "$(letter)max" => lims[2])

    if axis[:ticks] ∉ (nothing, false, :none, :native) && framestyle !== :none
        vals, labs =
            ticks = get_ticks(sp, axis, formatter = latex_formatter(axis[:formatter]))
        # pgfplot ignores ticks with angles below `90` when `xmin = 90`, so shift values
        tick_values = if ispolar(sp) && letter === :x
            vcat(rad2deg.(vals[3:end]), 360, 405)
        else
            vals
        end
        tick_labels = if axis[:showaxis]
            if is_log_scale && axis[:ticks] === :auto
                labels = wrap_power_labels(labs)
                if (lab = first(labels)) isa LaTeXString || pgfx_is_inline_math(lab)
                    join(labels, ',')
                else
                    "\\(" * join(labels, "\\),\\(") * "\\)"
                end
            else
                labels = if ispolar(sp) && letter === :x
                    vcat(labs[3:end], "0", "45")
                else
                    labs
                end
                join(is_log_scale ? wrap_power_labels(labels) : labels, ',')
            end
        else
            ""
        end
        push!(
            opt,
            "$(letter)ticklabels" => curly(tick_labels),
            "$(letter)tick" => curly(join(tick_values, ',')),
            if (tick_dir = axis[:tick_direction]) === :none || axis[:showaxis] === false
                "$(letter)tick style" => "draw=none"
            else
                "$(letter)tick align" => "$(tick_dir)side"
            end,
            "$(letter)ticklabel style" => pgfx_get_ticklabel_style(sp, axis),
            "$letter grid style" => pgfx_linestyle(
                pgfx_thickness_scaling(sp) * axis[:gridlinewidth],
                axis[:foreground_color_grid],
                axis[:gridalpha],
                axis[:gridstyle],
            ),
        )

        # minor ticks
        # NOTE: PGFPlots would provide "minor x ticks num", but this only places minor ticks
        #       between major ticks and not outside first and last tick to the axis limits.
        #       Hence, we hack around with extra ticks.
        #       Unfortunately this conflicts with `:zerolines` framestyle hack.
        #       So minor ticks are not working with `:zerolines`.
        if (minor_ticks = get_minor_ticks(sp, axis, ticks)) !== nothing
            if ispolar(sp) && letter === :x
                minor_ticks = vcat(rad2deg.(minor_ticks[3:end]), 360, 405)
            end
            push!(
                opt,
                "extra $letter ticks" => curly(join(minor_ticks, ',')),
                "extra $letter tick labels" => "",
                "extra $letter tick style" => Options(
                    "grid" => axis[:minorgrid] ? "major" : "none",
                    "$letter grid style" => pgfx_linestyle(
                        pgfx_thickness_scaling(sp) * axis[:minorgridlinewidth],
                        axis[:foreground_color_minor_grid],
                        axis[:minorgridalpha],
                        axis[:minorgridstyle],
                    ),
                    if length(minor_ticks) > 0
                        "major tick length" => "0.1cm"
                    else
                        "major tick length" => "0"
                    end,
                ),
            )
        end
    end

    # framestyle
    if framestyle in (:axes, :origin)
        push!(
            opt,  # the * after line disables the arrow at the axis
            "axis $letter line$(axis[:draw_arrow] ? "" : "*")" =>
                (axis[:mirror] ? "right" : framestyle === :axes ? "left" : "middle"),
        )
    end

    # allow axis mirroring with :box framestyle
    if framestyle in (:box,)
        push!(opt, "$(letter)ticklabel pos" => (axis[:mirror] ? "right" : "left"))
    end

    if framestyle === :zerolines
        gs = pgfx_linestyle(pgfx_thickness_scaling(sp), axis[:foreground_color_border], 1)
        push!(
            opt,
            "extra $letter ticks" => "0",
            "extra $letter tick labels" => "",
            "extra $letter tick style" =>
                Options("grid" => "major", "$letter grid style" => gs),
        )
    end

    axis[:showaxis] || push!(opt, "separate axis lines")

    push!(
        opt,
        "$letter axis line style" =>
            if !axis[:showaxis] || framestyle in (:zerolines, :grid, :none)
            "{draw opacity = 0}"
        else
            pgfx_linestyle(
                pgfx_thickness_scaling(sp),
                axis[:foreground_color_border],
                1,
            )
        end,
    )
    return nothing
end

# --------------------------------------------------------------------------------------
# display calls this and then _display, its called 3 times for plot(1:5)
# Set the (left, top, right, bottom) minimum padding around the plot area
# to fit ticks, tick labels, guides, colorbars, etc.
function _update_min_padding!(sp::Subplot{PGFPlotsXBackend})
    return sp.minpad =
    if (leg = sp[:legend_position]) in
            (:best, :outertopright, :outerright, :outerbottomright) ||
            (leg isa Tuple && leg[1] >= 1)
        (0mm, 0mm, 5mm, 0mm)
    else
        (0mm, 0mm, 0mm, 0mm)
    end
end

_create_backend_figure(plt::Plot{PGFPlotsXBackend}) = plt.o = PGFPlotsXPlot()

_series_added(plt::Plot{PGFPlotsXBackend}, series::Series) = plt.o.is_created = false

_update_plot_object(plt::Plot{PGFPlotsXBackend}) = plt.o(plt)

for mime in ("application/pdf", "image/svg+xml", "image/png")
    @eval function _show(io::IO, mime::MIME{Symbol($mime)}, plt::Plot{PGFPlotsXBackend})
        plt.o.was_shown = true
        return show(io, mime, plt.o.the_plot)
    end
end

function _show(io::IO, mime::MIME{Symbol("application/x-tex")}, plt::Plot{PGFPlotsXBackend})
    plt.o.was_shown = true
    return PGFPlotsX.print_tex(
        io,
        plt.o.the_plot,
        include_preamble = plt.attr[:tex_output_standalone],
    )
end

function _display(plt::Plot{PGFPlotsXBackend})
    plt.o.was_shown = true
    return display(PGFPlotsX.PGFPlotsXDisplay(), plt.o.the_plot)
end

ci_tol() =
if Sys.islinux()
    is_pkgeval() ? "1e-2" : "5e-4"
elseif Sys.isapple()
    "1e-3"
else
    "1e-1"
end

const TESTS_MODULE = Module(:PlotsTestsModule)
const PLOTS_IMG_TOL = parse(Float64, get(ENV, "PLOTS_IMG_TOL", is_ci() ? ci_tol() : "1e-5"))

Base.eval(TESTS_MODULE, :(using Random, StableRNGs, Plots))

reference_dir(args...) =
if (ref_dir = get(ENV, "PLOTS_REFERENCE_DIR", nothing)) !== nothing
    ref_dir
else
    joinpath(first(Base.DEPOT_PATH), "dev", "PlotReferenceImages.jl", args...)
end
reference_path(backend, version) = reference_dir("Plots", string(backend), string(version))

function checkout_reference_dir(dn::AbstractString)
    mkpath(dn)
    local repo
    for i in 1:6
        try
            repo = LibGit2.clone(
                "https://github.com/JuliaPlots/PlotReferenceImages.jl.git",
                dn,
            )
            break
        catch err
            @warn err
            sleep(20i)
        end
    end
    if (ver = Plots._current_plots_version).prerelease |> isempty
        try
            tag = LibGit2.GitObject(repo, "v$ver")
            hash = string(LibGit2.target(tag))
            LibGit2.checkout!(repo, hash)
        catch err
            @warn err
        end
    end
    LibGit2.peel(LibGit2.head(repo)) |> println  # print some information
    return nothing
end

let dn = reference_dir()
    isdir(dn) || checkout_reference_dir(dn)
end

ref_name(i) = "ref" * lpad(i, 3, '0')

function reference_file(backend, version, i)
    # NOTE: keep ref[...].png naming consistent with `PlotDocs`
    refdir = reference_dir("Plots", string(backend))
    fn = ref_name(i) * ".png"
    reffn = joinpath(refdir, string(version), fn)
    for ver in sort(VersionNumber.(readdir(refdir)), rev = true)
        ver > version && continue
        if (tmpfn = joinpath(refdir, string(ver), fn)) |> isfile
            reffn = tmpfn
            break
        end
    end
    return reffn
end

function image_comparison_tests(
        pkg::Symbol,
        idx::Int;
        debug = false,
        popup = !is_ci(),
        sigma = [1, 1],
        tol = 1.0e-2,
    )
    example = Plots._examples[idx]
    @info "Testing plot: $pkg:$idx:$(example.header)"

    ver = Plots._current_plots_version
    ver = VersionNumber(ver.major, ver.minor, ver.patch)
    reffn = reference_file(pkg, ver, idx)
    newfn = joinpath(reference_path(pkg, ver), ref_name(idx) * ".png")

    imports = something(example.imports, :())
    exprs = quote
        Plots.debug!($debug)
        backend($(QuoteNode(pkg)))
        theme(:default)
        rng = StableRNG(Plots.PLOTS_SEED)
        $(Plots.replace_rand(example.exprs))
    end
    @debug imports exprs

    func = fn -> Base.eval.(Ref(TESTS_MODULE), (imports, exprs, :(png($fn))))
    return test_images(
        VisualTest(func, reffn),
        newfn = newfn,
        popup = popup,
        sigma = sigma,
        tol = tol,
    )
end

function image_comparison_facts(
        pkg::Symbol;
        skip = [],          # skip these examples (int index)
        only = nothing,     # limit to these examples (int index)
        debug = false,      # print debug information ?
        sigma = [1, 1],     # number of pixels to "blur"
        tol = 1.0e-2,         # acceptable error (percent)
    )
    for i in setdiff(1:length(Plots._examples), skip)
        if only === nothing || i in only
            @test success(image_comparison_tests(pkg, i; debug, sigma, tol))
        end
    end
    return
end

## Uncomment the following lines to update reference images for different backends
#=

Plots.with(:gr) do
    image_comparison_facts(:gr, tol = PLOTS_IMG_TOL, skip = Plots._backend_skips[:gr])
end

Plots.with(:plotlyjs) do
    image_comparison_facts(:plotlyjs, tol = PLOTS_IMG_TOL, skip = Plots._backend_skips[:plotlyjs])
end

Plots.with(:pyplot) do
    image_comparison_facts(:pyplot, tol = PLOTS_IMG_TOL, skip = Plots._backend_skips[:pyplot])
end

Plots.with(:pgfplotsx) do
    image_comparison_facts(:pgfplotsx, tol = PLOTS_IMG_TOL, skip = Plots._backend_skips[:pgfplotsx])
end
=#

@testset "UnicodePlots" begin
    Plots.with(:unicodeplots) do
        @test backend() == Plots.UnicodePlotsBackend()

        io = IOContext(IOBuffer(), :color => true)

        # lets just make sure it runs without error
        pl = plot(rand(10))
        @test show(io, pl) isa Nothing

        pl = bar(randn(10))
        @test show(io, pl) isa Nothing

        pl = plot([1, 2], [3, 4])
        annotate!(pl, [(1.5, 3.2, Plots.text("Test", :red, :center))])
        hline!(pl, [3.1])
        @test show(io, pl) isa Nothing

        pl = plot([Dates.Date(2019, 1, 1), Dates.Date(2019, 2, 1)], [3, 4])
        hline!(pl, [3.1])
        annotate!(pl, [(Dates.Date(2019, 1, 15), 3.2, Plots.text("Test", :red, :center))])
        @test show(io, pl) isa Nothing

        pl = plot([Dates.Date(2019, 1, 1), Dates.Date(2019, 2, 1)], [3, 4])
        annotate!(pl, [(Dates.Date(2019, 1, 15), 3.2, :auto)])
        hline!(pl, [3.1])
        @test show(io, pl) isa Nothing

        pl = plot(map(plot, 1:4)..., layout = (2, 2))
        @test show(io, pl) isa Nothing

        pl = plot(map(plot, 1:3)..., layout = (2, 2))
        @test show(io, pl) isa Nothing

        pl = plot(map(plot, 1:2)..., layout = @layout([° _; _ °]))
        @test show(io, pl) isa Nothing

        redirect_stdout(devnull) do
            show(plot(1:2))
        end
    end
end

const blacklist = if VERSION.major == 1 && VERSION.minor ∈ (9, 10)
    [41]  # FIXME: github.com/JuliaLang/julia/issues/47261
else
    []
end
push!(blacklist, 50)  # NOTE:  remove when github.com/jheinen/GR.jl/issues/507 is resolved

@testset "GR - reference images" begin
    Plots.with(:gr) do
        # NOTE: use `ENV["VISUAL_REGRESSION_TESTS_AUTO"] = true;` to automatically replace reference images
        @test backend() == Plots.GRBackend()
        @test backend_name() === :gr
        image_comparison_facts(
            :gr,
            tol = PLOTS_IMG_TOL,
            skip = vcat(Plots._backend_skips[:gr], blacklist),
        )
    end
end

is_pkgeval() || @testset "PlotlyJS" begin
    Plots.with(:plotlyjs) do
        @test backend() == Plots.PlotlyJSBackend()
        pl = plot(rand(10))
        @test pl isa Plot
        @test_broken display(pl) isa Nothing
    end
end

is_pkgeval() || @testset "Examples $be" for be in TEST_BACKENDS
    callback(m, pkgname, i) = begin
        pl = m.Plots.current()
        save_func = (; pgfplotsx = m.Plots.pdf, unicodeplots = m.Plots.txt)  # fastest `savefig` for each backend
        fn = Base.invokelatest(
            get(save_func, pkgname, m.Plots.png),
            pl,
            tempname() * ref_name(i),
        )
        @test filesize(fn) > 1_000
    end
    Sys.islinux() || continue
    skip = vcat(Plots._backend_skips[be], blacklist)
    Plots.test_examples(be; skip, callback, disp = is_ci(), strict = true)  # `ci` display for coverage
    closeall()
end

# https://github.com/jheinen/GR.jl - significant contributions by @jheinen

const gr_projections = (auto = 1, ortho = 1, orthographic = 1, persp = 2, perspective = 2)
const gr_linetypes = (auto = 1, solid = 1, dash = 2, dot = 3, dashdot = 4, dashdotdot = -1)
const gr_fill_styles = ((/) = 9, (\) = 10, (|) = 7, (-) = 8, (+) = 11, (x) = 6)
const gr_x_log_scales =
    (ln = GR.OPTION_X_LN, log2 = GR.OPTION_X_LOG2, log10 = GR.OPTION_X_LOG)
const gr_y_log_scales =
    (ln = GR.OPTION_Y_LN, log2 = GR.OPTION_Y_LOG2, log10 = GR.OPTION_Y_LOG)
const gr_z_log_scales =
    (ln = GR.OPTION_Z_LN, log2 = GR.OPTION_Z_LOG2, log10 = GR.OPTION_Z_LOG)

const gr_arrowstyles = (
    simple = 1,
    hollow = 3,
    filled = 4,
    triangle = 5,
    filledtriangle = 6,
    closed = 6,
    open = 5,
)
const gr_markertypes = (
    auto = 1,
    pixel = 1,
    none = -1,
    circle = -1,
    rect = -7,
    diamond = -13,
    utriangle = -3,
    dtriangle = -5,
    ltriangle = -18,
    rtriangle = -17,
    pentagon = -21,
    hexagon = -22,
    heptagon = -23,
    octagon = -24,
    cross = 2,
    xcross = 5,
    (+) = 2,
    x = 5,
    star4 = -25,
    star5 = -26,
    star6 = -27,
    star7 = -28,
    star8 = -29,
    vline = -30,
    hline = -31,
)
const gr_haligns = (
    left = GR.TEXT_HALIGN_LEFT,
    hcenter = GR.TEXT_HALIGN_CENTER,
    center = GR.TEXT_HALIGN_CENTER,
    right = GR.TEXT_HALIGN_RIGHT,
)
const gr_valigns = (
    top = GR.TEXT_VALIGN_TOP,
    vcenter = GR.TEXT_VALIGN_HALF,
    center = GR.TEXT_VALIGN_HALF,
    bottom = GR.TEXT_VALIGN_BOTTOM,
)
const gr_font_family = Dict(
    # compat
    "times" => 101,
    "helvetica" => 105,
    "courier" => 109,
    "bookman" => 114,
    "newcenturyschlbk" => 118,
    "avantgarde" => 122,
    "palatino" => 126,
    "serif-roman" => 232,
    "sans-serif" => 233,
    # https://gr-framework.org/fonts.html
    "times roman" => 101,
    "times italic" => 102,
    "times bold" => 103,
    "times bold italic" => 104,
    "helvetica" => 105,
    "helvetica oblique" => 106,
    "helvetica bold" => 107,
    "helvetica bold oblique" => 108,
    "courier" => 109,
    "courier oblique" => 110,
    "courier bold" => 111,
    "courier bold oblique" => 112,
    "symbol" => 113,
    "bookman light" => 114,
    "bookman light italic" => 115,
    "bookman demi" => 116,
    "bookman demi italic" => 117,
    "new century schoolbook roman" => 118,
    "new century schoolbook italic" => 119,
    "new century schoolbook bold" => 120,
    "new century schoolbook bold italic" => 121,
    "avantgarde book" => 122,
    "avantgarde book oblique" => 123,
    "avantgarde demi" => 124,
    "avantgarde demi oblique" => 125,
    "palatino roman" => 126,
    "palatino italic" => 127,
    "palatino bold" => 128,
    "palatino bold italic" => 129,
    "zapf chancery medium italic" => 130,
    "zapf dingbats" => 131,
    "computer modern" => 232,
    "dejavu sans" => 233,
)

mutable struct GRViewport{T}
    xmin::T
    xmax::T
    ymin::T
    ymax::T
end

width(vp::GRViewport) = vp.xmax - vp.xmin
height(vp::GRViewport) = vp.ymax - vp.ymin

xcenter(vp::GRViewport) = 0.5(vp.xmin + vp.xmax)
ycenter(vp::GRViewport) = 0.5(vp.ymin + vp.ymax)

xposition(vp::GRViewport, pos) = vp.xmin + pos * width(vp)
yposition(vp::GRViewport, pos) = vp.ymin + pos * height(vp)

# --------------------------------------------------------------------------------------
gr_is3d(st) = RecipesPipeline.is3d(st)

gr_color(c, ::Type) = gr_color(RGBA(c), RGB)
gr_color(c) = gr_color(c, color_type(c))
gr_color(c, ::Type{<:AbstractRGB}) = UInt32(
    round(UInt, clamp(255alpha(c), 0, 255)) << 24 +
        round(UInt, clamp(255blue(c), 0, 255)) << 16 +
        round(UInt, clamp(255green(c), 0, 255)) << 8 +
        round(UInt, clamp(255red(c), 0, 255)),
)
gr_color(c, ::Type{<:AbstractGray}) =
let g = round(UInt, clamp(255gray(c), 0, 255)),
        α = round(UInt, clamp(255alpha(c), 0, 255))

    UInt32(α << 24 + g << 16 + g << 8 + g)
end

set_RGBA_alpha(alpha, c::RGBA) = RGBA(red(c), green(c), blue(c), alpha)
set_RGBA_alpha(alpha::Nothing, c::RGBA) = c

function gr_getcolorind(c)
    gr_set_transparency(float(alpha(c)))
    return convert(Int, GR.inqcolorfromrgb(red(c), green(c), blue(c)))
end

gr_set_linecolor(c) = GR.setlinecolorind(gr_getcolorind(_cycle(c, 1)))
gr_set_fillcolor(c) = GR.setfillcolorind(gr_getcolorind(_cycle(c, 1)))
gr_set_markercolor(c) = GR.setmarkercolorind(gr_getcolorind(_cycle(c, 1)))
gr_set_bordercolor(c) = GR.setbordercolorind(gr_getcolorind(_cycle(c, 1)))
gr_set_textcolor(c) = GR.settextcolorind(gr_getcolorind(_cycle(c, 1)))
gr_set_transparency(α::Real) = GR.settransparency(clamp(α, 0, 1))
gr_set_transparency(::Nothing) = GR.settransparency(1)
gr_set_transparency(c, α) = gr_set_transparency(α)
gr_set_transparency(c::Colorant, ::Nothing) = gr_set_transparency(c)
gr_set_transparency(c::Colorant) = GR.settransparency(alpha(c))

gr_set_arrowstyle(style::Symbol) = GR.setarrowstyle(get(gr_arrowstyles, style, 1))

gr_set_fillstyle(::Nothing) = GR.setfillintstyle(GR.INTSTYLE_SOLID)
function gr_set_fillstyle(s::Symbol)
    GR.setfillintstyle(GR.INTSTYLE_HATCH)
    GR.setfillstyle(get(gr_fill_styles, s, 9))
    return nothing
end

# https://gr-framework.org/python-gr.html?highlight=setprojectiontype#gr.setprojectiontype
# PROJECTION_DEFAULT      0 default
# PROJECTION_ORTHOGRAPHIC 1 orthographic
# PROJECTION_PERSPECTIVE  2 perspective
# we choose to unify backends by using a default `orthographic` proj when `:auto`
gr_set_projectiontype(sp) = GR.setprojectiontype(gr_projections[sp[:projection_type]])

# --------------------------------------------------------------------------------------

# draw line segments, splitting x/y into contiguous/finite segments
# note: this can be used for shapes by passing func `GR.fillarea`
function gr_polyline(x, y, func = GR.polyline; arrowside = :none, arrowstyle = :simple)
    draw_head = arrowside in (:head, :both)
    draw_tail = arrowside in (:tail, :both)
    n = length(x)
    iend = 0
    while iend < n - 1
        istart = -1  # set istart to the first index that is finite
        for j in (iend + 1):n
            if ok(x[j], y[j])
                istart = j
                break
            end
        end
        if istart > 0
            iend = -1  # iend is the last finite index
            for j in (istart + 1):n
                if ok(x[j], y[j])
                    iend = j
                else
                    break
                end
            end
        end
        # if we found a start and end, draw the line segment, otherwise we're done
        if istart > 0 && iend > 0
            func(x[istart:iend], y[istart:iend])
            if draw_head
                gr_set_arrowstyle(arrowstyle)
                GR.drawarrow(x[iend - 1], y[iend - 1], x[iend], y[iend])
            end
            if draw_tail
                gr_set_arrowstyle(arrowstyle)
                GR.drawarrow(x[istart + 1], y[istart + 1], x[istart], y[istart])
            end
        else
            break
        end
    end
    return
end

function gr_polyline3d(x, y, z, func = GR.polyline3d)
    iend = 0
    n = length(x)
    while iend < n - 1
        istart = -1  # set istart to the first index that is finite
        for j in (iend + 1):n
            if ok(x[j], y[j], z[j])
                istart = j
                break
            end
        end
        if istart > 0
            iend = -1  # iend is the last finite index
            for j in (istart + 1):n
                if ok(x[j], y[j], z[j])
                    iend = j
                else
                    break
                end
            end
        end
        # if we found a start and end, draw the line segment, otherwise we're done
        if istart > 0 && iend > 0
            func(x[istart:iend], y[istart:iend], z[istart:iend])
        else
            break
        end
    end
    return
end

gr_inqtext(x, y, s) = gr_inqtext(x, y, string(s))
gr_inqtext(x, y, s::AbstractString) =
if (occursin('\\', s) || occursin(r"10\^{|2\^{|e\^{", s)) &&
        match(r".*\$[^\$]+?\$.*", String(s)) === nothing
    GR.inqtextext(x, y, s)
else
    GR.inqtext(x, y, s)
end

gr_text(x, y, s) = gr_text(x, y, string(s))
gr_text(x, y, s::AbstractString) =
if (occursin('\\', s) || occursin(r"10\^{|2\^{|e\^{", s)) &&
        match(r".*\$[^\$]+?\$.*", String(s)) === nothing
    GR.textext(x, y, s)
else
    GR.text(x, y, s)
end

function gr_polaraxes(rmin::Real, rmax::Real, sp::Subplot)
    GR.savestate()
    xaxis = sp[:xaxis]
    yaxis = sp[:yaxis]

    α = 0:45:315
    a = α .+ 90
    sinf = sind.(a)
    cosf = cosd.(a)
    rtick_values, rtick_labels = get_ticks(sp, yaxis, update = false)

    # draw angular grid
    if xaxis[:grid]
        gr_set_line(
            xaxis[:gridlinewidth],
            xaxis[:gridstyle],
            xaxis[:foreground_color_grid],
            sp,
        )
        gr_set_transparency(xaxis[:foreground_color_grid], xaxis[:gridalpha])
        for i in eachindex(α)
            GR.polyline([sinf[i], 0], [cosf[i], 0])
        end
    end

    # draw radial grid
    if yaxis[:grid]
        gr_set_line(
            yaxis[:gridlinewidth],
            yaxis[:gridstyle],
            yaxis[:foreground_color_grid],
            sp,
        )
        gr_set_transparency(yaxis[:foreground_color_grid], yaxis[:gridalpha])
        for i in eachindex(rtick_values)
            r = (rtick_values[i] - rmin) / (rmax - rmin)
            (r ≤ 1 && r ≥ 0) && GR.drawarc(-r, r, -r, r, 0, 359)
        end
        GR.drawarc(-1, 1, -1, 1, 0, 359)
    end

    # prepare to draw ticks
    gr_set_transparency(1)
    GR.setlinecolorind(90)
    GR.settextalign(GR.TEXT_HALIGN_CENTER, GR.TEXT_VALIGN_HALF)

    # draw angular ticks
    if xaxis[:showaxis]
        GR.drawarc(-1, 1, -1, 1, 0, 359)
        for i in eachindex(α)
            x, y = GR.wctondc(1.1sinf[i], 1.1cosf[i])
            GR.textext(x, y, string((360 - α[i]) % 360, "^o"))
        end
    end

    # draw radial ticks
    yaxis[:showaxis] && for i in eachindex(rtick_values)
        r = (rtick_values[i] - rmin) / (rmax - rmin)
        (r ≤ 1 && r ≥ 0) && gr_text(GR.wctondc(0.05, r)..., _cycle(rtick_labels, i))
    end
    GR.restorestate()
    return nothing
end

# using the axis extrema and limit overrides, return the min/max value for this axis
gr_x_axislims(sp::Subplot) = axis_limits(sp, :x)
gr_y_axislims(sp::Subplot) = axis_limits(sp, :y)
gr_z_axislims(sp::Subplot) = axis_limits(sp, :z)
gr_xy_axislims(sp::Subplot) = gr_x_axislims(sp)..., gr_y_axislims(sp)...

function gr_fill_viewport(vp::GRViewport, c)
    if alpha(c) == 0
        return nothing
    end
    GR.savestate()
    GR.selntran(0)
    GR.setscale(0)
    GR.setfillintstyle(GR.INTSTYLE_SOLID)
    gr_set_fillcolor(c)
    GR.fillrect(vp.xmin, vp.xmax, vp.ymin, vp.ymax)
    GR.selntran(1)
    GR.restorestate()
    return nothing
end

gr_fill_plotarea(sp, vp::GRViewport) =
    gr_is3d(sp) || gr_fill_viewport(vp, plot_color(sp[:background_color_inside]))

# ---------------------------------------------------------

gr_nominal_size(s) = minimum(get_size(s)) / 500

# draw ONE Shape
function gr_draw_marker(series, xi, yi, zi, clims, i, msize, strokewidth, shape::Shape)
    # convert to ndc coords (percentages of window) ...
    xi, yi = if zi === nothing
        GR.wctondc(xi, yi)
    else
        gr_w3tondc(xi, yi, zi)
    end
    f = msize / sum(get_size(series))

    # ... convert back to world coordinates
    sx, sy = coords(shape)
    xs_ys = GR.ndctowc.(xi .+ sx .* f, yi .+ sy .* f)
    xs, ys = getindex.(xs_ys, 1), getindex.(xs_ys, 2)

    # draw the interior
    mc = get_markercolor(series, clims, i)
    gr_set_fill(mc)
    gr_set_transparency(mc, get_markeralpha(series, i))
    GR.fillarea(xs, ys)

    # draw the shapes
    msc = get_markerstrokecolor(series, i)
    gr_set_line(strokewidth, :solid, msc, series)
    gr_set_transparency(msc, get_markerstrokealpha(series, i))
    GR.polyline(xs, ys)
    return nothing
end

# draw ONE symbol marker
function gr_draw_marker(series, xi, yi, zi, clims, i, msize, strokewidth, shape::Symbol)
    GR.setborderwidth(strokewidth)
    gr_set_bordercolor(get_markerstrokecolor(series, i))
    gr_set_markercolor(get_markercolor(series, clims, i))
    gr_set_transparency(get_markeralpha(series, i))
    GR.setmarkertype(gr_markertypes[shape])
    GR.setmarkersize(0.3msize / gr_nominal_size(series))
    if zi === nothing
        GR.polymarker([xi], [yi])
    else
        GR.polymarker3d([xi], [yi], [zi])
    end
    return nothing
end

# ---------------------------------------------------------

function gr_set_line(lw, style, c, s)  # s can be Subplot or Series
    GR.setlinetype(gr_linetypes[style])
    GR.setlinewidth(get_thickness_scaling(s) * max(0, lw / gr_nominal_size(s)))
    gr_set_linecolor(c)
    return nothing
end

gr_set_fill(c) = (gr_set_fillcolor(c); GR.setfillintstyle(GR.INTSTYLE_SOLID); nothing)

# this stores the conversion from a font pointsize to "percentage of window height"
# (which is what GR uses). `s` can be a Series, Subplot or Plot
gr_point_mult(s) = 1.5get_thickness_scaling(s) * px / pt / maximum(get_size(s))

# set the font attributes.
function gr_set_font(
        f::Font,
        s;
        halign = f.halign,
        valign = f.valign,
        color = f.color,
        rotation = f.rotation,
    )
    family = lowercase(f.family)
    GR.setcharheight(gr_point_mult(s) * f.pointsize)
    GR.setcharup(sincosd(-rotation)...)
    if !haskey(gr_font_family, family)
        gr_font_family[family] = GR.loadfont(string(f.family, ".ttf"))
    end
    haskey(gr_font_family, family) && GR.settextfontprec(
        gr_font_family[family],
        gr_font_family[family] ≥ 200 ? 3 : GR.TEXT_PRECISION_STRING,
    )
    gr_set_textcolor(plot_color(color))
    GR.settextalign(gr_haligns[halign], gr_valigns[valign])
    return nothing
end

function gr_w3tondc(x, y, z)
    xw, yw, _ = GR.wc3towc(x, y, z)
    return GR.wctondc(xw, yw)  # x, y
end

# --------------------------------------------------------------------------------------
# viewport plot area

function gr_viewport_from_bbox(sp::Subplot{GRBackend}, bb::BoundingBox, w, h, vp_canvas)
    viewport = GRViewport(
        vp_canvas.xmax * (left(bb) / w),
        vp_canvas.xmax * (right(bb) / w),
        vp_canvas.ymax * (1 - bottom(bb) / h),
        vp_canvas.ymax * (1 - top(bb) / h),
    )
    hascolorbar(sp) && (viewport.xmax -= 0.1(1 + 0.5gr_is3d(sp)))
    return viewport
end

# change so we're focused on the viewport area

# in case someone wants to modify these hardcoded factors
const gr_cbar_width = Ref(0.03)
const gr_cbar_offsets = Ref((0.02, 0.07))

function gr_set_viewport_cmap(sp::Subplot, vp::GRViewport)
    offset = gr_cbar_offsets[][gr_is3d(sp) ? 2 : 1]
    args = vp.xmax + offset, vp.xmax + offset + gr_cbar_width[], vp.ymin, vp.ymax
    GR.setviewport(args...)
    return GRViewport(args...)
end

function gr_set_viewport_polar(vp)
    x_ctr = xcenter(vp)
    dist = vp.ymax - 0.05width(vp)
    y_ctr = 0.5(vp.ymin + dist)
    r = 0.5NaNMath.min(width(vp), dist - vp.ymin)
    GR.setviewport(x_ctr - r, x_ctr + r, y_ctr - r, y_ctr + r)
    GR.setwindow(-1, 1, -1, 1)
    return r
end

struct GRColorbar
    gradients
    fills
    lines
    GRColorbar() = new([], [], [])
end

function gr_update_colorbar!(cbar::GRColorbar, series::Series)
    (style = colorbar_style(series)) === nothing && return
    list =
        style == cbar_gradient ? cbar.gradients :
        style == cbar_fill ? cbar.fills :
        style == cbar_lines ? cbar.lines : error("Unknown colorbar style: $style.")
    return push!(list, series)
end

function gr_contour_levels(series::Series, clims)
    levels = collect(contour_levels(series, clims))
    # GR implicitly uses the maximal z value as the highest level
    isfilledcontour(series) && pop!(levels)
    return levels
end

function gr_colorbar_colors(series::Series, clims)
    colors = if iscontour(series)
        levels = gr_contour_levels(series, clims)
        zrange = if isfilledcontour(series)
            ignorenan_extrema(levels)  # GR.contourf uses a color range according to supplied levels
        else
            clims  # GR.contour uses a color range according to data range
        end
        @. 1_000 + 255 * (levels - zrange[1]) / (zrange[2] - zrange[1])
    else
        1_000:1_255  # 256 values
    end
    return round.(Int, colors)
end

function _cbar_unique(values, propname)
    out = last(values)
    if any(x != out for x in values)
        @warn """
        Multiple series with different $propname share a colorbar.
        Colorbar may not reflect all series correctly.
        """
    end
    return out
end

const gr_colorbar_tick_size = Ref(0.005)

function gr_colorbar_title(sp::Subplot)
    title = if (ttl = sp[:colorbar_title]) isa PlotText
        ttl
    else
        text(ttl, colorbartitlefont(sp))
    end
    title.font.rotation += 90  # default rotated by 90° (vertical)
    return title
end

function gr_colorbar_info(sp::Subplot)
    clims = gr_clims(sp)
    return maximum(first.(gr_text_size.(clims))), clims
end

# add the colorbar
function gr_draw_colorbar(cbar::GRColorbar, sp::Subplot, vp::GRViewport)
    GR.savestate()
    x_min, x_max = gr_x_axislims(sp)
    tick_max_width, clims = gr_colorbar_info(sp)
    z_min, z_max = clims
    vp_cmap = gr_set_viewport_cmap(sp, vp)
    GR.setscale(0)
    GR.setwindow(x_min, x_max, z_min, z_max)
    if !isempty(cbar.gradients)
        series = cbar.gradients
        gr_set_gradient(_cbar_unique(get_colorgradient.(series), "color"))
        gr_set_transparency(_cbar_unique(get_fillalpha.(series), "fill alpha"))
        GR.cellarray(x_min, x_max, z_max, z_min, 1, 256, 1_000:1_255)
    end

    if !isempty(cbar.fills)
        series = cbar.fills
        GR.setfillintstyle(GR.INTSTYLE_SOLID)
        gr_set_gradient(_cbar_unique(get_colorgradient.(series), "color"))
        gr_set_transparency(_cbar_unique(get_fillalpha.(series), "fill alpha"))
        levels = _cbar_unique(contour_levels.(series, Ref(clims)), "levels")
        # GR implicitly uses the maximal z value as the highest level
        if last(levels) < z_max
            @warn "GR: highest contour level less than maximal z value is not supported."
            # replace levels, rather than assign to last(levels), to ensure type
            # promotion in case levels is an integer array
            pop!(levels)
            push!(levels, z_max)
        end
        colors = gr_colorbar_colors(last(series), clims)
        for (from, to, color) in zip(levels[1:(end - 1)], levels[2:end], colors)
            GR.setfillcolorind(color)
            GR.fillrect(x_min, x_max, from, to)
        end
    end

    if !isempty(cbar.lines)
        series = cbar.lines
        gr_set_gradient(_cbar_unique(get_colorgradient.(series), "color"))
        gr_set_line(
            _cbar_unique(get_linewidth.(series), "line width"),
            _cbar_unique(get_linestyle.(series), "line style"),
            _cbar_unique(get_linecolor.(series, Ref(clims)), "line color"),
            sp,
        )
        gr_set_transparency(_cbar_unique(get_linealpha.(series), "line alpha"))
        levels = _cbar_unique(contour_levels.(series, Ref(clims)), "levels")
        colors = gr_colorbar_colors(last(series), clims)
        for (line, color) in zip(levels, colors)
            GR.setlinecolorind(color)
            GR.polyline([x_min, x_max], [line, line])
        end
    end

    if _has_ticks(sp[:colorbar_ticks])
        z_tick = 0.5GR.tick(z_min, z_max)
        gr_set_line(1, :solid, plot_color(:black), sp)
        (yscale = sp[:colorbar_scale]) ∈ _logScales && GR.setscale(gr_y_log_scales[yscale])
        # signature: gr.axes(x_tick, y_tick, x_org, y_org, major_x, major_y, tick_size)
        GR.axes(0, z_tick, x_max, z_min, 0, 1, gr_colorbar_tick_size[])
    end

    title = gr_colorbar_title(sp)
    gr_set_font(title.font, sp; halign = :center, valign = :top)
    gr_text(vp.xmax + 0.1, ycenter(vp), title.str)

    GR.restorestate()
    return nothing
end

position(symb) =
if symb === :top || symb === :right
    0.95
elseif symb === :left || symb === :bottom
    0.05
else
    0.5
end

alignment(symb) =
if symb === :top || symb === :right
    :right
elseif symb === :left || symb === :bottom
    :left
else
    :center
end

# --------------------------------------------------------------------------------------

function gr_set_gradient(c)
    grad = _as_gradient(c)
    for (i, z) in enumerate(range(0, 1; length = 256))
        c = grad[z]
        GR.setcolorrep(999 + i, red(c), green(c), blue(c))
    end
    return grad
end

gr_set_gradient(series::Series) =
    (color = get_colorgradient(series)) !== nothing && gr_set_gradient(color)

# this is our new display func... set up the viewport_canvas, compute bounding boxes, and display each subplot
function gr_display(plt::Plot, dpi_factor = 1, display = true)
    if (display)
        GR.clearws()
    end

    # collect some monitor/display sizes in meters and pixels
    dsp_width_meters, dsp_height_meters, dsp_width_px, dsp_height_px = GR.inqdspsize()
    dsp_width_ratio = dsp_width_meters / dsp_width_px
    dsp_height_ratio = dsp_height_meters / dsp_height_px

    # compute the viewport_canvas, normalized to the larger dimension
    vp_canvas = GRViewport(0.0, 1.0, 0.0, 1.0)
    w, h = get_size(plt)
    if w > h
        ratio = float(h) / w
        msize = dsp_width_ratio * w * dpi_factor
        GR.setwsviewport(0, msize, 0, msize * ratio)
        GR.setwswindow(0, 1, 0, ratio)
        vp_canvas.ymin *= ratio
        vp_canvas.ymax *= ratio
    else
        ratio = float(w) / h
        msize = dsp_height_ratio * h * dpi_factor
        GR.setwsviewport(0, msize * ratio, 0, msize)
        GR.setwswindow(0, ratio, 0, 1)
        vp_canvas.xmin *= ratio
        vp_canvas.xmax *= ratio
    end

    if (display)
        # fill in the viewport_canvas background
        gr_fill_viewport(vp_canvas, plt[:background_color_outside])

        # subplots
        foreach(sp -> gr_display(sp, w * px, h * px, vp_canvas), plt.subplots)

        GR.updatews()
    end
    return nothing
end

gr_set_tickfont(sp, ax::Axis; kw...) = gr_set_font(
    tickfont(ax),
    sp;
    rotation = ax[:rotation],
    color = ax[:tickfontcolor],
    kw...,
)

function gr_set_tickfont(sp, letter::Symbol; kw...)
    axis = sp[get_attr_symbol(letter, :axis)]
    return gr_set_font(
        tickfont(axis),
        sp;
        rotation = axis[:rotation],
        color = axis[:tickfontcolor],
        kw...,
    )
end

# size of the text with no rotation
function gr_text_size(str)
    GR.savestate()
    GR.selntran(0)
    GR.setcharup(0, 1)
    (l, r), (b, t) = extrema.(gr_inqtext(0, 0, string(str)))
    GR.restorestate()
    return r - l, t - b  # w, h
end

# size of the text with rotation applied
function gr_text_size(str, rot)
    GR.savestate()
    GR.selntran(0)
    GR.setcharup(0, 1)
    (l, r), (b, t) = extrema.(gr_inqtext(0, 0, string(str)))
    GR.restorestate()
    return text_box_width(r - l, t - b, rot), text_box_height(r - l, t - b, rot)  # w, h
end

text_box_width(w, h, rot) = abs(cosd(rot)) * w + abs(cosd(rot + 90)) * h
text_box_height(w, h, rot) = abs(sind(rot)) * w + abs(sind(rot + 90)) * h

function gr_get_3d_axis_angle(cvs, nt, ft, letter)
    length(cvs) < 2 && return 0
    tickpoints = map(cv -> gr_w3tondc(sort_3d_axes(cv, nt, ft, letter)...), cvs)
    dx = tickpoints[2][1] - tickpoints[1][1]
    dy = tickpoints[2][2] - tickpoints[1][2]
    return atand(dy, dx)
end

function gr_get_ticks_size(ticks, rot)
    w, h = 0.0, 0.0
    for (cv, dv) in zip(ticks...)
        wi, hi = gr_text_size(dv, rot)
        w = NaNMath.max(w, wi)
        h = NaNMath.max(h, hi)
    end
    return w, h
end

function labelfunc(scale::Symbol, backend::GRBackend)
    texfunc = labelfunc_tex(scale)
    # replace dash with \minus (U+2212)
    return label -> replace(texfunc(label), "-" => "−")
end

function gr_axis_height(sp, axis)
    GR.savestate()
    ticks = get_ticks(sp, axis, update = false)
    gr_set_font(tickfont(axis), sp)
    h = (
        ticks in (nothing, false, :none) ? 0 :
            last(gr_get_ticks_size(ticks, axis[:rotation]))
    )
    if (guide = Plots.get_guide(axis)) != ""
        gr_set_font(guidefont(axis), sp)
        h += last(gr_text_size(guide))
    end
    GR.restorestate()
    return h
end

function gr_axis_width(sp, axis)
    GR.savestate()
    ticks = get_ticks(sp, axis, update = false)
    gr_set_font(tickfont(axis), sp)
    w = (
        ticks in (nothing, false, :none) ? 0 :
            first(gr_get_ticks_size(ticks, axis[:rotation]))
    )
    if (guide = Plots.get_guide(axis)) != ""
        gr_set_font(guidefont(axis), sp)
        w += last(gr_text_size(guide))
    end
    GR.restorestate()
    return w
end

function _update_min_padding!(sp::Subplot{GRBackend})
    dpi = sp.plt[:thickness_scaling]
    width, height = sp_size = get_size(sp)

    # Add margin given by the user
    padding = (
        left = Ref(2mm + sp[:left_margin]),
        top = Ref(2mm + sp[:top_margin]),
        right = Ref(2mm + sp[:right_margin]),
        bottom = Ref(2mm + sp[:bottom_margin]),
    )

    # Add margin for title
    if (title = sp[:title]) != ""
        gr_set_font(titlefont(sp), sp)
        l = last(gr_text_size(title))
        padding.top[] += 1mm + height * l * px
    end

    xaxis, yaxis, zaxis = axes = sp[:xaxis], sp[:yaxis], sp[:zaxis]
    xticks, yticks, zticks = get_ticks.(Ref(sp), axes)

    if gr_is3d(sp)
        # Add margin for x and y ticks
        m = 0mm
        for (ax, tc) in ((xaxis, xticks), (yaxis, yticks))
            isempty(first(tc)) && continue
            rot = ax[:rotation]
            gr_set_tickfont(
                sp,
                ax;
                halign = (:left, :hcenter, :right)[sign(rot) + 2],
                valign = ax[:mirror] ? :bottom : :top,
            )
            l = 0.01 + last(gr_get_ticks_size(tc, rot))
            m = max(m, 1mm + height * l * px)
        end
        if m > 0mm
            (xaxis[:mirror] || yaxis[:mirror]) && (padding.top[] += m)
            (!xaxis[:mirror] || !yaxis[:mirror]) && (padding.bottom[] += m)
        end

        if !isempty(first(zticks))
            rot = zaxis[:rotation]
            gr_set_tickfont(
                sp,
                zaxis;
                halign = zaxis[:mirror] ? :left : :right,
                valign = (:top, :vcenter, :bottom)[sign(rot) + 2],
            )
            l = 0.01 + first(gr_get_ticks_size(zticks, rot))
            padding[zaxis[:mirror] ? :right : :left][] += 1mm + width * l * px
        end

        # Add margin for x or y label
        m = 0mm
        for ax in (xaxis, yaxis)
            (guide = Plots.get_guide(ax) == "") && continue
            gr_set_font(guidefont(ax), sp)
            l = last(gr_text_size(guide))
            m = max(m, 1mm + height * l * px)
        end
        if m > 0mm
            # NOTE: `xaxis` arbitrary here ?
            padding[mirrored(xaxis, :top) ? :top : :bottom][] += m
        end
        # Add margin for z label
        if (guide = Plots.get_guide(zaxis)) != ""
            gr_set_font(guidefont(zaxis), sp)
            l = last(gr_text_size(guide))
            padding[mirrored(zaxis, :right) ? :right : :left][] += 1mm + height * l * px  # NOTE:  why `height` here ?
        end
    else
        # Add margin for x/y ticks & labels
        for (ax, tc, (a, b)) in
            ((xaxis, xticks, (:top, :bottom)), (yaxis, yticks, (:right, :left)))
            if !isempty(first(tc))
                isy = ax[:letter] === :y
                gr_set_tickfont(sp, ax)
                ts = gr_get_ticks_size(tc, ax[:rotation])
                l = 0.01 + (isy ? first(ts) : last(ts))
                padding[ax[:mirror] ? a : b][] += 1mm + sp_size[isy ? 1 : 2] * l * px
            end
            if (guide = Plots.get_guide(ax)) != ""
                gr_set_font(guidefont(ax), sp)
                l = last(gr_text_size(guide))
                padding[mirrored(ax, a) ? a : b][] += 1mm + height * l * px  # NOTE: using `height` is arbitrary
            end
        end
    end
    if (title = gr_colorbar_title(sp)).str != ""
        padding.right[] += @static if false
            sz = gr_text_size(title)
            l = is_horizontal(title) ? first(sz) : last(sz)
            l * width * px
        else
            4mm
        end
    end

    return sp.minpad = (
        dpi * padding.left[],
        dpi * padding.top[],
        dpi * padding.right[],
        dpi * padding.bottom[],
    )
end

remap(x, lo, hi) = (x - lo) / (hi - lo)
get_z_normalized(z, clims...) = isnan(z) ? 256 / 255 : remap(clamp(z, clims...), clims...)

function gr_clims(sp, args...)
    sp[:clims] === :auto || return get_clims(sp)
    lo, hi = get_clims(sp, args...)
    if lo == hi
        if lo == 0
            hi = one(hi)
        elseif lo < 0
            hi = zero(hi)
        else
            lo = zero(lo)
        end
    end
    return lo, hi
end

function gr_viewport_bbox(vp, sp, color)
    GR.savestate()
    GR.selntran(0)
    GR.setscale(0)
    gr_set_line(1, :solid, plot_color(color), sp)
    GR.drawrect(vp.xmin, vp.xmax, vp.ymin, vp.ymax)
    GR.selntran(1)
    GR.restorestate()
    return nothing
end

function gr_display(sp::Subplot{GRBackend}, w, h, vp_canvas::GRViewport)
    _update_min_padding!(sp)

    # the viewports for this subplot and the whole plot
    vp_sp = gr_viewport_from_bbox(sp, bbox(sp), w, h, vp_canvas)
    vp_plt = gr_viewport_from_bbox(sp, plotarea(sp), w, h, vp_canvas)

    # update plot viewport
    leg = gr_get_legend_geometry(vp_plt, sp)
    gr_update_viewport_legend!(vp_plt, sp, leg)
    gr_update_viewport_ratio!(vp_plt, sp)

    # fill in the plot area background
    gr_fill_plotarea(sp, vp_plt)

    # set our plot area view
    GR.setviewport(vp_plt.xmin, vp_plt.xmax, vp_plt.ymin, vp_plt.ymax)

    # set the scale flags and window
    gr_set_window(sp, vp_plt)

    # draw the axes
    gr_draw_axes(sp, vp_plt)
    gr_add_title(sp, vp_plt, vp_sp)

    _debug[] && gr_viewport_bbox(vp_sp, sp, :red)
    _debug[] && gr_viewport_bbox(vp_plt, sp, :green)

    # this needs to be here to point the colormap to the right indices
    GR.setcolormap(1_000 + GR.COLORMAP_COOLWARM)

    # init the colorbar
    cbar = GRColorbar()

    for series in series_list(sp)
        gr_add_series(sp, series)
        gr_update_colorbar!(cbar, series)
    end

    # draw the colorbar
    hascolorbar(sp) && gr_draw_colorbar(cbar, sp, vp_plt)

    # add the legend
    gr_add_legend(sp, leg, vp_plt)

    # add annotations
    for ann in sp[:annotations]
        x, y = if is3d(sp)
            x, y, z, val = locate_annotation(sp, ann...)
            GR.setwindow(-1, 1, -1, 1)
            gr_w3tondc(x, y, z)
        else
            x, y, val = locate_annotation(sp, ann...)
            GR.wctondc(x, y)
        end
        gr_set_font(val.font, sp)
        gr_text(x, y, val.str)
    end
    return
end

## Legend

gr_legend_bbox(xpos, ypos, leg) = GR.drawrect(
    xpos - leg.space - leg.span,  # see ref(1)
    xpos + leg.textw,
    ypos - 0.5leg.dy,
    ypos + 0.5leg.dy,
)

const gr_lw_clamp_factor = Ref(5)

function gr_add_legend(sp, leg, viewport_area)
    sp[:legend_position] ∈ (:none, :inline) && return
    GR.savestate()
    GR.selntran(0)
    GR.setscale(0)
    vertical = leg.vertical
    legend_rows, legend_cols = leg.column_layout
    if leg.w > 0 || leg.h > 0
        xpos, ypos = gr_legend_pos(sp, leg, viewport_area)  # position between the legend line and text (see ref(1))
        #@show vertical leg.w leg.h leg.pad leg.span leg.entries (legend_rows, legend_cols) (xpos, ypos) leg.dx leg.dy leg.textw leg.texth
        GR.setfillintstyle(GR.INTSTYLE_SOLID)
        gr_set_fillcolor(sp[:legend_background_color])
        # ymax
        # |
        # |
        # o ----- xmax
        xs = xpos - leg.pad - leg.span, xpos + leg.w + leg.pad
        ys = ypos - leg.h, ypos + leg.dy
        # xmin, xmax, ymin, ymax
        GR.fillrect(xs..., ys...)  # allocating white space for actual legend width here
        gr_set_line(1, :solid, sp[:legend_foreground_color], sp)
        GR.drawrect(xs..., ys...)  # drawing actual legend width here
        if (ttl = sp[:legend_title]) !== nothing
            shift = legend_rows > 1 ? 0.5(legend_cols - 1) * leg.dx : 0 # shifting title to center if multi-column
            gr_set_font(legendtitlefont(sp), sp)
            _debug[] && gr_legend_bbox(xpos, ypos, leg)
            gr_text(xpos - leg.pad - leg.space + 0.5leg.textw + shift, ypos, string(ttl))
            if vertical || legend_rows != 1
                legend_rows -= 1
                ypos -= leg.dy
            else
                xpos += leg.dx
            end
        end
        gr_set_font(legendfont(sp), sp; halign = :left, valign = :center)

        lft, rgt, bot, top = -leg.space - leg.span, -leg.space, -0.4leg.dy, 0.4leg.dy
        lfps = sp[:legend_font_pointsize]

        min_lw = DEFAULT_LINEWIDTH[] / gr_lw_clamp_factor[]
        max_lw = DEFAULT_LINEWIDTH[] * gr_lw_clamp_factor[]

        nentry = 1

        for series in series_list(sp)
            should_add_to_legend(series) || continue
            st = series[:seriestype]
            clims = gr_clims(sp, series)
            lc = get_linecolor(series, clims)
            lw = get_linewidth(series)
            ls = get_linestyle(series)
            la = get_linealpha(series)
            clamped_lw = (lfps / 8) * clamp(lw, min_lw, max_lw)
            gr_set_line(clamped_lw, ls, lc, sp)  # see github.com/JuliaPlots/Plots.jl/issues/3003
            _debug[] && gr_legend_bbox(xpos, ypos, leg)

            if (
                    (st === :shape || series[:fillrange] !== nothing) &&
                        series[:ribbon] === nothing
                )
                (fc = get_fillcolor(series, clims)) |> gr_set_fill
                gr_set_fillstyle(get_fillstyle(series, 0))
                l, r = xpos + lft, xpos + rgt
                b, t = ypos + bot, ypos + top
                #   4     <--     3
                # (l,t) ------- (r,t)
                #   |             |
                #   |             |
                # (l,b) ------- (r,b)
                #   1     -->     2
                x, y = [l, r, r, l, l], [b, b, t, t, b]
                gr_set_transparency(fc, get_fillalpha(series))
                gr_polyline(x, y, GR.fillarea)
                gr_set_transparency(lc, la)
                gr_set_line(clamped_lw, ls, lc, sp)
                st === :shape && gr_polyline(x, y)
            end

            max_markersize = Inf
            if st in (:path, :straightline, :path3d)
                max_markersize = leg.base_markersize
                gr_set_transparency(lc, la)
                filled = series[:fillrange] !== nothing && series[:ribbon] === nothing
                GR.polyline(xpos .+ [lft, rgt], ypos .+ (filled ? [top, top] : [0, 0]))
            end

            if (msh = series[:markershape]) !== :none
                msz = max(first(series[:markersize]), 0)
                msw = max(first(series[:markerstrokewidth]), 0)
                mfac = 0.8 * lfps / (msz + 0.5 * msw + 1.0e-20)
                gr_draw_marker(
                    series,
                    xpos - 2leg.base_factor,
                    ypos,
                    nothing,
                    clims,
                    1,
                    min(max_markersize, mfac * msz),
                    min(max_markersize, mfac * msw),
                    Plots._cycle(msh, 1),
                )
            end

            gr_set_textcolor(plot_color(sp[:legend_font_color]))
            gr_text(xpos, ypos, string(series[:label]))
            if vertical
                ypos -= leg.dy
            else
                # println(string(series[:label]), " ", nentry, " ", nentry % legend_cols)
                xpos += nentry % legend_cols == 0 ? -(legend_cols - 1) * leg.dx : leg.dx
                ypos -= nentry % legend_cols == 0 ? leg.dy : 0
                nentry += 1
            end
        end
    end
    GR.selntran(1)
    GR.restorestate()
    return nothing
end

mirrored(ax::Axis, sym::Symbol) =
    ax[:guide_position] === sym || (ax[:guide_position] === :auto && ax[:mirror])

function gr_legend_pos(sp::Subplot, leg, vp)
    xaxis, yaxis = sp[:xaxis], sp[:yaxis]
    xmirror = mirrored(xaxis, :top)
    ymirror = mirrored(yaxis, :right)
    if (lp = sp[:legend_position]) isa Real
        return gr_legend_pos(lp, leg, vp)
    elseif lp isa Tuple{<:Real, Symbol}
        axisclearance = if lp[2] === :outer
            [
                !ymirror * gr_axis_width(sp, yaxis),
                ymirror * gr_axis_width(sp, yaxis),
                !xmirror * gr_axis_height(sp, xaxis),
                xmirror * gr_axis_height(sp, xaxis),
            ]
        else
            nothing
        end
        return gr_legend_pos(lp[1], leg, vp; axisclearance)
    elseif !(lp isa Symbol)
        return gr_legend_pos(lp, vp)
    end

    leg_str = string(_guess_best_legend_position(lp, sp))

    xpos = if occursin("left", leg_str)
        vp.xmin + if occursin("outer", leg_str)
            -leg.pad - leg.w - leg.xoffset - !ymirror * gr_axis_width(sp, yaxis)
        else
            leg.pad + leg.span + leg.xoffset
        end
    elseif occursin("right", leg_str)  # default / best
        vp.xmax + if occursin("outer", leg_str)  # per github.com/jheinen/GR.jl/blob/master/src/jlgr.jl#L525
            leg.pad + leg.span + leg.xoffset + ymirror * gr_axis_width(sp, yaxis)
        else
            -leg.pad - leg.w - leg.xoffset
        end
    else
        vp.xmin + 0.5width(vp) - 0.5leg.w + leg.xoffset
    end
    ypos = if occursin("bottom", leg_str)
        vp.ymin + if lp === :outerbottom
            -leg.yoffset - leg.dy - !xmirror * gr_axis_height(sp, xaxis)
        else
            leg.yoffset + leg.h
        end
    elseif occursin("top", leg_str)  # default / best
        vp.ymax + if lp === :outertop
            leg.yoffset + leg.h + xmirror * gr_axis_height(sp, xaxis)
        else
            -leg.yoffset - leg.dy
        end
    else
        # adding min y to shift legend pos to correct graph (#2377)
        vp.ymin + 0.5height(vp) + 0.5leg.h - leg.yoffset
    end
    return xpos, ypos
end

gr_legend_pos(v::NTuple{2, Real}, vp) =
    (vp.xmin + v[1] * (vp.xmax - vp.xmin), vp.ymin + v[2] * (vp.ymax - vp.ymin))

function gr_legend_pos(theta::Real, leg, vp; axisclearance = nothing)
    if isnothing(axisclearance)  # inner
        # rectangle where the anchor can legally be
        xmin = vp.xmin + leg.xoffset + leg.pad + leg.span
        xmax = vp.xmax - leg.xoffset - leg.pad - leg.textw
        ymin = vp.ymin + leg.yoffset + leg.h
        ymax = vp.ymax - leg.yoffset - leg.dy
    else  # outer
        xmin = vp.xmin - leg.xoffset - leg.pad - leg.textw - axisclearance[1]
        xmax = vp.xmax + leg.xoffset + leg.pad + leg.span + axisclearance[2]
        ymin = vp.ymin - leg.yoffset - leg.dy - axisclearance[3]
        ymax = vp.ymax + leg.yoffset + leg.h + axisclearance[4]
    end
    return legend_pos_from_angle(theta, xmin, xcenter(vp), xmax, ymin, ycenter(vp), ymax)
end

const gr_legend_marker_to_line_factor = Ref(2.0)

function gr_get_legend_geometry(vp, sp)
    vertical = (legend_column = sp[:legend_column]) == 1
    textw = texth = 0.0
    has_title = false
    nseries = 0
    if sp[:legend_position] !== :none
        GR.savestate()
        GR.selntran(0)
        GR.setcharup(0, 1)
        GR.setscale(0)
        ttl = sp[:legend_title]
        if (has_title = ttl !== nothing)
            gr_set_font(legendtitlefont(sp), sp)
            (l, r), (b, t) = extrema.(gr_inqtext(0, 0, string(ttl)))
            texth = t - b
            textw = r - l
        end
        gr_set_font(legendfont(sp), sp)
        for series in series_list(sp)
            should_add_to_legend(series) || continue
            (l, r), (b, t) = extrema.(gr_inqtext(0, 0, string(series[:label])))
            texth = max(texth, t - b)
            textw = max(textw, r - l)  # holds text width right now
            nseries += 1
        end
        GR.setscale(GR.OPTION_X_LOG)
        GR.selntran(1)
        GR.restorestate()
    end
    # deal with layout
    column_layout = if legend_column == -1
        (1, has_title + nseries)
    elseif legend_column > nseries && nseries != 0 # catch plot_title here
        @warn "n° of legend_column=$legend_column is larger than n° of series=$nseries"
        (1 + has_title, nseries)
    elseif legend_column == 0
        @warn "n° of legend_column=$legend_column. Assuming vertical layout."
        vertical = true
        (has_title + nseries, 1)
    else
        (ceil(Int64, nseries / legend_column) + has_title, legend_column)
    end
    #println(column_layout)

    base_factor = width(vp) / 45  # determines legend box base width (arbitrarily based on `width`)

    # legend box conventions ref(1)
    #  ______________________________
    # |<pad><span><space><text> <pad>|
    # |     ---o--       ⋅ y1        |
    # |__________________↑___________|
    #               (xpos,ypos)

    pad = 1base_factor  # legend padding
    span = 3base_factor  # horizontal span of the legend line: line x marker x line = 3base_factor
    space = 0.5base_factor  # white space between text and legend / markers

    # increment between each legend entry
    ekw = sp[:extra_kwargs]
    dy = texth * get(ekw, :legend_hfactor, 1)
    span_hspace = span + pad  # part of the horizontal increment
    dx = (textw + (vertical ? 0 : span_hspace)) * get(ekw, :legend_wfactor, 1)

    # This is to prevent that linestyle is obscured by large markers.
    # We are trying to get markers to not be larger than half the line length.
    # 1 / leg.dy translates base_factor to line length units (important in the context of size kwarg)
    # gr_legend_marker_to_line_factor is an empirical constant to translate between line length unit and marker size unit
    base_markersize = gr_legend_marker_to_line_factor[] * span / dy  # NOTE: arbitrarily based on horizontal measures !

    entries = has_title + nseries  # number of legend entries

    # NOTE: subtract `span_hspace`, since it joins labels in horizontal mode
    w = dx * column_layout[2] - space - !vertical * span_hspace
    h = dy * column_layout[1]

    return (
        yoffset = height(vp) / 30,
        xoffset = width(vp) / 30,
        base_markersize,
        base_factor,
        has_title,
        vertical,
        entries,
        column_layout,
        space,
        texth,
        textw,
        span,
        pad,
        dy,
        dx,
        w,
        h,
    )
end

## Viewport, window and scale

function gr_update_viewport_legend!(vp, sp, leg)
    xaxis, yaxis = sp[:xaxis], sp[:yaxis]
    xmirror = mirrored(xaxis, :top)
    ymirror = mirrored(yaxis, :right)
    leg_str = if (lp = sp[:legend_position]) isa Tuple{<:Real, Symbol} && lp[2] === :outer
        x, y = gr_legend_pos(sp, leg, vp)  # dry run, to figure out
        horz = x < vp.xmin ? "left" : (x > vp.xmax ? "right" : "")
        vert = y < vp.ymin ? "bot" : (y > vp.ymax ? "top" : "")
        "outer" * vert * horz
    else
        string(lp)
    end
    if occursin("outer", leg_str)
        xoff = leg.xoffset + leg.w + leg.pad + leg.span + leg.pad
        yoff = leg.yoffset + leg.h + leg.dy
        if occursin("right", leg_str)
            vp.xmax -= xoff
        elseif occursin("left", leg_str)
            vp.xmin += xoff + !ymirror * gr_axis_width(sp, yaxis)
        elseif occursin("top", leg_str)
            vp.ymax -= yoff
        elseif occursin("bot", leg_str)  # NOTE: matches `bottom` or `bot`
            vp.ymin += yoff + !xmirror * gr_axis_height(sp, xaxis)
        end
    end
    if lp === :inline
        if yaxis[:mirror]
            vp.xmin += leg.textw
        else
            vp.xmax -= leg.textw
        end
    end
    return nothing
end

gr_update_viewport_ratio!(vp, sp) =
if (ratio = get_aspect_ratio(sp)) !== :none
    ratio === :equal && (ratio = 1)
    x_min, x_max, y_min, y_max = gr_xy_axislims(sp)
    viewport_ratio = width(vp) / height(vp)
    window_ratio = (x_max - x_min) / (y_max - y_min) / ratio
    if window_ratio < viewport_ratio
        viewport_center = xcenter(vp)
        viewport_size = width(vp) * window_ratio / viewport_ratio
        vp.xmin = viewport_center - 0.5viewport_size
        vp.xmax = viewport_center + 0.5viewport_size
    elseif window_ratio > viewport_ratio
        viewport_center = ycenter(vp)
        viewport_size = height(vp) * viewport_ratio / window_ratio
        vp.ymin = viewport_center - 0.5viewport_size
        vp.ymax = viewport_center + 0.5viewport_size
    end
end

gr_set_window(sp, vp) =
if ispolar(sp)
    gr_set_viewport_polar(vp)
else
    x_min, x_max, y_min, y_max = gr_xy_axislims(sp)
    zok = if (needs_3d = needs_any_3d_axes(sp))
        z_min, z_max = gr_z_axislims(sp)
        z_max > z_min
    else
        true
    end
    if x_max > x_min && y_max > y_min && zok
        scaleop = 0
        if (xscale = sp[:xaxis][:scale]) ∈ _logScales
            scaleop |= gr_x_log_scales[xscale]
        end
        if (yscale = sp[:yaxis][:scale]) ∈ _logScales
            scaleop |= gr_y_log_scales[yscale]
        end
        if needs_3d && ((zscale = sp[:zaxis][:scale]) ∈ _logScales)
            scaleop |= gr_z_log_scales[zscale]
        end
        sp[:xaxis][:flip] && (scaleop |= GR.OPTION_FLIP_X)
        sp[:yaxis][:flip] && (scaleop |= GR.OPTION_FLIP_Y)
        (needs_3d && sp[:zaxis][:flip]) && (scaleop |= GR.OPTION_FLIP_Z)
        # NOTE: setwindow sets the "data coordinate" limits of the current "viewport"
        GR.setwindow(x_min, x_max, y_min, y_max)
        GR.setscale(scaleop)
    end
end

## Axes

function gr_draw_axes(sp, vp)
    GR.setlinewidth(sp.plt[:thickness_scaling])
    if gr_is3d(sp)
        # set space
        x_min, x_max, y_min, y_max = gr_xy_axislims(sp)
        z_min, z_max = gr_z_axislims(sp)

        azimuth, elevation = sp[:camera]

        GR.setwindow3d(x_min, x_max, y_min, y_max, z_min, z_max)
        fov = (isortho(sp) || isautop(sp)) ? NaN : 30
        cam = (isortho(sp) || isautop(sp)) ? 0 : NaN
        GR.setspace3d(-90 + azimuth, 90 - elevation, fov, cam)
        gr_set_projectiontype(sp)

        # fill the plot area
        gr_set_fill(plot_color(sp[:background_color_inside]))
        area_x = [x_min, x_min, x_min, x_max, x_max, x_max, x_min]
        area_y = [y_min, y_min, y_max, y_max, y_max, y_min, y_min]
        area_z = [z_min, z_max, z_max, z_max, z_min, z_min, z_min]
        x_bg, y_bg = RecipesPipeline.unzip(GR.wc3towc.(area_x, area_y, area_z))
        GR.fillarea(x_bg, y_bg)

        foreach(letter -> gr_draw_axis_minorgrid_3d(sp, letter, vp), (:x, :y, :z))
        foreach(letter -> gr_draw_axis_grid_3d(sp, letter, vp), (:x, :y, :z))
        foreach(letter -> gr_draw_axis_3d(sp, letter, vp), (:x, :y, :z))
    elseif ispolar(sp)
        r = gr_set_viewport_polar(vp)
        # rmin, rmax = GR.adjustrange(ignorenan_minimum(r), ignorenan_maximum(r))
        rmin, rmax = axis_limits(sp, :y)
        gr_polaraxes(rmin, rmax, sp)
    elseif sp[:framestyle] !== :none
        foreach(letter -> gr_draw_axis_minorgrid(sp, letter, vp), (:x, :y))
        foreach(letter -> gr_draw_axis_grid(sp, letter, vp), (:x, :y))
        foreach(letter -> gr_draw_axis(sp, letter, vp), (:x, :y))
    end
    GR.settransparency(1.0)
    return nothing
end

function gr_draw_axis_minorgrid_3d(sp, letter, vp)
    ax = axis_drawing_info_3d(sp, letter)
    axis = sp[get_attr_symbol(letter, :axis)]
    return gr_draw_minorgrid(sp, axis, ax.minorgrid_segments, gr_polyline3d)
end

function gr_draw_axis_grid_3d(sp, letter, vp)
    ax = axis_drawing_info_3d(sp, letter)
    axis = sp[get_attr_symbol(letter, :axis)]
    return gr_draw_grid(sp, axis, ax.grid_segments, gr_polyline3d)
end

function gr_draw_axis_minorgrid(sp, letter, vp)
    ax = axis_drawing_info(sp, letter)
    axis = sp[get_attr_symbol(letter, :axis)]
    return gr_draw_minorgrid(sp, axis, ax.minorgrid_segments)
end

function gr_draw_axis_grid(sp, letter, vp)
    ax = axis_drawing_info(sp, letter)
    axis = sp[get_attr_symbol(letter, :axis)]
    return gr_draw_grid(sp, axis, ax.grid_segments)
end

function gr_draw_axis(sp, letter, vp)
    ax = axis_drawing_info(sp, letter)
    axis = sp[get_attr_symbol(letter, :axis)]

    # draw segments
    gr_draw_spine(sp, axis, ax.segments)
    gr_draw_border(sp, axis, ax.border_segments)
    gr_draw_ticks(sp, axis, ax.tick_segments)

    # labels
    gr_label_ticks(sp, letter, ax.ticks)
    gr_label_axis(sp, letter, vp)
    return nothing
end

function gr_draw_axis_3d(sp, letter, vp)
    ax = axis_drawing_info_3d(sp, letter)
    axis = sp[get_attr_symbol(letter, :axis)]

    # draw segments
    gr_draw_spine(sp, axis, ax.segments, gr_polyline3d)
    gr_draw_border(sp, axis, ax.border_segments, gr_polyline3d)
    gr_draw_ticks(sp, axis, ax.tick_segments, gr_polyline3d)

    # labels
    GR.setscale(0)
    gr_label_ticks_3d(sp, letter, ax.ticks)
    gr_label_axis_3d(sp, letter)
    gr_set_window(sp, vp)
    return nothing
end

gr_draw_grid(sp, axis, segments, func = gr_polyline) =
if axis[:grid]
    gr_set_line(
        axis[:gridlinewidth],
        axis[:gridstyle],
        axis[:foreground_color_grid],
        sp,
    )
    gr_set_transparency(axis[:foreground_color_grid], axis[:gridalpha])
    func(coords(segments)...)
end

gr_draw_minorgrid(sp, axis, segments, func = gr_polyline) =
if axis[:minorgrid]
    gr_set_line(
        axis[:minorgridlinewidth],
        axis[:minorgridstyle],
        axis[:foreground_color_minor_grid],
        sp,
    )
    gr_set_transparency(axis[:foreground_color_minor_grid], axis[:minorgridalpha])
    func(coords(segments)...)
end

gr_draw_spine(sp, axis, segments, func = gr_polyline) =
if axis[:showaxis]
    gr_set_line(1, :solid, axis[:foreground_color_border], sp)
    gr_set_transparency(1.0)
    GR.setclip(0)
    func(coords(segments)...)
    GR.setclip(1)
end

gr_draw_border(sp, axis, segments, func = gr_polyline) =
if sp[:framestyle] in (:box, :semi)
    intensity = sp[:framestyle] === :semi ? 0.5 : 1
    GR.setclip(0)
    gr_set_line(intensity, :solid, axis[:foreground_color_border], sp)
    gr_set_transparency(axis[:foreground_color_border], intensity)
    func(coords(segments)...)
    GR.setclip(1)
end

gr_draw_ticks(sp, axis, segments, func = gr_polyline) =
if axis[:showaxis]
    if sp[:framestyle] in (:zerolines, :grid)
        gr_set_line(1, :solid, axis[:foreground_color_grid], sp)
        gr_set_transparency(
            axis[:foreground_color_grid],
            axis[:tick_direction] === :out ? axis[:gridalpha] : 0,
        )
    else
        gr_set_line(1, :solid, axis[:foreground_color_axis], sp)
    end
    GR.setclip(0)
    func(coords(segments)...)
    GR.setclip(1)
end

function gr_label_ticks(sp, letter, ticks)
    letters = axes_letters(sp, letter)
    ax, oax = map(l -> sp[get_attr_symbol(l, :axis)], letters)
    ax[:showaxis] || return
    _, (oamin, oamax) = map(l -> axis_limits(sp, l), letters)

    gr_set_tickfont(sp, letter)
    out_factor = ifelse(ax[:tick_direction] === :out, 1.5, 1)

    isy = letter === :y
    x_offset = isy ? -0.015out_factor : 0
    y_offset = isy ? 0 : -0.008out_factor

    rot = ax[:rotation] % 360
    ov = sp[:framestyle] === :origin ? 0 : xor(oax[:flip], ax[:mirror]) ? oamax : oamin
    sgn = ax[:mirror] ? -1 : 1
    sgn2 = iseven(Int(floor(rot / 90))) ? -1 : 1
    sgn3 = if isy
        -360 < rot < -180 || 0 < rot < 180 ? 1 : -1
    else
        rot < -270 || -90 < rot < 90 || rot > 270 ? 1 : -1
    end
    for (cv, dv) in zip(ticks...)
        x, y = GR.wctondc(reverse_if((cv, ov), isy)...)
        sz_rot, sz = gr_text_size(dv, rot), gr_text_size(dv)
        x_off, y_off = x_offset, y_offset
        if isy
            x_off += -first(sz_rot) / 2
            if rot % 90 != 0
                y_off += 0.5(sgn2 * last(sz_rot) + sgn3 * last(sz) * cosd(rot))
            end
        else
            if rot % 90 != 0
                x_off += 0.5(sgn2 * first(sz_rot) + sgn3 * last(sz) * sind(rot))
            end
            y_off += -last(sz_rot) / 2
        end
        gr_text(x + sgn * x_off, y + sgn * y_off, dv)
    end
    return
end

gr_label_ticks(sp, letter, ticks::Nothing) = nothing

function gr_label_ticks_3d(sp, letter, ticks)
    letters = axes_letters(sp, letter)
    _, (namin, namax), (famin, famax) = map(l -> axis_limits(sp, l), letters)
    ax = sp[get_attr_symbol(letter, :axis)]
    ax[:showaxis] || return

    isy, isz = letter .=== (:y, :z)
    n0, n1 = isy ? (namax, namin) : (namin, namax)

    gr_set_tickfont(sp, letter)
    nt = sp[:framestyle] === :origin ? 0 : ax[:mirror] ? n1 : n0
    ft = sp[:framestyle] === :origin ? 0 : ax[:mirror] ? famax : famin

    rot = mod(ax[:rotation], 360)
    sgn = ax[:mirror] ? -1 : 1

    cvs, dvs = ticks

    axisθ = isz ? 270 : mod(gr_get_3d_axis_angle(cvs, nt, ft, letter), 360)  # issue: doesn't work with 1 tick
    axisϕ = mod(axisθ - 90, 360)

    out_factor = ifelse(ax[:tick_direction] === :out, 1.5, 1)
    axis_offset = 0.012out_factor
    y_offset, x_offset = axis_offset .* sincosd(axisϕ)

    sgn2a = sgn2b = sgn3 = 0
    if axisθ != 0 || rot % 90 != 0
        sgn2a =
            (axisθ != 90) && (axisθ == 0 && (rot < 90 || 180 ≤ rot < 270)) ||
            (axisθ == 270) ||
            (axisθ < 90 && (axisθ < rot < 90 || axisθ + 180 < rot < 270)) ||
            (axisθ > 270 && (rot < 90 || axisθ - 180 < rot < 270 || rot > axisθ)) ? -1 : 1
    end

    if (axisθ - 90) % 180 != 0 || (rot - 90) % 180 != 0
        sgn2b =
            axisθ == 0 ||
            (axisθ == 90 && (90 ≤ rot < 180 || 270 ≤ rot < 360)) ||
            (axisθ == 270 && (rot < 90 || 180 ≤ rot < 270)) ||
            (axisθ < 90 && (axisθ < rot < 180 || axisθ + 180 < rot)) ||
            (axisθ > 270 && (rot < axisθ - 180 || 180 ≤ rot < axisθ)) ? -1 : 1
    end

    if !(axisθ == 0 && rot % 180 == 0) && (rot - 90) % 180 != 0
        sgn3 =
            (axisθ == 0 && 90 < rot < 270) ||
            (axisθ == 90 && rot < 180) ||
            (axisθ == 270 && rot > 180) ||
            (axisθ < 90 && (rot < axisθ || 90 ≤ rot < 180 || axisθ + 180 < rot < 270)) ||
            (axisθ > 270 && (90 ≤ rot < axisθ - 180 || 180 ≤ rot < 270 || rot > axisθ)) ?
            -1 : 1
    end

    GR.setwindow(-1, 1, -1, 1)
    for (cv, dv) in zip((ax[:flip] ? reverse(cvs) : cvs, dvs)...)
        xi, yi = gr_w3tondc(sort_3d_axes(cv, nt, ft, letter)...)
        sz_rot, sz = gr_text_size(dv, rot), gr_text_size(dv)
        x_off = x_offset + 0.5(sgn2a * first(sz_rot) + sgn3 * last(sz) * sind(rot))
        y_off = y_offset + 0.5(sgn2b * last(sz_rot) + sgn3 * last(sz) * cosd(rot))
        gr_text(xi + sgn * x_off, yi + sgn * y_off, dv)
    end
    return
end

function gr_label_axis(sp, letter, vp)
    ax = sp[get_attr_symbol(letter, :axis)]
    return if Plots.get_guide(ax) != ""
        mirror = ax[:mirror]
        GR.savestate()
        guide_position = ax[:guide_position]
        rotation = float(ax[:guidefontrotation])  # github.com/JuliaPlots/Plots.jl/issues/3089
        if letter === :x
            # default rotation = 0. should yield GR.setcharup(0, 1) i.e. 90°
            xpos = xposition(vp, position(ax[:guidefonthalign]))
            halign = alignment(ax[:guidefonthalign])
            ypos, valign =
            if guide_position === :top || (guide_position === :auto && mirror)
                vp.ymax + 0.015 + (mirror ? gr_axis_height(sp, ax) : 0.015), :top
            else
                vp.ymin - 0.015 - (mirror ? 0.015 : gr_axis_height(sp, ax)), :bottom
            end
        else
            rotation += 90  # default rotation = 0. should yield GR.setcharup(-1, 0) i.e. 180°
            ypos = yposition(vp, position(ax[:guidefontvalign]))
            halign = alignment(ax[:guidefontvalign])
            xpos, valign =
            if guide_position === :right || (guide_position === :auto && mirror)
                vp.xmax + 0.03 + mirror * gr_axis_width(sp, ax), :bottom
            else
                vp.xmin - 0.03 - !mirror * gr_axis_width(sp, ax), :top
            end
        end
        gr_set_font(guidefont(ax), sp; rotation, halign, valign)
        gr_text(xpos, ypos, Plots.get_guide(ax))
        GR.restorestate()
    end
end

function gr_label_axis_3d(sp, letter)
    ax = sp[get_attr_symbol(letter, :axis)]
    return if Plots.get_guide(ax) != ""
        letters = axes_letters(sp, letter)
        (amin, amax), (namin, namax), (famin, famax) = map(l -> axis_limits(sp, l), letters)
        n0, n1 = letter === :y ? (namax, namin) : (namin, namax)

        GR.savestate()
        gr_set_font(
            guidefont(ax),
            sp,
            halign = (:left, :hcenter, :right)[sign(ax[:rotation]) + 2],
            valign = ax[:mirror] ? :bottom : :top,
            rotation = ax[:rotation],
            # color = ax[:guidefontcolor],
        )
        ag = 0.5(amin + amax)
        ng = ax[:mirror] ? n1 : n0
        fg = ax[:mirror] ? famax : famin
        x, y = gr_w3tondc(sort_3d_axes(ag, ng, fg, letter)...)
        if letter in (:x, :y)
            h = gr_axis_height(sp, ax)
            x_offset = letter === :x ? -h : h
            y_offset = -h
        else
            x_offset = -0.03 - gr_axis_width(sp, ax)
            y_offset = 0
        end
        letter === :z && GR.setcharup(-1, 0)
        sgn = ax[:mirror] ? -1 : 1
        gr_text(x + sgn * x_offset, y + sgn * y_offset, Plots.get_guide(ax))
        GR.restorestate()
    end
end

gr_add_title(sp, vp_plt, vp_sp) =
if (title = sp[:title]) != ""
    GR.savestate()
    xpos, ypos, halign, valign = if (loc = sp[:titlelocation]) === :left
        vp_plt.xmin, vp_sp.ymax, :left, :top
    elseif loc === :center
        xcenter(vp_plt), vp_sp.ymax, :center, :top
    elseif loc === :right
        vp_plt.xmax, vp_sp.ymax, :right, :top
    else
        xposition(vp_plt, loc[1]),
            yposition(vp_plt, loc[2]),
            sp[:titlefonthalign],
            sp[:titlefontvalign]
    end
    gr_set_font(titlefont(sp), sp; halign, valign)
    gr_text(xpos, ypos, title)
    GR.restorestate()
end

## Series

function gr_add_series(sp, series)
    # update the current stored gradient
    gr_set_gradient(series)

    GR.savestate()

    x, y, z = map(letter -> handle_surface(series[letter]), (:x, :y, :z))
    xscale, yscale = sp[:xaxis][:scale], sp[:yaxis][:scale]
    frng = series[:fillrange]

    # recompute data
    if ispolar(sp) && z === nothing
        extrema_r = gr_y_axislims(sp)
        if frng !== nothing
            _, frng = convert_to_polar(x, frng, extrema_r)
        end
        x, y = convert_to_polar(x, y, extrema_r)
    end

    # add custom frame shapes to markershape?
    series_annotations_shapes!(series)
    # -------------------------------------------------------

    gr_is3d(sp) && gr_set_projectiontype(sp)

    # draw the series
    clims = gr_clims(sp, series)
    if (st = series[:seriestype]) in (:path, :scatter, :straightline)
        if st === :straightline
            x, y = straightline_data(series)
        end
        gr_draw_segments(series, x, y, nothing, frng, clims)
        if series[:markershape] !== :none
            gr_draw_markers(series, x, y, nothing, clims)
        end
    elseif st === :shape
        gr_draw_shapes(series, clims)
    elseif st in (:path3d, :scatter3d)
        gr_draw_segments(series, x, y, z, nothing, clims)
        if st === :scatter3d || series[:markershape] !== :none
            gr_draw_markers(series, x, y, z, clims)
        end
    elseif st === :contour
        gr_draw_contour(series, x, y, z, clims)
    elseif st in (:surface, :wireframe, :mesh3d)
        GR.setwindow(-1, 1, -1, 1)
        gr_draw_surface(series, x, y, z, clims)
    elseif st === :volume
        sp[:legend_position] = :none
        GR.gr3.clear()
    elseif st === :heatmap
        # `z` is already transposed, so we need to reverse before passing its size.
        x, y = heatmap_edges(x, xscale, y, yscale, reverse(size(z)), ispolar(series))
        gr_draw_heatmap(series, x, y, z, clims)
    elseif st === :image
        gr_draw_image(series, x, y, z, clims)
    end

    # this is all we need to add the series_annotations text
    for (xi, yi, str, fnt) in EachAnn(series[:series_annotations], x, y)
        gr_set_font(fnt, sp)
        gr_text(GR.wctondc(xi, yi)..., str)
    end

    if sp[:legend_position] === :inline && should_add_to_legend(series)
        gr_set_textcolor(plot_color(sp[:legend_font_color]))
        offset, halign, valign = if sp[:yaxis][:mirror]
            _, i = sp[:xaxis][:flip] ? findmax(x) : findmin(x)
            -0.01, :right, :center
        else
            _, i = sp[:xaxis][:flip] ? findmin(x) : findmax(x)
            +0.01, :left, :center
        end
        gr_set_font(legendfont(sp), sp; halign, valign)
        x_l, y_l = GR.wctondc(x[i], y[i])
        gr_text(x_l + offset, y_l, series[:label])
    end
    GR.restorestate()
    return nothing
end

function gr_draw_segments(series, x, y, z, fillrange, clims)
    (x === nothing || length(x) ≤ 1) && return
    if fillrange !== nothing  # prepare fill-in
        GR.setfillintstyle(GR.INTSTYLE_SOLID)
        fr_from, fr_to = is_2tuple(fillrange) ? fillrange : (y, fillrange)
    end

    # draw the line(s)
    st = series[:seriestype]
    for segment in series_segments(series, st; check = true)
        i, rng = segment.attr_index, segment.range
        isempty(rng) && continue
        is3d = st === :path3d && z !== nothing
        is2d = st === :path || st === :straightline
        if is2d && fillrange !== nothing
            (fc = get_fillcolor(series, clims, i)) |> gr_set_fillcolor
            gr_set_fillstyle(get_fillstyle(series, i))
            fx = _cycle(x, vcat(rng, reverse(rng)))
            fy = vcat(_cycle(fr_from, rng), _cycle(fr_to, reverse(rng)))
            gr_set_transparency(fc, get_fillalpha(series, i))
            GR.fillarea(fx, fy)
        end
        (lc = get_linecolor(series, clims, i)) |> gr_set_fillcolor
        gr_set_line(get_linewidth(series, i), get_linestyle(series, i), lc, series)
        gr_set_transparency(lc, get_linealpha(series, i))
        if is3d
            GR.polyline3d(x[rng], y[rng], z[rng])
        elseif is2d
            arrowside, arrowstyle = if (arrow = series[:arrow]) isa Arrow
                arrow.side, arrow.style
            else
                :none, :simple
            end
            gr_polyline(x[rng], y[rng]; arrowside = arrowside, arrowstyle = arrowstyle)
        end
    end
    return
end

function gr_draw_markers(
        series::Series,
        x,
        y,
        z,
        clims,
        msize = series[:markersize],
        strokewidth = series[:markerstrokewidth],
    )
    isempty(x) && return
    GR.setfillintstyle(GR.INTSTYLE_SOLID)
    (shapes = series[:markershape]) === :none && return
    for segment in series_segments(series, :scatter)
        rng = intersect(eachindex(IndexLinear(), x), segment.range)
        isempty(rng) && continue
        i = segment.attr_index
        ms = get_thickness_scaling(series) * _cycle(msize, i)
        msw = get_thickness_scaling(series) * _cycle(strokewidth, i)
        shape = _cycle(shapes, i)
        for j in rng
            gr_draw_marker(
                series,
                _cycle(x, j),
                _cycle(y, j),
                _cycle(z, j),
                clims,
                i,
                ms,
                msw,
                shape,
            )
        end
    end
    return
end

function gr_draw_shapes(series, clims)
    x, y = shape_data(series)
    for segment in series_segments(series, :shape)
        i, rng = segment.attr_index, segment.range
        if length(rng) > 1
            # connect to the beginning
            rng = vcat(rng, rng[1])

            # get the segments
            xseg, yseg = x[rng], y[rng]

            # draw the interior
            fc = get_fillcolor(series, clims, i)
            gr_set_fill(fc)
            fs = get_fillstyle(series, i)
            gr_set_fillstyle(fs)
            gr_set_transparency(fc, get_fillalpha(series, i))
            GR.fillarea(xseg, yseg)

            # draw the shapes
            lc = get_linecolor(series, clims, i)
            gr_set_line(get_linewidth(series, i), get_linestyle(series, i), lc, series)
            gr_set_transparency(lc, get_linealpha(series, i))
            GR.polyline(xseg, yseg)
        end
    end
    return
end

function gr_draw_contour(series, x, y, z, clims)
    GR.setprojectiontype(0)
    GR.setspace(clims[1], clims[2], 0, 90)
    gr_set_line(get_linewidth(series), get_linestyle(series), get_linecolor(series), series)
    gr_set_transparency(get_fillalpha(series))
    h = gr_contour_levels(series, clims)
    if series[:fillrange] !== nothing
        GR.contourf(x, y, h, z, Int(series[:contour_labels] == true))
    else
        black = plot_color(:black)
        coff = plot_color(series[:linecolor]) in (black, [black]) ? 0 : 1_000
        GR.contour(x, y, h, z, coff + Int(series[:contour_labels] == true))
    end
    return nothing
end

function gr_draw_surface(series, x, y, z, clims)
    e_kwargs = series[:extra_kwargs]
    if (st = series[:seriestype]) === :surface
        if ndims(x) == ndims(y) == ndims(z) == 2
            GR.gr3.surface(x', y', z, GR.OPTION_3D_MESH)
        else
            fillalpha = get_fillalpha(series)
            fillcolor = get_fillcolor(series)
            # NOTE: setting nx = 0 or ny = 0 disables GR.gridit interpolation
            nx, ny = get(e_kwargs, :nx, 200), get(e_kwargs, :ny, 200)
            if length(x) == length(y) == length(z) && nx > 0 && ny > 0
                x, y, z = GR.gridit(x, y, z, nx, ny)
            end
            d_opt = get(e_kwargs, :display_option, GR.OPTION_COLORED_MESH)
            if (!isnothing(fillalpha) && fillalpha < 1) || alpha(first(fillcolor)) < 1
                gr_set_transparency(fillcolor, fillalpha)
                GR.surface(x, y, z, d_opt)
            else
                GR.gr3.surface(x, y, z, d_opt)
            end
        end
    elseif st === :wireframe
        GR.setfillcolorind(0)
        GR.surface(x, y, z, get(e_kwargs, :display_option, GR.OPTION_FILLED_MESH))
    elseif st === :mesh3d
        if series[:connections] isa AbstractVector{<:AbstractVector{Int}}
            # Combination of any polygon types
            cns = map(cns -> [length(cns), cns...], series[:connections])
        elseif series[:connections] isa AbstractVector{NTuple{N, Int}} where {N}
            # Only N-gons - connections have to be 1-based (indexing)
            N = length(series[:connections][1])
            cns = map(cns -> [N, cns...], series[:connections])
        elseif series[:connections] isa NTuple{3, <:AbstractVector{Int}}
            # Only triangles - connections have to be 0-based (indexing)
            ci, cj, ck = series[:connections]
            if !(length(ci) == length(cj) == length(ck))
                "Argument connections must consist of equally sized arrays." |>
                    ArgumentError |>
                    throw
            end
            cns = map(i -> ([3, ci[i] + 1, cj[i] + 1, ck[i] + 1]), eachindex(ci))
        else
            "Unsupported `:connections` type $(typeof(series[:connections])) for seriestype=$st" |>
                ArgumentError |>
                throw
        end
        facecolor = if series[:fillcolor] isa AbstractArray
            series[:fillcolor]
        else
            fill(series[:fillcolor], length(cns))
        end
        fillalpha = get_fillalpha(series)
        facecolor = map(fc -> set_RGBA_alpha(fillalpha, fc), facecolor)
        GR.setborderwidth(get_linewidth(series))
        GR.setbordercolorind(gr_getcolorind(get_linecolor(series)))
        GR.polygonmesh3d(x, y, z, vcat(cns...), signed.(gr_color.(facecolor)))
    else
        throw(ArgumentError("Not handled !"))
    end
    return nothing
end

function gr_z_normalized_log_scaled(scale, z, clims)
    sf = RecipesPipeline.scale_func(scale)
    z_log = replace(x -> isinf(x) ? NaN : x, sf.(z))
    loglims = (
        !isfinite(sf(clims[1])) ? minimum(z_log) : sf(clims[1]),
        !isfinite(sf(clims[2])) ? maximum(z_log) : sf(clims[2]),
    )
    any(x -> !isfinite(x), loglims) && throw(
        DomainError(
            loglims,
            "Non-finite value in colorbar limits. Please provide explicits limits via `clims`.",
        ),
    )
    return z_log, get_z_normalized.(z_log, loglims...)
end

function gr_draw_heatmap(series, x, y, z, clims)
    fillgrad = _as_gradient(series[:fillcolor])
    GR.setprojectiontype(0)
    GR.setspace(clims..., 0, 90)
    w, h = length(x) - 1, length(y) - 1
    sp = series[:subplot]
    if !ispolar(series) && is_uniformly_spaced(x) && is_uniformly_spaced(y)
        # For uniformly spaced data use GR.drawimage, which can be
        # much faster than GR.nonuniformcellarray, especially for
        # pdf output, and also supports alpha values.
        # Note that drawimage draws uniformly spaced data correctly
        # even on log scales, where it is visually non-uniform.
        _z, colors = if (scale = sp[:colorbar_scale]) === :identity
            z, plot_color.(get(fillgrad, z, clims), series[:fillalpha])
        elseif scale ∈ _logScales
            z_log, z_normalized = gr_z_normalized_log_scaled(scale, z, clims)
            z_log, plot_color.(map(z -> get(fillgrad, z), z_normalized), series[:fillalpha])
        end
        for i in eachindex(colors)
            isnan(_z[i]) && (colors[i] = set_RGBA_alpha(0, colors[i]))
        end
        GR.drawimage(first(x), last(x), last(y), first(y), w, h, gr_color.(colors))
    else
        if something(series[:fillalpha], 1) < 1
            @warn "GR: transparency not supported in non-uniform heatmaps. Alpha values ignored."
        end
        _z, z_normalized = if (scale = sp[:colorbar_scale]) === :identity
            z, get_z_normalized.(z, clims...)
        elseif scale ∈ _logScales
            gr_z_normalized_log_scaled(scale, z, clims)
        end
        rgba = map(x -> round(Int32, 1_000 + 255x), z_normalized)
        bg_rgba = gr_getcolorind(plot_color(sp[:background_color_inside]))
        for i in eachindex(rgba)
            isnan(_z[i]) && (rgba[i] = bg_rgba)
        end
        if ispolar(series)
            y[1] < 0 && @warn "'y[1] < 0' (rmin) is not yet supported."
            rad_max = gr_y_axislims(sp)[2]
            GR.setwindow(-rad_max, rad_max, -rad_max, rad_max)  # square ar
            # nonuniformpolarcellarray(θ, ρ, nx, ny, color)
            GR.nonuniformpolarcellarray(rad2deg.(x), y, w, h, rgba)
        else
            GR.nonuniformcellarray(x, y, w, h, rgba)
        end
    end
    return nothing
end

function gr_draw_image(series, x, y, z, clims)
    x_min, x_max = ignorenan_extrema(x)
    y_min, y_max = ignorenan_extrema(y)
    GR.drawimage(x_min, x_max, y_max, y_min, size(z)..., gr_color.(z))
    return nothing
end

# ----------------------------------------------------------------

for (mime, fmt) in (
        "application/pdf" => "pdf",
        "image/png" => "png",
        "application/postscript" => "ps",
        "image/svg+xml" => "svg",
    )
    @eval function _show(io::IO, ::MIME{Symbol($mime)}, plt::Plot{GRBackend})
        dpi_factor = $fmt == "png" ? plt[:dpi] / Plots.DPI : 1
        filepath = tempname() * "." * $fmt
        # workaround  windows bug github.com/JuliaLang/julia/issues/46989
        touch(filepath)
        if plt[:overwrite_figure] # this is the default
            withenv(
                "GKS_ENCODING" => "utf8",
            ) do
                # ensure that the canvas' workstation viewport ist set
                gr_display(plt, dpi_factor, false)

                GR.beginprint(filepath)
                gr_display(plt, dpi_factor)
                GR.endprint()
            end
        else
            GR.emergencyclosegks()
            withenv(
                "GKS_FILEPATH" => filepath,
                "GKS_ENCODING" => "utf8",
                "GKSwstype" => $fmt,
            ) do
                gr_display(plt, dpi_factor)
            end
            GR.emergencyclosegks()
        end
        write(io, read(filepath, String))
        return rm(filepath)
    end
end

function _display(plt::Plot{GRBackend})
    return if plt[:display_type] === :inline
        filepath = tempname() * ".pdf"
        GR.emergencyclosegks()
        withenv(
            "GKS_FILEPATH" => filepath,
            "GKS_ENCODING" => "utf8",
            "GKSwstype" => "pdf",
        ) do
            gr_display(plt)
        end
        GR.emergencyclosegks()
        println(
            "\033]1337;File=inline=1;preserveAspectRatio=0:",
            base64encode(open(read, filepath)),
            "\a",
        )
        rm(filepath)
    else
        withenv("GKS_ENCODING" => "utf8", "GKS_DOUBLE_BUF" => true) do
            gr_display(plt)
        end
    end
end

closeall(::GRBackend) = GR.emergencyclosegks()

import Unitful: m, s, cm, DimensionError
import Plots: PLOTS_SEED, Plot, with
import SentinelArrays: ChainedVector
import GeometryBasics
import OffsetArrays
import ImageMagick
import FreeType  # for `unicodeplots`
import LibGit2
import Aqua
import JSON

using VisualRegressionTests
using RecipesPipeline
using FilePathsBase
using LaTeXStrings
using RecipesBase
using TestImages
using Unitful
using FileIO
using Plots
using Dates
using Test
using Gtk  # see JuliaPlots/VisualRegressionTests.jl/issues/30

# NOTE: don't use `plotly` (test hang, not surprised), test only the backends used in the docs
const TEST_BACKENDS = :gr, :unicodeplots, :pythonplot, :pgfplotsx, :plotlyjs, :gaston

# initial load - required for `should_warn_on_unsupported`
unicodeplots()
pgfplotsx()
plotlyjs()
hdf5()
gr()

is_auto() = Plots.bool_env("VISUAL_REGRESSION_TESTS_AUTO", "false")
is_pkgeval() = Plots.bool_env("JULIA_PKGEVAL", "false")
is_ci() = Plots.bool_env("CI", "false")

for name in (
        "quality",
        "misc",
        "utils",
        "args",
        "defaults",
        "dates",
        "axes",
        "layouts",
        "contours",
        "components",
        "shorthands",
        "recipes",
        "unitful",
        "hdf5plots",
        "pgfplotsx",
        "plotly",
        "animations",
        "output",
        "backends",
    )
    @testset "$name" begin
        if is_auto() || is_pkgeval()
            # skip the majority of tests if we only want to update reference images or under `PkgEval` (timeout limit)
            name != "backends" && continue
        end
        gr()  # reset to default backend (safer)
        include("test_$name.jl")
    end
end

# https://github.com/mbaz/Gaston.

should_warn_on_unsupported(::GastonBackend) = false

# create the window/figure for this backend.
function _create_backend_figure(plt::Plot{GastonBackend})
    return plt.o = Gaston.Figure(nothing; autolayout = false)  # for now all the figures will be kept
end

function _before_layout_calcs(plt::Plot{GastonBackend})
    # initialize all the subplots first
    foreach(sp -> gaston_init_subplot!(plt, sp), unique(plt.inset_subplots))

    if length(plt.subplots) > 0
        n, sps = gaston_get_subplots(0, plt.subplots, plt.layout)
    end

    r, c = gaston_init_subplots!(plt, sps)
    plt.o.multiplot = "layout $r,$c columnsfirst"

    # then add the series (curves in gaston)
    foreach(series -> gaston_add_series(plt, series), plt.series_list)

    for sp in plt.subplots
        sp === nothing && continue
        for ann in sp[:annotations]
            x, y, val = locate_annotation(sp, ann...)
            sp.o.settings *= "; set label '$(val.str)' at $x,$y $(gaston_font(val.font))"
        end
        if _debug[]
            sp.o.settings = replace(sp.o.settings, "; " => "\n")
            println(sp.o.settings)
            foreach(x -> println("== n°$(x[1]) ==\n", x[2].conf), enumerate(sp.o.curves))
        end
    end
    return nothing
end

_update_min_padding!(sp::Subplot{GastonBackend}) = sp.minpad = 0mm, 0mm, 0mm, 0mm

function _update_plot_object(plt::Plot{GastonBackend})
    # respect the layout ratio
    dat = gaston_multiplot_pos_size(plt.layout, (0, 0, 1, 1))
    gaston_multiplot_pos_size!(dat)
    return nothing
end

for (mime, term) in (
        "application/eps" => "epscairo",
        "image/eps" => "epslatex",
        "application/pdf" => "pdfcairo",
        "application/postscript" => "postscript",
        "image/png" => "png",
        "image/svg+xml" => "svg",
        "text/latex" => "tikz",
        "application/x-tex" => "epslatex",
        "text/plain" => "dumb",
    )
    @eval function _show(io::IO, ::MIME{Symbol($mime)}, plt::Plot{GastonBackend})
        if plt.o ≢ nothing
            term = String($term)
            filename = tempname() * ".$term"
            Gaston.producefigure(plt.o; filename, term = "$term $(gaston_saveopts(plt))")
            while !isfile(filename)
            end  # avoid race condition with read in next line
            write(io, read(filename))
            rm(filename; force = true)
        end
        return nothing
    end
end

_display(plt::Plot{GastonBackend}) = display(plt.o)

# --------------------------------------------
# These functions are Gaston specific
# --------------------------------------------

function gaston_saveopts(plt::Plot{GastonBackend})
    saveopts = ["size " * join(plt[:size], ',')]

    # scale all plot elements to match Plots.jl DPI standard
    scaling = plt[:dpi] / Plots.DPI

    push!(
        saveopts,
        gaston_font(
            plottitlefont(plt),
            rot = false,
            align = false,
            color = false,
            scale = 1,
        ),
        "background $(gaston_color(plt[:background_color]))",
        # "title '$(plt[:plot_title])'",  # FIXME: save hangs
        "fontscale $scaling lw $scaling dl $scaling",  # ps $scaling
    )

    return join(saveopts, " ")
end

function gaston_get_subplots(n, plt_subplots, layout)
    nr, nc = size(layout)
    sps = Array{Any}(nothing, nr, nc)
    for r in 1:nr, c in 1:nc  # NOTE: col major
        sps[r, c] = if (l = layout[r, c]) isa GridLayout
            n, sub = gaston_get_subplots(n, plt_subplots, l)
            size(sub) == (1, 1) ? only(sub) : sub
        else
            if get(l.attr, :blank, false)
                nothing
            else
                n += 1
                l
            end
        end
    end
    return n, sps
end

function gaston_init_subplots!(plt, sps)
    sz = nr, nc = size(sps)
    for c in 1:nc, r in 1:nr  # NOTE: row major
        if (sp = sps[r, c]) isa Subplot || sp === nothing
            gaston_init_subplot!(plt, sp)
        else
            gaston_init_subplots!(plt, sp)
            sz = max.(sz, size(sp))
        end
    end
    return sz
end

function gaston_init_subplot!(
        plt::Plot{GastonBackend},
        sp::Union{Nothing, Subplot{GastonBackend}},
    )
    obj = if sp === nothing
        Gaston.Axis()
    else
        dims = RecipesPipeline.is3d(sp) || sp[:projection] == "3d" || needs_any_3d_axes(sp) ? 3 : 2
        any_label = false
        for series in series_list(sp)
            if dims == 2 && series[:seriestype] ∈ (:heatmap, :contour)
                dims = 3  # we need heatmap/contour to use splot, not plot
            end
            any_label |= should_add_to_legend(series)
        end
        settings = gaston_parse_axes_attrs(plt, sp, dims, any_label)
        sp.o = Gaston.Axis(settings, Gaston.Plot[], dims == 3)
    end
    push!(plt.o, obj)  # add new Axis ≡ subplot
    return nothing
end

function gaston_multiplot_pos_size(layout, parent_xy_wh)
    nr, nc = size(layout)
    dat = Array{Any}(nothing, nr, nc)
    for r in 1:nr, c in 1:nc
        l = layout[r, c]
        # width and height (pct) are multiplicative (parent)
        w = layout.widths[c].value * parent_xy_wh[3]
        h = layout.heights[r].value * parent_xy_wh[4]
        if isa(l, EmptyLayout)
            dat[r, c] = (c - 1) * w, (r - 1) * h, w, h, nothing
        else
            # previous position (origin)
            prev_r = r > 1 ? dat[r - 1, c] : nothing
            prev_c = c > 1 ? dat[r, c - 1] : nothing
            prev_r isa Array && (prev_r = prev_r[end, end])
            prev_c isa Array && (prev_c = prev_c[end, end])
            x = prev_c !== nothing ? prev_c[1] + prev_c[3] : parent_xy_wh[1]
            y = prev_r !== nothing ? prev_r[2] + prev_r[4] : parent_xy_wh[2]
            dat[r, c] = if l isa GridLayout
                sub = gaston_multiplot_pos_size(l, (x, y, w, h))
                size(sub) == (1, 1) ? only(sub) : sub
            else
                x, y, w, h, l
            end
        end
    end
    return dat
end

function gaston_multiplot_pos_size!(dat)
    nr, nc = size(dat)
    for r in 1:nr, c in 1:nc
        if (xy_wh_sp = dat[r, c]) isa Array
            gaston_multiplot_pos_size!(xy_wh_sp)
        elseif xy_wh_sp isa Tuple
            x, y, w, h, sp = xy_wh_sp
            sp === nothing && continue
            sp.o === nothing && continue
            # gnuplot screen coordinates: bottom left at 0,0 and top right at 1,1
            gx, gy = x, 1 - y - h
            # @show gx, gy w, h
            sp.o.settings = "set origin $gx, $gy; set size $w, $h; " * sp.o.settings
        end
    end
    return nothing
end

function gaston_add_series(plt::Plot{GastonBackend}, series::Series)
    sp = series[:subplot]
    (gsp = sp.o) === nothing && return
    x, y, z = series[:x], series[:y], series[:z]
    st = series[:seriestype]
    if !gsp.is3d && z === nothing
        for (n, seg) in enumerate(series_segments(series, st; check = true))
            i, rng = seg.attr_index, seg.range
            fr = _cycle(series[:fillrange], 1:length(x[rng]))
            for sc in gaston_seriesconf!(sp, series, n == 1, i)
                push!(gsp.plots, Gaston.Plot(x[rng], y[rng], fr, sc))
            end
        end
    else
        if z isa Surface
            z = z.surf
            if st === :image
                z = reverse(Float32.(Gray.(z)), dims = 1)  # flip y axis
                nr, nc = size(z)
                if (ly = length(y)) == 2 && ly != nr
                    y = collect(range(y[1], y[2], length = nr))
                end
                if (lx = length(x)) == 2 && lx != nc
                    x = collect(range(x[1], x[2], length = nc))
                end
            end
            length(x) == size(z, 2) + 1 && (x = (x[1:(end - 1)] + x[2:end]) / 2)
            length(y) == size(z, 1) + 1 && (y = (y[1:(end - 1)] + y[2:end]) / 2)
        end
        if st === :mesh3d
            x, y, z = mesh3d_triangles(x, y, z, series[:connections])
        elseif st === :surface
            if ndims(x) == ndims(y) == ndims(z) == 1
                # must reinterpret 1D data for `pm3d` (points are ordered)
                x, y = unique(x), unique(y)
                z = reshape(z, length(y), length(x))
            end
        end
        for sc in gaston_seriesconf!(sp, series, true, 1)
            push!(gsp.plots, Gaston.Plot(x, y, z, sc))
        end
    end

    return nothing
end

function gaston_seriesconf!(
        sp::Subplot{GastonBackend},
        series::Series,
        add_to_legend::Bool,
        i::Int,
    )
    #=
    gnuplot abbreviations (see gnuplot/src/set.c)
    ---------------------------------------------
    dl: dashlength
    dt: dashtype
    fc: fillcolor
    fs: fillstyle
    lc: linecolor
    lp: linespoints
    ls: linestyle
    lt: linetype
    lw: linewidth
    pi: pointinterval
    pn: pointnumber
    ps: pointscale
    pt: pointtype
    tc: textcolor
    w: with
    =#
    gsp = sp.o
    st = series[:seriestype]
    add_to_legend &= should_add_to_legend(series)
    curveconf = add_to_legend ? "title '$(series[:label])' " : "notitle "
    extra_curves = String[]

    clims = get_clims(sp, series)
    if st ∈ (:scatter, :scatter3d)
        lc, dt, lw = gaston_lc_ls_lw(series, clims, i)
        pt, ps, mc = gaston_mk_ms_mc(series, clims, i)
        curveconf *= "w points pt $pt ps $ps lc $mc"
    elseif st ∈ (:path, :straightline, :path3d)
        fr = series[:fillrange]
        fc = gaston_color(get_fillcolor(series, i), get_fillalpha(series, i))
        fs = gaston_fillstyle(get_fillstyle(series, i))
        lc, dt, lw = gaston_lc_ls_lw(series, clims, i)
        curveconf *= if fr !== nothing  # filled curves, but not filled curves with markers
            "w filledcurves fc $fc fs $fs border lc $lc lw $lw dt $dt,'' w lines lc $lc lw $lw dt $dt"
        elseif series[:markershape] === :none  # simplepath
            "w lines lc $lc dt $dt lw $lw"
        else
            pt, ps, mc = gaston_mk_ms_mc(series, clims, i)
            "w lp lc $mc dt $dt lw $lw pt $pt ps $ps"
        end
    elseif st === :shape
        fc = gaston_color(get_fillcolor(series, i), get_fillalpha(series, i))
        fs = gaston_fillstyle(get_fillstyle(series, i))
        lc, = gaston_lc_ls_lw(series, clims, i)
        curveconf *= "w filledcurves fc $fc fs $fs border lc $lc"
    elseif st ∈ (:steppre, :stepmid, :steppost)
        step = if st === :steppre
            "fsteps"
        elseif st === :stepmid
            "histeps"
        elseif st === :steppost
            "steps"
        end
        curveconf *= "w $step"
        lc, dt, lw = gaston_lc_ls_lw(series, clims, i)
        push!(extra_curves, "w points lc $lc dt $dt lw $lw notitle")
    elseif st === :image
        gsp.settings *= gaston_palette_conf(series)
        curveconf *= "w image pixels"
    elseif st ∈ (:contour, :contour3d)
        filled = isfilledcontour(series)
        curveconf *= filled ? "w pm3d" : "w lines"
        if series[:contour_labels] == true
            gsp.settings *= "; set cntrlabel interval -1"
            push!(extra_curves, "w labels notitle")
        end
        levels = collect(contour_levels(series, clims))
        if st === :contour  # 2D
            gsp.settings *= if filled
                "; set view map; set palette maxcolors $(length(levels))"
            else
                "; set view map; unset surface"
            end
        end
        gsp.settings *= "; set contour both; set cntrparam levels discrete $(join(map(string, levels), ", "))"
    elseif st ∈ (:surface, :heatmap)
        curveconf *= "w pm3d"
        gsp.settings *= gaston_palette_conf(series)
        st === :heatmap && (gsp.settings *= "; set view map")
    elseif st ∈ (:wireframe, :mesh3d)
        lc, dt, lw = gaston_lc_ls_lw(series, clims, i)
        curveconf *= "w lines lc $lc dt $dt lw $lw"
    elseif st === :quiver
        curveconf *= "w vectors filled"
    else
        @warn "Plots(Gaston): $st is not implemented yet"
    end

    return [curveconf, extra_curves...]
end

const gp_borders = (
    bottom_left_front = 1 << 0,
    bottom_left_back = 1 << 1,
    bottom_right_front = 1 << 2,
    bottom_right_back = 1 << 3,
    left_vertical = 1 << 4,
    back_vertical = 1 << 5,
    right_vertical = 1 << 6,
    front_vertical = 1 << 7,
    top_left_back = 1 << 8,
    top_right_back = 1 << 9,
    top_left_front = 1 << 10,
    top_right_front = 1 << 11,
    polar = 1 << 11,
)

const gp_fillstyle = Dict(
    :x => 1,
    :\ => 4,
    :/ => 5,
    # :|, :-, :+  # unimplemented
)

gaston_fillstyle(x) = if haskey(gp_fillstyle, x)
    "pattern $(gp_fillstyle[x])"
else
    "solid"
end

function gaston_parse_axes_attrs(
        plt::Plot{GastonBackend},
        sp::Subplot{GastonBackend},
        dims::Int,
        any_label::Bool,
    )
    # settings = ["set margins 2, 2, 2, 2"]  # left, right, bottom, top
    settings = String[]

    polar = ispolar(sp) && dims == 2  # cannot splot in polar coordinates

    fs = sp[:framestyle]
    for letter in (:x, :y, :z)
        (letter === :z && dims == 2) && continue
        axis = sp[get_attr_symbol(letter, :axis)]

        # NOTE: there is no `z2tics` concept in gnuplot (only 2D)
        I = if dims == 2 && axis[:mirror]
            push!(settings, "unset $(letter)tics")
            "2"
        else
            ""
        end

        # guide labels
        guide_font = guidefont(axis)
        if letter === :y && dims == 2
            # vertical by default (consistency witht other backends)
            guide_font = font(guide_font; rotation = guide_font.rotation + 90)
        end
        push!(
            settings,
            "set $(letter)$(I)label '$(Plots.get_guide(axis))' $(gaston_font(guide_font))",
        )

        logscale, base = if (scale = axis[:scale]) === :identity
            "nologscale", ""
        elseif scale === :log10
            "logscale", "10"
        elseif scale === :log2
            "logscale", "2"
        elseif scale === :ln
            "logscale", "e"
        end
        push!(settings, "set $logscale $letter $base")

        # handle ticks
        if axis[:showaxis] && fs !== :none
            if polar
                push!(settings, "set size square; unset $(letter)tics")
            else
                push!(
                    settings,
                    "set $(letter)$(I)tics $(axis[:tick_direction]) $(gaston_font(tickfont(axis)))",
                )

                # major tick locations
                if axis[:ticks] !== :native
                    if axis[:flip]
                        hi, lo = axis_limits(sp, letter)
                    else
                        lo, hi = axis_limits(sp, letter)
                    end
                    push!(settings, "set $(letter)$(I)range [$lo:$hi]")

                    offset = if dims == 2 && letter == :y
                        # ticks appear too close to the border, offset them by 1 character
                        "offset " * string(axis[:mirror] ? 1 : -1)
                    else
                        ""
                    end
                    push!(settings, "set $(letter)$(I)tics border nomirror $offset")

                    ticks = get_ticks(sp, axis)
                    gaston_set_ticks!(settings, ticks, letter, I, "", "")

                    if axis[:minorticks] !== :native && !no_minor_intervals(axis)
                        minor_ticks = get_minor_ticks(sp, axis, ticks)
                        gaston_set_ticks!(settings, minor_ticks, letter, I, "m", "add")
                    end
                end
            end
        end
        if fs in (:zerolines, :origin)
            push!(settings, "set $(letter)zeroaxis")
        end
        if !axis[:showaxis] || fs === :none
            push!(settings, "set tics scale 0", "set format x \"\"", "set format y \"\"")
        end

        if axis[:grid]
            push!(settings, "set grid " * (polar ? "polar" : "$(letter)tics"))
            axis[:minorgrid] &&
                push!(settings, "set grid " * (polar ? "polar" : "m$(letter)tics"))
        end

        if (ratio = get_aspect_ratio(sp)) !== :none
            if dims == 2
                ratio === :equal && (ratio = -1)
                push!(settings, "set size ratio $ratio")
            else
                # ratio and square have no effect on 3D plots,
                # but do affect 3D projections created using set view map
                if ratio === :equal
                    push!(settings, "set view equal xyz")
                end
            end
        elseif dims == 3
            # by default unit x/y aspect ratio in 3d ?
            # push!(settings, "set view equal xy")
            # push!(settings, "set size square")
        end
    end
    gaston_set_legend!(settings, sp, any_label)

    # plots border
    border = if polar
        gp_borders[:polar]
    elseif dims == 2
        bottom = gp_borders[:bottom_left_front]
        left = gp_borders[:bottom_left_back]
        top = gp_borders[:bottom_right_front]
        right = gp_borders[:bottom_right_back]
        if fs === :box
            bottom + left + top + right
        elseif fs === :semi
            bottom + left
        elseif fs === :axes
            (sp[:xaxis][:mirror] ? top : bottom) + (sp[:yaxis][:mirror] ? right : left)
        else
            0
        end
    else  # 3D
        (
            gp_borders[:bottom_left_front] +
                gp_borders[:bottom_left_back] +
                gp_borders[:bottom_right_front] +
                gp_borders[:bottom_right_back] +
                gp_borders[:left_vertical]
        )
    end
    push!(settings, border > 0 ? "set border $border back" : "unset border")

    if hascolorbar(sp)
        push!(
            settings,
            "set colorbox",
            "set cbtics border offset 1 $(gaston_font(colorbartitlefont(sp)))",
        )
    else
        push!(settings, "unset colorbox")
    end

    if sp[:title] != ""
        # NOTE: `set title` is hard centered, cannot use `sp[:titlelocation]`
        # on `set label` takes `right`, `center` or `left` justification
        push!(settings, "set title '$(sp[:title])' $(gaston_font(titlefont(sp)))")
    end

    if polar
        push!(settings, "set polar")
        tmin, tmax = axis_limits(sp, :x, false, false)
        rmin, rmax = axis_limits(sp, :y, false, false)
        rticks = get_ticks(sp, :y)
        gaston_ticks = if (ttype = ticksType(rticks)) === :ticks
            string.(rticks)
        elseif ttype === :ticks_and_labels
            ["'$l' $t" for (t, l) in zip(rticks...)]
        end
        push!(
            settings,
            "set rtics ( $(join(gaston_ticks, ", ")) ) $(gaston_font(tickfont(sp[:yaxis])))",
            "set trange [$(min(0, tmin)):$(max(2π, tmax))]",
            "set rrange [$rmin:$rmax]",
            "set ttics 0,30 format \"%g\".GPVAL_DEGREE_SIGN $(gaston_font(tickfont(sp[:xaxis])))",
            "set mttics 3",
        )
    end

    return join(settings, "; ")
end

function gaston_fix_ticks_overflow(ticks::AbstractVector)
    if eltype(ticks) <: Integer
        of = if isdefined(Gaston, :GNUPLOT_VERSION)
            # toggle Int32 - Int64 for older gnuplot version
            Gaston.GNUPLOT_VERSION[] ≥ v"5.4.0" ? Int64 : Int32
        else
            Int32
        end |> typemax
        any(t -> abs(t) > of, ticks) && return float.(ticks)
    end
    return ticks
end

function gaston_set_ticks!(settings, ticks, letter, I, maj_min, add)
    ticks === :auto && return
    if ticks ∈ (:none, nothing, false)
        push!(settings, "unset $(maj_min)$(letter)tics")
        return
    end
    gaston_ticks = if (ttype = ticksType(ticks)) === :ticks
        tics = gaston_fix_ticks_overflow(ticks)
        if maj_min == "m"
            map(t -> "'' $t 1", tics)  # see gnuplot manual 'Mxtics'
        else
            map(string, tics)
        end
    elseif ttype === :ticks_and_labels
        tics = gaston_fix_ticks_overflow(first(ticks))
        labs = last(ticks)
        map(i -> "'$(gaston_enclose_tick_string(labs[i]))' $(tics[i])", eachindex(tics))
    else
        @error "Gaston: invalid input for $(maj_min)$(letter)ticks: $ticks ($ttype)"
        nothing
    end
    if gaston_ticks !== nothing
        push!(settings, "set $(letter)$(I)tics $add (" * join(gaston_ticks, ", ") * ")")
    end
    return nothing
end

function gaston_set_legend!(settings, sp, any_label)
    if (lp = sp[:legend_position]) ∉ (:none, :inline) && any_label
        leg_str = string(_guess_best_legend_position(lp, sp))

        pos = occursin("outer", leg_str) ? "outside " : "inside "
        pos *= if occursin("top", leg_str)
            "top "
        elseif occursin("bottom", leg_str)
            "bottom "
        else
            "center "
        end
        pos *= if occursin("left", leg_str)
            "left "
        elseif occursin("right", leg_str)
            "right "
        else
            "center "
        end
        pos *= sp[:legend_column] == 1 ? "vertical" : "horizontal"
        push!(settings, "set key $pos box lw 1 opaque noautotitle")
        push!(settings, "set key $(gaston_font(legendfont(sp), rot = false, align = false))")
        if sp[:legend_title] !== nothing
            # NOTE: cannot use legendtitlefont(sp) as it will override legendfont
            push!(settings, "set key title '$(sp[:legend_title])'")
        end
    else
        push!(settings, "set key off")
    end
    return nothing
end

# --------------------------------------------
# Helpers
# --------------------------------------------

gaston_halign(k) = (left = :left, hcenter = :center, right = :right)[k]
gaston_valign(k) = (top = :top, vcenter = :center, bottom = :bottom)[k]

# from the gnuplot docs:
# - an alpha value of 0 represents a fully opaque color; i.e., "#00RRGGBB" is the same as "#RRGGBB".
# - an alpha value of 255 (FF) represents full transparency
gaston_alpha(alpha) = alpha === nothing ? 0 : alpha

gaston_lc_ls_lw(series::Series, clims, i::Int) = (
    gaston_color(get_linecolor(series, clims, i), get_linealpha(series, i)),
    gaston_linestyle(get_linestyle(series, i)),
    get_linewidth(series, i),
)

gaston_mk_ms_mc(series::Series, clims, i::Int) = (
    gaston_marker(_cycle(series[:markershape], i), get_markeralpha(series, i)),
    0.2_cycle(series[:markersize], i),
    gaston_color(get_markercolor(series, clims, i), get_markeralpha(series, i)),
)

function gaston_font(f; rot = true, align = true, color = true, scale = 1)
    font = "font '$(f.family),$(round(Int, scale * f.pointsize))'"
    align && (font *= " $(gaston_halign(f.halign))")
    rot && (font *= " rotate by $(f.rotation)")
    color && (font *= " textcolor $(gaston_color(f.color))")
    return font
end

gaston_palette(gradient) = let palette = ["$(n - 1) $(c.r) $(c.g) $(c.b)" for (n, c) in enumerate(gradient)]
    '(' * join(palette, ", ") * ')'
end

gaston_palette_conf(series) = "; set palette model RGB defined $(gaston_palette(series[:seriescolor]))"

function gaston_marker(marker, alpha)
    # NOTE: :rtriangle, :ltriangle, :hexagon, :heptagon, :octagon seems unsupported by gnuplot
    filled = gaston_alpha(alpha) != 1
    marker === :none && return -1
    marker === :pixel && return 0
    marker ∈ (:+, :cross) && return 1
    marker ∈ (:x, :xcross) && return 2
    marker === :star5 && return 3
    marker === :rect && return filled ? 5 : 4
    marker === :circle && return filled ? 7 : 6
    marker === :utriangle && return filled ? 9 : 8
    marker === :dtriangle && return filled ? 11 : 10
    marker === :diamond && return filled ? 13 : 12
    marker === :pentagon && return filled ? 15 : 14
    # @debug "Plots(Gaston): unsupported marker $marker"
    return 1
end

function gaston_color(col, alpha = 0)
    col = single_color(col)  # in case of gradients
    col = alphacolor(col, gaston_alpha(alpha))  # add a default alpha if non existent
    return "rgbcolor '#$(hex(col, :aarrggbb))'"
end

function gaston_linestyle(style)
    style === :solid && return 1
    style === :dash && return 2
    style === :dot && return 3
    style === :dashdot && return 4
    style === :dashdotdot && return 5
    return 1
end

function gaston_enclose_tick_string(tick_string)
    findfirst('^', tick_string) === nothing && return tick_string
    base, power = split(tick_string, '^')
    return "$base^{$power}"
end

closeall(::GastonBackend) = Gaston.closeall()

using Plots, Test
@testset "Plotting plots" begin
    pl = @test_nowarn plot(plot(1:2), plot(1:2, size = (1_200, 400)))
    @test pl[:size] == (1_200, 400)
    pl = @test_nowarn plot(plot(1:2), plot(1:2), size = (1_200, 400))
    @test pl[:size] == (1_200, 400)
end

@testset "Subplot slicing" begin
    pl = @test_nowarn plot(
        rand(4, 8),
        layout = 4,
        yscale = [:identity :identity :log10 :log10],
    )
    @test pl[1][:yaxis][:scale] === :identity
    @test pl[2][:yaxis][:scale] === :identity
    @test pl[3][:yaxis][:scale] === :log10
    @test pl[4][:yaxis][:scale] === :log10
end

@testset "Plot title" begin
    pl = plot(
        rand(4, 8),
        layout = 4,
        plot_title = "My title",
        background_color = :darkgray,
        background_color_inside = :lightgray,
    )
    @test pl.layout.heights == [0.05Plots.pct, 0.95Plots.pct]
    @test pl[:plot_title] == "My title"
    @test pl[:plot_titleindex] == 5

    @test pl[5][:background_color_inside] == RGBA(colorant"darkgray")

    plot!(pl)
    @test pl[:plot_title] == "My title"
    @test pl[:plot_titleindex] == 5

    plot!(pl, plot_title = "My new title")
    @test pl[:plot_title] == "My new title"
    @test pl[:plot_titleindex] == 5
end

@testset "Plots.jl/issues/4083" begin
    pl = plot(plot(1:2), plot(1:2); border = :grid, plot_title = "abc")
    @test pl[1][:framestyle] === :grid
    @test pl[2][:framestyle] === :grid
    @test pl[3][:framestyle] === :none
end

@testset "Allowed subplot counts" begin
    pl = plot(plot(1:2); layout = grid(2, 2))
    @test length(pl) == 1

    pl = plot(map(_ -> plot(1:2), 1:2)...; layout = grid(2, 2))
    @test length(pl) == 2

    pl = plot(map(_ -> plot(1:2), 1:3)...; layout = grid(2, 2))
    @test length(pl) == 3
    @test length(plot!(pl, plot(1:2))) == 4

    pl = plot(map(_ -> plot(1:2), 1:4)...; layout = grid(2, 2))
    @test length(pl) == 4

    @test_throws ErrorException plot(map(_ -> plot(1:2), 1:5)...; layout = grid(2, 2))
end

@testset "Allowed grid widths/heights" begin
    @test_nowarn grid(2, 1, heights = [0.5, 0.5])
    @test_nowarn grid(4, 1, heights = [0.3, 0.3, 0.3, 0.1])
    @test_nowarn grid(1, 2, widths = [0.5, 0.5])
    @test_nowarn grid(1, 4, widths = [0.3, 0.3, 0.3, 0.1])
    @test_throws ErrorException grid(2, 1, heights = [0.5, 0.4])
    @test_throws ErrorException grid(4, 1, heights = [1.5, -0.5])
    @test_throws ErrorException grid(1, 2, widths = [0.5, 0.4])
    @test_throws ErrorException grid(1, 4, widths = [1.5, -0.5])
end

@testset "Invalid viewport" begin
    # github.com/JuliaPlots/Plots.jl/issues/2804
    pl = plot(1, layout = (10, 2))
    show(devnull, pl)
end

@testset "Coverage" begin
    pl = plot(map(plot, 1:4)..., layout = (2, 2))

    sp = pl[end]
    @test sp isa Plots.Subplot
    @test size(sp) == (1, 1)
    @test length(sp) == 1
    @test sp[1, 1] == sp
    @test Plots.get_subplot(pl, UInt32(4)) == sp
    @test Plots.series_list(sp) |> first |> Plots.get_subplot isa Plots.Subplot
    @test Plots.get_subplot(pl, keys(pl.spmap) |> first) isa Plots.Subplot

    gl = pl[2, 2]
    @test gl isa Plots.GridLayout
    @test length(gl) == 1
    @test size(gl) == (1, 1)
    @test Plots.layout_args(gl) == (gl, 1)

    @test size(pl, 1) == 2
    @test size(pl, 2) == 2
    @test size(pl) == (2, 2)
    @test ndims(pl) == 2

    @test pl[1][end] isa Plots.Series
    io = devnull
    show(io, pl[1])

    @test Plots.getplot(pl) == pl
    @test Plots.getattr(pl) == pl.attr
    @test Plots.backend_object(pl) == pl.o
    @test occursin("Plot", string(pl))
    print(io, pl)

    @test Plots.to_pixels(1Plots.mm) isa AbstractFloat
    @test Plots.ispositive(1Plots.mm)
    @test size(Plots.DEFAULT_BBOX[]) == (0Plots.mm, 0Plots.mm)
    show(io, Plots.DEFAULT_BBOX[])
    show(io, pl.layout)

    @test Plots.make_measure_hor(1Plots.mm) == 1Plots.mm
    @test Plots.make_measure_vert(1Plots.mm) == 1Plots.mm

    @test Plots.parent(pl.layout) isa Plots.RootLayout
    show(io, Plots.parent_bbox(pl.layout))

    rl = Plots.RootLayout()
    show(io, rl)
    @test parent(rl) === nothing
    @test Plots.parent_bbox(rl) == Plots.DEFAULT_BBOX[]
    @test Plots.bbox(rl) == Plots.DEFAULT_BBOX[]
    @test Plots.origin(Plots.DEFAULT_BBOX[]) == (0Plots.mm, 0Plots.mm)
    for h_anchor in (:left, :right, :hcenter), v_anchor in (:top, :bottom, :vcenter)
        @test Plots.bbox(0, 0, 1, 1, h_anchor, v_anchor) isa Plots.BoundingBox
    end

    el = Plots.EmptyLayout()
    @test Plots.update_position!(el) === nothing
    @test size(el) == (0, 0)
    @test length(el) == 0
    @test el[1, 1] === nothing

    @test Plots.left(el) == 0Plots.mm
    @test Plots.top(el) == 0Plots.mm
    @test Plots.right(el) == 0Plots.mm
    @test Plots.bottom(el) == 0Plots.mm

    plot(map(plot, 1:4)..., layout = (2, :))
    plot(map(plot, 1:4)..., layout = (:, 2))
end

@testset "Link" begin
    plot(map(plot, 1:4)..., link = :all)
    plot(map(plot, 1:4)..., link = :square)
end

using Plots, Test
Sys.isunix() && Plots.with(:plotly) do
    @testset "Basic" begin
        @test backend() == Plots.PlotlyBackend()

        pl = plot(rand(10))
        @test pl isa Plots.Plot
        @test_nowarn Plots.plotly_series(plot())
        @test !haskey(Plots.plotly_series(pl)[1], :zmax)
    end

    @testset "Contours" begin
        x = (-2π):0.1:(2π)
        y = (-π):0.1:π
        z = cos.(y) .* sin.(x')

        @testset "Contour numbers" begin
            @testset "Default" begin
                @test Plots.plotly_series(contour(x, y, z))[1][:ncontours] ==
                    Plots._series_defaults[:levels] + 2
            end
            @testset "Specified number" begin
                cont = contour(x, y, z, levels = 10)
                @test Plots.plotly_series(cont)[1][:ncontours] == 12
            end
        end

        @testset "Contour values" begin
            @testset "Range" begin
                levels = -1:0.5:1
                pl = contour(x, y, z, levels = levels)
                @test pl[1][1].plotattributes[:levels] == levels
                @test Plots.plotly_series(pl)[1][:contours][:start] == first(levels)
                @test Plots.plotly_series(pl)[1][:contours][:end] == last(levels)
                @test Plots.plotly_series(pl)[1][:contours][:size] == step(levels)
            end

            @testset "Set of contours" begin
                levels = [-1, -0.25, 0, 0.25, 1]
                levels_range =
                    range(first(levels), stop = last(levels), length = length(levels))
                pl = contour(x, y, z, levels = levels)
                @test pl[1][1].plotattributes[:levels] == levels
                series_dict = @test_logs (
                    :warn,
                    """
                    setting arbitrary contour levels with Plotly backend is not supported;
                    use a range to set equally-spaced contours or an integer to set the
                    approximate number of contours with the keyword `levels`.
                    Setting levels to -1.0:0.5:1.0
                    """,
                ) Plots.plotly_series(pl)
                @test series_dict[1][:contours][:start] == first(levels_range)
                @test series_dict[1][:contours][:end] == last(levels_range)
                @test series_dict[1][:contours][:size] == step(levels_range)
            end
        end
    end

    @testset "Extra kwargs" begin
        pl = plot(1:5, test = "me")
        @test Plots.plotly_series(pl)[1][:test] == "me"
        pl = plot(1:5, test = "me", extra_kwargs = :plot)
        @test Plots.plotly_layout(pl)[:test] == "me"
    end

    @testset "3D scene aspect" begin
        scene(pl) = Plots.plotly_layout(pl)[:scene]

        @testset "#5044 - default is data independent" begin
            # `plotly.js` defaults `scene.aspectmode` to `"auto"`, which proportions the box
            # to the data ranges but flips to `"cube"` once one axis spans more than 4x the
            # two others - so the same code produced different boxes for different data
            for zmax in (1, 2, 5, 100)  # crosses the `"auto"` 4x threshold
                pl = plot(1:3, 1:3, range(0, zmax, length = 3))
                @test scene(pl)[:aspectmode] == "cube"  # as `GR` and `PythonPlot` do
            end
        end

        @testset "`aspect_ratio = :equal`" begin
            # the box must follow the *axis limits*, so that one data unit is the same
            # length on each axis. `"data"` cannot express this: `plotly` computes it from
            # the traces and ignores these limits
            for ar in (:equal, 1, 1 // 1, true)
                sc = scene(
                    plot(
                        1:3, 1:3, 1:3;
                        aspect_ratio = ar, xlims = (0, 10), ylims = (0, 5), zlims = (0, 1),
                    ),
                )
                @test sc[:aspectmode] == "manual"
                @test sc[:aspectratio][:x] ≈ 1
                @test sc[:aspectratio][:y] ≈ 0.5
                @test sc[:aspectratio][:z] ≈ 0.1
            end
            # equal limits collapse to a cube, matching `GR`
            sc = scene(
                plot(
                    1:3, 1:3, 1:3;
                    aspect_ratio = :equal, xlims = (0, 4), ylims = (1, 5), zlims = (-2, 2),
                ),
            )
            @test sc[:aspectratio][:x] ≈ sc[:aspectratio][:y] ≈ sc[:aspectratio][:z] ≈ 1

            @testset "log scales are measured in decades" begin
                # `plotly_axis` reports a `:log10` range already scaled, so the box has to
                # be sized the same way - a raw data span would stretch it by orders of
                # magnitude (x here spans 3 decades, not 999 units)
                sc = scene(
                    plot(
                        [1, 1000], [0, 1], [0, 1];
                        seriestype = :surface, xscale = :log10, aspect_ratio = :equal,
                    ),
                )
                @test collect(sc[:xaxis][:range]) ≈ [0, 3]
                @test sc[:aspectratio][:x] / sc[:aspectratio][:y] ≈ 3
            end
        end

        @testset "explicit `aspect_ratio`" begin
            @test scene(plot(1:3, 1:3, 1:3, aspect_ratio = :none))[:aspectmode] == "cube"

            sc = scene(plot(1:3, 1:3, 1:3, aspect_ratio = [1, 2, 3]))
            @test sc[:aspectmode] == "manual"
            @test sc[:aspectratio][:x] == 1
            @test sc[:aspectratio][:y] == 2
            @test sc[:aspectratio][:z] == 3
        end

        # 2D subplots have no `scene`
        @test !haskey(Plots.plotly_layout(plot(1:3, aspect_ratio = :equal)), :scene)
    end
end

# https://github.com/sisl/PGFPlots.jl

# significant contributions by: @pkofod

# --------------------------------------------------------------------------------------
# COV_EXCL_START
const _pgfplots_linestyles = KW(
    :solid => "solid",
    :dash => "dashed",
    :dot => "dotted",
    :dashdot => "dashdotted",
    :dashdotdot => "dashdotdotted",
)

const _pgfplots_markers = KW(
    :none => "none",
    :cross => "+",
    :xcross => "x",
    :+ => "+",
    :x => "x",
    :utriangle => "triangle*",
    :dtriangle => "triangle*",
    :circle => "*",
    :rect => "square*",
    :star5 => "star",
    :star6 => "asterisk",
    :diamond => "diamond*",
    :pentagon => "pentagon*",
    :hline => "-",
    :vline => "|",
)

const _pgfplots_legend_pos = KW(
    :bottomleft => "south west",
    :bottomright => "south east",
    :topright => "north east",
    :topleft => "north west",
    :outertopright => "outer north east",
)

const _pgf_series_extrastyle = KW(
    :steppre => "const plot mark right",
    :stepmid => "const plot mark mid",
    :steppost => "const plot",
    :sticks => "ycomb",
    :ysticks => "ycomb",
    :xsticks => "xcomb",
)

# PGFPlots uses the anchors to define orientations for example to align left
# one needs to use the right edge as anchor
const _pgf_annotation_halign = KW(:center => "", :left => "right", :right => "left")

const _pgf_framestyles = [:box, :axes, :origin, :zerolines, :grid, :none]
const _pgf_framestyle_defaults = Dict(:semi => :box)
function pgf_framestyle(style::Symbol)
    if style in _pgf_framestyles
        return style
    else
        default_style = get(_pgf_framestyle_defaults, style, :axes)
        @warn "Framestyle :$style is not (yet) supported by the PGFPlots backend. :$default_style was cosen instead."
        default_style
    end
end

# --------------------------------------------------------------------------------------

# takes in color,alpha, and returns color and alpha appropriate for pgf style
function pgf_color(c::Colorant)
    cstr = @sprintf "{rgb,1:red,%.8f;green,%.8f;blue,%.8f}" red(c) green(c) blue(c)
    return cstr, alpha(c)
end

function pgf_color(grad::ColorGradient)
    # Can't handle ColorGradient here, fallback to defaults.
    cstr = @sprintf "{rgb,1:red,%.8f;green,%.8f;blue,%.8f}" 0.0 0.60560316 0.97868012
    return cstr, 1
end

# Generates a colormap for pgfplots based on a ColorGradient
pgf_colormap(grad::ColorGradient) = join(
    map(c -> @sprintf("rgb=(%.8f,%.8f,%.8f)", red(c), green(c), blue(c)), grad.colors),
    ", ",
)

pgf_thickness_scaling(plt::Plot) = plt[:thickness_scaling]
pgf_thickness_scaling(sp::Subplot) = pgf_thickness_scaling(sp.plt)
pgf_thickness_scaling(series) = pgf_thickness_scaling(series[:subplot])

function pgf_fillstyle(plotattributes, i = 1)
    cstr, a = pgf_color(get_fillcolor(plotattributes, i))
    fa = get_fillalpha(plotattributes, i)
    if fa !== nothing
        a = fa
    end
    return "fill = $cstr, fill opacity=$a"
end

function pgf_linestyle(linewidth::Real, color, α = 1, linestyle = "solid")
    cstr, a = pgf_color(plot_color(color, α))
    return """
    color = $cstr,
    draw opacity = $a,
    line width = $linewidth,
    $(get(_pgfplots_linestyles, linestyle, "solid"))"""
end

function pgf_linestyle(plotattributes, i = 1)
    lw = pgf_thickness_scaling(plotattributes) * get_linewidth(plotattributes, i)
    lc = get_linecolor(plotattributes, i)
    la = get_linealpha(plotattributes, i)
    ls = get_linestyle(plotattributes, i)
    return pgf_linestyle(lw, lc, la, ls)
end

function pgf_font(fontsize, thickness_scaling = 1, font = "\\selectfont")
    fs = fontsize * thickness_scaling
    return string("{\\fontsize{", fs, " pt}{", 1.3fs, " pt}", font, "}")
end

function pgf_marker(plotattributes, i = 1)
    shape = _cycle(plotattributes[:markershape], i)
    cstr, a = pgf_color(
        plot_color(get_markercolor(plotattributes, i), get_markeralpha(plotattributes, i)),
    )
    cstr_stroke, a_stroke = pgf_color(
        plot_color(
            get_markerstrokecolor(plotattributes, i),
            get_markerstrokealpha(plotattributes, i),
        ),
    )
    return string(
        "mark = $(get(_pgfplots_markers, shape, "*")),\n",
        "mark size = $(pgf_thickness_scaling(plotattributes) * 0.5 * _cycle(plotattributes[:markersize], i)),\n",
        plotattributes[:seriestype] === :scatter ? "only marks,\n" : "",
        "mark options = {
            color = $cstr_stroke, draw opacity = $a_stroke,
            fill = $cstr, fill opacity = $a,
            line width = $(pgf_thickness_scaling(plotattributes) * _cycle(plotattributes[:markerstrokewidth], i)),
            rotate = $(shape === :dtriangle ? 180 : 0),
            $(get(_pgfplots_linestyles, _cycle(plotattributes[:markerstrokestyle], i), "solid"))
        }",
    )
end

function pgf_add_annotation!(o, x, y, val, thickness_scaling = 1)
    # Construct the style string.
    # Currently supports color and orientation
    cstr, a = pgf_color(val.font.color)
    return push!(
        o,
        PGFPlots.Plots.Node(
            val.str, # Annotation Text
            x,
            y,
            style = """
            $(get(_pgf_annotation_halign, val.font.halign, "")),
            color=$cstr, draw opacity=$(convert(Float16, a)),
            rotate=$(val.font.rotation),
            font=$(pgf_font(val.font.pointsize, thickness_scaling))
            """,
        ),
    )
end

# --------------------------------------------------------------------------------------

function pgf_series(sp::Subplot, series::Series)
    plotattributes = series.plotattributes
    st = plotattributes[:seriestype]
    series_collection = PGFPlots.Plot[]

    # function args
    args = if st === :contour
        plotattributes[:z].surf, plotattributes[:x], plotattributes[:y]
    elseif RecipesPipeline.is3d(st)
        plotattributes[:x], plotattributes[:y], plotattributes[:z]
    elseif st === :straightline
        straightline_data(series)
    elseif st === :shape
        shape_data(series)
    elseif ispolar(sp)
        theta, r = plotattributes[:x], plotattributes[:y]
        rad2deg.(theta), r
    else
        plotattributes[:x], plotattributes[:y]
    end

    # PGFPlots can't handle non-Vector?
    # args = map(a -> if typeof(a) <: AbstractVector && typeof(a) != Vector
    #         collect(a)
    #     else
    #         a
    #     end, args)

    if st in (:contour, :histogram2d)
        style = []
        kw = KW()
        push!(style, pgf_linestyle(plotattributes))
        push!(style, pgf_marker(plotattributes))
        push!(style, "forget plot")

        kw[:style] = join(style, ',')
        func = if st === :histogram2d
            PGFPlots.Histogram2
        else
            kw[:labels] = series[:contour_labels]
            kw[:levels] = series[:levels]
            PGFPlots.Contour
        end
        push!(series_collection, func(args...; kw...))

    else
        # series segments
        segments = iter_segments(series)
        for (i, rng) in enumerate(segments)
            style = []
            kw = KW()
            push!(style, pgf_linestyle(plotattributes, i))
            push!(style, pgf_marker(plotattributes, i))

            if st === :shape
                push!(style, pgf_fillstyle(plotattributes, i))
            end

            # add to legend?
            if i == 1 && sp[:legend_position] !== :none && should_add_to_legend(series)
                if plotattributes[:fillrange] !== nothing
                    push!(style, "forget plot")
                    push!(series_collection, pgf_fill_legend_hack(plotattributes, args))
                else
                    kw[:legendentry] = plotattributes[:label]
                    if st === :shape # || plotattributes[:fillrange] !== nothing
                        push!(style, "area legend")
                    end
                end
            else
                push!(style, "forget plot")
            end

            seg_args = (arg[rng] for arg in args)

            # include additional style, then add to the kw
            if haskey(_pgf_series_extrastyle, st)
                push!(style, _pgf_series_extrastyle[st])
            end
            kw[:style] = join(style, ',')

            # add fillrange
            if series[:fillrange] !== nothing && st !== :shape
                push!(
                    series_collection,
                    pgf_fillrange_series(
                        series,
                        i,
                        _cycle(series[:fillrange], rng),
                        seg_args...,
                    ),
                )
            end

            # build/return the series object
            func = if st === :path3d
                PGFPlots.Linear3
            elseif st === :scatter
                PGFPlots.Scatter
            else
                PGFPlots.Linear
            end
            push!(series_collection, func(seg_args...; kw...))
        end
    end
    return series_collection
end

function pgf_fillrange_series(series, i, fillrange, args...)
    st = series[:seriestype]
    style = []
    kw = KW()
    push!(style, "line width = 0")
    push!(style, "draw opacity = 0")
    push!(style, pgf_fillstyle(series, i))
    push!(style, pgf_marker(series, i))
    push!(style, "forget plot")
    if haskey(_pgf_series_extrastyle, st)
        push!(style, _pgf_series_extrastyle[st])
    end
    kw[:style] = join(style, ',')
    func = RecipesPipeline.is3d(series) ? PGFPlots.Linear3 : PGFPlots.Linear
    return func(pgf_fillrange_args(fillrange, args...)...; kw...)
end

function pgf_fillrange_args(fillrange, x, y)
    n = length(x)
    x_fill = [x; x[n:-1:1]; x[1]]
    y_fill = [y; _cycle(fillrange, n:-1:1); y[1]]
    return x_fill, y_fill
end

function pgf_fillrange_args(fillrange, x, y, z)
    n = length(x)
    x_fill = [x; x[n:-1:1]; x[1]]
    y_fill = [y; y[n:-1:1]; x[1]]
    z_fill = [z; _cycle(fillrange, n:-1:1); z[1]]
    return x_fill, y_fill, z_fill
end

function pgf_fill_legend_hack(plotattributes, args)
    style = []
    kw = KW()
    push!(style, pgf_linestyle(plotattributes, 1))
    push!(style, pgf_marker(plotattributes, 1))
    push!(style, pgf_fillstyle(plotattributes, 1))
    push!(style, "area legend")
    kw[:legendentry] = plotattributes[:label]
    kw[:style] = join(style, ',')
    st = plotattributes[:seriestype]
    func = if st === :path3d
        PGFPlots.Linear3
    elseif st === :scatter
        PGFPlots.Scatter
    else
        PGFPlots.Linear
    end
    return func(([arg[1]] for arg in args)...; kw...)
end

# ----------------------------------------------------------------

function pgf_axis(sp::Subplot, letter)
    axis = sp[get_attr_symbol(letter, :axis)]
    style = []
    kw = KW()

    # turn off scaled ticks
    push!(style, "scaled $(letter) ticks = false")

    # set to supported framestyle
    framestyle = pgf_framestyle(sp[:framestyle])

    # axis guide
    kw[get_attr_symbol(letter, :label)] = Plots.get_guide(axis)

    # axis label position
    labelpos = ""
    if letter === :x && axis[:guide_position] === :top
        labelpos = "at={(0.5,1)},above,"
    elseif letter === :y && axis[:guide_position] === :right
        labelpos = "at={(1,0.5)},below,"
    end

    # Add label font
    cstr, α = pgf_color(plot_color(axis[:guidefontcolor]))
    push!(
        style,
        string(
            letter,
            "label style = {",
            labelpos,
            "font = ",
            pgf_font(axis[:guidefontsize], pgf_thickness_scaling(sp)),
            ", color = ",
            cstr,
            ", draw opacity = ",
            α,
            ", rotate = ",
            axis[:guidefontrotation],
            "}",
        ),
    )

    # flip/reverse?
    axis[:flip] && push!(style, "$letter dir=reverse")

    # scale
    scale = axis[:scale]
    if scale in (:log2, :ln, :log10)
        kw[get_attr_symbol(letter, :mode)] = "log"
        scale === :ln || push!(style, "log basis $letter=$(scale === :log2 ? 2 : 10)")
    end

    # ticks on or off
    if axis[:ticks] in (nothing, false, :none) || framestyle === :none
        push!(style, "$(letter)majorticks=false")
    end

    # grid on or off
    if axis[:grid] && framestyle !== :none
        push!(style, "$(letter)majorgrids = true")
    else
        push!(style, "$(letter)majorgrids = false")
    end

    # limits
    # TODO: support zlims
    if letter !== :z
        lims =
            ispolar(sp) && letter === :x ? rad2deg.(axis_limits(sp, :x)) :
            axis_limits(sp, letter)
        kw[get_attr_symbol(letter, :min)] = lims[1]
        kw[get_attr_symbol(letter, :max)] = lims[2]
    end

    if !(axis[:ticks] in (nothing, false, :none, :native)) && framestyle !== :none
        ticks = get_ticks(sp, axis)
        #pgf plot ignores ticks with angle below 90 when xmin = 90 so shift values
        tick_values =
            ispolar(sp) && letter === :x ? [rad2deg.(ticks[1])[3:end]..., 360, 405] :
            ticks[1]
        push!(style, string(letter, "tick = {", join(tick_values, ","), "}"))
        if axis[:showaxis] && axis[:scale] in (:ln, :log2, :log10) && axis[:ticks] === :auto
            # wrap the power part of label with }
            tick_labels = Vector{String}(undef, length(ticks[2]))
            for (i, label) in enumerate(ticks[2])
                base, power = split(label, "^")
                power = string("{", power, "}")
                tick_labels[i] = string(base, "^", power)
            end
            push!(
                style,
                string(letter, "ticklabels = {\$", join(tick_labels, "\$,\$"), "\$}"),
            )
        elseif axis[:showaxis]
            tick_labels =
                ispolar(sp) && letter === :x ? [ticks[2][3:end]..., "0", "45"] : ticks[2]
            if axis[:formatter] in (:scientific, :auto)
                tick_labels = string.("\$", convert_sci_unicode.(tick_labels), "\$")
                tick_labels = replace.(tick_labels, Ref("×" => "\\times"))
            end
            push!(style, string(letter, "ticklabels = {", join(tick_labels, ","), "}"))
        else
            push!(style, string(letter, "ticklabels = {}"))
        end
        push!(
            style,
            string(
                letter,
                "tick align = ",
                (axis[:tick_direction] === :out ? "outside" : "inside"),
            ),
        )
        cstr, α = pgf_color(plot_color(axis[:tickfontcolor]))
        push!(
            style,
            string(
                letter,
                "ticklabel style = {font = ",
                pgf_font(axis[:tickfontsize], pgf_thickness_scaling(sp)),
                ", color = ",
                cstr,
                ", draw opacity = ",
                α,
                ", rotate = ",
                axis[:tickfontrotation],
                "}",
            ),
        )
        push!(
            style,
            string(
                letter,
                " grid style = {",
                pgf_linestyle(
                    pgf_thickness_scaling(sp) * axis[:gridlinewidth],
                    axis[:foreground_color_grid],
                    axis[:gridalpha],
                    axis[:gridstyle],
                ),
                "}",
            ),
        )
    end

    # framestyle
    if framestyle in (:axes, :origin)
        axispos = framestyle === :axes ? "left" : "middle"
        if axis[:draw_arrow]
            push!(style, string("axis ", letter, " line = ", axispos))
        else
            # the * after line disables the arrow at the axis
            push!(style, string("axis ", letter, " line* = ", axispos))
        end
    end

    if framestyle === :zerolines
        push!(style, string("extra ", letter, " ticks = 0"))
        push!(style, string("extra ", letter, " tick labels = "))
        push!(
            style,
            string(
                "extra ",
                letter,
                " tick style = {grid = major, major grid style = {",
                pgf_linestyle(
                    pgf_thickness_scaling(sp),
                    axis[:foreground_color_border],
                    1.0,
                ),
                "}}",
            ),
        )
    end

    if !axis[:showaxis]
        push!(style, "separate axis lines")
    end
    if !axis[:showaxis] || framestyle in (:zerolines, :grid, :none)
        push!(style, string(letter, " axis line style = {draw opacity = 0}"))
    else
        push!(
            style,
            string(
                letter,
                " axis line style = {",
                pgf_linestyle(
                    pgf_thickness_scaling(sp),
                    axis[:foreground_color_border],
                    1.0,
                ),
                "}",
            ),
        )
    end

    # return the style list and KW args
    return style, kw
end

# ----------------------------------------------------------------

function _update_plot_object(plt::Plot{PGFPlotsBackend})
    plt.o = PGFPlots.Axis[]
    # Obtain the total height of the plot by extracting the maximal bottom
    # coordinate from the bounding box.
    total_height = bottom(bbox(plt.layout))

    for sp in plt.subplots
        # first build the PGFPlots.Axis object
        style = ["unbounded coords=jump"]
        kw = KW()

        # add to style/kw for each axis
        for letter in (:x, :y, :z)
            if letter !== :z || RecipesPipeline.is3d(sp)
                axisstyle, axiskw = pgf_axis(sp, letter)
                append!(style, axisstyle)
                merge!(kw, axiskw)
            end
        end

        # bounding box values are in mm
        # note: bb origin is top-left, pgf is bottom-left
        # A round on 2 decimal places should be enough precision for 300 dpi
        # plots.
        bb = bbox(sp)
        push!(
            style,
            """
                xshift = $(left(bb).value)mm,
                yshift = $(round((total_height - (bottom(bb))).value, digits = 2))mm,
                axis background/.style={fill=$(pgf_color(sp[:background_color_inside])[1])}
            """,
        )
        kw[:width] = "$(width(bb).value)mm"
        kw[:height] = "$(height(bb).value)mm"

        if sp[:title] != ""
            kw[:title] = "$(sp[:title])"
            cstr, α = pgf_color(plot_color(sp[:titlefontcolor]))
            push!(
                style,
                string(
                    "title style = {font = ",
                    pgf_font(sp[:titlefontsize], pgf_thickness_scaling(sp)),
                    ", color = ",
                    cstr,
                    ", draw opacity = ",
                    α,
                    ", rotate = ",
                    sp[:titlefontrotation],
                    "}",
                ),
            )
        end

        if get_aspect_ratio(sp) in (1, :equal)
            kw[:axisEqual] = "true"
        end

        legpos = sp[:legend_position]
        if haskey(_pgfplots_legend_pos, legpos)
            kw[:legendPos] = _pgfplots_legend_pos[legpos]
        end
        cstr, bg_alpha = pgf_color(plot_color(sp[:legend_background_color]))
        fg_alpha = alpha(plot_color(sp[:legend_foreground_color]))

        push!(
            style,
            string(
                "legend style = {",
                pgf_linestyle(
                    pgf_thickness_scaling(sp),
                    sp[:legend_foreground_color],
                    fg_alpha,
                    "solid",
                ),
                ",",
                "fill = $cstr,",
                "fill opacity = $bg_alpha,",
                "text opacity = $(alpha(plot_color(sp[:legend_font_color]))),",
                "font = ",
                pgf_font(sp[:legend_font_pointsize], pgf_thickness_scaling(sp)),
                "}",
            ),
        )

        if any(s[:seriestype] === :contour for s in series_list(sp))
            kw[:view] = "{0}{90}"
            kw[:colorbar] = !(sp[:colorbar] in (:none, :off, :hide, false))
        elseif RecipesPipeline.is3d(sp)
            azim, elev = sp[:camera]
            kw[:view] = "{$(azim)}{$(elev)}"
        end

        axisf = PGFPlots.Axis
        if sp[:projection] === :polar
            axisf = PGFPlots.PolarAxis
            #make radial axis vertical
            kw[:xmin] = 90
            kw[:xmax] = 450
        end

        # Search series for any gradient. In case one series uses a gradient set
        # the colorbar and colomap.
        # The reasoning behind doing this on the axis level is that pgfplots
        # colorbar seems to only works on axis level and needs the proper colormap for
        # correctly displaying it.
        # It's also possible to assign the colormap to the series itself but
        # then the colormap needs to be added twice, once for the axis and once for the
        # series.
        # As it is likely that all series within the same axis use the same
        # colormap this should not cause any problem.
        for series in series_list(sp)
            for col in (:markercolor, :fillcolor, :linecolor)
                if typeof(series.plotattributes[col]) == ColorGradient
                    push!(
                        style,
                        "colormap={plots}{$(pgf_colormap(series.plotattributes[col]))}",
                    )

                    if sp[:colorbar] === :none
                        kw[:colorbar] = "false"
                    else
                        kw[:colorbar] = "true"
                    end
                    # goto is needed to break out of col and series for
                    @goto colorbar_end
                end
            end
        end
        @label colorbar_end

        push!(style, "colorbar style={title=$(sp[:colorbar_title])}")
        o = axisf(; style = join(style, ","), kw...)

        # add the series object to the PGFPlots.Axis
        for series in series_list(sp)
            push!.(Ref(o), pgf_series(sp, series))

            # add series annotations
            anns = series[:series_annotations]
            for (xi, yi, str, fnt) in EachAnn(anns, series[:x], series[:y])
                pgf_add_annotation!(
                    o,
                    xi,
                    yi,
                    PlotText(str, fnt),
                    pgf_thickness_scaling(series),
                )
            end
        end

        # add the annotations
        for ann in sp[:annotations]
            pgf_add_annotation!(
                o,
                locate_annotation(sp, ann...)...,
                pgf_thickness_scaling(sp),
            )
        end

        # add the PGFPlots.Axis to the list
        push!(plt.o, o)
    end
    return
end

_show(io::IO, mime::MIME"image/svg+xml", plt::Plot{PGFPlotsBackend}) = show(io, mime, plt.o)

function _show(io::IO, mime::MIME"application/pdf", plt::Plot{PGFPlotsBackend})
    # prepare the object
    pgfplt = PGFPlots.plot(plt.o)

    # save a pdf
    fn = tempname() * ".pdf"
    PGFPlots.save(PGFPlots.PDF(fn), pgfplt)

    # read it into io
    write(io, read(open(fn), String))

    # cleanup
    return PGFPlots.cleanup(plt.o)
end

function _show(io::IO, mime::MIME"application/x-tex", plt::Plot{PGFPlotsBackend})
    fn = tempname() * ".tex"
    PGFPlots.save(
        fn,
        backend_object(plt),
        include_preamble = plt.attr[:tex_output_standalone],
    )
    return write(io, read(open(fn), String))
end

function _display(plt::Plot{PGFPlotsBackend})
    # prepare the object
    pgfplt = PGFPlots.plot(plt.o)

    # save an svg
    fn = string(tempname(), ".svg")
    PGFPlots.save(PGFPlots.SVG(fn), pgfplt)

    # show it
    open_browser_window(fn)

    # cleanup
    return PGFPlots.cleanup(plt.o)
end

# COV_EXCL_STOP

# ---------------------------------------------------------------
function bool_env(x, default)::Bool
    try
        return parse(Bool, get(ENV, x, default))
    catch e
        @warn e
        return false
    end
end

treats_y_as_x(seriestype) =
    seriestype in (:vline, :vspan, :histogram, :barhist, :stephist, :scatterhist)

function replace_image_with_heatmap(z::AbstractMatrix{<:Colorant})
    n, m = size(z)
    colors = palette(vec(z))
    return reshape(1:(n * m), n, m), colors
end

# ---------------------------------------------------------------

"Build line segments for plotting"
mutable struct Segments{T}
    pts::Vector{T}
end

# Segments() = Segments{Float64}(zeros(0))

Segments() = Segments(Float64)
Segments(::Type{T}) where {T} = Segments(T[])
Segments(p::Int) = Segments(NTuple{p, Float64}[])

# Segments() = Segments(zeros(0))

to_nan(::Type{Float64}) = NaN
to_nan(::Type{NTuple{2, Float64}}) = (NaN, NaN)
to_nan(::Type{NTuple{3, Float64}}) = (NaN, NaN, NaN)

coords(segs::Segments{Float64}) = segs.pts
coords(segs::Segments{NTuple{2, Float64}}) = (map(p -> p[1], segs.pts), map(p -> p[2], segs.pts))
coords(segs::Segments{NTuple{3, Float64}}) = (map(p -> p[1], segs.pts), map(p -> p[2], segs.pts), map(p -> p[3], segs.pts))

function Base.push!(segments::Segments{T}, vs...) where {T}
    isempty(segments.pts) || push!(segments.pts, to_nan(T))
    foreach(v -> push!(segments.pts, convert(T, v)), vs)
    return segments
end

function Base.push!(segments::Segments{T}, vs::AVec) where {T}
    isempty(segments.pts) || push!(segments.pts, to_nan(T))
    foreach(v -> push!(segments.pts, convert(T, v)), vs)
    return segments
end

struct SeriesSegment
    # indexes of this segment in series data vectors
    range::UnitRange
    # index into vector-valued attributes corresponding to this segment
    attr_index::Int
end

# -----------------------------------------------------
# helper to manage NaN-separated segments
struct NaNSegmentsIterator
    args::Tuple
    n1::Int
    n2::Int
end

function iter_segments(args...)
    tup = Plots.wraptuple(args)
    n1 = minimum(map(firstindex, tup))
    n2 = maximum(map(lastindex, tup))
    return NaNSegmentsIterator(tup, n1, n2)
end

"floor number x in base b, note this is different from using Base.round(...; base=b) !"
floor_base(x, b) = round_base(x, b, RoundDown)

"ceil number x in base b"
ceil_base(x, b) = round_base(x, b, RoundUp)

round_base(x::T, b, ::RoundingMode{:Down}) where {T} = T(b^floor(log(b, x)))
round_base(x::T, b, ::RoundingMode{:Up}) where {T} = T(b^ceil(log(b, x)))

ignorenan_min_max(::Any, ex) = ex
function ignorenan_min_max(x::AbstractArray{<:AbstractFloat}, ex::Tuple)
    mn, mx = ignorenan_extrema(x)
    return NaNMath.min(ex[1], mn), NaNMath.max(ex[2], mx)
end

function series_segments(series::Series, seriestype::Symbol = :path; check = false)
    x, y, z = series[:x], series[:y], series[:z]
    (x === nothing || isempty(x)) && return UnitRange{Int}[]

    args = RecipesPipeline.is3d(series) ? (x, y, z) : (x, y)
    nan_segments = collect(iter_segments(args...))

    if check
        scales = :xscale, :yscale, :zscale
        for (n, s) in enumerate(args)
            (scale = get(series, scales[n], :identity)) ∈ _logScales || continue
            for (i, v) in enumerate(s)
                if v <= 0
                    @warn "Invalid negative or zero value $v found at series index $i for $scale based $(scales[n])"
                    @debug "" exception = (DomainError(v), stacktrace())
                    break
                end
            end
        end
    end

    segments = if has_attribute_segments(series)
        (
            if seriestype === :shape
                    # warn_on_inconsistent_shape_attr(series, x, y, z, r)
                    (SeriesSegment(segment, j),)
            elseif seriestype in (:scatter, :scatter3d)
                    (SeriesSegment(i:i, i) for i in segment)
            else
                    (SeriesSegment(i:(i + 1), i) for i in first(segment):(last(segment) - 1))
            end for (j, segment) in enumerate(nan_segments)
        ) |> Iterators.flatten
    else
        (SeriesSegment(r, 1) for r in nan_segments)
    end

    # warn_on_attr_dim_mismatch(series, x, y, z, segments)
    return segments
end

function warn_on_attr_dim_mismatch(series, x, y, z, segments)
    isempty(segments) && return
    seg_range = UnitRange(
        minimum(map(seg -> first(seg.range), segments)),
        maximum(map(seg -> last(seg.range), segments)),
    )
    for attr in _segmenting_vector_attributes
        if (v = get(series, attr, nothing)) isa AVec && eachindex(v) != seg_range
            @warn "Indices $(eachindex(v)) of attribute `$attr` does not match data indices $seg_range."
            if any(v -> !isnothing(v) && any(isnan, v), (x, y, z))
                @info """Data contains NaNs or missing values, and indices of `$attr` vector do not match data indices.
                If you intend elements of `$attr` to apply to individual NaN-separated segments in the data,
                pass each segment in a separate vector instead, and use a row vector for `$attr`. Legend entries
                may be suppressed by passing an empty label.
                For example,
                    plot([1:2,1:3], [[4,5],[3,4,5]], label=["y" ""], $attr=[1 2])
                """
            end
        end
    end
    return
end

function warn_on_inconsistent_shape_attr(series, x, y, z, r)
    for attr in _segmenting_vector_attributes
        v = get(series, attr, nothing)
        if v isa AVec && length(unique(v[r])) > 1
            @warn "Different values of `$attr` specified for different shape vertices. Only first one will be used."
            break
        end
    end
    return
end

# helpers to figure out if there are NaN values in a list of array types
anynan(i::Int, args::Tuple) = any(
    a -> try
        isnan(_cycle(a, i))
    catch MethodError
        false
    end, args
)
anynan(args::Tuple) = i -> anynan(i, args)
anynan(istart::Int, iend::Int, args::Tuple) = any(anynan(args), istart:iend)
allnan(istart::Int, iend::Int, args::Tuple) = all(anynan(args), istart:iend)

function Base.iterate(itr::NaNSegmentsIterator, nextidx::Int = itr.n1)
    (i = findfirst(!anynan(itr.args), nextidx:(itr.n2))) === nothing && return
    nextval = nextidx + i - 1

    j = findfirst(anynan(itr.args), nextval:(itr.n2))
    nextnan = j === nothing ? itr.n2 + 1 : nextval + j - 1

    return nextval:(nextnan - 1), nextnan
end
Base.IteratorSize(::NaNSegmentsIterator) = Base.SizeUnknown()  # COV_EXCL_LINE

# Find minimal type that can contain NaN and x
# To allow use of NaN separated segments with categorical x axis

float_extended_type(x::AbstractArray{T}) where {T} = Union{T, Float64}
float_extended_type(x::AbstractArray{Real}) = Float64

# ------------------------------------------------------------------------------------
_cycle(wrapper::InputWrapper, idx::Int) = wrapper.obj
_cycle(wrapper::InputWrapper, idx::AVec{Int}) = wrapper.obj

_cycle(v::AVec, idx::Int) = v[mod(idx, axes(v, 1))]
_cycle(v::AMat, idx::Int) =
    size(v, 1) == 1 ? v[end, mod(idx, axes(v, 2))] : v[:, mod(idx, axes(v, 2))]
_cycle(v, idx::Int) = v

_cycle(v::AVec, indices::AVec{Int}) = map(i -> _cycle(v, i), indices)
_cycle(v::AMat, indices::AVec{Int}) = map(i -> _cycle(v, i), indices)
_cycle(v, indices::AVec{Int}) = fill(v, length(indices))

_cycle(cl::PlotUtils.AbstractColorList, idx::Int) = cl[mod1(idx, end)]
_cycle(cl::PlotUtils.AbstractColorList, idx::AVec{Int}) = cl[mod1.(idx, end)]

_as_gradient(grad) = grad
_as_gradient(v::AbstractVector{<:Colorant}) = cgrad(v)
_as_gradient(cp::ColorPalette) = cgrad(cp, categorical = true)
_as_gradient(c::Colorant) = cgrad([c, c])

makevec(v::AVec) = v
makevec(v::T) where {T} = T[v]

"duplicate a single value, or pass the 2-tuple through"
maketuple(x::Real) = (x, x)
maketuple(x::Tuple) = x

RecipesPipeline.unzip(v) = Unzip.unzip(v)  # COV_EXCL_LINE

"collect into columns (convenience for `unzip` from `Unzip.jl`)"
unzip(v) = RecipesPipeline.unzip(v)

replaceAlias!(plotattributes::AKW, k::Symbol, aliases::Dict{Symbol, Symbol}) =
if haskey(aliases, k)
    plotattributes[aliases[k]] = RecipesPipeline.pop_kw!(plotattributes, k)
end

replaceAliases!(plotattributes::AKW, aliases::Dict{Symbol, Symbol}) =
    foreach(k -> replaceAlias!(plotattributes, k, aliases), collect(keys(plotattributes)))

scale_inverse_scale_func(scale::Symbol) = (
    RecipesPipeline.scale_func(scale),
    RecipesPipeline.inverse_scale_func(scale),
    scale === :identity,
)

function __heatmap_edges(v::AVec, isedges::Bool, ispolar::Bool)
    (n = length(v)) == 1 && return v[1] .+ [ispolar ? max(-v[1], -0.5) : -0.5, 0.5]
    isedges && return v
    # `isedges = true` means that v is a vector which already describes edges
    # and does not need to be extended.
    vmin, vmax = ignorenan_extrema(v)
    extra_min = ispolar ? min(v[1], 0.5(v[2] - v[1])) : 0.5(v[2] - v[1])
    extra_max = 0.5(v[n] - v[n - 1])
    return vcat(vmin - extra_min, 0.5(v[1:(n - 1)] + v[2:n]), vmax + extra_max)
end

_heatmap_edges(::Val{true}, v::AVec, ::Symbol, isedges::Bool, ispolar::Bool) =
    __heatmap_edges(v, isedges, ispolar)

function _heatmap_edges(::Val{false}, v::AVec, scale::Symbol, isedges::Bool, ispolar::Bool)
    f, invf = scale_inverse_scale_func(scale)
    return invf.(__heatmap_edges(f.(v), isedges, ispolar))
end

"create an (n+1) list of the outsides of heatmap rectangles"
heatmap_edges(
    v::AVec,
    scale::Symbol = :identity,
    isedges::Bool = false,
    ispolar::Bool = false,
) = _heatmap_edges(Val(scale === :identity), v, scale, isedges, ispolar)

function heatmap_edges(
        x::AVec,
        xscale::Symbol,
        y::AVec,
        yscale::Symbol,
        z_size::NTuple{2, Int},
        ispolar::Bool = false,
    )
    nx, ny = length(x), length(y)
    # ismidpoints = z_size == (ny, nx) # This fails some tests, but would actually be
    # the correct check, since (4, 3) != (3, 4) and a missleading plot is produced.
    ismidpoints = prod(z_size) == (ny * nx)
    isedges = z_size == (ny - 1, nx - 1)
    (ismidpoints || isedges) ||
        """
    Length of x & y does not match the size of z.
    Must be either `size(z) == (length(y), length(x))` (x & y define midpoints)
    or `size(z) == (length(y)+1, length(x)+1))` (x & y define edges).
    """ |>
        ArgumentError |>
        throw
    return (
        _heatmap_edges(Val(xscale === :identity), x, xscale, isedges, false),
        _heatmap_edges(Val(yscale === :identity), y, yscale, isedges, ispolar),  # special handle for `r` in polar plots
    )
end

is_uniformly_spaced(v; tol = 1.0e-6) =
let dv = diff(v)
    maximum(dv) - minimum(dv) < tol * mean(abs.(dv))
end

function convert_to_polar(theta, r, r_extrema = ignorenan_extrema(r))
    rmin, rmax = r_extrema
    r = @. (r - rmin) / (rmax - rmin)
    x = @. r * cos(theta)
    y = @. r * sin(theta)
    return x, y
end

fakedata(sz::Int...) = fakedata(Random.seed!(PLOTS_SEED), sz...)

function fakedata(rng::AbstractRNG, sz...)
    y = zeros(sz...)
    for r in 2:size(y, 1)
        y[r, :] = 0.95vec(y[r - 1, :]) + randn(rng, size(y, 2))
    end
    return y
end

isijulia() = :IJulia in nameof.(collect(values(Base.loaded_modules)))
isatom() = :Atom in nameof.(collect(values(Base.loaded_modules)))

istuple(::Tuple) = true
istuple(::Any) = false
isvector(::AVec) = true
isvector(::Any) = false
ismatrix(::AMat) = true
ismatrix(::Any) = false
isscalar(::Real) = true
isscalar(::Any) = false

is_2tuple(v) = typeof(v) <: Tuple && length(v) == 2

isvertical(plotattributes::AKW) =
    get(plotattributes, :orientation, :vertical) in (:vertical, :v, :vert)
isvertical(series::Series) = isvertical(series.plotattributes)

ticksType(ticks::AVec{<:Real}) = :ticks
ticksType(ticks::AVec{<:AbstractString}) = :labels
ticksType(ticks::Tuple{<:Union{AVec, Tuple}, <:Union{AVec, Tuple}}) = :ticks_and_labels
ticksType(ticks) = :invalid

limsType(lims::Tuple{<:Real, <:Real}) = :limits
limsType(lims::Symbol) = lims === :auto ? :auto : :invalid
limsType(lims) = :invalid

isautop(sp::Subplot) = sp[:projection_type] === :auto
isortho(sp::Subplot) = sp[:projection_type] ∈ (:ortho, :orthographic)
ispersp(sp::Subplot) = sp[:projection_type] ∈ (:persp, :perspective)

# recursively merge kw-dicts, e.g. for merging extra_kwargs / extra_plot_kwargs in plotly)
recursive_merge(x::AbstractDict...) = merge(recursive_merge, x...)
# if values are not AbstractDicts, take the last definition (as does merge)
recursive_merge(x...) = x[end]

nanpush!(a::AbstractVector, b) = (push!(a, NaN); push!(a, b); nothing)
nanappend!(a::AbstractVector, b) = (push!(a, NaN); append!(a, b); nothing)

function nansplit(v::AVec)
    vs = Vector{eltype(v)}[]
    while true
        if (idx = findfirst(isnan, v)) === nothing
            # no nans
            push!(vs, v)
            break
        elseif idx > 1
            push!(vs, v[1:(idx - 1)])
        end
        v = v[(idx + 1):end]
    end
    return vs
end

function nanvcat(vs::AVec)
    v_out = zeros(0)
    foreach(v -> nanappend!(v_out, v), vs)
    return v_out
end

function sort_3d_axes(x, y, z, letter)
    return if letter === :x
        x, y, z
    elseif letter === :y
        y, x, z
    else
        z, y, x
    end
end

function axes_letters(sp, letter)
    return if RecipesPipeline.is3d(sp)
        sort_3d_axes(:x, :y, :z, letter)
    else
        letter === :x ? (:x, :y) : (:y, :x)
    end
end

handle_surface(z) = z
handle_surface(z::Surface) = permutedims(z.surf)

ok(x::Number, y::Number, z::Number = 0) = isfinite(x) && isfinite(y) && isfinite(z)
ok(tup::Tuple) = ok(tup...)

# compute one side of a fill range from a ribbon
function make_fillrange_side(y::AVec, rib)
    frs = zeros(axes(y))
    for (i, yi) in pairs(y)
        frs[i] = yi + _cycle(rib, i)
    end
    return frs
end

# turn a ribbon into a fillrange
function make_fillrange_from_ribbon(kw::AKW)
    y, rib = kw[:y], kw[:ribbon]
    rib = wraptuple(rib)
    rib1, rib2 = -first(rib), last(rib)
    # kw[:ribbon] = nothing
    kw[:fillrange] = make_fillrange_side(y, rib1), make_fillrange_side(y, rib2)
    return (get(kw, :fillalpha, nothing) === nothing) && (kw[:fillalpha] = 0.5)
end

#turn tuple of fillranges to one path
function concatenate_fillrange(x, y::Tuple)
    rib1, rib2 = collect(first(y)), collect(last(y)) # collect needed until https://github.com/JuliaLang/julia/pull/37629 is merged
    return vcat(x, reverse(x)), vcat(rib1, reverse(rib2))  # x, y
end

get_sp_lims(sp::Subplot, letter::Symbol) = axis_limits(sp, letter)

"""
    xlims([plt])

Returns the x axis limits of the current plot or subplot
"""
xlims(sp::Subplot) = get_sp_lims(sp, :x)

"""
    ylims([plt])

Returns the y axis limits of the current plot or subplot
"""
ylims(sp::Subplot) = get_sp_lims(sp, :y)

"""
    zlims([plt])

Returns the z axis limits of the current plot or subplot
"""
zlims(sp::Subplot) = get_sp_lims(sp, :z)

xlims(plt::Plot, sp_idx::Int = 1) = xlims(plt[sp_idx])
ylims(plt::Plot, sp_idx::Int = 1) = ylims(plt[sp_idx])
zlims(plt::Plot, sp_idx::Int = 1) = zlims(plt[sp_idx])
xlims(sp_idx::Int = 1) = xlims(current(), sp_idx)
ylims(sp_idx::Int = 1) = ylims(current(), sp_idx)
zlims(sp_idx::Int = 1) = zlims(current(), sp_idx)

iscontour(series::Series) = series[:seriestype] in (:contour, :contour3d)
isfilledcontour(series::Series) = iscontour(series) && series[:fillrange] !== nothing

function contour_levels(series::Series, clims)
    iscontour(series) || error("Not a contour series")
    zmin, zmax = clims
    levels = series[:levels]
    if levels isa Integer
        levels = range(zmin, stop = zmax, length = levels + 2)
        isfilledcontour(series) || (levels = levels[2:(end - 1)])
    end
    return levels
end

for comp in (:line, :fill, :marker)
    compcolor = string(comp, :color)
    get_compcolor = Symbol(:get_, compcolor)
    comp_z = string(comp, :_z)

    compalpha = string(comp, :alpha)
    get_compalpha = Symbol(:get_, compalpha)

    @eval begin
        # defines `get_linecolor`, `get_fillcolor` and `get_markercolor` <- for grep
        function $get_compcolor(
                series,
                cmin::Real,
                cmax::Real,
                i::Integer = 1,
                s::Symbol = :identity,
            )
            c = series[$Symbol($compcolor)]  # series[:linecolor], series[:fillcolor], series[:markercolor]
            z = series[$Symbol($comp_z)]  # series[:line_z], series[:fill_z], series[:marker_z]
            return if z === nothing
                isa(c, ColorGradient) ? c : plot_color(_cycle(c, i))
            else
                grad = get_gradient(c)
                if s === :identity
                    get(grad, z[i], (cmin, cmax))
                else
                    base = _logScaleBases[s]
                    get(grad, log(base, z[i]), (log(base, cmin), log(base, cmax)))
                end
            end
        end

        function $get_compcolor(series, i::Integer = 1, s::Symbol = :identity)
            return if series[$Symbol($comp_z)] === nothing
                $get_compcolor(series, 0, 1, i, s)
            else
                $get_compcolor(series, get_clims(series[:subplot]), i, s)
            end
        end

        $get_compcolor(series, clims::NTuple{2, <:Number}, args...) =
            $get_compcolor(series, clims[1], clims[2], args...)

        $get_compalpha(series, i::Integer = 1) = _cycle(series[$Symbol($compalpha)], i)
    end
end

function get_colorgradient(series::Series)
    return if (st = series[:seriestype]) in (:surface, :heatmap) || isfilledcontour(series)
        series[:fillcolor]
    elseif st in (:contour, :wireframe, :contour3d)
        series[:linecolor]
    elseif series[:marker_z] !== nothing
        series[:markercolor]
    elseif series[:line_z] !== nothing
        series[:linecolor]
    elseif series[:fill_z] !== nothing
        series[:fillcolor]
    end
end

single_color(c, v = 0.5) = c
single_color(grad::ColorGradient, v = 0.5) = grad[v]

get_gradient(c) = cgrad()
get_gradient(cg::ColorGradient) = cg
get_gradient(cp::ColorPalette) = cgrad(cp, categorical = true)

get_linewidth(series, i::Integer = 1) = _cycle(series[:linewidth], i)
get_linestyle(series, i::Integer = 1) = _cycle(series[:linestyle], i)
get_fillstyle(series, i::Integer = 1) = _cycle(series[:fillstyle], i)

get_markerstrokecolor(series, i::Integer = 1) =
let msc = series[:markerstrokecolor]
    msc isa ColorGradient ? msc : _cycle(msc, i)
end

get_markerstrokealpha(series, i::Integer = 1) = _cycle(series[:markerstrokealpha], i)
get_markerstrokewidth(series, i::Integer = 1) = _cycle(series[:markerstrokewidth], i)

const _segmenting_vector_attributes = (
    :seriescolor,
    :seriesalpha,
    :linecolor,
    :linealpha,
    :linewidth,
    :linestyle,
    :fillcolor,
    :fillalpha,
    :fillstyle,
    :markercolor,
    :markeralpha,
    :markersize,
    :markerstrokecolor,
    :markerstrokealpha,
    :markerstrokewidth,
    :markershape,
)

const _segmenting_array_attributes = :line_z, :fill_z, :marker_z

# we want to check if a series needs to be split into segments just because
# of its attributes
# check relevant attributes if they have multiple inputs
has_attribute_segments(series::Series) =
    any(
    series[attr] isa AbstractVector && length(series[attr]) > 1 for
        attr in _segmenting_vector_attributes
) || any(series[attr] isa AbstractArray for attr in _segmenting_array_attributes)

check_aspect_ratio(ar::AbstractVector) = nothing  # for PyPlot
check_aspect_ratio(ar::Number) = nothing
check_aspect_ratio(ar::Symbol) =
    ar in (:none, :equal, :auto) || throw(ArgumentError("Invalid `aspect_ratio` = $ar"))
check_aspect_ratio(ar::T) where {T} =
    throw(ArgumentError("Invalid `aspect_ratio`::$T = $ar "))

function get_aspect_ratio(sp)
    ar = sp[:aspect_ratio]
    check_aspect_ratio(ar)
    if ar === :auto
        ar = :none
        for series in series_list(sp)
            if series[:seriestype] === :image
                ar = :equal
            end
        end
    end
    ar isa Bool && (ar = Int(ar))  # NOTE: Bool <: ... <: Number
    return ar
end

get_size(series::Series) = get_size(series.plotattributes[:subplot])
get_size(kw) = get(kw, :size, default(:size))
get_size(plt::Plot) = get_size(plt.attr)
get_size(sp::Subplot) = get_size(sp.plt)

get_thickness_scaling(kw) = get(kw, :thickness_scaling, default(:thickness_scaling))
get_thickness_scaling(plt::Plot) = get_thickness_scaling(plt.attr)
get_thickness_scaling(sp::Subplot) = get_thickness_scaling(sp.plt)
get_thickness_scaling(series::Series) =
    get_thickness_scaling(series.plotattributes[:subplot])

# ---------------------------------------------------------------
makekw(; kw...) = KW(kw)

wraptuple(x::Tuple) = x
wraptuple(x) = (x,)

trueOrAllTrue(f::Function, x::AbstractArray) = all(f, x)
trueOrAllTrue(f::Function, x) = f(x)

allLineTypes(arg) = trueOrAllTrue(a -> get(_typeAliases, a, a) in _allTypes, arg)
allStyles(arg) = trueOrAllTrue(a -> get(_styleAliases, a, a) in _allStyles, arg)
allShapes(arg) =
    (trueOrAllTrue(a -> get(_markerAliases, a, a) in _allMarkers || a isa Shape, arg))
allAlphas(arg) = trueOrAllTrue(
    a ->
    (typeof(a) <: Real && a > 0 && a < 1) || (
        typeof(a) <: AbstractFloat && (a == zero(typeof(a)) || a == one(typeof(a)))
    ),
    arg,
)
allReals(arg) = trueOrAllTrue(a -> typeof(a) <: Real, arg)
allFunctions(arg) = trueOrAllTrue(a -> isa(a, Function), arg)

# ---------------------------------------------------------------

"""
Allows temporary setting of backend and defaults for Plots. Settings apply only for the `do` block.  Example:
```
Plots.with(:gr, size=(400,400), type=:histogram) do
  plot(rand(10))
  plot(rand(10))
end
```
"""
function with(f::Function, args...; scalefonts = nothing, kw...)
    newdefs = KW(kw)

    if :canvas in args
        newdefs[:xticks] = nothing
        newdefs[:yticks] = nothing
        newdefs[:grid] = false
        newdefs[:legend_position] = false
    end

    # dict to store old and new keyword args for anything that changes
    olddefs = KW()
    for k in keys(newdefs)
        olddefs[k] = default(k)
    end

    # save the backend
    CURRENT_BACKEND.sym === :none && _pick_default_backend()
    oldbackend = CURRENT_BACKEND.sym

    for arg in args
        # change backend?
        arg in backends() && backend(arg)

        # TODO: generalize this strategy to allow args as much as possible
        #       as in:  with(:gr, :scatter, :legend, :grid) do; ...; end
        # TODO: can we generalize this enough to also do something similar in the plot commands??

        k = :legend
        if arg in (k, :leg)
            olddefs[k] = default(k)
            newdefs[k] = true
        end

        k = :grid
        if arg == k
            olddefs[k] = default(k)
            newdefs[k] = true
        end
    end

    # now set all those defaults
    default(; newdefs...)
    scalefonts ≡ nothing || scalefontsizes(scalefonts)

    # call the function
    ret = f()

    # put the defaults back
    scalefonts ≡ nothing || resetfontsizes()
    default(; olddefs...)

    # revert the backend
    CURRENT_BACKEND.sym != oldbackend && backend(oldbackend)

    # return the result of the function
    return ret
end

# ---------------------------------------------------------------

const _debug = Ref(false)

debug!(on = true) = _debug[] = on
debugshow(io, x) = show(io, x)
debugshow(io, x::AbstractArray) = print(io, summary(x))

function dumpdict(io::IO, plotattributes::AKW, prefix = "")
    _debug[] || return
    println(io)
    prefix == "" || println(io, prefix, ":")
    for k in sort(collect(keys(plotattributes)))
        @printf(io, "%14s: ", k)
        debugshow(io, plotattributes[k])
        println(io)
    end
    return println(io)
end

# -------------------------------------------------------
# indexing notation

Base.setindex!(plt::Plot, xy::NTuple{2}, i::Integer) = (setxy!(plt, xy, i); plt)
Base.setindex!(plt::Plot, xyz::Tuple{3}, i::Integer) = (setxyz!(plt, xyz, i); plt)

# -------------------------------------------------------
# operate on individual series

Base.push!(series::Series, args...) = extend_series!(series, args...)
Base.append!(series::Series, args...) = extend_series!(series, args...)

function extend_series!(series::Series, yi)
    y = extend_series_data!(series, yi, :y)
    x = extend_to_length!(series[:x], length(y))
    expand_extrema!(series[:subplot][:xaxis], x)
    return x, y
end

extend_series!(series::Series, xi, yi) =
    (extend_series_data!(series, xi, :x), extend_series_data!(series, yi, :y))

extend_series!(series::Series, xi, yi, zi) = (
    extend_series_data!(series, xi, :x),
    extend_series_data!(series, yi, :y),
    extend_series_data!(series, zi, :z),
)

function extend_series_data!(series::Series, v, letter)
    copy_series!(series, letter)
    d = extend_by_data!(series[letter], v)
    expand_extrema!(series[:subplot][get_attr_symbol(letter, :axis)], d)
    return d
end

function copy_series!(series, letter)
    plt = series[:plot_object]
    for s in plt.series_list, l in (:x, :y, :z)
        if (s !== series || l !== letter) && s[l] === series[letter]
            series[letter] = copy(series[letter])
        end
    end
    return
end

extend_to_length!(v::AbstractRange, n) = range(first(v), step = step(v), length = n)
function extend_to_length!(v::AbstractVector, n)
    vmax = isempty(v) ? 0 : ignorenan_maximum(v)
    return extend_by_data!(v, vmax .+ (1:(n - length(v))))
end
extend_by_data!(v::AbstractVector, x) = isimmutable(v) ? vcat(v, x) : push!(v, x)
extend_by_data!(v::AbstractVector, x::AbstractVector) =
    isimmutable(v) ? vcat(v, x) : append!(v, x)

# -------------------------------------------------------

function attr!(series::Series; kw...)
    plotattributes = KW(kw)
    Plots.preprocess_attributes!(plotattributes)
    for (k, v) in plotattributes
        if haskey(_series_defaults, k)
            series[k] = v
        else
            @warn "unused key $k in series attr"
        end
    end
    _series_updated(series[:subplot].plt, series)
    return series
end

function attr!(sp::Subplot; kw...)
    plotattributes = KW(kw)
    Plots.preprocess_attributes!(plotattributes)
    for (k, v) in plotattributes
        if haskey(_subplot_defaults, k)
            sp[k] = v
        else
            @warn "unused key $k in subplot attr"
        end
    end
    return sp
end

# -------------------------------------------------------
# push/append for one series

Base.push!(plt::Plot, args::Real...) = push!(plt, 1, args...)
Base.push!(plt::Plot, i::Integer, args::Real...) = push!(plt.series_list[i], args...)
Base.append!(plt::Plot, args::AbstractVector) = append!(plt, 1, args...)
Base.append!(plt::Plot, i::Integer, args::Real...) = append!(plt.series_list[i], args...)

# tuples
Base.push!(plt::Plot, t::Tuple) = push!(plt, 1, t...)
Base.push!(plt::Plot, i::Integer, t::Tuple) = push!(plt, i, t...)
Base.append!(plt::Plot, t::Tuple) = append!(plt, 1, t...)
Base.append!(plt::Plot, i::Integer, t::Tuple) = append!(plt, i, t...)

# -------------------------------------------------------
# push/append for all series

# push y[i] to the ith series
function Base.push!(plt::Plot, y::AVec)
    ny = length(y)
    for i in 1:(plt.n)
        push!(plt, i, y[mod1(i, ny)])
    end
    return plt
end

# push y[i] to the ith series
# same x for each series
Base.push!(plt::Plot, x::Real, y::AVec) = push!(plt, [x], y)

# push (x[i], y[i]) to the ith series
function Base.push!(plt::Plot, x::AVec, y::AVec)
    nx = length(x)
    ny = length(y)
    for i in 1:(plt.n)
        push!(plt, i, x[mod1(i, nx)], y[mod1(i, ny)])
    end
    return plt
end

# push (x[i], y[i], z[i]) to the ith series
function Base.push!(plt::Plot, x::AVec, y::AVec, z::AVec)
    nx = length(x)
    ny = length(y)
    nz = length(z)
    for i in 1:(plt.n)
        push!(plt, i, x[mod1(i, nx)], y[mod1(i, ny)], z[mod1(i, nz)])
    end
    return plt
end

# ---------------------------------------------------------------

# Some conversion functions
# note: I borrowed these conversion constants from Compose.jl's Measure

inch2px(inches::Real) = float(inches * PX_PER_INCH)
px2inch(px::Real) = float(px / PX_PER_INCH)
inch2mm(inches::Real) = float(inches * MM_PER_INCH)
mm2inch(mm::Real) = float(mm / MM_PER_INCH)
px2mm(px::Real) = float(px * MM_PER_PX)
mm2px(mm::Real) = float(mm / MM_PER_PX)

"Smallest x in plot"
xmin(plt::Plot) = ignorenan_minimum(
    [
        ignorenan_minimum(series.plotattributes[:x]) for series in plt.series_list
    ]
)
"Largest x in plot"
xmax(plt::Plot) = ignorenan_maximum(
    [
        ignorenan_maximum(series.plotattributes[:x]) for series in plt.series_list
    ]
)

"Extrema of x-values in plot"
ignorenan_extrema(plt::Plot) = (xmin(plt), xmax(plt))

# ---------------------------------------------------------------
# get fonts from objects:

plottitlefont(p::Plot) = font(;
    family = p[:plot_titlefontfamily],
    pointsize = p[:plot_titlefontsize],
    valign = p[:plot_titlefontvalign],
    halign = p[:plot_titlefonthalign],
    rotation = p[:plot_titlefontrotation],
    color = p[:plot_titlefontcolor],
)

colorbartitlefont(sp::Subplot) = font(;
    family = sp[:colorbar_titlefontfamily],
    pointsize = sp[:colorbar_titlefontsize],
    valign = sp[:colorbar_titlefontvalign],
    halign = sp[:colorbar_titlefonthalign],
    rotation = sp[:colorbar_titlefontrotation],
    color = sp[:colorbar_titlefontcolor],
)

titlefont(sp::Subplot) = font(;
    family = sp[:titlefontfamily],
    pointsize = sp[:titlefontsize],
    valign = sp[:titlefontvalign],
    halign = sp[:titlefonthalign],
    rotation = sp[:titlefontrotation],
    color = sp[:titlefontcolor],
)

legendfont(sp::Subplot) = font(;
    family = sp[:legend_font_family],
    pointsize = sp[:legend_font_pointsize],
    valign = sp[:legend_font_valign],
    halign = sp[:legend_font_halign],
    rotation = sp[:legend_font_rotation],
    color = sp[:legend_font_color],
)

legendtitlefont(sp::Subplot) = font(;
    family = sp[:legend_title_font_family],
    pointsize = sp[:legend_title_font_pointsize],
    valign = sp[:legend_title_font_valign],
    halign = sp[:legend_title_font_halign],
    rotation = sp[:legend_title_font_rotation],
    color = sp[:legend_title_font_color],
)

tickfont(ax::Axis) = font(;
    family = ax[:tickfontfamily],
    pointsize = ax[:tickfontsize],
    valign = ax[:tickfontvalign],
    halign = ax[:tickfonthalign],
    rotation = ax[:tickfontrotation],
    color = ax[:tickfontcolor],
)

guidefont(ax::Axis) = font(;
    family = ax[:guidefontfamily],
    pointsize = ax[:guidefontsize],
    valign = ax[:guidefontvalign],
    halign = ax[:guidefonthalign],
    rotation = ax[:guidefontrotation],
    color = ax[:guidefontcolor],
)

# ---------------------------------------------------------------
# converts unicode scientific notation, as returned by Showoff,
# to a tex-like format (supported by gr, pyplot, and pgfplots).

function convert_sci_unicode(label::AbstractString)
    unicode_dict = Dict(
        '⁰' => "0",
        '¹' => "1",
        '²' => "2",
        '³' => "3",
        '⁴' => "4",
        '⁵' => "5",
        '⁶' => "6",
        '⁷' => "7",
        '⁸' => "8",
        '⁹' => "9",
        '⁻' => "-",
        "×10" => "×10^{",
    )
    for key in keys(unicode_dict)
        label = replace(label, key => unicode_dict[key])
    end
    if occursin("×10^{", label)
        label = string(label, "}")
    end
    return label
end

function ___straightline_data(xl, yl, x, y, exp_fact)
    x_vals, y_vals = if y[1] == y[2]
        if x[1] == x[2]
            error("Two identical points cannot be used to describe a straight line.")
        else
            [xl[1], xl[2]], [y[1], y[2]]
        end
    elseif x[1] == x[2]
        [x[1], x[2]], [yl[1], yl[2]]
    else
        # get a and b from the line y = a * x + b through the points given by
        # the coordinates x and x
        b = y[1] - (y[1] - y[2]) * x[1] / (x[1] - x[2])
        a = (y[1] - y[2]) / (x[1] - x[2])
        # get the data values
        xdata = [
            clamp(x[1] + (x[1] - x[2]) * (ylim - y[1]) / (y[1] - y[2]), xl...) for
                ylim in yl
        ]

        xdata, a .* xdata .+ b
    end
    # expand the data outside the axis limits, by a certain factor too improve
    # plotly(js) and interactive behaviour
    return (
        x_vals .+ (x_vals[2] - x_vals[1]) .* exp_fact,
        y_vals .+ (y_vals[2] - y_vals[1]) .* exp_fact,
    )
end

function __straightline_data(xl, yl, x, y, exp_fact)
    return if (n = length(x)) == 2
        ___straightline_data(xl, yl, x, y, exp_fact)
    else
        k, r = divrem(n, 3)
        @assert r == 0 "Misformed data. `straightline_data` either accepts vectors of length 2 or 3k. The provided series has length $n"
        xdata, ydata = fill(NaN, n), fill(NaN, n)
        for i in 1:k
            inds = (3i - 2):(3i - 1)
            xdata[inds], ydata[inds] =
                ___straightline_data(xl, yl, x[inds], y[inds], exp_fact)
        end
        xdata, ydata
    end
end

_straightline_data(::Val{true}, ::Function, ::Function, ::Function, ::Function, args...) =
    __straightline_data(args...)

function _straightline_data(
        ::Val{false},
        xf::Function,
        xinvf::Function,
        yf::Function,
        yinvf::Function,
        xl,
        yl,
        x,
        y,
        exp_fact,
    )
    xdata, ydata = __straightline_data(xf.(xl), yf.(yl), xf.(x), yf.(y), exp_fact)
    return xinvf.(xdata), yinvf.(ydata)
end

function straightline_data(series, expansion_factor = 1)
    sp = series[:subplot]
    xl, yl = isvertical(series) ? (xlims(sp), ylims(sp)) : (ylims(sp), xlims(sp))

    # handle axes scales
    xf, xinvf, xnoop = scale_inverse_scale_func(sp[:xaxis][:scale])
    yf, yinvf, ynoop = scale_inverse_scale_func(sp[:yaxis][:scale])

    return _straightline_data(
        Val(xnoop && ynoop),
        xf,
        xinvf,
        yf,
        yinvf,
        xl,
        yl,
        series[:x],
        series[:y],
        [-expansion_factor, +expansion_factor],
    )
end

function _shape_data!(::Val{false}, xf::Function, xinvf::Function, x, xl, exp_fact)
    @inbounds for i in eachindex(x)
        if x[i] == -Inf
            x[i] = xinvf(xf(xl[1]) - exp_fact * (xf(xl[2]) - xf(xl[1])))
        elseif x[i] == +Inf
            x[i] = xinvf(xf(xl[2]) + exp_fact * (xf(xl[2]) - xf(xl[1])))
        end
    end
    return x
end

function _shape_data!(::Val{true}, ::Function, ::Function, x, xl, exp_fact)
    @inbounds for i in eachindex(x)
        if x[i] == -Inf
            x[i] = xl[1] - exp_fact * (xl[2] - xl[1])
        elseif x[i] == +Inf
            x[i] = xl[2] + exp_fact * (xl[2] - xl[1])
        end
    end
    return x
end

function shape_data(series, expansion_factor = 1)
    sp = series[:subplot]
    xl, yl = isvertical(series) ? (xlims(sp), ylims(sp)) : (ylims(sp), xlims(sp))

    # handle axes scales
    xf, xinvf, xnoop = scale_inverse_scale_func(sp[:xaxis][:scale])
    yf, yinvf, ynoop = scale_inverse_scale_func(sp[:yaxis][:scale])

    return (
        _shape_data!(Val(xnoop), xf, xinvf, copy(series[:x]), xl, expansion_factor),
        _shape_data!(Val(ynoop), yf, yinvf, copy(series[:y]), yl, expansion_factor),
    )
end

function _add_triangle!(I::Int, i::Int, j::Int, k::Int, x, y, z, X, Y, Z)
    m = 4(I - 1) + 1
    n = m + 1
    o = m + 2
    p = m + 3
    X[m] = X[p] = x[i]
    Y[m] = Y[p] = y[i]
    Z[m] = Z[p] = z[i]
    X[n] = x[j]
    Y[n] = y[j]
    Z[n] = z[j]
    X[o] = x[k]
    Y[o] = y[k]
    Z[o] = z[k]
    return nothing
end

function mesh3d_triangles(x, y, z, cns::Tuple{Array, Array, Array})
    ci, cj, ck = cns
    length(ci) == length(cj) == length(ck) ||
        throw(ArgumentError("Argument connections must consist of equally sized arrays."))
    X = zeros(eltype(x), 4length(ci))
    Y = zeros(eltype(y), 4length(cj))
    Z = zeros(eltype(z), 4length(ck))
    @inbounds for I in eachindex(ci)  # connections are 0-based
        _add_triangle!(I, ci[I] + 1, cj[I] + 1, ck[I] + 1, x, y, z, X, Y, Z)
    end
    return X, Y, Z
end

function mesh3d_triangles(x, y, z, cns::AbstractVector{NTuple{3, Int}})
    X = zeros(eltype(x), 4length(cns))
    Y = zeros(eltype(y), 4length(cns))
    Z = zeros(eltype(z), 4length(cns))
    @inbounds for I in eachindex(cns)  # connections are 1-based
        _add_triangle!(I, cns[I]..., x, y, z, X, Y, Z)
    end
    return X, Y, Z
end

# cache joined symbols so they can be looked up instead of constructed each time
const _attrsymbolcache = Dict{Symbol, Dict{Symbol, Symbol}}()

get_attr_symbol(letter::Symbol, keyword::String) = get_attr_symbol(letter, Symbol(keyword))
get_attr_symbol(letter::Symbol, keyword::Symbol) = _attrsymbolcache[letter][keyword]

texmath2unicode(s::AbstractString, pat = r"\$([^$]+)\$") =
    replace(s, pat => m -> UnicodeFun.to_latex(m[2:(length(m) - 1)]))

_fmt_paragraph(paragraph::AbstractString; kw...) =
    _fmt_paragraph(PipeBuffer(), paragraph, 0; kw...)

function _fmt_paragraph(
        io::IOBuffer,
        remaining_text::AbstractString,
        column_count::Integer;
        fillwidth = 60,
        leadingspaces = 0,
    )
    kw = (; fillwidth, leadingspaces)

    return if (m = match(r"(.*?) (.*)", remaining_text)) isa Nothing
        if column_count + length(remaining_text) ≤ fillwidth
            print(io, remaining_text)
        else
            print(io, '\n', ' '^leadingspaces, remaining_text)
        end
        read(io, String)
    else
        if column_count + length(m[1]) ≤ fillwidth
            print(io, m[1], ' ')
            _fmt_paragraph(io, m[2], column_count + length(m[1]) + 1; kw...)
        else
            print(io, '\n', ' '^leadingspaces, m[1], ' ')
            _fmt_paragraph(io, m[2], leadingspaces; kw...)
        end
    end
end

_argument_description(s::Symbol) =
if s ∈ keys(_arg_desc)
    aliases = if (al = Plots.aliases(s)) |> length > 0
        " Aliases: " * string(Tuple(al)) * '.'
    else
        ""
    end
    "`$s::$(_arg_desc[s][1])`: $(rstrip(replace(_arg_desc[s][2], '\n' => ' '), '.'))." *
        aliases
else
    ""
end

_document_argument(s::Symbol) =
    _fmt_paragraph(_argument_description(s), leadingspaces = 6 + length(string(s)))

# The following functions implement the guess of the optimal legend position,
# from the data series.
function d_point(x, y, lim, scale)
    p_scaled = (x / scale[1], y / scale[2])
    d = sum(abs2, lim .- p_scaled)
    isnan(d) && return 0.0
    return d
end
# Function barrier because lims are type-unstable
function _guess_best_legend_position(xl, yl, plt, weight = 100)
    scale = (maximum(xl) - minimum(xl), maximum(yl) - minimum(yl))
    u = zeros(4) # faster than tuple
    # Quadrants where the points will be tested
    quadrants = (
        ((0.0, 0.25), (0.0, 0.25)),   # bottomleft
        ((0.75, 1.0), (0.0, 0.25)),   # bottomright
        ((0.0, 0.25), (0.75, 1.0)),   # topleft
        ((0.75, 1.0), (0.75, 1.0)),   # topright
    )
    for series in plt.series_list
        x = series[:x]
        y = series[:y]
        yoffset = firstindex(y) - firstindex(x)
        for (i, lim) in enumerate(Iterators.product(xl, yl))
            lim = lim ./ scale
            for ix in eachindex(x)
                xi, yi = x[ix], _cycle(y, ix + yoffset)
                # ignore y points outside quadrant visible quadrant
                xi < xl[1] + quadrants[i][1][1] * (xl[2] - xl[1]) && continue
                xi > xl[1] + quadrants[i][1][2] * (xl[2] - xl[1]) && continue
                yi < yl[1] + quadrants[i][2][1] * (yl[2] - yl[1]) && continue
                yi > yl[1] + quadrants[i][2][2] * (yl[2] - yl[1]) && continue
                u[i] += inv(1 + weight * d_point(xi, yi, lim, scale))
            end
        end
    end
    # return in the preferred order in case of draws
    ibest = findmin(u)[2]
    u[ibest] ≈ u[4] && return :topright
    u[ibest] ≈ u[3] && return :topleft
    u[ibest] ≈ u[2] && return :bottomright
    return :bottomleft
end

"""
Computes the distances of the plot limits to a sample of points at the extremes of
the ranges, and places the legend at the corner where the maximum distance to the limits is found.
"""
function _guess_best_legend_position(lp::Symbol, plt)
    lp === :best || return lp
    return _guess_best_legend_position(xlims(plt), ylims(plt), plt)
end

macro ext_imp_use(imp_use::QuoteNode, mod::Symbol, args...)
    dots = ntuple(_ -> :., isdefined(Base, :get_extension) ? 1 : 3)
    ex = if length(args) > 0
        Expr(:(:), Expr(dots..., mod), Expr.(:., args)...)
    else
        Expr(dots..., mod)
    end
    return Expr(imp_use.value, ex) |> esc
end

# for UnitfulExt
abstract type AbstractProtectedString <: AbstractString end
struct ProtectedString{S} <: AbstractProtectedString
    content::S
end
const APS = AbstractProtectedString
# Minimum required AbstractString interface to work with PlotsBase
Base.iterate(n::APS) = iterate(n.content)
Base.iterate(n::APS, i::Integer) = iterate(n.content, i)
Base.codeunit(n::APS) = codeunit(n.content)
Base.ncodeunits(n::APS) = ncodeunits(n.content)
Base.isvalid(n::APS, i::Integer) = isvalid(n.content, i)
Base.pointer(n::APS) = pointer(n.content)
Base.pointer(n::APS, i::Integer) = pointer(n.content, i)
function protectedstring(s)
    Base.depwarn(
        """
        `protectedstring` and the `P_str` macro (used for Unitful plots) are deprecated,
        and will be dropped in Plots.jl 2.0 .

        To suppress all axis labels, pass an empty string to `xlabel`, etc.
        To suppress units in axis labels pass `unitformat = :nounit` or `unitformat=(l,u)->l`
        (equivalently for `xunitformat`, `yunitformat`, etc.).
            """,
        :protectedstring,
        force = true,
    )
    return ProtectedString(s)
end

"""
    P_str(s)

(Unitful extension only).
Creates a string that will be Protected from recipe passes.

Example:
```julia
julia> using Unitful
julia> plot([0,1]u"m", [1,2]u"m/s^2", xlabel=P"This label will NOT display units")
julia> plot([0,1]u"m", [1,2]u"m/s^2", xlabel="This label will display units")
```
"""
macro P_str(s)
    return protectedstring(s)
end

# for `PGFPlotsx` together with `UnitfulExt`
function pgfx_sanitize_string end  # COV_EXCL_LINE

# github.com/stevengj/PythonPlot.jl

is_marker_supported(::PythonPlotBackend, shape::Shape) = true

# problem: github.com/tbreloff/Plots.jl/issues/308
# solution: hack from @stevengj: github.com/JuliaPy/PyPlot.jl/pull/223#issuecomment-229747768
let otherdisplays = splice!(Base.Multimedia.displays, 2:length(Base.Multimedia.displays))
    append!(Base.Multimedia.displays, otherdisplays)
end

if PythonPlot.version < v"3.4"
    @warn """You are using Matplotlib $(PythonPlot.version), which is no longer
    officially supported by the Plots community. To ensure smooth Plots.jl
    integration update your Matplotlib library to a version ≥ 3.4.0
    """
end

for k in (:linthresh, :base, :label)
    # add PythonPlot specific symbols to cache
    _attrsymbolcache[k] = Dict{Symbol, Symbol}()
    for letter in (:x, :y, :z, Symbol(), :top, :bottom, :left, :right)
        _attrsymbolcache[k][letter] = Symbol(k, letter)
    end
end

_py_handle_surface(v) = v
_py_handle_surface(z::Surface) = z.surf

_py_color(s) = _py_color(parse(Colorant, string(s)))
_py_color(c::Colorant) = [red(c), green(c), blue(c), alpha(c)]  # NOTE: returning a tuple fails `PythonPlot`
_py_color(cs::AVec) = map(_py_color, cs)
_py_color(grad::PlotUtils.AbstractColorList) = _py_color(color_list(grad))
_py_color(c::Colorant, α) = _py_color(plot_color(c, α))

function _py_colormap(cg::ColorGradient)
    pyvals = collect(zip(cg.values, _py_color(PlotUtils.color_list(cg))))
    cm = mpl.colors.LinearSegmentedColormap.from_list("tmp", pyvals)
    cm.set_bad(color = (0, 0, 0, 0.0), alpha = 0.0)
    return cm
end
function _py_colormap(cg::PlotUtils.CategoricalColorGradient)
    r = range(0, 1; length = 256)
    pyvals = collect(zip(r, _py_color(cg[r])))
    cm = mpl.colors.LinearSegmentedColormap.from_list("tmp", pyvals)
    cm.set_bad(color = (0, 0, 0, 0.0), alpha = 0.0)
    return cm
end
_py_colormap(c) = _py_colormap(_as_gradient(c))

_py_shading(c, z) = mpl.colors.LightSource(270, 45).shade(
    z,
    _py_colormap(c),
    vert_exag = 0.1,
    blend_mode = "soft",
)

# get the style (solid, dashed, etc)
function _py_linestyle(seriestype::Symbol, linestyle::Symbol)
    seriestype === :none && return " "
    linestyle === :solid && return "-"
    linestyle === :dash && return "--"
    linestyle === :dot && return ":"
    linestyle === :dashdot && return "-."
    @warn "Unknown linestyle $linestyle"
    return "-"
end

function _py_marker(marker::Shape)
    x, y = coords(marker)
    n = length(x)
    mat = zeros(n + 1, 2)
    @inbounds for i in eachindex(x)
        mat[i, 1] = x[i]
        mat[i, 2] = y[i]
    end
    mat[n + 1, :] = @view mat[1, :]
    return mpl.path.Path(mat)
end

# get the marker shape
function _py_marker(marker::Symbol)
    marker === :none && return " "
    marker === :circle && return "o"
    marker === :rect && return "s"
    marker === :diamond && return "D"
    marker === :utriangle && return "^"
    marker === :dtriangle && return "v"
    marker === :+ && return "+"
    marker === :x && return "x"
    marker === :star5 && return "*"
    marker === :pentagon && return "p"
    marker === :hexagon && return "h"
    marker === :octagon && return "8"
    marker === :pixel && return ","
    marker === :hline && return "_"
    marker === :vline && return "|"
    haskey(_shapes, marker) && return _py_marker(_shapes[marker])

    @warn "Unknown marker $marker"
    return "o"
end

# _py_marker(markers::AVec) = map(_py_marker, markers)
function _py_marker(markers::AVec)
    @warn "Vectors of markers are currently unsupported in PythonPlot: $markers"
    return markers |> first |> _py_marker
end

# pass through
function _py_marker(marker::AbstractString)
    @assert length(marker) == 1
    return marker
end

function _py_stepstyle(seriestype::Symbol)
    seriestype === :steppost && return "steps-post"
    seriestype === :stepmid && return "steps-mid"
    seriestype === :steppre && return "steps-pre"
    return "default"
end

function _py_fillstepstyle(seriestype::Symbol)
    seriestype === :steppost && return "post"
    seriestype === :stepmid && return "mid"
    seriestype === :steppre && return "pre"
    return nothing
end

_py_fillstyle(::Nothing) = nothing
_py_fillstyle(fillstyle::Symbol) = string(fillstyle)

function _py_get_matching_math_font(parent_fontfamily)
    # matplotlib supported math fonts according to
    # matplotlib.org/stable/tutorials/text/mathtext.html
    _py_math_supported_fonts = Dict{String, String}(
        "serif" => "dejavuserif",
        "sans-serif" => "dejavusans",
        "stixsans" => "stixsans",
        "stix" => "stix",
        "cm" => "cm",
    )
    # Fallback to "dejavusans" or "dejavuserif" in case the parentfont is different
    # from supported by matplotlib fonts
    matching_font(font) = occursin("serif", lowercase(font)) ? "dejavuserif" : "dejavusans"
    return get(_py_math_supported_fonts, parent_fontfamily, matching_font(parent_fontfamily))
end

get_locator_and_formatter(vals::AVec) =
    mpl.ticker.FixedLocator(eachindex(vals)), mpl.ticker.FixedFormatter(vals)

labelfunc(scale::Symbol, backend::PythonPlotBackend) =
    PythonPlot.LaTeXStrings.latexstring ∘ labelfunc_tex(scale)

_py_mask_nans(z) = PythonPlot.pycall(numpy.ma.masked_invalid, z)

# ---------------------------------------------------------------------------

function fix_xy_lengths!(plt::Plot{PythonPlotBackend}, series::Series)
    return if (x = series[:x]) !== nothing
        y = series[:y]
        nx, ny = length(x), length(y)
        if !(get(series.plotattributes, :z, nothing) isa Surface || nx == ny)
            if nx < ny
                series[:x] = map(i -> Float64(x[mod1(i, nx)]), 1:ny)
            else
                series[:y] = map(i -> Float64(y[mod1(i, ny)]), 1:nx)
            end
        end
    end
end

is_valid_cgrad_color(::PlotUtils.ColorSchemes.ColorScheme) = true
is_valid_cgrad_color(::PlotUtils.ColorGradient) = true
is_valid_cgrad_color(::AbstractVector) = true
is_valid_cgrad_color(::Nothing) = false
is_valid_cgrad_color(::Symbol) = true
is_valid_cgrad_color(::Any) = false

_py_linecolormap(series::Series) =
if (color = get(series, :linecolor, nothing)) |> is_valid_cgrad_color
    _py_colormap(cgrad(color, alpha = get_linealpha(series)))
else
    nothing
end
_py_fillcolormap(series::Series) =
if (color = get(series, :fillcolor, nothing)) |> is_valid_cgrad_color
    _py_colormap(cgrad(color, alpha = get_fillalpha(series)))
else
    nothing
end
_py_markercolormap(series::Series) =
if (color = get(series, :markercolor, nothing)) |> is_valid_cgrad_color
    _py_colormap(cgrad(color, alpha = get_markeralpha(series)))
else
    nothing
end

# ---------------------------------------------------------------------------
# Figure utils -- F*** matplotlib for making me work so hard to figure this crap out

# the drawing surface
_py_canvas(fig) = fig.canvas

# the object controlling draw commands
_py_renderer(fig) = _py_canvas(fig).get_renderer()

# draw commands... paint the screen (probably updating internals too)
_py_drawfig(fig) = fig.draw(_py_renderer(fig))

# `get_points` returns a numpy array in the form [x0 y0; x1 y1] coords (origin is bottom-left (0, 0)!)
_py_extents(obj) = PythonPlot.PyArray(obj.get_window_extent().get_points())

# see cjdoris.github.io/PythonCall.jl/stable/conversion-to-julia/#py2jl-conversion
to_vec(x) = PythonPlot.pyconvert(Vector, x)
to_str(x) = PythonPlot.pyconvert(String, x)

# compute a bounding box (with origin top-left), however PythonPlot gives coords with origin bottom-left
function _py_bbox(obj)
    pyisnone(obj) && return _py_bbox(nothing)
    fl, fr, fb, ft = bb = _py_extents(obj.get_figure())
    l, r, b, t = ex = _py_extents(obj)
    # @show obj bb ex
    x0, y0, width, height = l * px, (ft - t) * px, (r - l) * px, (t - b) * px
    # @show width height
    return BoundingBox(x0, y0, width, height)
end

_py_bbox(::Nothing) = BoundingBox(0mm, 0mm)

# get the bounding box of the union of the objects
function _py_bbox(v::AVec)
    bbox_union = DEFAULT_BBOX[]
    for obj in v
        bbox_union += _py_bbox(obj)
    end
    return bbox_union
end

get_axis(l::Symbol, x::Union{Symbol, AbstractString}) = Symbol(:get_, l, x)
set_axis(l::Symbol, x::Union{Symbol, AbstractString}) = Symbol(:set_, l, x)

# bounding box: union of axis tick labels
_py_bbox_ticks(ax, letter) =
if to_str(ax.name) == "3d"
    _py_bbox(nothing)  # FIXME: broken in `3d` (huge extents)
else
    getproperty(ax, get_axis(letter, :ticklabels))() |> to_vec |> _py_bbox
end

# bounding box: axis guide
_py_bbox_axislabel(ax, letter) =
    getproperty(ax, get_axis(letter, :axis))().label |> _py_bbox

# bounding box: union of axis ticks and guide
function _py_bbox_axis(ax, letter)
    ticks = _py_bbox_ticks(ax, letter)
    labels = _py_bbox_axislabel(ax, letter)
    return ticks + labels
end

# bounding box: axis title
function _py_bbox_title(ax)
    bb = DEFAULT_BBOX[]
    for s in (:title, :_left_title, :_right_title)
        bb += _py_bbox(getproperty(ax, s))
    end
    return bb
end

# bounding box: legend
_py_bbox_legend(ax) = _py_bbox(ax.get_legend())
_py_thickness_scale(plt::Plot{PythonPlotBackend}, ptsz) = ptsz * plt[:thickness_scaling]

# ---------------------------------------------------------------------------

# Create the window/figure for this backend.
function _create_backend_figure(plt::Plot{PythonPlotBackend})
    w, h = map(s -> px2inch(s * plt[:dpi] / Plots.DPI), plt[:size])
    # reuse the current figure?
    return plt[:overwrite_figure] ? PythonPlot.gcf() : PythonPlot.figure()
end

# Set up the subplot within the backend object.
# function _initialize_subplot(plt::Plot{PythonPlotBackend}, sp::Subplot{PythonPlotBackend})

function _py_init_subplot(plt::Plot{PythonPlotBackend}, sp::Subplot{PythonPlotBackend})
    fig = plt.o
    projection = (proj = sp[:projection]) ∈ (nothing, :none) ? nothing : string(proj)
    kw = if projection == "3d"
        # PythonPlot defaults to "persp" projection by default, we choose to unify backends
        # by using a default "ortho" proj when `:auto`
        (;
            proj_type = (
                auto = "ortho",
                ortho = "ortho",
                orthographic = "ortho",
                persp = "persp",
                perspective = "persp",
            )[sp[:projection_type]],
        )
    else
        (;)
    end
    # add a new axis, and force it to create a new one by setting a distinct label
    return sp.o = fig.add_subplot(; label = string(gensym()), projection, kw...)
end

# ---------------------------------------------------------------------------
const _py_line_series = :path, :path3d, :steppre, :stepmid, :steppost, :straightline
const _py_marker_series =
    :path, :scatter, :path3d, :scatter3d, :steppre, :stepmid, :steppost, :bar
const _py_legend_series = :path, :straightline, :scatter, :steppre, :stepmid, :steppost

function _py_add_series(plt::Plot{PythonPlotBackend}, series::Series)
    # plotattributes = series.plotattributes
    st = series[:seriestype]
    sp = series[:subplot]
    xaxis, yaxis = sp[:xaxis], sp[:yaxis]
    ax = sp.o

    # PythonPlot doesn't handle mismatched x/y
    fix_xy_lengths!(plt, series)

    # ax = getAxis(plt, series)
    x, y, z = (_py_handle_surface(series[letter]) for letter in (:x, :y, :z))
    if st === :straightline
        x, y = straightline_data(series)
    elseif st === :shape
        x, y = shape_data(series)
    end

    # make negative radii positive and flip the angle (PythonPlot ignores negative radii)
    ispolar(series) && for i in eachindex(y)
        if y[i] < 0
            y[i] = -y[i]
            x[i] -= π
        end
    end

    xyargs = st ∈ _3dTypes ? (x, y, z) : (x, y)

    # handle zcolor and get c/cmap
    needs_colorbar = hascolorbar(sp)
    vmin, vmax = clims = get_clims(sp, series)

    # Dict to store extra kwargs
    extrakw = if st === :wireframe || st === :hexbin
        # vmin, vmax cause an error for wireframe plot
        # We are not supporting clims for hexbin as calculation of bins is not trivial
        KW()
    else
        KW(:vmin => vmin, :vmax => vmax)
    end

    # holds references to any python object representing the matplotlib series
    handles = []
    push_h(x) = push!(handles, x)

    # pass in an integer value as an arg, but a levels list as a keyword arg
    levels = series[:levels]
    levelargs = isscalar(levels) ? levels : ()
    isvector(levels) && (extrakw[:levels] = levels)

    # add custom frame shapes to markershape?
    series_annotations_shapes!(series, :xy)

    # some defaults
    cbar_scale = sp[:colorbar_scale]
    linewidths = linewidth = _py_thickness_scale(plt, get_linewidth(series))
    linestyles = linestyle = _py_linestyle(st, get_linestyle(series))
    edgecolor = edgecolors = _py_color(get_linecolor(series, 1, cbar_scale))
    facecolor = facecolors = _py_color(series[:fillcolor])
    zorder = series[:series_plotindex]
    alpha = get_fillalpha(series)
    label = series[:label]

    # add lines ?
    if st ∈ _py_line_series && maximum(series[:linewidth]) > 0
        for (k, segment) in enumerate(series_segments(series, st; check = true))
            i, rng = segment.attr_index, segment.range
            ax.plot(
                map(arg -> arg[rng], xyargs)...;
                label = k == 1 ? label : "",
                color = _py_color(
                    single_color(get_linecolor(series, clims, i, cbar_scale)),
                    get_linealpha(series, i),
                ),
                linewidth = _py_thickness_scale(plt, get_linewidth(series, i)),
                linestyle = _py_linestyle(st, get_linestyle(series, i)),
                solid_capstyle = "butt",
                dash_capstyle = "butt",
                drawstyle = _py_stepstyle(st),
                zorder,
            ) |> push_h
        end

        if (a = series[:arrow]) !== nothing && !RecipesPipeline.is3d(st)  # TODO: handle 3d later
            if typeof(a) != Arrow
                @warn "Unexpected type for arrow: $(typeof(a))"
            else
                arrowprops = Dict(
                    "arrowstyle" => "simple,head_length=$(a.headlength),head_width=$(a.headwidth)",
                    "edgecolor" => edgecolor,
                    "facecolor" => edgecolor,
                    "linewidth" => linewidth,
                    "linestyle" => linestyle,
                    "shrinkA" => 0,
                    "shrinkB" => 0,
                )
                add_arrows(x, y) do xyprev, xy
                    ax.annotate(
                        "";
                        xytext = (0.001xyprev[1] + 0.999xy[1], 0.001xyprev[2] + 0.999xy[2]),
                        zorder = 999,
                        arrowprops,
                        xy,
                    )
                end
            end
        end
    end

    # add markers ?
    if series[:markershape] !== :none && st ∈ _py_marker_series
        for segment in series_segments(series, :scatter)
            i, rng = segment.attr_index, segment.range
            args = if st === :bar && !isvertical(series)
                y[rng], x[rng]
            else
                x[rng], y[rng]
            end
            RecipesPipeline.is3d(sp) && (args = (args..., z[rng]))
            ax.scatter(
                args...;
                zorder = zorder + 0.5,
                marker = _py_marker(_cycle(series[:markershape], i)),
                s = _py_thickness_scale(plt, _cycle(series[:markersize], i)) .^ 2,
                facecolors = _py_color(
                    get_markercolor(series, i, cbar_scale),
                    get_markeralpha(series, i),
                ),
                edgecolors = _py_color(
                    get_markerstrokecolor(series, i),
                    get_markerstrokealpha(series, i),
                ),
                linewidths = _py_thickness_scale(plt, get_markerstrokewidth(series, i)),
                label,
                extrakw...,
            ) |> push_h
        end
    end

    if st === :shape
        for segment in series_segments(series, st)
            i, rng = segment.attr_index, segment.range
            if length(rng) > 1
                lc = get_linecolor(series, clims, i, cbar_scale)
                fc = get_fillcolor(series, clims, i)
                la = get_linealpha(series, i)
                fa = get_fillalpha(series, i)
                ls = get_linestyle(series, i)
                fs = get_fillstyle(series, i)
                has_fs = !isnothing(fs)

                path = mpl.path.Path(hcat(x[rng], y[rng]))

                # shape outline (and potentially solid fill)
                mpl.patches.PathPatch(
                    path;
                    edgecolor = _py_color(lc, la),
                    facecolor = _py_color(fc, has_fs ? 0 : fa),
                    linewidth = _py_thickness_scale(plt, get_linewidth(series, i)),
                    linestyle = _py_linestyle(st, ls),
                    fill = !has_fs,
                    zorder,
                    label,
                ) |>
                    ax.add_patch |>
                    push_h
                # shape hatched fill - hatch color/alpha are controlled by edge (not face) color/alpha
                if has_fs
                    mpl.patches.PathPatch(
                        path;
                        label = "",
                        edgecolor = _py_color(fc, fa),
                        facecolor = _py_color(fc, 0), # don't fill with solid background
                        hatch = _py_fillstyle(fs),
                        linewidth = 0, # don't replot shape outline (doesn't affect hatch linewidth)
                        linestyle = _py_linestyle(st, ls),
                        fill = false,
                        zorder,
                    ) |>
                        ax.add_patch |>
                        push_h
                end
            end
        end
    elseif st === :image
        x, y = series[:x], series[:y]
        xmin, xmax = ignorenan_extrema(x)
        ymin, ymax = ignorenan_extrema(y)
        z = if eltype(z) <: Colors.AbstractGray
            float(z)
        elseif eltype(z) <: Colorant
            rgba = Array{Float64, 3}(undef, size(z)..., 4)
            rgba[:, :, 1] = Colors.red.(z)
            rgba[:, :, 2] = Colors.green.(z)
            rgba[:, :, 3] = Colors.blue.(z)
            rgba[:, :, 4] = Colors.alpha.(z)
            rgba
        else
            z  # hopefully it's in a data format that will "just work" with imshow
        end
        aspect = if get_aspect_ratio(sp) === :equal
            "equal"
        else
            "auto"
        end
        ax.imshow(
            z;
            cmap = _py_colormap(cgrad(plot_color([:black, :white]))),
            extent = (xmin, xmax, ymax, ymin),
            vmin = 0.0,
            vmax = 1.0,
            zorder,
            aspect,
        ) |> push_h
    elseif st === :heatmap
        x, y = heatmap_edges(x, xaxis[:scale], y, yaxis[:scale], size(z))
        expand_extrema!(xaxis, x)
        expand_extrema!(yaxis, y)
        ax.pcolormesh(
            x,
            y,
            _py_mask_nans(z);
            # edgecolors = (series[:linewidth] > 0 ? _py_linecolor(series) : "face"),
            cmap = _py_fillcolormap(series),
            zorder,
            alpha,
            label,
            extrakw...,
        ) |> push_h
    elseif st === :mesh3d
        cns = series[:connections]
        polygons = if cns isa AbstractVector{<:AbstractVector{<:Integer}}
            # Combination of any polygon types
            map(inds -> map(i -> [x[i], y[i], z[i]], inds), cns)
        elseif cns isa AbstractVector{NTuple{N, <:Integer}} where {N}
            # Only N-gons - connections have to be 1-based (indexing)
            map(inds -> map(i -> [x[i], y[i], z[i]], inds), cns)
        elseif cns isa NTuple{3, <:AbstractVector{<:Integer}}
            # Only triangles - connections have to be 0-based (indexing)
            X, Y, Z = mesh3d_triangles(x, y, z, cns)
            ntris = length(cns[1])
            polys = sizehint!(Matrix{eltype(x)}[], ntris)
            for n in 1:ntris
                m = 4(n - 1) + 1
                push!(
                    polys,
                    [
                        X[m + 0] Y[m + 0] Z[m + 0]
                        X[m + 1] Y[m + 1] Z[m + 1]
                        X[m + 2] Y[m + 2] Z[m + 2]
                    ],
                )
            end
            polys
        else
            "Unsupported `:connections` type $(typeof(series[:connections])) for seriestype=$st" |>
                ArgumentError |>
                throw
        end
        mpl_toolkits.mplot3d.art3d.Poly3DCollection(
            polygons;
            linewidths,
            edgecolors,
            facecolors,
            zorder,
            alpha,
        ) |>
            ax.add_collection3d |>
            push_h
    elseif st === :hexbin
        sekw = series[:extra_kwargs]
        extrakw[:mincnt] = get(sekw, :mincnt, nothing)
        extrakw[:edgecolors] = get(sekw, :edgecolors, edgecolor)
        ax.hexbin(
            x,
            y;
            C = series[:weights],
            gridsize = series[:bins] === :auto ? 100 : series[:bins],  # 100 is the default value
            cmap = _py_fillcolormap(series),  # applies to the pcolorfast object
            linewidths,
            zorder,
            alpha,
            label,
            extrakw...,
        ) |> push_h
    elseif st ∈ (:contour, :contour3d)
        if st === :contour3d
            extrakw[:extend3d] = true
            if !ismatrix(x) || !ismatrix(y)
                x, y = repeat(x', length(y), 1), repeat(y, 1, length(x))
            end
        end
        if typeof(series[:linecolor]) <: AbstractArray
            extrakw[:colors] = _py_color.(series[:linecolor])
        else
            extrakw[:cmap] = _py_linecolormap(series)
        end
        (
            handle = ax.contour(
                x,
                y,
                z,
                levelargs...;
                linestyles,
                linewidths,
                zorder,
                extrakw...,
            )
        ) |> push_h
        series[:contour_labels] === true && ax.clabel(handle, handle.levels)

        # contour fills
        series[:fillrange] !== nothing &&
            ax.contourf(
            x,
            y,
            z,
            levelargs...;
            zorder = zorder + 0.5,
            label,
            alpha,
            extrakw...,
        ) |> push_h
    elseif st ∈ (:surface, :wireframe)
        if z isa AbstractMatrix
            if !ismatrix(x) || !ismatrix(y)
                x, y = repeat(x', length(y), 1), repeat(y, 1, length(x))
            end
            if st === :surface
                if series[:fill_z] !== nothing
                    # the surface colors are different than z-value
                    extrakw[:facecolors] =
                        _py_shading(series[:fillcolor], _py_handle_surface(series[:fill_z]))
                    extrakw[:shade] = false
                else
                    extrakw[:cmap] = _py_fillcolormap(series)
                end
            end
            rstride, cstride = series[:stride]
            getproperty(ax, Symbol(:plot_, st))(
                x,
                y,
                z;
                edgecolor,
                linewidth,
                rstride,
                cstride,
                zorder,
                label,
                extrakw...,
            ) |> push_h

            # contours on the axis planes
            series[:contours] && for (zdir, mat) in (("x", x), ("y", y), ("z", z))
                offset = zdir == "y" ? ignorenan_maximum(mat) : ignorenan_minimum(mat)
                ax.contourf(
                    x,
                    y,
                    z,
                    levelargs...;
                    cmap = _py_fillcolormap(series),
                    offset,  # where to draw the contour plane
                    zdir,
                ) |> push_h
            end
        elseif typeof(z) <: AbstractVector
            # tri-surface plot (matplotlib.org/mpl_toolkits/mplot3d/tutorial.html#tri-surface-plots)
            ax.plot_trisurf(
                x,
                y,
                z;
                cmap = _py_fillcolormap(series),
                edgecolor,
                linewidth,
                zorder,
                label,
                extrakw...,
            ) |> push_h
        else
            error("Unsupported z type $(typeof(z)) for seriestype=$st")
        end
    end

    series[:serieshandle] = handles

    # # smoothing
    # handleSmooth(plt, ax, series, series[:smooth])

    # handle area filling
    if (fillrange = series[:fillrange]) !== nothing && st !== :contour
        for segment in series_segments(series)
            i, rng = segment.attr_index, segment.range
            f, dim1, dim2 = if isvertical(series)
                :fill_between, x[rng], y[rng]
            else
                :fill_betweenx, y[rng], x[rng]
            end
            n = length(dim1)
            args = if typeof(fillrange) <: Union{Real, AVec}
                dim1, _cycle(fillrange, rng), dim2
            elseif is_2tuple(fillrange)
                dim1, _cycle(fillrange[1], rng), _cycle(fillrange[2], rng)
            end

            la = get_linealpha(series, i)
            fc = get_fillcolor(series, clims, i)
            fa = get_fillalpha(series, i)
            fs = get_fillstyle(series, i)
            has_fs = !isnothing(fs)

            getproperty(ax, f)(
                args...,
                trues(n),
                false,
                _py_fillstepstyle(st);
                # hatch color/alpha are controlled by edge (not face) color/alpha
                # if has_fs, set edge color/alpha <- fill color/alpha and face alpha <- 0
                edgecolor = _py_color(fc, has_fs ? fa : la),
                facecolor = _py_color(fc, has_fs ? 0 : fa),
                hatch = _py_fillstyle(fs),
                linewidths = 0,
                zorder,
            ) |> push_h
        end
    end

    # this is all we need to add the series_annotations text
    for (xi, yi, str, fnt) in EachAnn(series[:series_annotations], x, y)
        _py_add_annotations(sp, xi, yi, PlotText(str, fnt))
    end
    return
end

# --------------------------------------------------------------------------

_py_set_lims(ax, sp::Subplot, axis::Axis) =
let letter = axis[:letter]
    getproperty(ax, set_axis(letter, :lim))(axis_limits(sp, letter)...)
end

function _py_set_ticks(sp, ax, ticks, letter)
    ticks === :auto && return
    axis = getproperty(ax, get_attr_symbol(letter, :axis))
    if ticks === :none || ticks === nothing || ticks == false
        kw = KW()
        for dir in (:top, :bottom, :left, :right)
            kw[dir] = kw[get_attr_symbol(:label, dir)] = false
        end
        axis.set_tick_params(; which = "both", kw...)
        return
    end

    tick_values, tick_labels = if (ttype = ticksType(ticks)) === :ticks
        ticks, []
    elseif ttype === :ticks_and_labels
        ticks
    else
        error("Invalid input for $(letter)ticks: $ticks")
    end
    length(tick_values) > 0 && axis.set_ticks(tick_values)
    length(tick_labels) > 0 && axis.set_ticklabels(tick_labels)
    return nothing
end

function _py_compute_axis_minval(sp::Subplot, axis::Axis)
    # compute the smallest absolute value for the log scale's linear threshold
    minval = 1.0
    for sp in axis.sps, series in series_list(sp)
        (v = series.plotattributes[axis[:letter]]) |> isempty && continue
        minval = NaNMath.min(minval, ignorenan_minimum(abs.(v)))
    end

    # now if the axis limits go to a smaller abs value, use that instead
    vmin, vmax = axis_limits(sp, axis[:letter])
    return NaNMath.min(minval, abs(vmin), abs(vmax))
end

function _py_set_scale(ax, sp::Subplot, scale::Symbol, letter::Symbol)
    scale ∈ supported_scales() || return @warn "Unhandled scale value in PythonPlot: $scale"
    scl, kw = if scale === :identity
        "linear", KW()
    else
        "symlog",
            KW(
                get_attr_symbol(:base, Symbol()) => _logScaleBases[scale],
                get_attr_symbol(:linthresh, Symbol()) => NaNMath.max(
                    1.0e-16,
                    _py_compute_axis_minval(sp, sp[get_attr_symbol(letter, :axis)]),
                ),
            )
    end
    return getproperty(ax, set_axis(letter, :scale))(scl; kw...)
end

_py_set_scale(ax, sp::Subplot, axis::Axis) =
    _py_set_scale(ax, sp, axis[:scale], axis[:letter])

_py_set_spine_color(spines, color) = foreach(loc -> spines[loc].set_color(color), spines)

_py_set_spine_color(spines::Dict, color) =
    foreach(spine -> spine.set_color(color), values(spines))

function _py_set_axis_colors(sp, ax, a::Axis)
    _py_set_spine_color(ax.spines, _py_color(a[:foreground_color_border]))
    axissym = get_attr_symbol(a[:letter], :axis)
    return if hasproperty(ax, axissym)
        tickcolor =
            sp[:framestyle] ∈ (:zerolines, :grid) ?
            _py_color(plot_color(a[:foreground_color_grid], a[:gridalpha])) :
            _py_color(a[:foreground_color_axis])
        ax.tick_params(
            axis = string(a[:letter]),
            which = "both",
            colors = tickcolor,
            labelcolor = _py_color(a[:tickfontcolor]),
        )
        getproperty(ax, axissym).label.set_color(_py_color(a[:guidefontcolor]))
    end
end

# --------------------------------------------------------------------------
_py_hide_spines(ax) =
    foreach(spine -> getproperty(ax.spines, string(spine)).set_visible(false), ax.spines)

function _before_layout_calcs(plt::Plot{PythonPlotBackend})
    # update the fig
    w, h = plt[:size]
    fig = plt.o
    fig.clear()
    fig.set_size_inches(w / DPI, h / DPI, forward = true)
    fig.set_facecolor(_py_color(plt[:background_color_outside]))
    fig.set_dpi(plt[:dpi])

    # resize the window
    PythonPlot.get_current_fig_manager().resize(w, h)

    # initialize subplots
    foreach(sp -> _py_init_subplot(plt, sp), plt.subplots)

    # add the series
    foreach(series -> _py_add_series(plt, series), plt.series_list)

    # update subplots
    for sp in plt.subplots
        (ax = sp.o) === nothing && continue
        xaxis, yaxis = sp[:xaxis], sp[:yaxis]

        # add the annotations
        foreach(
            ann -> _py_add_annotations(sp, locate_annotation(sp, ann...)...),
            sp[:annotations],
        )

        # title
        if (title = sp[:title]) != ""  # support symbols
            loc = lowercase(string(sp[:titlelocation]))
            func = getproperty(
                ax, if loc == "left"
                    :_left_title
                elseif loc == "right"
                    :_right_title
                else
                    :title
                end
            )
            func.set_text(string(title))
            func.set_fontsize(_py_thickness_scale(plt, sp[:titlefontsize]))
            func.set_family(sp[:titlefontfamily])
            func.set_math_fontfamily(_py_get_matching_math_font(sp[:titlefontfamily]))
            func.set_color(_py_color(sp[:titlefontcolor]))
        end

        # add the colorbar legend
        if hascolorbar(sp)
            cbar_scale = sp[:colorbar_scale]
            # add keyword args for a discrete colorbar
            slist = series_list(sp)
            cbar_series = slist[findfirst(hascolorbar, slist)]
            kw = KW()
            handle =
            if !isempty(sp[:zaxis][:discrete_values]) &&
                    cbar_series[:seriestype] === :heatmap
                kw[:ticks], kw[:format] =
                    get_locator_and_formatter(sp[:zaxis][:discrete_values])
                # kw[:values] = eachindex(sp[:zaxis][:discrete_values])
                kw[:values] = sp[:zaxis][:continuous_values]
                kw[:boundaries] = vcat(0, kw[:values] + 0.5)
                cbar_series[:serieshandle][end]
            elseif any(
                    cbar_series[attr] !== nothing for attr in (:line_z, :fill_z, :marker_z)
                )
                cmin, cmax = get_clims(sp)
                norm = if cbar_scale === :identity
                    mpl.colors.Normalize(vmin = cmin, vmax = cmax)
                else
                    mpl.colors.LogNorm(vmin = cmin, vmax = cmax)
                end
                cmap = nothing
                for func in (_py_linecolormap, _py_fillcolormap, _py_markercolormap)
                    (cmap = func(cbar_series)) === nothing || break
                end
                c_map = mpl.cm.ScalarMappable(; cmap, norm)
                c_map.set_array(PythonPlot.pylist([]))
                c_map
            else
                cbar_series[:serieshandle][end]
            end
            kw[:spacing] = "proportional"

            cb_sym = sp[:colorbar]
            label = string("cbar", sp[:subplot_index])
            cbar = if RecipesPipeline.is3d(sp) || ispolar(sp)
                cax = fig.add_axes([0.9, 0.1, 0.03, 0.8]; label)
                fig.colorbar(handle; cax, kw...)
            else
                # divider approach works only with 2d plots
                divider = mpl_toolkits.axes_grid1.make_axes_locatable(ax)
                pos, pad, orientation = if cb_sym === :left
                    cb_sym, "5%", "vertical"
                elseif cb_sym === :top
                    cb_sym, "2.5%", "horizontal"
                elseif cb_sym === :bottom
                    cb_sym, "5%", "horizontal"
                else  # :right or :best
                    :right, "2.5%", "vertical"
                end
                # Reasonable value works most of the usecases
                cax = divider.append_axes(string(pos); size = "5%", label, pad)
                if cb_sym === :left
                    cax.yaxis.set_ticks_position("left")
                elseif cb_sym === :right
                    cax.yaxis.set_ticks_position("right")
                elseif cb_sym === :top
                    cax.xaxis.set_ticks_position("top")
                else  # :bottom or :best
                    cax.xaxis.set_ticks_position("bottom")
                end
                fig.colorbar(handle; orientation, cax, kw...)
            end

            cbar.set_label(
                sp[:colorbar_title];
                size = _py_thickness_scale(plt, sp[:colorbar_titlefontsize]),
                family = sp[:colorbar_titlefontfamily],
                math_fontfamily = _py_get_matching_math_font(sp[:colorbar_titlefontfamily]),
                color = _py_color(sp[:colorbar_titlefontcolor]),
            )

            # cbar.formatter.set_useOffset(false)  # this for some reason does not work, must be a pyplot bug, instead this is a workaround:
            cbar_scale === :identity && cbar.formatter.set_powerlimits((-Inf, Inf))
            cbar.update_ticks()

            ticks = get_colorbar_ticks(sp)
            axis, cbar_axis, ticks_letter = if sp[:colorbar] ∈ (:top, :bottom)
                xaxis, cbar.ax.xaxis, :x  # colorbar inherits from x axis
            else
                yaxis, cbar.ax.yaxis, :y  # colorbar inherits from y axis
            end
            _py_set_scale(cbar.ax, sp, sp[:colorbar_scale], ticks_letter)
            sp[:colorbar_ticks] === :native ||
                _py_set_ticks(sp, cbar.ax, ticks, ticks_letter)

            for lab in cbar_axis.get_ticklabels()
                lab.set_fontsize(_py_thickness_scale(plt, sp[:colorbar_tickfontsize]))
                lab.set_family(sp[:colorbar_tickfontfamily])
                lab.set_math_fontfamily(
                    _py_get_matching_math_font(sp[:colorbar_tickfontfamily]),
                )
                lab.set_color(_py_color(sp[:colorbar_tickfontcolor]))
            end

            # Adjust thickness of the cbar ticks
            intensity = 0.5
            cbar_axis.set_tick_params(
                direction = axis[:tick_direction] === :out ? "out" : "in",
                width = _py_thickness_scale(plt, intensity),
                length = axis[:tick_direction] === :none ? 0 :
                    5_py_thickness_scale(plt, intensity),
            )

            cbar.outline.set_linewidth(_py_thickness_scale(plt, 1))

            sp.attr[:cbar_handle] = cbar
            sp.attr[:cbar_ax] = cax
        end

        framestyle = sp[:framestyle]
        if !ispolar(sp) && !RecipesPipeline.is3d(sp)
            for pos in ("left", "right", "top", "bottom")
                # Scale all axes by default first
                getproperty(ax.spines, pos).set_linewidth(_py_thickness_scale(plt, 1))
            end

            # Then set visible some of them
            if framestyle === :semi
                intensity = 0.5

                pyspine = getproperty(ax.spines, yaxis[:mirror] ? "left" : "right")
                pyspine.set_alpha(intensity)
                pyspine.set_linewidth(_py_thickness_scale(plt, intensity))

                pyspine = getproperty(ax.spines, xaxis[:mirror] ? "bottom" : "top")
                pyspine.set_linewidth(_py_thickness_scale(plt, intensity))
                pyspine.set_alpha(intensity)
            elseif framestyle === :box
                ax.tick_params(top = true)   # Add ticks too
                ax.tick_params(right = true) # Add ticks too
            elseif framestyle ∈ (:axes, :origin)
                for loc in
                    (xaxis[:mirror] ? "bottom" : "top", yaxis[:mirror] ? "left" : "right")
                    getproperty(ax.spines, loc).set_visible(false)
                end
                if framestyle === :origin
                    ax.spines.bottom.set_position("zero")
                    ax.spines.left.set_position("zero")
                end
            elseif framestyle ∈ (:grid, :none, :zerolines)
                _py_hide_spines(ax)
                if framestyle === :zerolines
                    ax.axhline(
                        y = 0,
                        color = _py_color(xaxis[:foreground_color_axis]),
                        lw = _py_thickness_scale(plt, 0.75),
                    )
                    ax.axvline(
                        x = 0,
                        color = _py_color(yaxis[:foreground_color_axis]),
                        lw = _py_thickness_scale(plt, 0.75),
                    )
                end
            end

            if xaxis[:mirror]
                ax.xaxis.set_label_position("top")  # the guides
                framestyle === :box || ax.xaxis.tick_top()
            end

            if yaxis[:mirror]
                ax.yaxis.set_label_position("right")  # the guides
                framestyle === :box || ax.yaxis.tick_right()
            end
        end

        # axis attributes
        for letter in (:x, :y, :z)
            axissym = get_attr_symbol(letter, :axis)
            hasproperty(ax, axissym) || continue
            axis = sp[axissym]
            pyaxis = getproperty(ax, axissym)

            if axis[:guide_position] !== :auto && letter !== :z
                pyaxis.set_label_position(string(axis[:guide_position]))
            end

            _py_set_scale(ax, sp, axis)
            _py_set_lims(ax, sp, axis)
            (ispolar(sp) && letter === :y) && ax.set_rlabel_position(90)
            ticks = framestyle === :none ? nothing : get_ticks(sp, axis)

            has_major_ticks = ticks !== :none && ticks !== nothing && ticks !== false
            has_major_ticks &= if (ttype = ticksType(ticks)) === :ticks
                length(ticks) > 0
            elseif ttype === :ticks_and_labels
                tcs, labs = ticks
                if framestyle === :origin
                    # don't show the 0 tick label for the origin framestyle
                    labs[tcs .== 0] .= ""
                end
                length(tcs) > 0
            else
                true
            end

            # Set ticks
            intensity = 0.5  # this value corresponds to scaling of other grid elements
            length_factor = 6  # arbitrary factor (closest to mpl examples)

            if axis[:ticks] === :native # it is easier to reset than to account for this
                _py_set_lims(ax, sp, axis)
                pyaxis.set_major_locator(mpl.ticker.AutoLocator())
                pyaxis.set_major_formatter(mpl.ticker.ScalarFormatter())
            elseif has_major_ticks
                fontProperties = Dict(
                    "math_fontfamily" => _py_get_matching_math_font(axis[:tickfontfamily]),
                    "size" => _py_thickness_scale(plt, axis[:tickfontsize]),
                    "rotation" => axis[:tickfontrotation],
                    "family" => axis[:tickfontfamily],
                )
                positions = getproperty(ax, get_axis(letter, :ticks))()
                pyaxis.set_major_locator(mpl.ticker.FixedLocator(positions))
                kw = if RecipesPipeline.is3d(sp)
                    NamedTuple(Symbol(k) => v for (k, v) in fontProperties)
                else
                    (; fontdict = PythonPlot.PyDict(fontProperties))
                end
                getproperty(ax, set_axis(letter, :ticklabels))(positions; kw...)
                _py_set_ticks(sp, ax, ticks, letter)

                pyaxis.set_tick_params(
                    direction = axis[:tick_direction] === :out ? "out" : "in",
                    width = _py_thickness_scale(plt, intensity),
                    length = axis[:tick_direction] === :none ? 0 :
                        length_factor * _py_thickness_scale(plt, intensity),
                )
            else
                pyaxis.set_major_locator(mpl.ticker.NullLocator())
            end

            getproperty(ax, set_axis(letter, :label))(Plots.get_guide(axis))
            pyaxis.label.set_fontsize(_py_thickness_scale(plt, axis[:guidefontsize]))
            pyaxis.label.set_family(axis[:guidefontfamily])
            pyaxis.label.set_math_fontfamily(
                _py_get_matching_math_font(axis[:guidefontfamily]),
            )

            RecipesPipeline.is3d(sp) && pyaxis.set_rotate_label(false)
            axis[:flip] && getproperty(ax, Symbol(:invert_, letter, :axis))()

            axis[:guidefontrotation] + if letter === :y && !RecipesPipeline.is3d(sp)
                90
            else
                0
            end |> pyaxis.label.set_rotation

            if axis[:grid] && has_major_ticks
                pyaxis.grid(
                    true,
                    color = _py_color(axis[:foreground_color_grid]),
                    linestyle = _py_linestyle(:line, axis[:gridstyle]),
                    linewidth = _py_thickness_scale(plt, axis[:gridlinewidth]),
                    alpha = axis[:gridalpha],
                )
                ax.set_axisbelow(true)
            else
                pyaxis.grid(false)
            end

            # minorticks
            if !no_minor_intervals(axis) && has_major_ticks
                ax.minorticks_on()
                n_minor_intervals = num_minor_intervals(axis)
                if (scale = axis[:scale]) === :identity
                    mpl.ticker.AutoMinorLocator(n_minor_intervals)
                else
                    mpl.ticker.LogLocator(
                        base = _logScaleBases[scale],
                        subs = 1:n_minor_intervals,
                    )
                end |> pyaxis.set_minor_locator
                pyaxis.set_tick_params(
                    which = "minor",
                    direction = axis[:tick_direction] === :out ? "out" : "in",
                    length = axis[:tick_direction] === :none ? 0 :
                        0.5length_factor * _py_thickness_scale(plt, intensity),
                )
            end

            axis[:minorgrid] && pyaxis.grid(
                true;
                which = "minor",
                color = _py_color(axis[:foreground_color_grid]),
                linestyle = _py_linestyle(:line, axis[:minorgridstyle]),
                linewidth = _py_thickness_scale(plt, axis[:minorgridlinewidth]),
                alpha = axis[:minorgridalpha],
            )

            _py_set_axis_colors(sp, ax, axis)
        end

        # showaxis
        if !xaxis[:showaxis]
            kw = KW()
            ispolar(sp) && ax.spines.polar.set_visible(false)
            for dir in (:top, :bottom)
                ispolar(sp) || getproperty(ax.spines, string(dir)).set_visible(false)
                kw[dir] = kw[get_attr_symbol(:label, dir)] = false
            end
            ax.xaxis.set_tick_params(; which = "both", kw...)
        end
        if !yaxis[:showaxis]
            kw = KW()
            for dir in (:left, :right)
                ispolar(sp) || getproperty(ax.spines, string(dir)).set_visible(false)
                kw[dir] = kw[get_attr_symbol(:label, dir)] = false
            end
            ax.yaxis.set_tick_params(; which = "both", kw...)
        end

        # aspect ratio
        if (ratio = get_aspect_ratio(sp)) !== :none
            if RecipesPipeline.is3d(sp)
                if ratio === :auto
                    nothing
                elseif ratio === :equal
                    ax.set_box_aspect((1, 1, 1))
                else
                    ax.set_box_aspect(ratio)
                end
            else
                ax.set_aspect(ratio isa Symbol ? string(ratio) : ratio, anchor = "C")
            end
        end

        # camera/view angle
        if RecipesPipeline.is3d(sp)
            # convert azimuth to match GR behaviour
            azimuth, elevation = sp[:camera] .- (90, 0)
            ax.view_init(elevation, azimuth)
        end

        # legend
        _py_add_legend(plt, sp, ax)

        # this sets the bg color inside the grid
        ax.set_facecolor(_py_color(sp[:background_color_inside]))

        # link axes
        x_ax_link, y_ax_link = xaxis.sps[1].o, yaxis.sps[1].o
        if Bool(ax != x_ax_link)  # twinx
            ax.sharey(y_ax_link)
        end
        if Bool(ax != y_ax_link)  # twiny
            ax.sharex(x_ax_link)
        end
    end  # for sp in pl.subplots
    return _py_drawfig(fig)
end

expand_padding!(padding, bb, plotbb) =
if ispositive(width(bb)) && ispositive(height(bb))
    padding[1] = max(padding[1], left(plotbb) - left(bb))
    padding[2] = max(padding[2], top(plotbb) - top(bb))
    padding[3] = max(padding[3], right(bb) - right(plotbb))
    padding[4] = max(padding[4], bottom(bb) - bottom(plotbb))
end

# Set the (left, top, right, bottom) minimum padding around the plot area
# to fit ticks, tick labels, guides, colorbars, etc.
function _update_min_padding!(sp::Subplot{PythonPlotBackend})
    (ax = sp.o) === nothing && return sp.minpad
    plotbb = _py_bbox(ax)

    # TODO: this should initialize to the margin from sp.attr
    # figure out how much the axis components and title "stick out" from the plot area
    padding = [0mm, 0mm, 0mm, 0mm]  # leftpad, toppad, rightpad, bottompad

    for bb in (
            _py_bbox_axis(ax, :x),
            _py_bbox_axis(ax, :y),
            _py_bbox_title(ax),
            _py_bbox_legend(ax),
        )
        expand_padding!(padding, bb, plotbb)
    end
    if haskey(sp.attr, :cbar_ax) # Treat colorbar the same way
        cbar_ax = sp.attr[:cbar_handle].ax
        for bb in (
                _py_bbox_axis(cbar_ax, :x),
                _py_bbox_axis(cbar_ax, :y),
                _py_bbox_title(cbar_ax),
            )
            expand_padding!(padding, bb, plotbb)
        end
    end

    # optionally add the width of colorbar labels and colorbar to rightpad
    if RecipesPipeline.is3d(sp)
        expand_padding!(padding, _py_bbox_axis(ax, :z), plotbb)
        if haskey(sp.attr, :cbar_ax)
            sp.attr[:cbar_bbox] = _py_bbox(sp.attr[:cbar_handle].ax)
        end
    end

    # add ∈ the user-specified margin
    padding .+= [sp[:left_margin], sp[:top_margin], sp[:right_margin], sp[:bottom_margin]]

    return sp.minpad = Tuple((Plots.DPI / sp.plt[:dpi]) .* padding)
end

# -----------------------------------------------------------------

_py_add_annotations(sp::Subplot{PythonPlotBackend}, x, y, val) =
    sp.o.annotate(val, xy = (x, y), annotation_clip = false, zorder = 999)

_py_add_annotations(sp::Subplot{PythonPlotBackend}, x, y, val::PlotText) = sp.o.annotate(
    val.str,
    xy = (x, y),
    size = _py_thickness_scale(sp.plt, val.font.pointsize),
    horizontalalignment = val.font.halign === :hcenter ? "center" : string(val.font.halign),
    verticalalignment = val.font.valign === :vcenter ? "center" : string(val.font.valign),
    color = _py_color(val.font.color),
    rotation = val.font.rotation,
    family = val.font.family,
    annotation_clip = false,
    zorder = 999,
)

_py_add_annotations(sp::Subplot{PythonPlotBackend}, x, y, z, val::PlotText) = sp.o.text3D(
    x,
    y,
    z,
    val.str;
    size = _py_thickness_scale(sp.plt, val.font.pointsize),
    horizontalalignment = val.font.halign === :hcenter ? "center" : string(val.font.halign),
    verticalalignment = val.font.valign === :vcenter ? "center" : string(val.font.valign),
    color = _py_color(val.font.color),
    rotation = val.font.rotation,
    family = val.font.family,
    zorder = 999,
)

# -----------------------------------------------------------------

_py_legend_pos(pos::Tuple{S, T}) where {S <: Real, T <: Real} = "lower left"

function _py_legend_pos(pos::Tuple{<:Real, Symbol})
    s, c = sincosd(pos[1]) .* (pos[2] === :outer ? -1 : 1)
    yanchors = "lower", "center", "upper"
    xanchors = "left", "center", "right"
    return join([yanchors[legend_anchor_index(s)], xanchors[legend_anchor_index(c)]], ' ')
end

# legend_pos_from_angle(theta, xmin, xcenter, xmax, ymin, ycenter, ymax)
_py_legend_bbox(pos::Tuple{<:Real, Symbol}) =
    legend_pos_from_angle(pos[1], 0.0, 0.5, 1.0, 0.0, 0.5, 1.0)
_py_legend_bbox(pos) = pos

function _py_add_legend(plt::Plot, sp::Subplot, ax)
    (leg = sp[:legend_position]) === :none && return

    # gotta do this to ensure both axes are included
    labels, handles = [], []
    push_h(x) = push!(handles, x)

    nseries = 0
    for series in series_list(sp)
        should_add_to_legend(series) || continue
        clims = get_clims(sp, series)
        nseries += 1
        # add a line/marker and a label
        if series[:seriestype] === :shape || series[:fillrange] !== nothing
            lc = get_linecolor(series, clims)
            fc = get_fillcolor(series, clims)
            la = get_linealpha(series)
            fa = get_fillalpha(series)
            ls = get_linestyle(series)
            fs = get_fillstyle(series)
            has_fs = !isnothing(fs)

            # line (and potentially solid fill)
            mpl.patches.Patch(
                edgecolor = _py_color(single_color(lc), la),
                facecolor = _py_color(single_color(fc), has_fs ? 0 : fa),
                linewidth = _py_thickness_scale(plt, clamp(get_linewidth(series), 0, 5)),
                linestyle = _py_linestyle(series[:seriestype], ls),
                capstyle = "butt",
            ) |> push_h

            # plot two handles on top of each other by passing in a tuple
            # matplotlib.org/stable/tutorials/intermediate/legend_guide.html

            # hatched fill
            # hatch color/alpha are controlled by edge (not face) color/alpha
            has_fs &&
                mpl.patches.Patch(
                edgecolor = _py_color(single_color(fc), fa),
                facecolor = _py_color(single_color(fc), 0), # don't fill with solid background
                hatch = _py_fillstyle(fs),
                linewidth = 0, # don't replot shape outline (doesn't affect hatch linewidth)
                linestyle = _py_linestyle(series[:seriestype], ls),
                capstyle = "butt",
            ) |> push_h
        elseif series[:seriestype] ∈ _py_legend_series
            has_line = get_linewidth(series) > 0
            PythonPlot.pyplot.Line2D(
                (0, 1),
                (0, 0),
                color = _py_color(
                    single_color(get_linecolor(series, clims)),
                    get_linealpha(series),
                ),
                linewidth = _py_thickness_scale(
                    plt,
                    has_line * sp[:legend_font_pointsize] / 8,
                ),
                linestyle = _py_linestyle(:path, get_linestyle(series)),
                solid_capstyle = "butt",
                solid_joinstyle = "miter",
                dash_capstyle = "butt",
                dash_joinstyle = "miter",
                marker = _py_marker(_cycle(series[:markershape], 1)),
                markersize = _py_thickness_scale(plt, 0.8sp[:legend_font_pointsize]),
                markeredgecolor = _py_color(
                    single_color(get_markerstrokecolor(series)),
                    get_markerstrokealpha(series),
                ),
                markerfacecolor = _py_color(
                    single_color(get_markercolor(series, clims, 1, sp[:colorbar_scale])),
                    get_markeralpha(series),
                ),
                markeredgewidth = _py_thickness_scale(
                    plt,
                    0.8get_markerstrokewidth(series) * sp[:legend_font_pointsize] /
                        first(series[:markersize]),
                ),   # retain the markersize/markerstroke ratio from the markers on the plot
            ) |> push_h
        else
            first(series[:serieshandle]) |> push_h
        end
        push!(labels, series[:label])
    end

    # if anything was added, call ax.legend and set the colors
    isempty(handles) && return

    leg = legend_angle(leg)
    ncol = if (lc = sp[:legend_column]) < 0
        nseries
    elseif lc > 1
        lc == nseries ||
            @warn "n° of legend_column=$lc is not compatible with n° of series=$nseries"
        nseries
    else
        1
    end
    leg = ax.legend(
        handles,
        labels;
        loc = _py_legend_pos(leg),
        bbox_to_anchor = _py_legend_bbox(leg),
        scatterpoints = 1,
        fontsize = _py_thickness_scale(plt, sp[:legend_font_pointsize]),
        facecolor = _py_color(sp[:legend_background_color]),
        edgecolor = _py_color(sp[:legend_foreground_color]),
        framealpha = alpha(plot_color(sp[:legend_background_color])),
        fancybox = false,  # makes the legend box square
        # borderpad = 0.8,  # to match GR legendbox
        ncol,
    )
    leg.get_frame().set_linewidth(_py_thickness_scale(plt, 1))
    leg.set_zorder(1_000)
    if sp[:legend_title] !== nothing
        leg.set_title(string(sp[:legend_title]))
        PythonPlot.setp(
            leg.get_title(),
            color = _py_color(sp[:legend_title_font_color]),
            family = sp[:legend_title_font_family],
            fontsize = _py_thickness_scale(plt, sp[:legend_title_font_pointsize]),
        )
    end

    for txt in leg.get_texts()
        PythonPlot.setp(
            txt,
            color = _py_color(sp[:legend_font_color]),
            family = sp[:legend_font_family],
            fontsize = _py_thickness_scale(plt, sp[:legend_font_pointsize]),
        )
    end
    return nothing
end

# -----------------------------------------------------------------

# Use the bounding boxes (and methods left/top/right/bottom/width/height) `sp.bbox` and `sp.plotarea` to
# position the subplot in the backend.
function _update_plot_object(plt::Plot{PythonPlotBackend})
    for sp in plt.subplots
        (ax = sp.o) === nothing && return
        figw, figh = sp.plt[:size] .* px

        # ax.set_position signature: `[left, bottom, width, height]`
        bbox_to_pcts(sp.plotarea, figw, figh) |> ax.set_position

        if haskey(sp.attr, :cbar_ax) && RecipesPipeline.is3d(sp)  # 2D plots are completely handled by axis dividers
            bb = sp.attr[:cbar_bbox]
            # this is the bounding box of just the colors of the colorbar (not labels)
            pad = 2mm
            cb_bbox = BoundingBox(
                right(sp.bbox) - 2width(bb) - 2pad,  # x0
                top(sp.bbox) + pad,  # y0
                width(bb),  # width
                height(sp.bbox) - 2pad,  # height
            )
            get(sp[:extra_kwargs], "3d_colorbar_axis", bbox_to_pcts(cb_bbox, figw, figh)) |>
                sp.attr[:cbar_ax].set_position
        end
    end
    return PythonPlot.draw()
end

# -----------------------------------------------------------------
# display/output

_display(plt::Plot{PythonPlotBackend}) = plt.o.show()

for (mime, fmt) in (
        "application/eps" => "eps",
        "image/eps" => "eps",
        "application/pdf" => "pdf",
        "image/png" => "png",
        "application/postscript" => "ps",
        "image/svg+xml" => "svg",
        "application/x-tex" => "pgf",
    )
    @eval function _show(io::IO, ::MIME{Symbol($mime)}, plt::Plot{PythonPlotBackend})
        fig = plt.o
        return fig.canvas.print_figure(
            io,
            format = $fmt,
            # bbox_inches = "tight",
            facecolor = fig.get_facecolor(),
            edgecolor = "none",
            dpi = plt[:dpi],
        )
    end
end

closeall(::PythonPlotBackend) = PythonPlot.close("all")

macro test_save(fmt)
    quote
        let pl = plot(1:2), fn = tempname(), fp = tmpname()  # fp is an AbstractPath from FilePathsBase.jl
            getfield(Plots, $fmt)(pl, fn)
            getfield(Plots, $fmt)(fn)
            getfield(Plots, $fmt)(fp)

            fn_ext = string(fn, '.', $fmt)
            fp_ext = string(fp, '.', $fmt)

            savefig(fn_ext)
            savefig(fp_ext)

            savefig(pl, fn_ext)
            savefig(pl, fp_ext)

            @test isfile(fn_ext)
            @test isfile(fp_ext)

            @test_throws ErrorException savefig(string(fn, ".foo"))
            @test_throws ErrorException savefig(string(fp, ".foo"))
        end

        let pl = plot(1:2), io = PipeBuffer()
            getfield(Plots, $fmt)(pl, io)
            getfield(Plots, $fmt)(io)
            @test length(io.data) > 10
        end
    end |> esc
end

Plots.with(:gr) do
    @test Plots.defaultOutputFormat(plot()) == "png"
    @test Plots.addExtension("foo", "bar") == "foo.bar"

    @test_save :png
    @test_save :pdf
    @test_save :svg
    @test_save :ps
end

Plots.with(:unicodeplots) do
    @test_save :txt
    if Plots.UnicodePlots.get_font_face() ≢ nothing
        @test_save :png
    end
end

if Sys.isunix()
    Plots.with(:plotlyjs) do
        @test_save :html
        @test_save :json
        @test_save :pdf
        @test_save :png
        @test_save :svg
        # @test_save :eps
    end

    Plots.with(:plotly) do
        @test_save :pdf
        @test_save :png
        @test_save :svg
        @test_save :html
    end
end

if Sys.islinux() && Sys.which("pdflatex") ≢ nothing
    Plots.with(:pgfplotsx) do
        @test_save :tex
        @test_save :png
        @test_save :pdf
    end

    Plots.with(:pythonplot) do
        @test_save :pdf
        @test_save :png
        @test_save :svg
        @test_save :eps
        @test_save :ps
    end
end

#=
Plots.with(:gaston) do
    @test_save :png
    @test_save :pdf
    @test_save :eps
    @test_save :svg
end

Plots.with(:inspectdr) do
    @test_save :png
    @test_save :pdf
    @test_save :eps
    @test_save :svg
end
=#

@testset "html" begin
    Plots.with(:gr) do
        io = PipeBuffer()
        pl = plot(1:2)
        pl.attr[:html_output_format] = :auto
        Plots._show(io, MIME("text/html"), pl)
        pl.attr[:html_output_format] = :png
        Plots._show(io, MIME("text/html"), pl)
        pl.attr[:html_output_format] = :svg
        Plots._show(io, MIME("text/html"), pl)
        pl.attr[:html_output_format] = :txt
        Plots._show(io, MIME("text/html"), pl)
    end
end

@testset "size error handling" begin
    plt = plot(size = ())
    @test_throws ArgumentError savefig(plt, tempname())
    plt = plot(size = (1))
    @test_throws ArgumentError savefig(plt, tempname())
    plt = plot(size = (1, 2, 3))
    @test_throws ArgumentError savefig(plt, tempname())
end

@testset "Animation constructors" begin
    @test Animation() isa Animation
    @test Animation("dir") isa Animation
    @test Animation("dir", String[]) isa Animation
end

@testset "Missing animation directory" begin
    anim = Animation("nonexisting_dir")
    @test_throws SystemError frame(anim, plot([1, 2, 3]))
end

@testset "Empty anim" begin
    anim = @animate for i in []
    end
    @test_throws ArgumentError gif(anim, show_msg = false)
end

@userplot CirclePlot
@recipe function f(cp::CirclePlot)
    x, y, i = cp.args
    n = length(x)
    inds = circshift(1:n, 1 - i)
    linewidth --> range(0, 10, length = n)
    seriesalpha --> range(0, 1, length = n)
    aspect_ratio --> 1
    label --> false
    x[inds], y[inds]
end

@testset "Circle plot" begin
    n = 10
    t = range(0, 2π, length = n)
    x = sin.(t)
    y = cos.(t)

    anim = @animate for i in 1:n
        circleplot(x, y, i)
    end
    @test filesize(gif(anim, show_msg = false).filename) > 10_000
    @test filesize(mov(anim, show_msg = false).filename) > 10_000
    @test filesize(mp4(anim, show_msg = false).filename) > 10_000
    @test filesize(webm(anim, show_msg = false).filename) > 10_000
    @test filesize(Plots.apng(anim, show_msg = false).filename) > 10_000

    @gif for i in 1:n
        circleplot(x, y, i, line_z = 1:n, cbar = false, framestyle = :zerolines)
    end every 5

    @gif for i in 1:n
        circleplot(x, y, i, line_z = 1:n, cbar = false, framestyle = :zerolines)
    end when i % 5 == 0

    @gif for i in 1:n
        circleplot(x, y, i, line_z = 1:n, cbar = false, framestyle = :zerolines)
    end when i % 5 == 0 fps = 10

    @test_throws LoadError macroexpand(
        @__MODULE__,
        quote
            @gif for i in 1:n
                circleplot(x, y, i, line_z = 1:n, cbar = false, framestyle = :zerolines)
            end when i % 5 == 0 every 10 # cannot use every and when together
        end,
    )

    @test_nowarn macroexpand(
        @__MODULE__,
        quote
            @gif for i in 1:n
                circleplot(x, y, i, line_z = 1:n, cbar = false, framestyle = :zerolines)
            end asdf = bla #asdf is allowed
        end,
    )

    anim = Plots.@apng for i in 1:n
        circleplot(x, y, i, line_z = 1:n, cbar = false, framestyle = :zerolines)
    end every 5
    @test showable(MIME("image/png"), anim)
end

@testset "html" begin
    pl = plot([sin, cos], zeros(0), leg = false, xlims = (0, 2π), ylims = (-1, 1))
    anim = Animation()
    for x in range(0, stop = 2π, length = 10)
        push!(pl, x, Float64[sin(x), cos(x)])
        frame(anim)
    end

    agif = gif(anim, show_msg = false)
    html = tempname() * ".html"
    open(html, "w") do io
        show(io, MIME("text/html"), agif)
    end
    @test filesize(html) > 10_000
    @test showable(MIME("image/gif"), agif)

    agif = mp4(anim, show_msg = false)
    html = tempname() * ".html"
    open(html, "w") do io
        show(io, MIME("text/html"), agif)
    end
    @test filesize(html) > 10_000
end

@testset "animate" begin
    anim = animate([1:2, 2:3]; show_msg = false, fps = 1 // 10)
    @test anim isa Plots.AnimatedGif
    @test showable(MIME("image/gif"), anim)

    fn = tempname() * ".apng"
    open(fn, "w") do io
        show(io, MIME("image/png"), anim)
    end
    @test filesize(fn) > 1_000

    fn = tempname() * ".gif"
    open(fn, "w") do io
        show(io, MIME("image/gif"), anim)
    end
    @test filesize(fn) > 1_000
end

@testset "coverage" begin
    @test animate([1:2, 2:3]; variable_palette = true, show_msg = false) isa
        Plots.AnimatedGif
    @test Plots.FrameIterator([1:2, 2:3]).every == 1
end

@testset "Limits" begin
    y = [1.0 * i * i for i in 1:10]
    x = [Date(2019, 11, i) for i in 1:10]

    rx = [x[3], x[5]]

    pl = plot(x, y, widen = false)
    vspan!(pl, rx, label = "", alpha = 0.2)

    ref_ylims = (y[1], y[end])
    ref_xlims = (x[1].instant.periods.value, x[end].instant.periods.value)
    @test Plots.ylims(pl) == ref_ylims
    @test Plots.xlims(pl) == ref_xlims
end

@testset "Date xlims" begin
    y = [1.0 * i * i for i in 1:10]
    x = [Date(2019, 11, i) for i in 1:10]
    span = (Date(2019, 10, 31), Date(2019, 11, 11))

    ref_xlims = map(date -> date.instant.periods.value, span)

    pl = plot(x, y, xlims = span, widen = false)
end

@testset "DateTime xlims" begin
    y = [1.0 * i * i for i in 1:10]
    x = [DateTime(2019, 11, i, 11) for i in 1:10]
    span = (DateTime(2019, 10, 31, 11, 59, 59), DateTime(2019, 11, 11, 12, 01, 15))

    ref_xlims = map(date -> date.instant.periods.value, span)

    pl = plot(x, y, xlims = span, widen = false)
    @test Plots.xlims(pl) == ref_xlims
end

# TODO: I declare lots of types here because of the lacking ability to do forward declarations in current Julia
# I should move these to the relevant files when something like "extern" is implemented

const AVec = AbstractVector
const AMat = AbstractMatrix
const KW = Dict{Symbol, Any}
const AKW = AbstractDict{Symbol, Any}
const TicksArgs =
    Union{AVec{T}, Tuple{AVec{T}, AVec{S}}, Symbol} where {T <: Real, S <: AbstractString}

struct PlotsDisplay <: AbstractDisplay end

struct InputWrapper{T}
    obj::T
end

mutable struct Series
    plotattributes::DefaultsDict
end

@recipe function f(s::Series)
    for (k, v) in s.plotattributes
        k in (:subplot, :yerror, :xerror, :zerror) && continue
        plotattributes[k] = v
    end
    ()
end

# a single subplot
mutable struct Subplot{T <: AbstractBackend} <: AbstractLayout
    parent::AbstractLayout
    series_list::Vector{Series}  # arguments for each series
    primary_series_count::Int # Number of primary series in the series list
    minpad::Tuple # leftpad, toppad, rightpad, bottompad
    bbox::BoundingBox  # the canvas area which is available to this subplot
    plotarea::BoundingBox  # the part where the data goes
    attr::DefaultsDict  # args specific to this subplot
    o  # can store backend-specific data... like a pyplot ax
    plt  # the enclosing Plot object (can't give it a type because of no forward declarations)

    Subplot(::T; parent = RootLayout()) where {T <: AbstractBackend} = new{T}(
        parent,
        Series[],
        0,
        DEFAULT_MINPAD[],
        DEFAULT_BBOX[],
        DEFAULT_BBOX[],
        DefaultsDict(KW(), _subplot_defaults),
        nothing,
        nothing,
    )
end

# simple wrapper around a KW so we can hold all attributes pertaining to the axis in one place
mutable struct Axis
    sps::Vector{Subplot}
    plotattributes::DefaultsDict
end

mutable struct Extrema
    emin::Float64
    emax::Float64
end

Extrema() = Extrema(Inf, -Inf)

const SubplotMap = Dict{Any, Subplot}

mutable struct Plot{T <: AbstractBackend} <: AbstractPlot{T}
    backend::T                   # the backend type
    n::Int                       # number of series
    attr::DefaultsDict            # arguments for the whole plot
    series_list::Vector{Series}  # arguments for each series
    o                            # the backend's plot object
    subplots::Vector{Subplot}
    spmap::SubplotMap            # provide any label as a map to a subplot
    layout::AbstractLayout
    inset_subplots::Vector{Subplot}  # list of inset subplots
    init::Bool

    function Plot()
        be = backend()
        return new{typeof(be)}(
            be,
            0,
            DefaultsDict(KW(), _plot_defaults),
            Series[],
            nothing,
            Subplot[],
            SubplotMap(),
            EmptyLayout(),
            Subplot[],
            false,
        )
    end

    function Plot(osp::Subplot)
        plt = Plot()
        plt.layout = GridLayout(1, 1)
        sp = deepcopy(osp)  # FIXME: fails `PlotlyJS` ?
        plt.layout.grid[1, 1] = sp
        # reset some attributes
        sp.minpad = DEFAULT_MINPAD[]
        sp.bbox = DEFAULT_BBOX[]
        sp.plotarea = DEFAULT_BBOX[]
        sp.plt = plt  # change the enclosing plot
        push!(plt.subplots, sp)
        return plt
    end
end

struct PlaceHolder end
const PlotOrSubplot = Union{Plot, Subplot}

# -----------------------------------------------------------

wrap(obj::T) where {T} = InputWrapper{T}(obj)
Base.isempty(wrapper::InputWrapper) = false

# -----------------------------------------------------------
attr(series::Series, k::Symbol) = series.plotattributes[k]
attr!(series::Series, v, k::Symbol) = (series.plotattributes[k] = v)

should_add_to_legend(series::Series) =
    series.plotattributes[:primary] &&
    series.plotattributes[:label] != "" &&
    series.plotattributes[:seriestype] ∉ (
    :hexbin,
    :bins2d,
    :histogram2d,
    :hline,
    :vline,
    :contour,
    :contourf,
    :contour3d,
    :surface,
    :wireframe,
    :heatmap,
    :image,
)

# -----------------------------------------------------------------------
Base.iterate(plt::Plot) = iterate(plt.subplots)

Base.getindex(plt::Plot, i::Union{Vector{<:Integer}, Integer}) = plt.subplots[i]
Base.length(plt::Plot) = length(plt.subplots)
Base.lastindex(plt::Plot) = length(plt)

Base.getindex(plt::Plot, r::Integer, c::Integer) = plt.layout[r, c]
Base.size(plt::Plot) = size(plt.layout)
Base.size(plt::Plot, i::Integer) = size(plt.layout)[i]
Base.ndims(plt::Plot) = 2

# clear out series list, but retain subplots
Base.empty!(plt::Plot) = foreach(sp -> empty!(sp.series_list), plt.subplots)

# attr(plt::Plot, k::Symbol) = plt.attr[k]
# attr!(plt::Plot, v, k::Symbol) = (plt.attr[k] = v)

Base.getindex(sp::Subplot, i::Union{Vector{<:Integer}, Integer}) = series_list(sp)[i]
Base.lastindex(sp::Subplot) = length(series_list(sp))

Base.empty!(sp::Subplot) = empty!(sp.series_list)

# -----------------------------------------------------------------------

Base.show(io::IO, sp::Subplot) = print(io, "Subplot{$(sp[:subplot_index])}")

"""
    plotarea(subplot)

Return the bounding box of a subplot.
"""
plotarea(sp::Subplot) = sp.plotarea
plotarea!(sp::Subplot, bbox::BoundingBox) = (sp.plotarea = bbox)

Base.size(sp::Subplot) = (1, 1)
Base.length(sp::Subplot) = 1
Base.getindex(sp::Subplot, r::Int, c::Int) = sp

leftpad(sp::Subplot) = sp.minpad[1]
toppad(sp::Subplot) = sp.minpad[2]
rightpad(sp::Subplot) = sp.minpad[3]
bottompad(sp::Subplot) = sp.minpad[4]

get_subplot(plt::Plot, sp::Subplot) = sp
get_subplot(plt::Plot, i::Integer) = plt.subplots[i]
get_subplot(plt::Plot, k) = plt.spmap[k]
get_subplot(series::Series) = series.plotattributes[:subplot]

get_subplot_index(plt::Plot, sp::Subplot) = findfirst(x -> x === sp, plt.subplots)

series_list(sp::Subplot) = sp.series_list # filter(series -> series.plotattributes[:subplot] === sp, sp.plt.series_list)

using Scratch: @get_scratch!
using REPL
import Base64

"""
Reference to hold path of local plotly temp file. Initialized to `nothing`.
"""
const _plotly_local_file_path = Ref{Union{Nothing, String}}(nothing)

"""
Reference to hold cached plotly data URL. Initialized to `nothing`.
"""
const _plotly_data_url_cached = Ref{Union{Nothing, String}}(nothing)

_plotly_data_url() =
if _plotly_data_url_cached[] === nothing
    _plotly_data_url_cached[] = "data:text/javascript;base64,$(Base64.base64encode(read(_plotly_local_file_path)))"
else
    _plotly_data_url_cached[]
end

"""
use fixed version of Plotly instead of the latest one for stable dependency
"""
const _plotly_min_js_filename = "plotly-2.6.3.min.js"

const _requirejs_version = v"2.3.7"

"""
Whether to use local embedded or local dependencies instead of CDN.
"""
const _use_local_dependencies = Ref(false)

"""
Whether to use local plotly.js files instead of CDN.
"""
const _use_local_plotlyjs = Ref(false)

_plots_defaults() =
if isdefined(Main, :PLOTS_DEFAULTS)
    copy(Dict{Symbol, Any}(Main.PLOTS_DEFAULTS))
else
    Dict{Symbol, Any}()
end

function _plots_theme_defaults()
    user_defaults = _plots_defaults()
    return theme(pop!(user_defaults, :theme, :default); user_defaults...)
end

function _plots_plotly_defaults()
    if bool_env("PLOTS_HOST_DEPENDENCY_LOCAL", "false")
        _plotly_local_file_path[] =
            fn = joinpath(@get_scratch!("plotly"), _plotly_min_js_filename)
        isfile(fn) ||
            Downloads.download("https://cdn.plot.ly/$(_plotly_min_js_filename)", fn)
        _use_local_plotlyjs[] = true
    end
    return _use_local_dependencies[] = _use_local_plotlyjs[]
end

function __init__()
    _plots_theme_defaults()
    _plots_plotly_defaults()

    insert!(
        Base.Multimedia.displays,
        findlast(
            x -> x isa Base.TextDisplay || x isa REPL.REPLDisplay,
            Base.Multimedia.displays,
        ) + 1,
        PlotsDisplay(),
    )

    atreplinit(
        i -> begin
            while PlotsDisplay() in Base.Multimedia.displays
                popdisplay(PlotsDisplay())
            end
            insert!(
                Base.Multimedia.displays,
                findlast(x -> x isa REPL.REPLDisplay, Base.Multimedia.displays) + 1,
                PlotsDisplay(),
            )
        end,
    )

    _runtime_init(backend())
    return nothing
end

##################################################################
backend()
include(_path(backend_name()))

# COV_EXCL_START
@setup_workload begin
    @debug backend_package_name()
    n = length(_examples)
    imports = sizehint!(Expr[], n)
    examples = sizehint!(Expr[], 10n)
    scratch_dir = mktempdir()
    for i in setdiff(1:n, _backend_skips[backend_name()], _animation_examples)
        _examples[i].external && continue
        (imp = _examples[i].imports) === nothing || push!(imports, imp)
        func = gensym(string(i))
        push!(
            examples,
            quote
                $func() = begin  # evaluate each example in a local scope
                    $(_examples[i].exprs)
                    $i == 1 || return  # only for one example
                    fn = tempname($scratch_dir)
                    pl = current()
                    show(devnull, pl)
                    showable(MIME"image/png"(), pl) && savefig(pl, "$fn.png")
                    showable(MIME"application/pdf"(), pl) && savefig(pl, "$fn.pdf")
                    if showable(MIME"image/svg+xml"(), pl)
                        show(IOBuffer(), MIME"image/svg+xml"(), pl)
                    end
                    nothing
                end
                $func()
            end,
        )
    end
    @compile_workload begin
        withenv("GKSwstype" => "nul", "MPLBACKEND" => "agg") do
            load_default_backend()
            eval.(imports)
            eval.(examples)
            if backend_name() ≠ :pythonplot  # FIXME: __init__ failure with PythonPlot
                closeall()  # required for `Gaston` not to deadlock for example
            end
        end
    end
    CURRENT_PLOT.nullableplot = nothing
end
# COV_EXCL_STOP

const AStr = AbstractString
const ColorType = Union{Symbol, Colorant, PlotUtils.ColorSchemes.ColorScheme, Integer}
const TicksType = Union{AVec{Real}, Tuple{AVec{Real}, AVec{AStr}}, Symbol, Bool, Nothing}

# NOTE: when updating `arg_desc`, don't forget to modify `PlotDocs.make_attr_df` accordingly.
const _arg_desc = KW(
    # series args
    :label => (AStr, "The label for a series, which appears in a legend. If empty, no legend entry is added."),
    :seriescolor => (ColorType, "The base color for this series. `:auto` (the default) will select a color from the subplot's `color_palette`, based on the order it was added to the subplot. Also describes the colormap for surfaces."),
    :seriesalpha => (Real, "The alpha/opacity override for the series. `nothing` (the default) means it will take the alpha value of the color."),
    :seriestype => (Symbol, "This is the identifier of the type of visualization for this series. Choose from $(_allTypes) or any series recipes which are defined."),
    :linestyle => (Symbol, "Style of the line (for path and bar stroke). Choose from $(_allStyles)"),
    :linewidth => (Real, "Width of the line (in pixels)."),
    :linecolor => (ColorType, "Color of the line (for path and bar stroke). `:match` will take the value from `:seriescolor`, (though histogram/bar types use `:black` as a default)."),
    :linealpha => (Real, "The alpha/opacity override for the line. `nothing` (the default) means it will take the alpha value of linecolor."),
    :fillrange => (Union{Real, AVec}, "Fills area between fillrange and `y` for line-types, sets the base for `bar`, `sticks` types, and similar for other types."),
    :fillcolor => (ColorType, "Color of the filled area of path or bar types. `:match` will take the value from `:seriescolor`."),
    :fillalpha => (Real, "The alpha/opacity override for the fill area. `nothing` (the default) means it will take the alpha value of fillcolor."),
    :markershape => (Union{Symbol, Shape, AVec}, "Choose from $(_allMarkers)."),
    :fillstyle => (Symbol, "Style of the fill area. `nothing` (the default) means solid fill. Choose from :/, :\\, :|, :-, :+, :x."),
    :markercolor => (ColorType, "Color of the interior of the marker or shape. `:match` will take the value from `:seriescolor`."),
    :markeralpha => (Real, "The alpha/opacity override for the marker interior. `nothing` (the default) means it will take the alpha value of markercolor."),
    :markersize => (Union{Real, AVec}, "Size (radius pixels) of the markers."),
    :markerstrokestyle => (Symbol, "Style of the marker stroke (border). Choose from $(_allStyles)."),
    :markerstrokewidth => (Real, "Width of the marker stroke (border) in pixels."),
    :markerstrokecolor => (ColorType, "Color of the marker stroke (border). `:match` will take the value from `:foreground_color_subplot`."),
    :markerstrokealpha => (Real, "The alpha/opacity override for the marker stroke (border). `nothing` (the default) means it will take the alpha value of markerstrokecolor."),
    :bins => (
        Union{Integer, NTuple{2, Integer}, AVec, Symbol}, """
        Default is :auto (the Freedman-Diaconis rule). For histogram-types, defines the approximate number of bins to aim for, or the auto-binning algorithm to use (:sturges, :sqrt, :rice, :scott or :fd).
        For fine-grained control pass a Vector of break values, e.g. `range(minimum(x), stop = maximum(x), length = 25)`.""",
    ),
    :smooth => (Bool, "Add a regression line ?"),
    :group => (AVec, "Data is split into a separate series, one for each unique value in `group`."),
    :x => (Any, "Input data (first dimension)."),
    :y => (Any, "Input data (second dimension)."),
    :z => (Any, "Input data (third dimension). May be wrapped by a `Surface` for surface and heatmap types."),
    :marker_z => (Union{AVec, Function}, "z-values for each series data point, which correspond to the color to be used from a markercolor gradient (`f(x,y,z) -> z_value` or `f(x,y) -> z_value`)."),
    :line_z => (Union{AVec, Function}, "z-values for each series line segment, which correspond to the color to be used from a linecolor gradient. Note that for N points, only the first N-1 values are used (one per line-segment)."),
    :fill_z => (AMat, "Matrix of the same size as z matrix, which specifies the color of the 3D surface."),
    :levels => (Union{AVec, Integer}, "Singleton for number of contours or iterable for contour values. Determines contour levels for a contour type."),
    :permute => (NTuple{2, Symbol}, "Permutes data and axis properties of the axes given in the tuple, e.g. (:x, :y)."),
    :orientation => (Symbol, "(deprecated in favor of `:permute`) Horizontal or vertical orientation for bar types. Values `:h`, `:hor`, `:horizontal` correspond to horizontal (sideways, anchored to y-axis), and `:v`, `:vert`, and `:vertical` correspond to vertical (the default)."),
    :bar_position => (Symbol, "Choose from `:overlay` (default), `:stack`. (warning: may only be partially implemented)."),
    :bar_width => (Real, " Width of bars in data coordinates. When `nothing`, chooses based on `x` (or `y` when `orientation = :h`)."),
    :bar_edges => (Bool, "Align bars to edges (true), or centers (the default) ?"),
    :xerror => (Union{AVec, NTuple{2, AVec}}, "`x` (horizontal) error relative to x-value. If 2-tuple of vectors, the first vector corresponds to the left error (and the second to the right)."),
    :yerror => (Union{AVec, NTuple{2, AVec}}, "`y` (vertical) error relative to y-value. If 2-tuple of vectors, the first vector corresponds to the bottom error (and the second to the top)."),
    :ribbon => (Union{Real, AVec}, "Creates a fillrange around the data points."),
    :quiver => (Union{AVec, NTuple{2, AVec}}, "The directional vectors U,V which specify velocity/gradient vectors for a quiver plot."),
    :arrow => (Union{Bool, Arrow}, "Defines arrowheads that should be displayed at the end of path line segments (just before a NaN and the last non-NaN point). Used in quiverplot, streamplot, or similar."),
    :normalize => (Union{Bool, Symbol}, "Histogram normalization mode. Possible values are: false/:none (no normalization, default), true/:pdf (normalize to a discrete PDF, where the total area of the bins is 1), :probability (bin heights sum to 1) and :density (the area of each bin, rather than the height, is equal to the counts - useful for uneven bin sizes)."),
    :weights => (AVec, "Used in histogram types for weighted counts."),
    :show_empty_bins => (Bool, "Whether empty bins in a 2D histogram are colored as 0 (true), or transparent (the default)."),
    :contours => (Bool, "Add contours to the side-grids of 3D plots?  Used in surface/wireframe."),
    :contour_labels => (Bool, "Show labels at the contour lines ?"),
    :match_dimensions => (Bool, "For heatmap types: should the first dimension of a matrix (rows) correspond to the first dimension of the plot (`x`-axis) ? Defaults to `false`, which matches the behavior of Matplotlib, Plotly, and others. Note: when passing a function for `z`, the function should still map `(x,y) -> z`."),
    :subplot => (Union{Integer, Subplot}, "The subplot that this series belongs to."),
    :series_annotations => (Union{AVec, AStr, PlotText}, "These are annotations which are mapped to data points/positions."),
    :primary => (Bool, "Does this count as a 'real series'? For example, you could have a path (primary), and a scatter (secondary) as two separate series, maybe with different data (see `sticks` recipe for an example). The secondary series will get the same color, etc as the primary."),
    :hover => (AVec{AStr}, "Text to display when hovering over each data point."),
    :colorbar_entry => (Bool, "Include this series in the color bar?  Set to `false` to exclude."),
    :z_order => (Union{Symbol, Integer}, ":front (default), :back or index of position where 1 is furthest in the background."),

    # plot args
    :plot_title => (AStr, "Whole plot title (not to be confused with the title for individual subplots)."),
    :plot_titlevspan => (Real, "Vertical span of the whole plot title (fraction of the plot height)."),
    :background_color => (ColorType, " Base color for all backgrounds."),
    :background_color_outside => (ColorType, "Color outside the plot area(s) (`:match` matches `:background_color`)."),
    :foreground_color => (ColorType, "Base color for all foregrounds."),
    :size => (NTuple{2, Integer}, "(width_px, height_px) of the whole Plot."),
    :pos => (NTuple{2, Integer}, "(left_px, top_px) position of the GUI window (note: currently unimplemented)."),
    :window_title => (AStr, "Title of the standalone gui-window."),
    :show => (Bool, "Should this command open/refresh a GUI/display ? Allows to display plots in scripts or functions without explicitly calling `display`."),
    :layout => (Union{Integer, NTuple{2, Integer}, AbstractLayout}, "Number of subplot, grid dimensions, layout (for example `grid(2,2)`), or the return from the `@layout` macro. This builds the layout of subplots."),
    :link => (Symbol, "How/whether to link axis limits between subplots. Values: `:none`, `:x` (x axes are linked by columns), `:y` (y axes are linked by rows), `:both` (x and y are linked), `:all` (every subplot is linked together regardless of layout position)."),
    :overwrite_figure => (Bool, "Should we reuse the same GUI window/figure when plotting (true) or open a new one (false)."),
    :html_output_format => (Symbol, "When writing html output, what is the format?  `:png` and `:svg` are currently supported."),
    :tex_output_standalone => (Bool, "When writing tex output, should the source include a preamble for a standalone document class."),
    :inset_subplots => (AVec{NTuple{2, Any}}, "Optionally pass a vector of (parent,bbox) tuples which are the parent layout and the relative bounding box of inset subplots."),
    :dpi => (Real, "Dots Per Inch of output figures."),
    :thickness_scaling => (Real, "Scale for the thickness of all line elements like lines, borders, axes, grid lines, ... defaults to 1."),
    :display_type => (Symbol, "When supported, `display` will either open a GUI window or plot inline. Choose from (`:auto`, `:gui`, or `:inline`)."),
    :extra_kwargs => (
        Symbol, """
        Specify for which element extra keyword args are collected or a KW (Dict{Symbol,Any}) to pass a map of extra keyword args which may be specific to a backend. Choose from (`:plot`, `:subplot`, `:series`), defaults to `:series`.
        Example: `pgfplotsx(); scatter(1:5, extra_kwargs=Dict(:subplot=>Dict("axis line shift" => "10pt"))`.""",
    ),
    :fontfamily => (Union{AStr, Symbol}, "Default font family for title, legend entries, tick labels and guides."),
    :warn_on_unsupported => (Bool, "Warn on unsupported attributes, series types and marker shapes."),

    # subplot args
    :title => (AStr, "Subplot title."),
    :titlelocation => (Symbol, "Position of subplot title. Choose from (`:left`, `:center`, `:right`)."),
    :titlefontfamily => (Union{AStr, Symbol}, "Font family of subplot title."),
    :titlefontsize => (Integer, "Font pointsize of subplot title."),
    :titlefonthalign => (Symbol, "Font horizontal alignment of subplot title. Choose from (:hcenter, :left, :right, :center)."),
    :titlefontvalign => (Symbol, "Font vertical alignment of subplot title. Choose from (:vcenter, :top, :bottom, :center)."),
    :titlefontrotation => (Real, "Font rotation of subplot title."),
    :titlefontcolor => (ColorType, "Color Type. Font color of subplot title."),
    :background_color_subplot => (ColorType, "Base background color of the subplot (`:match` matches `:background_color`)."),
    :legend_background_color => (ColorType, "Background color of the legend (`:match` matches :background_color_subplot`)."),
    :background_color_inside => (ColorType, "Background color inside the plot area (under the grid) (`:match` matches :background_color_subplot`)."),
    :foreground_color_subplot => (ColorType, "Base foreground color of the subplot (`:match` matches :foreground_color`)."),
    :legend_foreground_color => (ColorType, "Foreground color of the legend (`:match` matches :foreground_color_subplot`)."),
    :foreground_color_title => (ColorType, "Color of subplot title (`:match` matches :foreground_color_subplot`)."),
    :color_palette => (Union{AVec{ColorType}, Symbol}, "Iterable (cycle through) or color gradient (generate list from gradient) or `:auto` (generate a color list using `Colors.distiguishable_colors` and custom seed colors chosen to contrast with the background). The color palette is a color list from which series colors are automatically chosen."),
    :legend_position => (
        Union{Bool, NTuple{2, Real}, Symbol}, """
        Show the legend ? Can also be a (x,y) tuple or Symbol (legend position) or angle (angle,inout) tuple. Bottom left corner of legend is placed at (x,y).
        Choose from (`:none`, `:best`, `:inline`, `:inside`, `:legend`) or any valid combination of `:(outer ?)(top/bottom ?)(right/left ?)`, i.e.: `:top`, `:topright`, `:outerleft`, `:outerbottomright` ... (note: only some may be supported in each backend).""",
    ),
    :legend_column => (Integer, "Number of columns in the legend. `-1` stands for maximum number of colums (horizontal legend)."),
    :legend_title_font => (Font, "Font of the legend title."),
    :legend_font_family => (Union{AStr, Symbol}, "Font family of legend entries."),
    :legend_font_pointsize => (Integer, "Font pointsize of legend entries."),
    :legend_font_halign => (Symbol, "Font horizontal alignment of legend entries. Choose from (:hcenter, :left, :right, :center)."),
    :legend_font_valign => (Symbol, "Font vertical alignment of legend entries. Choose from (:vcenter, :top, :bottom, :center)."),
    :legend_font_rotation => (Real, "Font rotation of legend entries."),
    :legend_title_font_color => (ColorType, "Font color of legend entries."),
    :legend_title => (AStr, "Legend title."),
    :legend_title_font_family => (Union{AStr, Symbol}, "Font family of the legend title."),
    :legend_title_font_pointsize => (Integer, "Font pointsize the legend title."),
    :legend_title_font_halign => (Symbol, "Font horizontal alignment of the legend title. Choose from (:hcenter, :left, :right, :center)."),
    :legend_title_font_valign => (Symbol, "Font vertical alignment of the legend title. Choose from (:vcenter, :top, :bottom, :center)."),
    :legend_title_font_rotation => (Real, "Font rotation of the legend title."),
    :legend_title_font_color => (ColorType, "Font color of the legend title."),
    :colorbar => (Union{Bool, Symbol}, "Show the colorbar ? A symbol specifies a colorbar position. Choose from (`:none`, `:best`, `:right`, `:left`, `:top`, `:bottom`, `:legend`): `legend` matches legend value (note: only some may be supported in each backend)."),
    :clims => (Union{NTuple{2, Real}, Symbol, Function}, "Fixes the limits of the colorbar: values, `:auto`, or a function taking series data in and returning a NTuple{2,Real}."),
    :colorbar_fontfamily => (Union{AStr, Symbol}, "Font family of colorbar entries."),
    :colorbar_ticks => (TicksType, "Tick values, (tickvalues, ticklabels), `:auto`/`true`, or `:none`/`false`/`nothing` (ticks disabled)."),
    :colorbar_tickfontfamily => (Union{AStr, Symbol}, "String or Symbol. Font family of colorbar tick labels."),
    :colorbar_tickfontsize => (Integer, "Font pointsize of colorbar tick entries."),
    :colorbar_tickfontcolor => (ColorType, "Font color of colorbar tick entries."),
    :colorbar_scale => (Symbol, "Scale of the colorbar axis. Choose from $(_allScales)."),
    :colorbar_formatter => (Union{Function, Symbol}, "Choose from (:scientific, :plain, :none, :auto), or a method which converts a number to a string for tick labeling."),
    :legend_font => (Font, "Font of legend items."),
    :legend_titlefont => (Font, "Font of the legend title."),
    :annotations => (Union{AVec{Tuple}, Tuple{Real, Real, Union{AStr, PlotText, Tuple}}}, "(x,y,text) tuple(s), where text can be String, PlotText (created with `text(args...)`), or a tuple of arguments to `text` (e.g., `(\"Label\", 8, :red, :top)`). Add one-off text annotations at the (x,y) coordinates."),
    :annotationfontfamily => (Union{AStr, Symbol}, "Font family of annotations."),
    :annotationfontsize => (Integer, "Font pointsize of annotations."),
    :annotationhalign => (Symbol, "horizontal alignment of annotations. Choose from (:hcenter, :left, :right, :center)."),
    :annotationvalign => (Symbol, "Vertical alignment of annotations. Choose from (:vcenter, :top, :bottom, :center)."),
    :annotationrotation => (Real, "Rotation of annotations in degrees."),
    :annotationcolor => (ColorType, "Annotations color."),
    :projection => (Union{AStr, Symbol}, "`3d` or `polar`."),
    :projection_type => (Symbol, "3d plots projection type: :auto (backend dependent), :persp(ective), :ortho(graphic)."),
    :aspect_ratio => (Union{Symbol, Real}, "Plot area is resized so that 1 y-unit is the same size as `aspect_ratio` x-units. With `:none`, images inherit aspect ratio of the plot area. Use `:equal` for unit aspect ratio."),
    :margin => (Union{Tuple, Real}, "Number multiplied by `mm`, `px`, etc... or Tuple `(0, :mm)`. Base for individual margins... not directly used. Specifies the extra padding around subplots."),
    :left_margin => (Union{Tuple, Real, Symbol}, "Specifies the extra padding to the left of the subplot (`:match` matches `:margin`)."),
    :top_margin => (Union{Tuple, Real, Symbol}, "Specifies the extra padding on the top of the subplot (`:match` matches `:margin`)."),
    :right_margin => (Union{Tuple, Real, Symbol}, "Specifies the extra padding to the right of the subplot (`:match` matches `:margin`)."),
    :bottom_margin => (Union{Tuple, Real, Symbol}, "Specifies the extra padding on the bottom of the subplot (`:match` matches `:margin`)."),
    :subplot_index => (Integer, "Internal (not set by user). Specifies the index of this subplot in the Plot's `plt.subplot` list."),
    :colorbar_title => (AStr, "Title of colorbar."),
    :framestyle => (Symbol, "Style of the axes frame. Choose from $(_allFramestyles)."),
    :camera => (NTuple{2, Real}, "Sets the view angle (azimuthal, elevation) for 3D plots."),

    # axis args
    :guide => (AStr, "Axis guide (label)."),
    :guide_position => (Symbol, "Position of axis guides. Choose from (:top, :bottom, :left, :right)."),
    :lims => (
        Union{NTuple{2, Real}, Symbol}, """
        Force axis limits. Only finite values are used (you can set only the right limit with `xlims = (-Inf, 2)` for example).
        `:round` widens the limit to the nearest round number, i.e. [0.1,3.6]=>[0.0,4.0].
        `:symmetric` sets the limits to be symmetric around zero.
        Set `widen=true` to widen the specified limits (as occurs when lims are not specified).""",
    ),
    :ticks => (TicksType, "Tick values, (tickvalues, ticklabels), `:auto`/`true`, `:none`/`false`/`nothing` (ticks disabled), or `:native` (tells backend to calculate ticks by itself; good idea for interactive backends with mouse zooming)."),
    :scale => (Symbol, "Scale of the axis. Choose from $(_allScales)."),
    :rotation => (Real, "Degrees rotation of tick labels."),
    :flip => (Bool, "Should we flip (reverse) the axis ?"),
    :formatter => (Union{Symbol, Function}, "Choose from (:scientific, :plain or :auto), or a method which converts a number to a string for tick labeling."),
    :tickfontfamily => (Union{AStr, Symbol}, "Font family of tick labels."),
    :tickfontsize => (Integer, "Font pointsize of tick labels."),
    :tickfonthalign => (Symbol, "Font horizontal alignment of tick labels. Choose from (:hcenter, :left, :right, :center)."),
    :tickfontvalign => (Symbol, "Font vertical alignment of tick labels. Choose from (:vcenter, :top, :bottom, :center)."),
    :tickfontrotation => (Real, "Font rotation of tick labels."),
    :tickfontcolor => (ColorType, "Font color of tick labels."),
    :guidefontfamily => (Union{AStr, Symbol}, "Font family of axes guides."),
    :guidefontsize => (Integer, "Font pointsize of axes guides."),
    :guidefonthalign => (Symbol, "Font horizontal alignment of axes guides. Choose from (:hcenter, :left, :right, :center)."),
    :guidefontvalign => (Symbol, "Font vertical alignment of axes guides. Choose from (:vcenter, :top, :bottom, :center)."),
    :guidefontrotation => (Real, "Font rotation of axes guides."),
    :guidefontcolor => (ColorType, "Font color of axes guides."),
    :foreground_color_axis => (ColorType, "Color of axis ticks (`:match` matches `:foreground_color_subplot`)."),
    :foreground_color_border => (ColorType, "Color of plot area border/spines (`:match` matches `:foreground_color_subplot`)."),
    :foreground_color_text => (ColorType, "Color of tick labels (`:match` matches `:foreground_color_subplot`)."),
    :foreground_color_guide => (ColorType, "Color of axis guides/labels (`:match` matches `:foreground_color_subplot`)."),
    :mirror => (Bool, "Switch the side of the tick labels (right or top)."),
    :grid => (Union{Bool, Symbol, AStr}, "Show the grid lines ? `true`, `false`, `:show`, `:hide`, `:yes`, `:no`, `:x`, `:y`, `:z`, `:xy`, ..., `:all`, `:none`, `:off`."),
    :foreground_color_grid => (ColorType, "Color of grid lines (`:match` matches `:foreground_color_subplot`)."),
    :gridalpha => (Real, "The alpha/opacity override for the grid lines."),
    :gridstyle => (Symbol, "Style of the grid lines. Choose from $(_allStyles)."),
    :gridlinewidth => (Real, "Width of the grid lines (in pixels)."),
    :foreground_color_minor_grid => (ColorType, "Color of minor grid lines (`:match` matches `:foreground_color_subplot`)."),
    :minorgrid => (Bool, "Adds minor grid lines and ticks to the plot. Set minorticks to change number of gridlines."),
    :minorticks => (Integer, "Number of minor intervals between major ticks."),
    :minorgridalpha => (Real, "The alpha/opacity override for the minorgrid lines."),
    :minorgridstyle => (Symbol, "Style of the minor grid lines. Choose from $(_allStyles)."),
    :minorgridlinewidth => (Real, "Width of the minor grid lines (in pixels)."),
    :tick_direction => (Symbol, "Direction of the ticks. Choose from (`:in`, `:out`, `:none`)."),
    :showaxis => (Union{Bool, Symbol, AStr}, "Show the axis. `true`, `false`, `:show`, `:hide`, `:yes`, `:no`, `:x`, `:y`, `:z`, `:xy`, ..., `:all`, `:off`."),
    :widen => (
        Union{Bool, Real, Symbol}, """
        Widen the axis limits by a small factor to avoid cut-off markers and lines at the borders.
        If set to `true`, scale the axis limits by the default factor of $(default_widen_factor).
        A different factor may be specified by setting `widen` to a number.
        Defaults to `:auto`, which widens by the default factor unless limits were manually set.
        See also the `scale_limits!` function for scaling axis limits in an existing plot.""",
    ),
    :draw_arrow => (Bool, "Draw arrow at the end of the axis."),
    :unitformat => (Union{Bool, Nothing, Symbol, Char, String, NTuple{<:Union{Char, String}}, Function}, """Check examples in https://docs.juliaplots.org/stable/generated/unitfulext_examples/#Unit-formatting"""),
)

@testset "Auto QUality Assurance" begin
    # JuliaTesting/Aqua.jl/issues/77
    # TODO: fix :Contour, :Latexify and :LaTeXStrings stale imports in Plots 2.0
    # :Conda stale deps show up when running CI
    Aqua.test_all(
        Plots;
        stale_deps = (;
            ignore = [
                :GR,
                :CondaPkg,
                :Contour,
                :Latexify,
                :LaTeXStrings,
                :Requires,
                :Pkg,
            ],
        ),
        ambiguities = false,
        deps_compat = false,  # FIXME: fails `CondaPkg`
        piracies = false,
    )
    Aqua.test_ambiguities(Plots; exclude = [RecipesBase.apply_recipe])  # FIXME: remaining ambiguities
end

@testset "Utils" begin
    zipped = (
        [(1, 2)],
        [("a", "b")],
        [(1, "a"), (2, "b")],
        [(1, 2), (3, 4)],
        [(1, 2, 3), (3, 4, 5)],
        [(1, 2, 3, 4), (3, 4, 5, 6)],
        [(1, 2.0), (missing, missing)],
        [(1, missing), (missing, "a")],
        [(missing, missing)],
        [(missing, missing, missing), ("a", "b", "c")],
    )
    for z in zipped
        @test isequal(collect(zip(Plots.unzip(z)...)), z)
        @test isequal(collect(zip(Plots.unzip(GeometryBasics.Point.(z))...)), z)
    end
    op1 = Plots.process_clims((1.0, 2.0))
    op2 = Plots.process_clims((1, 2.0))
    data = randn(100, 100)
    @test op1(data) == op2(data)
    @test Plots.process_clims(nothing) ==
        Plots.process_clims(missing) ==
        Plots.process_clims(:auto)

    @test (==)(
        Plots.texmath2unicode(
            raw"Equation $y = \alpha \cdot x + \beta$ and eqn $y = \sin(x)^2$",
        ),
        raw"Equation y = α ⋅ x + β and eqn y = sin(x)²",
    )

    @test Plots.isvector([1, 2])
    @test !Plots.isvector(nothing)
    @test Plots.ismatrix([1 2; 3 4])
    @test !Plots.ismatrix(nothing)
    @test Plots.isscalar(1.0)
    @test !Plots.isscalar(nothing)
    @test Plots.anynan(1, 3, (1, NaN, 3))
    @test Plots.allnan(1, 2, (NaN, NaN, 1))
    @test Plots.makevec([]) isa AbstractVector
    @test Plots.makevec(1) isa AbstractVector
    @test Plots.maketuple(1) == (1, 1)
    @test Plots.maketuple((1, 1)) == (1, 1)
    @test Plots.ok(1, 2)
    @test !Plots.ok(1, 2, NaN)
    @test Plots.ok((1, 2, 3))
    @test !Plots.ok((1, 2, NaN))
    @test Plots.nansplit([1, 2, NaN, 3, 4]) == [[1.0, 2.0], [3.0, 4.0]]
    @test Plots.nanvcat([1, NaN]) |> length == 4

    @test Plots.inch2px(1) isa AbstractFloat
    @test Plots.px2inch(1) isa AbstractFloat
    @test Plots.inch2mm(1) isa AbstractFloat
    @test Plots.mm2inch(1) isa AbstractFloat
    @test Plots.px2mm(1) isa AbstractFloat
    @test Plots.mm2px(1) isa AbstractFloat

    pl = plot()
    @test xlims() isa Tuple
    @test ylims() isa Tuple
    @test zlims() isa Tuple

    @test_throws MethodError Plots.inline()
    @test_throws MethodError Plots._do_plot_show(plot(), :inline)

    @test plot(-1:10, xscale = :log10) isa Plots.Plot

    Plots.makekw(foo = 1, bar = 2) isa Dict

    ######################
    Plots.debug!(true)

    io = PipeBuffer()
    Plots.debugshow(io, nothing)
    Plots.debugshow(io, [1])

    pl = plot(1:2)
    Plots.dumpdict(devnull, first(pl.series_list).plotattributes)
    show(devnull, pl[1][:xaxis])

    # bounding boxes
    Plots.with(:gr) do
        show(devnull, plot(1:2))
    end

    Plots.debug!(false)
    ######################

    let pl = plot(1)
        push!(pl, 1.5)
        push!(pl, 1, 1.5)
        append!(pl, [1.0, 2.0])
        append!(pl, 1, 2.5, 2.5)
        push!(pl, (1.5, 2.5))
        push!(pl, 1, (1.5, 2.5))
        append!(pl, (1.5, 2.5))
        append!(pl, 1, (1.5, 2.5))
    end

    pl = scatter(1:2, 1:2)
    push!(pl, 2:3)
    pl = scatter(1:2, 1:2, 1:2)
    push!(pl, 1:2, 2:3, 3:4)

    pl = plot([1, 2, 3], [4, 5, 6])
    @test Plots.xmin(pl) == 1
    @test Plots.xmax(pl) == 3
    @test Plots.ignorenan_extrema(pl) == (1, 3)

    @test Plots.get_attr_symbol(:x, "lims") === :xlims
    @test Plots.get_attr_symbol(:x, :lims) === :xlims

    @test contains(Plots._document_argument(:bar_position), "bar_position")

    @test Plots.limsType((1, 1)) === :limits
    @test Plots.limsType(:undefined) === :invalid
    @test Plots.limsType(:auto) === :auto
    @test Plots.limsType(NaN) === :invalid

    @test Plots.ticksType([1, 2]) === :ticks
    @test Plots.ticksType(["1", "2"]) === :labels
    @test Plots.ticksType(([1, 2], ["1", "2"])) === :ticks_and_labels
    @test Plots.ticksType(((1, 2), ("1", "2"))) === :ticks_and_labels
    @test Plots.ticksType(:undefined) === :invalid

    pl = plot(1:2, 1:2, 1:2, proj_type = :ortho)
    @test Plots.isortho(first(pl.subplots))
    pl = plot(1:2, 1:2, 1:2, proj_type = :persp)
    @test Plots.ispersp(first(pl.subplots))

    let pl = plot(1:2)
        series = first(pl.series_list)
        label = "fancy label"
        attr!(series; label)
        @test series[:label] == label
        @test Plots.attr(series, :label) == label

        label = "another label"
        attr!(series, label, :label)
        @test Plots.attr(series, :label) == label

        sp = first(pl.subplots)
        title = "fancy title"
        attr!(sp; title)
        @test sp[:title] == title
    end
end

@testset "NaN-separated Segments" begin
    segments(args...) = collect(iter_segments(args...))

    nan10 = fill(NaN, 10)
    @test segments(11:20) == [1:10]
    @test segments([NaN]) == []
    @test segments(nan10) == []
    @test segments([nan10; 1:5]) == [11:15]
    @test segments([1:5; nan10]) == [1:5]
    @test segments([nan10; 1:5; nan10; 1:5; nan10]) == [11:15, 26:30]
    @test segments([NaN; 1], 1:10) == [2:2, 4:4, 6:6, 8:8, 10:10]
    @test segments([nan10; 1:15], [1:15; nan10]) == [11:15]
end

@testset "Invalid scale values" begin
    @test_logs match_mode = :any (:warn, r"Invalid negative or zero value.*") png(
        plot([0, 1], yscale = :log10),
        tempname(),
    )
end

@testset "Triangulation" begin
    x = [0, 1, 2, 0]
    y = [0, 0, 1, 2]
    z = [0, 2, 0, 1]

    i = [0, 0, 0, 1]
    j = [1, 2, 3, 2]
    k = [2, 3, 1, 3]

    X, Y, Z = Plots.mesh3d_triangles(x, y, z, (i, j, k))
    @test length(X) == length(Y) == length(Z) == 4length(i)

    cns = [(1, 2, 3), (1, 3, 2), (1, 4, 2), (2, 3, 4)]

    X, Y, Z = Plots.mesh3d_triangles(x, y, z, cns)
    @test length(X) == length(Y) == length(Z) == 4length(i)
end

@testset "SentinelArrays - _cycle" begin
    # discourse.julialang.org/t/plots-borking-on-sentinelarrays-produced-by-csv-read/89505
    # `CSV` produces `SentinelArrays` data
    @test scatter(ChainedVector([[1, 2], [3, 4]]), 1:4) isa Plot
end

@testset "Best legend position" begin
    x = 0:0.01:2
    pl = plot(x, x, label = "linear")
    pl = plot!(x, x .^ 2, label = "quadratic")
    pl = plot!(x, x .^ 3, label = "cubic")
    @test Plots._guess_best_legend_position(:best, pl) === :topleft

    x = OffsetArrays.OffsetArray(0:0.01:2, OffsetArrays.Origin(-3))
    pl = plot(x, x, label = "linear")
    pl = plot!(x, x .^ 2, label = "quadratic")
    pl = plot!(x, x .^ 3, label = "cubic")
    @test Plots._guess_best_legend_position(:best, pl) === :topleft

    x = OffsetArrays.OffsetArray(0:0.01:2, OffsetArrays.Origin(+3))
    pl = plot(x, x, label = "linear")
    pl = plot!(x, x .^ 2, label = "quadratic")
    pl = plot!(x, x .^ 3, label = "cubic")
    @test Plots._guess_best_legend_position(:best, pl) === :topleft

    x = 0:0.01:2
    pl = plot(x, -x, label = "linear")
    pl = plot!(x, -x .^ 2, label = "quadratic")
    pl = plot!(x, -x .^ 3, label = "cubic")
    @test Plots._guess_best_legend_position(:best, pl) === :bottomleft

    x = OffsetArrays.OffsetArray(0:0.01:2, OffsetArrays.Origin(-3))
    pl = plot(x, -x, label = "linear")
    pl = plot!(x, -x .^ 2, label = "quadratic")
    pl = plot!(x, -x .^ 3, label = "cubic")
    @test Plots._guess_best_legend_position(:best, pl) === :bottomleft

    x = [0, 1, 0, 1]
    y = [0, 0, 1, 1]
    pl = scatter(x, y, xlims = [0.0, 1.3], ylims = [0.0, 1.3], label = "test")
    @test Plots._guess_best_legend_position(:best, pl) === :topright

    pl = scatter(x, y, xlims = [-0.3, 1.0], ylims = [-0.3, 1.0], label = "test")
    @test Plots._guess_best_legend_position(:best, pl) === :bottomleft

    pl = scatter(x, y, xlims = [0.0, 1.3], ylims = [-0.3, 1.0], label = "test")
    @test Plots._guess_best_legend_position(:best, pl) === :bottomright

    pl = scatter(x, y, xlims = [-0.3, 1.0], ylims = [0.0, 1.3], label = "test")
    @test Plots._guess_best_legend_position(:best, pl) === :topleft

    y1 = [
        0.6640202072697099,
        0.04435946459047402,
        0.4819421561655691,
        0.7812872333045798,
        0.9468591660437995,
        0.5530071466041402,
        0.22969207890925003,
        0.48741164266779236,
        0.0546763558355734,
        0.1432072797975329,
    ]
    y2 = [0.40089741940615464, 0.6687326060649715, 0.6844117863127116]
    pl = plot(1:10, y1)
    pl = plot!(1:3, y2, xlims = (0, 10), ylims = (0, 1))
    @test Plots._guess_best_legend_position(:best, pl) === :topright

    # test empty plot
    pl = plot([])
    @test Plots._guess_best_legend_position(:best, pl) === :topright

    # test that we didn't overlap other placements
    @test Plots._guess_best_legend_position(:bottomleft, pl) === :bottomleft

    # test singleton
    pl = plot(1:1)
    @test Plots._guess_best_legend_position(:best, pl) === :topright

    # test cycling indexes
    x = 0.0:0.1:1
    y = [1, 2, 3]
    pl = scatter(x, y)
    @test Plots._guess_best_legend_position(:best, pl) === :topright

    # Test step plot with variable limits
    x = 0:0.001:1
    y = vcat([0.0 for _ in 1:100], [1.0 for _ in 101:200], [0.5 for _ in 201:1001])
    pl = scatter(x, y)
    @test Plots._guess_best_legend_position(:best, pl) === :topright
    pl = scatter(x, y, xlims = [0, 0.25])
    @test Plots._guess_best_legend_position(:best, pl) === :topleft
    pl = scatter(x, y, xlims = [0.1, 0.25])
    @test Plots._guess_best_legend_position(:best, pl) === :topright
    pl = scatter(x, y, xlims = [0.18, 0.25])
    @test Plots._guess_best_legend_position(:best, pl) === :topright
    pl = scatter(x, y, ylims = [-1, 0.75])
    @test Plots._guess_best_legend_position(:best, pl) === :bottomright
    pl = scatter(x, y, ylims = [0.25, 0.75])
    @test Plots._guess_best_legend_position(:best, pl) === :topright
    pl = scatter(-x, y, ylims = [0.25, 0.75])
    @test Plots._guess_best_legend_position(:best, pl) === :topright
    pl = scatter(-x, y)
    @test Plots._guess_best_legend_position(:best, pl) === :topleft
    pl = scatter(-x, -y)
    @test Plots._guess_best_legend_position(:best, pl) === :topleft
    pl = scatter(x, -y)
    @test Plots._guess_best_legend_position(:best, pl) === :topright
end

@testset "dispatch" begin
    Plots.with(:gr) do
        pl = heatmap(rand(10, 10); xscale = :log10, yscale = :log10)
        @test show(devnull, pl) isa Nothing

        pl = plot(Shape([(1, 1), (2, 1), (2, 2), (1, 2)]); xscale = :log10)
        @test show(devnull, pl) isa Nothing
    end
end

# https://github.com/JuliaPlots/UnicodePlots.jl

const _canvas_map = (
    braille = UnicodePlots.BrailleCanvas,
    density = UnicodePlots.DensityCanvas,
    heatmap = UnicodePlots.HeatmapCanvas,
    lookup = UnicodePlots.LookupCanvas,
    ascii = UnicodePlots.AsciiCanvas,
    block = UnicodePlots.BlockCanvas,
    dot = UnicodePlots.DotCanvas,
)

should_warn_on_unsupported(::UnicodePlotsBackend) = false

function _before_layout_calcs(plt::Plot{UnicodePlotsBackend})
    plt.o = UnicodePlots.Plot[]
    up_width = UnicodePlots.DEFAULT_WIDTH[]
    up_height = UnicodePlots.DEFAULT_HEIGHT[]

    has_layout = prod(size(plt.layout)) > 1
    for sp in plt.subplots
        sp_kw = sp[:extra_kwargs]
        xaxis = sp[:xaxis]
        yaxis = sp[:yaxis]
        xlim = collect(axis_limits(sp, :x))
        ylim = collect(axis_limits(sp, :y))
        zlim = collect(axis_limits(sp, :z))
        F = float(eltype(xlim))

        # We set x/y to have a single point,
        # since we need to create the plot with some data.
        # Since this point is at the bottom left corner of the plot,
        # it should be hidden by consecutive plotting commands.
        x = Vector{F}(xlim)
        y = Vector{F}(ylim)
        z = Vector{F}(zlim)

        plot_3d = RecipesPipeline.is3d(sp)

        # create a plot window with xlim/ylim set,
        # but the X/Y vectors are outside the bounds
        canvas = if (up_c = get(sp_kw, :canvas, :auto)) ≡ :auto
            isijulia() ? :ascii : :braille
        else
            up_c
        end

        border = if (up_b = get(sp_kw, :border, :auto)) ≡ :auto
            if plot_3d
                :none  # no plots border in 3d (consistency with other backends)
            else
                isijulia() ? :ascii : :solid
            end
        else
            up_b
        end

        # blank plots will not be shown
        width = has_layout && isempty(series_list(sp)) ? 0 : get(sp_kw, :width, up_width)
        height = get(sp_kw, :height, up_height)

        blend = get(sp_kw, :blend, true)
        grid = xaxis[:grid] && yaxis[:grid]
        quiver = contour = false
        for series in series_list(sp)
            st = series[:seriestype]
            blend &= get(series[:extra_kwargs], :blend, true)
            quiver |= series[:arrow] isa Arrow  # post-pipeline detection (:quiver -> :path)
            contour |= st ≡ :contour
            if st ≡ :histogram2d
                xlim = ylim = (0, 0)
            elseif st ≡ :spy || st ≡ :heatmap
                width = height = nothing
                grid = false
            end
        end
        grid &= !(quiver || contour)
        blend &= !(quiver || contour)

        plot_3d && (xlim = ylim = (0, 0))  # determined using projection
        azimuth, elevation = sp[:camera]
        # use the same convention as `gr`, `PyPlot`, `PlotlyJS`, and wrap in range [-180, 180]
        azimuth = mod(azimuth + 180 - 90, 360) - 180
        # => this defaults to azimuth = -60, elevation = 30
        projection = if plot_3d
            (
                auto = :ortho,  # we choose to unify backends by using `:ortho` proj when `:auto`
                ortho = :ortho,
                orthographic = :ortho,
                persp = :persp,
                perspective = :persp,
            )[sp[:projection_type]]
        else
            nothing
        end

        kw = (
            compact = true,
            title = texmath2unicode(sp[:title]),
            xlabel = texmath2unicode(Plots.get_guide(xaxis)),
            ylabel = texmath2unicode(Plots.get_guide(yaxis)),
            labels = !plot_3d,  # guide labels and limits do not make sense in 3d
            xscale = xaxis[:scale],
            yscale = yaxis[:scale],
            xflip = xaxis[:flip],
            yflip = yaxis[:flip],
            xticks = has_ticks(xaxis),
            yticks = has_ticks(yaxis),
            border,
            height,
            width,
            blend,
            grid,
            xlim,
            ylim,
            # 3d
            projection,
            elevation,
            azimuth,
            zoom = get(sp_kw, :zoom, 1),
            up = get(sp_kw, :up, :z),
        )

        o = UnicodePlots.Plot(x, y, plot_3d ? z : nothing, _canvas_map[canvas]; kw...)
        for series in series_list(sp)
            o = addUnicodeSeries!(sp, o, kw, series, sp[:legend_position] ≢ :none, plot_3d)
        end

        for ann in sp[:annotations]
            x, y, val = locate_annotation(sp, ann...)
            o = UnicodePlots.annotate!(
                o,
                x,
                y,
                texmath2unicode(val.str);
                color = up_color(val.font.color),
                halign = val.font.halign,
                valign = val.font.valign,
            )
        end

        push!(plt.o, o)  # save the object
    end
    return
end

up_color(col::UnicodePlots.UserColorType) = col
up_color(col::RGBA) =
    (c = convert(ARGB32, col); map(Int, (red(c).i, green(c).i, blue(c).i)))
up_color(::Any) = :auto

up_cmap(series) = map(
    c -> (red(c), green(c), blue(c)),
    get(get_colorgradient(series), range(0, 1, length = 256)),
)

# add a single series
function addUnicodeSeries!(
        sp::Subplot{UnicodePlotsBackend},
        up::UnicodePlots.Plot,
        kw,
        series,
        addlegend::Bool,
        plot_3d::Bool,
    )
    st = series[:seriestype]
    se_kw = series[:extra_kwargs]

    # get the series data and label
    x, y = if st ≡ :straightline
        straightline_data(series)
    elseif st ≡ :shape
        shape_data(series)
    else
        series[:x], series[:y]
    end

    (ispolar(sp) || ispolar(series)) && return UnicodePlots.polarplot(x, y)

    # special handling (src/interface)
    fix_ar = get(se_kw, :fix_ar, true)
    if st ≡ :histogram2d
        return UnicodePlots.densityplot(x, y; kw...)
    elseif st ≡ :spy
        return UnicodePlots.spy(Array(series[:z]); fix_ar = fix_ar, kw...)
    elseif st ≡ :image
        return UnicodePlots.imageplot(Array(series[:z]); kw...)
    elseif st in (:contour, :heatmap)  # 2D
        colormap = get(se_kw, :colormap, :none)
        kw = (
            kw...,
            zlabel = sp[:colorbar_title],
            colormap = colormap ≡ :none ? up_cmap(series) : colormap,
            colorbar = hascolorbar(sp),
        )
        z = Array(series[:z])
        if st ≡ :contour
            isfilledcontour(series) &&
                @warn "Plots(UnicodePlots): filled contour is not implemented"
            return UnicodePlots.contourplot(x, y, z; kw..., levels = series[:levels])
        elseif st ≡ :heatmap
            return UnicodePlots.heatmap(z; fix_ar = fix_ar, kw...)
        end
    elseif st in (:surface, :wireframe)  # 3D
        colormap = get(se_kw, :colormap, :none)
        lines = get(se_kw, :lines, st ≡ :wireframe)
        zscale = get(se_kw, :zscale, :aspect)
        kw = (
            kw...,
            zlabel = sp[:colorbar_title],
            color = st ≡ :wireframe ? up_color(get_linecolor(series, 1)) : nothing,
            colormap = colormap ≡ :none ? up_cmap(series) : colormap,
            colorbar = hascolorbar(sp),
            zscale,
            lines,
        )
        z = Array(series[:z])
        return UnicodePlots.surfaceplot(x, y, z isa AMat ? transpose(z) : z; kw...)
    elseif st ≡ :mesh3d
        return UnicodePlots.lineplot!(
            up,
            mesh3d_triangles(x, y, series[:z], series[:connections])...,
        )
    end

    # now use the ! functions to add to the plot
    if st in (:path, :path3d, :straightline, :shape, :mesh3d)
        func = UnicodePlots.lineplot!
        series_kw = (; head_tail = series[:arrow] isa Arrow ? series[:arrow].side : nothing)
    elseif st in (:scatter, :scatter3d) || series[:markershape] ≢ :none
        func = UnicodePlots.scatterplot!
        series_kw = (; marker = series[:markershape])
    else
        throw(ArgumentError("Plots(UnicodePlots): series type $st not supported"))
    end

    label = addlegend ? series[:label] : ""

    for (n, segment) in enumerate(series_segments(series, st; check = true))
        i, rng = segment.attr_index, segment.range
        lc = get_linecolor(series, i)
        up = func(
            up,
            x[rng],
            y[rng],
            plot_3d ? series[:z][rng] : nothing;
            color = up_color(lc),
            name = n == 1 ? label : "",
            series_kw...,
        )
    end

    for (xi, yi, str, fnt) in EachAnn(series[:series_annotations], x, y)
        up = UnicodePlots.annotate!(
            up,
            xi,
            yi,
            str;
            color = up_color(fnt.color),
            halign = fnt.halign,
            valign = fnt.valign,
        )
    end

    return up
end

function unsupported_layout_error()
    """
    Plots(UnicodePlots): complex nested layout is currently unsupported.
    Consider using plain `UnicodePlots` commands and `grid` from Term.jl as an alternative.
    """ |>
        ArgumentError |>
        throw
    return nothing
end

# ------------------------------------------------------------------------------------------

function _show(io::IO, ::MIME"image/png", plt::Plot{UnicodePlotsBackend})
    applicable(UnicodePlots.save_image, io) ||
        "Plots(UnicodePlots): saving to `.png` requires `import FreeType, FileIO`" |>
        ArgumentError |>
        throw
    prepare_output(plt)
    nr, nc = size(plt.layout)
    s1, s2 = map(_ -> zeros(Int, nr, nc), 1:2)
    canvas_type = nothing
    imgs = []
    sps = 0
    for r in 1:nr, c in 1:nc
        if (l = plt.layout[r, c]) isa GridLayout && size(l) != (1, 1)
            unsupported_layout_error()
        else
            img = UnicodePlots.png_image(plt.o[sps += 1]; pixelsize = 32)
            img ≡ nothing && continue
            canvas_type = eltype(img)
            s1[r, c], s2[r, c] = size(img)
            push!(imgs, img)
        end
    end
    if canvas_type ≡ nothing
        @warn "Plots(UnicodePlots) failed to render `png` from plot (font issue)."
    else
        m1 = maximum(s1; dims = 2)
        m2 = maximum(s2; dims = 1)
        img = zeros(canvas_type, sum(m1), sum(m2))
        length(img) == 0 && return  # early return on failing fonts
        sps = 0
        n1 = 1
        for r in 1:nr
            n2 = 1
            for c in 1:nc
                h, w = (sp = imgs[sps += 1]) |> size
                img[n1:(n1 + (h - 1)), n2:(n2 + (w - 1))] = sp
                n2 += m2[c]
            end
            n1 += m1[r]
        end
        UnicodePlots.save_image(io, img)
    end
    return nothing
end

Base.show(plt::Plot{UnicodePlotsBackend}) = show(stdout, plt)
Base.show(io::IO, plt::Plot{UnicodePlotsBackend}) = _show(io, MIME("text/plain"), plt)

# NOTE: _show(...) must be kept for Base.showable (src/output.jl)
function _show(io::IO, ::MIME"text/plain", plt::Plot{UnicodePlotsBackend})
    prepare_output(plt)
    nr, nc = size(plt.layout)
    if nr == 1 && nc == 1  # fast path
        n = length(plt.o)
        for (i, p) in enumerate(plt.o)
            show(io, p)
            i < n && println(io)
        end
    else
        color = get(io, :color, false)
        lines_colored = Array{Union{Nothing, Vector{String}}}(nothing, nr, nc)
        lines_uncolored = color ? similar(lines_colored) : lines_colored
        l_max = zeros(Int, nr)
        w_max = zeros(Int, nc)
        nsp = length(plt.o)
        sps = 0
        for r in 1:nr
            lmax = 0
            for c in 1:nc
                if (l = plt.layout[r, c]) isa GridLayout && size(l) != (1, 1)
                    unsupported_layout_error()
                else
                    if get(l.attr, :blank, false)
                        continue
                    elseif (sps += 1) > nsp
                        continue
                    end
                    colored = string(plt.o[sps]; color)
                    lines_colored[r, c] = lu = lc = split(colored, '\n')
                    if color
                        uncolored = UnicodePlots.no_ansi_escape(colored)
                        lines_uncolored[r, c] = lu = split(uncolored, '\n')
                    end
                    lmax = max(length(lc), lmax)
                    w_max[c] = max(maximum(length.(lu)), w_max[c])
                end
            end
            l_max[r] = lmax
        end
        empty = map(w -> ' '^w, w_max)
        for r in 1:nr
            for n in 1:l_max[r]
                for c in 1:nc
                    pre = c == 1 ? '\0' : ' '
                    if (lc = lines_colored[r, c]) ≡ nothing || length(lc) < n
                        print(io, pre, empty[c])
                    else
                        lu = lines_uncolored[r, c]
                        print(io, pre, lc[n], ' '^(w_max[c] - length(lu[n])))
                    end
                end
                n < l_max[r] && println(io)
            end
            r < nr && println(io)
        end
    end
    return nothing
end

# we only support MIME"text/plain", hence display(...) falls back to plain-text on stdout
function _display(plt::Plot{UnicodePlotsBackend})
    show(stdout, plt)
    return println(stdout)
end

# https://github.com/ma-laforge/InspectDR.jl

#=TODO:
    Tweak scale factor for width & other sizes

Not supported by InspectDR:
    :foreground_color_grid
    :foreground_color_border
    :polar,

Add in functionality to Plots.jl:
    :aspect_ratio,
=#

should_warn_on_unsupported(::InspectDRBackend) = false

is_marker_supported(::InspectDRBackend, shape::Shape) = true

#Do we avoid Map to avoid possible pre-comile issues?
function _inspectdr_mapglyph(s::Symbol)
    s === :rect && return :square
    return s
end

function _inspectdr_mapglyph(s::Shape)
    x, y = coords(s)
    return InspectDR.GlyphPolyline(x, y)
end

# py_marker(markers::AVec) = map(py_marker, markers)
function _inspectdr_mapglyph(markers::AVec)
    @warn "Vectors of markers are currently unsupported in InspectDR."
    return _inspectdr_mapglyph(markers[1])
end

_inspectdr_mapglyphsize(v::Real) = v
function _inspectdr_mapglyphsize(v::Vector)
    @warn "Vectors of marker sizes are currently unsupported in InspectDR."
    return _inspectdr_mapglyphsize(v[1])
end

_inspectdr_mapcolor(v::Colorant) = v
function _inspectdr_mapcolor(g::PlotUtils.ColorGradient)
    @warn "Color gradients are currently unsupported in InspectDR."
    # Pick middle color:
    return _inspectdr_mapcolor(g.colors[div(1 + end, 2)])
end
function _inspectdr_mapcolor(v::AVec)
    @warn "Vectors of colors are currently unsupported in InspectDR."
    # Pick middle color:
    return _inspectdr_mapcolor(v[div(1 + end, 2)])
end

# Hack: suggested point size does not seem adequate relative to plot size, for some reason.
_inspectdr_mapptsize(v) = 1.5 * v

_inspectdr_add_annotations(plot, sp::Subplot, x, y, val) = nothing  # What kind of annotation is this?

#plot::InspectDR.Plot2D
function _inspectdr_add_annotations(plot, sp::Subplot, x, y, val::PlotText)
    vmap = Dict{Symbol, Symbol}(:top => :t, :bottom => :b)  # :vcenter
    hmap = Dict{Symbol, Symbol}(:left => :l, :right => :r)  # :hcenter
    align = Symbol(get(vmap, val.font.valign, :c), get(hmap, val.font.halign, :c))
    fnt = InspectDR.Font(
        val.font.family,
        val.font.pointsize,
        color = _inspectdr_mapcolor(val.font.color),
    )
    ann = InspectDR.atext(
        texmath2unicode(val.str),
        x = x,
        y = y,
        font = fnt,
        angle = -val.font.rotation, # minus for consistency with other backends
        align = align,
    )
    InspectDR.add(plot, ann)
    return nothing
end

# placement relative to figure
function _inspectdr_add_annotations(
        plot,
        sp::Subplot,
        pos::Union{Tuple, Symbol},
        val::PlotText,
    )
    x, y, val = locate_annotation(sp, pos, val)
    return _inspectdr_add_annotations(plot, sp, x, y, val)
end

# ---------------------------------------------------------------------------

function _inspectdr_getaxisticks(ticks, gridlines, xfrm)
    TickCustom = InspectDR.TickCustom
    _xfrm(coord) = InspectDR.axis2aloc(Float64(coord), xfrm.spec) #Ensure Float64 - in case

    ttype = ticksType(ticks)
    if ticks === :native
        # keep current
    elseif ttype === :ticks_and_labels
        pos = ticks[1]
        labels = ticks[2]
        nticks = length(ticks[1])
        newticks = TickCustom[TickCustom(_xfrm(pos[i]), labels[i]) for i in 1:nticks]
        gridlines = InspectDR.GridLinesCustom(gridlines)
        gridlines.major = newticks
        gridlines.minor = []
        gridlines.displayminor = false
    elseif ttype === :ticks
        nticks = length(ticks)
        gridlines.major = Float64[_xfrm(t) for t in ticks]
        gridlines.minor = []
        gridlines.displayminor = false
    elseif isnothing(ticks)
        gridlines.major = []
        gridlines.minor = []
    else  # Assume ticks === :native
        # keep current
    end

    return gridlines  # keep current
end

function _inspectdr_setticks(sp::Subplot, plot, strip, xaxis, yaxis)
    _get_ticks(axis) = axis[:ticks] === :native ? :native : get_ticks(sp, axis)

    xticks = _get_ticks(xaxis)
    yticks = _get_ticks(yaxis)

    (xticks === :native && yticks === :native) && return  # Don't "eval" tick values

    # TODO: Allow InspectDR to independently "eval" x or y ticks
    ext = InspectDR.getextents_aloc(plot, 1)
    grid = InspectDR._eval(strip.grid, plot.xscale, strip.yscale, ext)
    grid.xlines =
        _inspectdr_getaxisticks(xticks, grid.xlines, InspectDR.InputXfrm1D(plot.xscale))
    grid.ylines =
        _inspectdr_getaxisticks(yticks, grid.ylines, InspectDR.InputXfrm1D(strip.yscale))
    return strip.grid = grid
end

# ---------------------------------------------------------------------------

function _inspectdr_getscale(s::Symbol, yaxis::Bool)
    #TODO: Support :asinh, :sqrt
    kwargs = yaxis ? (:tgtmajor => 8, :tgtminor => 2) : () #More grid lines on y-axis
    return if :log2 == s
        InspectDR.AxisScale(:log2; kwargs...)
    elseif :log10 == s
        InspectDR.AxisScale(:log10; kwargs...)
    elseif :ln == s
        InspectDR.AxisScale(:ln; kwargs...)
    else #identity
        InspectDR.AxisScale(:lin; kwargs...)
    end
end

# ---------------------------------------------------------------------------

#Glyph used when plotting "Shape"s:
INSPECTDR_GLYPH_SHAPE =
    InspectDR.GlyphPolyline(2 * InspectDR.GLYPH_SQUARE.x, InspectDR.GLYPH_SQUARE.y)

mutable struct InspecDRPlotRef
    mplot::Union{Nothing, InspectDR.Multiplot}
    gui::Union{Nothing, InspectDR.GtkPlot}
end

_inspectdr_getmplot(::Any) = nothing
_inspectdr_getmplot(r::InspecDRPlotRef) = r.mplot

_inspectdr_getgui(::Any) = nothing
_inspectdr_getgui(gplot::InspectDR.GtkPlot) = (gplot.destroyed ? nothing : gplot)
_inspectdr_getgui(r::InspecDRPlotRef) = _inspectdr_getgui(r.gui)
push!(_initialized_backends, :inspectdr)

# ---------------------------------------------------------------------------

# Create the window/figure for this backend.
function _create_backend_figure(plt::Plot{InspectDRBackend})
    mplot = _inspectdr_getmplot(plt.o)
    gplot = _inspectdr_getgui(plt.o)

    # :overwrite_figure: want to reuse current figure
    if plt[:overwrite_figure] && mplot !== nothing
        mplot.subplots = []  # Reset
        if gplot !== nothing  # Ensure still references current plot
            gplot.src = mplot
        end
    else  # want new one:
        mplot = InspectDR.Multiplot()
        gplot = nothing  # Will be created later
    end

    # break link with old subplots
    foreach(sp -> sp.o = nothing, plt.subplots)

    return InspecDRPlotRef(mplot, gplot)
end

# ---------------------------------------------------------------------------

# Set up the subplot within the backend object.
function _initialize_subplot(plt::Plot{InspectDRBackend}, sp::Subplot{InspectDRBackend})
    plot = sp.o
    # Don't do anything without a "subplot" object:  Will process later.
    plot === nothing && return
    plot.data = []
    plot.userannot = [] #Clear old markers/text annotation/polyline "annotation"
    return plot
end

# ---------------------------------------------------------------------------

# Add one series to the underlying backend object.
# Called once per series
# NOTE: Seems to be called when user calls plot()... even if backend
#       plot, sp.o has not yet been constructed...
function _series_added(plt::Plot{InspectDRBackend}, series::Series)
    st = series[:seriestype]
    sp = series[:subplot]

    # Don't do anything without a "subplot" object:  Will process later.
    (plot = sp.o) === nothing && return

    clims = get_clims(sp, series)

    _vectorize(v) = isa(v, Vector) ? v : collect(v) #InspectDR only supports vectors
    x, y = if st === :straightline
        straightline_data(series)
    else
        _vectorize(series[:x]), _vectorize(series[:y])
    end

    # No support for polar grid... but can still perform polar transformation:
    if ispolar(sp)
        Θ = x
        r = y
        x = r .* cos.(Θ)
        y = r .* sin.(Θ)
    end

    # doesn't handle mismatched x/y - wrap data (pyplot behaviour):
    nx, ny = map(length, (x, y))
    if nx < ny
        series[:x] = Float64[x[mod1(i, nx)] for i in 1:ny]
    elseif ny > nx
        series[:y] = Float64[y[mod1(i, ny)] for i in 1:nx]
    end

    #= TODO: Eventually support
        series[:fillcolor] #I think this is fill under line
        zorder = series[:series_plotindex]

    For st in :shape:
        zorder = series[:series_plotindex],
    =#

    if st in (:shape,)
        x, y = shape_data(series)
        nmax = 0
        for (i, rng) in enumerate(iter_segments(x, y))
            nmax = i
            if length(rng) > 1
                linewidth = series[:linewidth]
                c = plot_color(get_linecolor(series), get_linealpha(series))
                linecolor = _inspectdr_mapcolor(_cycle(c, i))
                c = plot_color(get_fillcolor(series), get_fillalpha(series))
                fillcolor = _inspectdr_mapcolor(_cycle(c, i))
                line = InspectDR.line(style = :solid, width = linewidth, color = linecolor)
                apline = InspectDR.PolylineAnnotation(
                    x[rng],
                    y[rng],
                    line = line,
                    fillcolor = fillcolor,
                )
                InspectDR.add(plot, apline)
            end
        end

        i = (nmax >= 2 ? div(nmax, 2) : nmax) #Must pick one set of colors for legend
        if i > 1 #Add dummy waveform for legend entry:
            linewidth = series[:linewidth]
            c = plot_color(get_linecolor(series), get_linealpha(series))
            linecolor = _inspectdr_mapcolor(_cycle(c, i))
            c = plot_color(get_fillcolor(series), get_fillalpha(series))
            fillcolor = _inspectdr_mapcolor(_cycle(c, i))
            wfrm = InspectDR.add(plot, Float64[], Float64[], id = series[:label])
            wfrm.line = InspectDR.line(
                style = :none,
                width = linewidth, #linewidth affects glyph
            )
            wfrm.glyph = InspectDR.glyph(
                shape = INSPECTDR_GLYPH_SHAPE,
                size = 8,
                color = linecolor,
                fillcolor = fillcolor,
            )
        end
    elseif st in (:path, :scatter, :straightline) #, :steppre, :stepmid, :steppost)
        # NOTE: In Plots.jl, :scatter plots have 0-linewidths (I think).
        linewidth = series[:linewidth]
        # More efficient & allows some support for markerstrokewidth:
        _style = (0 == linewidth ? :none : series[:linestyle])
        wfrm = InspectDR.add(plot, x, y, id = series[:label])
        wfrm.line = InspectDR.line(
            style = _style,
            width = series[:linewidth],
            color = plot_color(get_linecolor(series), get_linealpha(series)),
        )
        # InspectDR does not control markerstrokewidth independently.
        if _style === :none
            # Use this property only if no line is displayed:
            wfrm.line.width = series[:markerstrokewidth]
        end
        wfrm.glyph = InspectDR.glyph(
            shape = _inspectdr_mapglyph(series[:markershape]),
            size = _inspectdr_mapglyphsize(series[:markersize]),
            color = _inspectdr_mapcolor(
                plot_color(get_markerstrokecolor(series), get_markerstrokealpha(series)),
            ),
            fillcolor = _inspectdr_mapcolor(
                plot_color(get_markercolor(series, clims), get_markeralpha(series)),
            ),
        )
    end

    # this is all we need to add the series_annotations text
    anns = series[:series_annotations]
    for (xi, yi, str, fnt) in EachAnn(anns, x, y)
        _inspectdr_add_annotations(plot, sp, xi, yi, PlotText(str, fnt))
    end
    return
end

# ---------------------------------------------------------------------------

# When series data is added/changed, this callback can do dynamic updates to the backend object.
# note: if the backend rebuilds the plot from scratch on display, then you might not do anything here.
_series_updated(plt::Plot{InspectDRBackend}, series::Series) = nothing

# ---------------------------------------------------------------------------

function _inspectdr_setupsubplot(sp::Subplot{InspectDRBackend})
    plot = sp.o
    strip = plot.strips[1] #Only 1 strip supported with Plots.jl

    xaxis = sp[:xaxis]
    yaxis = sp[:yaxis]
    xgrid_show = xaxis[:grid]
    ygrid_show = yaxis[:grid]

    strip.grid = InspectDR.GridRect(
        vmajor = xgrid_show, # vminor=xgrid_show,
        hmajor = ygrid_show, # hminor=ygrid_show,
    )

    plot.xscale = _inspectdr_getscale(xaxis[:scale], false)
    strip.yscale = _inspectdr_getscale(yaxis[:scale], true)
    xmin, xmax = axis_limits(sp, :x)
    ymin, ymax = axis_limits(sp, :y)
    if ispolar(sp)
        #Plots.jl appears to give (xmin,xmax) ≜ (Θmin,Θmax) & (ymin,ymax) ≜ (rmin,rmax)
        rmax = NaNMath.max(abs(ymin), abs(ymax))
        xmin, xmax = -rmax, rmax
        ymin, ymax = -rmax, rmax
    end
    plot.xext_full = InspectDR.PExtents1D(xmin, xmax)
    strip.yext_full = InspectDR.PExtents1D(ymin, ymax)
    #Set current extents = full extents (needed for _eval(strip.grid,...))
    plot.xext = plot.xext_full
    strip.yext = strip.yext_full
    _inspectdr_setticks(sp, plot, strip, xaxis, yaxis)

    a = plot.annotation
    a.title = texmath2unicode(sp[:title])
    a.xlabel = texmath2unicode(Plots.get_guide(xaxis))
    a.ylabels = [texmath2unicode(Plots.get_guide(yaxis))]

    #Modify base layout of new object:
    l = plot.layout.defaults = deepcopy(InspectDR.defaults.plotlayout)
    #IMPORTANT: Must deepcopy to ensure we don't change layouts of other plots.
    #Works because plot uses defaults (not user-overwritten `layout.values`)
    l.frame_canvas.fillcolor = _inspectdr_mapcolor(sp[:background_color_subplot])
    l.frame_data.fillcolor = _inspectdr_mapcolor(sp[:background_color_inside])
    l.frame_data.line.color = _inspectdr_mapcolor(xaxis[:foreground_color_axis])
    l.font_title = InspectDR.Font(
        sp[:titlefontfamily],
        _inspectdr_mapptsize(sp[:titlefontsize]),
        color = _inspectdr_mapcolor(sp[:titlefontcolor]),
    )
    #Cannot independently control fonts of axes with InspectDR:
    l.font_axislabel = InspectDR.Font(
        xaxis[:guidefontfamily],
        _inspectdr_mapptsize(xaxis[:guidefontsize]),
        color = _inspectdr_mapcolor(xaxis[:guidefontcolor]),
    )
    l.font_ticklabel = InspectDR.Font(
        xaxis[:tickfontfamily],
        _inspectdr_mapptsize(xaxis[:tickfontsize]),
        color = _inspectdr_mapcolor(xaxis[:tickfontcolor]),
    )
    l.enable_legend = (sp[:legend_position] !== :none)
    #l.halloc_legend = 150 #TODO: compute???
    l.font_legend = InspectDR.Font(
        sp[:legend_font_family],
        _inspectdr_mapptsize(sp[:legend_font_pointsize]),
        color = _inspectdr_mapcolor(sp[:legend_font_color]),
    )
    l.frame_legend.fillcolor = _inspectdr_mapcolor(sp[:legend_background_color])
    #_round!() ensures values use integer spacings (looks better on screen):
    return InspectDR._round!(InspectDR.autofit2font!(l, legend_width = 10.0)) #10 "em"s wide
end

# called just before updating layout bounding boxes... in case you need to prep
# for the calcs
function _before_layout_calcs(plt::Plot{InspectDRBackend})
    (mplot = _inspectdr_getmplot(plt.o)) === nothing && return

    mplot.title = plt[:plot_title]
    if isempty(mplot.title)
        # Don't use window_title... probably not what you want.
        # mplot.title = plt[:window_title]
    end

    mplot.layout[:frame].fillcolor = _inspectdr_mapcolor(plt[:background_color_outside])
    mplot.layout[:frame] = mplot.layout[:frame] #register changes
    resize!(mplot.subplots, length(plt.subplots))
    nsubplots = length(plt.subplots)
    for (i, sp) in enumerate(plt.subplots)
        isassigned(mplot.subplots, i) || (mplot.subplots[i] = InspectDR.Plot2D())
        sp.o = mplot.subplots[i]
        plot = sp.o
        _initialize_subplot(plt, sp)
        _inspectdr_setupsubplot(sp)

        # add the annotations
        for ann in sp[:annotations]
            _inspectdr_add_annotations(plot, sp, ann...)
        end
    end

    # Do not yet support absolute plot positioning.
    # Just try to make things look more-or less ok:
    mplot.layout[:ncolumns] = if nsubplots <= 1
        1
    elseif nsubplots <= 4
        2
    elseif nsubplots <= 6
        3
    elseif nsubplots <= 12
        4
    else
        5
    end

    foreach(series -> _series_added(plt, series), plt.series_list)
    return nothing
end

# ----------------------------------------------------------------

# Set the (left, top, right, bottom) minimum padding around the plot area
# to fit ticks, tick labels, guides, colorbars, etc.
function _update_min_padding!(sp::Subplot{InspectDRBackend})
    plot = sp.o
    isa(plot, InspectDR.Plot2D) || return sp.minpad
    # Computing plotbounds with 0-BoundingBox returns required padding:
    bb = InspectDR.plotbounds(plot.layout.values, InspectDR.BoundingBox(0, 0, 0, 0))
    # NOTE: plotbounds always pads for titles, legends, etc. even if not in use.
    # TODO: possibly zero-out items not in use??

    # add in the user-specified margin to InspectDR padding:
    leftpad = abs(bb.xmin) * px + sp[:left_margin]
    toppad = abs(bb.ymin) * px + sp[:top_margin]
    rightpad = abs(bb.xmax) * px + sp[:right_margin]
    bottompad = abs(bb.ymax) * px + sp[:bottom_margin]
    return sp.minpad = (leftpad, toppad, rightpad, bottompad)
end

# ----------------------------------------------------------------

# Override this to update plot items (title, xlabel, etc), and add annotations (plotattributes[:annotations])
function _update_plot_object(plt::Plot{InspectDRBackend})
    (mplot = _inspectdr_getmplot(plt.o)) === nothing && return
    mplot.bblist = InspectDR.BoundingBox[]

    for (i, sp) in enumerate(plt.subplots)
        figw, figh = sp.plt[:size]
        pcts = bbox_to_pcts(sp.bbox, figw * px, figh * px)
        _left, _bottom, _width, _height = pcts
        ymax = 1.0 - _bottom
        ymin = ymax - _height
        bb = InspectDR.BoundingBox(_left, _left + _width, ymin, ymax)
        push!(mplot.bblist, bb)
    end

    (gplot = _inspectdr_getgui(plt.o)) === nothing && return

    gplot.src = mplot #Ensure still references current plot
    InspectDR.refresh(gplot)
    return nothing
end

# ----------------------------------------------------------------

_inspectdr_show(io::IO, mime::MIME, ::Nothing, w, h) =
    throw(ErrorException("Cannot show(::IO, ...) plot - not yet generated"))
_inspectdr_show(io::IO, mime::MIME, mplot, w, h) =
    InspectDR._show(io, mime, mplot, Float64(w), Float64(h))

function _show(io::IO, mime::MIME{Symbol("image/png")}, plt::Plot{InspectDRBackend})
    dpi = plt[:dpi] # TODO: support
    return _inspectdr_show(io, mime, _inspectdr_getmplot(plt.o), plt[:size]...)
end
for (mime, fmt) in (
        "image/svg+xml" => "svg",
        "application/eps" => "eps",
        "image/eps" => "eps",
        # "application/postscript" => "ps", # TODO: support once Cairo supports PSSurface
        "application/pdf" => "pdf",
    )
    @eval function _show(io::IO, mime::MIME{Symbol($mime)}, plt::Plot{InspectDRBackend})
        return _inspectdr_show(io, mime, _inspectdr_getmplot(plt.o), plt[:size]...)
    end
end

# ----------------------------------------------------------------

# Display/show the plot (open a GUI window, or browser page, for example).
function _display(plt::Plot{InspectDRBackend})
    (mplot = _inspectdr_getmplot(plt.o)) === nothing && return

    if (gplot = _inspectdr_getgui(plt.o)) === nothing
        gplot = display(InspectDR.GtkDisplay(), mplot)
    else
        # redundant... Plots.jl will call _update_plot_object:
        # InspectDR.refresh(gplot)
    end
    plt.o = InspecDRPlotRef(mplot, gplot)
    return gplot
end

module ImageInTerminalExt

import Plots
Plots.@ext_imp_use :import ImageInTerminal

if ImageInTerminal.ENCODER_BACKEND[] == :Sixel
    get!(ENV, "GKSwstype", "nul")  # disable `gr` output, we display in the terminal instead
    for be in (
            Plots.GRBackend,
            Plots.PyPlotBackend,
            Plots.PythonPlotBackend,
            # Plots.UnicodePlotsBackend,  # better and faster as MIME("text/plain") in terminal
            Plots.PGFPlotsXBackend,
            Plots.PlotlyJSBackend,
            Plots.PlotlyBackend,
            Plots.GastonBackend,
            Plots.InspectDRBackend,
        )
        @eval function Base.display(::Plots.PlotsDisplay, plt::Plots.Plot{$be})
            Plots.prepare_output(plt)
            buf = PipeBuffer()
            show(buf, MIME("image/png"), plt)
            return display(
                ImageInTerminal.TerminalGraphicDisplay(stdout),
                MIME("image/png"),
                read(buf),
            )
        end
    end
end

end  # module

using OffsetArrays

@testset "Series" begin
    pl = plot(1:3, yerror = 1)
    @test plot(pl[1][1])[1][1][:primary] == true
    @test plot(pl[1][2])[1][1][:primary] == false
    @test isequal(plot(pl[1][2])[1][1][:y], pl[1][2][:y])
end

@testset "User recipes" begin
    struct LegendPlot end
    @recipe function f(plot::LegendPlot)
        legend --> :topleft
        (1:3, 1:3)
    end
    let pl = pl = plot(LegendPlot(); legend = :right)
        @test pl[1][:legend_position] === :right
    end
    let pl = pl = plot(LegendPlot())
        @test pl[1][:legend_position] === :topleft
    end
    let pl = plot(LegendPlot(); legend = :inline)
        @test pl[1][:legend_position] === :inline
    end
    let pl = plot(LegendPlot(); legend = :inline, ymirror = true)
        @test pl[1][:legend_position] === :inline
    end
end

@testset "lens!" begin
    pl = plot(1:5)
    lens!(pl, [1, 2], [1, 2], inset = (1, bbox(0.0, 0.0, 0.2, 0.2)), colorbar = false)
    @test length(pl.series_list) == 4
    @test pl[2][:colorbar] === :none
end

@testset "vline, vspan" begin
    vl = vline([1], widen = false)
    @test Plots.xlims(vl) == (1, 2)
    @test Plots.ylims(vl) == (1, 2)
    vl = vline([1], xlims = (0, 2), widen = false)
    @test Plots.xlims(vl) == (0, 2)
    vl = vline([1], ylims = (-3, 5), widen = false)
    @test Plots.ylims(vl) == (-3, 5)

    vsp = vspan([1, 3], widen = false)
    @test Plots.xlims(vsp) == (1, 3)
    @test Plots.ylims(vsp) == (0, 1) # TODO: might be problematic on log-scales
    vsp = vspan([1, 3], xlims = (-2, 5), widen = false)
    @test Plots.xlims(vsp) == (-2, 5)
    vsp = vspan([1, 3], ylims = (-2, 5), widen = false)
    @test Plots.ylims(vsp) == (-2, 5)
end

@testset "steps offset" begin
    data = OffsetArray(rand(11), -5:5)
    plot(data, linetype = :steppre)
    plot(data, linetype = :stepmid)
    plot(data, linetype = :steppost)
end

@testset "offset axes" begin
    tri = OffsetVector(vcat(1:5, 4:-1:1), 11:19)
    sticks = plot(tri, seriestype = :sticks)
    @test length(sticks) == 1
end

@testset "offset images" begin
    img = OffsetMatrix(rand(RGB{Colors.N0f8}, 11, 11), -5:5, -5:5)
    plt = plot(img)
    @test length(plt) == 1

    plt = plot(Gray.(img))
    @test length(plt) == 1

    data = OffsetMatrix(rand(11, 11), -5:5, -5:5)
    @test_broken begin
        plt = plot(data)
        length(plt) == 1
    end
end

# NOTE: the following test seems to trigger these deprecated warnings:
# WARNING: importing deprecated binding Colors.RGB1 into PlotUtils.
# WARNING: importing deprecated binding Colors.RGB1 into Plots.
@testset "framestyle axes" begin
    pl = plot(-1:1, -1:1, -1:1)
    sp = pl.subplots[1]
    defaultret = Plots.axis_drawing_info_3d(sp, :x)
    for letter in (:x, :y, :z)
        for framestyle in [:box :semi :origin :zerolines :grid :none]
            prevha = UInt64(0)
            push!(sp.attr, :framestyle => framestyle)
            ret = Plots.axis_drawing_info_3d(sp, letter)
            ha = hash(string(ret))
            @test ha != prevha
            prevha = ha
        end
    end
end

@testset "coverage" begin
    @test :surface in Plots.all_seriestypes()
    @test Plots.seriestype_supported(Plots.UnicodePlotsBackend(), :surface) === :native
    @test Plots.seriestype_supported(Plots.UnicodePlotsBackend(), :hspan) === :recipe
    @test Plots.seriestype_supported(Plots.NoBackend(), :line) === :no
end

Plots.with(:gr) do
    @testset "error bars" begin
        x = y = 1:10
        yerror = fill(1, length(y))
        xerror = fill(0.2, length(x))
        p = Plots.xerror(x, y; xerror, linestyle = :solid)
        plot!(p, x, y; linestyle = :dash)
        yerror!(p, x, y; yerror, linestyle = :dot)
        @test length(p.series_list) == 3
        @test p[1][1][:linestyle] == :solid
        @test p[1][2][:linestyle] == :dash
        @test p[1][3][:linestyle] == :dot
    end

    @testset "parametric" begin
        @test plot(sin, sin, cos, 0, 2π) isa Plots.Plot
        @test plot(sin, sin, cos, collect((-2π):(π / 4):(2π))) isa Plots.Plot
    end

    @testset "dict" begin
        @test_nowarn show(devnull, plot(Dict(1 => 2, 3 => -1)))
    end

    @testset "gray image" begin
        @test_nowarn show(devnull, plot(rand(Gray, 2, 2)))
    end

    @testset "plots_heatmap" begin
        @test_nowarn show(devnull, plots_heatmap(rand(RGBA, 2, 2)))
    end

    @testset "scatter3d" begin
        @test_nowarn show(devnull, scatter3d(1:2, 1:2, 1:2))
    end

    @testset "sticks" begin
        @test_nowarn show(devnull, sticks(1:2, marker = :circle))
    end

    @testset "stephist" begin
        @test_nowarn show(devnull, stephist([1, 2], marker = :circle))
    end

    @testset "bar with logscales" begin
        @test_nowarn show(devnull, bar([1 2 3], [0.02 125 10_000]; yscale = :log10))
        @test_nowarn histogram(randn(100), yscale = :log10)
    end

    @testset "histogram range" begin
        @test histogram(1:10) isa Plot
    end
end
